FoX package

Quick start:

1. Type "./configure" to generate appropriate compiler-dependent information for the Makefile.

2. Type "make"

(Optionally)

3. Type "make check"

Full documentation is in DoX/index.html

                                The FOX GUI Library
                                ===================

	              Jeroen van der Zijp <jeroen@fox-toolkit.org>





What Is FOX?
============

FOX is a C++ based Toolkit for developing Graphical User Interfaces easily and
effectively.   It offers a wide, and growing, collection of Controls, and provides
state of the art facilities such as drag and drop, selection, as well as OpenGL widgets
for 3D graphical manipulation.  FOX also implements icons, images, and user-convenience
features such as status line help, and tooltips.  Tooltips may even be used for 3D
objects!

Considerable importance has been placed on making FOX one of the fastest toolkits
around, and to minimize memory use:- FOX uses a number of techniques to speed up drawing
and spatial layout of the GUI.  Memory is conserved by allowing programmers to create
and destroy GUI elements on the fly.

Even though FOX offers a large collection of Controls already, FOX leverages C++ to
allow programmers to easily build additional Controls and GUI elements, simply by taking
existing controls, and creating a derived class which simply adds or redefines the
desired behavior.

One of the prime design goals of FOX is the ease of programming; thus, most controls
can be created using a single line of C++ code; most parameters have sensible default
values, so that they may be omitted, and layout managers ensure that designers of GUI's
do not have to worry about precise alignments.

Another nice feature of FOX which significantly reduces the number of lines of code
which have to be written is FOX's ability to have widgets connect to each other, and
passing certain commands between them; for example, a menu entry Hide Toolbar can be
directly connected to the Toolbar, and cause it to hide.

Finally, FOX makes it easy to maintain the state of the GUI in an application by having
the GUI elements automatically updating themselves by interrogating the application's
state.  This feature eliminates the large amount of effort that may go into sensitizing,
graying out, checking/unchecking etc. depending on the application state.



Where to get it?
================

You can FTP the complete FOX GUI toolkit from our FTP site:


	ftp://ftp.fox-toolkit.org/pub/


The distribution includes this on-line (HTML) documentation you see here.


Mailing List.
=============

To stay informed, we now have a mailing list for FOX.  To subscribe, send mail to
foxgui-users-request@lists.sourceforge.net with the word subscribe in the message body.
Messages to the list can be sent to foxgui-users@lists.sourceforge.net.
FOX announcements will be made through the foxgui-announce@lists.sourceforge.net list;
you can subscribe to this list by sending a message "subscribe" to the list server at
foxgui-announce-request@lists.sourceforge.net.


Installation.
=============

Please refer to the file INSTALL.  FOX should compile on a large number of UNIX
systems.  The current "configure" scripts are however still somewhat primitive;
if you need to make specific alterations to the configure system, feel free to
send them to me so that I may merge them into the main distribution.
The current FOX distribution compiles on Windows NT using the eXceed system; we
expect however to get some core functionality to become available under the native
Windows environment fairly soon.



Getting started.
================

To get started programming with FOX, take a look at the tests directory, which contains
some example programs.  The best one to look at is probably the "glviewer" application.
Note that you need OpenGL or Mesa on your machine in order to compile it.



Finding FOX using GNU configure.
================================

GNU auto configure has features to detect the whereabouts of a library (AC_CHECK_LIB).
Unfortunately, it assumes that you're looking for a C library, not a C++ library,
and thus name mangling prevents it from finding FOX as all of FOX's API are C++.

A special "dummy" C-linkage function was created to allow GNU auto configure to
find the FOX library; you can use it in your configure.in as follows:


        AC_CHECK_LIB(FOX, fxfindfox)




Bugs.
=====

Please file bugs and questions to the list foxgui-users@lists.sourceforge.net.  Before
filing a bug, please take a moment to download the latest version of FOX, and make sure
the problem still persists:- FOX is being developed fairly rapidly, and it is possible
that some of the problems you may have experienced have already been fixed.



License.
========

The FOX Library proper is licensed under GNU Lesser GPL; all the examples and demo
programs are licensed under GPL.

If you write software based on the FOX library, please include the following in your
About Box, or some other place where a user may be able to see it:


        This software uses the FOX Toolkit (http://www.fox-toolkit.org).
        


Thanks!

module m_wxml_escape

#ifndef DUMMYLIB
  !Ensure all characters are safe to go out into XML file.

  use m_common_charset, only: XML1_0
  use m_common_error, only: FoX_error, FoX_warning
  use m_common_format, only: str

  implicit none
  private

  integer, parameter :: AMP = iachar('&')
  integer, parameter :: LT = iachar('<')
  integer, parameter :: GT = iachar('>')
  integer, parameter :: QUOT = iachar('"')
  integer, parameter :: APOS = iachar("'")

  public :: escape_string
  public :: escape_string_len

contains

  pure function escape_string_len(s) result(c)
    character(len=*), intent(in) :: s
    integer :: c

    integer :: i 
    c = len(s)
    do i = 1, len(s)
      select case(iachar(s(i:i)))
      case (AMP)
        c = c + 4
      case (LT)
        c = c + 3
      case (GT)
        c = c + 3
      case (QUOT)
        c = c + 5
      case (APOS)
        c = c + 5
      case (1:8)
        c = c + 3
      case (11:12)
        c = c + 4
      case (14:31)
        c = c + 4
      case (127:)
        c = c + 5
        ! a char can never contain more than 8 bits = 256 characters, so
        ! we never need more than 3 chars to represent the int.
      end select
    enddo 

  end function escape_string_len
    

  function escape_string(s, version) result (s2)
    character(len=*), intent(in) :: s
    integer, intent(in) :: version
    character(len=escape_string_len(s)) :: s2

    integer :: c, i, ic

    ! We have to do it this way (with achar etc) in case the native
    ! platform encoding is not ASCII

    c = 1
    do i = 1, len(s)
      ic = iachar(s(i:i))
      select case (ic)
      case (0)
        call FoX_error("Tried to output a NUL character")
      case (1:8)
        if (version==XML1_0) then
          call FoX_error("Tried to output a character invalid under XML 1.0")
        else
          s2(c:c+3) = "&#"//str(ic)//";"
          c = c + 4
        endif
      case(9:10)
        s2(c:c) = achar(ic)
        c = c + 1
      case(11:12)
        if (version==XML1_0) then
          call FoX_error("Tried to output a character invalid under XML 1.0")
        else
          s2(c:c+5) = "&#"//str(ic)//";"
          c = c + 5
        endif
      case(13)
        s2(c:c) = achar(13)
        c = c + 1
      case (14:31)
        if (version==XML1_0) then
          call FoX_error("Tried to output a character invalid under XML 1.0")
        else
          s2(c:c+5) = "&#"//str(ic)//";"
          c = c + 5
        endif
      case (32:126)
        select case (iachar(s(i:i)))
        case (AMP)
          s2(c:c+4) = "&amp;"
          c = c + 5
        case (LT)
          s2(c:c+3) = "&lt;"
          c = c + 4
        case (GT)
          s2(c:c+3) = "&gt;"
          c = c + 4
        case (QUOT)
          s2(c:c+5) = "&quot;"
          c = c + 6
        case (APOS)
          s2(c:c+5) = "&apos;"
          c = c + 6
        case default
          s2(c:c) = achar(ic)
          c = c + 1
        end select
      case (127)
        s2(c:c+5) = "&#127;"
        c = c + 6
      case default
        !TOHW we should maybe just disallow this ...
        call FoX_warning("emitting non-ASCII character. Platform-dependent result!")
        s2(c:c+6) = "&#"//str(ic)//";"
        c = c + 6
        ! a char can never contain more than 8 bits = 256 characters, so
        ! we never need more than 3 chars to represent the int.
        ! We have to encode it though, because UTF-8 x7F-x9F must be 
        ! encoded, and if they are in the native charset they'll be > 128
      end select
    enddo 

  end function escape_string

#endif
end module m_wxml_escape

module m_common_namecheck

#ifndef DUMMYLIB
  ! These are basically a collection of what would be regular
  ! expressions in a more sensible language.
  ! The only external dependency should be knowing how these
  ! regular expressions may differ between XML-1.0 and 1.1 (which
  ! is only in the areas of
  ! 1: allowing character entity references to control characters
  ! 2: More characters allowed in Names (but this only affects
  !    unicode-aware programs, so is only skeleton here)

  use fox_m_fsys_format, only: str_to_int_10, str_to_int_16, operator(//)
  use fox_m_fsys_string, only: toLower
  use m_common_charset, only: isLegalCharRef, isNCNameChar, &
    isInitialNCNameChar, isInitialNameChar, isNameChar, isRepCharRef

  implicit none
  private

  character(len=*), parameter :: lowerCase = "abcdefghijklmnopqrstuvwxyz"
  character(len=*), parameter :: upperCase = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
  character(len=*), parameter :: letters = lowerCase//upperCase
  character(len=*), parameter :: digits = "0123456789"
  character(len=*), parameter :: hexdigits = "0123456789abcdefABCDEF"
  character(len=*), parameter :: NameChars = lowerCase//upperCase//digits//".-_:"

  public :: checkName
  public :: checkNames
  public :: checkQName
  public :: checkQNames
  public :: checkNmtoken
  public :: checkNmtokens
  public :: checkNCName
  public :: checkNCNames
  public :: checkEncName
  public :: checkPITarget
  public :: checkPublicId
  public :: checkPEDef
  public :: checkPseudoAttValue
  public :: checkAttValue
  public :: checkCharacterEntityReference
  public :: checkRepCharEntityReference
  public :: likeCharacterEntityReference

  public :: prefixOfQName
  public :: localpartOfQName

contains

  pure function checkEncName(name) result(good)
    ![81]   	EncName	   ::=   	[A-Za-z] ([A-Za-z0-9._] | '-')*
    character(len=*), intent(in) :: name
    logical :: good

    integer :: n
    
    n = len(name)
    good = (n > 0)
    if (good) good = (scan(name(1:1), letters) /= 0)
    if (good .and. n > 1) &
         good = (verify(name(2:), letters//digits//'.-_') == 0)
  end function checkEncName


  function checkPITarget(name, xv) result(good)
    character(len=*), intent(in) :: name
    integer, intent(in) :: xv
    logical :: good
    ! Validates a string against the XML requirements for a NAME
    ! Is not fully compliant; ignores UTF issues.

    good = checkName(name, xv) &
      .and.toLower(name)/="xml"

  end function checkPITarget


  pure function checkName(name, xv) result(good)
    character(len=*), intent(in) :: name
    integer, intent(in) :: xv
    logical :: good
    ! Validates a string against the XML requirements for a NAME
    ! Is not fully compliant; ignores UTF issues.

    good = (len(name) > 0)
    if (.not.good) return
    if (good) good = isInitialNameChar(name(1:1), xv)
    if (.not.good.or.len(name)==1) return
    good = isNameChar(name(2:), xv)
       
  end function checkName

  pure function checkNames(name, xv) result(good)
    character(len=*), intent(in) :: name
    integer, intent(in) :: xv
    logical :: good
    ! Validates a string against the production for NAMES

    integer :: i, j

    good = (len(name) > 0)
    if (.not.good) return
    i = verify(name, " ")
    if (i==0) then
      good = .false.
      return
    endif
    j = scan(name(i:), " ")
    if (j==0) then
      j = len(name)
    else
      j = i + j - 2
    endif
    do
      good = checkName(name(i:j), xv)
      if (.not.good) return
      i = j + 1
      j = verify(name(i:), " ")
      if (j==0) exit
      i = i + j - 1
      j = scan(name(i:), " ")
      if (j==0) then
        j = len(name)
      else
        j = i + j - 2
      endif
    enddo
       
  end function checkNames


  pure function checkQName(name, xv) result(good)
    character(len=*), intent(in) :: name
    integer, intent(in) :: xv
    logical :: good
    ! Validates a string against the XML requirements for a NAME
    ! Is not fully compliant; ignores UTF issues.

    integer :: n

    n = index(name, ':')
    if (n == 0) then
      good = checkNCName(name, xv)
    else
      good = (checkNCName(name(:n-1), xv) .and. checkNCName(name(n+1:), xv))
    endif
  end function checkQName


  pure function checkQNames(name, xv) result(good)
    character(len=*), intent(in) :: name
    integer, intent(in) :: xv
    logical :: good
    ! Validates a string against the production for NAMES

    integer :: i, j

    good = (len(name) > 0)
    if (.not.good) return
    i = verify(name, " ")
    if (i==0) then
      good = .false.
      return
    endif
    j = scan(name(i:), " ")
    if (j==0) then
      j = len(name)
    else
      j = i + j - 2
    endif
    do
      good = checkQName(name(i:j), xv)
      if (.not.good) return
      i = j + 1
      j = verify(name(i:), " ")
      if (j==0) exit
      i = i + j - 1
      j = scan(name(i:), " ")
      if (j==0) then
        j = len(name)
      else
        j = i + j - 2
      endif
    enddo
       
  end function checkQNames


  pure function checkNCName(name, xv) result(good)
    character(len=*), intent(in) :: name
    integer, intent(in) :: xv
    logical :: good
    ! Validates a string against the XML requirements for an NCNAME
    ! Is not fully compliant; ignores UTF issues.

    good = (len(name)/=0)
    if (.not.good) return
    good = isInitialNCNameChar(name(1:1), xv)
    if (.not.good.or.len(name)==1) return
    good = isNCNameChar(name(2:), xv)
       
  end function checkNCName


  pure function checkNCNames(name, xv) result(good)
    character(len=*), intent(in) :: name
    integer, intent(in) :: xv
    logical :: good
    ! Validates a string against the production for NAMES

    integer :: i, j

    good = (len(name) > 0)
    if (.not.good) return
    i = verify(name, " ")
    if (i==0) then
      good = .false.
      return
    endif
    j = scan(name(i:), " ")
    if (j==0) then
      j = len(name)
    else
      j = i + j - 2
    endif
    do
      good = checkNCName(name(i:j), xv)
      if (.not.good) return
      i = j + 1
      j = verify(name(i:), " ")
      if (j==0) exit
      i = i + j - 1
      j = scan(name(i:), " ")
      if (j==0) then
        j = len(name)
      else
        j = i + j - 2
      endif
    enddo
       
  end function checkNCNames


  pure function checkNmtoken(name, xv) result(good)
    character(len=*), intent(in) :: name
    integer, intent(in) :: xv
    logical :: good
    ! Validates a string against the XML requirements for an NCNAME
    ! Is not fully compliant; ignores UTF issues.

    good = isNameChar(name, xv)
       
  end function checkNmtoken


  pure function checkNmtokens(name, xv) result(good)
    character(len=*), intent(in) :: name
    integer, intent(in) :: xv
    logical :: good
    ! Validates a string against the XML requirements for an NCNAME
    ! Is not fully compliant; ignores UTF issues.

    integer :: i, j

    good = (len(name) > 0)
    if (.not.good) return
    i = verify(name, " ")
    if (i==0) then
      good = .false.
      return
    endif
    j = scan(name(i:), " ")
    if (j==0) then
      j = len(name)
    else
      j = i + j - 2
    endif
    do
      good = isNameChar(name(i:j), xv)
      if (.not.good) return
      i = j + 1
      j = verify(name(i:), " ")
      if (j==0) exit
      i = i + j - 1
      j = scan(name(i:), " ")
      if (j==0) then
        j = len(name)
      else
        j = i + j - 2
      endif
    enddo
       
  end function checkNmtokens


  function checkPublicId(value) result(good)
    character(len=*), intent(in) :: value
    logical :: good
    character(len=*), parameter :: PubIdChars = &
      " "//achar(10)//achar(13)//lowerCase//upperCase//digits//"-'()+,./:=?;!*#@$_%"

    good = (verify(value, PubIdChars)==0) 
  end function checkPublicId


  function checkPEDef(value, xv) result(p)
    character(len=*), intent(in) :: value
    integer, intent(in) :: xv
    logical :: p

    integer :: i1, i2

    p = .false.
    if (scan(value, '%&')==0) then
      p = .true.
    elseif (scan(value, '"')==0) then
      i1 = scan(value, '%&')
      i2 = 0
      do while (i1>0)
        i1 = i2 + i1
        i2 = index(value(i1+1:),';')
        if (i2==0) return
        i2 = i1 + i2
        if (value(i1:i1)=='&') then
          if (.not.checkName(value(i1+1:i2-1), xv) .and. &
            .not.checkCharacterEntityReference(value(i1+1:i2-1), xv)) return
        else
          if (.not.checkName(value(i1+1:i2-1), xv)) &
            return
        endif
        i1 = scan(value(i2+1:), '%&')
      enddo
      p = .true.
    endif
  end function checkPEDef

  function checkPseudoAttValue(value, xv) result(p)
    character(len=*), intent(in) :: value
    integer, intent(in) :: xv
    logical :: p

    integer :: i1, i2
!fixme can we have entrefs in PIs?
    p = .false.
    if (scan(value, '"<&')==0) then
      p = .true.
    elseif (index(value, '&') > 0) then
      i1 = index(value, '&')
      i2 = 0
      do while (i1 > 0)
        i1 = i2 + i1
        i2 = index(value(i1+1:),';')
        if (i2==0) return
        i2 = i1 + i2
        if (value(i1+1:i2-1) /= 'amp' .and. &
          value(i1+1:i2-1) /= 'lt' .and. &
          value(i1+1:i2-1) /= 'gt' .and. &
          value(i1+1:i2-1) /= 'quot' .and. &
          value(i1+1:i2-1) /= 'apos' .and. &
          .not.checkCharacterEntityReference(value(i1+1:i2-1), xv)) &
          return
        i1 = index(value(i2+1:), '&')
      enddo
      p = .true.
    endif
  end function checkPseudoAttValue

  function checkAttValue(value, xv) result(p)
    character(len=*), intent(in) :: value
    integer, intent(in) :: xv
    logical :: p
    ! This function is called basically to make sure
    ! that any attribute value looks like one. It will
    ! not flag up out-of-range character entities, and
    ! is a very weak check. Only used from xml_AddAttribute
    ! when escaping is off.
    integer :: i1, i2

    p = .false.
    if (scan(value, '"<&'//"'")==0) then
      p = .true.
    elseif (index(value, '&') > 0) then
      i1 = index(value, '&')
      i2 = 0
      do while (i1 > 0)
        i1 = i1 + i2 + 1
        i2 = scan(value(i1+1:),';')
        if (i2 == 0) return
        i2 = i1 + i2
        if (.not.checkName(value(i1+1:i2-1), xv) .and. &
          .not.likeCharacterEntityReference(value(i1+1:i2-1))) then
          print*, value(i1+1:i2-1), " ", &
            likeCharacterEntityReference(value(i1+1:i2-1))
          return
        endif
        i1 = index(value(i2+1:), '&')
      enddo
      p = .true.
    endif
  end function checkAttValue

  
  function likeCharacterEntityReference(code) result(good)
    character(len=*), intent(in) :: code
    logical :: good

    good = .false.
    if (len(code) > 0) then
      if (code(1:1) == "#") then
        if (code(2:2) == "x") then
          if (len(code) > 2) then
            good = (verify(code(3:), hexdigits) == 0)
          endif
        else
          good = (verify(code(2:), digits) == 0)
        endif
      endif
    endif

  end function likeCharacterEntityReference

  function checkCharacterEntityReference(code, xv) result(good)
    character(len=*), intent(in) :: code
    integer, intent(in) :: xv
    logical :: good

    integer :: i

    good = .false.
    if (len(code) > 0) then
      if (code(1:1) == "#") then
        if (code(2:2) == "x") then
          if (len(code) > 2) then
            good = (verify(code(3:), hexdigits) == 0)
            if (good) then
              i = str_to_int_16(code(3:))
            endif
          endif
        else
          good = (verify(code(2:), digits) == 0)
          if (good) then
            i = str_to_int_10(code(2:))
          endif
        endif
      endif
    endif
    if (good) good = isLegalCharRef(i, xv)

  end function checkCharacterEntityReference

  function checkRepCharEntityReference(code, xv) result(good)
    character(len=*), intent(in) :: code
    integer, intent(in) :: xv
    logical :: good
    
    ! Is this a reference to a character we can actually represent
    ! in memory? ie without unicode, US-ASCII only.

    integer :: i

    good = .false.
    if (len(code) > 0) then
      if (code(1:1) == "#") then
        if (code(2:2) == "x") then
          if (len(code) > 2) then
            good = (verify(code(3:), hexdigits) == 0)
            if (good) then
              i = str_to_int_16(code(3:))
            endif
          endif
        else
          good = (verify(code(2:), digits) == 0)
          if (good) then
            i = str_to_int_10(code(2:))
          endif
        endif
      endif
    endif
    if (good) good = isRepCharRef(i, xv)

  end function checkRepCharEntityReference
  

  pure function prefixOfQName(qname) result(prefix)
    character(len=*), intent(in) :: qname
    character(len=max(index(qname, ':')-1,0)) :: prefix

    prefix = qname ! automatic truncation
  end function prefixOfQName

  
  pure function localpartOfQname(qname) result(localpart)
    character(len=*), intent(in) :: qname
    character(len=max(len(qname)-index(qname,':'),0)) ::localpart

    localpart = qname(index(qname,':')+1:)
  end function localpartOfQname

#endif
end module m_common_namecheck

module m_common_content_model

#ifndef DUMMYLIB
  ! Allow validating the content model of an XML document

  use fox_m_fsys_array_str, only: str_vs, vs_str_alloc, vs_vs_alloc
  implicit none
  private

  integer, parameter :: OP_NULL = 0
  integer, parameter :: OP_EMPTY = 1
  integer, parameter :: OP_ANY = 2
  integer, parameter :: OP_MIXED = 3
  integer, parameter :: OP_NAME = 4
  integer, parameter :: OP_CHOICE = 5
  integer, parameter :: OP_SEQ = 6

  integer, parameter :: REP_NULL = 0
  integer, parameter :: REP_ONCE = 1
  integer, parameter :: REP_QUESTION_MARK = 2
  integer, parameter :: REP_ASTERISK = 3
  
  type content_particle_t
    character, pointer :: name(:) => null()
    integer :: operator = OP_NULL
    integer :: repeater = REP_NULL
    type(content_particle_t), pointer :: nextSibling => null()
    type(content_particle_t), pointer :: parent => null()
    type(content_particle_t), pointer :: firstChild => null()
  end type content_particle_t

  public :: content_particle_t

  public :: newCP
  public :: transformCPPlus
  public :: checkCP
  public :: checkCPToEnd
  public :: elementContentCP
  public :: emptyContentCP
  public :: destroyCPtree
  public :: dumpCPtree

  public :: OP_NULL, OP_NAME, OP_MIXED, OP_CHOICE, OP_SEQ
  public :: REP_QUESTION_MARK, REP_ASTERISK

contains

  function newCP(empty, any, name, repeat) result(cp)
    logical, intent(in), optional :: empty
    logical, intent(in), optional :: any
    character(len=*), intent(in), optional :: name
    character, intent(in), optional :: repeat
    type(content_particle_t), pointer :: cp

    allocate(cp)
    if (present(empty)) then
      cp%operator = OP_EMPTY
    elseif (present(any)) then
      cp%operator = OP_ANY
    elseif (present(name)) then
      cp%operator = OP_NAME
      cp%name => vs_str_alloc(name)
    else
      cp%operator = OP_SEQ
    endif
    if (present(repeat)) then
      select case (repeat)
      case("?")
        cp%repeater = REP_QUESTION_MARK
      case("*")
        cp%repeater = REP_ASTERISK
      end select
    endif

  end function newCP

  function copyCP(cp) result(cp_out)
    type(content_particle_t), pointer :: cp
    type(content_particle_t), pointer :: cp_out

    allocate(cp_out)
    if (associated(cp%name)) cp_out%name => vs_vs_alloc(cp%name)
    cp_out%operator = cp%operator
    cp_out%repeater = cp%repeater
  end function copyCP

  function copyCPtree(cp) result(cp_out)
    type(content_particle_t), pointer :: cp
    type(content_particle_t), pointer :: cp_out

    type(content_particle_t), pointer :: tcp, tcp_out, tcpn_out, tcpp_out
    logical :: done

    tcp => cp
    cp_out => copyCP(cp)
    tcp_out => cp_out
    done = .false.
    do while (associated(tcp_out))
      if (.not.done) then
        do while (associated(tcp%firstChild))
          tcp => tcp%firstChild
          tcpn_out => copyCP(tcp)
          tcp_out%firstChild => tcpn_out
          tcpn_out%parent => tcp_out
          tcp_out => tcpn_out
        enddo
      endif
      tcpp_out => tcp_out%parent
      if (associated(tcp%nextSibling)) then
        done = .false.
        tcp => tcp%nextSibling
        tcpn_out => copyCP(tcp)
        tcp_out%nextSibling => tcpn_out
        tcpn_out%parent => tcpp_out
        tcp_out => tcpn_out
      else
        done = .true.
        tcp => tcp%parent
        tcp_out => tcp_out%parent
      endif
    enddo
  end function copyCPtree

  subroutine transformCPPlus(cp)
    type(content_particle_t), pointer :: cp

    type(content_particle_t), pointer :: tcp, cp_new

    ! Make copy of cp, and graft children on
    cp_new => copyCP(cp)
    cp_new%firstChild => cp%firstChild

    ! Reset children's parents ...
    tcp => cp%firstChild
    do while (associated(tcp))
      tcp%parent => cp_new
      tcp => tcp%nextSibling
    enddo

    ! Clear cp & make it an SEQ
    if (associated(cp%name)) deallocate(cp%name)
    cp%operator = OP_SEQ

    ! Append our copied cp to the now-an-SEQ
    cp%firstChild => cp_new
    cp_new%parent => cp

    ! Copy it for a sibling, and make the sibling a *
    cp_new%nextSibling => copyCPtree(cp_new)
    cp_new%nextSibling%parent => cp
    cp_new%nextSibling%repeater = REP_ASTERISK

  end subroutine transformCPPlus

  function checkCP(cp, name) result(p)
    type(content_particle_t), pointer :: cp
    character(len=*), intent(in) :: name
    logical :: p

    type(content_particle_t), pointer :: tcp

    ! for EMPTY, ANY or MIXED, cp never moves.
    ! for element content, we move the pointer as we
    ! move through the regex.

    ! If the regex includes ambiguous content, we are
    ! a bit screwed. But the document is in error if so.
    ! (and we are not required to diagnose errors.)

    p = .false.
    if (.not.associated(cp)) return

    select case(cp%operator)
    case (OP_EMPTY)
      continue ! anything fails
    case (OP_ANY)
      p = .true.
    case (OP_MIXED)
      tcp => cp%firstChild
      do while (associated(tcp))
        if (name==str_vs(tcp%name)) then
          p = .true.
          exit
        endif
        tcp => tcp%nextSibling
      enddo
    case default
      do
        if (.not.associated(cp)) exit
        select case (cp%operator)
        case (OP_NAME)
          p = (name==str_vs(cp%name))
          if (p) then
            tcp => nextCPAfterMatch(cp)
            cp => tcp
            exit
          else
            tcp => nextCPAfterFail(cp)
            cp => tcp
          endif
        case (OP_CHOICE, OP_SEQ)
          cp => cp%firstChild
        end select
      end do
    end select

  end function checkCP

  function nextCPaftermatch(cp) result(cp_next)
    type (content_particle_t), pointer :: cp
    type (content_particle_t), pointer :: cp_next

    type (content_particle_t), pointer :: tcp

    cp_next => cp

    do
      if (cp_next%repeater==REP_ASTERISK) exit
      tcp => cp_next%parent
      if (associated(tcp)) then
        if (tcp%operator==OP_CHOICE) then
          ! siblings are uninteresting, we've matched this CHOICE
          cp_next => tcp
          ! Move up & try the whole thing again on the parent CHOICE
        elseif (tcp%operator==OP_SEQ) then
          ! we do care about siblings, move onto next one
          if (associated(cp_next%nextSibling)) then
            cp_next => cp_next%nextSibling
            ! thatll do, itll be the next thing to try
            exit
          else
            ! No sibling, move up a level
            cp_next => tcp
            ! and try again
          endif
        endif
      else
        ! We've got to the top already.
        cp_next => tcp
        exit
      endif
    enddo
        
  end function nextCPaftermatch

  function nextCPafterfail(cp) result(cp_next)
    type(content_particle_t), pointer :: cp
    type(content_particle_t), pointer :: cp_next

    type(content_particle_t), pointer :: tcp
    logical :: match

    match = .false.
    cp_next => cp
    do
      tcp => cp_next%parent
      if (associated(tcp)) then
        if (tcp%operator==OP_CHOICE) then
          ! we care about siblings, lets try the next one
          if (associated(cp_next%nextSibling)) then
            cp_next => cp_next%nextSibling
            ! super, lets go back and try that
            exit
          else ! weve failed to match any cp in this CHOICE ...
            cp_next => tcp
            ! go up a level and see if theres another legitimate choice
          endif
        elseif (tcp%operator==OP_SEQ) then
          if ((match.or.cp_next%repeater/=REP_NULL) &
            .and.associated(cp_next%nextSibling)) then
            ! we were allowed to fail to match, try sibling
            cp_next => cp_next%nextSibling
            exit
          elseif (cp_next%repeater/=REP_NULL) then
            match = .true.
            ! The last item was optional, so weve matched at this level
            cp_next => tcp
          elseif (associated(tcp%firstChild, cp_next)) then
            ! we havent matched - but we hadnt started, Maybe it was ok
            ! not to match because we are nested inside an optional thingy
            cp_next => tcp
          else
            ! We were not allowed to fail there,
            ! there is no legitimate next choice.
            cp_next => null()
            exit
          endif
        endif
      else
        ! weve got all the way to the top without
        ! finding a new cp to try. But if this top-level
        ! cp is ASTERISK'ed we can try it agin
        cp_next => null()
        exit
      endif
    enddo
    
  end function nextCPafterfail

  function checkCPToEnd(cp) result(p)
    type(content_particle_t), pointer :: cp
    logical :: p

    type(content_particle_t), pointer :: tcp

    if (associated(cp)) then
      select case(cp%operator)
      case (OP_EMPTY, OP_ANY, OP_MIXED)
        p = .true.
      case default
        tcp => nextCPMustMatch(cp)
        p = .not.associated(tcp)
      end select
    else
      p = .true.
    endif
  end function checkCPToEnd

  function nextCPMustMatch(cp) result(cp_next)
    type(content_particle_t), pointer :: cp
    type(content_particle_t), pointer :: cp_next

    type(content_particle_t), pointer :: tcp

    if (.not.associated(cp)) return
    if (.not.associated(cp%parent)) then
      ! we havent started exploring this one.
      ! get the first starting position
      cp_next => cp
      do while (cp_next%repeater==REP_NULL)
        if (associated(cp_next%firstChild)) then
          cp_next => cp_next%firstChild
        else
          exit
        endif
      enddo
    else
      cp_next => cp
    endif
    if (cp_next%repeater==REP_NULL) return
    do
      tcp => cp_next%parent
      if (associated(tcp)) then
        if (tcp%operator==OP_CHOICE) then
          ! its matched by the optional one we are on, go up a level
          cp_next => tcp
        elseif (tcp%operator==OP_SEQ) then
          ! check all siblings for any compulsory ones
          do while (associated(cp_next%nextSibling))
            cp_next => cp_next%nextSibling
            if (cp_next%repeater==REP_NULL) return
          enddo
          ! all were optional, go up a level
          cp_next => tcp
        endif
      else
        ! weve got all the way to the top without
        ! finding a new cp to try
        cp_next => tcp
        exit
      endif
    enddo
    
  end function nextCPMustMatch

  function elementContentCP(cp) result(p)
    type(content_particle_t), pointer :: cp
    logical :: p

    if (associated(cp)) then
      select case (cp%operator)
      case (OP_EMPTY, OP_ANY, OP_MIXED)
        p = .false.
      case default
        p = .true.
      end select
    else
      p = .true.
    endif

  end function elementContentCP

  function emptyContentCP(cp) result(p)
    type(content_particle_t), pointer :: cp
    logical :: p

    if (associated(cp)) then
      p = cp%operator==OP_EMPTY
    else
      p = .false.
    endif

  end function emptyContentCP

  subroutine destroyCP(cp)
    type(content_particle_t), pointer :: cp

    if (associated(cp%name)) deallocate(cp%name)
    deallocate(cp)
  end subroutine destroyCP

  subroutine destroyCPtree(cp)
    type(content_particle_t), pointer :: cp

    type(content_particle_t), pointer :: current, tcp

    current => cp
    do
      do while (associated(current%firstChild))
        current => current%firstChild
      enddo
      if (associated(current, cp)) exit
      tcp => current
      if (associated(current%nextSibling)) then
        current => current%nextSibling
        call destroyCP(tcp)
      else
        current => current%parent
        call destroyCP(tcp)
        current%firstChild => null()
      endif
    enddo
    call destroyCP(cp)

  end subroutine destroyCPtree

  subroutine dumpCP(cp)
    type(content_particle_t), pointer :: cp

    select case(cp%operator)
    case (OP_EMPTY)
      write(*,'(a)', advance="no") "EMPTY"
    case (OP_ANY)
      write(*,'(a)', advance="no") "ANY"
    case (OP_MIXED)
      write(*,'(a)', advance="no") "MIXED"
    case (OP_NAME)
      write(*,'(a)', advance="no") str_vs(cp%name)
    case (OP_CHOICE)
      write(*,'(a)', advance="no") "CHOICE"
    case (OP_SEQ)
      write(*,'(a)', advance="no") "SEQ"
    end select
    select case(cp%repeater)
    case (REP_QUESTION_MARK)
      write(*,'(a)', advance="no") "?"
    case (REP_ASTERISK)
      write(*,'(a)', advance="no") "*"
    end select
    write(*,*)
  end subroutine dumpCP

  subroutine dumpCPtree(cp)
    type(content_particle_t), pointer :: cp

    type(content_particle_t), pointer :: current

    integer :: i
    logical :: done
    i = 0
    current => cp
    done = .false.
    call dumpCP(current)
    do
      if (.not.done) then
        do while (associated(current%firstChild))
          i = i + 2
          current => current%firstChild
          write(*,'(a)', advance="no") repeat(" ",i)
          call dumpCP(current)
        enddo
      endif
      if (associated(current, cp)) exit
      if (associated(current%nextSibling)) then
        done = .false.
        current => current%nextSibling
        write(*,'(a)', advance="no") repeat(" ",i)
        call dumpCP(current)
      else
        done = .true.
        i = i - 2
        current => current%parent
      endif
    enddo

  end subroutine dumpCPtree

#endif

end module m_common_content_model

module fox_m_fsys_realtypes

  implicit none
  private

  integer, parameter :: sp = selected_real_kind(6,30)
  integer, parameter :: dp = selected_real_kind(14,100)

  public :: sp
  public :: dp

end module fox_m_fsys_realtypes

module m_common_charset

#ifndef DUMMYLIB
  ! Written to use ASCII charset only. Full UNICODE would
  ! take much more work and need a proper unicode library.

  use fox_m_fsys_string, only: toLower

  implicit none
  private

!!$  character(len=1), parameter :: ASCII = &
!!$achar(0)//achar(1)//achar(2)//achar(3)//achar(4)//achar(5)//achar(6)//achar(7)//achar(8)//achar(9)//&
!!$achar(10)//achar(11)//achar(12)//achar(13)//achar(14)//achar(15)//achar(16)//achar(17)//achar(18)//achar(19)//&
!!$achar(20)//achar(21)//achar(22)//achar(23)//achar(24)//achar(25)//achar(26)//achar(27)//achar(28)//achar(29)//&
!!$achar(30)//achar(31)//achar(32)//achar(33)//achar(34)//achar(35)//achar(36)//achar(37)//achar(38)//achar(39)//&
!!$achar(40)//achar(41)//achar(42)//achar(43)//achar(44)//achar(45)//achar(46)//achar(47)//achar(48)//achar(49)//&
!!$achar(50)//achar(51)//achar(52)//achar(53)//achar(54)//achar(55)//achar(56)//achar(57)//achar(58)//achar(59)//&
!!$achar(60)//achar(61)//achar(62)//achar(63)//achar(64)//achar(65)//achar(66)//achar(67)//achar(68)//achar(69)//&
!!$achar(70)//achar(71)//achar(72)//achar(73)//achar(74)//achar(75)//achar(76)//achar(77)//achar(78)//achar(79)//&
!!$achar(80)//achar(81)//achar(82)//achar(83)//achar(84)//achar(85)//achar(86)//achar(87)//achar(88)//achar(89)//&
!!$achar(90)//achar(91)//achar(92)//achar(93)//achar(94)//achar(95)//achar(96)//achar(97)//achar(98)//achar(99)//&
!!$achar(100)//achar(101)//achar(102)//achar(103)//achar(104)//achar(105)//achar(106)//achar(107)//achar(108)//achar(109)//&
!!$achar(110)//achar(111)//achar(112)//achar(113)//achar(114)//achar(115)//achar(116)//achar(117)//achar(118)//achar(119)//&
!!$achar(120)//achar(121)//achar(122)//achar(123)//achar(124)//achar(125)//achar(126)//achar(127)

  character(len=1), parameter :: SPACE           = achar(32)
  character(len=1), parameter :: NEWLINE         = achar(10)
  character(len=1), parameter :: CARRIAGE_RETURN = achar(13)
  character(len=1), parameter :: TAB             = achar(9)

  character(len=*), parameter :: whitespace = SPACE//NEWLINE//CARRIAGE_RETURN//TAB

  character(len=*), parameter :: lowerCase = "abcdefghijklmnopqrstuvwxyz"
  character(len=*), parameter :: upperCase = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
  character(len=*), parameter :: digits = "0123456789"
  character(len=*), parameter :: hexdigits = "0123456789abcdefABCDEF"
  character(len=*), parameter :: InitialNCNameChars = lowerCase//upperCase//"_"
  character(len=*), parameter :: NCNameChars = InitialNCNameChars//digits//".-"
  character(len=*), parameter :: InitialNameChars = InitialNCNameChars//":"
  character(len=*), parameter :: NameChars = NCNameChars//":"

  character(len=*), parameter :: PubIdChars = NameChars//whitespace//"'()+,/=?;!*#@$%"
  character(len=*), parameter :: validchars = &
    whitespace//"!""#$%&'()*+,-./"//digits// &
    ":;<=>?@"//upperCase//"[\]^_`"//lowerCase//"{|}~"
  ! these are all the standard ASCII printable characters: whitespace + (33-126)
  ! which are the only characters we can guarantee to know how to handle properly.

  integer, parameter :: XML1_0 = 10      ! NB 0x7F was legal in XML-1.0, but illegal in XML-1.1

  integer, parameter :: XML1_1 = 11

  character(len=*), parameter :: XML1_0_ILLEGALCHARS = achar(0)
  character(len=*), parameter :: XML1_1_ILLEGALCHARS = NameChars

  character(len=*), parameter :: XML1_0_INITIALNAMECHARS = InitialNameChars
  character(len=*), parameter :: XML1_1_INITIALNAMECHARS = InitialNameChars
  character(len=*), parameter :: XML1_0_NAMECHARS = NameChars
  character(len=*), parameter :: XML1_1_NAMECHARS = NameChars

  character(len=*), parameter :: XML1_0_INITIALNCNAMECHARS = InitialNCNameChars
  character(len=*), parameter :: XML1_1_INITIALNCNAMECHARS = InitialNCNameChars
  character(len=*), parameter :: XML1_0_NCNAMECHARS = NCNameChars
  character(len=*), parameter :: XML1_1_NCNAMECHARS = NCNameChars


  character(len=*), parameter :: XML_WHITESPACE = whitespace
  character(len=*), parameter :: XML_INITIALENCODINGCHARS = lowerCase//upperCase
  character(len=*), parameter :: XML_ENCODINGCHARS = lowerCase//upperCase//digits//'._-'

  public :: validchars
  public :: whitespace
  public :: uppercase

  public :: digits
  public :: hexdigits

  public :: XML1_0
  public :: XML1_1
  public :: XML1_0_NAMECHARS
  public :: XML1_1_NAMECHARS
  public :: XML1_0_INITIALNAMECHARS
  public :: XML1_1_INITIALNAMECHARS
  public :: XML_WHITESPACE
  public :: XML_INITIALENCODINGCHARS
  public :: XML_ENCODINGCHARS

  public :: isLegalChar
  public :: isLegalCharRef
  public :: isRepCharRef
  public :: isInitialNameChar
  public :: isNameChar
  public :: isInitialNCNameChar
  public :: isNCNameChar
  public :: isXML1_0_NameChar
  public :: isXML1_1_NameChar
  public :: checkChars
  public :: isUSASCII
  public :: allowed_encoding

contains

  pure function isLegalChar(c, ascii_p, xml_version) result(p)
    character, intent(in) :: c
    ! really we should check the encoding here & be more intelligent
    ! for now we worry only about is it ascii or not.
    logical, intent(in) :: ascii_p
    integer, intent(in) :: xml_version
    logical :: p 
    ! Is this character legal as a source character in the document?
    integer :: i
    i = iachar(c)
    if (i<0) then
      p = .false.
      return
    elseif (i>127) then
      p = .not.ascii_p
      return
      ! ie if we are ASCII, then >127 is definitely illegal.
      ! otherwise maybe it's ok
    endif
    select case(xml_version)
    case (XML1_0)
      p = (i==9.or.i==10.or.i==13.or.(i>31.and.i<128))
    case (XML1_1)
      p = (i==9.or.i==10.or.i==13.or.(i>31.and.i<127))
      ! NB 0x7F was legal in XML-1.0, but illegal in XML-1.1
    end select
  end function isLegalChar

  pure function isLegalCharRef(i, xml_version) result(p)
    integer, intent(in) :: i
    integer, intent(in) :: xml_version
    logical :: p 

    ! Is Unicode character #i legal as a character reference?

    if (xml_version==XML1_0) then
      p = (i==9).or.(i==10).or.(i==13).or.(i>31.and.i<55296).or.(i>57343.and.i<65534).or.(i>65535.and.i<1114112)
    elseif (xml_version==XML1_1) then
      p = (i>0.and.i<55296).or.(i>57343.and.i<65534).or.(i>65535.and.i<1114112)
      ! XML 1.1 made all control characters legal as character references.
    end if
  end function isLegalCharRef

  pure function isRepCharRef(i, xml_version) result(p)
    integer, intent(in) :: i
    integer, intent(in) :: xml_version
    logical :: p 

    ! Is Unicode character #i legal and representable here?

    if (xml_version==XML1_0) then
      p = (i==9).or.(i==10).or.(i==13).or.(i>31.and.i<128)
    elseif (xml_version==XML1_1) then
      p = (i>0.and.i<128)
      ! XML 1.1 made all control characters legal as character references.
    end if
  end function isRepCharRef

  pure function isInitialNameChar(c, xml_version) result(p)
    character, intent(in) :: c
    integer, intent(in) :: xml_version
    logical :: p

    select case(xml_version)
    case (XML1_0)
      p = (verify(c, XML1_0_INITIALNAMECHARS)==0)
    case (XML1_1)
      p = (verify(c, XML1_1_INITIALNAMECHARS)==0)
    end select

  end function isInitialNameChar

  pure function isNameChar(c, xml_version) result(p)
    character(len=*), intent(in) :: c
    integer, intent(in) :: xml_version
    logical :: p

    select case(xml_version)
    case (XML1_0)
      p = (verify(c, XML1_0_NAMECHARS)==0)
    case (XML1_1)
      p = (verify(c, XML1_1_NAMECHARS)==0)
    end select

  end function isNameChar

  pure function isInitialNCNameChar(c, xml_version) result(p)
    character, intent(in) :: c
    integer, intent(in) :: xml_version
    logical :: p

    select case(xml_version)
    case (XML1_0)
      p = (verify(c, XML1_0_INITIALNCNAMECHARS)==0)
    case (XML1_1)
      p = (verify(c, XML1_1_INITIALNCNAMECHARS)==0)
    end select
  end function isInitialNCNameChar

  pure function isNCNameChar(c, xml_version) result(p)
    character(len=*), intent(in) :: c
    integer, intent(in) :: xml_version
    logical :: p

    select case(xml_version)
    case (XML1_0)
      p = (verify(c, XML1_0_NCNAMECHARS)==0)
    case (XML1_1)
      p = (verify(c, XML1_1_NCNAMECHARS)==0)
    end select
  end function isNCNameChar

  function isXML1_0_NameChar(c) result(p)
    character, intent(in) :: c
    logical :: p

    p = (verify(c, XML1_0_NAMECHARS)==0)

  end function isXML1_0_NameChar

  function isXML1_1_NameChar(c) result(p)
    character, intent(in) :: c
    logical :: p

    p = (verify(c, XML1_1_NAMECHARS)==0)

  end function isXML1_1_NameChar

  pure function checkChars(value, xv) result(p)
    character(len=*), intent(in) :: value
    integer, intent(in) :: xv
    logical :: p

    ! This checks if value only contains values
    ! legal to appear (escaped or unescaped) 
    ! according to whichever XML version is in force.
    integer :: i

    p = .true.
    do i = 1, len(value)
      if (xv == XML1_0) then
        select case(iachar(value(i:i)))
        case (0,8)
          p = .false.
        case (11,12)
          p = .false.
        end select
      else
        if (iachar(value(i:i))==0) p =.false.
      endif
    enddo
  end function checkChars

  function isUSASCII(encoding) result(p)
    character(len=*), intent(in) :: encoding
    logical :: p

    character(len=len(encoding)) :: enc
    enc = toLower(encoding)
    p = (enc=="ansi_x3.4-1968" &
      .or. enc=="ansi_x3.4-1986" &
      .or. enc=="iso_646.irv:1991" &
      .or. enc=="ascii" &
      .or. enc=="iso646-us" &
      .or. enc=="us-ascii" &
      .or. enc=="us" &
      .or. enc=="ibm367" &
      .or. enc=="cp367" &
      .or. enc=="csascii")

  end function isUSASCII

  function allowed_encoding(encoding) result(p)
    character(len=*), intent(in) :: encoding
    logical :: p

    character(len=len(encoding)) :: enc
    logical :: utf8, usascii, iso88591, iso88592, iso88593, iso88594, &
      iso88595, iso88596, iso88597, iso88598, iso88599, iso885910,  &
      iso885913, iso885914, iso885915, iso885916

    enc = toLower(encoding)

    ! From http://www.iana.org/assignments/character-sets
    ! We can only reliably do US-ASCII (the below is mostly
    ! a list of synonyms for US-ASCII) but we also accept
    ! UTF-8 as a practicality. We bail out if any non-ASCII
    ! characters are used later on.
    utf8 = (enc=="utf-8")

    usascii = (enc=="ansi_x3.4-1968" &
      .or. enc=="ansi_x3.4-1986" &
      .or. enc=="iso_646.irv:1991" &
      .or. enc=="ascii" &
      .or. enc=="iso646-us" &
      .or. enc=="us-ascii" &
      .or. enc=="us" &
      .or. enc=="ibm367" &
      .or. enc=="cp367" &
      .or. enc=="csascii")
! As of FoX 4.0, we accept ISO-8859-??, also as practicality
! since we know it is identical to ASCII as far as 0x7F

    iso88591 = (enc =="iso_8859-1:1987" &
      .or. enc=="iso-ir-100" &
      .or. enc=="iso_8859-1" &
      .or. enc=="iso-8859-1" &
      .or. enc=="latin1" &
      .or. enc=="l1" &
      .or. enc=="ibm819" &
      .or. enc=="cp819" &
      .or. enc=="csisolatin1")

    iso88592 = (enc=="iso_8859-2:1987" &
      .or. enc=="iso-ir-101" &
      .or. enc=="iso_8859-2" &
      .or. enc=="iso-8859-2" &
      .or. enc=="latin2" &
      .or. enc=="l2" &
      .or. enc=="csisolatin2")

    iso88593 = (enc=="iso_8859-3:1988" &
      .or. enc=="iso-ir-109" &
      .or. enc=="iso_8859-3" &
      .or. enc=="iso-8859-3" &
      .or. enc=="latin3" &
      .or. enc=="l3" &
      .or. enc=="csisolatin3")

    iso88594 = (enc=="iso_8859-4:1988" &
      .or. enc=="iso-ir-110" &
      .or. enc=="iso_8859-4" &
      .or. enc=="iso-8859-4" &
      .or. enc=="latin4" &
      .or. enc=="l4" &
      .or. enc=="csisolatin4")

    iso88595 = (enc=="iso_8859-5:1988" &
      .or. enc=="iso-ir-144" &
      .or. enc=="iso_8859-5" &
      .or. enc=="iso-8859-5" &
      .or. enc=="cyrillic" &
      .or. enc=="csisolatincyrillic")

    iso88596 = (enc=="iso_8859-6:1987" &
      .or. enc=="iso-ir-127" &
      .or. enc=="iso_8859-6" &
      .or. enc=="iso-8859-6" &
      .or. enc=="ecma-114" &
      .or. enc=="asmo-708" &
      .or. enc=="arabic" &
      .or. enc=="csisolatinarabic")

    iso88597 = (enc=="iso_8859-7:1987" &
      .or. enc=="iso-ir-126" &
      .or. enc=="iso_8859-7" &
      .or. enc=="iso-8859-7" &
      .or. enc=="elot_928" &
      .or. enc=="ecma-118" &
      .or. enc=="greek" &
      .or. enc=="greek8" &
      .or. enc=="csisolatingreek")

    iso88598 = (enc=="iso_8859-8:1988" &
      .or. enc=="iso-ir-138" &
      .or. enc=="iso_8859-8" &
      .or. enc=="iso-8859-8" &
      .or. enc=="hebrew" &
      .or. enc=="csisolatinhebrew")

    iso88599 = (enc=="iso_8859-9:1989" &
      .or. enc=="iso-ir-148" &
      .or. enc=="iso_8859-9" &
      .or. enc=="iso-8859-9" &
      .or. enc=="latin5" &
      .or. enc=="l5" &
      .or. enc=="csisolatin5")

    iso885910 = (enc=="iso-8859-10" &
      .or. enc=="iso-ir-157" &
      .or. enc=="l6" &
      .or. enc=="iso_8859-10:1992" &
      .or. enc=="csisolatin6" &
      .or. enc=="latin6")

! ISO 6937 replaces $ sign with currency sign.
! JIS-X0201 has Yen instead of backslash, macron instead of tilde
! 16, 17, 18, 19 - Japanese encoding we can't use.
! BS 4730 replaces hash with UK pound sign, and tilde to macron
! 21, 22, 23, 24, 25, 26 - other variants of iso646, similar but not identical
      
!      iso10646utf1 = (enc=="iso-10646-utf-1") ! FIXME check
!      iso656basic1983 = (enc=="iso_646.basic:1983" &
!        .or. enc=="csiso646basic1983") ! FIXME check
! INVARIANT - almost but not quite a subset of ASCII
!      iso646irv = (enc=="iso_646.irv:1983" &
!        .or. enc=="iso-ir-2" &
!        .or. enc=="irv")
! 31, 32, 33, 34 - NATS scandinavian, different from ASCII
! 35 - another iso646 variant
! 36, 37, 38 Korean shifted/multibyte
! 39, 40 Japanese shifted/multibyte
! 41, 42, JIS (iso646inv 7 bits)
! 43 another iso646 variantt
! 44, 45 greek variants
! 46 another iso646 variant
! 47 greek
! 48 cyrillic ascii relationship unknown
! 49 JIS again
! 50 similar not identical
! 51, 52, 53 not identical
! 54 see 48
! 55 see 47
! 56 another iso646 variant
! 57 chinese
! ... to be continued

      iso885913 = (enc=="iso-8859-13")
      iso885914 = (enc=="iso-8859-14" &
      .or. enc=="iso-ir-199" &
      .or. enc=="iso_8859-14:1998" &
      .or. enc=="iso_8849-14" &
      .or. enc=="iso_latin8" &
      .or. enc=="iso-celtic" &
      .or. enc=="l8")
      iso885915 = (enc=="iso-8859-15" &
        .or. enc=="iso-8859-15" &
        .or. enc=="latin-9")
      iso885916 = (enc=="iso-8859-16" &
        .or. enc=="iso-ir226" &
        .or. enc=="iso_8859-16:2001" &
        .or. enc=="iso_8859-16" &
        .or. enc=="latin10" &
        .or. enc=="l10")

      p = utf8.or.usascii.or.iso88591.or.iso88592.or.iso88593 &
        .or.iso88594.or.iso88595.or.iso88596.or.iso88597 &
        .or.iso88598.or.iso88599.or.iso885910.or.iso885913 &
        .or.iso885914.or.iso885915.or.iso885916

  end function allowed_encoding

#endif
end module m_common_charset

module m_common_namespaces

#ifndef DUMMYLIB
  use fox_m_fsys_array_str, only: str_vs, vs_str, vs_str_alloc

  use fox_m_utils_uri, only: URI, parseURI, destroyURI, hasScheme
  use m_common_attrs, only: dictionary_t, get_key, get_value, remove_key, getLength, hasKey
  use m_common_attrs, only: set_nsURI, set_localName, get_prefix, add_item_to_dict
  use m_common_charset, only: XML1_0, XML1_1
  use m_common_error, only: FoX_error, FoX_warning, error_stack, add_error, in_error
  use m_common_namecheck, only: checkNCName
  use m_common_struct, only: xml_doc_state

  implicit none
  private

  character(len=*), parameter :: invalidNS = '::INVALID::'
  ! an invalid URI name to indicate a namespace error.

  type URIMapping
    character, dimension(:), pointer :: URI
    integer :: ix ! link back to node depth
  end type URIMapping
  !This is a single URI, and the node depth under which
  !its namespace applies.

  type prefixMapping
    character, dimension(:), pointer :: prefix
    type(URIMapping), dimension(:), pointer :: urilist
  end type prefixMapping
  !This is the mapping for a single prefix; with the
  !list of namespaces which are in force at various
  !depths

  type namespaceDictionary
    private
    type(URIMapping), dimension(:), pointer :: defaults
    type(prefixMapping), dimension(:), pointer :: prefixes
  end type namespaceDictionary
  !This is the full namespace dictionary; defaults is
  !the list of default namespaces in force; prefix a
  !list of all prefixes in force.

  public :: invalidNS

  public :: initNamespaceDictionary
  public :: destroyNamespaceDictionary
  public :: namespaceDictionary
  public :: checkNamespaces
  public :: checkNamespacesWriting
  public :: checkEndNamespaces
  public :: getnamespaceURI
  interface getnamespaceURI
     module procedure getURIofDefaultNS, getURIofPrefixedNS
  end interface
  public :: isPrefixInForce
  public :: isDefaultNSInForce
  public :: getNumberOfPrefixes
  public :: getPrefixByIndex

  public :: dumpnsdict !FIXME

  public :: addDefaultNS
  public :: removeDefaultNS
  public :: addPrefixedNS
  public :: removePrefixedNS

contains


  subroutine initNamespaceDictionary(nsDict)
    type(namespaceDictionary), intent(inout) :: nsDict

    !We need to properly initialize 0th elements
    !(which are never used) in order to provide
    !sensible behaviour when trying to manipulate
    !an empty dictionary.

    allocate(nsDict%defaults(0:0))
    allocate(nsDict%defaults(0)%URI(0))
    !The 0th element of the defaults NS is the empty namespace
    nsDict%defaults(0)%ix = -1
    
    allocate(nsDict%prefixes(0:0))
    allocate(nsDict%prefixes(0)%prefix(0))
    allocate(nsDict%prefixes(0)%urilist(0:0))
    allocate(nsDict%prefixes(0)%urilist(0)%URI(len(invalidNS)))
    nsDict%prefixes(0)%urilist(0)%URI = vs_str(invalidNS)
    nsDict%prefixes(0)%urilist(0)%ix = -1

  end subroutine initNamespaceDictionary


  subroutine destroyNamespaceDictionary(nsDict)
    type(namespaceDictionary), intent(inout) :: nsDict

    integer :: i, j

    do i = 0, ubound(nsDict%defaults,1)
       deallocate(nsDict%defaults(i)%URI)
    enddo
    deallocate(nsDict%defaults)
    do i = 0, ubound(nsDict%prefixes,1)
       do j = 0, ubound(nsDict%prefixes(i)%urilist,1)
          deallocate(nsDict%prefixes(i)%urilist(j)%URI)
       enddo
       deallocate(nsDict%prefixes(i)%prefix)
       deallocate(nsDict%prefixes(i)%urilist)
    enddo
    deallocate(nsDict%prefixes)
  end subroutine destroyNamespaceDictionary


  subroutine copyURIMapping(urilist1, urilist2, l_m)
    type(URIMapping), dimension(0:), intent(inout) :: urilist1
    type(URIMapping), dimension(0:), intent(inout) :: urilist2
    integer, intent(in):: l_m
    integer :: i

    if (ubound(urilist1,1) < l_m .or. ubound(urilist2,1) < l_m) then
       call FoX_error('Internal error in m_sax_namespaces:copyURIMapping')
    endif
    ! Now copy all defaults across (or rather - add pointers to them)
    do i = 0, l_m
       urilist2(i)%ix = urilist1(i)%ix
       urilist2(i)%URI => urilist1(i)%URI
    enddo

  end subroutine copyURIMapping
    
  
  subroutine addDefaultNS(nsDict, uri, ix, es)
    type(namespaceDictionary), intent(inout) :: nsDict
    character(len=*), intent(in) :: uri
    integer, intent(in) :: ix
    type(error_stack), intent(inout), optional :: es

    type(URIMapping), dimension(:), allocatable :: tempMap
    integer :: l_m, l_s

    if (uri=="http://www.w3.org/XML/1998/namespace") then
      if (present(es)) then
        call add_error(es, "Attempt to assign incorrect URI to prefix 'xml'")
      else
        call FoX_error("Attempt to assign incorrect URI to prefix 'xml'")
      endif
    elseif (uri=="http://www.w3.org/2000/xmlns/") then
      if (present(es)) then
        call add_error(es, "Attempt to assign prefix to xmlns namespace")
      else
        call FoX_error("Attempt to assign prefix to xmlns namespace")
      endif
    endif

    ! FIXME check URI is valid ...

    l_m = ubound(nsDict%defaults,1)
    allocate(tempMap(0:l_m))
    ! Now copy all defaults across ...
    call copyURIMapping(nsDict%defaults, tempMap, l_m)
    deallocate(nsDict%defaults)
    l_m = l_m + 1
    allocate(nsDict%defaults(0:l_m))
    !Now copy everything back ...
    call copyURIMapping(tempMap, nsDict%defaults, l_m-1)
    deallocate(tempMap)
    ! And finally, add the new default NS
    nsDict%defaults(l_m)%ix = ix
    l_s = len(uri)
    allocate(nsDict%defaults(l_m)%URI(l_s))
    nsDict%defaults(l_m)%URI = vs_str(uri)

  end subroutine addDefaultNS
  

  subroutine addPrefixedURI(nsPrefix, uri, ix)
    type(PrefixMapping), intent(inout) :: nsPrefix
    character, dimension(:), intent(in) :: uri
    integer, intent(in) :: ix

    type(URIMapping), dimension(:), allocatable :: tempMap
    integer :: l_m, l_s

    l_m = ubound(nsPrefix%urilist,1)
    allocate(tempMap(0:l_m))
    ! Now copy all across ...
    call copyURIMapping(nsPrefix%urilist, tempMap, l_m)
    deallocate(nsPrefix%urilist)
    l_m = l_m + 1
    allocate(nsPrefix%urilist(0:l_m))
    !Now copy everything back ...
    call copyURIMapping(tempMap, nsPrefix%urilist, l_m-1)
    deallocate(tempMap)
    ! And finally, add the new default NS
    nsPrefix%urilist(l_m)%ix = ix
    l_s = size(uri)
    allocate(nsPrefix%urilist(l_m)%URI(l_s))
    nsPrefix%urilist(l_m)%URI = uri

  end subroutine addPrefixedURI
   
  subroutine removeDefaultNS(nsDict)
    type(namespaceDictionary), intent(inout) :: nsDict

    type(URIMapping), dimension(:), allocatable :: tempMap
    integer :: l_m

    l_m = ubound(nsDict%defaults,1)
    allocate(tempMap(0:l_m-1))
    ! Now copy all defaults across ...
    call copyURIMapping(nsDict%defaults, tempMap, l_m-1)
    !And remove tail-end charlie
    deallocate(nsDict%defaults(l_m)%URI)
    deallocate(nsDict%defaults)
    l_m = l_m - 1
    allocate(nsDict%defaults(0:l_m))
    !Now copy everything back ...
    call copyURIMapping(tempMap, nsDict%defaults, l_m)
    deallocate(tempMap)

  end subroutine removeDefaultNS

  subroutine removePrefixedURI(nsPrefix)
    type(PrefixMapping), intent(inout) :: nsPrefix

    type(URIMapping), dimension(:), allocatable :: tempMap
    integer :: l_m

    l_m = ubound(nsPrefix%urilist,1)
    allocate(tempMap(0:l_m-1))
    ! Now copy all defaults across ...
    call copyURIMapping(nsPrefix%urilist, tempMap, l_m-1)
    !And remove tail-end charlie
    deallocate(nsPrefix%urilist(l_m)%URI)
    deallocate(nsPrefix%urilist)
    l_m = l_m - 1
    allocate(nsPrefix%urilist(0:l_m))
    !Now copy everything back ...
    call copyURIMapping(tempMap, nsPrefix%urilist, l_m)
    deallocate(tempMap)

  end subroutine removePrefixedURI

  subroutine addPrefixedNS(nsDict, prefix, URI, ix, xds, xml, es)
    type(namespaceDictionary), intent(inout) :: nsDict
    character(len=*), intent(in) :: prefix
    character(len=*), intent(in) :: uri
    integer, intent(in) :: ix
    type(xml_doc_state), intent(in) :: xds
    logical, intent(in), optional :: xml
    type(error_stack), intent(inout), optional :: es
    
    integer :: l_p, p_i, i
    logical :: xml_

    if (present(xml)) then
      xml_ = xml
    else
      xml_ = .false.
    endif

    if (prefix=='xml' .and. &
      URI/='http://www.w3.org/XML/1998/namespace') then
      if (present(es)) then
        call add_error(es, "Attempt to assign incorrect URI to prefix 'xml'")
      else
        call FoX_error("Attempt to assign incorrect URI to prefix 'xml'")
      endif
    elseif (prefix/='xml' .and. &
      URI=='http://www.w3.org/XML/1998/namespace') then
      if (present(es)) then
        call add_error(es, "Attempt to assign incorrect prefix to XML namespace")
      else
        call FoX_error("Attempt to assign incorrect prefix to XML namespace")
      endif
    elseif (prefix == 'xmlns') then
      if (present(es)) then
        call add_error(es, "Attempt to declare 'xmlns' prefix")
      else
        call FoX_error("Attempt to declare 'xmlns' prefix")
      endif
    elseif (URI=="http://www.w3.org/2000/xmlns/") then
      if (present(es)) then
        call add_error(es, "Attempt to assign prefix to xmlns namespace")
      else
        call FoX_error("Attempt to assign prefix to xmlns namespace")
      endif
    elseif (len(prefix) > 2) then
      if ((verify(prefix(1:1), 'xX') == 0) &
        .and. (verify(prefix(2:2), 'mM') == 0) &
        .and. (verify(prefix(3:3), 'lL') == 0)) then
        if (.not.xml_) then
          ! FIXME need working warning infrastructure
          !if (present(es)) then
          !  call add_error(es, "Attempt to declare reserved prefix: "//prefix)
          !else
          call FoX_warning("Attempt to declare reserved prefix: "//prefix)
          !endif
        endif
      endif
    endif

    if (.not.checkNCName(prefix, xds%xml_version)) &
      call FoX_error("Attempt to declare invalid prefix: "//prefix)

    ! FIXME check URI is valid

    l_p = ubound(nsDict%prefixes, 1)
    
    p_i = 0
    do i = 1, l_p
       if (str_vs(nsDict%prefixes(i)%prefix) == prefix) then
          p_i = i
          exit
       endif
    enddo

    if (p_i == 0) then
       call addPrefix(nsDict, vs_str(prefix))
       p_i = l_p + 1
    endif
 
    call addPrefixedURI(nsDict%prefixes(p_i), vs_str(URI), ix)

  end subroutine addPrefixedNS

  subroutine removePrefixedNS(nsDict, prefix)
    type(namespaceDictionary), intent(inout) :: nsDict
    character, dimension(:), intent(in) :: prefix
    integer :: l_p, p_i, i
    l_p = ubound(nsDict%prefixes, 1)

    p_i = 0
    do i = 1, l_p
      if (str_vs(nsDict%prefixes(i)%prefix) == str_vs(prefix)) then
        p_i = i
        exit
      endif
    enddo

    if (p_i /= 0) then
      call removePrefixedURI(nsDict%prefixes(p_i))
      if (ubound(nsDict%prefixes(p_i)%urilist,1) == 0) then
        !that was the last mapping for that prefix
        call removePrefix(nsDict, p_i)
      endif
    else
      call FoX_error('Internal error in m_sax_namespaces:removePrefixedNS')
    endif
    
  end subroutine removePrefixedNS

  subroutine addPrefix(nsDict, prefix)
    type(namespaceDictionary), intent(inout) :: nsDict
    character, dimension(:), intent(in) :: prefix
    integer :: l_p

    type(prefixMapping), dimension(:), pointer :: tempPrefixMap

    integer :: i

    !Add a new prefix to the namespace dictionary.
    !Unfortunately this involves copying the entire
    !prefixes dictionary to a temporary structure, then
    !reallocating the prefixes dictionary to be one
    !longer, then copying everything back:

    l_p = ubound(nsDict%prefixes, 1)
    allocate(tempPrefixMap(0:l_p))

    !for each current prefix, append everything to temporary structure
    do i = 0, l_p
       tempPrefixMap(i)%prefix => nsDict%prefixes(i)%prefix
       tempPrefixMap(i)%urilist => nsDict%prefixes(i)%urilist
    enddo
    deallocate(nsDict%prefixes)
    !extend prefix dictionary by one ...
    l_p = l_p + 1
    allocate(nsDict%prefixes(0:l_p))
    !and copy back ...
    do i = 0, l_p-1
       nsDict%prefixes(i)%prefix => tempPrefixMap(i)%prefix
       nsDict%prefixes(i)%urilist => tempPrefixMap(i)%urilist
    enddo
    deallocate(tempPrefixMap)

    allocate(nsDict%prefixes(l_p)%prefix(size(prefix)))
    nsDict%prefixes(l_p)%prefix = prefix
    allocate(nsDict%prefixes(l_p)%urilist(0:0))
    allocate(nsDict%prefixes(l_p)%urilist(0)%URI(len(invalidNS)))
    nsDict%prefixes(l_p)%urilist(0)%URI = vs_str(invalidNS)
    nsDict%prefixes(l_p)%urilist(0)%ix = -1
    
  end subroutine addPrefix

  subroutine removePrefix(nsDict, i_p)
    type(namespaceDictionary), intent(inout) :: nsDict
    integer, intent(in) :: i_p
    integer :: l_p

    type(prefixMapping), dimension(:), pointer :: tempPrefixMap

    integer :: i

    !Remove a prefix from the namespace dictionary.
    !Unfortunately this involves copying the entire
    !prefixes dictionary to a temporary structure, then
    !reallocating the prefixes dictionary to be one
    !shorter, then copying everything back:

    l_p = ubound(nsDict%prefixes, 1)
    allocate(tempPrefixMap(0:l_p-1))

    !for each current prefix, append everything to temporary structure
    do i = 0, i_p-1
       tempPrefixMap(i)%prefix => nsDict%prefixes(i)%prefix
       tempPrefixMap(i)%urilist => nsDict%prefixes(i)%urilist
    enddo
    deallocate(nsDict%prefixes(i_p)%urilist(0)%URI)
    deallocate(nsDict%prefixes(i_p)%urilist)
    deallocate(nsDict%prefixes(i_p)%prefix)
    !this subroutine will only get called if the urilist is already
    !empty, so no need to deallocate it.
    do i = i_p+1, l_p
       tempPrefixMap(i-1)%prefix => nsDict%prefixes(i)%prefix
       tempPrefixMap(i-1)%urilist => nsDict%prefixes(i)%urilist
    enddo
    deallocate(nsDict%prefixes)
    !shorten prefix dictionary by one ...
    l_p = l_p - 1
    allocate(nsDict%prefixes(0:l_p))
    !and copy back ...
    do i = 0, l_p
       nsDict%prefixes(i)%prefix => tempPrefixMap(i)%prefix
       nsDict%prefixes(i)%urilist => tempPrefixMap(i)%urilist
    enddo
    deallocate(tempPrefixMap)

  end subroutine removePrefix


  subroutine checkNamespaces(atts, nsDict, ix, xds, namespace_prefixes, xmlns_uris, es, &
    partial, start_prefix_handler, end_prefix_handler)
    type(dictionary_t), intent(inout) :: atts
    type(namespaceDictionary), intent(inout) :: nsDict
    integer, intent(in) :: ix ! depth of nesting of current element.
    type(xml_doc_state), intent(in) :: xds
    logical, intent(in) :: namespace_prefixes, xmlns_uris
    type(error_stack), intent(inout) :: es
    logical, intent(in) :: partial ! if so, don't try and resolve anything except xml & xmlns
    optional :: start_prefix_handler, end_prefix_handler

    interface
      subroutine start_prefix_handler(namespaceURI, prefix)
        character(len=*), intent(in) :: namespaceURI
        character(len=*), intent(in) :: prefix
      end subroutine start_prefix_handler
      subroutine end_prefix_handler(prefix)
        character(len=*), intent(in) :: prefix
      end subroutine end_prefix_handler
    end interface

    character(len=6) :: xmlns
    character, dimension(:), pointer :: QName, URIstring
    integer :: i, n
    type(URI), pointer :: URIref
    !Check for namespaces; *and* remove xmlns references from 
    !the attributes dictionary.

    ! we can't do a simple loop across the attributes,
    ! because we need to remove some as we go along ...
    i = 1
    do while (i <= getLength(atts))
      xmlns = get_key(atts, i)
      if (xmlns == 'xmlns ') then
        !Default namespace is being set
        URIstring => vs_str_alloc(get_value(atts, i))
        if (str_vs(URIstring)=="") then
          ! Empty nsURI on default namespace has same effect in 1.0 and 1.1
          if (present(end_prefix_handler)) &
            call end_prefix_handler("")
          call addDefaultNS(nsDict, invalidNS, ix)
          deallocate(URIstring)
        else
          URIref => parseURI(str_vs(URIstring))
          if (.not.associated(URIref)) then
            call add_error(es, "Invalid URI: "//str_vs(URIstring))
            deallocate(URIstring)
            return
          elseif (.not.hasScheme(URIref)) then
            call add_error(es, "Relative namespace in URI deprecated: "//str_vs(URIstring))
            deallocate(URIstring)
            call destroyURI(URIref)
            return
          endif
          call destroyURI(URIref)
          if (present(start_prefix_handler)) &
            call start_prefix_handler(str_vs(URIstring), "")
          call addDefaultNS(nsDict, str_vs(URIstring), ix)
          deallocate(URIstring)
        endif
        if (namespace_prefixes) then
          i = i + 1
        else
          call remove_key(atts, i)
        endif
      elseif (xmlns == 'xmlns:') then
        !Prefixed namespace is being set
        QName => vs_str_alloc(get_key(atts, i))
        URIstring => vs_str_alloc(get_value(atts, i))
        if (str_vs(URIstring)=="") then
          if (xds%xml_version==XML1_0) then
            call add_error(es, "Empty nsURI is invalid in XML 1.0")
            deallocate(URIstring)
            deallocate(QName)
            return
          elseif (xds%xml_version==XML1_1) then
            call addPrefixedNS(nsDict, str_vs(QName(7:)), invalidNS, ix, xds, es=es)
            if (in_error(es)) then
              deallocate(URIstring)
              deallocate(QName)
              return
            elseif (present(end_prefix_handler)) then
              call end_prefix_handler(str_vs(QName(7:)))
            endif
            deallocate(URIstring)
            deallocate(QName)
          endif
        else
          URIref => parseURI(str_vs(URIstring))
          if (.not.associated(URIref)) then
            call add_error(es, "Invalid URI: "//str_vs(URIstring))
            deallocate(URIstring)
            deallocate(QName)
            return
          elseif (.not.hasScheme(URIref)) then
            call add_error(es, "Relative namespace in URI deprecated: "//str_vs(URIstring))
            deallocate(URIstring)
            deallocate(QName)
            call destroyURI(URIref)
            return
          endif
          call destroyURI(URIref)
          call addPrefixedNS(nsDict, str_vs(QName(7:)), str_vs(URIstring), ix, xds, es=es)
          if (in_error(es)) then
            deallocate(URIstring)
            deallocate(QName)
            return
          elseif (present(start_prefix_handler)) then
            call start_prefix_handler(str_vs(URIstring), str_vs(QName(7:)))
          endif
          deallocate(URIstring)
          deallocate(QName)
        endif
        if (namespace_prefixes) then
          i = i + 1
        else
          call remove_key(atts, i)
        endif
      else
        ! we only increment if we haven't removed a key
        i = i + 1
      endif
    enddo

    ! having done that, now resolve all attribute namespaces:
    do i = 1, getLength(atts)
      QName => vs_str_alloc(get_key(atts,i))
      n = index(str_vs(QName), ":")
      if (n > 0) then
        if (str_vs(QName(1:n-1))=="xmlns") then
          ! FIXME but this can be controlled by SAX configuration xmlns-uris
          if (xmlns_uris) then
            call set_nsURI(atts, i, "http://www.w3.org/2000/xmlns/")
          else
            call set_nsURI(atts, i, "")
          endif
        else
          if (str_vs(QName(1:n-1))=="xml") then
            call set_nsURI(atts, i, "http://www.w3.org/XML/1998/namespace")
          elseif (getnamespaceURI(nsDict, str_vs(QName(1:n-1)))==invalidNS) then
            ! Sometimes we don't want to worry about unbound prefixes,
            ! eg if we are in the middle of parsing an entity.
            if (.not.partial) then
              call add_error(es, "Unbound namespace prefix")
              deallocate(QName)
              return
            else
              call set_nsURI(atts, i, "")
            endif
          else
            call set_nsURI(atts, i, getnamespaceURI(nsDict, str_vs(QName(1:n-1))))
          endif
        endif
      else
        if (xmlns_uris.and.str_vs(QName)=="xmlns") then
          call set_nsURI(atts, i, "http://www.w3.org/2000/xmlns/")
        else
          call set_nsURI(atts, i, "") ! no such thing as a default namespace on attributes
        endif
      endif
      ! Check for duplicates
      if (hasKey(atts, getnamespaceURI(nsDict, str_vs(QName(1:n-1))), str_vs(QName(n+1:)))) then
        call add_error(es, "Duplicate attribute names after namespace processing")
        deallocate(QName)
        return
      endif
      call set_localName(atts, i, QName(n+1:))
      deallocate(QName)
    enddo

  end subroutine checkNamespaces

  
  subroutine checkNamespacesWriting(atts, nsdict, ix)
    type(dictionary_t), intent(inout) :: atts
    type(namespaceDictionary), intent(inout) :: nsDict
    integer, intent(in) :: ix
    ! Read through a list of attributes, check with currently
    ! active namespaces & add any necessary declarations

    integer :: i, i_p, l_d, l_ps, n

    n = getLength(atts) ! we need the length before we fiddle with it

    !Does the default NS need added?
    l_d = ubound(nsDict%defaults,1)
    if (nsDict%defaults(l_d)%ix == ix) then
      !It's not been registered yet:
      call add_item_to_dict(atts, "xmlns", &
           str_vs(nsDict%defaults(l_d)%URI), type="CDATA")
    endif

    !next, add any overdue prefixed NS's in the same way:
    ! there should only ever be one. More would be an error,
    ! but the check should have been done earlier.
    do i_p = 0, ubound(nsDict%prefixes, 1)
      l_ps = ubound(nsDict%prefixes(i_p)%urilist,1)
      if (nsDict%prefixes(i_p)%urilist(l_ps)%ix == ix) then
        call add_item_to_dict(atts, &
             "xmlns:"//str_vs(nsDict%prefixes(i_p)%prefix), &
             str_vs(nsDict%prefixes(i_p)%urilist(l_ps)%URI), &
             type="CDATA")
      endif
    enddo
    

    !Finally, we may have some we've added for attribute QNames
    ! have to get those too:
    do i = 1, getLength(atts)
      ! get prefix, and identify the relevant NS mapping
      i_p = getPrefixIndex(nsDict, get_prefix(atts, i))
      l_ps = ubound(nsDict%prefixes(i_p)%urilist,1)
      !If the index is greater than what it should be:
      if (nsDict%prefixes(i_p)%urilist(l_ps)%ix > ix) then
        !we only just added this, so we need to declare it
        call add_item_to_dict(atts, "xmlns:"//get_prefix(atts, i), &
             str_vs(nsDict%prefixes(i_p)%urilist(l_ps)%URI), &
             type="CDATA")
        !Reset the index to the right value:
        nsDict%prefixes(i_p)%urilist(l_ps)%ix = ix
      endif
    enddo

  end subroutine checkNamespacesWriting


  subroutine checkEndNamespaces(nsDict, ix, end_prefix_handler)
    type(namespaceDictionary), intent(inout) :: nsDict
    integer, intent(in) :: ix

    optional :: end_prefix_handler
    
    interface
      subroutine end_prefix_handler(prefix)
        character(len=*), intent(in) :: prefix
      end subroutine end_prefix_handler
    end interface

    integer :: l_d, l_p, l_ps, i
    character, pointer :: prefix(:)

    !It will only ever be the final elements in the list which
    ! might have expired.

    l_d = ubound(nsDict%defaults,1)
    do while (nsDict%defaults(l_d)%ix == ix)
      if (present(end_prefix_handler)) &
        call end_prefix_handler("")
      call removeDefaultNS(nsDict)
      l_d = ubound(nsDict%defaults,1)
    enddo

    l_p = ubound(nsDict%prefixes, 1)
    i = 1
    do while (i <= l_p)
      l_ps = ubound(nsDict%prefixes(l_p)%urilist,1)
      if (nsDict%prefixes(i)%urilist(l_ps)%ix == ix) then
        if (present(end_prefix_handler)) &
          call end_prefix_handler(str_vs(nsDict%prefixes(i)%prefix))
        ! We have to assign this pointer explicitly, otherwise the next call
        ! aliases its arguments illegally.
        prefix =>  nsDict%prefixes(i)%prefix
        call removePrefixedNS(nsDict, prefix)
        if (l_p > ubound(nsDict%prefixes, 1)) then
          ! we just removed the last reference to that prefix,
          ! so our list of prefixes has shrunk - update the running total.
          ! and go to the next prefix, which is at the same index
          l_p = l_p - 1
          cycle
        endif
      endif
      i = i + 1
    enddo

  end subroutine checkEndNamespaces


  subroutine dumpnsdict(nsdict)
    type(namespaceDictionary), intent(in) :: nsdict
    integer :: i, j
    write(*,'(a)')'* default namespaces *'

    do i = 1, ubound(nsdict%defaults, 1)
      write(*,'(i0,a)') nsdict%defaults(i)%ix, str_vs(nsdict%defaults(i)%URI)
    enddo
    write(*,'(a)') '* Prefixed namespaces *'
    do i = 1, ubound(nsdict%prefixes, 1)
       write(*,'(2a)') '* prefix: ', str_vs(nsdict%prefixes(i)%prefix)
       do j = 1, ubound(nsdict%prefixes(i)%urilist, 1)
          write(*,'(i0,a)') nsdict%prefixes(i)%urilist(j)%ix, str_vs(nsdict%prefixes(i)%urilist(j)%URI)
       enddo
    enddo

  end subroutine dumpnsdict


  pure function getURIofDefaultNS(nsDict) result(uri)
    type(namespaceDictionary), intent(in) :: nsDict
    character(len=size(nsDict%defaults(ubound(nsDict%defaults,1))%URI)) :: URI
    
    integer :: l_d
    l_d = ubound(nsDict%defaults,1)
    uri = str_vs(nsDict%defaults(l_d)%URI)
  end function getURIofDefaultNS


  pure function isPrefixInForce(nsDict, prefix) result(force)
    type(namespaceDictionary), intent(in) :: nsDict
    character(len=*), intent(in) :: prefix
    logical :: force
    integer :: i, l_s

    force = .false.
    do i = 1, ubound(nsDict%prefixes, 1)
       if (str_vs(nsDict%prefixes(i)%prefix) == prefix) then
         l_s = ubound(nsDict%prefixes(i)%urilist, 1)
         force = (size(nsdict%prefixes(i)%urilist(l_s)%URI) > 0)
         exit
       endif
    enddo

  end function isPrefixInForce


  pure function isDefaultNSInForce(nsDict) result(force)
    type(namespaceDictionary), intent(in) :: nsDict
    logical :: force
    integer :: l_s

    force = .false.
    l_s = ubound(nsDict%defaults, 1)
    if (l_s > 0) &
      force = (size(nsdict%defaults(l_s)%URI) > 0)

  end function isDefaultNSInForce


  pure function getPrefixIndex(nsDict, prefix) result(p)
    type(namespaceDictionary), intent(in) :: nsDict
    character(len=*), intent(in) :: prefix
    integer :: p
    
    integer :: i
    p = 0
    do i = 1, ubound(nsDict%prefixes, 1)
      if (str_vs(nsDict%prefixes(i)%prefix) == prefix) then
           p = i
           exit
       endif
    enddo
  end function getPrefixIndex

  
  function getNumberOfPrefixes(nsDict) result(n)
    type(namespaceDictionary), intent(in) :: nsDict
    integer :: n
    n = ubound(nsDict%prefixes, 1)
  end function getNumberOfPrefixes


  function getPrefixByIndex(nsDict, i) result(c)
    type(namespaceDictionary), intent(in) :: nsDict
    integer, intent(in) :: i
    character(len=size(nsDict%prefixes(i)%prefix)) :: c

    c = str_vs(nsDict%prefixes(i)%prefix)
  end function getPrefixByIndex


  pure function getURIofPrefixedNS(nsDict, prefix) result(uri)
    type(namespaceDictionary), intent(in) :: nsDict
    character(len=*), intent(in) :: prefix
    character(len=size( &
              nsDict%prefixes( &
           getPrefixIndex(nsDict,prefix) &
                             ) &
                     %urilist( &
           ubound(nsDict%prefixes(getPrefixIndex(nsDict,prefix))%urilist, 1) &
                             ) & 
                      %uri)) :: URI
    integer :: p_i, l_m
    p_i = getPrefixIndex(nsDict, prefix)
    l_m = ubound(nsDict%prefixes(p_i)%urilist, 1)
    uri = str_vs(nsDict%prefixes(p_i)%urilist(l_m)%URI)

  end function getURIofPrefixedNS

#endif
end module m_common_namespaces

! This file is AUTOGENERATED!!!!
! Do not edit this file; edit m_wcml_quantity.m4 and regenerate.
!
!
module m_wcml_property

  use fox_m_fsys_realtypes, only: sp, dp
  use FoX_wxml, only: xmlf_t

#ifndef DUMMYLIB
  use FoX_wxml, only: xml_NewElement, xml_AddAttribute
  use FoX_wxml, only: xml_EndElement
  use m_wcml_stml, only: stmAddValue

! Fix for pgi, requires this explicitly:
  use m_wxml_overloads
#endif

  implicit none
  private

  interface cmlAddproperty
     module procedure propertyCmplxDpSca
     module procedure propertyCmplxDpArrSi
     module procedure propertyCmplxDpArrSh
     module procedure propertyCmplxDpMatSi
     module procedure propertyCmplxDpMatSh
     module procedure propertyCmplxSpSca
     module procedure propertyCmplxSpArrSi
     module procedure propertyCmplxSpArrSh
     module procedure propertyCmplxSpMatSi
     module procedure propertyCmplxSpMatSh
     module procedure propertyRealDpSca
     module procedure propertyRealDpArrSi
     module procedure propertyRealDpArrSh
     module procedure propertyRealDpMatSi
     module procedure propertyRealDpMatSh
     module procedure propertyRealSpSca
     module procedure propertyRealSpArrSi
     module procedure propertyRealSpArrSh
     module procedure propertyRealSpMatSi
     module procedure propertyRealSpMatSh
     module procedure propertyIntSca
     module procedure propertyIntArrSi
     module procedure propertyIntArrSh
     module procedure propertyIntMatSi
     module procedure propertyIntMatSh
     module procedure propertyLgSca
     module procedure propertyLgArrSi
     module procedure propertyLgArrSh
     module procedure propertyLgMatSi
     module procedure propertyLgMatSh
     module procedure propertyChSca
     module procedure propertyChArrSi
     module procedure propertyChArrSh
     module procedure propertyChMatSi
     module procedure propertyChMatSh

  end interface

  public :: cmlAddproperty

contains

  subroutine propertyCmplxDpSca &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in)   :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyCmplxDpSca

  subroutine propertyCmplxSpSca &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in)   :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyCmplxSpSca

  subroutine propertyRealDpSca &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in)   :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyRealDpSca

  subroutine propertyRealSpSca &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in)   :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyRealSpSca

  subroutine propertyIntSca &
    (xf, value, dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in)   :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyIntSca

  subroutine propertyLgSca &
    (xf, value, dictRef, convention, title, id, ref, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in)   :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyLgSca

  subroutine propertyChSca &
    (xf, value, dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in)   :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyChSca


  subroutine propertyCmplxDpArrSi &
    (xf, value,nitems,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyCmplxDpArrSi

  subroutine propertyCmplxSpArrSi &
    (xf, value,nitems,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyCmplxSpArrSi

  subroutine propertyRealDpArrSi &
    (xf, value,nitems,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyRealDpArrSi

  subroutine propertyRealSpArrSi &
    (xf, value,nitems,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyRealSpArrSi

  subroutine propertyIntArrSi &
    (xf, value,nitems,  dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyIntArrSi

  subroutine propertyLgArrSi &
    (xf, value,nitems,  dictRef, convention, title, id, ref, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems))
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyLgArrSi

  subroutine propertyChArrSi &
    (xf, value,nitems,  dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyChArrSi


  subroutine propertyCmplxDpArrSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyCmplxDpArrSh

  subroutine propertyCmplxSpArrSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyCmplxSpArrSh

  subroutine propertyRealDpArrSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyRealDpArrSh

  subroutine propertyRealSpArrSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyRealSpArrSh

  subroutine propertyIntArrSh &
    (xf, value, dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyIntArrSh

  subroutine propertyLgArrSh &
    (xf, value, dictRef, convention, title, id, ref, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyLgArrSh

  subroutine propertyChArrSh &
    (xf, value, dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyChArrSh


  subroutine propertyCmplxDpMatSi &
    (xf, value,nrows, ncols,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyCmplxDpMatSi

  subroutine propertyCmplxSpMatSi &
    (xf, value,nrows, ncols,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyCmplxSpMatSi

  subroutine propertyRealDpMatSi &
    (xf, value,nrows, ncols,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyRealDpMatSi

  subroutine propertyRealSpMatSi &
    (xf, value,nrows, ncols,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyRealSpMatSi

  subroutine propertyIntMatSi &
    (xf, value,nrows, ncols,  dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyIntMatSi

  subroutine propertyLgMatSi &
    (xf, value,nrows, ncols,  dictRef, convention, title, id, ref, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols))
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyLgMatSi

  subroutine propertyChMatSi &
    (xf, value,nrows, ncols,  dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyChMatSi


  subroutine propertyCmplxDpMatSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyCmplxDpMatSh

  subroutine propertyCmplxSpMatSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyCmplxSpMatSh

  subroutine propertyRealDpMatSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyRealDpMatSh

  subroutine propertyRealSpMatSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyRealSpMatSh

  subroutine propertyIntMatSh &
    (xf, value, dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyIntMatSh

  subroutine propertyLgMatSh &
    (xf, value, dictRef, convention, title, id, ref, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyLgMatSh

  subroutine propertyChMatSh &
    (xf, value, dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "property")
#endif
 
  end subroutine propertyChMatSh


end module m_wcml_property

module fox_m_fsys_format

!Note that there are several oddities to this package,
!to get round assorted compiler bugs.

!All the _matrix_ subroutines should be straight
!call-throughs to the relevant _array_ subroutine,
!but with flattened arrays. (this would allow easy
!generation of all functions up to 7 dimensions)
!but unfortunately that breaks PGI-6.1, and causes
!errors on Pathscale-2.4.

!The Logical array/matrix functions should be able
!to COUNT their length inline in the specification
!expression, but Pathscale-2.4 gives an error on that.

  use fox_m_fsys_abort_flush, only: pxfflush
  use fox_m_fsys_realtypes, only: sp, dp

  implicit none
  private

#ifndef DUMMYLIB
  integer, parameter :: sig_sp = digits(1.0_sp)/4
  integer, parameter :: sig_dp = digits(1.0_dp)/4 ! Approximate precision worth outputting of each type.

  character(len=*), parameter :: digit = "0123456789:"
  character(len=*), parameter :: hexdigit = "0123456789abcdefABCDEF"
#endif

  interface str
! This is for external use only: str should not be called within this
! file.
! All *_chk subroutines check that the fmt they are passed is valid.
    module procedure str_string, str_string_array, str_string_matrix, &
                     str_integer, str_integer_array, str_integer_matrix, &
                     str_integer_fmt, str_integer_array_fmt, str_integer_matrix_fmt, &
                     str_logical, str_logical_array, str_logical_matrix, &
                     str_real_sp, str_real_sp_fmt_chk, &
                     str_real_sp_array, str_real_sp_array_fmt_chk, &
                     str_real_sp_matrix, str_real_sp_matrix_fmt_chk, &
                     str_real_dp, str_real_dp_fmt_chk, &
                     str_real_dp_array, str_real_dp_array_fmt_chk, &
                     str_real_dp_matrix, str_real_dp_matrix_fmt_chk, &
                     str_complex_sp, str_complex_sp_fmt_chk, &
                     str_complex_sp_array, str_complex_sp_array_fmt_chk, &
                     str_complex_sp_matrix, str_complex_sp_matrix_fmt_chk, &
                     str_complex_dp, str_complex_dp_fmt_chk, &
                     str_complex_dp_array, str_complex_dp_array_fmt_chk, &
                     str_complex_dp_matrix, str_complex_dp_matrix_fmt_chk
  end interface str

#ifndef DUMMYLIB
  interface safestr
! This is for internal use only - no check is made on the validity of 
! any fmt input.
    module procedure str_string, str_string_array, str_string_matrix, &
                     str_integer, str_integer_array, str_integer_matrix, &
                     str_logical, str_logical_array, str_logical_matrix, &
                     str_real_sp, str_real_sp_fmt, &
                     str_real_sp_array, str_real_sp_array_fmt, &
                     str_real_sp_matrix, str_real_sp_matrix_fmt, &
                     str_real_dp, str_real_dp_fmt, &
                     str_real_dp_array, str_real_dp_array_fmt, &
                     str_real_dp_matrix, str_real_dp_matrix_fmt, &
                     str_complex_sp, str_complex_sp_fmt, &
                     str_complex_sp_array, str_complex_sp_array_fmt, &
                     str_complex_sp_matrix, str_complex_sp_matrix_fmt, &
                     str_complex_dp, str_complex_dp_fmt, &
                     str_complex_dp_array, str_complex_dp_array_fmt, &
                     str_complex_dp_matrix, str_complex_dp_matrix_fmt
  end interface safestr

  interface len
    module procedure str_integer_len, str_integer_array_len, str_integer_matrix_len, &
                     str_integer_fmt_len, str_integer_array_fmt_len, str_integer_matrix_fmt_len, &
                     str_logical_len, str_logical_array_len, str_logical_matrix_len, &
                     str_real_sp_len, str_real_sp_fmt_len, &
                     str_real_sp_array_len, str_real_sp_array_fmt_len, &
                     str_real_sp_matrix_len, str_real_sp_matrix_fmt_len, &
                     str_real_dp_len, str_real_dp_fmt_len, &
                     str_real_dp_array_len, str_real_dp_array_fmt_len, &
                     str_real_dp_matrix_len, str_real_dp_matrix_fmt_len, &
                     str_complex_sp_len, str_complex_sp_fmt_len, &
                     str_complex_sp_array_len, str_complex_sp_array_fmt_len, &
                     str_complex_sp_matrix_len, str_complex_sp_matrix_fmt_len, &
                     str_complex_dp_len, str_complex_dp_fmt_len, &
                     str_complex_dp_array_len, str_complex_dp_array_fmt_len, &
                     str_complex_dp_matrix_len, str_complex_dp_matrix_fmt_len
  end interface
#endif

  interface operator(//)
    module procedure concat_str_int, concat_int_str, &
      concat_str_logical, concat_logical_str, &
      concat_real_sp_str, concat_str_real_sp, &
      concat_real_dp_str, concat_str_real_dp, &
      concat_complex_sp_str, concat_str_complex_sp, &
      concat_complex_dp_str, concat_str_complex_dp
  end interface

  public :: str
  public :: operator(//)

#ifndef DUMMYLIB
  public :: str_to_int_10
  public :: str_to_int_16
#endif

contains

#ifndef DUMMYLIB
  subroutine FoX_error(msg)
    ! Emit error message and stop.
    ! No clean up is done here, but this can
    ! be overridden to include clean-up routines
    character(len=*), intent(in) :: msg

    write(0,'(a)') 'ERROR(FoX)'
    write(0,'(a)')  msg
    call pxfflush(0)

    stop

  end subroutine FoX_error


  pure function str_to_int_10(str) result(n)
    ! Takes a string containing digits, and returns
    ! the integer representable by those digits.
    ! Does not deal with negative numbers, and
    ! presumes that the number is representable
    ! in a default integer
    ! Error is flagged by returning -1
    character(len=*), intent(in) :: str
    integer :: n

    integer :: max_power, i, j

    if (verify(str, digit) > 0) then
      n = -1
      return
    endif

    max_power = len(str) - 1

    n = 0
    do i = 0, max_power
      j = max_power - i + 1
      n = n + (index(digit, str(j:j)) - 1) * 10**i
    enddo

  end function str_to_int_10

  pure function str_to_int_16(str) result(n)
    ! Takes a string containing hexadecimal digits, and returns
    ! the integer representable by those digits.
    ! Does not deal with negative numbers, and
    ! presumes that the number is representable
    ! in a default integer
    ! Error is flagged by returning -1
    character(len=*), intent(in) :: str
    integer :: n
    
    character(len=len(str)) :: str_l
    integer :: max_power, i, j

    if (verify(str, hexdigit) == 0) then
       str_l = to_lower(str)
    else
      n = -1
      return
    endif

    max_power = len(str) - 1

    n = 0
    do i = 0, max_power
      j = max_power - i + 1
      n = n + (index(hexdigit, str_l(j:j)) - 1) * 16**i
    enddo

  contains
    pure function to_lower(s) result(s2)
      character(len=*), intent(in) :: s
      character(len=len(s)) :: s2
      character(len=*), parameter :: hex = "abcdef"
      integer :: j, k
      do j = 1, len(s)
        k = index('ABCDEF', s(j:j))
        if (k > 0) then
          s2(j:j) = hex(k:k)
        else
          s2(j:j) = s(j:j)
        endif
      enddo
    end function to_lower
         
  end function str_to_int_16
#endif

  pure function str_string(st) result(s)
    character(len=*), intent(in) :: st
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " " 
#else
    character(len=len(st)) :: s
    s = st
#endif
  end function str_string

#ifndef DUMMYLIB
  pure function str_string_array_len(st) result(n)
    character(len=*), dimension(:), intent(in) :: st
    integer :: n

    integer :: k

    n = size(st) - 1
    do k = 1, size(st)
      n = n + len(st(k))
    enddo

  end function str_string_array_len
#endif

  pure function str_string_array(st, delimiter) result(s)
    character(len=*), dimension(:), intent(in) :: st
    character(len=1), intent(in), optional :: delimiter
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=str_string_array_len(st)) :: s
    
    integer :: k, n
    character(len=1) :: d
    
    if (present(delimiter)) then
      d = delimiter
    else
      d = " "
    endif

    n = 1
    do k = 1, size(st) - 1
      s(n:n+len(st(k))) = st(k)//d
      n = n + len(st(k)) + 1
    enddo
    s(n:) = st(k)
#endif
  end function str_string_array

#ifndef DUMMYLIB
  pure function str_string_matrix_len(st) result(n)
    character(len=*), dimension(:, :), intent(in) :: st
    integer :: n

    n = len(st) * size(st) + size(st) - 1
  end function str_string_matrix_len
#endif

  pure function str_string_matrix(st, delimiter) result(s)
    character(len=*), dimension(:, :), intent(in) :: st
    character(len=1), intent(in), optional :: delimiter
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=str_string_matrix_len(st)) :: s
    
    integer :: j, k, n
    character(len=1) :: d

    if (present(delimiter)) then
      d = delimiter
    else
      d = " "
    endif

    s(1:len(st)) = st(1,1)
    n = len(st) + 1
    do j = 2, size(st, 1)
      s(n:n+len(st)) = d//st(j,1)
        n = n + len(st) + 1
    enddo
    do k = 2, size(st, 2)
      do j = 1, size(st, 1)
        s(n:n+len(st(j,k))) = d//st(j,k)
        n = n + len(st) + 1
      enddo
    enddo
#endif
  end function str_string_matrix

#ifndef DUMMYLIB
  pure function str_integer_len(i) result(n)
    integer, intent(in) :: i
    integer :: n
    
    n = int(log10(real(max(abs(i),1)))) + 1 + dim(-i,0)/max(abs(i),1)

  end function str_integer_len

  pure function str_integer_base_len(i, b) result(n)
    integer, intent(in) :: i, b
    integer :: n
    
    n = int(log10(real(max(abs(i),1)))/log10(real(b))) &
      + 1 + dim(-i,0)/max(abs(i),1)

  end function str_integer_base_len

  pure function str_integer_fmt_len(i, fmt) result(n)
    integer, intent(in) :: i
    character(len=*), intent(in) :: fmt
    integer :: n
    
    select case (len(fmt))
    case(0)
      n = 0
    case(1)
      if (fmt=="x") then
        n = int(log10(real(max(abs(i),1)))/log10(16.0)) + 1 + dim(-i,0)/max(abs(i),1)
      elseif (fmt=="d") then
        n = int(log10(real(max(abs(i),1)))) + 1 + dim(-i,0)/max(abs(i),1)
      else
        return
      endif
    case default
      if (fmt(1:1)/='x'.and.fmt(1:1)/='d') then
        n = 0
      elseif (verify(fmt(2:), digit)==0) then
        n = str_to_int_10(fmt(2:))
      else
        n = 0 
      endif
    end select

  end function str_integer_fmt_len
#endif

  pure function str_integer(i) result(s)
    integer, intent(in) :: i
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=str_integer_len(i)) :: s

    integer :: b, ii, j, k, n

    b = 10

    if (i < 0) then
      s(1:1) = "-"
      n = 2
    else
      n = 1
    endif
    ii = abs(i)
    do k = len(s) - n, 0, -1
      j = ii/(b**k)
      ii = ii - j*(b**k)
      s(n:n) = digit(j+1:j+1)
      n = n + 1
    enddo
#endif
  end function str_integer


  pure function str_integer_fmt(i, fmt) result(s)
    integer, intent(in) :: i
    character(len=*), intent(in):: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=str_integer_fmt_len(i, fmt)) :: s

    character :: f
    integer :: b, ii, j, k, n, ls
 
    if (len(fmt)>0) then
      if (fmt(1:1)=="d") then
        f = 'd'
        b = 10
      elseif (fmt(1:1)=="x") then
        f = 'x'
        b = 16
      else
        ! Undefined outcome
        s = ""
        return
      endif
    else
      ! Undefined outcome
      s = ""
      return
    endif

    ls = str_integer_base_len(i, b)
    n = len(s) - ls + 1

    if (i < 0) then
      if (n>0) s(:n) = "-"//repeat("0", n-1)
      n = n + 1
    else
      if (n>1) s(:n) = repeat("0", n)
    endif

    ii = abs(i)
    do k = 1, -n + 1
      j = ii/(b**k)
      ii = ii - j*(b**k)
      n = n + 1
    enddo
    do k = len(s) - n, 0, -1
      j = ii/(b**k)
      ii = ii - j*(b**k)
      s(n:n) = hexdigit(j+1:j+1)
      n = n + 1
    enddo
#endif
  end function str_integer_fmt

#ifndef DUMMYLIB
  pure function str_integer_array_len(ia) result(n)
    integer, dimension(:), intent(in) :: ia
    integer :: n
    
    integer :: j

    n = size(ia) - 1

    do j = 1, size(ia)
      n = n + len(ia(j))
    enddo

  end function str_integer_array_len

  pure function str_integer_array_fmt_len(ia, fmt) result(n)
    integer, dimension(:), intent(in) :: ia
    character(len=*), intent(in) :: fmt
    integer :: n
    
    integer :: j

    n = size(ia) - 1

    do j = 1, size(ia)
      n = n + len(ia(j), fmt)
    enddo

  end function str_integer_array_fmt_len
#endif

  pure function str_integer_array(ia) result(s)
    integer, dimension(:), intent(in) :: ia
#ifdef DUMMYLIB
    character(len=1) :: s
#else
    character(len=len(ia, "d")) :: s

    integer :: j, k, n

    n = 1
    do k = 1, size(ia) - 1
      j = len(ia(k))
      s(n:n+j) = str(ia(k))//" "
      n = n + j + 1
    enddo
    s(n:) = str(ia(k))
#endif
  end function str_integer_array


  function str_integer_array_fmt(ia, fmt) result(s)
    integer, dimension(:), intent(in) :: ia
    character(len=*), intent(in) :: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(ia, fmt)) :: s

    integer :: j, k, n

    n = 1
    do k = 1, size(ia) - 1
      j = len(ia(k), fmt)
      s(n:n+j) = str(ia(k), fmt)//" "
      n = n + j + 1
    enddo
    s(n:) = str(ia(k), fmt)
#endif
  end function str_integer_array_fmt

#ifndef DUMMYLIB
  pure function str_integer_matrix_len(ia) result(n)
    integer, dimension(:,:), intent(in) :: ia
    integer :: n

    integer :: j, k

    n = size(ia) - 1

    do k = 1, size(ia, 2)
      do j = 1, size(ia, 1)
        n = n + len(ia(j, k))
      enddo
    enddo

  end function str_integer_matrix_len

  pure function str_integer_matrix_fmt_len(ia, fmt) result(n)
    integer, dimension(:,:), intent(in) :: ia
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: j, k

    n = size(ia) - 1

    do k = 1, size(ia, 2)
      do j = 1, size(ia, 1)
        n = n + len(ia(j, k), fmt)
      enddo
    enddo

  end function str_integer_matrix_fmt_len
#endif

  pure function str_integer_matrix(ia) result(s)
    integer, dimension(:,:), intent(in) :: ia
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(ia, "d")) :: s

    integer :: j, k, n

    s(:len(ia(1,1))) = str(ia(1,1))
    n = len(ia(1,1)) + 1
    do j = 2, size(ia, 1)
      s(n:n+len(ia(j,1))) = " "//str(ia(j,1))
      n = n + len(ia(j,1)) + 1
    enddo
    do k = 2, size(ia, 2) 
      do j = 1, size(ia, 1)
        s(n:n+len(ia(j,k))) = " "//str(ia(j,k))
        n = n + len(ia(j,k)) + 1
      enddo
    enddo
#endif
  end function str_integer_matrix


  pure function str_integer_matrix_fmt(ia, fmt) result(s)
    integer, dimension(:,:), intent(in) :: ia
    character(len=*), intent(in) :: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(ia, fmt)) :: s

    integer :: j, k, n

    s(:len(ia(1,1), fmt)) = str(ia(1,1), fmt)
    n = len(ia(1,1), fmt) + 1
    do j = 2, size(ia, 1)
      s(n:n+len(ia(j,1), fmt)) = " "//str(ia(j,1), fmt)
      n = n + len(ia(j,1), fmt) + 1
    enddo
    do k = 2, size(ia, 2) 
      do j = 1, size(ia, 1)
        s(n:n+len(ia(j,k), fmt)) = " "//str(ia(j,k), fmt)
        n = n + len(ia(j,k), fmt) + 1
      enddo
    enddo
#endif
  end function str_integer_matrix_fmt

#ifndef DUMMYLIB
  pure function str_logical_len(l) result (n)
    logical, intent(in) :: l
    integer :: n
    
    if (l) then
      n = 4
    else
      n = 5
    endif
  end function str_logical_len
#endif

  pure function str_logical(l) result(s)
    logical, intent(in) :: l
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
! Pathscale 2.5 gets it wrong if we use merge here
!    character(len=merge(4,5,l)) :: s
! And g95 (sep2007) cant resolve the generic here
    character(len=str_logical_len(l)) :: s
    
    if (l) then
      s="true"
    else
      s="false"
    endif
#endif
  end function str_logical

#ifndef DUMMYLIB
  pure function str_logical_array_len(la) result(n)
! This function should be inlined in the declarations of
! str_logical_array below but PGI and pathscale don't like it.
    logical, dimension(:), intent(in)   :: la
    integer :: n
    n = 5*size(la) - 1 + count(.not.la)
  end function str_logical_array_len
#endif

  pure function str_logical_array(la) result(s)
    logical, dimension(:), intent(in)   :: la
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(la)) :: s
    
    integer :: k, n

    n = 1
    do k = 1, size(la) - 1
      if (la(k)) then
        s(n:n+3) = "true"
        n = n + 5
      else
        s(n:n+4) = "false"
        n = n + 6
      endif
      s(n-1:n-1) = " "
    enddo
    if (la(k)) then
      s(n:) = "true"
    else
      s(n:) = "false"
    endif
#endif
  end function str_logical_array

#ifndef DUMMYLIB
  pure function str_logical_matrix_len(la) result(n)
! This function should be inlined in the declarations of
! str_logical_matrix below but PGI and pathscale don't like it.
    logical, dimension(:,:), intent(in)   :: la
    integer :: n
    n = 5*size(la) - 1 + count(.not.la)
  end function str_logical_matrix_len
#endif

  pure function str_logical_matrix(la) result(s)
    logical, dimension(:,:), intent(in)   :: la
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(la)) :: s

    integer :: j, k, n

    if (la(1,1)) then
       s(:4) = "true"
       n = 5
    else
       s(:5) = "false"
       n = 6
    endif
    do j = 2, size(la, 1)
      s(n:n) = " "
      if (la(j,1)) then
        s(n+1:n+4) = "true"
        n = n + 5
      else
        s(n+1:n+5) = "false"
        n = n + 6
      endif
    enddo
    do k = 2, size(la, 2)
      do j = 1, size(la, 1)
        s(n:n) = " "
        if (la(j,k)) then
          s(n+1:n+4) = "true"
          n = n + 5
        else
          s(n+1:n+5) = "false"
          n = n + 6
        endif
      enddo
    enddo
#endif
  end function str_logical_matrix
  
#ifndef DUMMYLIB
  ! In order to convert real numbers to strings, we need to
  ! perform an internal write - but how long will the 
  ! resultant string be? We don't know & there is no way
  ! to discover for an arbitrary format. Therefore, 
  ! (if we have the capability; f95 or better)
  ! we assume it will be less than 100 characters, write
  ! it to a string of that length, then remove leading &
  ! trailing whitespace. (this means that if the specified
  ! format includes whitespace, this will be lost.)
  !
  ! If we are working with an F90-only compiler, then
  ! we cannot do this trick - the output string will
  ! always be 100 chars in length, though we will remove
  ! leading whitespace. 


  ! The standard Fortran format functions do not give us
  ! enough control, so we write our own real number formatting
  ! routines here. For each real type, we optionally take a
  ! format like so:
  ! "r<integer>" which will produce output without an exponent,
  ! and <integer> digits after the decimal point.
  ! or
  ! "s<integer>": which implies scientific notation, with an 
  ! exponent, with <integer> significant figures.
  ! If the integer is absent, then the precision will be
  ! half of the number of significant figures available
  ! for that real type.
  ! The absence of a format implies scientific notation, with
  ! the default precision.

  ! These routines are fairly imperfect - they are inaccurate for
  ! the lower-end bits of the number, since they work by simple
  ! multiplications by 10.
  ! Also they will probably be orders of magnitude slower than library IO.
  ! Ideally they'd be rewritten to convert from teh native format by
  ! bit-twidding. Not sure how to do that portably though.

  ! The format specification could be done more nicely - but unfortunately
  ! not in F95 due to *stupid* restrictions on specification expressions.

  ! And I wouldn't have to invent my own format specification if Fortran
  ! had a proper IO library anyway.

!FIXME Signed zero is not handled correctly; don't quite understand why.
!FIXME too much duplication between sp & dp, we should m4.

  pure function real_sp_str(x, sig) result(s)
    real(sp), intent(in) :: x
    integer, intent(in) :: sig
    character(len=sig) :: s
    ! make a string of numbers sig long of x.
    integer :: e, i, j, k, n
    real(sp) :: x_

    if (sig < 1) then
      s ="" 
      return
    endif

    if (x == 0.0_sp) then
      e = 1
    else
      e = floor(log10(abs(x)))
    endif
    x_ = abs(x)
    ! Have to do this next in a loop rather than just exponentiating in
    ! order to  avoid under/over-flow.
    do i = 1, abs(e)
      ! Have to multiply by 10^-e rather than divide by 10^e
      ! to avoid rounding errors.
      x_ = x_ * (10.0_sp**(-abs(e)/e))
    enddo
    n = 1
    do k = sig - 2, 0, -1
      ! This baroque way of taking int() ensures the optimizer 
      ! stores it in j without keeping a different value in cache.
      j = iachar(digit(int(x_)+1:int(x_)+1)) - 48
      if (j==10) then
        ! This can happen if, on the previous cycle, int(x_) in 
        ! the line above gave a result approx. 1.0 less than
        ! expected.
        ! In this case we want to quit the cycle & just get 999... to the end
        s(n:) = repeat("9", sig - n + 1)
        return
      endif
      s(n:n) = digit(j+1:j+1)
      n = n + 1
      x_ = (x_ - j) * 10.0_sp
    enddo
    j = nint(x_)
    if (j == 10) then
      ! Now round ...
      s(n:n) = "9"
      ! Are they all 9's?
      i = verify(s, "9", .true.)
      if (i == 0) then
        s(1:1) = "!"
        ! overflow
        return
      endif
      j = index(digit, s(i:i))
      s(i:i) = digit(j+1:j+1)
      s(i+1:) = repeat("0", sig - i + 1)
    else
      s(n:n) = digit(j+1:j+1)
    endif

  end function real_sp_str

  pure function str_real_sp_fmt_len(x, fmt) result(n)
    real(sp), intent(in) :: x
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: dec, sig
    integer :: e

    if (.not.checkFmt(fmt)) then
      n = 0
      return
    endif

    if (x == 0.0_sp) then
      e = 1
    else
      e = floor(log10(abs(x)))
    endif
      
    if (x < 0.0_sp) then
      n = 1
    else
      n = 0
    endif
      
    if (len(fmt) == 0) then
      sig = sig_sp

      n = n + sig + 2 + len(e) 
      ! for the decimal point and the e

    elseif (fmt(1:1) == "s") then
      if (len(fmt) > 1) then
        sig = str_to_int_10(fmt(2:))
      else
        sig = sig_sp
      endif
      sig = max(sig, 1)
      sig = min(sig, digits(1.0_sp))

      if (sig > 1) n = n + 1 
      ! for the decimal point
      
      n = n + sig + 1 + len(e)

    elseif (fmt(1:1) == "r") then

      if (len(fmt) > 1) then
        dec = str_to_int_10(fmt(2:))
      else
        dec = sig_sp - e - 1
      endif
      dec = min(dec, digits(1.0_sp)-e)
      dec = max(dec, 0)

      if (dec > 0) n = n + 1
      if (abs(x) >= 1.0_sp) n = n + 1

      ! Need to know if there's an overflow ....
      if (e+dec+1 > 0) then
        if (index(real_sp_str(abs(x), e+dec+1), "!") == 1) &
             e = e + 1
      endif

      n = n + abs(e) + dec

    endif

  end function str_real_sp_fmt_len
#endif

  function str_real_sp_fmt_chk(x, fmt) result(s)
    real(sp), intent(in) :: x
    character(len=*), intent(in) :: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(x, fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(x, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif
#endif
  end function str_real_sp_fmt_chk

#ifndef DUMMYLIB
  pure function str_real_sp_fmt(x, fmt) result(s)
    real(sp), intent(in) :: x
    character(len=*), intent(in) :: fmt
    character(len=len(x, fmt)) :: s

    integer :: sig, dec
    integer :: e, n
    character(len=len(x, fmt)) :: num !this will always be enough memory.

    if (x == 0.0_sp) then
      e = 0
    else
      e = floor(log10(abs(x)))
    endif

    if (x < 0.0_sp) then
      s(1:1) = "-"
      n = 2
    else
      n = 1
    endif

    if (len(fmt) == 0) then

      sig = sig_sp

      num = real_sp_str(abs(x), sig)
      if (num(1:1) == "!") then
        e = e + 1
        num = "1"//repeat("0",len(num)-1)
      endif

      if (sig == 1) then
        s(n:n) = num
        n = n + 1
      else
        s(n:n+1) = num(1:1)//"."
        s(n+2:n+sig) = num(2:)
        n = n + sig + 1
      endif

      s(n:n) = "e"
      s(n+1:) = str(e)

    elseif (fmt(1:1) == "s") then

      if (len(fmt) > 1) then
        sig = str_to_int_10(fmt(2:))
      else
        sig = sig_sp
      endif
      sig = max(sig, 1)
      sig = min(sig, digits(1.0_sp))

      num = real_sp_str(abs(x), sig)
      if (num(1:1) == "!") then
        e = e + 1
        num = "1"//repeat("0",len(num)-1)
      endif

      if (sig == 1) then
        s(n:n) = num
        n = n + 1
      else
        s(n:n+1) = num(1:1)//"."
        s(n+2:n+sig) = num(2:)
        n = n + sig + 1
      endif

      s(n:n) = "e"
      s(n+1:) = str(e)

    elseif (fmt(1:1) == "r") then

      if (len(fmt) > 1) then
        dec = str_to_int_10(fmt(2:))
      else
        dec = sig_sp - e - 1
      endif
      dec = min(dec, digits(1.0_sp)-e-1)
      dec = max(dec, 0)

      if (e+dec+1 > 0) then
        num = real_sp_str(abs(x), e+dec+1)
      else
        num = ""
      endif
      if (num(1:1) == "!") then
        e = e + 1
        num = "1"//repeat("0",len(num)-1)
      endif

      if (abs(x) >= 1.0_sp) then
        s(n:n+e) = num(:e+1)
        n = n + e + 1
        if (dec > 0) then
          s(n:n) = "."
          n = n + 1
          s(n:) = num(e+2:)
        endif
      else
        s(n:n) = "0"
        if (dec > 0) then
          s(n+1:n+1) = "."
          n = n + 2
          if (dec < -e-1) then
            s(n:) = repeat("0", dec)
          else
            s(n:n-e-2) = repeat("0", max(-e-1,0))
            n = n - min(e,-1) - 1
            if (n <= len(s)) then
              s(n:) = num
            endif
          endif
        endif
      endif

    endif

  end function str_real_sp_fmt


  pure function str_real_sp_len(x) result(n)
    real(sp), intent(in) :: x
    integer :: n

    n = len(x, "")

  end function str_real_sp_len
#endif

  pure function str_real_sp(x) result(s)
    real(sp), intent(in) :: x
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(x)) :: s

    s = safestr(x, "")
#endif
  end function str_real_sp

#ifndef DUMMYLIB
  pure function str_real_sp_array_len(xa) result(n)
    real(sp), dimension(:), intent(in) :: xa
    integer :: n

    integer :: k

    n = size(xa) - 1
    do k = 1, size(xa)
      n = n + len(xa(k), "")
    enddo

  end function str_real_sp_array_len
#endif

  pure function str_real_sp_array(xa) result(s)
    real(sp), dimension(:), intent(in) :: xa
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(xa)) :: s
    
    integer :: j, k, n

    n = 1
    do k = 1, size(xa) - 1
      j = len(xa(k), "")
      s(n:n+j) = safestr(xa(k), "")//" "
      n = n + j + 1
    enddo
    s(n:) = safestr(xa(k), "")
#endif
  end function str_real_sp_array

#ifndef DUMMYLIB
  pure function str_real_sp_array_fmt_len(xa, fmt) result(n)
    real(sp), dimension(:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: k

    n = size(xa) - 1
    do k = 1, size(xa)
      n = n + len(xa(k), fmt)
    enddo
    
  end function str_real_sp_array_fmt_len
     
  pure function str_real_sp_array_fmt(xa, fmt) result(s)
    real(sp), dimension(:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    character(len=len(xa, fmt)) :: s
    
    integer :: j, k, n

    n = 1
    do k = 1, size(xa) - 1
      j = len(xa(k), fmt)
      s(n:n+j) = safestr(xa(k), fmt)//" "
      n = n + j + 1
    enddo
    s(n:) = safestr(xa(k), fmt)

  end function str_real_sp_array_fmt
#endif

  function str_real_sp_array_fmt_chk(xa, fmt) result(s)
    real(sp), dimension(:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(xa, fmt)) :: s
    
    if (checkFmt(fmt)) then
      s = safestr(xa, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif
#endif
  end function str_real_sp_array_fmt_chk

#ifndef DUMMYLIB
  pure function str_real_sp_matrix_fmt_len(xa, fmt) result(n)
    real(sp), dimension(:,:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: j, k

    n = size(xa) - 1
    do k = 1, size(xa, 2)
      do j = 1, size(xa, 1)
        n = n + len(xa(j,k), fmt)
      enddo
    enddo

  end function str_real_sp_matrix_fmt_len

  pure function str_real_sp_matrix_len(xa) result(n)
    real(sp), dimension(:,:), intent(in) :: xa
    integer :: n

    n = len(xa, "")
  end function str_real_sp_matrix_len

  pure function str_real_sp_matrix_fmt(xa, fmt) result(s)
    real(sp), dimension(:,:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    character(len=len(xa,fmt)) :: s

    integer :: i, j, k, n

    i = len(xa(1,1), fmt)
    s(:i) = safestr(xa(1,1), fmt)
    n = i + 1
    do j = 2, size(xa, 1)
      i = len(xa(j,1), fmt)
      s(n:n+i) = " "//safestr(xa(j,1), fmt)
      n = n + i + 1
    enddo
    do k = 2, size(xa, 2)
      do j = 1, size(xa, 1)
        i = len(xa(j,k), fmt)
        s(n:n+i) = " "//safestr(xa(j,k), fmt)
        n = n + i + 1
      enddo
    enddo

  end function str_real_sp_matrix_fmt
#endif

  function str_real_sp_matrix_fmt_chk(xa, fmt) result(s)
    real(sp), dimension(:,:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(xa,fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(xa, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    end if
#endif
  end function str_real_sp_matrix_fmt_chk

  pure function str_real_sp_matrix(xa) result(s)
    real(sp), dimension(:,:), intent(in) :: xa
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(xa)) :: s

    s = safestr(xa, "")
#endif
  end function str_real_sp_matrix
    
#ifndef DUMMYLIB
  pure function real_dp_str(x, sig) result(s)
    real(dp), intent(in) :: x
    integer, intent(in) :: sig
    character(len=sig) :: s
    ! make a string of numbers sig long of x.
    integer :: e, i, j, k, n
    real(dp) :: x_

    if (sig < 1) then
      s ="" 
      return
    endif

    if (x == 0.0_dp) then
      e = 1
    else
      e = floor(log10(abs(x)))
    endif
    x_ = abs(x)
    ! Have to do this next in a loop rather than just exponentiating in
    ! order to  avoid under/over-flow.
    do i = 1, abs(e)
      ! Have to multiply by 10^-e rather than divide by 10^e
      ! to avoid rounding errors.
      x_ = x_ * (10.0_dp**(-abs(e)/e))
    enddo
    n = 1
    do k = sig - 2, 0, -1
      ! This baroque way of taking int() ensures the optimizer definitely
      ! stores it in j without keeping a different value in cache.
      j = iachar(digit(int(x_)+1:int(x_)+1)) - 48
      if (j==10) then
        ! This can happen if, on the previous cycle, int(x_) in 
        ! the line above gave a result almost exactly 1.0 less than
        ! expected - but FP arithmetic is not consistent.
        ! In this case we want to quit the cycle & just get 999... to the end
        s(n:) = repeat("9", sig - n + 1)
        return
      endif
      s(n:n) = digit(j+1:j+1)
      n = n + 1
      x_ = (x_ - j) * 10.0_dp
    enddo
    j = nint(x_)
    if (j == 10) then
      ! Now round ...
      s(n:n) = "9"
      i = verify(s, "9", .true.)
      if (i == 0) then
        s(1:1) = "!"
        !overflow
        return
      endif
      j = index(digit, s(i:i))
      s(i:i) = digit(j+1:j+1)
      s(i+1:) = repeat("0", sig - i + 1)
    else
      s(n:n) = digit(j+1:j+1)
    endif

  end function real_dp_str


  pure function str_real_dp_fmt_len(x, fmt) result(n)
    real(dp), intent(in) :: x
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: dec, sig
    integer :: e

    if (.not.checkFmt(fmt)) then
      n = 0
      return
    endif

    if (x == 0.0_dp) then
      e = 1
    else
      e = floor(log10(abs(x)))
    endif
      
    if (x < 0.0_dp) then
      n = 1
    else
      n = 0
    endif
      
    if (len(fmt) == 0) then
      sig = sig_dp

      n = n + sig + 2 + len(e) 
      ! for the decimal point and the e

    elseif (fmt(1:1) == "s") then
      if (len(fmt) > 1) then
        sig = str_to_int_10(fmt(2:))
      else
        sig = sig_dp
      endif
      sig = max(sig, 1)
      sig = min(sig, digits(1.0_dp))

      if (sig > 1) n = n + 1 
      ! for the decimal point
      
      n = n + sig + 1 + len(e)

    elseif (fmt(1:1) == "r") then

      if (len(fmt) > 1) then
        dec = str_to_int_10(fmt(2:))
      else
        dec = sig_dp - e - 1
      endif
      dec = min(dec, digits(1.0_dp)-e)
      dec = max(dec, 0)

      if (dec > 0) n = n + 1
      if (abs(x) >= 1.0_dp) n = n + 1

      ! Need to know if there's an overflow ....
      if (e+dec+1 > 0) then
        if (index(real_dp_str(abs(x), e+dec+1), "!") == 1) &
             e = e + 1
      endif

      n = n + abs(e) + dec

    endif

  end function str_real_dp_fmt_len
#endif

  function str_real_dp_fmt_chk(x, fmt) result(s)
    real(dp), intent(in) :: x
    character(len=*), intent(in) :: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(x, fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(x, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif
#endif
  end function str_real_dp_fmt_chk

#ifndef DUMMYLIB
  pure function str_real_dp_fmt(x, fmt) result(s)
    real(dp), intent(in) :: x
    character(len=*), intent(in) :: fmt
    character(len=len(x, fmt)) :: s

    integer :: sig, dec
    integer :: e, n
    character(len=len(x, fmt)) :: num !this will always be enough memory.

    if (x == 0.0_dp) then
      e = 0
    else
      e = floor(log10(abs(x)))
    endif

    if (x < 0.0_dp) then
      s(1:1) = "-"
      n = 2
    else
      n = 1
    endif

    if (len(fmt) == 0) then

      sig = sig_dp

      num = real_dp_str(abs(x), sig)
      if (num(1:1) == "!") then
        e = e + 1
        num = "1"//repeat("0",len(num)-1)
      endif

      if (sig == 1) then
        s(n:n) = num
        n = n + 1
      else
        s(n:n+1) = num(1:1)//"."
        s(n+2:n+sig) = num(2:)
        n = n + sig + 1
      endif

      s(n:n) = "e"
      s(n+1:) = safestr(e)

    elseif (fmt(1:1) == "s") then

      if (len(fmt) > 1) then
        sig = str_to_int_10(fmt(2:))
      else
        sig = sig_dp
      endif
      sig = max(sig, 1)
      sig = min(sig, digits(1.0_dp))

      num = real_dp_str(abs(x), sig)
      if (num(1:1) == "!") then
        e = e + 1
        num = "1"//repeat("0",len(num)-1)
      endif

      if (sig == 1) then
        s(n:n) = num
        n = n + 1
      else
        s(n:n+1) = num(1:1)//"."
        s(n+2:n+sig) = num(2:)
        n = n + sig + 1
      endif

      s(n:n) = "e"
      s(n+1:) = safestr(e)

    elseif (fmt(1:1) == "r") then

      if (len(fmt) > 1) then
        dec = str_to_int_10(fmt(2:))
      else
        dec = sig_dp - e - 1
      endif
      dec = min(dec, digits(1.0_dp)-e-1)
      dec = max(dec, 0)

      if (e+dec+1 > 0) then
        num = real_dp_str(abs(x), e+dec+1)
      else
        num = ""
      endif
      if (num(1:1) == "!") then
        e = e + 1
        num = "1"//repeat("0",len(num)-1)
      endif

      if (abs(x) >= 1.0_dp) then
        s(n:n+e) = num(:e+1)
        n = n + e + 1
        if (dec > 0) then
          s(n:n) = "."
          n = n + 1
          s(n:) = num(e+2:)
        endif
      else
        s(n:n) = "0"
        if (dec > 0) then
          s(n+1:n+1) = "."
          n = n + 2
          if (dec < -e-1) then
            s(n:) = repeat("0", dec)
          else
            s(n:n-e-2) = repeat("0", max(-e-1,0))
            n = n - min(e,-1) - 1
            if (n <= len(s)) then
              s(n:) = num
            endif
          endif
        endif
      endif

    endif

  end function str_real_dp_fmt


  pure function str_real_dp_len(x) result(n)
    real(dp), intent(in) :: x
    integer :: n

    n = len(x, "")

  end function str_real_dp_len
#endif

  pure function str_real_dp(x) result(s)
    real(dp), intent(in) :: x
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(x)) :: s

    s = safestr(x, "")
#endif
  end function str_real_dp

#ifndef DUMMYLIB
  pure function str_real_dp_array_len(xa) result(n)
    real(dp), dimension(:), intent(in) :: xa
    integer :: n

    integer :: k

    n = size(xa) - 1
    do k = 1, size(xa)
      n = n + len(xa(k), "")
    enddo
    
  end function str_real_dp_array_len
#endif

  pure function str_real_dp_array(xa) result(s)
    real(dp), dimension(:), intent(in) :: xa
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(xa)) :: s
    
    integer :: j, k, n

    n = 1
    do k = 1, size(xa) - 1
      j = len(xa(k), "")
      s(n:n+j) = safestr(xa(k), "")//" "
      n = n + j + 1
    enddo
    s(n:) = safestr(xa(k))
#endif
  end function str_real_dp_array

#ifndef DUMMYLIB
  pure function str_real_dp_array_fmt_len(xa, fmt) result(n)
    real(dp), dimension(:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: k

    n = size(xa) - 1
    do k = 1, size(xa)
      n = n + len(xa(k), fmt)
    enddo
    
  end function str_real_dp_array_fmt_len

  pure function str_real_dp_array_fmt(xa, fmt) result(s)
    real(dp), dimension(:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    character(len=len(xa, fmt)) :: s
    
    integer :: j, k, n

    n = 1
    do k = 1, size(xa) - 1
      j = len(xa(k), fmt)
      s(n:n+j) = safestr(xa(k), fmt)//" "
      n = n + j + 1
    enddo
    s(n:) = safestr(xa(k), fmt)

  end function str_real_dp_array_fmt
#endif

  function str_real_dp_array_fmt_chk(xa, fmt) result(s)
    real(dp), dimension(:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(xa, fmt)) :: s
    
    if (checkFmt(fmt)) then
      s = safestr(xa, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif
#endif
  end function str_real_dp_array_fmt_chk

#ifndef DUMMYLIB
  pure function str_real_dp_matrix_fmt_len(xa, fmt) result(n)
    real(dp), dimension(:,:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: j, k

    n = size(xa) - 1
    do k = 1, size(xa, 2)
      do j = 1, size(xa, 1)
        n = n + len(xa(j,k), fmt)
      enddo
    enddo

  end function str_real_dp_matrix_fmt_len

  pure function str_real_dp_matrix_len(xa) result(n)
    real(dp), dimension(:,:), intent(in) :: xa
    integer :: n

    n = len(xa, "")
  end function str_real_dp_matrix_len

  function str_real_dp_matrix_fmt(xa, fmt) result(s)
    real(dp), dimension(:,:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    character(len=len(xa,fmt)) :: s

    integer :: i, j, k, n

    i = len(xa(1,1), fmt)
    s(:i) = safestr(xa(1,1), fmt)
    n = i + 1
    do j = 2, size(xa, 1)
      i = len(xa(j,1), fmt)
      s(n:n+i) = " "//safestr(xa(j,1), fmt)
      n = n + i + 1
    enddo
    do k = 2, size(xa, 2)
      do j = 1, size(xa, 1)
        i = len(xa(j,k), fmt)
        s(n:n+i) = " "//safestr(xa(j,k), fmt)
        n = n + i + 1
      enddo
    enddo

  end function str_real_dp_matrix_fmt
#endif

  function str_real_dp_matrix_fmt_chk(xa, fmt) result(s)
    real(dp), dimension(:,:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(xa,fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(xa, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    end if
#endif
  end function str_real_dp_matrix_fmt_chk

  function str_real_dp_matrix(xa) result(s)
    real(dp), dimension(:,:), intent(in) :: xa
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(xa)) :: s

    s = safestr(xa, "")
#endif
  end function str_real_dp_matrix

#ifndef DUMMYLIB
! For complex numbers, there's not really much prior art, so
! we use the easy solution: a+bi, where a & b are real numbers
! as output above.

  pure function str_complex_sp_fmt_len(c, fmt) result(n)
    complex(sp), intent(in) :: c
    character(len=*), intent(in) :: fmt
    integer :: n

    real(sp) :: re, im
    re = real(c)
    im = aimag(c)

    n = len(re, fmt) + len(im, fmt) + 6
  end function str_complex_sp_fmt_len
#endif

  function str_complex_sp_fmt_chk(c, fmt) result(s)
    complex(sp), intent(in) :: c
    character(len=*), intent(in) :: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(c, fmt)) :: s
    
    if (checkFmt(fmt)) then
      s = safestr(c, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif
#endif
  end function str_complex_sp_fmt_chk

#ifndef DUMMYLIB
  pure function str_complex_sp_fmt(c, fmt) result(s)
    complex(sp), intent(in) :: c
    character(len=*), intent(in) :: fmt
    character(len=len(c, fmt)) :: s
    
    real(sp) :: re, im
    integer :: i
    re = real(c)
    im = aimag(c)
    i = len(re, fmt)
    s(:i+4) = "("//safestr(re, fmt)//")+i"
    s(i+5:)="("//safestr(im,fmt)//")"
  end function str_complex_sp_fmt

  pure function str_complex_sp_len(c) result(n)
    complex(sp), intent(in) :: c
    integer :: n

    n = len(c, "")
  end function str_complex_sp_len
#endif

  pure function str_complex_sp(c) result(s)
    complex(sp), intent(in) :: c
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(c, "")) :: s

    s = safestr(c, "")
#endif
  end function str_complex_sp

#ifndef DUMMYLIB
  pure function str_complex_sp_array_fmt_len(ca, fmt) result(n)
    complex(sp), dimension(:), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: i

    n = size(ca) - 1
    do i = 1, size(ca)
      n = n + len(ca(i), fmt) 
    enddo
  end function str_complex_sp_array_fmt_len
     
  pure function str_complex_sp_array_fmt(ca, fmt) result(s)
    complex(sp), dimension(:), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    character(len=len(ca, fmt)) :: s

    integer :: i, n
 
    s(1:len(ca(1), fmt)) = safestr(ca(1), fmt)
    n = len(ca(1), fmt)+1
    do i = 2, size(ca) 
      s(n:n+len(ca(i), fmt)) = " "//safestr(ca(i), fmt)
      n = n + len(ca(i), fmt)+1
    enddo
  end function str_complex_sp_array_fmt
#endif

  function str_complex_sp_array_fmt_chk(ca, fmt) result(s)
    complex(sp), dimension(:), intent(in) :: ca
    character(len=*), intent(in) :: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(ca, fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(ca, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif
#endif
  end function str_complex_sp_array_fmt_chk

#ifndef DUMMYLIB
  pure function str_complex_sp_array_len(ca) result(n)
    complex(sp), dimension(:), intent(in) :: ca
    integer :: n

    n = len(ca, "")
  end function str_complex_sp_array_len
#endif

  pure function str_complex_sp_array(ca) result(s)
    complex(sp), dimension(:), intent(in) :: ca
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(ca)) :: s

    s = safestr(ca, "")
#endif
  end function str_complex_sp_array

#ifndef DUMMYLIB
  pure function str_complex_sp_matrix_fmt_len(ca, fmt) result(n)
    complex(sp), dimension(:, :), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: i, j

    n = size(ca) - 1
    do i = 1, size(ca, 1)
      do j = 1, size(ca, 2)
        n = n + len(ca(i, j), fmt)
      enddo
    enddo
  end function str_complex_sp_matrix_fmt_len
     
  pure function str_complex_sp_matrix_fmt(ca, fmt) result(s)
    complex(sp), dimension(:, :), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    character(len=len(ca, fmt)) :: s

    integer :: i, j, k, n

    i = len(ca(1,1), fmt)
    s(:i) = safestr(ca(1,1), fmt)
    n = i + 1
    do j = 2, size(ca, 1)
      i = len(ca(j,1), fmt)
      s(n:n+i) = " "//safestr(ca(j,1), fmt)
      n = n + i + 1
    enddo
    do k = 2, size(ca, 2)
      do j = 1, size(ca, 1)
        i = len(ca(j,k), fmt)
        s(n:n+i) = " "//safestr(ca(j,k), fmt)
        n = n + i + 1
      enddo
    enddo

  end function str_complex_sp_matrix_fmt
#endif

  function str_complex_sp_matrix_fmt_chk(ca, fmt) result(s)
    complex(sp), dimension(:, :), intent(in) :: ca
    character(len=*), intent(in) :: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(ca, fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(ca, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif
#endif
  end function str_complex_sp_matrix_fmt_chk

#ifndef DUMMYLIB
  pure function str_complex_sp_matrix_len(ca) result(n)
    complex(sp), dimension(:, :), intent(in) :: ca
    integer :: n

    n = len(ca, "")
  end function str_complex_sp_matrix_len
#endif

  pure function str_complex_sp_matrix(ca) result(s)
    complex(sp), dimension(:, :), intent(in) :: ca
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(ca)) :: s

    s = safestr(ca, "")
#endif
  end function str_complex_sp_matrix
  
#ifndef DUMMYLIB
  pure function str_complex_dp_fmt_len(c, fmt) result(n)
    complex(dp), intent(in) :: c
    character(len=*), intent(in) :: fmt
    integer :: n

    real(dp) :: re, im
    re = real(c)
    im = aimag(c)

    n = len(re, fmt) + len(im, fmt) + 6
  end function str_complex_dp_fmt_len
#endif

  function str_complex_dp_fmt_chk(c, fmt) result(s)
    complex(dp), intent(in) :: c
    character(len=*), intent(in) :: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(c, fmt)) :: s
    
    if (checkFmt(fmt)) then
      s = safestr(c, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif
#endif
  end function str_complex_dp_fmt_chk

#ifndef DUMMYLIB
  pure function str_complex_dp_fmt(c, fmt) result(s)
    complex(dp), intent(in) :: c
    character(len=*), intent(in) :: fmt
    character(len=len(c, fmt)) :: s
    
    real(dp) :: re, im
    integer :: i
    re = real(c)
    im = aimag(c)
    i = len(re, fmt)
    s(:i+4) = "("//safestr(re, fmt)//")+i"
    s(i+5:)="("//safestr(im,fmt)//")"
  end function str_complex_dp_fmt

  pure function str_complex_dp_len(c) result(n)
    complex(dp), intent(in) :: c
    integer :: n

    n = len(c, "")
  end function str_complex_dp_len
#endif

  pure function str_complex_dp(c) result(s)
    complex(dp), intent(in) :: c
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(c, "")) :: s

    s = safestr(c, "")
#endif
  end function str_complex_dp

#ifndef DUMMYLIB
  pure function str_complex_dp_array_fmt_len(ca, fmt) result(n)
    complex(dp), dimension(:), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: i

    n = size(ca) - 1
    do i = 1, size(ca)
      n = n + len(ca(i), fmt)
    enddo
  end function str_complex_dp_array_fmt_len
     
  pure function str_complex_dp_array_fmt(ca, fmt) result(s)
    complex(dp), dimension(:), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    character(len=len(ca, fmt)) :: s

    integer :: i, n

    s(1:len(ca(1), fmt)) = safestr(ca(1), fmt)
    n = len(ca(1), fmt)+1
    do i = 2, size(ca) 
      s(n:n+len(ca(i), fmt)) = " "//safestr(ca(i), fmt)
      n = n + len(ca(i), fmt)+1
    enddo
  end function str_complex_dp_array_fmt
#endif

  function str_complex_dp_array_fmt_chk(ca, fmt) result(s)
    complex(dp), dimension(:), intent(in) :: ca
    character(len=*), intent(in) :: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(ca, fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(ca, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif
#endif
  end function str_complex_dp_array_fmt_chk

#ifndef DUMMYLIB
  pure function str_complex_dp_array_len(ca) result(n)
    complex(dp), dimension(:), intent(in) :: ca
    integer :: n

    n = len(ca, "")
  end function str_complex_dp_array_len
#endif

  pure function str_complex_dp_array(ca) result(s)
    complex(dp), dimension(:), intent(in) :: ca
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(ca)) :: s

    s = safestr(ca, "")
#endif
  end function str_complex_dp_array

#ifndef DUMMYLIB
  pure function str_complex_dp_matrix_fmt_len(ca, fmt) result(n)
    complex(dp), dimension(:, :), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: i, j

    n = size(ca) - 1
    do i = 1, size(ca, 1)
      do j = 1, size(ca, 2)
        n = n + len(ca(i, j), fmt)
      enddo
    enddo
  end function str_complex_dp_matrix_fmt_len
     
  pure function str_complex_dp_matrix_fmt(ca, fmt) result(s)
    complex(dp), dimension(:, :), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    character(len=len(ca, fmt)) :: s

    integer :: i, j, k, n

    i = len(ca(1,1), fmt)
    s(:i) = safestr(ca(1,1), fmt)
    n = i + 1
    do j = 2, size(ca, 1)
      i = len(ca(j,1), fmt)
      s(n:n+i) = " "//safestr(ca(j,1), fmt)
      n = n + i + 1
    enddo
    do k = 2, size(ca, 2)
      do j = 1, size(ca, 1)
        i = len(ca(j,k), fmt)
        s(n:n+i) = " "//safestr(ca(j,k), fmt)
        n = n + i + 1
      enddo
    enddo

  end function str_complex_dp_matrix_fmt
#endif

  function str_complex_dp_matrix_fmt_chk(ca, fmt) result(s)
    complex(dp), dimension(:, :), intent(in) :: ca
    character(len=*), intent(in) :: fmt
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(ca, fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(ca, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif
#endif
  end function str_complex_dp_matrix_fmt_chk

#ifndef DUMMYLIB
  pure function str_complex_dp_matrix_len(ca) result(n)
    complex(dp), dimension(:, :), intent(in) :: ca
    integer :: n

    n = len(ca, "")
  end function str_complex_dp_matrix_len
#endif

  pure function str_complex_dp_matrix(ca) result(s)
    complex(dp), dimension(:, :), intent(in) :: ca
#ifdef DUMMYLIB
    character(len=1) :: s
    s = " "
#else
    character(len=len(ca)) :: s

    s = safestr(ca, "")
#endif
  end function str_complex_dp_matrix

#ifndef DUMMYLIB
  pure function checkFmt(fmt) result(good)
    character(len=*), intent(in) :: fmt
    logical :: good

    ! should be ([rs]\d*)?

    if (len(fmt) > 0) then
      if (fmt(1:1) == "r" .or. fmt(1:1) == "s") then
        if (len(fmt) > 1) then
          good = (verify(fmt(2:), digit) == 0)
        else
          good = .true.
        endif
      else
        good = .false.
      endif
    else
      good = .true.
    endif
  end function checkFmt
#endif

  pure function concat_str_int(s1, s2) result(s3)
    character(len=*), intent(in) :: s1
    integer, intent(in) :: s2
#ifdef DUMMYLIB
    character(len=1) :: s3
    s3 = " "
#else
    character(len=len(s1)+len(s2)) :: s3
    s3 = s1//str(s2)
#endif
  end function concat_str_int
  pure function concat_int_str(s1, s2) result(s3)
    integer, intent(in) :: s1
    character(len=*), intent(in) :: s2
#ifdef DUMMYLIB
    character(len=1) :: s3
    s3 = " "
#else
    character(len=len(s1)+len(s2)) :: s3
    s3 = str(s1)//s2
#endif
  end function concat_int_str

  pure function concat_str_logical(s1, s2) result(s3)
    character(len=*), intent(in) :: s1
    logical, intent(in) :: s2
#ifdef DUMMYLIB
    character(len=1) :: s3
    s3 = " "
#else
    character(len=len(s1)+len(s2)) :: s3
    s3 = s1//str(s2)
#endif
  end function concat_str_logical
  pure function concat_logical_str(s1, s2) result(s3)
    logical, intent(in) :: s1
    character(len=*), intent(in) :: s2
#ifdef DUMMYLIB
    character(len=1) :: s3
    s3 = " "
#else
    character(len=len(s1)+len(s2)) :: s3
    s3 = str(s1)//s2
#endif
  end function concat_logical_str

  pure function concat_str_real_sp(s1, s2) result(s3)
    character(len=*), intent(in) :: s1
    real(sp), intent(in) :: s2
#ifdef DUMMYLIB
    character(len=1) :: s3
    s3 = " "
#else
    character(len=len(s1)+len(s2)) :: s3
    s3 = s1//str(s2)
#endif
  end function concat_str_real_sp
  pure function concat_real_sp_str(s1, s2) result(s3)
    real(sp), intent(in) :: s1
    character(len=*), intent(in) :: s2
#ifdef DUMMYLIB
    character(len=1) :: s3
    s3 = " "
#else
    character(len=len(s1)+len(s2)) :: s3
    s3 = str(s1)//s2
#endif
  end function concat_real_sp_str

  pure function concat_str_real_dp(s1, s2) result(s3)
    character(len=*), intent(in) :: s1
    real(dp), intent(in) :: s2
#ifdef DUMMYLIB
    character(len=1) :: s3
    s3 = " "
#else
    character(len=len(s1)+len(s2)) :: s3
    s3 = s1//str(s2)
#endif
  end function concat_str_real_dp
  pure function concat_real_dp_str(s1, s2) result(s3)
    real(dp), intent(in) :: s1
    character(len=*), intent(in) :: s2
#ifdef DUMMYLIB
    character(len=1) :: s3
    s3 = " "
#else
    character(len=len(s1)+len(s2)) :: s3
    s3 = str(s1)//s2
#endif
  end function concat_real_dp_str

  pure function concat_str_complex_sp(s1, s2) result(s3)
    character(len=*), intent(in) :: s1
    complex(sp), intent(in) :: s2
#ifdef DUMMYLIB
    character(len=1) :: s3
    s3 = " "
#else
    character(len=len(s1)+len(s2)) :: s3
    s3 = s1//str(s2)
#endif
  end function concat_str_complex_sp
  pure function concat_complex_sp_str(s1, s2) result(s3)
    complex(sp), intent(in) :: s1
    character(len=*), intent(in) :: s2
#ifdef DUMMYLIB
    character(len=1) :: s3
    s3 = " "
#else
    character(len=len(s1)+len(s2)) :: s3
    s3 = str(s1)//s2
#endif
  end function concat_complex_sp_str

  pure function concat_str_complex_dp(s1, s2) result(s3)
    character(len=*), intent(in) :: s1
    complex(dp), intent(in) :: s2
#ifdef DUMMYLIB
    character(len=1) :: s3
    s3 = " "
#else
    character(len=len(s1)+len(s2)) :: s3
    s3 = s1//str(s2)
#endif
  end function concat_str_complex_dp
  pure function concat_complex_dp_str(s1, s2) result(s3)
    complex(dp), intent(in) :: s1
    character(len=*), intent(in) :: s2
#ifdef DUMMYLIB
    character(len=1) :: s3
    s3 = " "
#else
    character(len=len(s1)+len(s2)) :: s3
    s3 = str(s1)//s2
#endif
  end function concat_complex_dp_str

end module fox_m_fsys_format

module fox_m_fsys_array_str
#ifndef DUMMYLIB

  implicit none
  private

  interface destroy
    module procedure destroy_vs
  end interface

  interface concat
    module procedure vs_s_concat
  end interface

  interface alloc
    module procedure vs_str_alloc
  end interface

  public :: str_vs
  public :: vs_str
  public :: vs_str_alloc
  public :: vs_vs_alloc

  public :: concat
  public :: alloc

  public :: destroy

contains

  pure function str_vs(vs) result(s)
    character, dimension(:), intent(in) :: vs
    character(len=size(vs)) :: s
#ifdef PGF90
!PGI crashes on this use of transfer. Knob-ends.
    integer :: i
    do i = 1, size(vs)
      s(i:i) = vs(i)
    enddo
#else
    s = transfer(vs, s)
#endif
  end function str_vs


  pure function vs_str(s) result(vs)
    character(len=*), intent(in) :: s
    character, dimension(len(s)) :: vs

    vs = transfer(s, vs)
  end function vs_str

  pure function vs_str_alloc(s) result(vs)
    character(len=*), intent(in) :: s
    character, dimension(:), pointer :: vs

    allocate(vs(len(s)))
    vs = vs_str(s)
  end function vs_str_alloc

  pure function vs_vs_alloc(s) result(vs)
    character, dimension(:), pointer :: s
    character, dimension(:), pointer :: vs

    if (associated(s)) then
      allocate(vs(size(s)))
      vs = s
    else
      vs => null()
    endif
  end function vs_vs_alloc

  pure function vs_s_concat(vs, s) result(vs2)
    character, dimension(:), intent(in) :: vs
    character(len=*), intent(in) :: s
    character, dimension(:), pointer :: vs2

    allocate(vs2(size(vs)+len(s)))
    vs2(:size(vs)) = vs
    vs2(size(vs)+1:) = vs_str(s)
  end function vs_s_concat

  subroutine destroy_vs(vs)
    character, dimension(:), pointer :: vs

    deallocate(vs)
  end subroutine destroy_vs

#endif
end module fox_m_fsys_array_str

!
! This file is AUTOGENERATED
! To update, edit m_wcml_geometry.m4 and regenerate

module m_wcml_geometry

  use fox_m_fsys_realtypes, only: sp, dp
  use FoX_wxml, only: xmlf_t
#ifndef DUMMYLIB
  use FoX_wxml, only: xml_NewElement, xml_EndElement
  use FoX_wxml, only: xml_AddAttribute, xml_AddCharacters

! Fix for pgi, requires this explicitly:
  use m_wxml_overloads
#endif

  implicit none
  private

  interface cmlAddLength
    module procedure cmlAddLength_SP, cmlAddLength_DP
  end interface

  interface cmlAddAngle
    module procedure cmlAddAngle_SP, cmlAddAngle_DP
  end interface

  interface cmlAddTorsion
    module procedure cmlAddTorsion_SP, cmlAddTorsion_DP
  end interface

  public :: cmlAddLength
  public :: cmlAddAngle
  public :: cmlAddTorsion

contains

  subroutine cmlAddLength_sp(xf, id, atomRef1, atomRef2, length, fmt)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: id
    character(len=*), intent(in) :: atomRef1
    character(len=*), intent(in) :: atomRef2
    real(kind=sp), intent(in)    :: length
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "length")
    call xml_AddAttribute(xf, "id", id)
    call xml_AddAttribute(xf, "atomRefs2", atomRef1//" "//atomRef2)
    call xml_AddCharacters(xf, length, fmt)
    call xml_EndElement(xf, "length")
#endif

  end subroutine cmlAddLength_sp

  subroutine cmlAddAngle_sp(xf, id, atomRef1, atomRef2, atomRef3, angle, fmt)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: id
    character(len=*), intent(in) :: atomRef1
    character(len=*), intent(in) :: atomRef2
    character(len=*), intent(in) :: atomRef3
    real(kind=sp), intent(in)     :: angle
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "angle")
    call xml_AddAttribute(xf, "id", id)
    call xml_AddAttribute(xf, "atomRefs3", atomRef1//" "//atomRef2//" "//atomRef3)
    call xml_AddCharacters(xf, angle, fmt)
    call xml_EndElement(xf, "angle")
#endif

  end subroutine cmlAddAngle_sp

  subroutine cmlAddTorsion_sp(xf, id, atomRef1, atomRef2, atomRef3, atomRef4, torsion, fmt)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: id
    character(len=*), intent(in) :: atomRef1
    character(len=*), intent(in) :: atomRef2
    character(len=*), intent(in) :: atomRef3        ! ref to third atom
    character(len=*), intent(in) :: atomRef4
    real(kind=sp), intent(in)    :: torsion
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "torsion")
    call xml_AddAttribute(xf, "id", id)
    call xml_AddAttribute(xf, "atomRefs4", &
         atomRef1//" "//atomRef2//" "//atomRef3//" "//atomRef4)
    call xml_AddCharacters(xf, torsion, fmt)
    call xml_EndElement(xf, "torsion")
#endif

  end subroutine cmlAddTorsion_sp


  subroutine cmlAddLength_dp(xf, id, atomRef1, atomRef2, length, fmt)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: id
    character(len=*), intent(in) :: atomRef1
    character(len=*), intent(in) :: atomRef2
    real(kind=dp), intent(in)    :: length
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "length")
    call xml_AddAttribute(xf, "id", id)
    call xml_AddAttribute(xf, "atomRefs2", atomRef1//" "//atomRef2)
    call xml_AddCharacters(xf, length, fmt)
    call xml_EndElement(xf, "length")
#endif

  end subroutine cmlAddLength_dp

  subroutine cmlAddAngle_dp(xf, id, atomRef1, atomRef2, atomRef3, angle, fmt)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: id
    character(len=*), intent(in) :: atomRef1
    character(len=*), intent(in) :: atomRef2
    character(len=*), intent(in) :: atomRef3
    real(kind=dp), intent(in)     :: angle
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "angle")
    call xml_AddAttribute(xf, "id", id)
    call xml_AddAttribute(xf, "atomRefs3", atomRef1//" "//atomRef2//" "//atomRef3)
    call xml_AddCharacters(xf, angle, fmt)
    call xml_EndElement(xf, "angle")
#endif

  end subroutine cmlAddAngle_dp

  subroutine cmlAddTorsion_dp(xf, id, atomRef1, atomRef2, atomRef3, atomRef4, torsion, fmt)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: id
    character(len=*), intent(in) :: atomRef1
    character(len=*), intent(in) :: atomRef2
    character(len=*), intent(in) :: atomRef3        ! ref to third atom
    character(len=*), intent(in) :: atomRef4
    real(kind=dp), intent(in)    :: torsion
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "torsion")
    call xml_AddAttribute(xf, "id", id)
    call xml_AddAttribute(xf, "atomRefs4", &
         atomRef1//" "//atomRef2//" "//atomRef3//" "//atomRef4)
    call xml_AddCharacters(xf, torsion, fmt)
    call xml_EndElement(xf, "torsion")
#endif

  end subroutine cmlAddTorsion_dp


end module m_wcml_geometry

module fox_m_utils_uri
#ifndef DUMMYLIB

  ! Manipulate URIs and URI references a la RFC 2396
  ! NB: ...
  ! Forbidden (ASCII control) characters are not handled correctly
  ! checking of reg names (not hosts) is done wrongly
  ! checking of ipv6/X is untested

  use fox_m_fsys_array_str, only: str_vs, vs_str_alloc, vs_vs_alloc
  use fox_m_fsys_format, only: str_to_int_10, str_to_int_16, str
  use fox_m_fsys_string, only: toLower

  implicit none
  private

  type path_segment
    character, pointer :: s(:) => null()
  end type path_segment
#endif

  type URI
    private
#ifndef DUMMYLIB
    character, pointer :: scheme(:) => null()
    character, pointer :: authority(:) => null()
    character, pointer :: userinfo(:) => null()
    character, pointer :: host(:) => null()
    integer :: port = -1
    character, pointer :: path(:) => null()
    type(path_segment), pointer :: segments(:) => null()
    character, pointer :: query(:) => null()
    character, pointer :: fragment(:) => null()
#else
    integer :: i
#endif
  end type URI

#ifndef DUMMYLIB
  character(len=*), parameter :: lowalpha = "abcdefghijklmnopqrstuvwxyz"
  character(len=*), parameter :: upalpha = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
  character(len=*), parameter :: alpha = lowalpha//upalpha
  character(len=*), parameter :: digit = "0123456789"
  character(len=*), parameter :: hexdigit = "0123456789abcdefABCDEF"
  character(len=*), parameter :: alphanum = alpha//digit
  character(len=*), parameter :: unreserved = alphanum//"-._~"
  character(len=*), parameter :: gen_delims  = ":/?#[]@"
  character(len=*), parameter :: sub_delims  = "!$&'()*+,;="
  character(len=*), parameter :: reserved = gen_delims//sub_delims
  character(len=*), parameter :: pchar = unreserved//":@&=+$,"
  character(len=*), parameter :: uric_no_slash = unreserved//";?:@&=+$,"
  character(len=*), parameter :: uric = unreserved//reserved
  character(len=*), parameter :: unwise = "{}|\^[]`"
#endif 

  public :: URI
  public :: parseURI
  public :: expressURI
  public :: isAbsoluteURI
  public :: rebaseURI
  public :: copyURI
  public :: destroyURI

  public :: hasScheme
  public :: getScheme
  public :: hasAuthority
  public :: getAuthority
  public :: hasUserinfo
  public :: getUserinfo
  public :: hasHost
  public :: getHost
  public :: hasPort
  public :: getPort
  public :: getPath
  public :: hasQuery
  public :: getQuery
  public :: hasFragment
  public :: getFragment

#ifndef DUMMYLIB
  public :: dumpURI
#endif

contains

#ifndef DUMMYLIB
  function unEscape_alloc(s) result(c)
    character(len=*), intent(in) :: s
    character, pointer :: c(:)

    integer :: i, j, n
    character(len(s)) :: t

    c => null()

    i = 1
    j = 0
    do while (i<=len(s))
      j = j + 1
      if (s(i:i)=="%") then
        if (i+2>len(s)) return
        if (verify(s(i+1:i+2), hexdigit)/=0) return
        n = str_to_int_16(s(i+1:i+2))
        t(j:j) = achar(n)
        i = i + 3
      else
        t(j:j) = s(i:i)
        i = i + 1
      endif
    enddo

    c => vs_str_alloc(t(:j))
  end function unEscape_alloc

  function verifyWithPctEncoding(s, chars) result(p)
    character(len=*), intent(in) :: s
    character(len=*), intent(in) :: chars
    logical :: p

    integer :: i

    p = .false.
    i = 1
    do while (i<=len(s))
      if (s(i:i)=="%") then
        if (i+2>len(s)) return
        if (verify(s(i+1:i+2), hexdigit)>0) return
        i = i + 3
      else
        if (verify(s(i:i),chars)>0) return
        i = i + 1
      endif
    enddo
    p = .true.
  end function verifyWithPctEncoding

  pure function pctEncode_len(s, chars) result(n)
    character(len=*), intent(in) :: s
    character(len=*), intent(in) :: chars
    integer :: n

    integer :: i
    n = 0
    do i = 1, len(s)
      n = n + 1
      if (verify(s(i:i), unwise)==0.or.verify(s(i:i), chars)>0) n = n + 2
    enddo

  end function pctEncode_len

  function pctEncode(s, chars) result(ps)
    character(len=*), intent(in) :: s
    character(len=*), intent(in) :: chars
    character(len=pctEncode_len(s, chars)) :: ps

    integer :: i, n

    n = 1
    do i = 1, len(s)
      if (verify(s(i:i), unwise)==0.or.verify(s(i:i), chars)>0) then
        ps(n:n+2) = "%"//str(iachar(s(i:i)), "x2")
        n = n + 3
      else
        ps(n:n) = s(i:i)
        n = n + 1
      endif
    enddo

  end function pctEncode

  function checkOpaquePart(part) result(p)
    character(len=*), intent(in) :: part
    logical :: p

    if (len(part)>0) then
      p = verify(part(1:1), uric_no_slash)==0
      if (p.and.len(part)>1) &
        p = verify(part(1:1), uric)==0
    endif
  end function checkOpaquePart
    

  function checkScheme(scheme) result(p)
    character(len=*), intent(in) :: scheme
    logical :: p

    p = len(scheme)>0 
    if (p) then
      p = verify(scheme(1:1), lowalpha//upalpha)==0
      if (p.and.len(scheme)>1) then
        p = verify(scheme(2:), alphanum//"+-.")==0
      endif
    endif
  end function checkScheme

  function checkIpvX(host) result(p)
    character(len=*), intent(in) :: host
    logical :: p

    integer :: i, n1, n2

    p = (len(host)>5).and.(host(1:1)=="[".and.host(len(host):len(host))=="]")

    if (p) then

      ! Try IPvFuture:
      p = (verify(host(2:2),"Vv")==0 &
        .and.verify(host(3:3),hexdigit)==0 &
        .and.host(4:4)=="." &
        .and.verify(host(3:3),unreserved//sub_delims//":")==0)

      if (.not.p) then ! is it IPv6?
        n1 = 0
        do i = 1, 4
          n2 = index(host(n1+1:), ":")
          if (n2==0.or.n2>6) return
          n2 = n2 + n1
          if (verify(host(n1+1:n2-1),hexdigit)>0) return
          n1 = n2
        enddo
        n2 = index(host(n1+1:), ":")
        if (n2==0) then
          ! this must be ipv4 format
          do i = 1, 3
            n2 = index(host(n1+1:), ".")
            if (n2==0) return
            n2 = n2 + n1
            if (verify(host(n1+1:n2-1),digit)>0) return
            if (str_to_int_10(host(n1+1:n2-1))>255) return
            n1 = n2
          enddo
          ! Now there must be 3 or less digits followed by ]
          n2 = len(host)-1
          if (verify(host(n1+1:n2-1),digit)>0) return
          if (str_to_int_10(host(n1+1:n2-1))>255) return 
        elseif (n2<6) then
          n2 = n2 + n1
          if (verify(host(n1+1:n2-1),hexdigit)>0) return
          ! Now there must be 4 or less digits followed by ]
          n1 = n2
          n2 = len(host)
          if (n2-n1>4) return
          if (verify(host(n1+1:n2-1),hexdigit)>0) return
        endif
        p = .true.
      endif
    endif
  end function checkIpvX

  function checkHost(host) result(p)
    character(len=*), intent(in) :: host
    logical :: p

    p = checkIpvX(host)
    if (.not.p) &
      p = verifyWithPctEncoding(host, unreserved//sub_delims)

  end function checkHost

  function checkAuthority(authority, userinfo, host, port) result(p)
    character(len=*), intent(in) :: authority
    character, pointer :: userinfo(:), host(:)
    integer :: port
    logical :: p

    integer :: i1, i2

    p = .true.
    if (len(authority)==0) return

    i1 = index(authority, "@")
    if (i1>0) then
      i2 = index(authority(i1+1:), ":")
    else
      i2 = index(authority, ":")
    endif
    if (i1==0) then
      userinfo => null()
    else
      p = verifyWithPctEncoding(authority(:i1-1), unreserved//sub_delims//":")
      if (p) userinfo => unEscape_alloc(authority(:i1-1))
    endif
    if (i2==0) then
      i2 = len(authority)+1
    else
      i2 = i1 + i2
      p = p.and.verify(authority(i2+1:), digit)==0
      if (p) port = str_to_int_10(authority(i2+1:))
    endif
    p = p.and.checkHost(authority(i1+1:i2-1))
    if (p) then
      host => vs_str_alloc(authority(i1+1:i2-1))
    else
      if (associated(userinfo)) deallocate(userinfo)
    end if

  end function checkAuthority
  
  function checkPathSegment(segment) result(p)
    character(len=*), intent(in) :: segment
    logical :: p

    integer :: i1

    i1 = index(segment, ";")
    if (i1>0) then
      p = verifyWithPctEncoding(segment(:i1-1), pchar) &
        .and.verifyWithPctEncoding(segment(i1+1:), pchar)
    else
      p = verifyWithPctEncoding(segment, unreserved//pchar)
    endif
  end function checkPathSegment

  function checkNonOpaquePath(path, segments) result(p)
    character(len=*), intent(in) :: path
    type(path_segment), pointer :: segments(:)
    logical :: p

    integer :: i, i1, i2
    type(path_segment), pointer :: temp(:)
    
    p = .true.
    i1 = index(path, "/")
    if (i1==1) then
      allocate(segments(1))
      segments(1)%s => vs_str_alloc("/")
    else
      allocate(segments(0))
      i1 = 0
    endif

    do
      i2 = index(path(i1+1:), "/")
      if (i2==0) then
        i2 = len(path)
      else
        i2 = i1 + i2
      endif
      if (checkPathSegment(path(i1+1:i2-1))) then
        allocate(temp(size(segments)+1))
        do i = 1, size(segments)
          temp(i)%s => segments(i)%s
        enddo
        temp(i)%s => unEscape_alloc(path(i1+1:i2))
        deallocate(segments)
        segments => temp
      else
        do i = 1, size(segments)
          deallocate(segments(i)%s)
        enddo
        deallocate(segments)
        p = .false.
        return
      endif
      if (i2==len(path)) exit
      i1 = i2
    end do
  end function checkNonOpaquePath

  function checkPath(path, segments) result(p)
    character(len=*), intent(in) :: path
    type(path_segment), pointer :: segments(:)
    logical :: p

    p = checkNonOpaquePath(path, segments)
    if (.not.p) then
      p = checkOpaquePart(path)
    endif

  end function checkPath

  function checkQuery(query) result(p)
    character(len=*), intent(in) :: query
    logical :: p

    p = verifyWithPctEncoding(query, uric)
  end function checkQuery

  function checkFragment(fragment) result(p)
    character(len=*), intent(in) :: fragment
    logical :: p

    p = verifyWithPctEncoding(fragment, uric)
  end function checkFragment
#endif

  function parseURI(URIstring) result(u)
    character(len=*), intent(in) :: URIstring
    type(URI), pointer :: u
#ifndef DUMMYLIB
    character, pointer, dimension(:) :: scheme, authority, &
      userinfo, host, path, query, fragment
    integer :: port
    type(path_segment), pointer :: segments(:)
    integer :: i1, i2, i3, i4
    logical :: p

#endif
    u => null()
#ifndef DUMMYLIB

    scheme => null()
    authority => null()
    userinfo => null()
    host => null()
    path => null()
    segments => null()
    query => null()
    fragment => null()

    i1 = index(URIstring, ":")
    if (i1>0) then 
      p = checkScheme(URIstring(:i1-1))
      if (p) then
        scheme => vs_str_alloc(toLower(URIstring(:i1-1)))
      else
        i1 = 0
      endif
    endif
    ! if either i1==0 or the scheme doesn't validate, there is no scheme..
    if (len(URIstring)>i1+3) then
      if (URIstring(i1+1:i1+2)=="//") then
        i2 = scan(URIstring(i1+3:), "/#?")
        if (i2==0) then
          i2 = len(URIstring) + 1
        else
          i2 = i1 + i2 + 2
        endif
        p = checkAuthority(URIstring(i1+3:i2-1), userinfo, host, port)
        if (.not.p) then
          call cleanUp
          return
        endif
        authority => vs_str_alloc(URIstring(i1+3:i2-1))
      else
        i2 = i1 + 1
      endif
    else
      i2 = i1 + 1
    endif

    if (i2>len(URIstring)) then
      path => vs_str_alloc("")
      allocate(segments(1))
      segments(1)%s => vs_str_alloc("")
      call produceResult
      return
    endif

    i3 = scan(URIstring(i2:),"#?")
    if (i3==0) then
      i3 = len(URIstring) + 1
    else
      i3 = i2 + i3 - 1
    endif
    p = checkPath(URIstring(i2:i3-1), segments)
    if (.not.p) then
      call cleanUp
      return
    endif
    path => unEscape_alloc(URIstring(i2:i3-1))

    if (i3>len(URIstring)) then
      call produceResult
      return
    endif

    if (URIstring(i3:i3)=="?") then
      i4 = index(URIstring(i3+1:), "#")
      if (i4==0) then
        i4 = len(URIstring) + 1
      else
        i4 = i3 + i4
      endif
      p = checkQuery(URIstring(i3+1:i4-1))
      if (.not.p) then
        call cleanUp
        return
      endif
      query => vs_str_alloc(URIstring(i3+1:i4-1))
    else
      i4 = i3
    endif

    if (i4>len(URIstring)) then
      call produceResult
      return
    endif

    p = checkFragment(URIstring(i4+1:))
    if (.not.p) then
      call cleanUp
      return
    endif
    fragment => vs_str_alloc(URIstring(i4+1:))
    call produceResult

    contains
      subroutine cleanUp
        integer :: i
        if (associated(scheme)) deallocate(scheme)
        if (associated(authority)) deallocate(authority)
        if (associated(userinfo)) deallocate(userinfo)
        if (associated(host)) deallocate(host)
        if (associated(path)) deallocate(path)
        if (associated(query)) deallocate(query)
        if (associated(fragment)) deallocate(fragment)
        if (associated(segments)) then
          do i = 1, size(segments)
            deallocate(segments(i)%s)
          enddo
          deallocate(segments)
        endif
      end subroutine cleanUp
      subroutine produceResult
        allocate(u)
        u%scheme => scheme
        u%authority => authority
        u%userinfo => userinfo
        u%host => host
        u%port = port
        u%path => path
        u%segments => segments
        u%query => query
        u%fragment => fragment
        u%segments => segments
      end subroutine produceResult
#endif
  end function parseURI

  function isAbsoluteURI(u) result(p)
    type(URI), intent(in) :: u
    logical :: p

#ifdef DUMMYLIB
    p = .false.
#else
    p = associated(u%scheme).or.associated(u%authority)
    if (.not.p.and.size(u%segments(1)%s)>0) then
      p = u%segments(1)%s(1)=="/"
    endif
#endif
  end function isAbsoluteURI

  function rebaseURI(u1, u2) result(u3)
    type(URI), pointer :: u1, u2
    type(URI), pointer :: u3

    u3 => null()
#ifndef DUMMYLIB

    if (associated(u2%scheme).or.associated(u2%authority)) then
      u3 => copyURI(u2)
      return
    endif

    allocate(u3)
    if (associated(u1%scheme)) u3%scheme => vs_vs_alloc(u1%scheme)
    if (associated(u1%authority)) u3%authority => vs_vs_alloc(u1%authority)

    u3%segments => appendPaths(u1%segments, u2%segments)
    u3%path => expressSegments(u3%segments)

    if (associated(u2%query)) u3%query => vs_vs_alloc(u2%query)
    if (associated(u2%fragment)) u3%fragment => vs_vs_alloc(u2%fragment)
#endif
  end function rebaseURI

#ifndef DUMMYLIB
  function appendPaths(seg1, seg2) result(seg3)
    type(path_segment), pointer :: seg1(:), seg2(:)
    type(path_segment), pointer :: seg3(:)

    type(path_segment), pointer :: temp(:)

    integer :: i, n, n2

    if (size(seg2(1)%s)==0) then
      seg3 => normalizePath(seg1)
      return
    elseif (seg2(1)%s(1)=="/") then
      seg3 => normalizePath(seg2)
      return
    endif

    n = size(seg1) + size(seg2)
    i = size(seg1)
    if (seg1(i)%s(size(seg1(i)%s))/="/") &
      n = n - 1

    allocate(temp(n))
    n2 = 1
    do i = 1, size(seg1)
      if (i==size(seg1).and.seg1(i)%s(size(seg1(i)%s))/="/") exit ! it's a file
      temp(n2)%s => vs_vs_alloc(seg1(i)%s)
      n2 = n2 + 1
    enddo
      
    do i = 1, size(seg2)
      temp(n2)%s => vs_vs_alloc(seg2(i)%s)
      n2 = n2 + 1
    enddo

    seg3 => normalizePath(temp)
    do i = 1, size(temp)
      deallocate(temp(i)%s)
    enddo
    deallocate(temp)

  end function appendPaths

  function normalizepath(seg1) result(seg2)
    type(path_segment), pointer :: seg1(:)
    type(path_segment), pointer :: seg2(:)

    integer :: i, n, n2, parents

    n = 0
    parents = 0
    do i = 1, size(seg1)
      if (str_vs(seg1(i)%s)//"x"=="./x") then
        continue
      elseif (str_vs(seg1(i)%s)//"x"=="../x") then
        if (n>0) then
          n = n - 1
        else
          parents = parents + 1
        endif
      else
        n = n + 1
      endif
    enddo

    n = n + parents
    allocate(seg2(n))

    n2 = parents
    do i = 1, parents
      seg2(i)%s => vs_str_alloc("../")
    enddo
    do i = 1, size(seg1)
      if (str_vs(seg1(i)%s)//"x"=="./x") then
        continue
      elseif (str_vs(seg1(i)%s)//"x"=="../x") then
        if (n2>parents) then
          if (n2<=n) deallocate(seg2(n2)%s)
          n2 = n2 - 1
        endif
      else
        n2 = n2 + 1
        if (n2>0.and.n2<=n) &
          seg2(n2)%s => vs_vs_alloc(seg1(i)%s)
      endif
    enddo

  end function normalizepath

  function expressSegments(seg1) result(s)
    type(path_segment), pointer :: seg1(:)
    character, pointer :: s(:)

    integer :: i, n

    n = 0

    do i = 1, size(seg1)
      n = n + size(seg1(i)%s)
    enddo
    allocate(s(n))
    n = 1
    do i = 1, size(seg1)
      s(n:n+size(seg1(i)%s)-1) = seg1(i)%s
      n = n + size(seg1(i)%s)
    enddo
  end function expressSegments

  pure function expressURI_len(u) result(n)
    type(URI), intent(in) :: u
    integer :: n

    n = 0
    if (associated(u%scheme)) &
      n = size(u%scheme) + 1
    if (associated(u%authority)) &
      n = n + pctEncode_len(str_vs(u%authority), unreserved//sub_delims//"@:") + 2
    n = n + pctEncode_len(str_vs(u%path), pchar//"/")
    if (associated(u%query)) &
      n = n + pctEncode_len(str_vs(u%query), uric) + 1
    if (associated(u%fragment)) &
      n = n + pctEncode_len(str_vs(u%fragment), uric) + 1

  end function expressURI_len

  function expressURI(u) result(URIstring)
    type(URI), intent(in) :: u
    character(len=expressURI_len(u)) :: URIstring

    integer :: i, j
    URIstring=""
    i = 1
    if (associated(u%scheme)) then
      URIstring(:size(u%scheme)+1) = str_vs(u%scheme)//":"
      i = i + size(u%scheme) + 1
    endif
    if (associated(u%authority)) then
      j = pctEncode_len(str_vs(u%authority), unreserved//sub_delims//"@:")
      URIstring(i:i+j+1) = &
        "//"//pctEncode(str_vs(u%authority), unreserved//sub_delims//"@:")
      i = i + j + 2
    endif
    if (size(u%path)>0) then
      j = pctEncode_len(str_vs(u%path), pchar//"/")
      URIstring(i:i+j-1) = pctEncode(str_vs(u%path), pchar//"/")
      i = i + j
    endif
    if (associated(u%query)) then
      j = pctEncode_len(str_vs(u%query), uric)
      URIstring(i:i+j) = "?"//pctEncode(str_vs(u%query), uric)
      i = i + j + 1
    endif
    if (associated(u%fragment)) then
      j = pctEncode_len(str_vs(u%fragment), uric)
      URIstring(i:i+j) = "#"//pctEncode(str_vs(u%fragment), uric)
    endif

  end function expressURI

  subroutine dumpURI(u)
    type(URI), intent(in) :: u
    integer :: i
    if (associated(u%scheme)) then
      write(*,*) "scheme: ", str_vs(u%scheme)
    else
      write(*,*) "scheme UNDEFINED"
    endif
    if (associated(u%authority)) then
      write(*,*) "authority: ", str_vs(u%authority)
    else
      write(*,*) "authority UNDEFINED"
    endif
    if (associated(u%userinfo)) then
      write(*,*) "userinfo: ", str_vs(u%userinfo)
    else
      write(*,*) "userinfo UNDEFINED"
    endif
    if (associated(u%host)) then
      write(*,*) "host: ", str_vs(u%host)
    else
      write(*,*) "host UNDEFINED"
    endif
    if (u%port>0) then
      write(*,*) "port: ", u%port
    else
      write(*,*) "port UNDEFINED"
    endif
    if (associated(u%path)) then
      write(*,*) "path: ", str_vs(u%path)
    else
      write(*,*) "path UNDEFINED"
    endif
    if (associated(u%segments)) then
      do i = 1, size(u%segments)
        write(*,*) "    segment: ", str_vs(u%segments(i)%s)
      enddo
    endif
    if (associated(u%query)) then
      write(*,*) "query: ", str_vs(u%query)
    else
      write(*,*) "query UNDEFINED"
    endif
    if (associated(u%fragment)) then
      write(*,*) "fragment: ", str_vs(u%fragment)
    else
      write(*,*) "fragment UNDEFINED"
    endif
  end subroutine dumpURI
#endif

  function copyURI(u1) result(u2)
    type(URI), pointer :: u1
    type(URI), pointer :: u2
#ifndef DUMMYLIB
    integer :: i

    if (.not.associated(u1)) then
#endif
      u2 => null()
#ifndef DUMMYLIB
      return
    endif
    allocate(u2)
    u2%scheme => vs_vs_alloc(u1%scheme)
    u2%authority => vs_vs_alloc(u1%authority)
    u2%userinfo => vs_vs_alloc(u1%userinfo)
    u2%host => vs_vs_alloc(u1%host)
    u2%port = u1%port
    u2%path => vs_vs_alloc(u1%path)
    allocate(u2%segments(size(u1%segments)))
    do i = 1, size(u1%segments)
      u2%segments(i)%s => vs_vs_alloc(u1%segments(i)%s)
    enddo
    u2%query => vs_vs_alloc(u1%query)
    u2%fragment => vs_vs_alloc(u1%fragment)
#endif
  end function copyURI


  subroutine destroyURI(u)
    type(URI), pointer :: u
#ifndef DUMMYLIB
    integer :: i
    if (associated(u%scheme)) deallocate(u%scheme)
    if (associated(u%authority)) deallocate(u%authority)
    if (associated(u%userinfo)) deallocate(u%userinfo)
    if (associated(u%host)) deallocate(u%host)
    if (associated(u%path)) deallocate(u%path)
    if (associated(u%segments)) then
      do i = 1, size(u%segments)
        deallocate(u%segments(i)%s)
      enddo
      deallocate(u%segments)
    endif
    if (associated(u%query)) deallocate(u%query)
    if (associated(u%fragment)) deallocate(u%fragment)

    deallocate(u)
#endif
  end subroutine destroyURI

  function hasScheme(u) result(p)
    type(URI), pointer :: u
    logical :: p

    p = .false.
#ifndef DUMMYLIB
    if (.not.associated(u)) return
    p = associated(u%scheme)
#endif
  end function hasScheme

  function getScheme(u) result(s)
    type(URI), pointer :: u

#ifndef DUMMYLIB
    character(len=size(u%scheme)) :: s
    s = str_vs(u%scheme)
#else
    character(len=1) :: s
    s = ""
#endif
  end function getScheme

  function hasAuthority(u) result(p)
    type(URI), pointer :: u
    logical :: p

    p = .false.
#ifndef DUMMYLIB
    if (.not.associated(u)) return
    p = associated(u%authority)
#endif
  end function hasAuthority

  function getAuthority(u) result(s)
    type(URI), pointer :: u
#ifndef DUMMYLIB
    character(len=size(u%authority)) :: s
    s = str_vs(u%authority)
#else
    character(len=1) :: s
    s = ""
#endif
  end function getAuthority

  function hasUserinfo(u) result(p)
    type(URI), pointer :: u
    logical :: p

    p = .false.
#ifndef DUMMYLIB
    if (.not.associated(u)) return
    p = associated(u%userinfo)
#endif
  end function hasUserinfo

  function getUserinfo(u) result(s)
    type(URI), pointer :: u
#ifndef DUMMYLIB
    character(len=size(u%userinfo)) :: s
    s = str_vs(u%userinfo)
#else
    character(len=1) :: s
    s = ""
#endif
  end function getUserinfo

  function hasHost(u) result(p)
    type(URI), pointer :: u
    logical :: p

    p = .false.
#ifndef DUMMYLIB
    if (.not.associated(u)) return
    p = associated(u%host)
#endif
  end function hasHost

  function getHost(u) result(s)
    type(URI), pointer :: u
#ifndef DUMMYLIB
    character(len=size(u%host)) :: s
    s = str_vs(u%host)
#else
    character(len=1) :: s
    s = ""
#endif
  end function getHost

  function hasPort(u) result(p)
    type(URI), pointer :: u
    logical :: p

    p = .false.
#ifndef DUMMYLIB
    if (.not.associated(u)) return
    p = u%port > 0
#endif
  end function hasPort

  function getPort(u) result(n)
    type(URI), pointer :: u
    integer :: n
#ifndef DUMMYLIB
    n = u%port
#else
    n = 0
#endif
  end function getPort

  function getPath(u) result(s)
    type(URI), pointer :: u
#ifndef DUMMYLIB
    character(len=size(u%path)) :: s
    s = str_vs(u%path)
#else
    character(len=1) :: s
    s = ""
#endif
  end function getPath

  function hasQuery(u) result(p)
    type(URI), pointer :: u
    logical :: p

    p = .false.
#ifndef DUMMYLIB
    if (.not.associated(u)) return
    p = associated(u%query)
#endif
  end function hasQuery

  function getQuery(u) result(s)
    type(URI), pointer :: u
#ifndef DUMMYLIB
    character(len=size(u%query)) :: s
    s = str_vs(u%query)
#else
    character(len=1) :: s
    s = ""
#endif
  end function getQuery

  function hasFragment(u) result(p)
    type(URI), pointer :: u
    logical :: p

    p = .false.
#ifndef DUMMYLIB
    if (.not.associated(u)) return
    p = associated(u%fragment)
#endif
  end function hasFragment

  function getFragment(u) result(s)
    type(URI), pointer :: u
#ifndef DUMMYLIB
    character(len=size(u%fragment)) :: s
    s = str_vs(u%fragment)
#else
    character(len=1) :: s
    s = ""
#endif
  end function getFragment

end module fox_m_utils_uri

module m_common_error

#ifndef DUMMYLIB
  use fox_m_fsys_array_str, only: vs_str_alloc
  use pxf, only: pxfabort, pxfflush

  implicit none
  private

  integer, parameter :: ERR_NULL = 0
  integer, parameter :: ERR_WARNING = 1
  integer, parameter :: ERR_ERROR = 2
  integer, parameter :: ERR_FATAL = 3

  type error_t
    integer :: severity = ERR_NULL
    integer :: error_code = 0
    character, dimension(:), pointer :: msg => null()
  end type error_t

  type error_stack
    type(error_t), dimension(:), pointer :: stack => null()
  end type error_stack

  interface FoX_warning
    module procedure FoX_warning_base
  end interface

  interface FoX_error
    module procedure FoX_error_base
  end interface

  interface FoX_fatal
    module procedure FoX_fatal_base
  end interface

  public :: ERR_NULL
  public :: ERR_WARNING
  public :: ERR_ERROR
  public :: ERR_FATAL

  public :: error_t
  public :: error_stack

  public :: init_error_stack
  public :: destroy_error_stack

  public :: FoX_warning
  public :: FoX_error
  public :: FoX_fatal

  public :: FoX_warning_base
  public :: FoX_error_base
  public :: FoX_fatal_base

  public :: add_error
  public :: in_error

contains

  subroutine FoX_warning_base(msg)
    ! Emit warning, but carry on.
    character(len=*), intent(in) :: msg

    write(0,'(a)') 'WARNING(FoX)'
    write(0,'(a)')  msg
    call pxfflush(0)

  end subroutine FoX_warning_base


  subroutine FoX_error_base(msg)
    ! Emit error message and stop.
    ! No clean up is done here, but this can
    ! be overridden to include clean-up routines
    character(len=*), intent(in) :: msg

    write(0,'(a)') 'ERROR(FoX)'
    write(0,'(a)')  msg
    call pxfflush(0)

    stop

  end subroutine FoX_error_base

  subroutine FoX_fatal_base(msg)
    !Emit error message and abort with coredump.
    !No clean-up occurs

    character(len=*), intent(in) :: msg

    write(0,'(a)') 'ABORT(FOX)'
    write(0,'(a)')  msg
    call pxfflush(0)

    call pxfabort()

  end subroutine FoX_fatal_base


  subroutine init_error_stack(stack)
    type(error_stack), intent(inout) :: stack
    
    allocate(stack%stack(0))
  end subroutine init_error_stack


  subroutine destroy_error_stack(stack)
    type(error_stack), intent(inout) :: stack
    
    integer :: i

    do i = 1, size(stack%stack)
      deallocate(stack%stack(i)%msg)
    enddo
    deallocate(stack%stack)
  end subroutine destroy_error_stack


  subroutine add_error(stack, msg, severity, error_code)
    type(error_stack), intent(inout) :: stack
    character(len=*), intent(in) :: msg
    integer, intent(in), optional :: severity
    integer, intent(in), optional :: error_code

    integer :: i, n
    type(error_t), dimension(:), pointer :: temp_stack 

    if (.not.associated(stack%stack)) &
      call init_error_stack(stack)

    n = size(stack%stack)
    
    temp_stack => stack%stack
    allocate(stack%stack(n+1))
    do i = 1, size(temp_stack)
      stack%stack(i)%msg => temp_stack(i)%msg
      stack%stack(i)%severity = temp_stack(i)%severity
      stack%stack(i)%error_code = temp_stack(i)%error_code
    enddo
    deallocate(temp_stack)

    stack%stack(n+1)%msg => vs_str_alloc(msg)
    if (present(severity)) then
      stack%stack(n+1)%severity = severity
    else
      stack%stack(n+1)%severity = ERR_ERROR
    endif
    if (present(error_code)) then
      stack%stack(n+1)%error_code = error_code
    else
      stack%stack(n+1)%error_code = -1
    endif

  end subroutine add_error


  function in_error(stack) result(p)
    type(error_stack), intent(in) :: stack
    logical :: p

    if (associated(stack%stack)) then
      p = (size(stack%stack) > 0)
    else
      p = .false.
    endif
  end function in_error

#endif
end module m_common_error

module fox_m_fsys_string_list
#ifndef DUMMYLIB

  use fox_m_fsys_array_str, only: str_vs, vs_str_alloc
  implicit none
  private

  type string_t
    character, pointer :: s(:) => null()
  end type string_t

  type string_list
    type(string_t), pointer :: list(:) => null()
  end type string_list

  public :: string_t
  public :: string_list

  public :: init_string_list
  public :: destroy_string_list
  public :: add_string
  public :: remove_last_string
  public :: get_last_string
  public :: tokenize_to_string_list
  public :: tokenize_and_add_strings
  public :: registered_string

  interface destroy
    module procedure destroy_string_list
  end interface

  public :: destroy

contains

  subroutine init_string_list(s_list)
    type(string_list), intent(inout) :: s_list

    allocate(s_list%list(0))
  end subroutine init_string_list

  subroutine destroy_string_list(s_list)
    type(string_list), intent(inout) :: s_list

    integer :: i

    if (associated(s_list%list)) then
      do i = 1, ubound(s_list%list, 1)
        deallocate(s_list%list(i)%s)
      enddo
      deallocate(s_list%list)
    endif
  end subroutine destroy_string_list

  subroutine add_string(s_list, s)
    type(string_list), intent(inout) :: s_list
    character(len=*), intent(in) :: s

    integer :: i
    type(string_t), pointer :: temp(:)

    temp => s_list%list
    allocate(s_list%list(size(temp)+1))
    do i = 1, size(temp)
      s_list%list(i)%s => temp(i)%s
    enddo
    deallocate(temp)
    s_list%list(i)%s => vs_str_alloc(s)
  end subroutine add_string

  subroutine remove_last_string(s_list)
    type(string_list), intent(inout) :: s_list

    integer :: i
    type(string_t), pointer :: temp(:)

    temp => s_list%list
    allocate(s_list%list(size(temp)-1))
    do i = 1, size(temp)-1
      s_list%list(i)%s => temp(i)%s
    enddo
    deallocate(temp)

  end subroutine remove_last_string

  function get_last_string(s_list) result(s)
    type(string_list), intent(in) :: s_list
    character(len=size(s_list%list(size(s_list%list))%s)) :: s

    s = str_vs(s_list%list(size(s_list%list))%s)
  end function get_last_string

  function tokenize_to_string_list(s) result(s_list)
    character(len=*), intent(in) :: s
    type(string_list) :: s_list

    ! tokenize a whitespace-separated list of strings
    ! and place results in a string list

    character(len=*), parameter :: &
      WHITESPACE = achar(9)//achar(10)//achar(13)//achar(32)
    integer :: i, j

    call init_string_list(s_list)

    i = verify(s, WHITESPACE)
    if (i==0) return
    j = scan(s(i:), WHITESPACE)
    if (j==0) then
      j = len(s)
    else
      j = i + j - 2
    endif
    do
      call add_string(s_list, s(i:j))
      i = j + 1
      j = verify(s(i:), WHITESPACE)
      if (j==0) exit
      i = i + j - 1
      j = scan(s(i:), WHITESPACE)
      if (j==0) then
        j = len(s)
      else
        j = i + j - 2
      endif
    enddo

  end function tokenize_to_string_list

  subroutine tokenize_and_add_strings(s_list, s, uniquify)
    type(string_list), intent(inout) :: s_list
    character(len=*), intent(in) :: s
    logical, intent(in), optional :: uniquify

    ! tokenize a whitespace-separated list of strings
    ! and place results in the given string list

    character(len=*), parameter :: & 
      WHITESPACE = achar(9)//achar(10)//achar(13)//achar(32)
    integer :: i, j
    logical :: uniquify_		
    
    if (present(uniquify)) then
      uniquify_ = uniquify
    else
      uniquify_ = .false.
    endif

    i = verify(s, WHITESPACE)
    if (i==0) return
    j = scan(s(i:), WHITESPACE)
    if (j==0) then
      j = len(s)
    else
      j = i + j - 2
    endif
    do
      if (uniquify_.and..not.registered_string(s_list, s(i:j))) &
        call add_string(s_list, s(i:j))
      i = j + 1
      j = verify(s(i:), WHITESPACE)
      if (j==0) exit
      i = i + j - 1
      j = scan(s(i:), WHITESPACE)
      if (j==0) then
        j = len(s)
      else
        j = i + j - 2
      endif
    enddo

  end subroutine tokenize_and_add_strings

  function registered_string(s_list, s) result(p)
    type(string_list), intent(in) :: s_list
    character(len=*), intent(in) :: s
    logical :: p

    integer :: i

    p = .false.
    do i = 1, size(s_list%list)
      if (str_vs(s_list%list(i)%s)//"x"==s//"x") then
        p = .true.
        exit
      endif
    enddo
  end function registered_string

#endif
end module fox_m_fsys_string_list

module m_common_attrs

#ifndef DUMMYLIB
  use fox_m_fsys_array_str, only : str_vs, vs_str_alloc
  use m_common_element, only: get_att_type_enum, ATT_CDATA, ATT_CDAMB, ATT_TYPES
  use m_common_error, only : FoX_error, FoX_fatal

  implicit none
  private

  !Initial length of dictionary
  integer, parameter :: DICT_INIT_LEN = 10 
  !Multiplier if we need to extend it.
  real, parameter :: DICT_LEN_MULT = 1.5

  type dict_item
    character(len=1), pointer, dimension(:) :: nsURI => null()
    character(len=1), pointer, dimension(:) :: localName => null()
    character(len=1), pointer, dimension(:) :: prefix => null()
    character(len=1), pointer, dimension(:) :: key => null()
    character(len=1), pointer, dimension(:) :: value => null()
    logical :: specified = .true.
    logical :: declared = .false.
    logical :: isId = .false.
    integer :: type = 11
  end type dict_item

  type dict_item_ptr
    type(dict_item), pointer :: d => null()
  end type dict_item_ptr
#endif

  type dictionary_t
    private
#ifndef DUMMYLIB
    type(dict_item_ptr), dimension(:), pointer :: list => null()
    character, dimension(:), pointer           :: base => null()
#else
    integer :: i
#endif
  end type dictionary_t

  public :: dictionary_t

  ! Building procedures
#ifndef DUMMYLIB
  public :: init_dict
  public :: reset_dict
  public :: add_item_to_dict
  public :: destroy_dict
#endif
  ! Query and extraction procedures

  ! SAX names:
  public :: getIndex
  public :: getLength
  public :: getLocalName
  public :: getQName
  public :: getURI
  public :: getValue
  public :: getType
  public :: isSpecified
  public :: setSpecified
  public :: isDeclared
  public :: setDeclared
  public :: hasKey

#ifndef DUMMYLIB
  public :: len
  public :: get_key 
  public :: get_value
  public :: remove_key
  public :: has_key
  public :: print_dict

  ! Namespaces
  public :: get_prefix
  public :: get_localName
  public :: set_nsURI
  public :: set_prefix
  public :: set_localName
#endif

  ! For internal FoX use only:
  public :: get_att_index_pointer
  public :: getWhitespaceHandling
  public :: setIsId
  public :: getIsId

  public :: setBase
  public :: getBase

  public :: sortAttrs

  interface len
    module procedure getLength
  end interface

  interface hasKey
    module procedure has_key, has_key_ns
  end interface

  interface getIndex
    module procedure get_key_index, get_key_index_ns
  end interface

  interface getQName
    module procedure get_key
  end interface

  interface getValue
    module procedure get_value_by_key, get_value_by_index, get_value_by_key_ns
  end interface
#ifndef DUMMYLIB
  interface get_value
    module procedure get_value_by_key, get_value_by_index
  end interface
  interface remove_key
    module procedure remove_key_by_index
  end interface
#endif

  interface getURI
    module procedure get_nsURI_by_index
  end interface
#ifndef DUMMYLIB
  interface get_prefix
    module procedure get_prefix_by_index
  end interface
#endif
  interface getLocalName
    module procedure get_localName_by_index
  end interface
#ifndef DUMMYLIB
  interface get_localName
    module procedure get_localName_by_index
  end interface
  interface set_nsURI
    module procedure set_nsURI_by_index
  end interface
  interface set_prefix
    module procedure set_prefix_by_index
  end interface
  interface set_localName
    module procedure set_localName_by_index_s
    module procedure set_localName_by_index_vs
  end interface
#endif

  interface getType
    module procedure getType_by_index
    module procedure getType_by_keyname
  end interface

  interface isSpecified
    module procedure isSpecified_by_index
    module procedure isSpecified_by_key
    module procedure isSpecified_by_keyNS
  end interface

  interface isDeclared
    module procedure isDeclared_by_index
    module procedure isDeclared_by_key
    module procedure isDeclared_by_keyNS
  end interface

#ifndef DUMMYLIB
  interface getIsId
    module procedure getIsId_by_index
  end interface

  interface setIsId
    module procedure setIsId_by_index
  end interface

  interface destroy
    module procedure destroy_dict_item
    module procedure destroy_dict
  end interface

#endif

contains

  pure function getLength(dict) result(n)
    type(dictionary_t), intent(in) :: dict
    integer :: n

#ifndef DUMMYLIB
    n = ubound(dict%list, 1)
#else
    n = 0
#endif
  end function getLength


  function has_key(dict, key) result(found)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: key
    logical :: found

#ifndef DUMMYLIB
    integer :: i

    do i = 1, ubound(dict%list, 1)
      if (key==str_vs(dict%list(i)%d%key)) then
        found = .true.
        return
      endif
    enddo
    found = .false.
#else
    found = .false.
#endif
  end function has_key

  function has_key_ns(dict, uri, localname) result(found)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: uri, localname
    logical :: found

#ifndef DUMMYLIB
    integer  ::  i
    found = .false.
    do i = 1, ubound(dict%list, 1)
      ! FIXME xlf 10.01 segfaults if the below is done as
      ! an AND rather than two separate ifs. This is
      ! probably due to the Heisenbug
      if (uri==str_vs(dict%list(i)%d%nsURI)) then
        if (localname==str_vs(dict%list(i)%d%localname)) then
          found = .true.
          exit
        endif
      endif
    enddo
#else
    found = .false.
#endif
  end function has_key_ns

  pure function get_key_index(dict, key) result(ind)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: key
    integer :: ind

#ifndef DUMMYLIB
    integer  ::  i
    do i = 1, ubound(dict%list, 1)
      if (key == str_vs(dict%list(i)%d%key)) then
        ind = i
        return
      endif
    enddo
    ind = 0
#else
    ind = 0
#endif
  end function get_key_index

  pure function get_key_index_ns(dict, uri, localname) result(ind)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: uri, localname
    integer :: ind

#ifndef DUMMYLIB
    integer  ::  i
    ind = -1
    do  i = 1, ubound(dict%list, 1)
      if (uri==str_vs(dict%list(i)%d%nsURI) &
        .and. localname==str_vs(dict%list(i)%d%localname)) then
        ind = i
        exit
      endif
    enddo
#else
    ind = 0
#endif
  end function get_key_index_ns

  function get_value_by_key(dict, key) result(value)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: key
#ifndef DUMMYLIB
    character(len=size(dict%list(get_key_index(dict,key))%d%value)) :: value

    integer  :: i

    do i = 1, ubound(dict%list, 1)
      if (key == str_vs(dict%list(i)%d%key)) then
        value = str_vs(dict%list(i)%d%value)
        return
      endif
    enddo
    value = ""
#else
    character(len=1) :: value
    value = ""
#endif
  end function get_value_by_key

  function get_value_by_key_ns(dict, nsUri, localname) result(value)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: nsUri
    character(len=*), intent(in) :: localname
#ifndef DUMMYLIB
    character(len=size(dict%list(get_key_index_ns(dict,nsuri,localname))%d%value)) :: value

    integer  :: i

    do i = 1, ubound(dict%list, 1)
      if (nsUri==str_vs(dict%list(i)%d%nsURI) &
        .and.localname==str_vs(dict%list(i)%d%localname)) then
        value = str_vs(dict%list(i)%d%value)
        return
      endif
    enddo
    value = ""
#else
    character(len=1) :: value
    value = ""
#endif
  end function get_value_by_key_ns

#ifndef DUMMYLIB
  subroutine get_att_index_pointer(dict, key, i, value)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: key
    integer, intent(out) :: i
    character, pointer :: value(:)

    value => null()
    do i = 1, ubound(dict%list, 1)
      if (key == str_vs(dict%list(i)%d%key)) then
        value => dict%list(i)%d%value
        return
      endif
    enddo
    i = 0
  end subroutine get_att_index_pointer

  subroutine remove_key_by_index(dict, ind)
    type(dictionary_t), intent(inout) :: dict
    integer, intent(in) :: ind

    integer :: i, n
    type(dict_item_ptr), pointer :: tempList(:)

    n = ubound(dict%list, 1)

    if (ind<=0.or.ind>n) return

    allocate(tempList(0:n-1))
    do i = 0, ind-1
      tempList(i)%d => dict%list(i)%d
    enddo
    call destroy(dict%list(ind)%d)
    do i = ind+1, n
      tempList(i-1)%d => dict%list(i)%d
    enddo
    deallocate(dict%list)
    dict%list => tempList
  end subroutine remove_key_by_index
#endif

  pure function get_value_by_index_len(dict, i) result(n)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
    integer :: n

#ifdef DUMMYLIB
    n = 1
#else
    if (i>0.and.i<=ubound(dict%list, 1)) then
      n = size(dict%list(i)%d%value)
    else
      n = 0
    endif
#endif
  end function get_value_by_index_len

  function get_value_by_index(dict, i) result(value)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
#ifndef DUMMYLIB
    character(len=get_value_by_index_len(dict, i)) :: value

    if (i>0.and.i<=ubound(dict%list, 1)) then
      value = str_vs(dict%list(i)%d%value)
    else
      value = ""
    endif
#else
    character(len=1) :: value
    value = ""
#endif
  end function get_value_by_index

#ifndef DUMMYLIB
  pure function get_key_len(dict, i) result(n)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
    integer :: n

    if (i>0.and.i<=ubound(dict%list, 1)) then
      n = size(dict%list(i)%d%key)
    else
      n = 0
    endif
  end function get_key_len
#endif

  function get_key(dict, i) result(key)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
#ifndef DUMMYLIB
    character(len=get_key_len(dict,i)) :: key

    if (i>0.and.i<=ubound(dict%list, 1)) then
      key = str_vs(dict%list(i)%d%key)
    else
      key = ""
    endif
#else
    character(len=1) :: key
    key = ""
#endif
  end function get_key

#ifndef DUMMYLIB
  subroutine add_item_to_dict(dict, key, value, prefix, nsURI, type, itype, specified, declared)
    type(dictionary_t), intent(inout) :: dict
    character(len=*), intent(in)           :: key
    character(len=*), intent(in)           :: value
    character(len=*), intent(in), optional :: prefix
    character(len=*), intent(in), optional :: nsURI
    character(len=*), intent(in), optional :: type
    integer, intent(in), optional :: itype
    logical, intent(in), optional :: specified
    logical, intent(in), optional :: declared

    type(dict_item_ptr), pointer :: tempList(:)
    integer :: i, n

    if (present(prefix) .eqv. .not.present(nsURI)) &
      call FoX_Error('Namespace improperly specified')

    n = ubound(dict%list, 1)
    allocate(tempList(0:n+1))
    do i = 0, n
      tempList(i)%d => dict%list(i)%d
    enddo
    n = n + 1

    allocate(tempList(n)%d)
    tempList(n)%d%value => vs_str_alloc(value)
    if (present(prefix)) then
      tempList(n)%d%key => vs_str_alloc(prefix//":"//key)
      tempList(n)%d%localname => vs_str_alloc(key)
      tempList(n)%d%prefix => vs_str_alloc(prefix)
      tempList(n)%d%nsURI => vs_str_alloc(nsURI)
    else
      tempList(n)%d%key => vs_str_alloc(key)
      tempList(n)%d%localname => vs_str_alloc(key)
      allocate(tempList(n)%d%prefix(0))
      allocate(tempList(n)%d%nsURI(0))
    endif
    if (present(type)) then
      if (present(itype)) &
        call FoX_fatal("internal library error in add_item_to_dict")
      tempList(n)%d%type = get_att_type_enum(type)
    elseif (present(itype)) then
      tempList(n)%d%type = itype
    else
      tempList(n)%d%type = ATT_CDAMB
    endif
    if (present(specified)) then
      tempList(n)%d%specified = specified
    else
      tempList(n)%d%specified = .true.
    endif
    if (present(declared)) then
      tempList(n)%d%declared = declared
    else
      tempList(n)%d%declared = .false.
    endif

    deallocate(dict%list)
    dict%list => tempList

  end subroutine add_item_to_dict

  subroutine set_nsURI_by_index(dict, i, nsURI)
    type(dictionary_t), intent(inout) :: dict
    integer, intent(in) :: i
    character(len=*), intent(in) :: nsURI

    if (associated(dict%list(i)%d%nsURI)) &
      deallocate(dict%list(i)%d%nsURI)
    dict%list(i)%d%nsURI => vs_str_alloc(nsURI)
  end subroutine set_nsURI_by_index

  subroutine set_prefix_by_index(dict, i, prefix)
    type(dictionary_t), intent(inout) :: dict
    integer, intent(in) :: i
    character(len=*), intent(in) :: prefix

    if (associated(dict%list(i)%d%prefix)) &
      deallocate(dict%list(i)%d%prefix)
    dict%list(i)%d%prefix => vs_str_alloc(prefix)
  end subroutine set_prefix_by_index

  subroutine set_localName_by_index_s(dict, i, localName)
    type(dictionary_t), intent(inout) :: dict
    integer, intent(in) :: i
    character(len=*), intent(in) :: localName

    if (associated(dict%list(i)%d%localName)) &
      deallocate(dict%list(i)%d%localName)
    dict%list(i)%d%localName => vs_str_alloc(localName)
  end subroutine set_localName_by_index_s

  subroutine set_localName_by_index_vs(dict, i, localName)
    type(dictionary_t), intent(inout) :: dict
    integer, intent(in) :: i
    character(len=1), dimension(:), intent(in) :: localName

    if (associated(dict%list(i)%d%localName)) &
      deallocate(dict%list(i)%d%localName)
    allocate(dict%list(i)%d%localName(size(localName)))
    dict%list(i)%d%localName = localName
  end subroutine set_localName_by_index_vs
#endif

  pure function get_nsURI_by_index(dict, i) result(nsURI)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
#ifndef DUMMYLIB
    character(len=size(dict%list(i)%d%nsURI)) :: nsURI
    nsURI = str_vs(dict%list(i)%d%nsURI)
#else
    character(len=1) :: nsURI
    nsURI = ""
#endif
  end function get_nsURI_by_index

#ifndef DUMMYLIB
  pure function get_prefix_by_index(dict, i) result(prefix)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
    character(len=size(dict%list(i)%d%prefix)) :: prefix

    prefix = str_vs(dict%list(i)%d%prefix)
  end function get_prefix_by_index
#endif

  pure function get_localName_by_index(dict, i) result(localName)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
#ifndef DUMMYLIB
    character(len=size(dict%list(i)%d%localName)) :: localName
    localName = str_vs(dict%list(i)%d%localName)
#else
    character(len=1) :: localName
    localName = ""
#endif
  end function get_localName_by_index

#ifndef DUMMYLIB
  pure function get_nsURI_by_keyname(dict, keyname) result(nsURI)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: keyname
    character(len=size(dict%list(get_key_index(dict, keyname))%d%nsURI)) :: nsURI
    integer :: i

    i = get_key_index(dict, keyname)
    nsURI = str_vs(dict%list(i)%d%nsURI)
  end function get_nsURI_by_keyname

  pure function get_prefix_by_keyname(dict, keyname) result(prefix)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: keyname
    character(len=size(dict%list(get_key_index(dict, keyname))%d%prefix)) :: prefix
    integer :: i

    i=get_key_index(dict, keyname)
    prefix = str_vs(dict%list(i)%d%prefix)

  end function get_prefix_by_keyname

  pure function get_localName_by_keyname(dict, keyname) result(localName)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: keyname
    character(len=size(dict%list(get_key_index(dict, keyname))%d%localName)) :: localName
    integer :: i

    i=get_key_index(dict, keyname)
    localName = str_vs(dict%list(i)%d%localName)

  end function get_localName_by_keyname
#endif

#ifndef DUMMYLIB
  pure function getType_by_index_len(dict, i) result(n)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
    integer :: n

    if (i>0.and.i<=ubound(dict%list, 1)) then
      n = len_trim(ATT_TYPES(dict%list(i)%d%type))
    else
      n = 0
    endif
  end function getType_by_index_len
#endif

  function getType_by_index(dict, i) result(type)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
#ifndef DUMMYLIB
    character(len=getType_by_index_len(dict, i)) :: type

    if (i>0.and.i<=ubound(dict%list, 1)) then
      type = ATT_TYPES(dict%list(i)%d%type)
    else
      type = ""
    endif
#else
    character(len=1) :: type
    type = ""
#endif
  end function getType_by_index

#ifndef DUMMYLIB
  pure function getType_by_keyname_len(dict, keyname) result(n)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: keyname
    integer :: n

    integer :: i
    i = get_key_index(dict, keyname)

    if (i>0) then
      n = len_trim(ATT_TYPES(i))
    else
      n = 0
    endif
  end function getType_by_keyname_len
#endif

  function getType_by_keyname(dict, keyname) result(type)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: keyname
#ifndef DUMMYLIB
    character(len=getType_by_keyname_len(dict, keyname)) :: type

    integer :: i
    i = get_key_index(dict, keyname)
    if (i>0) then
      type = ATT_TYPES(dict%list(i)%d%type)
    else
      type = ""
    endif
#else
    character(len=1) :: type
    type = ""
#endif
  end function getType_by_keyname

  function isSpecified_by_index(dict, i) result(p)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
    logical :: p

#ifndef DUMMYLIB
    if (i>0.and.i<=ubound(dict%list, 1)) then
      p = dict%list(i)%d%specified
    else
      p = .false.
    endif
#else
    p = .false.
#endif
  end function isSpecified_by_index

  function isSpecified_by_key(dict, qName) result(p)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: qName
    logical :: p

#ifndef DUMMYLIB
    integer :: i
    i = getIndex(dict, qName)
    if (i>0.and.i<=ubound(dict%list, 1)) then
      p = dict%list(i)%d%specified
    else
      p = .false.
    endif
#else
    p = .false.
#endif
  end function isSpecified_by_key

  subroutine setSpecified(dict, i, p)
    type(dictionary_t), intent(inout) :: dict
    integer, intent(in) :: i
    logical, intent(in) :: p

#ifndef DUMMYLIB
    if (i>0.and.i<=ubound(dict%list, 1)) then
      dict%list(i)%d%specified = p
    endif
#endif
  end subroutine setSpecified

  function isSpecified_by_keyNS(dict, uri, localName) result(p)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: uri
    character(len=*), intent(in) :: localName
    logical :: p

#ifndef DUMMYLIB
    integer :: i
    i = getIndex(dict, uri, localName)
    if (i>0.and.i<=ubound(dict%list, 1)) then
      p = dict%list(i)%d%specified
    else
      p = .false.
    endif
#else
    p = .false.
#endif
  end function isSpecified_by_keyNS

  function isDeclared_by_index(dict, i) result(p)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
    logical :: p

#ifndef DUMMYLIB
    if (i>0.and.i<=ubound(dict%list, 1)) then
      p = dict%list(i)%d%declared
    else
      p = .false.
    endif
#else
    p = .false.
#endif
  end function isDeclared_by_index

  function isDeclared_by_key(dict, qName) result(p)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: qName
    logical :: p

#ifndef DUMMYLIB
    integer :: i
    i = getIndex(dict, qName)
    if (i>0.and.i<=ubound(dict%list, 1)) then
      p = dict%list(i)%d%declared
    else
      p = .false.
    endif
#else
    p = .false.
#endif
  end function isDeclared_by_key

  function isDeclared_by_keyNS(dict, uri, localName) result(p)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: uri
    character(len=*), intent(in) :: localName
    logical :: p

#ifndef DUMMYLIB
    integer :: i
    i = getIndex(dict, uri, localName)
    if (i>0.and.i<=ubound(dict%list, 1)) then
      p = dict%list(i)%d%declared
    else
      p = .false.
    endif
#else
    p = .false.
#endif
  end function isDeclared_by_keyNS

  subroutine setDeclared(dict, i, p)
    type(dictionary_t), intent(inout) :: dict
    integer, intent(in) :: i
    logical, intent(in) :: p

#ifndef DUMMYLIB
    if (i>0.and.i<=ubound(dict%list, 1)) then
      dict%list(i)%d%declared = p
    endif
#endif
  end subroutine setDeclared

#ifndef DUMMYLIB
  function getIsId_by_index(dict, i) result(p)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
    logical :: p

    if (i>0.and.i<=ubound(dict%list, 1)) then
      p = dict%list(i)%d%isId
    else
      p = .false.
    endif

  end function getIsId_by_index

  subroutine setIsId_by_index(dict, i, p)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
    logical, intent(in) :: p

    if (i>0.and.i<=ubound(dict%list, 1)) then
      dict%list(i)%d%isId = p
    endif
  end subroutine setIsId_by_index

  function getWhitespaceHandling(dict, i) result(j)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
    integer :: j

    if (i<=ubound(dict%list, 1)) then
      select case(dict%list(i)%d%type)
      case (ATT_CDATA)
        j = 0 !
      case (ATT_CDAMB)
        j = 1
      case default
        j = 2
      end select
    else
      j = 2
    endif

  end function getWhitespaceHandling

  subroutine setBase(dict, base)
    type(dictionary_t), intent(inout) :: dict
    character(len=*), intent(in) :: base

    if (associated(dict%base)) deallocate(dict%base)
    dict%base => vs_str_alloc(base)
  end subroutine setBase

  pure function getBase_len(dict) result(n)
    type(dictionary_t), intent(in) :: dict
    integer :: n

    if (associated(dict%base)) then
      n = size(dict%base)
    else
      n = 0
    endif
  end function getBase_len

  function getBase(dict) result(base)
    type(dictionary_t), intent(in) :: dict
    character(len=getBase_len(dict)) :: base

    if (associated(dict%base)) then
      base = str_vs(dict%base)
    else
      base = ""
    endif
  end function getBase

  subroutine destroy_dict_item(d)
    type(dict_item), pointer :: d

    if (associated(d)) then
      deallocate(d%key)
      deallocate(d%value)
      deallocate(d%nsURI)
      deallocate(d%prefix)
      deallocate(d%localName)
      deallocate(d)
    endif
  end subroutine destroy_dict_item

  subroutine init_dict(dict)
    type(dictionary_t), intent(out) :: dict


    allocate(dict%list(0:0))
    allocate(dict%list(0)%d)
    allocate(dict%list(0)%d%key(0))

  end subroutine init_dict

  subroutine destroy_dict(dict)
    type(dictionary_t), intent(inout) :: dict
    integer :: i

    if (associated(dict%list)) then
      deallocate(dict%list(0)%d%key)
      deallocate(dict%list(0)%d)
      do i = 1, ubound(dict%list, 1)
        call destroy(dict%list(i)%d)
      enddo
      deallocate(dict%list)
    endif
    if (associated(dict%base)) deallocate(dict%base)

  end subroutine destroy_dict


  subroutine reset_dict(dict)
    type(dictionary_t), intent(inout) :: dict

    call destroy_dict(dict)
    call init_dict(dict)

  end subroutine reset_dict

  subroutine sortAttrs(dict)
    type(dictionary_t), intent(inout) :: dict

    logical :: done(ubound(dict%list, 1))
    type(dict_item_ptr), dimension(:), pointer :: list => null()
    integer :: i, j, n, firstIndex
    character, pointer :: firstKey(:)

    !Ridiculously naive sort algorithm. We are unlikely
    !to ever be sorting more then ten or so attributes though

    n = ubound(dict%list, 1)

    allocate(list(0:n))
    list(0)%d => dict%list(0)%d

    j = 1
    done = .false.

    firstIndex = 1
    do while (firstIndex/=0)
      firstIndex = 0
      firstKey => null()
      do i = 1, n
        if (.not.done(i).and.str_vs(dict%list(i)%d%key)=="xmlns" &
          .or. str_vs(dict%list(i)%d%prefix)=="xmlns") then
          firstIndex = i
          if (associated(firstKey)) then
            if (llt(str_vs(dict%list(i)%d%key),str_vs(firstKey))) then
              firstIndex = i
              firstKey => dict%list(i)%d%key
            endif
          else
            firstIndex = i
            firstKey => dict%list(i)%d%key
          endif
        endif
      enddo
      if (firstIndex/=0) then
        done(firstIndex) = .true.
        list(j)%d => dict%list(firstIndex)%d
        j = j + 1
      endif
    enddo

    do while (any(.not.done))
      firstIndex = 0
      firstKey => null()
      do i = 1, n
        if (.not.done(i)) then
          if (associated(firstKey)) then
            if (llt(str_vs(dict%list(i)%d%key),str_vs(firstKey))) then
              firstIndex = i
              firstKey => dict%list(i)%d%key
            endif
          else
            firstIndex = i
            firstKey => dict%list(i)%d%key
          endif
        endif
      enddo
      done(firstIndex) = .true.
      list(j)%d => dict%list(firstIndex)%d
      j = j + 1
    enddo

    deallocate(dict%list)
    dict%list => list

  end subroutine sortAttrs


  subroutine print_dict(dict)
    type(dictionary_t), intent(in) :: dict

    integer  :: i

    do i = 1, ubound(dict%list, 1)
      write(*,'(7a)') str_vs(dict%list(i)%d%key), " [ {", str_vs(dict%list(i)%d%nsURI), &
        "}", str_vs(dict%list(i)%d%localName), " ]  = ", str_vs(dict%list(i)%d%value)
    enddo

  end subroutine print_dict

#endif
end module m_common_attrs

module m_sax_types

#ifndef DUMMYLIB
  use m_common_attrs, only: dictionary_t
  use m_common_elstack, only: elstack_t
  use m_common_entities, only: entity_list
  use m_common_error, only: error_stack
  use m_common_namespaces, only: namespacedictionary
  use m_common_notations, only: notation_list
  use m_common_struct, only: xml_doc_state

  use m_sax_reader, only: file_buffer_t

  implicit none

  ! Context

  integer, parameter :: CTXT_NULL = -1
  integer, parameter :: CTXT_INIT = 0
  integer, parameter :: CTXT_BEFORE_DTD = 1
  integer, parameter :: CTXT_IN_DTD = 2
  integer, parameter :: CTXT_IGNORE = 3
  integer, parameter :: CTXT_BEFORE_CONTENT = 4
  integer, parameter :: CTXT_IN_CONTENT = 5
  integer, parameter :: CTXT_AFTER_CONTENT = 6

  ! State

  integer, parameter :: ST_STOP                     = -1
  integer, parameter :: ST_NULL                     = 0
  integer, parameter :: ST_MISC                     = 1
  integer, parameter :: ST_BANG_TAG                 = 2
  integer, parameter :: ST_START_PI                 = 3
  integer, parameter :: ST_PI_CONTENTS              = 4
  integer, parameter :: ST_PI_END                   = 5
  integer, parameter :: ST_START_COMMENT            = 6
  integer, parameter :: ST_COMMENT_END              = 7
  integer, parameter :: ST_START_TAG                = 8
  integer, parameter :: ST_START_CDATA_DECLARATION  = 9
  integer, parameter :: ST_FINISH_CDATA_DECLARATION = 10
  integer, parameter :: ST_IN_TAG                   = 11
  integer, parameter :: ST_ATT_NAME                 = 12
  integer, parameter :: ST_ATT_EQUALS               = 13
  integer, parameter :: ST_CHAR_IN_CONTENT          = 14
  integer, parameter :: ST_CLOSING_TAG              = 15
  integer, parameter :: ST_CDATA_CONTENTS           = 16
  integer, parameter :: ST_IN_CLOSING_TAG           = 17
  integer, parameter :: ST_TAG_IN_CONTENT           = 18
  integer, parameter :: ST_CDATA_END                = 19
  integer, parameter :: ST_IN_DOCTYPE               = 20
  integer, parameter :: ST_DOC_NAME                 = 21
  integer, parameter :: ST_DOC_SYSTEM               = 22
  integer, parameter :: ST_DOC_PUBLIC               = 23
  integer, parameter :: ST_DOC_DECL                 = 24
  integer, parameter :: ST_CLOSE_DOCTYPE            = 25
  integer, parameter :: ST_START_ENTITY             = 26
  integer, parameter :: ST_START_PE                 = 27
  integer, parameter :: ST_IN_SUBSET                = 28

! DTD states
  integer, parameter :: ST_DTD_NULL                = 50
  integer, parameter :: ST_DTD_SUBSET              = 51
  integer, parameter :: ST_DTD_START_SECTION_DECL  = 52
  integer, parameter :: ST_DTD_FINISH_SECTION_DECL = 53
  integer, parameter :: ST_DTD_IN_IGNORE_SECTION   = 54
  integer, parameter :: ST_DTD_BANG_TAG            = 55
  integer, parameter :: ST_DTD_START_PI            = 56
  integer, parameter :: ST_DTD_PI_CONTENTS         = 57
  integer, parameter :: ST_DTD_PI_END              = 58
  integer, parameter :: ST_DTD_COMMENT_END         = 59
  integer, parameter :: ST_DTD_START_COMMENT       = 60
  integer, parameter :: ST_DTD_ATTLIST             = 61
  integer, parameter :: ST_DTD_ELEMENT             = 62
  integer, parameter :: ST_DTD_ENTITY              = 63
  integer, parameter :: ST_DTD_NOTATION            = 64
  integer, parameter :: ST_DTD_NOTATION_ID         = 65
  integer, parameter :: ST_DTD_NOTATION_SYSTEM     = 66
  integer, parameter :: ST_DTD_NOTATION_PUBLIC     = 67
  integer, parameter :: ST_DTD_NOTATION_PUBLIC_2   = 68
  integer, parameter :: ST_DTD_NOTATION_END        = 69
  integer, parameter :: ST_DTD_ENTITY_PE           = 70
  integer, parameter :: ST_DTD_ENTITY_ID           = 71
  integer, parameter :: ST_DTD_ENTITY_PUBLIC       = 72
  integer, parameter :: ST_DTD_ENTITY_SYSTEM       = 73
  integer, parameter :: ST_DTD_ENTITY_NDATA        = 74
  integer, parameter :: ST_DTD_ENTITY_NDATA_VALUE  = 75
  integer, parameter :: ST_DTD_ENTITY_END          = 76
  integer, parameter :: ST_DTD_ATTLIST_CONTENTS    = 77
  integer, parameter :: ST_DTD_ATTLIST_END         = 78
  integer, parameter :: ST_DTD_ELEMENT_CONTENTS    = 79
  integer, parameter :: ST_DTD_ELEMENT_END         = 80
  integer, parameter :: ST_DTD_DONE                = 81

! token types

  integer, parameter :: TOK_NULL = 0
  integer, parameter :: TOK_PI_TAG = 1 ! <?
  integer, parameter :: TOK_BANG_TAG = 2 ! <!
  integer, parameter :: TOK_OPEN_TAG = 3 ! <
  integer, parameter :: TOK_OPEN_SB = 4 ! [
  integer, parameter :: TOK_CLOSE_SB = 5 ! [
  integer, parameter :: TOK_OPEN_COMMENT = 6 ! --
  integer, parameter :: TOK_NAME = 7 ! name (+token)
  integer, parameter :: TOK_CHAR = 8 ! character data (+token)
  integer, parameter :: TOK_PI_END = 9 ! ?>
  integer, parameter :: TOK_COMMENT_END = 10 ! -->
  integer, parameter :: TOK_SECTION_START = 11 ! <![
  integer, parameter :: TOK_SECTION_END = 12 ! ]]>
  integer, parameter :: TOK_END_TAG = 13 ! >
  integer, parameter :: TOK_END_TAG_CLOSE = 14 ! />
  integer, parameter :: TOK_CLOSE_TAG = 15 ! </
  integer, parameter :: TOK_ENTITY = 16 ! % or &
  integer, parameter :: TOK_EQUALS = 17 ! =
  integer, parameter :: TOK_DTD_CONTENTS = 18 ! for element and attlist
  integer, parameter :: TOK_OPEN_PAR = 19 ! (
  integer, parameter :: TOK_CLOSE_PAR = 20 ! )

  type sax_parser_t
    type(xml_doc_state), pointer :: xds
    logical :: xds_used = .false. ! is the xds used by DOM? If so, we must
                                  ! not destroy it once we are finished
    integer :: context 
    integer :: state = ST_NULL
    integer :: state_dtd = ST_DTD_SUBSET
    logical :: well_formed = .false.
    logical :: skippedExternal = .false.
    character, dimension(:), pointer :: token => null()
    character, dimension(:), pointer :: content => null()
    integer :: tokenType = TOK_NULL
    integer :: nextTokenType = TOK_NULL
    character, dimension(:), pointer :: name => null()
    character, dimension(:), pointer :: attname => null()
    logical :: error = .false.
    type(error_stack) :: error_stack
    ! Aspects of document structure
    character, dimension(:), pointer :: root_element => null()
    type(elstack_t) :: elstack
    type(dictionary_t) :: attributes
    type(namespacedictionary) :: nsdict
    type(notation_list) :: nlist
    type(entity_list) :: predefined_e_list
    type(entity_list) :: forbidden_pe_list
    type(entity_list) :: forbidden_ge_list
    character(len=1), dimension(:), pointer :: PublicId => null()
    character(len=1), dimension(:), pointer :: SystemId => null()
    character(len=1), dimension(:), pointer :: Ndata => null()
    logical :: inIntSubset = .false.
    logical :: spaceBeforeEntity = .false.
  end type sax_parser_t
#endif

  type xml_t
#ifndef DUMMYLIB
    type(file_buffer_t) :: fb
    type(sax_parser_t) :: fx
#else
    integer :: i = 0
#endif
  end type xml_t

end module m_sax_types

module m_common_entity_expand

#ifndef DUMMYLIB
  use fox_m_fsys_array_str, only: str_vs, vs_str
  use m_common_entities, only: expand_char_entity
  use m_common_error, only: error_stack, add_error
  use m_common_namecheck, only: checkName, checkCharacterEntityReference, &
    checkRepCharEntityReference
  use m_common_struct, only: xml_doc_state

  implicit none
  private

  public :: expand_entity_value_alloc

  ! This does the first level of expansion of the contents of an entity
  ! reference, for storage during processing. Only character references
  ! are expanded.

contains

  function expand_entity_value_alloc(repl, xds, stack) result(repl_new)
    !perform expansion of character entity references
    ! check that no parameter entities are present
    ! and check that all general entity references are well-formed.
    !before storing it.
    !
    ! This is only ever called from the SAX parser
    ! (might it be called from WXML?)
    ! so input & output is with character arrays, not strings.
    character, dimension(:), intent(in) :: repl
    type(xml_doc_state), intent(in) :: xds
    type(error_stack), intent(inout) :: stack
    character, dimension(:), pointer :: repl_new

    character, dimension(size(repl)) :: repl_temp
    integer :: i, i2, j
    
    allocate(repl_new(0))
    if (index(str_vs(repl),'%')/=0) then
      call add_error(stack, "Not allowed % in internal subset general entity value")
      return
    endif

    i = 1
    i2 = 1
    do
      if (i>size(repl)) exit
      if (repl(i)=='&') then
        j = index(str_vs(repl(i+1:)),';')
        if (j==0) then
          call add_error(stack, "Not allowed bare & in entity value")
          return
        elseif (checkName(str_vs(repl(i+1:i+j-1)), xds%xml_version)) then
          repl_temp(i2:i2+j) = repl(i:i+j)
          i = i + j + 1
          i2 = i2 + j + 1
          ! For SAX, we need to be able to represent the character:
        elseif (checkRepCharEntityReference(str_vs(repl(i+1:i+j-1)), xds%xml_version)) then
          !if it is ascii then
          repl_temp(i2:i2) = vs_str(expand_char_entity(str_vs(repl(i+1:i+j-1))))
          i = i + j + 1
          i2 = i2 + 1
        elseif (checkCharacterEntityReference(str_vs(repl(i+1:i+j-1)), xds%xml_version)) then
          ! We can't represent it. Issue an error and stop.
          call add_error(stack, "Unable to digest character entity reference in entity value, sorry.")
          return
        else
          call add_error(stack, "Invalid entity reference in entity value")
          return
        endif
      else
        repl_temp(i2) = repl(i)
        i = i + 1
        i2 = i2 + 1
      endif
    enddo

    deallocate(repl_new)
    allocate(repl_new(i2-1))
    repl_new = repl_temp(:i2-1)

  end function expand_entity_value_alloc

#endif
end module m_common_entity_expand

module m_sax_reader
#ifndef DUMMYLIB

  use fox_m_fsys_array_str, only: str_vs, vs_str_alloc, vs_vs_alloc
  use fox_m_fsys_format, only: operator(//)
  use m_common_charset, only: XML1_0
  use m_common_error,  only: error_stack, FoX_error, in_error, add_error
  use m_common_io, only: setup_io, get_unit, io_err

  use FoX_utils, only: URI, parseURI, copyURI, destroyURI, &
    hasScheme, getScheme, getPath

  use m_sax_xml_source, only: xml_source_t, &
    get_char_from_file, push_file_chars, parse_declaration

  implicit none
  private

  type file_buffer_t
    !FIXME private
    type(xml_source_t), pointer :: f(:) => null()
    logical                     :: standalone = .false.
    integer                     :: xml_version = XML1_0
  end type file_buffer_t

  public :: file_buffer_t
  public :: line
  public :: column

  public :: open_file
  public :: close_file

  public :: open_new_file

  public :: push_chars

  public :: get_character
  public :: get_all_characters

  public :: open_new_string
  public :: pop_buffer_stack

  public :: parse_xml_declaration
  public :: parse_text_declaration

  public :: reading_main_file
  public :: reading_first_entity

contains

  subroutine open_file(fb, iostat, file, lun, string, es)
    type(file_buffer_t), intent(out)  :: fb
    character(len=*), intent(in), optional :: file
    integer, intent(out)              :: iostat
    integer, intent(in), optional     :: lun
    character(len=*), intent(in), optional :: string
    type(error_stack), intent(inout) :: es

    type(URI), pointer :: fileURI

    iostat = 0

    call setup_io()
    if (present(string)) then
      if (present(file)) then
        call FoX_error("Cannot specify both file and string input to open_xml")
      elseif (present(lun)) then
        call FoX_error("Cannot specify lun for string input to open_xml")
      endif
      fileURI => parseURI("")
      call open_new_string(fb, string, "", baseURI=fileURI)
    else
      fileURI => parseURI(file)
      if (.not.associated(fileURI)) then
        call add_error(es, "Could not open file "//file//" - not a valid URI")
        return
      endif
      call open_new_file(fb, fileURI, iostat, lun)
    endif
    call destroyURI(fileURI)

  end subroutine open_file


  subroutine open_new_file(fb, baseURI, iostat, lun, pe)
    type(file_buffer_t), intent(inout)  :: fb
    integer, intent(out) :: iostat
    type(URI), pointer :: baseURI
    integer, intent(in), optional :: lun
    logical, intent(in), optional :: pe

    integer :: i
    type(xml_source_t) :: f
    type(xml_source_t), pointer :: temp(:)
    logical :: pe_

    if (present(pe)) then
      pe_ = pe
    else
      pe_ = .false.
    endif

    if (hasScheme(baseURI)) then
      if (getScheme(baseURI)/="file") then
        iostat = io_err
        return
      endif
    endif

    call open_actual_file(f, getPath(baseURI), iostat, lun)
    if (iostat==0) then
      if (.not.associated(fb%f)) allocate(fb%f(0))
      ! First file

      temp => fb%f
      allocate(fb%f(size(temp)+1))
      do i = 1, size(temp)
        fb%f(i+1)%lun = temp(i)%lun
        fb%f(i+1)%xml_version = temp(i)%xml_version
        fb%f(i+1)%encoding => temp(i)%encoding
        fb%f(i+1)%filename => temp(i)%filename
        fb%f(i+1)%line = temp(i)%line
        fb%f(i+1)%col = temp(i)%col
        fb%f(i+1)%startChar = temp(i)%startChar
        fb%f(i+1)%next_chars => temp(i)%next_chars
        fb%f(i+1)%input_string => temp(i)%input_string
        fb%f(i+1)%baseURI => temp(i)%baseURI
        fb%f(i+1)%pe = temp(i)%pe
      enddo
      deallocate(temp)
      fb%f(1)%lun = f%lun
      fb%f(1)%filename => f%filename
      if (pe_) then
        fb%f(1)%next_chars => vs_str_alloc(" ")
      else
        fb%f(1)%next_chars => vs_str_alloc("")
      endif
      fb%f(1)%pe = pe_
      fb%f(1)%baseURI => copyURI(baseURI)
    endif

  end subroutine open_new_file

  subroutine open_actual_file(f, file, iostat, lun)
    type(xml_source_t), intent(out)    :: f
    character(len=*), intent(in)     :: file
    integer, intent(out)             :: iostat
    integer, intent(in), optional    :: lun

    if (present(lun)) then
      f%lun = lun
    else
      call get_unit(f%lun, iostat)
      if (iostat/=0) return
    endif
    open(unit=f%lun, file=file, form="formatted", status="old", &
      action="read", position="rewind", iostat=iostat)
    if (iostat/=0) return
    f%filename => vs_str_alloc(file)

  end subroutine open_actual_file

  subroutine close_file(fb)
    type(file_buffer_t), intent(inout)  :: fb

    integer :: i

    do i = 1, size(fb%f)
      call close_actual_file(fb%f(i))
    enddo

    deallocate(fb%f)

  end subroutine close_file


  subroutine close_actual_file(f)
    type(xml_source_t), intent(inout)    :: f

    deallocate(f%filename)
    
    if (f%lun>0) then
      close(f%lun)
    else
      deallocate(f%input_string%s)
      deallocate(f%input_string)
    endif

    if (associated(f%encoding)) deallocate(f%encoding)
    f%line = 0
    f%col = 0
    deallocate(f%next_chars)
    call destroyURI(f%baseURI)
  end subroutine close_actual_file


  subroutine open_new_string(fb, string, name, baseURI, pe)
    type(file_buffer_t), intent(inout) :: fb
    character(len=*), intent(in) :: string
    character(len=*), intent(in) :: name
    type(URI), pointer :: baseURI
    logical, intent(in), optional :: pe

    integer :: i
    type(xml_source_t), pointer :: temp(:)
    logical :: pe_

    if (present(pe)) then
      pe_ = pe
    else
      pe_ = .false.
    endif

    if (.not.associated(fb%f)) allocate(fb%f(0))

    temp => fb%f
    allocate(fb%f(size(temp)+1))
    do i = 1, size(temp)
      fb%f(i+1)%lun = temp(i)%lun
      fb%f(i+1)%xml_version = temp(i)%xml_version
      fb%f(i+1)%encoding => temp(i)%encoding
      fb%f(i+1)%filename => temp(i)%filename
      fb%f(i+1)%line = temp(i)%line
      fb%f(i+1)%col = temp(i)%col
      fb%f(i+1)%startChar = temp(i)%startChar
      fb%f(i+1)%next_chars => temp(i)%next_chars
      fb%f(i+1)%input_string => temp(i)%input_string
      fb%f(i+1)%baseURI => temp(i)%baseURI
      fb%f(i+1)%pe = temp(i)%pe
    enddo
    deallocate(temp)

    allocate(fb%f(1)%input_string)
    fb%f(1)%filename => vs_str_alloc(name)
    fb%f(1)%input_string%s => vs_str_alloc(string)
    if (pe_) then
      fb%f(1)%next_chars => vs_str_alloc(" ")
    else
      fb%f(1)%next_chars => vs_str_alloc("")
    endif
    fb%f(1)%pe = pe_
    if (associated(baseURI)) then
      fb%f(1)%baseURI => copyURI(baseURI)
    else
      fb%f(1)%baseURI => copyURI(fb%f(2)%baseURI)
    endif

  end subroutine open_new_string 

  subroutine pop_buffer_stack(fb)
    type(file_buffer_t), intent(inout) :: fb

    integer :: i
    type(xml_source_t), pointer :: temp(:)
    
    call close_actual_file(fb%f(1))

    temp => fb%f
    allocate(fb%f(size(temp)-1))
    do i = 1, size(temp)-1
      fb%f(i)%lun = temp(i+1)%lun
      fb%f(i)%xml_version = temp(i+1)%xml_version
      fb%f(i)%encoding => temp(i+1)%encoding
      fb%f(i)%filename => temp(i+1)%filename
      fb%f(i)%line = temp(i+1)%line
      fb%f(i)%col = temp(i+1)%col
      fb%f(i)%startChar = temp(i+1)%startChar
      fb%f(i)%next_chars => temp(i+1)%next_chars
      fb%f(i)%input_string => temp(i+1)%input_string
      fb%f(i)%baseURI => temp(i+1)%baseURI
      fb%f(i)%pe = temp(i+1)%pe
    enddo
    deallocate(temp)

  end subroutine pop_buffer_stack


  subroutine push_chars(fb, s)
    type(file_buffer_t), intent(inout) :: fb
    character(len=*), intent(in) :: s

    call push_file_chars(fb%f(1), s)

  end subroutine push_chars

  function get_character(fb, eof, es) result(string)
    type(file_buffer_t), intent(inout) :: fb
    logical, intent(out) :: eof
    type(error_stack), intent(inout) :: es
    character(len=1) :: string

    type(xml_source_t), pointer :: f
    character, pointer :: temp(:)

    f => fb%f(1)

    if (size(f%next_chars)>0) then
      eof = .false.
      string = f%next_chars(1)
      if (size(f%next_chars)>1) then
        temp => vs_str_alloc(str_vs(f%next_chars(2:)))
      else
        temp => vs_str_alloc("")
      endif
      deallocate(f%next_chars)
      f%next_chars => temp
    else
      string = get_char_from_file(f, fb%xml_version, eof, es)
    endif

  end function get_character

  function get_all_characters(fb, es) result(s)
    type(file_buffer_t), intent(inout) :: fb
    type(error_stack), intent(inout) :: es
    character, pointer :: s(:)

    logical :: eof
    character :: c
    character, pointer :: temp(:)

    eof = .false.
    s => vs_str_alloc("")
    do while (.not.eof)
      c = get_character(fb, eof, es)
      if (eof.or.in_error(es)) return
      temp => vs_str_alloc(str_vs(s)//c)
      deallocate(s)
      s => temp
    enddo
  end function get_all_characters

  function line(fb) result(n)
    type(file_buffer_t), intent(in) :: fb
    integer :: n

    n = fb%f(1)%line
  end function line

  function column(fb) result(n)
    type(file_buffer_t), intent(in) :: fb
    integer :: n

    n = fb%f(1)%col
  end function column

  subroutine parse_xml_declaration(fb, xv, enc, sa, es)
    type(file_buffer_t), intent(inout) :: fb
    integer, intent(out) :: xv
    character, pointer :: enc(:)
    logical, intent(out) :: sa
    type(error_stack), intent(inout) :: es

    logical :: eof

    call parse_declaration(fb%f(1), eof, es, sa)
    if (eof.or.in_error(es)) then
      call add_error(es, "Error parsing XML declaration")
    else
      fb%xml_version = fb%f(1)%xml_version
      xv = fb%xml_version
      enc => vs_vs_alloc(fb%f(1)%encoding)
    endif
  end subroutine parse_xml_declaration

  subroutine parse_text_declaration(fb, es)
    type(file_buffer_t), intent(inout) :: fb
    type(error_stack), intent(inout) :: es

    logical :: eof
    integer :: xv

    xv = fb%f(size(fb%f))%xml_version

    call parse_declaration(fb%f(1), eof, es)
    if (in_error(es)) then
      call add_error(es, "Error parsing text declaration")
      return
    elseif (xv==XML1_0.and.fb%f(1)%xml_version/=XML1_0) then
      call add_error(es, "XML 1.0 document cannot reference entities with higher version numbers")
      return
    endif

  end subroutine parse_text_declaration


  function reading_main_file(fb) result(p)
    type(file_buffer_t), intent(in) :: fb
    logical :: p

    p = (size(fb%f)==1)
  end function reading_main_file

 function reading_first_entity(fb) result(p)
    type(file_buffer_t), intent(in) :: fb
    logical :: p

    p = (size(fb%f)==2)
  end function reading_first_entity
#endif

end module m_sax_reader

module m_sax_tokenizer

#ifndef DUMMYLIB
  use fox_m_fsys_array_str, only: vs_str, str_vs, vs_str_alloc
  use m_common_charset, only: XML_WHITESPACE, &
    upperCase, isInitialNameChar
  use m_common_error, only: add_error, in_error
  use m_common_entities, only: entity_t, existing_entity, &
    expand_entity_text, expand_char_entity, &
    add_internal_entity, pop_entity_list, getEntityByName
  use m_common_namecheck, only: checkName, checkCharacterEntityReference

  use m_sax_reader, only: file_buffer_t, open_new_file, pop_buffer_stack, &
    push_chars, get_character, get_all_characters, &
    parse_text_declaration
  use m_sax_types ! everything, really

  implicit none
  private

  public :: sax_tokenize
  public :: normalize_attribute_text
  public :: expand_pe_text

contains

  subroutine sax_tokenize(fx, fb, eof)
    type(sax_parser_t), intent(inout) :: fx
    type(file_buffer_t), intent(inout) :: fb
    logical, intent(out) :: eof

    character :: c, q
    integer :: xv, phrase
    logical :: firstChar, ws_discard
    character, pointer :: tempString(:)

    xv = fx%xds%xml_version

    if (associated(fx%token)) deallocate(fx%token)
    fx%token => vs_str_alloc("")
    if (fx%nextTokenType/=TOK_NULL) then
      eof = .false.
      fx%tokenType = fx%nextTokenType
      fx%nextTokenType = TOK_NULL
      return
    endif
    fx%tokentype = TOK_NULL

    q = " "
    phrase = 0
    firstChar = .true.
    do
      c = get_character(fb, eof, fx%error_stack)
      if (eof) then
        if (fx%state==ST_CHAR_IN_CONTENT) then
          if (phrase==1) then
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(fx%token)//"]")
            deallocate(tempString)
          elseif (phrase==2) then
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(fx%token)//"]]")
            deallocate(tempString)
          endif
          fx%tokenType = TOK_CHAR
        endif
        if (fx%tokenType/=TOK_NULL) then
          ! make sure we pass back this token before eof'ing
          eof = .false.
          return
        endif
      endif
      if (eof.or.in_error(fx%error_stack)) return
      if (fx%inIntSubset) then
        tempString => fx%xds%intSubset
        fx%xds%intSubset => vs_str_alloc(str_vs(tempString)//c)
        deallocate(tempString)
      endif

      select case (fx%state)
      case (ST_MISC)
        if (firstChar) ws_discard = .true.
        if (ws_discard) then
          if (verify(c, XML_WHITESPACE)>0) then
            if (c=="<") then
              ws_discard = .false.
            else
              call add_error(fx%error_stack, "Unexpected character found outside content")
            endif
          endif
        else
          if (c=="?") then
            fx%tokenType = TOK_PI_TAG
          elseif (c=="!") then
            fx%tokenType = TOK_BANG_TAG
          elseif (isInitialNameChar(c, xv)) then
            call push_chars(fb, c)
            fx%tokenType = TOK_OPEN_TAG
          else
            call add_error(fx%error_stack, "Unexpected character after <")
          endif
        endif

      case (ST_BANG_TAG)
        if (firstChar) then
          if (c=="-") then
            phrase = 1
          elseif (c=="[") then
            fx%tokenType = TOK_OPEN_SB
          elseif (verify(c,upperCase)==0) then
            deallocate(fx%token)
            fx%token => vs_str_alloc(c)
          else
            call add_error(fx%error_stack, "Unexpected character after <!")
          endif
        elseif (phrase==1) then
          if (c=="-") then
            fx%tokenType = TOK_OPEN_COMMENT
          else
            call add_error(fx%error_stack, "Unexpected character after <!-")
          endif
        elseif (verify(c,XML_WHITESPACE)>0) then
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
        else
          call push_chars(fb, c)
          fx%tokenType = TOK_NAME
        endif

      case (ST_START_PI)
        ! grab until whitespace or ?
        if (verify(c, XML_WHITESPACE//"?")>0) then
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
        else
          fx%tokenType = TOK_NAME
          if (c=="?") call push_chars(fb, c)
        endif

      case (ST_PI_CONTENTS)
        if (firstChar) ws_discard = .true.
        if (ws_discard) then
          if (verify(c, XML_WHITESPACE)/=0) then
            ws_discard = .false.
          else
            cycle
          endif
        endif
        if (phrase==1) then
          if (c==">") then
            fx%tokenType = TOK_CHAR
            fx%nextTokenType = TOK_PI_END
          elseif (c=="?") then
            ! The last ? didn't mean anything, but this one might.
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//"?")
            deallocate(tempString)
          else
            phrase = 0
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//"?"//c)
            deallocate(tempString)
          endif
        elseif (c=="?") then
          phrase = 1
        else
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
        endif

      case (ST_START_COMMENT)
        select case(phrase)
        case (0)
          if (c=="-") then
            phrase = 1
          else
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
          endif
        case (1)
          if (c=="-") then
            phrase = 2
          else
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//"-"//c)
          deallocate(tempString)
            phrase = 0
          endif
        case (2)
          if (c==">") then
            fx%tokenType = TOK_CHAR
            fx%nextTokenType = TOK_COMMENT_END
            exit
          else
            call add_error(fx%error_stack, &
              "Expecting > after -- inside a comment.")
          endif
        end select

      case (ST_START_TAG)
        ! grab until whitespace or /, >
        if (verify(c, XML_WHITESPACE//"/>")>0) then
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
        else
          fx%tokenType = TOK_NAME
          if (c==">") then
            fx%nextTokenType = TOK_END_TAG
          else
            call push_chars(fb, c)
          endif
        endif

      case (ST_START_CDATA_DECLARATION)
        if (firstChar) then
          if (verify(c, XML_WHITESPACE)==0) then
            call add_error(fx%error_stack, &
              "Whitespace not allowed around CDATA in section declaration")
          else
            deallocate(fx%token)
            fx%token => vs_str_alloc(c)
            ws_discard = .false.
          endif
        else
          if (verify(c, XML_WHITESPACE)==0) then
            call add_error(fx%error_stack, &
              "Whitespace not allowed around CDATA in section declaration")
          elseif (c=="[") then
            fx%tokenType = TOK_NAME
            if (c=="[") fx%nextTokenType = TOK_OPEN_SB
          else
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//c)
            deallocate(tempString)
          endif
        endif


      case (ST_CDATA_CONTENTS)
        select case(phrase)
        case (0)
          if (c=="]") then
            phrase = 1
          else
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//c)
            deallocate(tempString)
          endif
        case (1)
          if (c=="]") then
            phrase = 2
          else
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//"]"//c)
            deallocate(tempString)
            phrase = 0
          endif
        case (2)
          if (c==">") then
            fx%tokenType = TOK_CHAR
            fx%nextTokenType = TOK_SECTION_END
          elseif (c=="]") then
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//"]")
            deallocate(tempString)
          else
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//"]]"//c)
            deallocate(tempString)
            phrase = 0
          endif
        end select

      case (ST_IN_TAG)
        if (firstChar) then
          if (verify(c,XML_WHITESPACE//"/>")>0) then
            call add_error(fx%error_stack, &
              "Whitespace required inside tag")
            exit
          endif
          ws_discard = .true.
        endif
        if (ws_discard) then
          if (verify(c,XML_WHITESPACE)>0) then
            if (c==">") then
              fx%tokenType = TOK_END_TAG
            elseif (c=="/") then
              phrase = 1
              ws_discard = .false.
            else
              deallocate(fx%token)
              fx%token => vs_str_alloc(c)
              ws_discard = .false.
            endif
          endif
        else
          if (phrase==1) then
            if (c==">") then
              fx%tokenType = TOK_END_TAG_CLOSE
            else
              call add_error(fx%error_stack, &
                "Unexpected character after / in element tag")
              exit
            endif
          else
            if (verify(c,XML_WHITESPACE//"=/>")==0) then
              fx%tokenType = TOK_NAME
              if (c=="=") then
                fx%nextTokenType = TOK_EQUALS
              elseif (c==">") then
                fx%nextTokenType = TOK_END_TAG
              else
                call push_chars(fb, c)
              endif
            else
              tempString => fx%token
              fx%token => vs_str_alloc(str_vs(tempString)//c)
              deallocate(tempString)
            endif
          endif
        endif

      case (ST_ATT_NAME)
        if (firstChar) ws_discard = .true.
        if (ws_discard) then
          if (verify(c,XML_WHITESPACE)>0) then
            if (c=="=") then
              fx%tokenType = TOK_EQUALS
            else
              call add_error(fx%error_stack, &
                "Unexpected character in element tag, expected =")
            endif
          endif
        endif

      case (ST_ATT_EQUALS)
        if (firstChar) ws_discard = .true.
        if (ws_discard) then
          if (verify(c,XML_WHITESPACE)>0) then
            if (verify(c,"'""")==0) then
              q = c
              ws_discard = .false.
            else
              call add_error(fx%error_stack, "Expecting "" or '")
            endif
          endif
        else
          if (c==q) then
            fx%tokenType = TOK_CHAR
          else
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//c)
            deallocate(tempString)
          endif
        endif

      case (ST_CHAR_IN_CONTENT)
        if (c=="<".or.c=="&") then
          if (phrase==1) then
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//"]")
            deallocate(tempString)
          elseif (phrase==2) then
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//"]]")
            deallocate(tempString)
          endif
          fx%tokenType = TOK_CHAR
          if (c=="<") then
            call push_chars(fb, c)
          elseif (c=="&") then
            fx%nextTokenType = TOK_ENTITY
          endif
        elseif (c=="]") then
          if (phrase==0) then
            phrase = 1
          elseif (phrase==1) then
            phrase = 2
          else
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//"]")
            deallocate(tempString)
          endif
        elseif (c==">") then
          if (phrase==1) then
            phrase = 0
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//"]>")
            deallocate(tempString)
          elseif (phrase==2) then
            call add_error(fx%error_stack, "]]> forbidden in character context")
          else
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//">")
            deallocate(tempString)
          endif
        elseif (phrase==1) then
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//"]"//c)
          deallocate(tempString)
        elseif (phrase==2) then
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//"]]"//c)
          deallocate(tempString)
        else
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
        endif

      case (ST_TAG_IN_CONTENT)
        if (phrase==0) then
          if (c=="<") then
            phrase = 1
            ws_discard = .false.
          elseif (c=="&") then
            fx%tokenType = TOK_ENTITY
          else
            call add_error(fx%error_stack, "Unexpected character found in content")
          endif
        elseif (phrase==1) then
          if (c=="?") then
            fx%tokenType = TOK_PI_TAG
          elseif (c=="!") then
            fx%tokenType = TOK_BANG_TAG
          elseif (c=="/") then
            fx%tokenType = TOK_CLOSE_TAG
          elseif (isInitialNameChar(c, xv)) then
            call push_chars(fb, c)
            fx%tokenType = TOK_OPEN_TAG
          else
            call add_error(fx%error_stack, "Unexpected character after <")
          endif
        endif

      case (ST_START_ENTITY)
        if (verify(c,XML_WHITESPACE//";")>0) then
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
        elseif (c==";") then
          fx%tokenType = TOK_NAME
        else
          call add_error(fx%error_stack, "Entity reference must be terminated with a ;")
        endif

      case (ST_CLOSING_TAG)
        if (verify(c,XML_WHITESPACE//">")>0) then
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
        else
          fx%tokenType = TOK_NAME
          if (c==">") fx%nextTokenType = TOK_END_TAG
        endif

      case (ST_IN_CLOSING_TAG)
        if (verify(c, XML_WHITESPACE)>0) then
          if (c==">") then
            fx%tokenType = TOK_END_TAG
          else
            call add_error(fx%error_stack, "Unexpected character - expecting >")
          endif
        endif

      case (ST_IN_DOCTYPE, ST_DOC_NAME, ST_DOC_SYSTEM, ST_DOC_PUBLIC, &
        ST_DOC_DECL, ST_CLOSE_DOCTYPE)
        if (firstChar) then
          if (verify(c, XML_WHITESPACE)>0) then
            if (c==">") then
              fx%tokenType = TOK_END_TAG
            elseif (c=="[") then
              fx%tokenType = TOK_OPEN_SB
            else
              call add_error(fx%error_stack, &
                "Missing whitespace in doctype delcaration.")
            endif
          else
            ws_discard = .true.
          endif
        endif
        if (ws_discard) then
          if (verify(c, XML_WHITESPACE)>0) then
            if (verify(c, "'""")==0) then
              q = c
              deallocate(fx%token)
              fx%token => vs_str_alloc("")
              ws_discard = .false.
            elseif (c=="[") then
              fx%tokenType = TOK_OPEN_SB
            elseif (c==">") then
              fx%tokenType = TOK_END_TAG
            else
              deallocate(fx%token)
              fx%token => vs_str_alloc(c)
              ws_discard = .false.
            endif
          endif
        else
          if (q/=" ".and.c==q) then
            fx%tokenType = TOK_CHAR
          elseif (q==" ".and.verify(c, XML_WHITESPACE)==0) then
            call push_chars(fb, c)
            fx%tokenType = TOK_NAME
          else
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//c)
            deallocate(tempString)
          endif
        endif

      case (ST_IN_SUBSET)
        call tokenizeDTD

      case (ST_START_PE)
        if (verify(c,XML_WHITESPACE//";")>0) then
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
        elseif (c==";") then
          fx%tokenType = TOK_NAME
        else
          call add_error(fx%error_stack, "Entity reference must be terminated with a ;")
        endif

      end select
      
      firstChar = .false.
      if (fx%tokenType/=TOK_NULL) exit
    enddo

  contains

    subroutine tokenizeDTD

      if (c=="%") then
        if (fx%state_dtd==ST_DTD_START_COMMENT &
          .or.fx%state_dtd==ST_DTD_START_PI &
          .or.fx%state_dtd==ST_DTD_PI_CONTENTS &
          .or.fx%state_dtd==ST_DTD_ENTITY &
          .or.fx%state_dtd==ST_DTD_NOTATION_SYSTEM &
          .or.fx%state_dtd==ST_DTD_NOTATION_PUBLIC &
          .or.fx%state_dtd==ST_DTD_NOTATION_PUBLIC_2 &
          .or.fx%state_dtd==ST_DTD_ENTITY_PUBLIC &
          .or.fx%state_dtd==ST_DTD_ENTITY_SYSTEM) then
          ! % is perfectly legitimate
          continue
        elseif (fx%state_dtd==ST_DTD_SUBSET) then
          if (.not.fx%spaceBeforeEntity) then
            fx%spaceBeforeEntity = .true.
            call push_chars(fb, c)
            c = " "
          else
            fx%spaceBeforeEntity = .false.
            fx%tokenType = TOK_ENTITY
            return
          endif
        elseif (fx%state_dtd==ST_DTD_ATTLIST_CONTENTS &
          .and. q/="") then
            ! We are inside a ATTLIST attvalue, so apparent PErefs arent.
            continue
        elseif (fx%inIntSubset) then
          call add_error(fx%error_stack, &
            "Parameter entity reference not permitted inside markup for internal subset")
          return
        elseif (fx%state_dtd==ST_DTD_ATTLIST_CONTENTS &
          .or.fx%state_dtd==ST_DTD_ELEMENT_CONTENTS) then
          if (.not.associated(fx%content)) then
            ! content will not always be empty here;
            ! if we have two PErefs bang next to each other.
            fx%content => fx%token
            fx%token => vs_str_alloc("")
          endif
          fx%tokenType = TOK_ENTITY
          return
        elseif (fx%state_dtd==ST_DTD_ENTITY_ID) then
          ! % is ok if we are in the external subset
          continue
        else
          if (.not.fx%spaceBeforeEntity) then
            fx%spaceBeforeEntity = .true.
            call push_chars(fb, c)
            c = " "
          else
            fx%spaceBeforeEntity = .false.
            fx%tokenType = TOK_ENTITY
            return
          endif
        endif
      endif

      select case(fx%state_dtd)

      case (ST_DTD_SUBSET)
        if (firstChar) ws_discard = .true.
        if (ws_discard) then
          if (verify(c, XML_WHITESPACE)>0) then
            if (c=="]") then
              phrase = 1
              q = c
              ws_discard = .false.
            elseif (c=="<") then
              phrase = 1
              q = c
              ws_discard = .false.
            else
              call add_error(fx%error_stack, "Unexpected character found in document subset")
            endif
          endif
        elseif (phrase==1) then
          if (q=="<") then
            if (c=="?") then
              fx%tokenType = TOK_PI_TAG
            elseif (c=="!") then
              fx%tokenType = TOK_BANG_TAG
            else
              call add_error(fx%error_stack, "Unexpected character, expecting ! or ?")
            endif
          elseif (q=="]") then
            if (c=="]") then
              phrase = 2
            else
              fx%tokenType = TOK_CLOSE_SB
              call push_chars(fb, c)
              if (fx%inIntSubset) then
                tempString => fx%xds%intSubset
                allocate(fx%xds%intSubset(size(tempString)-2))
                fx%xds%intSubset = tempString(:size(tempString)-2)
                deallocate(tempString)
              endif
            endif
          endif
        elseif (phrase==2) then
          if (c==">") then
            fx%tokenType = TOK_SECTION_END
          else
            call add_error(fx%error_stack, "Unexpected character, expecting >")
          endif
        endif


      case (ST_DTD_BANG_TAG)
        if (firstChar) then
          if (c=="-") then
            phrase = 1
          elseif (c=="[") then
            fx%tokenType = TOK_OPEN_SB
          elseif (verify(c,upperCase)==0) then
            deallocate(fx%token)
            fx%token => vs_str_alloc(c)
          else
            call add_error(fx%error_stack, "Unexpected character after <!")
          endif
        elseif (phrase==1) then
          if (c=="-") then
            fx%tokenType = TOK_OPEN_COMMENT
          else
            call add_error(fx%error_stack, "Unexpected character after <!-")
          endif
        elseif (verify(c,XML_WHITESPACE)>0) then
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
        else
          call push_chars(fb, c)
          fx%tokenType = TOK_NAME
        endif


      case (ST_DTD_START_SECTION_DECL)
        if (firstChar) then
          ws_discard = .true.
        endif
        if (ws_discard) then
          if (verify(c, XML_WHITESPACE)/=0) then
            deallocate(fx%token)
            fx%token => vs_str_alloc(c)
            ws_discard = .false.
          endif
        else
          if (verify(c, XML_WHITESPACE//"[")>0) then
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//c)
            deallocate(tempString)
          else
            fx%tokenType = TOK_NAME
            if (c=="[") fx%nextTokenType = TOK_OPEN_SB
          endif
        endif

      case (ST_DTD_FINISH_SECTION_DECL)
        if (verify(c, XML_WHITESPACE)>0) then
          if (c/="[") then
            call add_error(fx%error_stack, &
              "Unexpected token found, expecting [")
          else
            fx%tokenType = TOK_OPEN_SB
          endif
        endif

      case (ST_DTD_IN_IGNORE_SECTION)
        select case(phrase)
        case (0)
          if (c=="<".or.c=="]") then
            phrase = 1
            q = c
          endif
        case (1)
          if ((q=="<".and.c=="!").or.(q=="]".and.c=="]")) then
            phrase = 2
          else
            phrase = 0
          endif
        case (2)
          if (q=="<".and.c=="[") then
            fx%tokenType = TOK_SECTION_START
          elseif (q=="]".and.c==">") then
            fx%tokenType = TOK_SECTION_END
          else
            phrase = 0
          endif
        end select


      case (ST_DTD_START_PI)
        ! grab until whitespace or ?
        if (verify(c, XML_WHITESPACE//"?")>0) then
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
        else
          fx%tokenType = TOK_NAME
          if (c=="?") call push_chars(fb, c)
        endif

      case (ST_DTD_PI_CONTENTS)
        if (firstChar) ws_discard = .true.
        if (ws_discard) then
          if (verify(c, XML_WHITESPACE)/=0) then
            ws_discard = .false.
          else
            return
          endif
        endif
        if (phrase==1) then
          if (c==">") then
            fx%tokenType = TOK_CHAR
            fx%nextTokenType = TOK_PI_END
          elseif (c=="?") then
            ! The last ? didn't mean anything, but this one might.
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//"?")
            deallocate(tempString)
          else
            phrase = 0
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//"?"//c)
            deallocate(tempString)
          endif
        elseif (c=="?") then
          phrase = 1
        else
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
        endif

      case (ST_DTD_START_COMMENT)
        select case(phrase)
        case (0)
          if (c=="-") then
            phrase = 1
          else
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
          endif
        case (1)
          if (c=="-") then
            phrase = 2
          else
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//"-"//c)
          deallocate(tempString)
            phrase = 0
          endif
        case (2)
          if (c==">") then
            fx%tokenType = TOK_CHAR
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//c)
            deallocate(tempString)
            fx%nextTokenType = TOK_COMMENT_END
          else
            call add_error(fx%error_stack, &
              "Expecting > after -- inside a comment.")
          endif
        end select

      case (ST_DTD_ATTLIST, ST_DTD_ELEMENT, ST_DTD_ENTITY, &
        ST_DTD_ENTITY_PE, ST_DTD_NOTATION)
        if (firstChar) ws_discard = .true.
        if (ws_discard) then
          if (verify(c,XML_WHITESPACE)>0) then
            deallocate(fx%token)
            fx%token => vs_str_alloc(c)
            ws_discard = .false.
          endif
        elseif (verify(c,XML_WHITESPACE//">")>0) then
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
        else
          if (c==">") then
            fx%nextTokenType = TOK_END_TAG
          else
            call push_chars(fb, c)
          endif
          fx%tokenType = TOK_NAME
        endif
        
      case (ST_DTD_ELEMENT_CONTENTS)
        if (c==">") then
          if (associated(fx%content)) then
            deallocate(fx%token)
            fx%token => fx%content
            fx%content => null()
          endif
          fx%tokenType = TOK_DTD_CONTENTS
          fx%nextTokenType = TOK_END_TAG
        else
          if (associated(fx%content)) then
            deallocate(fx%token)
            fx%token => vs_str_alloc(str_vs(fx%content)//c)
            deallocate(fx%content)
          else
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//c)
            deallocate(tempString)
          endif
          if (c=="(") then
            fx%tokenType = TOK_OPEN_PAR
            fx%content => fx%token
            fx%token => vs_str_alloc("")
          elseif (c==")") then
            fx%tokenType = TOK_CLOSE_PAR
            fx%content => fx%token
            fx%token => vs_str_alloc("")
          endif
        endif

      case (ST_DTD_ATTLIST_CONTENTS)
        if (c==">") then
          fx%tokenType = TOK_DTD_CONTENTS
          fx%nextTokenType = TOK_END_TAG
        elseif (associated(fx%content)) then
          deallocate(fx%token)
          fx%token => vs_str_alloc(str_vs(fx%content)//c)
          deallocate(fx%content)
        else
          tempString => fx%token
          fx%token => vs_str_alloc(str_vs(tempString)//c)
          deallocate(tempString)
        endif
        if (c=="'".or.c=="""") then
          if (q==c) then
            q = ""
          else
            q = c
          endif
        endif

      case (ST_DTD_ENTITY_ID, ST_DTD_ENTITY_PUBLIC, ST_DTD_ENTITY_SYSTEM, &
        ST_DTD_ENTITY_NDATA, ST_DTD_ENTITY_END, ST_DTD_ENTITY_NDATA_VALUE, &
        ST_DTD_NOTATION_ID, ST_DTD_NOTATION_SYSTEM, ST_DTD_NOTATION_PUBLIC, &
        ST_DTD_NOTATION_PUBLIC_2, ST_DTD_NOTATION_END)
        if (firstChar) then
          if (verify(c, XML_WHITESPACE)>0) then
            if (c==">") then
              fx%tokenType = TOK_END_TAG
            else
              call add_error(fx%error_stack, "Missing whitespace in DTD.")
            endif
          else
            ws_discard = .true.
          endif
        elseif (ws_discard) then
          if (verify(c, XML_WHITESPACE)>0) then
            if (verify(c, "'""")==0) then
              q = c
              deallocate(fx%token)
              fx%token => vs_str_alloc("")
              ws_discard = .false.
            elseif (c==">") then
              fx%tokenType = TOK_END_TAG
            else
              deallocate(fx%token)
              fx%token => vs_str_alloc(c)
              ws_discard = .false.
            endif
          endif
        else
          if (q/=" ".and.c==q) then
            fx%tokenType = TOK_CHAR
          elseif (q==" ".and.verify(c, XML_WHITESPACE//">")==0) then
            fx%tokenType = TOK_NAME
            if (c==">") then
              fx%nextTokenType = TOK_END_TAG
            else
              call push_chars(fb, c)
            endif
          else
            tempString => fx%token
            fx%token => vs_str_alloc(str_vs(tempString)//c)
            deallocate(tempString)
          endif
        endif

      end select
    end subroutine tokenizeDTD

  end subroutine sax_tokenize


  recursive function normalize_attribute_text(fx, s_in) result(s_out)
    type(sax_parser_t), intent(inout) :: fx
    character, dimension(:), intent(in) :: s_in
    character, dimension(:), pointer :: s_out

    character, dimension(:), pointer :: s_temp, s_temp2, s_ent, tempString
    character :: dummy
    integer :: i, i2, j
    type(entity_t), pointer :: ent

    ! Condense all whitespace, only if we are validating,
    ! Expand all &
    ! Complain about < and &

    allocate(s_temp(size(s_in))) ! in the first instance
    allocate(s_out(0)) ! in case we return early ...
    s_ent => null()
    tempString => null()

    i2 = 1
    i = 1
    do 
      if (i > size(s_in)) exit
      ! Firstly, all whitespace must become 0x20
      if (verify(s_in(i),XML_WHITESPACE)==0) then
        s_temp(i2) = " "
        ! Then, < is always illegal
        i = i + 1
        i2 = i2 + 1
      elseif (s_in(i)=='<') then
        call add_error(fx%error_stack, "Illegal < found in attribute.")
        goto 100
        ! Then, expand <
      elseif (s_in(i)=='&') then
        j = index(str_vs(s_in(i+1:)), ';')
        if (j==0) then
          call add_error(fx%error_stack, "Illegal & found in attribute")
          goto 100
        elseif (j==1) then
          call add_error(fx%error_stack, "No entity reference found")
          goto 100
        endif
        allocate(tempString(j-1))
        tempString = s_in(i+1:i+j-1)
        if (existing_entity(fx%predefined_e_list, str_vs(tempString))) then
          ! Expand immediately
          s_temp(i2) = expand_entity_text(fx%predefined_e_list, str_vs(tempString))
          i = i + j + 1
          i2 = i2 + 1
        elseif (checkCharacterEntityReference(str_vs(tempString), fx%xds%xml_version)) then
          ! Expand all character entities
          s_temp(i2) = expand_char_entity(str_vs(tempString))
          i = i + j  + 1
          i2 = i2 + 1 ! fixme
        elseif (checkName(str_vs(tempString), fx%xds%xml_version)) then
          ent => getEntityByName(fx%forbidden_ge_list, str_vs(tempString))
          if (associated(ent)) then
            call add_error(fx%error_stack, 'Recursive entity expansion')
            goto 100
          else
            ent => getEntityByName(fx%xds%entityList, str_vs(tempString))
          endif
          if (associated(ent)) then
            if (ent%wfc.and.fx%xds%standalone) then
              call add_error(fx%error_stack, 'Externally declared entity referenced in standalone document')
              goto 100
            endif
            !is it the right sort of entity?
            if (ent%external) then
              call add_error(fx%error_stack, "External entity forbidden in attribute")
              goto 100
            endif
            call add_internal_entity(fx%forbidden_ge_list, str_vs(tempString), "", null(), .false.)
            ! Recursively expand entity, checking for errors.
            s_ent => normalize_attribute_text(fx, &
              vs_str(expand_entity_text(fx%xds%entityList, str_vs(tempString))))
            dummy = pop_entity_list(fx%forbidden_ge_list)
            if (in_error(fx%error_stack)) then
              goto 100
            endif
            allocate(s_temp2(size(s_temp)+size(s_ent)-j))
            s_temp2(:i2-1) = s_temp(:i2-1)
            s_temp2(i2:i2+size(s_ent)-1) = s_ent
            deallocate(s_temp)
            s_temp => s_temp2
            nullify(s_temp2)
            i = i + j + 1
            i2 = i2 + size(s_ent)
            deallocate(s_ent)
          else
            s_temp(i2:i2+j) = s_in(i:i+j)
            i = i + j + 1
            i2 = i2 + j + 1
            if (.not.fx%skippedExternal.or.fx%xds%standalone) then
              call add_error(fx%error_stack, "Undeclared entity encountered in standalone document.")
              goto 100
            endif
          endif
        else
          call add_error(fx%error_stack, "Illegal entity reference")
          goto 100
        endif
        deallocate(tempString)
      else
        s_temp(i2) = s_in(i)
        i = i + 1
        i2 = i2 + 1
      endif
    enddo

    deallocate(s_out)
    allocate(s_out(i2-1))
    s_out = s_temp(:i2-1)
100 deallocate(s_temp)
    if (associated(s_ent))  deallocate(s_ent)
    if (associated(tempString)) deallocate(tempString)

  end function normalize_attribute_text

  recursive function expand_pe_text(fx, s_in, fb) result(s_out)
    type(sax_parser_t), intent(inout) :: fx
    character, dimension(:), intent(in) :: s_in
    type(file_buffer_t), intent(inout) :: fb
    character, dimension(:), pointer :: s_out

    character, dimension(:), pointer :: s_temp, s_temp2, s_ent, tempString
    character :: dummy
    integer :: i, i2, j, iostat
    type(entity_t), pointer :: ent

    ! Expand all %PE;

    allocate(s_temp(size(s_in))) ! in the first instance
    allocate(s_out(0)) ! in case we return early ...
    s_ent => null()
    tempString => null()
    s_temp2 => null()

    i2 = 1
    i = 1
    do while (i <= size(s_in))
      if (s_in(i)=='%') then
        j = index(str_vs(s_in(i+1:)), ';')
        if (j==0) then
          call add_error(fx%error_stack, "Illegal % found in attribute")
          goto 100
        elseif (j==1) then
          call add_error(fx%error_stack, "No entity reference found")
          goto 100
        endif
        allocate(tempString(j-1))
        tempString = s_in(i+1:i+j-1)
        if (checkName(str_vs(tempString), fx%xds%xml_version)) then
          ent => getEntityByName(fx%forbidden_pe_list, str_vs(tempString))
          if (associated(ent)) then
            call add_error(fx%error_stack, 'Recursive entity expansion')
            goto 100
          endif
          ent => getEntityByName(fx%xds%peList, str_vs(tempString))
          if (associated(ent)) then
            if (ent%wfc.and.fx%xds%standalone) then
              call add_error(fx%error_stack, &
                "Externally declared entity used in standalone document")
              goto 100
            elseif (str_vs(ent%notation)/="") then
              call add_error(fx%error_stack, "Unparsed entity reference forbidden in entity value")
              goto 100
            endif
            call add_internal_entity(fx%forbidden_pe_list, str_vs(tempString), "", null(), .false.)
            ! Recursively expand entity, checking for errors.
            if (ent%external) then
              call open_new_file(fb, ent%baseURI, iostat)
              if (iostat/=0) then
                call add_error(fx%error_stack, "Unable to access external parameter entity")
                goto 100
              endif
              call parse_text_declaration(fb, fx%error_stack)
              if (in_error(fx%error_stack)) goto 100
              s_temp2 => get_all_characters(fb, fx%error_stack)
              call pop_buffer_stack(fb)
              if (in_error(fx%error_stack)) goto 100
              s_ent => expand_pe_text(fx, s_temp2, fb)
              deallocate(s_temp2)
            else
              s_ent => expand_pe_text(fx, &
                vs_str(expand_entity_text(fx%xds%peList, str_vs(tempString))), fb)
            endif
            dummy = pop_entity_list(fx%forbidden_pe_list)
            if (in_error(fx%error_stack)) then
              goto 100
            endif
            allocate(s_temp2(size(s_temp)+size(s_ent)-j))
            s_temp2(:i2-1) = s_temp(:i2-1)
            s_temp2(i2:i2+size(s_ent)-1) = s_ent
            deallocate(s_temp)
            s_temp => s_temp2
            s_temp2 => null()
            i = i + j + 1
            i2 = i2 + size(s_ent)
            deallocate(s_ent)
          else
            s_temp(i2:i2+j) = s_in(i:i+j)
            i = i + j + 1
            i2 = i2 + j + 1
            if (.not.fx%skippedExternal.or.fx%xds%standalone) then
              call add_error(fx%error_stack, "Reference to undeclared parameter entity encountered in standalone document.")
              goto 100
            endif
          endif
        else
          call add_error(fx%error_stack, "Illegal parameter entity reference")
          goto 100
        endif
        deallocate(tempString)
      else
        s_temp(i2) = s_in(i)
        i = i + 1
        i2 = i2 + 1
      endif
    enddo

    deallocate(s_out)
    allocate(s_out(i2-1))
    s_out = s_temp(:i2-1)
100 deallocate(s_temp)
    if (associated(s_temp2))  deallocate(s_temp2)
    if (associated(s_ent))  deallocate(s_ent)
    if (associated(tempString)) deallocate(tempString)

  end function expand_pe_text
#endif

end module m_sax_tokenizer

module m_common_element

#ifndef DUMMYLIB
  ! Structure and manipulation of element specification

  use fox_m_fsys_array_str, only: str_vs, vs_str_alloc, vs_vs_alloc
  use fox_m_fsys_string_list, only: string_list, init_string_list, &
    destroy_string_list, add_string, tokenize_to_string_list, &
    registered_string
  use m_common_charset, only: isInitialNameChar, isNameChar, &
    upperCase, XML_WHITESPACE
  use m_common_content_model, only: content_particle_t, newCP, destroyCPtree, &
    OP_MIXED, OP_CHOICE, OP_SEQ, OP_NAME, &
    REP_QUESTION_MARK, REP_ASTERISK, &
    transformCPPlus ! , dumpCPtree ! For debugging - see below.
  use m_common_error, only: error_stack, add_error, in_error
  use m_common_namecheck, only: checkName, checkNames, checkNCName, &
    checkNCNames, checkQName, checkNmtoken, checkNmtokens

  implicit none
  private

  integer, parameter :: ST_START               = 0
  integer, parameter :: ST_EMPTYANY            = 1
  integer, parameter :: ST_FIRSTCHILD          = 2
  integer, parameter :: ST_END                 = 3
  integer, parameter :: ST_PCDATA              = 4
  integer, parameter :: ST_NAME                = 5
  integer, parameter :: ST_CHILD               = 6
  integer, parameter :: ST_AFTERBRACKET        = 7
  integer, parameter :: ST_AFTERLASTBRACKET    = 8
  integer, parameter :: ST_SEPARATOR           = 9
  integer, parameter :: ST_AFTERNAME           = 10
  integer, parameter :: ST_ATTTYPE             = 11
  integer, parameter :: ST_AFTER_NOTATION      = 12
  integer, parameter :: ST_NOTATION_LIST       = 13
  integer, parameter :: ST_ENUMERATION         = 14
  integer, parameter :: ST_ENUM_NAME           = 15
  integer, parameter :: ST_AFTER_ATTTYPE_SPACE = 16
  integer, parameter :: ST_AFTER_ATTTYPE       = 17
  integer, parameter :: ST_DEFAULT_DECL        = 18
  integer, parameter :: ST_AFTERDEFAULTDECL    = 19
  integer, parameter :: ST_DEFAULTVALUE        = 20

  integer, parameter :: ATT_NULL = 0

  integer, parameter :: ATT_CDATA = 1
  integer, parameter :: ATT_ID = 2
  integer, parameter :: ATT_IDREF = 3
  integer, parameter :: ATT_IDREFS = 4
  integer, parameter :: ATT_ENTITY = 5
  integer, parameter :: ATT_ENTITIES = 6
  integer, parameter :: ATT_NMTOKEN = 7
  integer, parameter :: ATT_NMTOKENS = 8
  integer, parameter :: ATT_NOTATION = 9
  integer, parameter :: ATT_ENUM = 10
  integer, parameter :: ATT_CDANO = 11
  integer, parameter :: ATT_CDAMB = 12

  character(len=8), parameter :: ATT_TYPES(12) = (/ &
    "CDATA   ", &
    "ID      ", &
    "IDREF   ", &
    "IDREFS  ", &
    "ENTITY  ", &
    "ENTITIES", &
    "NMTOKEN ", &
    "NMTOKENS", &
    "NOTATION", &
    "ENUM    ", &
    "CDANO   ", &
    "CDAMB   "/)

  integer, parameter :: ATT_REQUIRED = 1
  integer, parameter :: ATT_IMPLIED = 2
  integer, parameter :: ATT_DEFAULT = 4
  integer, parameter :: ATT_FIXED = 3


  type attribute_t
    character, pointer :: name(:) => null()
    integer :: attType = ATT_NULL 
    integer :: attDefault = ATT_NULL
    type(string_list) :: enumerations
    character, pointer :: default(:) => null()
    logical :: internal = .true.
  end type attribute_t

  type attribute_list
    type(attribute_t), pointer :: list(:) => null()
  end type attribute_list

  type element_t
    character, pointer :: name(:) => null()
    logical :: empty = .false.
    logical :: any = .false.
    logical :: mixed = .false.
    logical :: id_declared = .false.
    logical :: internal = .true.
    type (content_particle_t), pointer :: cp => null()
    character, pointer :: model(:) => null()
    type(attribute_list) :: attlist
  end type element_t

  type element_list
    type(element_t), pointer :: list(:) => null()
  end type element_list


  public :: element_t
  public :: element_list

  public :: attribute_t
  public :: attribute_list

  public :: init_element_list
  public :: destroy_element_list
  public :: existing_element
  public :: declared_element
  public :: get_element
  public :: add_element

  public :: parse_dtd_element

  public :: init_attribute_list
  public :: destroy_attribute_list


  public :: parse_dtd_attlist

  public :: report_declarations

  public :: attribute_has_default
  public :: get_attlist_size
  public :: get_attribute_declaration
  public :: express_attribute_declaration

  public :: att_value_normalize

  public :: get_att_type_enum

  public :: ATT_NULL
  public :: ATT_CDATA
  public :: ATT_ID 
  public :: ATT_IDREF
  public :: ATT_IDREFS
  public :: ATT_ENTITY
  public :: ATT_ENTITIES
  public :: ATT_NMTOKEN
  public :: ATT_NMTOKENS
  public :: ATT_NOTATION
  public :: ATT_ENUM

  public :: ATT_CDANO
  public :: ATT_CDAMB

  public :: ATT_REQUIRED
  public :: ATT_IMPLIED
  public :: ATT_DEFAULT
  public :: ATT_FIXED

  public :: ATT_TYPES

  interface get_attribute_declaration
    module procedure get_attdecl_by_index
    module procedure get_attdecl_by_name
  end interface

contains

  subroutine init_element_list(e_list)
    type(element_list), intent(inout) :: e_list

    allocate(e_list%list(0))
  end subroutine init_element_list

  subroutine destroy_element_list(e_list)
    type(element_list), intent(inout) :: e_list

    integer :: i

    do i = 1, size(e_list%list)
      deallocate(e_list%list(i)%name)
      if (associated(e_list%list(i)%cp)) call destroyCPtree(e_list%list(i)%cp)
      if (associated(e_list%list(i)%model)) deallocate(e_list%list(i)%model)
      call destroy_attribute_list(e_list%list(i)%attlist)
    enddo
    deallocate(e_list%list)
  end subroutine destroy_element_list

  function existing_element(e_list, name) result(p)
    type(element_list), intent(in) :: e_list
    character(len=*), intent(in) :: name
    logical :: p

    integer :: i

    p = .false.
    do i = 1, size(e_list%list)
      if (str_vs(e_list%list(i)%name)==name) then
        p = .true.
        exit
      endif
    enddo
  end function existing_element

  function declared_element(e_list, name) result(p)
    type(element_list), intent(in) :: e_list
    character(len=*), intent(in) :: name
    logical :: p

    integer :: i

    p = .false.
    do i = 1, size(e_list%list)
      if (str_vs(e_list%list(i)%name)==name) then
        p = associated(e_list%list(i)%model)
        exit
      endif
    enddo
  end function declared_element

  function get_element(e_list, name) result(e)
    type(element_list), intent(in) :: e_list
    character(len=*), intent(in) :: name
    type(element_t), pointer :: e

    integer :: i

    do i = 1, size(e_list%list)
      if (str_vs(e_list%list(i)%name)==name) then
        e => e_list%list(i)
        return
      endif
    enddo
    e => null()
  end function get_element

  function add_element(e_list, name) result(e)
    type(element_list), intent(inout) :: e_list
    character(len=*), intent(in) :: name
    type(element_t), pointer :: e

    type(element_t), pointer :: temp(:)
    integer :: i

    temp => e_list%list

    allocate(e_list%list(size(temp)+1))
    do i = 1, size(temp)
      e_list%list(i)%name => temp(i)%name
      e_list%list(i)%model => temp(i)%model
      e_list%list(i)%empty = temp(i)%empty
      e_list%list(i)%any = temp(i)%any
      e_list%list(i)%mixed = temp(i)%mixed
      e_list%list(i)%cp => temp(i)%cp
      e_list%list(i)%id_declared = temp(i)%id_declared
      e_list%list(i)%internal = temp(i)%internal
      e_list%list(i)%attlist%list => temp(i)%attlist%list
    enddo
    deallocate(temp)
    e => e_list%list(i)
    e%name => vs_str_alloc(name)
    call init_attribute_list(e%attlist)

  end function add_element

  subroutine parse_dtd_element(contents, xv, stack, element, internal)
    character(len=*), intent(in) :: contents
    integer, intent(in) :: xv
    type(error_stack), intent(inout) :: stack
    type(element_t), pointer :: element
    logical, intent(in) :: internal

    integer :: state
    integer :: i, nbrackets
    logical :: mixed, empty, any
    character :: c
    character, pointer :: order(:), name(:), temp(:)
    type(content_particle_t), pointer :: top, current, tcp
    logical :: mixed_additional, firstChild

    ! FIXME should we check namespaces here (for element names)
    ! checking duplicates - valid or wf? - and only for MIXED?

    order => null()
    name => null()
    temp => null()

    any = .false.
    empty = .false.
    mixed = .false.
    nbrackets = 0
    mixed_additional = .false.
    firstChild = .true.
    state = ST_START

    top => null()

    do i = 1, len(contents) + 1
      if (i<=len(contents)) then
        c = contents(i:i)
      else
        c = ' '
      endif

      if (state==ST_START) then
        !write(*,*)'ST_START'
        if (verify(c, XML_WHITESPACE)==0) then
          continue
        elseif (verify(c, 'EMPTYANY')==0) then
          name => vs_str_alloc(c)
          state = ST_EMPTYANY
        elseif (c=='(') then
          order => vs_str_alloc(" ")
          nbrackets = 1
          top => newCP()
          current => top
          state = ST_FIRSTCHILD
        else
          call add_error(stack, &
            'Unexpected character "'//c//'" at start of ELEMENT specification')
          goto 100
        endif

      elseif (state==ST_EMPTYANY) then
        !write(*,*)'ST_EMPTYANY'
        if (verify(c, upperCase)==0) then
          temp => name
          name => vs_str_alloc(str_vs(temp)//c)
          deallocate(temp)
        elseif (verify(c, XML_WHITESPACE)==0) then
          if (str_vs(name)=='EMPTY') then
            empty = .true.
            top => newCP(empty=.true.)
            current => top
          elseif (str_vs(name)=='ANY') then
            any = .true.
            top => newCP(any=.true.)
            current => top
          else
            call add_error(stack, &
              'Unexpected ELEMENT specification; expecting EMPTY or ANY')
            goto 100
          endif
          deallocate(name)
          state = ST_END
        else
          call add_error(stack, &
            'Unexpected ELEMENT specification; expecting EMPTY or ANY')
          goto 100
        endif

      elseif (state==ST_FIRSTCHILD) then
        !write(*,*)'ST_FIRSTCHILD'
        if (verify(c, XML_WHITESPACE)==0) cycle
        if (c=='#') then
          mixed = .true.
          state = ST_PCDATA
          name => vs_str_alloc("")
        elseif (isInitialNameChar(c, xv)) then
          allocate(name(1))
          name(1) = c
          state = ST_NAME
        elseif (c=='(') then
          nbrackets = nbrackets + 1
          deallocate(order)
          tcp => newCP()
          current%firstChild => tcp
          tcp%parent => current
          current => tcp
          order => vs_str_alloc("  ")
          state = ST_CHILD
        else
          call add_error(stack, &
            'Unexpected character in ELEMENT specification')
          goto 100
        endif

      elseif (state==ST_PCDATA) then
        !write(*,*)'ST_PCDATA'
        if (verify(c, 'PCDATA')==0) then
          temp => name
          name => vs_str_alloc(str_vs(temp)//c)
          deallocate(temp)
        elseif (verify(c, XML_WHITESPACE)==0) then
          if (str_vs(name)=='PCDATA') then
            deallocate(name)
          else
            call add_error(stack, &
              'Unexpected token after #')
            goto 100
          endif
          ! Must be first child
          current%operator = OP_MIXED
          tcp => newCP(name="#PCDATA")
          current%firstChild => tcp
          tcp%parent => current
          current => tcp
          firstChild = .false.
          state = ST_SEPARATOR
        elseif (c==')') then
          if (str_vs(name)=='PCDATA') then
            deallocate(name)
            nbrackets = 0
            state = ST_AFTERLASTBRACKET
            deallocate(order)
          else
            call add_error(stack, &
              'Unexpected token after #')
            goto 100
          endif
          ! Must be first child
          current%operator = OP_MIXED
          tcp => newCP(name="#PCDATA")
          current%firstChild => tcp
          tcp%parent => current
          firstChild = .false.
        elseif (c=='|') then
          if (str_vs(name)=='PCDATA') then
            firstChild = .false.
            deallocate(name)
          else
            call add_error(stack, &
              'Unexpected token after #')
            goto 100
          endif
          ! Must be first child
          current%operator = OP_MIXED
          tcp => newCP(name="#PCDATA")
          current%firstChild => tcp
          tcp%parent => current
          current => tcp
          firstChild = .false.
          order(1) = '|'
          state = ST_CHILD
        elseif (c==',') then
          call add_error(stack, &
            'Ordered specification not allowed for Mixed elements')
          goto 100
        else
          call add_error(stack, &
            'Unexpected character in ELEMENT specification')
          goto 100
        endif

      elseif (state==ST_NAME) then
        !write(*,*)'ST_NAME'
        if (isNameChar(c, xv)) then
          temp => name
          name => vs_str_alloc(str_vs(temp)//c)
          deallocate(temp)
        elseif (scan(c, "?+*")>0) then
          if (mixed) then
            call add_error(stack, &
              'Repeat operators forbidden for Mixed elements')
            goto 100
          endif
          tcp => newCP(name=str_vs(name), repeat=c)
          deallocate(name)
          if (firstChild) then
            current%firstChild => tcp
            tcp%parent => current
            firstChild = .false.
          else
            current%nextSibling => tcp
            tcp%parent => current%parent
          endif
          current => tcp
          if (c=="+") call transformCPPlus(current)
          state = ST_SEPARATOR
        elseif (verify(c, XML_WHITESPACE)==0) then
          if (mixed) mixed_additional = .true.
          tcp => newCP(name=str_vs(name))
          deallocate(name)
          if (firstChild) then
            current%firstChild => tcp
            tcp%parent => current
            firstChild = .false.
          else
            current%nextSibling => tcp
            tcp%parent => current%parent
          endif
          current => tcp
          state = ST_SEPARATOR
        elseif (scan(c,',|')>0) then
          if (order(nbrackets)=='') then
            order(nbrackets)=c
          elseif (order(nbrackets)/=c) then
            call add_error(stack, &
              'Cannot mix ordered and unordered elements')
            goto 100
          endif
          if (mixed) mixed_additional = .true.
          tcp => newCP(name=str_vs(name))
          deallocate(name)
          if (firstChild) then
            current%firstChild => tcp
            tcp%parent => current
            firstChild = .false.
          else
            current%nextSibling => tcp
            tcp%parent => current%parent
          endif
          current => tcp
          if (c=="|".and.current%parent%operator/=OP_MIXED) &
            current%parent%operator = OP_CHOICE
          state = ST_CHILD
        elseif (c==')') then
          if (mixed) mixed_additional = .true.
          nbrackets = nbrackets - 1
          if (nbrackets==0) then
            state = ST_AFTERLASTBRACKET
            deallocate(order)
          else
            temp => order
            allocate(order(nbrackets))
            order = temp(:size(order))
            deallocate(temp)
            state = ST_AFTERBRACKET
          endif
          tcp => newCP(name=str_vs(name))
          deallocate(name)
          if (firstChild) then
            current%firstChild => tcp
            tcp%parent => current
            firstChild = .false.
          else
            current%nextSibling => tcp
            tcp%parent => current%parent
            current => current%parent
            if (.not.check_duplicates(current)) &
              goto 100
          endif
        else
          call add_error(stack, &
            'Unexpected character found after element name')
          goto 100
        endif

      elseif (state==ST_CHILD) then
        !write(*,*)'ST_CHILD'
        if (verify(c, XML_WHITESPACE)==0) cycle
        if (c=='#') then
          call add_error(stack, &
            '# forbidden except as first child element')
          goto 100
        elseif (isInitialNameChar(c, xv)) then
          name => vs_str_alloc(c)
          state = ST_NAME
        elseif (c=='(') then
          if (mixed) then
            call add_error(stack, &
              'Nested brackets forbidden for Mixed content')
            goto 100
          endif
          tcp => newCP()
          if (firstChild) then
            current%firstChild => tcp
            tcp%parent => current
          else
            current%nextSibling => tcp
            tcp%parent => current%parent
            firstChild = .true.
          endif
          current => tcp
          nbrackets = nbrackets + 1
          temp => order
          order => vs_str_alloc(str_vs(temp)//" ")
          deallocate(temp)
        else
          call add_error(stack, &
            'Unexpected character "'//c//'" found after (')
          goto 100
        endif

      elseif (state==ST_SEPARATOR) then
        !write(*,*)'ST_SEPARATOR'
        if (verify(c, XML_WHITESPACE)==0) cycle
        if (c=='#') then
          call add_error(stack, &
            '#PCDATA must be first in list')
          goto 100
        elseif (scan(c,'|,')>0) then
          if (order(nbrackets)=='') then
            order(nbrackets) = c
          elseif (order(nbrackets)/=c) then
            call add_error(stack, &
              'Cannot mix ordered and unordered elements')
            goto 100
          endif
          if (c=="|".and.current%parent%operator/=OP_MIXED) &
            current%parent%operator = OP_CHOICE
          state = ST_CHILD
        elseif (c==')') then
          nbrackets = nbrackets - 1
          if (nbrackets==0) then
            state = ST_AFTERLASTBRACKET
            deallocate(order)
          else
            temp => order
            allocate(order(nbrackets))
            order = temp(:size(order))
            deallocate(temp)
            state = ST_AFTERBRACKET
          endif
          current => current%parent
          if (.not.check_duplicates(current)) &
            goto 100
        else
          call add_error(stack, &
            'Unexpected character found in element declaration.')
          goto 100
        endif

      elseif (state==ST_AFTERBRACKET) then
        !write(*,*)'ST_AFTERBRACKET'
        if (c=='*') then
          current%repeater = REP_ASTERISK
          state = ST_SEPARATOR
        elseif (c=='+') then
          call transformCPPlus(current)
          state = ST_SEPARATOR
        elseif (c=='?') then
          current%repeater = REP_QUESTION_MARK
          state = ST_SEPARATOR
        elseif (verify(c, XML_WHITESPACE)==0) then
          state = ST_SEPARATOR
        elseif (scan(c,'|,')>0) then
          if (order(nbrackets)=='') then
            order(nbrackets) = c
          elseif (order(nbrackets)/=c) then
            call add_error(stack, &
              'Cannot mix ordered and unordered elements')
            goto 100
          endif
          if (c=="|".and.current%parent%operator/=OP_MIXED) &
            current%parent%operator = OP_CHOICE
          state = ST_CHILD
        elseif (c==')') then
          nbrackets = nbrackets - 1
          if (nbrackets==0) then
            deallocate(order)
            state = ST_AFTERLASTBRACKET
          else
            temp => order
            allocate(order(nbrackets))
            order = temp(:size(order))
            deallocate(temp)
            state = ST_AFTERBRACKET
          endif
          current => current%parent
          if (.not.check_duplicates(current)) &
            goto 100
        else
          call add_error(stack, &
            'Unexpected character "'//c//'"found after ")"')
          goto 100
        endif

      elseif (state==ST_AFTERLASTBRACKET) then
        !write(*,*)'ST_AFTERLASTBRACKET'
        if (c=='*') then
          state = ST_END
          current%repeater = REP_ASTERISK
        elseif (c=='+') then
          if (mixed) then
            call add_error(stack, &
              '+ operator disallowed for Mixed elements')
            goto 100
          endif
          call transformCPPlus(current)
          state = ST_END
        elseif (c=='?') then
          if (mixed) then
            call add_error(stack, &
              '? operator disallowed for Mixed elements')
            goto 100
          endif
          current%repeater = REP_QUESTION_MARK
          state = ST_END
        elseif (verify(c, XML_WHITESPACE)==0) then
          if (mixed) then
            if (mixed_additional) then
              call add_error(stack, &
                'Missing "*" at end of Mixed element specification')
              goto 100
            endif
          endif
          state = ST_END
        else
          call add_error(stack, &
            'Unexpected character "'//c//'" found after final ")"')
          goto 100
        endif

      elseif (state==ST_END) then
        !write(*,*)'ST_END'
        if (verify(c, XML_WHITESPACE)==0) then
          continue
        else
          call add_error(stack, &
            'Unexpected token found after end of element specification')
          goto 100
        endif

      endif

    enddo

    if (state/=ST_END) then
      call add_error(stack, "Error in parsing contents of element declaration")
      goto 100
    endif

    if (associated(element)) then
      element%any = any
      element%empty = empty
      element%mixed = mixed
      element%model => vs_str_alloc(trim(strip_spaces(contents)))
      element%cp => top
      element%internal = internal
! For debugging it may be useful to dump the result here...
! Also need to use the subroutine.
!      call dumpCPtree(top)
    else
      if (associated(top)) call destroyCPtree(top)
    endif
    return

100 if (associated(order)) deallocate(order)
    if (associated(name)) deallocate(name)
    if (associated(top)) call destroyCPtree(top)

    contains
      function strip_spaces(s1) result(s2)
        character(len=*) :: s1
        character(len=len(s1)) :: s2
        integer :: i, i2
        i2 = 1
        do i = 1, len(s1)
          if (verify(s1(i:i), XML_WHITESPACE)==0) cycle
          s2(i2:i2) = s1(i:i)
          i2 = i2 + 1
        end do
        s2(i2:) = ''
      end function strip_spaces

      function check_duplicates(cp) result(p)
        type(content_particle_t), pointer :: cp
        logical :: p

        type(string_list) :: sl
        type(content_particle_t), pointer :: tcp

        if (cp%operator==OP_SEQ) then
          p = .true.
          return
        endif

        call init_string_list(sl)
        tcp => cp%firstChild
        p = .false.
        do while (associated(tcp))
          if (tcp%operator==OP_NAME) then
            if (registered_string(sl, str_vs(tcp%name))) then
              call destroy_string_list(sl)
              if (cp%operator==OP_MIXED) then
                call add_error(stack, &
                  "Duplicate element names found in MIXED")
              elseif (cp%operator==OP_CHOICE) then
                call add_error(stack, &
                  "Duplicate element names found in CHOICE")
              endif
              return
            else
              call add_string(sl, str_vs(tcp%name))
            endif
          endif
          tcp => tcp%nextSibling
        enddo
        p = .true.
        call destroy_string_list(sl)
      end function check_duplicates
  end subroutine parse_dtd_element


  subroutine init_attribute_list(a_list)
    type(attribute_list), intent(inout) :: a_list

    allocate(a_list%list(0))
  end subroutine init_attribute_list

  subroutine destroy_attribute_t(a)
    type(attribute_t), pointer :: a 

    if (associated(a%name)) deallocate(a%name)
    if (associated(a%default)) deallocate(a%default)
    call destroy_string_list(a%enumerations)

    deallocate(a)
  end subroutine destroy_attribute_t

  subroutine destroy_attribute_list(a_list)
    type(attribute_list), intent(inout) :: a_list

    integer :: i

    do i = 1, size(a_list%list)
      deallocate(a_list%list(i)%name)
      if (associated(a_list%list(i)%default)) deallocate(a_list%list(i)%default)
      call destroy_string_list(a_list%list(i)%enumerations)
    enddo
    deallocate(a_list%list)

  end subroutine destroy_attribute_list

  function existing_attribute(a_list, name) result(p)
    type(attribute_list), intent(inout) :: a_list
    character(len=*), intent(in) :: name
    logical :: p

    integer :: i
    p = .false.
    do i = 1, size(a_list%list)
      p = (str_vs(a_list%list(i)%name)==name)
      if (p) exit
    enddo
  end function existing_attribute

  function add_attribute(a_list, name, internal) result(a)
    type(attribute_list), intent(inout) :: a_list
    character(len=*), intent(in) :: name
    logical, intent(in) :: internal
    type(attribute_t), pointer :: a

    integer :: i
    type(attribute_t), pointer :: temp(:)

    temp => a_list%list
    allocate(a_list%list(size(temp)+1))
    do i = 1, size(temp)
      a_list%list(i)%name => temp(i)%name
      a_list%list(i)%atttype = temp(i)%atttype
      a_list%list(i)%attdefault = temp(i)%attdefault
      a_list%list(i)%default => temp(i)%default
      a_list%list(i)%enumerations%list => temp(i)%enumerations%list
      a_list%list(i)%internal = temp(i)%internal
    enddo
    deallocate(temp)
    a => a_list%list(i)

    a%name => vs_str_alloc(name)
    call init_string_list(a%enumerations)
    a%internal = internal

  end function add_attribute
  
  function get_attribute(a_list, name) result(a)
    type(attribute_list), intent(inout) :: a_list
    character(len=*), intent(in) :: name
    type(attribute_t), pointer :: a

    integer :: i
    do i = 1, size(a_list%list)
      if (str_vs(a_list%list(i)%name)==name) then
        a => a_list%list(i)
        exit
      endif
    enddo
  end function get_attribute

  subroutine parse_dtd_attlist(contents, xv, namespaces, validCheck, stack, elem, internal)
    character(len=*), intent(in) :: contents
    integer, intent(in) :: xv
    logical, intent(in) :: validCheck
    logical, intent(in) :: namespaces
    type(error_stack), intent(inout) :: stack
    type(element_t), pointer :: elem
    logical, intent(in) :: internal

    integer :: i
    integer :: state
    character :: c, q
    character, pointer :: name(:), attType(:), default(:), value(:), temp(:)

    type(attribute_t), pointer :: ca
    type(attribute_t), pointer :: ignore_att

    ignore_att => null()
    ! We need ignore_att to process but not take account of duplicate attributes
    ! elem is optional so we can not record declarations if necessary.
    ca => null()
    name => null()
    attType => null()
    default => null()
    value => null()
    temp => null()

    state = ST_START

    do i = 1, len(contents) + 1
      if (in_error(stack)) exit
      if (i<=len(contents)) then
        c = contents(i:i)
      else
        c = " "
      endif

      if (state==ST_START) then
        !write(*,*)'ST_START'
        if (verify(c, XML_WHITESPACE)==0) cycle
        if (isInitialNameChar(c, xv)) then
          name => vs_str_alloc(c)
          state = ST_NAME
        else
          call add_error(stack, &
            'Unexpected character in Attlist')
        endif

      elseif (state==ST_NAME) then
        !write(*,*)'ST_NAME'
        if (isNameChar(c, xv)) then
          temp => vs_str_alloc(str_vs(name)//c)
          deallocate(name)
          name => temp
        elseif (verify(c, XML_WHITESPACE)==0) then
          if (namespaces.and..not.checkQName(str_vs(name), xv)) then
            call add_error(stack, &
              "Attribute name in ATTLIST must be QName")
          elseif (associated(elem)) then
            if (existing_attribute(elem%attlist, str_vs(name))) then
              if (associated(ignore_att)) call destroy_attribute_t(ignore_att)
              allocate(ignore_att)
              call init_string_list(ignore_att%enumerations)
              ignore_att%name => vs_vs_alloc(name)
              ca => ignore_att
            else
              ca => add_attribute(elem%attlist, str_vs(name), internal)
            endif
          else
            if (associated(ignore_att)) call destroy_attribute_t(ignore_att)
            allocate(ignore_att)
            call init_string_list(ignore_att%enumerations)
            ignore_att%name => vs_vs_alloc(name)
            ca => ignore_att
          endif
          deallocate(name)
          state = ST_AFTERNAME
        else
          call add_error(stack, &
            'Unexpected character in Attlist Name')
        endif

      elseif (state==ST_AFTERNAME) then
        !write(*,*)'ST_AFTERNAME'
        if (verify(c, XML_WHITESPACE)==0) cycle
        if (verify(c, upperCase)==0) then
          attType => vs_str_alloc(c)
          state = ST_ATTTYPE
        elseif (c=='(') then
          allocate(value(0))
          ca%attType = ATT_ENUM
          state = ST_ENUMERATION
        else
          call add_error(stack, &
            'Unexpected error after Attlist Name')
        endif

      elseif (state==ST_ATTTYPE) then
        !write(*,*)'ST_ATTTYPE'
        if (verify(c, upperCase)==0) then
          temp => attType
          attType => vs_str_alloc(str_vs(temp)//c)
          deallocate(temp)
        elseif (verify(c, XML_WHITESPACE)==0) then
          ! xml:id constraint
          if (str_vs(ca%name)=="xml:id" &
            .and..not.str_vs(attType)=="ID") then
            call add_error(stack, &
              "xml:id attribute must be declared as type ID")
          elseif (str_vs(attType)=='CDATA') then
            ca%attType = ATT_CDATA
            state = ST_AFTER_ATTTYPE
          elseif (str_vs(attType)=='ID') then
            if (validCheck) then
              ! Validity Constraint: One ID per Element Type
              if (associated(elem)) then
                if (elem%id_declared) then
                  call add_error(stack, &
                    "Cannot have two declared attributes of type ID on one element type.")
                else
                  elem%id_declared = .true.
                endif
              endif
            endif
            ca%attType = ATT_ID
            state = ST_AFTER_ATTTYPE
          elseif (str_vs(attType)=='IDREF') then
            ca%attType = ATT_IDREF
            state = ST_AFTER_ATTTYPE
          elseif (str_vs(attType)=='IDREFS') then
            ca%attType = ATT_IDREFS
            state = ST_AFTER_ATTTYPE
          elseif (str_vs(attType)=='ENTITY') then
            ca%attType = ATT_ENTITY
            state = ST_AFTER_ATTTYPE
          elseif (str_vs(attType)=='ENTITIES') then
            ca%attType = ATT_ENTITIES
            state = ST_AFTER_ATTTYPE
          elseif (str_vs(attType)=='NMTOKEN') then
            ca%attType = ATT_NMTOKEN
            state = ST_AFTER_ATTTYPE
          elseif (str_vs(attType)=='NMTOKENS') then
            ca%attType = ATT_NMTOKENS
            state = ST_AFTER_ATTTYPE
          elseif (str_vs(attType)=='NOTATION') then
            ca%attType = ATT_NOTATION
            state = ST_AFTER_NOTATION
          else
            call add_error(stack, &
              'Unknown AttType')
          endif
          deallocate(attType)
        else
          call add_error(stack, &
            'Unexpected character in AttType')
        endif

      elseif (state==ST_AFTER_NOTATION) then
        !write(*,*)'ST_AFTER_NOTATION'
        if (verify(c, XML_WHITESPACE)==0) cycle
        if (c=='(') then
          state = ST_NOTATION_LIST
        else
          call add_error(stack, &
            'Unexpected character after Notation')
        endif

      elseif (state==ST_NOTATION_LIST) then
        !write(*,*)'ST_NOTATION_LIST'
        if (verify(c, XML_WHITESPACE)==0) cycle
        if (isInitialNameChar(c, xv)) then
          value => vs_str_alloc(c)
          state = ST_ENUM_NAME
        else
          call add_error(stack, &
            'Unexpected character in Notation list')
        endif

      elseif (state==ST_ENUMERATION) then
        !write(*,*)'ST_ENUMERATION'
        if (verify(c, XML_WHITESPACE)==0) cycle
        if (isNameChar(c, xv)) then
          temp => vs_str_alloc(str_vs(value)//c)
          deallocate(value)
          value => temp
          state = ST_ENUM_NAME
        elseif (c=='|') then
          call add_error(stack, &
            "Missing token in Enumeration")
        elseif (c==')') then
          call add_error(stack, &
            "Missing tokens in Enumeration")
        else
          call add_error(stack, &
            'Unexpected character in attlist enumeration')
        endif

      elseif (state==ST_ENUM_NAME) then
        !write(*,*)'ST_ENUM_NAME'
        if (isNameChar(c, xv)) then
          temp => vs_str_alloc(str_vs(value)//c)
          deallocate(value)
          value => temp
        elseif (verify(c, XML_WHITESPACE)==0) then
          if (validCheck.and.registered_string(ca%enumerations, str_vs(value))) then
            call add_error(stack, &
              "Duplicate enumeration value in ATTLIST")
          elseif (namespaces.and.ca%attType==ATT_NOTATION &
            .and..not.checkNCName(str_vs(value), xv)) then
            call add_error(stack, &
              "Notation name must be NCName")
          else
            call add_string(ca%enumerations, str_vs(value))
          endif
          deallocate(value)
          state = ST_SEPARATOR
        elseif (c=='|') then
          if (validCheck.and.registered_string(ca%enumerations, str_vs(value))) then
            call add_error(stack, &
              "Duplicate enumeration value in ATTLIST")
          elseif (namespaces.and.ca%attType==ATT_NOTATION &
            .and..not.checkNCName(str_vs(value), xv)) then
            call add_error(stack, &
              "Notation name must be NCName")
          else
            call add_string(ca%enumerations, str_vs(value))
          endif
          deallocate(value)
          if (ca%attType==ATT_NOTATION) then
            state = ST_NOTATION_LIST
          else
            allocate(value(0))
            state = ST_ENUMERATION
          endif
        elseif (c==')') then
          if (size(value)==0) then
            call add_error(stack, &
              'Missing token in Enumeration list')
          endif
          if (validCheck.and.registered_string(ca%enumerations, str_vs(value))) then
            call add_error(stack, &
              "Duplicate enumeration value in ATTLIST")
          elseif (namespaces.and.ca%attType==ATT_NOTATION &
            .and..not.checkNCName(str_vs(value), xv)) then
            call add_error(stack, &
              "Notation name must be NCName")
          else
            call add_string(ca%enumerations, str_vs(value))
          endif
          deallocate(value)
          state = ST_AFTER_ATTTYPE_SPACE
        else
          call add_error(stack, &
            'Unexpected character in attlist enumeration')
        endif

      elseif (state==ST_SEPARATOR) then
        !write(*,*)'ST_SEPARATOR'
        if (verify(c, XML_WHITESPACE)==0) cycle
        if (c=='|') then
          if (ca%attType==ATT_NOTATION) then
            state = ST_NOTATION_LIST
          else
            allocate(value(0))
            state = ST_ENUMERATION
          endif
        elseif (c==')') then
          state = ST_AFTER_ATTTYPE_SPACE
        else
          call add_error(stack, &
            'Unexpected character in attlist enumeration')
        endif

      elseif (state==ST_AFTER_ATTTYPE_SPACE) then
        if (verify(c, XML_WHITESPACE)/=0) then
          call add_error(stack, &
            'Missing whitespace in attlist enumeration')
        endif
        state = ST_AFTER_ATTTYPE

      elseif (state==ST_AFTER_ATTTYPE) then
        !write(*,*)'ST_AFTER_ATTTYPE'
        if (verify(c, XML_WHITESPACE)==0) cycle
        if (c=='#') then
          allocate(default(0))
          state = ST_DEFAULT_DECL
        elseif (c=='"'.or.c=="'") then
          if (validCheck) then
            ! Validity Constraint: ID Attribute Default
            if (ca%attType==ATT_ID) &
              call add_error(stack, &
              "Attribute of type ID may not have default value")
          endif
          ca%attDefault = ATT_DEFAULT
          q = c
          allocate(value(0))
          state = ST_DEFAULTVALUE
        else
          call add_error(stack, &
            'Unexpected character after AttType')
        endif

      elseif (state==ST_DEFAULT_DECL) then
        !write(*,*)'ST_DEFAULT_DECL'
        if (verify(c, upperCase)==0) then
          temp => vs_str_alloc(str_vs(default)//c)
          deallocate(default)
          default => temp
        elseif (verify(c, XML_WHITESPACE)==0) then
          if (str_vs(default)=='REQUIRED') then
            ca%attdefault = ATT_REQUIRED
            deallocate(default)
            state = ST_START
          elseif (str_vs(default)=='IMPLIED') then
            ca%attdefault = ATT_IMPLIED
            deallocate(default)
            state = ST_START
          elseif (str_vs(default)=='FIXED') then
            if (validCheck) then
              ! Validity Constraint: ID Attribute Default
              if (ca%attType==ATT_ID) &
                call add_error(stack, &
                "Attribute of type ID may not have FIXED value")
            endif
            ca%attdefault = ATT_FIXED
            deallocate(default)
            state = ST_AFTERDEFAULTDECL
          else
            call add_error(stack, &
              'Unknown Default declaration')
          endif
        else
          call add_error(stack, &
            'Unexpected character in Default declaration')
        endif

      elseif (state==ST_AFTERDEFAULTDECL) then
        !write(*,*)'ST_AFTERDEFAULTDECL'
        if (verify(c, XML_WHITESPACE)==0) cycle
        if (c=='"') then
          q = c
          allocate(value(0))
          state = ST_DEFAULTVALUE
        elseif (c=="'") then
          q = c
          allocate(value(0))
          state = ST_DEFAULTVALUE
        else
          call add_error(stack, &
            'Unexpected character after Default declaration')
        endif

      elseif (state==ST_DEFAULTVALUE) then
        !write(*,*)'ST_DEFAULTVALUE'
        if (c==q) then
          if (ca%attType/=ATT_CDATA) then
            temp => vs_str_alloc(att_value_normalize(str_vs(value)))
            deallocate(value)
            value => temp
          endif
          if (validCheck) then
            select case(ca%attType)
              ! Can't have ID with defaults
            case (ATT_IDREF)
              ! VC: IDREF
              if (namespaces) then
                if (.not.checkNCName(str_vs(value), xv)) &
                  call add_error(stack, &
                  "Attributes of type IDREF must have a value which is an XML NCName")
              else
                if (.not.checkName(str_vs(value), xv)) &
                  call add_error(stack, &
                  "Attributes of type IDREF must have a value which is an XML Name")
              endif
            case (ATT_IDREFS)
              ! VC: IDREF
              if (namespaces) then
                if (.not.checkNCNames(str_vs(value), xv)) &
                  call add_error(stack, &
                  "Attributes of type IDREFS must have a value which contains only XML NCNames")
              else
                if (.not.checkNames(str_vs(value), xv)) &
                  call add_error(stack, &
                  "Attributes of type IDREFS must have a value which contains only XML Names")
              endif
            case (ATT_ENTITY)
              ! VC: Entity Name
              if (namespaces) then
                if (.not.checkNCName(str_vs(value), xv)) &
                  call add_error(stack, &
                  "Attributes of type ENTITY must have a value which is an XML NCName")
              else
                if (.not.checkName(str_vs(value), xv)) &
                  call add_error(stack, &
                  "Attributes of type ENTITY must have a value which is an XML Name")
              endif
            case (ATT_ENTITIES)
              ! VC: Entity Name
              if (namespaces) then
                if (.not.checkNames(str_vs(value), xv)) &
                  call add_error(stack, &
                  "Attributes of type ENTITIES must have a value which contains only XML NCNames")
              else
                if (.not.checkNames(str_vs(value), xv)) &
                  call add_error(stack, &
                  "Attributes of type ENTITIES must have a value which contains only XML Names")
              endif
            case (ATT_NMTOKEN)
              ! VC Name Token
              if (.not.checkNmtoken(str_vs(value), xv)) &
                call add_error(stack, &
                "Attributes of type NMTOKEN must have a value which is a NMTOKEN")
            case (ATT_NMTOKENS)
              ! VC: Name Token
              if (.not.checkNmtokens(str_vs(value), xv)) &
                call add_error(stack, &
                "Attributes of type NMTOKENS must have a value which contain only NMTOKENs")
            case (ATT_NOTATION)
              ! VC: Notation Attributes
              if (namespaces) then
                if (.not.checkNCName(str_vs(value), xv)) &
                  call add_error(stack, &
                  "Attributes of type NOTATION must have a value which is an XMLNCName")
              else
                if (.not.checkName(str_vs(value), xv)) &
                  call add_error(stack, &
                  "Attributes of type NOTATION must have a value which is an XML Name")
              endif
            case (ATT_ENUM)
              ! VC: Enumeration
              if (.not.checkNmtoken(str_vs(value), xv)) &
                call add_error(stack, &
                "Attributes of type ENUM must have a value which is an NMTOKENs")
              if (.not.registered_string(ca%enumerations, str_vs(value))) &
                call add_error(stack, &
                "Default value of ENUM does not match permitted values")
            end select
          endif
          if (.not.in_error(stack)) then
            if (ca%attType==ATT_ENTITIES) then
              call destroy_string_list(ca%enumerations)
              ca%enumerations = tokenize_to_string_list(str_vs(value))
            endif
            ca%default => value
            value => null()
            state = ST_START
          endif
        else
          temp => vs_str_alloc(str_vs(value)//c)
          deallocate(value)
          value => temp
        endif

      endif

    enddo

    if (associated(ignore_att)) call destroy_attribute_t(ignore_att)

    if (.not.in_error(stack)) then
      if (state==ST_START) then
        return
      else
        call add_error(stack, &
          'Incomplete Attlist declaration')
      endif
    endif
    
    if (associated(name)) deallocate(name)
    if (associated(attType)) deallocate(attType)
    if (associated(default)) deallocate(default)
    if (associated(value)) deallocate(value)

  end subroutine parse_dtd_attlist

  subroutine report_declarations(elem, attributeDecl_handler)
    type(element_t), intent(in) :: elem
    interface
      subroutine attributeDecl_handler(eName, aName, type, mode, value)
        character(len=*), intent(in) :: eName
        character(len=*), intent(in) :: aName
        character(len=*), intent(in) :: type
        character(len=*), intent(in), optional :: mode
        character(len=*), intent(in), optional :: value
      end subroutine attributeDecl_handler
    end interface

    integer :: i
    character(len=8) :: type
    character(len=8) :: mode
    type(attribute_t), pointer :: a

    do i = 1, size(elem%attlist%list)
      a => elem%attlist%list(i)
      type = ATT_TYPES(a%attType)
      select case (a%attDefault)
      case (ATT_REQUIRED)
        mode = "REQUIRED"
      case (ATT_IMPLIED)
        mode = "IMPLIED"
      case (ATT_FIXED)
        mode = "FIXED"
      end select

      if (a%attType==ATT_NOTATION) then
        if (a%attDefault==ATT_DEFAULT) then
          if (associated(a%default)) then
            call attributeDecl_handler(str_vs(elem%name), str_vs(a%name), &
              'NOTATION '//make_token_group(a%enumerations), value=str_vs(a%default))
          else
            call attributeDecl_handler(str_vs(elem%name), str_vs(a%name), &
              'NOTATION '//make_token_group(a%enumerations))
          endif
        else
          if (associated(a%default)) then
            call attributeDecl_handler(str_vs(elem%name), str_vs(a%name), &
              'NOTATION '//make_token_group(a%enumerations), mode=trim(mode), &
              value=str_vs(a%default))
          else
            call attributeDecl_handler(str_vs(elem%name), str_vs(a%name), &
              'NOTATION '//make_token_group(a%enumerations), mode=trim(mode))
          endif
        endif
      elseif (a%attType==ATT_ENUM) then
        if (a%attDefault==ATT_DEFAULT) then
          if (associated(a%default)) then
            call attributeDecl_handler(str_vs(elem%name), str_vs(a%name), &
              make_token_group(a%enumerations), value=str_vs(a%default))
          else
            call attributeDecl_handler(str_vs(elem%name), str_vs(a%name), &
              make_token_group(a%enumerations))
          endif
        else
          if (associated(a%default)) then
            call attributeDecl_handler(str_vs(elem%name), str_vs(a%name), &
              make_token_group(a%enumerations), mode=trim(mode), &
              value=str_vs(a%default))
          else
            call attributeDecl_handler(str_vs(elem%name), str_vs(a%name), &
              make_token_group(a%enumerations), mode=trim(mode))
          endif
        endif
      else
        if (a%attDefault==ATT_DEFAULT) then
          if (associated(a%default)) then
            call attributeDecl_handler(str_vs(elem%name), str_vs(a%name), &
              trim(type), value=str_vs(a%default))
          else
            call attributeDecl_handler(str_vs(elem%name), str_vs(a%name), &
              trim(type))
          endif
        else
          if (associated(a%default)) then
            call attributeDecl_handler(str_vs(elem%name), str_vs(a%name), &
              trim(type), mode=trim(mode), value=str_vs(a%default))
          else
            call attributeDecl_handler(str_vs(elem%name), str_vs(a%name), &
              trim(type), mode=trim(mode))
          endif
        endif
      endif
    enddo


  end subroutine report_declarations

  pure function make_token_group_len(s_list) result(n)
    type(string_list), intent(in) :: s_list
    integer :: n

    integer :: i
    n = size(s_list%list) + 1
    do i = 1, size(s_list%list)
      n = n + size(s_list%list(i)%s)
    enddo
  end function make_token_group_len

  function make_token_group(s_list) result(s)
    type(string_list), intent(in) :: s_list
    character(len=make_token_group_len(s_list)) :: s
    
    integer :: i, m, n
    s(1:1) = '('
    n = 2
    do i = 1, size(s_list%list)-1
      m = size(s_list%list(i)%s)
      s(n:n+m) = str_vs(s_list%list(i)%s)//'|'
      n = n + m + 1
    enddo
    s(n:) = str_vs(s_list%list(i)%s)//')'
  end function make_token_group

  function attribute_has_default(att) result(p)
    type(attribute_t), pointer :: att
    logical :: p

    if (associated(att)) then
      p = att%attDefault==ATT_DEFAULT.or.att%attDefault==ATT_FIXED
    else
      p = .false.
    endif
  end function attribute_has_default

  function get_attlist_size(elem) result(n)
    type(element_t), pointer :: elem
    integer :: n

    if (associated(elem)) then
      n = size(elem%attlist%list)
    else
      n = 0
    endif
  end function get_attlist_size

  function get_attdecl_by_index(elem, n) result(att)
    type(element_t), pointer :: elem
    integer, intent(in) :: n
    type(attribute_t), pointer :: att

    att => null()
    if (associated(elem)) then
      if (n>0.and.n<=size(elem%attlist%list)) then
        att => elem%attlist%list(n)
      endif
    endif
  end function get_attdecl_by_index

  function get_attdecl_by_name(elem, name) result(att)
    type(element_t), pointer :: elem
    character(len=*), intent(in) :: name
    type(attribute_t), pointer :: att

    integer :: i
    att => null()
    if (associated(elem)) then
      do i = 1, size(elem%attlist%list)
        if (str_vs(elem%attlist%list(i)%name)==name) then
          att => elem%attlist%list(i)
          return
        endif
      enddo
    endif
  end function get_attdecl_by_name

  pure function express_att_decl_len(a) result(n)
    type(attribute_t), intent(in) :: a
    integer :: n

    if (a%attType==ATT_ENUM) then
      n = size(a%name)
    else
      n = size(a%name)+1+len_trim(ATT_TYPES(a%attType))
    endif

    if (a%attType==ATT_NOTATION &
      .or.a%attType==ATT_ENUM) &
      n = n + 1 + make_token_group_len(a%enumerations)

    select case(a%attDefault)
    case (ATT_REQUIRED)
      n = n + len(" #REQUIRED")
    case (ATT_IMPLIED)
      n = n + len(" #IMPLIED")
    case (ATT_DEFAULT)
      n = n + len(" ")
    case (ATT_FIXED)
      n = n + len(" #FIXED")
    end select
    
    if (associated(a%default)) &
      n = n + 3 + size(a%default)
  end function express_att_decl_len

  function express_attribute_declaration(a) result(s)
    type(attribute_t), intent(in) :: a
    character(len=express_att_decl_len(a)) :: s

    if (a%attType==ATT_ENUM) then
      s = str_vs(a%name)
    else
      s = str_vs(a%name)//" "//ATT_TYPES(a%attType)
    endif
    if (a%attType==ATT_NOTATION &
      .or.a%attType==ATT_ENUM) &
      s = trim(s)//" "//make_token_group(a%enumerations)

    select case(a%attDefault)
    case (ATT_REQUIRED)
      s = trim(s)//" #REQUIRED"
    case (ATT_IMPLIED)
      s = trim(s)//" #IMPLIED"
    case (ATT_DEFAULT)
      s = trim(s)//" "
    case (ATT_FIXED)
      s = trim(s)//" #FIXED"
    end select
    
    if (associated(a%default)) &
      s = trim(s)//" """//str_vs(a%default)//""""
  end function express_attribute_declaration

  function get_att_type_enum(s) result(n)
    character(len=*), intent(in) :: s
    integer :: n

    select case(s)
    case ('CDATA')
      n = ATT_CDATA
    case ('ID')
      n = ATT_ID
    case ('IDREF')
      n = ATT_IDREF
    case ('IDREFS')
      n = ATT_IDREFS
    case ('NMTOKEN')
      n = ATT_NMTOKEN
    case ('NMTOKENS')
      n = ATT_NMTOKENS
    case ('ENTITY')
      n = ATT_ENTITY
    case ('ENTITIES')
      n = ATT_ENTITIES
    case ('NOTATION')
      n = ATT_NOTATION
    case ('CDANO')
      n= ATT_CDANO
    case ('CDAMB')
      n = ATT_CDAMB
    end select
  end function get_att_type_enum

  pure function att_value_normalize_len(s1) result(n)
    character(len=*), intent(in) :: s1
    integer :: n

    integer :: i
    logical :: w

    n = 0
    w = .true.
    do i = 1, len(s1)
      if (w.and.(verify(s1(i:i),XML_WHITESPACE)==0)) cycle
      w = .false.
      n = n + 1
      if (verify(s1(i:i),XML_WHITESPACE)==0) w = .true.
    enddo
    if (w) n = n - 1 ! Discard final space
    
  end function att_value_normalize_len

  function att_value_normalize(s1) result(s2)
    character(len=*), intent(in) :: s1
    character(len=att_value_normalize_len(s1)) :: s2
    
    integer :: i, i2
    logical :: w
    
    i = 0
    i2 = 1
    w = .true.
    do while (i2<=len(s2))
      i = i + 1
      if (w.and.(verify(s1(i:i),XML_WHITESPACE)==0)) cycle
      w = .false.
      s2(i2:i2) = s1(i:i)
      i2 = i2 + 1
      if (verify(s1(i:i),XML_WHITESPACE)==0) w = .true.
    enddo

  end function att_value_normalize

#endif
end module m_common_element

module FoX_common

  use fox_m_fsys_array_str
  use fox_m_fsys_format
  use fox_m_fsys_parse_input
  use m_common_attrs

  implicit none
  private

#ifdef DUMMYLIB
  character(len=*), parameter :: FoX_version = '4.0.4-dummy'
#else
  character(len=*), parameter :: FoX_version = '4.0.4'
#endif

  public :: FoX_version

  public :: rts
  public :: str
  public :: operator(//)

#ifndef DUMMYLIB
  public :: str_vs
  public :: vs_str
  public :: alloc
  public :: concat
#endif

!These are all exported through SAX now
  public :: dictionary_t
!SAX functions
  public :: getIndex 
  public :: getLength
  public :: getLocalName
  public :: getQName
  public :: getURI
  public :: getValue
  public :: getType
  public :: isSpecified
  public :: isDeclared
  public :: setSpecified
  public :: setDeclared
!For convenience
  public :: hasKey

end module FoX_common

module m_dom_utils

  use fox_m_fsys_array_str, only: str_vs, vs_str
  use fox_m_fsys_format, only: operator(//)
  use m_common_attrs, only: getValue
  use m_common_element, only: element_t, attribute_t, &
    get_attlist_size, get_attribute_declaration, express_attribute_declaration
  use m_common_struct, only: xml_doc_state

  ! Public interfaces
  use m_dom_dom, only: DOMConfiguration, NamedNodeMap, Node,     &
    NodeList,                                                                  &
    ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_NODE,           &
    DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_REFERENCE_NODE,                   &
    PROCESSING_INSTRUCTION_NODE, TEXT_NODE,                                    &
    getAttributes, getChildNodes, getData, getDomConfig, getEntities,          &
    getFirstChild, getFoX_checks, getLength, getLocalName, getName,            &
    getNamespaceURI, getNextSibling, getNodeName, getNodeType, getNotationName,&
    getNotations, getOwnerDocument, getOwnerElement, getParameter,             &
    getParentNode, getPrefix, getPublicId, getSpecified, getSystemId,          &
    getTagName, getTarget, getXmlStandalone, getXmlVersion, getValue,          &
    haschildnodes, item, normalizeDocument

  ! Private interfaces
  use m_dom_dom, only: getNamespaceNodes, getStringValue, getXds, namespaceFixup

  use m_dom_error, only: DOMException, inException, throw_exception,           &
    getExceptionCode,                                                          &
    NAMESPACE_ERR, SERIALIZE_ERR, FoX_INTERNAL_ERROR, FoX_INVALID_NODE

  use FoX_wxml, only: xmlf_t,                                                  &
    xml_AddAttribute, xml_AddCharacters, xml_AddComment, xml_AddElementToDTD,  &
    xml_AddEntityReference, xml_AddExternalEntity, xml_AddInternalEntity,      &
    xml_AddDOCTYPE, xml_AddNotation, xml_AddXMLDeclaration, xml_AddXMLPI,      &
    xml_EndElement, xml_Close, xml_DeclareNamespace, xml_NewElement,           &
    xml_OpenFile, xml_UndeclareNamespace, xml_AddAttlistToDTD

  implicit none

  public :: dumpTree
  public :: serialize

  private

contains

  subroutine dumpTree(startNode)

    type(Node), pointer :: startNode   

    integer           :: indent_level

    indent_level = 0

    call dump2(startNode)

  contains

    recursive subroutine dump2(input)
      type(Node), pointer :: input
      type(Node), pointer :: temp, np
      type(NamedNodeMap), pointer :: attrs
      type(NodeList), pointer :: nsnodes
      integer :: i
      temp => input
      do while(associated(temp))
         write(*,"(3a,i0)") repeat(" ", indent_level), &
                        getNodeName(temp), " of type ", &
                        getNodeType(temp)
         if (getNodeType(temp)==ELEMENT_NODE) then
           write(*,"(2a)") repeat(" ", indent_level), &
                        "  ATTRIBUTES:"
           attrs => getAttributes(temp)
           do i = 0, getLength(attrs) - 1
             np => item(attrs, i)
             write(*, "(2a)") repeat(" ", indent_level)//"  ", &
               getName(np)
           enddo
           write(*,"(2a)") repeat(" ", indent_level), &
                        "  IN-SCOPE NAMESPACES:"
           nsnodes => getNamespaceNodes(temp)
           do i = 0, getLength(nsnodes) - 1
             np => item(nsnodes, i)
             write(*,"(4a)") repeat(" ", indent_level)//"  ", &
               getPrefix(np), ':', &
               getNamespaceURI(np)
           enddo
         endif
         if (hasChildNodes(temp)) then
            indent_level = indent_level + 3
            call dump2(getFirstChild(temp))
            indent_level = indent_level - 3
         endif
         temp => getNextSibling(temp)
      enddo

    end subroutine dump2

  end subroutine dumpTree


  subroutine serialize(startNode, name, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: startNode   
    character(len=*), intent(in) :: name

    type(Node), pointer :: doc
    type(xmlf_t)  :: xf
    integer :: iostat
    logical :: xmlDecl

    if (getNodeType(startNode)/=DOCUMENT_NODE &
      .and.getNodeType(startNode)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "serialize", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    
    if (getNodeType(startNode)==DOCUMENT_NODE) then
      doc => startNode
      if (getParameter(getDomConfig(doc), "canonical-form") &
        .and.getXmlVersion(doc)=="1.1") then
        if (getFoX_checks().or.SERIALIZE_ERR<200) then
  call throw_exception(SERIALIZE_ERR, "serialize", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

      endif
      call normalizeDocument(startNode, ex)
      if (present(ex)) then
        ! Only possible error should be namespace error ...
        if (getExceptionCode(ex)/=NAMESPACE_ERR) then
          if (getFoX_checks().or.FoX_INTERNAL_ERROR<200) then
  call throw_exception(FoX_INTERNAL_ERROR, "serialize", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

        else
          if (getFoX_checks().or.SERIALIZE_ERR<200) then
  call throw_exception(SERIALIZE_ERR, "serialize", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

        endif
      endif
    else
      doc => getOwnerDocument(startNode)
      ! We need to do this namespace fixup or serialization will fail.
      ! it doesn't change the semantics of the docs, but other
      ! normalization would, so we done here
      ! But only normalize if this is not a DOM level 1 node.
      if (getLocalName(startNode)/="" &
        .and.getParameter(getDomConfig(doc), "namespaces")) &
        call namespaceFixup(startNode, .true.)
    endif
    xmlDecl = getParameter(getDomConfig(doc), "xml-declaration")

    ! FIXME we shouldnt really normalize the Document here
    ! (except for namespace Normalization) but rather just
    ! pay attention to the DOMConfig values

    call xml_OpenFile(name, xf, iostat=iostat, unit=-1, &
      pretty_print=getParameter(getDomConfig(doc), "format-pretty-print"), &
      canonical=getParameter(getDomConfig(doc), "canonical-form"), &
      warning=.false., addDecl=.false.)
    if (iostat/=0) then
      if (getFoX_checks().or.SERIALIZE_ERR<200) then
  call throw_exception(SERIALIZE_ERR, "serialize", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (xmlDecl) then
      if (getXmlStandalone(doc)) then
        call xml_AddXMLDeclaration(xf, version=getXmlVersion(doc), standalone=.true.)
      else
        call xml_AddXMLDeclaration(xf, version=getXmlVersion(doc))
      endif
    endif

    call iter_dmp_xml(xf, startNode, ex)
    call xml_Close(xf)

  end subroutine serialize

  subroutine iter_dmp_xml(xf, arg, ex)
    type(DOMException), intent(out), optional :: ex
    type(xmlf_t), intent(inout) :: xf

    type(Node), pointer :: this, arg, treeroot 
    type(Node), pointer :: doc, attrchild, np
    type(NamedNodeMap), pointer :: nnm
    type(DOMConfiguration), pointer :: dc
    type(xml_doc_state), pointer :: xds
    type(element_t), pointer :: elem
    type(attribute_t), pointer :: att_decl
    integer :: i_tree, j, k
    logical :: doneChildren, doneAttributes
    character, pointer :: attrvalue(:), tmp(:)

    if (getNodeType(arg)==DOCUMENT_NODE) then
      doc => arg
    else
      doc => getOwnerDocument(arg)
    endif
    dc => getDomConfig(doc)
    xds => getXds(doc)

    treeroot => arg

    i_tree = 0
    doneChildren = .false.
    doneAttributes = .false.
    this => treeroot
    do
      if (.not.doneChildren.and..not.(getNodeType(this)==ELEMENT_NODE.and.doneAttributes)) then
    select case(getNodeType(this))
    case (ELEMENT_NODE)
      nnm => getAttributes(this)
      do j = 0, getLength(nnm) - 1
        attrchild => item(nnm, j)
        if (getLocalName(attrchild)=="xmlns") then
          if (len(getValue(attrchild))==0) then
            call xml_UndeclareNamespace(xf)
          else
            call xml_DeclareNamespace(xf, getValue(attrchild))
          endif
        elseif (getPrefix(attrchild)=="xmlns") then
          if (len(getValue(attrchild))==0) then
            call xml_UndeclareNamespace(xf, getLocalName(attrchild))
          else
            call xml_DeclareNamespace(xf, getValue(attrchild), &
              getLocalName(attrchild))
          endif
        endif
      enddo
      call xml_NewElement(xf, getTagName(this))
    case (ATTRIBUTE_NODE)
      if ((.not.getParameter(dc, "discard-default-content") &
        .or.getSpecified(this)) &
        ! only output it if it is not a default, or we are outputting defaults
        .and. (getPrefix(this)/="xmlns".and.getLocalName(this)/="xmlns")) then
        ! and we dont output NS declarations here.
        ! complex loop below is because we might have to worry about entrefs 
        ! being preserved in the attvalue. If we dont, we only go through the loop once anyway.
        allocate(attrvalue(0))
        do j = 0, getLength(getChildNodes(this)) - 1
          attrchild => item(getChildNodes(this), j)
          if (getNodeType(attrchild)==TEXT_NODE) then
            tmp => attrvalue
            allocate(attrvalue(size(tmp)+getLength(attrchild)))
            attrvalue(:size(tmp)) = tmp
            attrvalue(size(tmp)+1:) = vs_str(getData(attrChild))
            deallocate(tmp)
          elseif (getNodeType(attrchild)==ENTITY_REFERENCE_NODE) then
            tmp => attrvalue
            allocate(attrvalue(size(tmp)+len(getNodeName(attrchild))+2))
            attrvalue(:size(tmp)) = tmp
            attrvalue(size(tmp)+1:) = vs_str("&"//getData(attrChild)//";")
            deallocate(tmp)
          else
            if (getFoX_checks().or.FoX_INTERNAL_ERROR<200) then
  call throw_exception(FoX_INTERNAL_ERROR, "iter_dmp_xml", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

          endif
        enddo
        call xml_AddAttribute(xf, getName(this), str_vs(attrvalue))
        deallocate(attrvalue)
      endif
      doneChildren = .true.
    case (TEXT_NODE)
      call xml_AddCharacters(xf, getData(this))
    case (CDATA_SECTION_NODE)
      if (getParameter(getDomConfig(doc), "canonical-form")) then
        call xml_AddCharacters(xf, getData(this))
      else
        call xml_AddCharacters(xf, getData(this), parsed = .false.)
      endif
    case (ENTITY_REFERENCE_NODE)
      if (.not.getParameter(getDomConfig(doc), "canonical-form")) then
        call xml_AddEntityReference(xf, getNodeName(this))
        doneChildren = .true.
      endif
    case (PROCESSING_INSTRUCTION_NODE)
      call xml_AddXMLPI(xf, getTarget(this), getData(this))
    case (COMMENT_NODE)
      if (.not.getParameter(getDomConfig(doc), "comments")) then
        call xml_AddComment(xf, getData(this))
      endif
    case (DOCUMENT_TYPE_NODE)
      if (.not.getParameter(getDomConfig(doc), "canonical-form")) then
        call xml_AddDOCTYPE(xf, getName(this))
        nnm => getNotations(this)
        do j = 0, getLength(nnm)-1
          np => item(nnm, j)
          if (getSystemId(np)=="") then
            call xml_AddNotation(xf, getNodeName(np), public=getPublicId(np))
          elseif (getPublicId(np)=="") then
            call xml_AddNotation(xf, getNodeName(np), system=getSystemId(np))
          else
            call xml_AddNotation(xf, getNodeName(np), system=getSystemId(np), &
              public=getPublicId(np))
          endif
        enddo
        nnm => getEntities(this)
        do j = 0, getLength(nnm)-1
          np => item(nnm, j)
          if (getSystemId(np)=="") then
            call xml_AddInternalEntity(xf, getNodeName(np), getStringValue(np))
          elseif (getPublicId(np)=="".and.getNotationName(np)=="") then
            call xml_AddExternalEntity(xf, getNodeName(np), system=getSystemId(np))
          elseif (getNotationName(np)=="") then
            call xml_AddExternalEntity(xf, getNodeName(np), system=getSystemId(np), &
              public=getPublicId(np))
          elseif (getPublicId(np)=="") then
            call xml_AddExternalEntity(xf, getNodeName(np), system=getSystemId(np), &
              notation=getNotationName(np))
          else
            call xml_AddExternalEntity(xf, getNodeName(np), system=getSystemId(np), &
              public=getPublicId(np), notation=getNotationName(np))
          endif
        enddo
        do j = 1, size(xds%element_list%list)
          elem => xds%element_list%list(j)
          if (associated(elem%model)) &
            call xml_AddElementToDTD(xf, str_vs(elem%name), str_vs(elem%model))
            ! Because we may have some undeclared but referenced elements
          do k = 1, get_attlist_size(elem)
            att_decl => get_attribute_declaration(elem, k)
            call xml_AddAttlistToDTD(xf, str_vs(elem%name), &
              express_attribute_declaration(att_decl))
          enddo
        enddo
      endif
    end select

      else
        if (getNodeType(this)==ELEMENT_NODE.and..not.doneChildren) then
          doneAttributes = .true.
        else

    if (getNodeType(this)==ELEMENT_NODE) then
      call xml_EndElement(xf, getTagName(this))
    endif

        endif
      endif


      if (.not.doneChildren) then
        if (getNodeType(this)==ELEMENT_NODE.and..not.doneAttributes) then
          if (getLength(getAttributes(this))>0) then
            this => item(getAttributes(this), 0)
          else
            doneAttributes = .true.
          endif
        elseif (hasChildNodes(this)) then
          this => getFirstChild(this)
          doneChildren = .false.
          doneAttributes = .false.
        else
          doneChildren = .true.
          doneAttributes = .false.
        endif

      else ! if doneChildren

        if (associated(this, treeroot)) exit
        if (getNodeType(this)==ATTRIBUTE_NODE) then
          if (i_tree<getLength(getAttributes(getOwnerElement(this)))-1) then
            i_tree= i_tree+ 1
            this => item(getAttributes(getOwnerElement(this)), i_tree)
            doneChildren = .false.
          else
            i_tree= 0
            this => getOwnerElement(this)
            doneAttributes = .true.
            doneChildren = .false.
          endif
        elseif (associated(getNextSibling(this))) then

          this => getNextSibling(this)
          doneChildren = .false.
          doneAttributes = .false.
        else
          this => getParentNode(this)
        endif
      endif

    enddo



  end subroutine iter_dmp_xml

end module m_dom_utils

module m_common_elstack

#ifndef DUMMYLIB
  use fox_m_fsys_array_str, only: str_vs, vs_str
  use m_common_error, only: FoX_fatal
  use m_common_content_model, only: content_particle_t, checkCP, &
    elementContentCP, emptyContentCP, checkCPToEnd

  implicit none
  private

  ! Element stack during parsing. Keeps track of element names
  ! and optionally tracks validity of content model

  ! Initial stack size:
  integer, parameter :: STACK_SIZE_INIT = 10
  ! Multiplier when stack is exceeded:
  real, parameter :: STACK_SIZE_MULT = 1.5

  type :: elstack_item
    character, dimension(:), pointer          :: name => null()
    type(content_particle_t), pointer         :: cp => null()
  end type elstack_item

  type :: elstack_t
    private
    integer                                   :: n_items
    type(elstack_item), pointer, dimension(:) :: stack => null()
  end type elstack_t

  public :: elstack_t

  public  :: push_elstack, pop_elstack, init_elstack, destroy_elstack, reset_elstack, print_elstack
  public  :: get_top_elstack, is_empty
  public :: checkContentModel
  public :: checkContentModelToEnd
  public :: elementContent
  public :: emptyContent
  public  :: len

  interface len
    module procedure number_of_items
  end interface

  interface is_empty
    module procedure is_empty_elstack
  end interface

contains

  subroutine init_elstack(elstack)
    type(elstack_t), intent(inout)  :: elstack

    ! We go from 0 (and initialize the 0th string to "")
    ! in order that we can safely check the top of an
    ! empty stack
    allocate(elstack%stack(0:STACK_SIZE_INIT))
    elstack%n_items = 0
    allocate(elstack%stack(0)%name(0))

  end subroutine init_elstack

  subroutine destroy_elstack(elstack)
    type(elstack_t), intent(inout)  :: elstack
    integer :: i
    do i = 0, elstack % n_items
      deallocate(elstack%stack(i)%name)
    enddo
    deallocate(elstack%stack)
  end subroutine destroy_elstack

  subroutine reset_elstack(elstack)
    type(elstack_t), intent(inout)  :: elstack

    call destroy_elstack(elstack)
    call init_elstack(elstack)

  end subroutine reset_elstack

  subroutine resize_elstack(elstack)
    type(elstack_t), intent(inout)  :: elstack
    type(elstack_item), dimension(0:ubound(elstack%stack,1)) :: temp
    integer :: i, s

    s = ubound(elstack%stack, 1)

    do i = 0, s
      temp(i)%name => elstack%stack(i)%name
      temp(i)%cp => elstack%stack(i)%cp
    enddo
    deallocate(elstack%stack)
    allocate(elstack%stack(0:nint(s*STACK_SIZE_MULT)))
    do i = 0, s
      elstack%stack(i)%name => temp(i)%name
      elstack%stack(i)%cp => temp(i)%cp
    enddo

  end subroutine resize_elstack

  pure function is_empty_elstack(elstack) result(answer)
    type(elstack_t), intent(in)  :: elstack
    logical                    :: answer

    answer = (elstack%n_items == 0)
  end function is_empty_elstack

  function number_of_items(elstack) result(n)
    type(elstack_t), intent(in)  :: elstack
    integer                      :: n

    n = elstack%n_items
  end function number_of_items

  subroutine push_elstack(elstack, name, cp)
    type(elstack_t), intent(inout)              :: elstack
    character(len=*), intent(in)                :: name
    type(content_particle_t), pointer, optional :: cp

    integer :: n

    n = elstack%n_items
    n = n + 1
    if (n == size(elstack%stack)) then
      call resize_elstack(elstack)
    endif
    allocate(elstack%stack(n)%name(len(name)))
    elstack%stack(n)%name = vs_str(name)
    if (present(cp)) elstack%stack(n)%cp => cp
    elstack%n_items = n

  end subroutine push_elstack

  function pop_elstack(elstack) result(item)
    type(elstack_t), intent(inout)     :: elstack
    character(len=merge(size(elstack%stack(elstack%n_items)%name), 0, elstack%n_items > 0)) :: item

    integer :: n

    n = elstack%n_items
    if (n == 0) then
      call FoX_fatal("Element stack empty")
    endif
    item = str_vs(elstack%stack(n)%name)
    deallocate(elstack%stack(n)%name)
    elstack%n_items = n - 1

  end function pop_elstack

  pure function get_top_elstack(elstack) result(item)
    ! Get the top element of the stack, *without popping it*.
    type(elstack_t), intent(in)        :: elstack
    character(len=merge(size(elstack%stack(elstack%n_items)%name), 0, elstack%n_items > 0)) :: item 

    integer :: n

    n = elstack%n_items

    if (n==0) then
      item = ""
    else
      item = str_vs(elstack%stack(n)%name)
    endif

  end function get_top_elstack

  function checkContentModel(elstack, name) result(p)
    type(elstack_t), intent(inout) :: elstack
    character(len=*), intent(in) :: name
    logical :: p

    type(content_particle_t), pointer :: cp

    integer :: n
    n = elstack%n_items
    if (n==0) then
      p = .true.
    else
      cp => elstack%stack(n)%cp
      p = checkCP(cp, name)
      elstack%stack(n)%cp => cp
    endif
  end function checkContentModel

  function checkContentModelToEnd(elstack) result(p)
    type(elstack_t), intent(inout) :: elstack
    logical :: p

    type(content_particle_t), pointer :: cp

    integer :: n
    n = elstack%n_items

    cp => elstack%stack(n)%cp
    p = checkCPToEnd(cp)

  end function checkContentModelToEnd

  function elementContent(elstack) result(p)
    type(elstack_t), intent(in) :: elstack
    logical :: p

    integer :: n
    n = elstack%n_items
    if (n==0) then
      p = .false.
    else
      p = elementContentCP(elstack%stack(n)%cp)
    endif
  end function elementContent

  function emptyContent(elstack) result(p)
    type(elstack_t), intent(in) :: elstack
    logical :: p

    integer :: n
    n = elstack%n_items
    if (n==0) then
      p = .false.
    else
      p = emptyContentCP(elstack%stack(n)%cp)
    endif
  end function emptyContent

  subroutine print_elstack(elstack,unit)
    type(elstack_t), intent(in)   :: elstack
    integer, intent(in)           :: unit
    integer   :: i

    do i = elstack%n_items, 1, -1
      write(unit=unit,fmt=*) elstack%stack(i)%name
    enddo

  end subroutine print_elstack

#endif
end module m_common_elstack

module m_dom_extras

  use fox_m_fsys_realtypes, only: sp, dp
  use fox_m_fsys_parse_input, only: rts

  use m_dom_error, only: DOMException, inException, throw_exception,           &
    FoX_NODE_IS_NULL, FoX_INVALID_NODE
  use m_dom_dom, only: Node, ELEMENT_NODE,                                     &
    getAttribute, getAttributeNS, getTextContent, getNodeType, getFoX_checks

  implicit none
  private

  public :: extractDataContent
  public :: extractDataAttribute
  public :: extractDataAttributeNS

  interface extractDataContent
     module procedure extractDataContentCmplxDpSca
     module procedure extractDataContentCmplxDpArr
     module procedure extractDataContentCmplxDpMat
     module procedure extractDataContentCmplxSpSca
     module procedure extractDataContentCmplxSpArr
     module procedure extractDataContentCmplxSpMat
     module procedure extractDataContentRealDpSca
     module procedure extractDataContentRealDpArr
     module procedure extractDataContentRealDpMat
     module procedure extractDataContentRealSpSca
     module procedure extractDataContentRealSpArr
     module procedure extractDataContentRealSpMat
     module procedure extractDataContentIntSca
     module procedure extractDataContentIntArr
     module procedure extractDataContentIntMat
     module procedure extractDataContentLgSca
     module procedure extractDataContentLgArr
     module procedure extractDataContentLgMat
     module procedure extractDataContentChSca
     module procedure extractDataContentChArr
     module procedure extractDataContentChMat

  end interface extractDataContent

  interface extractDataAttribute
     module procedure extractDataAttributeCmplxDpSca
     module procedure extractDataAttributeCmplxDpArr
     module procedure extractDataAttributeCmplxDpMat
     module procedure extractDataAttributeCmplxSpSca
     module procedure extractDataAttributeCmplxSpArr
     module procedure extractDataAttributeCmplxSpMat
     module procedure extractDataAttributeRealDpSca
     module procedure extractDataAttributeRealDpArr
     module procedure extractDataAttributeRealDpMat
     module procedure extractDataAttributeRealSpSca
     module procedure extractDataAttributeRealSpArr
     module procedure extractDataAttributeRealSpMat
     module procedure extractDataAttributeIntSca
     module procedure extractDataAttributeIntArr
     module procedure extractDataAttributeIntMat
     module procedure extractDataAttributeLgSca
     module procedure extractDataAttributeLgArr
     module procedure extractDataAttributeLgMat
     module procedure extractDataAttributeChSca
     module procedure extractDataAttributeChArr
     module procedure extractDataAttributeChMat

  end interface extractDataAttribute

  interface extractDataAttributeNS
     module procedure extractDataAttNSCmplxDpSca
     module procedure extractDataAttNSCmplxDpArr
     module procedure extractDataAttNSCmplxDpMat
     module procedure extractDataAttNSCmplxSpSca
     module procedure extractDataAttNSCmplxSpArr
     module procedure extractDataAttNSCmplxSpMat
     module procedure extractDataAttNSRealDpSca
     module procedure extractDataAttNSRealDpArr
     module procedure extractDataAttNSRealDpMat
     module procedure extractDataAttNSRealSpSca
     module procedure extractDataAttNSRealSpArr
     module procedure extractDataAttNSRealSpMat
     module procedure extractDataAttNSIntSca
     module procedure extractDataAttNSIntArr
     module procedure extractDataAttNSIntMat
     module procedure extractDataAttNSLgSca
     module procedure extractDataAttNSLgArr
     module procedure extractDataAttNSLgMat
     module procedure extractDataAttNSChSca
     module procedure extractDataAttNSChArr
     module procedure extractDataAttNSChMat

  end interface extractDataAttributeNS

contains

subroutine extractDataContentCmplxDpSca(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    complex(dp), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentCmplxDpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentCmplxDpSca

subroutine extractDataContentCmplxSpSca(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    complex(sp), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentCmplxSpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentCmplxSpSca

subroutine extractDataContentRealDpSca(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    real(dp), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentRealDpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentRealDpSca

subroutine extractDataContentRealSpSca(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    real(sp), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentRealSpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentRealSpSca

subroutine extractDataContentIntSca(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    integer, intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentIntSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentIntSca

subroutine extractDataContentLgSca(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    logical, intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentLgSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentLgSca

subroutine extractDataContentChSca(arg, data, separator, csv, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(out) :: data

    logical, intent(in), optional :: csv
    character, intent(in), optional :: separator
    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentChSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif
    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, separator, csv, num, iostat)
    else
      call rts(getTextContent(arg), data, separator, csv, num, iostat)
    endif

  end subroutine extractDataContentChSca


subroutine extractDataContentCmplxDpArr(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    complex(dp), dimension(:), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentCmplxDpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentCmplxDpArr

subroutine extractDataContentCmplxSpArr(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    complex(sp), dimension(:), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentCmplxSpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentCmplxSpArr

subroutine extractDataContentRealDpArr(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    real(dp), dimension(:), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentRealDpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentRealDpArr

subroutine extractDataContentRealSpArr(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    real(sp), dimension(:), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentRealSpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentRealSpArr

subroutine extractDataContentIntArr(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    integer, dimension(:), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentIntArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentIntArr

subroutine extractDataContentLgArr(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    logical, dimension(:), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentLgArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentLgArr

subroutine extractDataContentChArr(arg, data, separator, csv, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), dimension(:), intent(out) :: data

    logical, intent(in), optional :: csv
    character, intent(in), optional :: separator
    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentChArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif
    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, separator, csv, num, iostat)
    else
      call rts(getTextContent(arg), data, separator, csv, num, iostat)
    endif

  end subroutine extractDataContentChArr


subroutine extractDataContentCmplxDpMat(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    complex(dp), dimension(:,:), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentCmplxDpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentCmplxDpMat

subroutine extractDataContentCmplxSpMat(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    complex(sp), dimension(:,:), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentCmplxSpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentCmplxSpMat

subroutine extractDataContentRealDpMat(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    real(dp), dimension(:,:), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentRealDpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentRealDpMat

subroutine extractDataContentRealSpMat(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    real(sp), dimension(:,:), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentRealSpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentRealSpMat

subroutine extractDataContentIntMat(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    integer, dimension(:,:), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentIntMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentIntMat

subroutine extractDataContentLgMat(arg, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    logical, dimension(:,:), intent(out) :: data

    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentLgMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, num, iostat)
    else
      call rts(getTextContent(arg), data, num, iostat)
    endif

  end subroutine extractDataContentLgMat

subroutine extractDataContentChMat(arg, data, separator, csv, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), dimension(:,:), intent(out) :: data

    logical, intent(in), optional :: csv
    character, intent(in), optional :: separator
    integer, intent(out), optional :: num, iostat

    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataContentChMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif
    if (present(ex)) then
      call rts(getTextContent(arg, ex), data, separator, csv, num, iostat)
    else
      call rts(getTextContent(arg), data, separator, csv, num, iostat)
    endif

  end subroutine extractDataContentChMat


subroutine extractDataAttributeCmplxDpSca(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    complex(dp), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeCmplxDpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeCmplxDpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeCmplxDpSca

subroutine extractDataAttributeCmplxSpSca(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    complex(sp), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeCmplxSpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeCmplxSpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeCmplxSpSca

subroutine extractDataAttributeRealDpSca(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    real(dp), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeRealDpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeRealDpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeRealDpSca

subroutine extractDataAttributeRealSpSca(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    real(sp), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeRealSpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeRealSpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeRealSpSca

subroutine extractDataAttributeIntSca(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    integer, intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeIntSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeIntSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeIntSca

subroutine extractDataAttributeLgSca(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    logical, intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeLgSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeLgSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeLgSca

subroutine extractDataAttributeChSca(arg, name, data, separator, csv, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    logical, intent(in), optional :: csv
    character, intent(in), optional :: separator
    character(len=*), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeChSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeChSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, separator, csv, num, iostat)
    else
      call rts(getAttribute(arg, name), data, separator, csv, num, iostat)
    endif


  end subroutine extractDataAttributeChSca


subroutine extractDataAttributeCmplxDpArr(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    complex(dp), dimension(:), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeCmplxDpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeCmplxDpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeCmplxDpArr

subroutine extractDataAttributeCmplxSpArr(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    complex(sp), dimension(:), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeCmplxSpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeCmplxSpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeCmplxSpArr

subroutine extractDataAttributeRealDpArr(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    real(dp), dimension(:), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeRealDpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeRealDpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeRealDpArr

subroutine extractDataAttributeRealSpArr(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    real(sp), dimension(:), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeRealSpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeRealSpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeRealSpArr

subroutine extractDataAttributeIntArr(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    integer, dimension(:), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeIntArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeIntArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeIntArr

subroutine extractDataAttributeLgArr(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    logical, dimension(:), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeLgArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeLgArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeLgArr

subroutine extractDataAttributeChArr(arg, name, data, separator, csv, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    logical, intent(in), optional :: csv
    character, intent(in), optional :: separator
    character(len=*), dimension(:), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeChArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeChArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, separator, csv, num, iostat)
    else
      call rts(getAttribute(arg, name), data, separator, csv, num, iostat)
    endif


  end subroutine extractDataAttributeChArr


subroutine extractDataAttributeCmplxDpMat(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    complex(dp), dimension(:,:), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeCmplxDpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeCmplxDpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeCmplxDpMat

subroutine extractDataAttributeCmplxSpMat(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    complex(sp), dimension(:,:), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeCmplxSpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeCmplxSpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeCmplxSpMat

subroutine extractDataAttributeRealDpMat(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    real(dp), dimension(:,:), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeRealDpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeRealDpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeRealDpMat

subroutine extractDataAttributeRealSpMat(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    real(sp), dimension(:,:), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeRealSpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeRealSpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeRealSpMat

subroutine extractDataAttributeIntMat(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    integer, dimension(:,:), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeIntMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeIntMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeIntMat

subroutine extractDataAttributeLgMat(arg, name, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    logical, dimension(:,:), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeLgMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeLgMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, num, iostat)
    else
      call rts(getAttribute(arg, name), data, num, iostat)
    endif


  end subroutine extractDataAttributeLgMat

subroutine extractDataAttributeChMat(arg, name, data, separator, csv, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: name

    logical, intent(in), optional :: csv
    character, intent(in), optional :: separator
    character(len=*), dimension(:,:), intent(out) :: data
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttributeChMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttributeChMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getAttribute(arg, name, ex), data, separator, csv, num, iostat)
    else
      call rts(getAttribute(arg, name), data, separator, csv, num, iostat)
    endif


  end subroutine extractDataAttributeChMat


subroutine extractDataAttNSCmplxDpSca(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    complex(dp), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSCmplxDpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSCmplxDpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSCmplxDpSca

subroutine extractDataAttNSCmplxSpSca(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    complex(sp), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSCmplxSpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSCmplxSpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSCmplxSpSca

subroutine extractDataAttNSRealDpSca(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    real(dp), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSRealDpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSRealDpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSRealDpSca

subroutine extractDataAttNSRealSpSca(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    real(sp), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSRealSpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSRealSpSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSRealSpSca

subroutine extractDataAttNSIntSca(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    integer, intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSIntSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSIntSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSIntSca

subroutine extractDataAttNSLgSca(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    logical, intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSLgSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSLgSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSLgSca

subroutine extractDataAttNSChSca(arg, namespaceURI, localName, data, separator, csv, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    character(len=*), intent(out) :: data

    logical, intent(in), optional :: csv
    character, intent(in), optional :: separator
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSChSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSChSca", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, separator, csv, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, separator, csv, num, iostat)
    endif


  end subroutine extractDataAttNSChSca


subroutine extractDataAttNSCmplxDpArr(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    complex(dp), dimension(:), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSCmplxDpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSCmplxDpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSCmplxDpArr

subroutine extractDataAttNSCmplxSpArr(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    complex(sp), dimension(:), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSCmplxSpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSCmplxSpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSCmplxSpArr

subroutine extractDataAttNSRealDpArr(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    real(dp), dimension(:), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSRealDpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSRealDpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSRealDpArr

subroutine extractDataAttNSRealSpArr(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    real(sp), dimension(:), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSRealSpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSRealSpArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSRealSpArr

subroutine extractDataAttNSIntArr(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    integer, dimension(:), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSIntArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSIntArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSIntArr

subroutine extractDataAttNSLgArr(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    logical, dimension(:), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSLgArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSLgArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSLgArr

subroutine extractDataAttNSChArr(arg, namespaceURI, localName, data, separator, csv, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    character(len=*), dimension(:), intent(out) :: data

    logical, intent(in), optional :: csv
    character, intent(in), optional :: separator
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSChArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSChArr", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, separator, csv, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, separator, csv, num, iostat)
    endif


  end subroutine extractDataAttNSChArr


subroutine extractDataAttNSCmplxDpMat(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    complex(dp), dimension(:,:), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSCmplxDpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSCmplxDpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSCmplxDpMat

subroutine extractDataAttNSCmplxSpMat(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    complex(sp), dimension(:,:), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSCmplxSpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSCmplxSpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSCmplxSpMat

subroutine extractDataAttNSRealDpMat(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    real(dp), dimension(:,:), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSRealDpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSRealDpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSRealDpMat

subroutine extractDataAttNSRealSpMat(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    real(sp), dimension(:,:), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSRealSpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSRealSpMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSRealSpMat

subroutine extractDataAttNSIntMat(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    integer, dimension(:,:), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSIntMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSIntMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSIntMat

subroutine extractDataAttNSLgMat(arg, namespaceURI, localName, data, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    logical, dimension(:,:), intent(out) :: data

    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSLgMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSLgMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif


    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, num, iostat)
    endif


  end subroutine extractDataAttNSLgMat

subroutine extractDataAttNSChMat(arg, namespaceURI, localName, data, separator, csv, num, iostat, ex)
    type(DOMException), intent(out), optional :: ex
    type(Node), pointer :: arg
    character(len=*), intent(in) :: namespaceURI, localName
    character(len=*), dimension(:,:), intent(out) :: data

    logical, intent(in), optional :: csv
    character, intent(in), optional :: separator
    integer, intent(out), optional :: num, iostat
    if (.not.associated(arg)) then
      if (getFoX_checks().or.FoX_NODE_IS_NULL<200) then
  call throw_exception(FoX_NODE_IS_NULL, "extractDataAttNSChMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    elseif (getNodeType(arg)/=ELEMENT_NODE) then
      if (getFoX_checks().or.FoX_INVALID_NODE<200) then
  call throw_exception(FoX_INVALID_NODE, "extractDataAttNSChMat", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

    if (present(ex)) then
      call rts(getAttributeNS(arg, namespaceURI, localName, ex), &
        data, separator, csv, num, iostat)
    else
      call rts(getAttributeNS(arg, namespaceURI, localName), &
        data, separator, csv, num, iostat)
    endif


  end subroutine extractDataAttNSChMat



end module m_dom_extras

module m_wxml_escape
  
  !Ensure all characters are safe to go out into XML file.

  use m_common_charset, only: XML1_0
  use m_common_error, only: FoX_error, FoX_warning
  use m_common_format, only: str

  implicit none
  private

  integer, parameter :: AMP = iachar('&')
  integer, parameter :: LT = iachar('<')
  integer, parameter :: GT = iachar('>')
  integer, parameter :: QUOT = iachar('"')
  integer, parameter :: APOS = iachar("'")

  public :: escape_string
  public :: escape_string_len

contains

  pure function escape_string_len(s) result(c)
    character(len=*), intent(in) :: s
    integer :: c

    integer :: i 
    c = len(s)
    do i = 1, len(s)
      select case(iachar(s(i:i)))
      case (AMP)
        c = c + 4
      case (LT)
        c = c + 3
      case (GT)
        c = c + 3
      case (QUOT)
        c = c + 5
      case (APOS)
        c = c + 5
      case (1:8)
        c = c + 3
      case (11:12)
        c = c + 4
      case (14:31)
        c = c + 4
      case (127:)
        c = c + 5
        ! a char can never contain more than 8 bits = 256 characters, so
        ! we never need more than 3 chars to represent the int.
      end select
    enddo 

  end function escape_string_len
    

  function escape_string(s, version) result (s2)
    character(len=*), intent(in) :: s
    integer, intent(in) :: version
    character(len=escape_string_len(s)) :: s2

    integer :: c, i, ic

    ! We have to do it this way (with achar etc) in case the native
    ! platform encoding is not ASCII

    c = 1
    do i = 1, len(s)
      ic = iachar(s(i:i))
      select case (ic)
      case (0)
        call FoX_error("Tried to output a NUL character")
      case (1:8)
        if (version==XML1_0) then
          call FoX_error("Tried to output a character invalid under XML 1.0")
        else
          s2(c:c+3) = "&#"//str(ic)//";"
          c = c + 4
        endif
      case(9:10)
        s2(c:c) = achar(ic)
        c = c + 1
      case(11:12)
        if (version==XML1_0) then
          call FoX_error("Tried to output a character invalid under XML 1.0")
        else
          s2(c:c+5) = "&#"//str(ic)//";"
          c = c + 5
        endif
      case(13)
        s2(c:c) = achar(13)
        c = c + 1
      case (14:31)
        if (version==XML1_0) then
          call FoX_error("Tried to output a character invalid under XML 1.0")
        else
          s2(c:c+5) = "&#"//str(ic)//";"
          c = c + 5
        endif
      case (32:126)
        select case (iachar(s(i:i)))
        case (AMP)
          s2(c:c+4) = "&amp;"
          c = c + 5
        case (LT)
          s2(c:c+3) = "&lt;"
          c = c + 4
        case (GT)
          s2(c:c+3) = "&gt;"
          c = c + 4
        case (QUOT)
          s2(c:c+5) = "&quot;"
          c = c + 6
        case (APOS)
          s2(c:c+5) = "&apos;"
          c = c + 6
        case default
          s2(c:c) = achar(ic)
          c = c + 1
        end select
      case (127)
        s2(c:c+5) = "&#127;"
        c = c + 6
      case default
        !TOHW we should maybe just disallow this ...
        call FoX_warning("emitting non-ASCII character. Platform-dependent result!")
        s2(c:c+6) = "&#"//str(ic)//";"
        c = c + 6
        ! a char can never contain more than 8 bits = 256 characters, so
        ! we never need more than 3 chars to represent the int.
        ! We have to encode it though, because UTF-8 x7F-x9F must be 
        ! encoded, and if they are in the native charset they'll be > 128
      end select
    enddo 

  end function escape_string

end module m_wxml_escape

module m_handlers

  use FoX_common
  use FoX_sax

  implicit none
  private

  ! This shows how you might use a SAX processor
  ! to extract character data from within certain nodes.

  ! It will print out the character content of all scalar
  ! nodes inside parameter nodes.

  ! It will also remember the value of the scalar within the 
  ! parameter node called DM.EnergyTolerance

  ! Note that when dealing with character data, we need to 
  ! concatenate all the character handling events in question:
  ! we do this using some of the character handling routines 
  ! provided as a convenience by FoX.

  public :: characters_handler
  public :: endDocument_handler
  public :: endElement_handler
  public :: startDocument_handler
  public :: startElement_handler

  logical :: inScalar
  logical :: inParameter
  logical :: etolFound
  real :: etol
  character, pointer :: c(:) => null()

  public :: etol

contains

  subroutine characters_handler(chunk)
    character(len=*), intent(in) :: chunk
    character, pointer :: c2(:)
    if (inScalar.and.inParameter) then
      print*, "Found some scalar parameter data:"
      print*, trim(chunk)
      if (etolFound) then
        if (associated(c)) then
          c2 => concat(c, chunk)
          deallocate(c)
          c => c2
        else
          c => alloc(chunk)
        endif
      endif
    endif

  end subroutine characters_handler

  subroutine endElement_handler(URI, localname, name)
    character(len=*), intent(in)     :: URI
    character(len=*), intent(in)     :: localname
    character(len=*), intent(in)     :: name

    ! Note if we are leaving a scalar or parameter element.
    if (URI=="http://www.xml-cml.org/schema" &
      .and. localName=="scalar") then
      inScalar = .false.
      if (etolFound) then
        ! pull the data out of the concatenated string:
        etol = vs_real(c)
      endif
    elseif (URI=="http://www.xml-cml.org/schema" &
      .and. localName=="parameter") then
      inParameter = .false.
      etolFound = .false.
    endif
  end subroutine endElement_handler
  
  subroutine startDocument_handler
    ! Initialize state variables
    inScalar = .false.
    inParameter = .false.
  end subroutine startDocument_handler
  
  subroutine endDocument_handler
    if (associated(c)) deallocate(c)
  end subroutine endDocument_handler
  
  subroutine startElement_handler(URI, localname, name, attributes)
    character(len=*), intent(in)   :: URI
    character(len=*), intent(in)   :: localname
    character(len=*), intent(in)   :: name
    type(dictionary_t), intent(in) :: attributes

    integer :: i

    ! Note if we are entering a scalar or parameter element.
    if (URI=="http://www.xml-cml.org/schema" &
      .and. localName=="scalar") then
      inScalar = .true.
    elseif (URI=="http://www.xml-cml.org/schema" &
      .and. localName=="parameter") then
      inParameter = .true.
      ! Loop over the attributes, looking for the name ...
      do i = 1, getLength(attributes)
        if (getQName(attributes, i)=="name") then
          ! And if the attribute is called name, check if the name
          ! is what we are interested in.
          print*, "name=", getValue(attributes, i)
          etolfound = getValue(attributes, i)=="DM.EnergyTolerance"
        endif
      enddo
    endif
  end subroutine startElement_handler

end module m_handlers

program sax_example

  use FoX_sax

  use m_handlers ! above

  implicit none

  integer :: iostat
  type(xml_t)  :: fxml

  call open_xml_file(fxml, "h2o.xml", iostat=iostat)
  if (iostat /= 0) then
    write(*,*) "Cannot open file."
    stop
  endif

  call parse(fxml,&
    characters_handler=characters_handler, &
    endDocument_handler=endDocument_handler, & 
    endElement_handler=endElement_handler, & 
    startDocument_handler=startDocument_handler, & 
    startElement_handler=startElement_handler)

  call close_xml_t(fxml)

  print*, "The energy tolerance requested was:", etol

end program sax_example

module FoX_utils
  
  use fox_m_utils_uuid
  use fox_m_utils_uri

  implicit none
  private

  public :: generate_uuid

  public :: URI
  public :: parseURI
  public :: rebaseURI
  public :: copyURI
  public :: destroyURI
  public :: expressURI
  public :: hasFragment
  public :: hasScheme
  public :: getScheme
  public :: getPath

end module FoX_utils

program test

  use FoX_wcml
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  real, dimension(3,3) :: ucell

  ucell = reshape((/  1.0, 0.5, 0.5,   &
                      0.0, 1.0, 0.0,   &
                      0.0, 0.0, 1.0/), &
                   (/3,3/))

  call cmlBeginFile(xf, filename, unit=-1)
  call cmlStartCml(xf)
  
  call cmlAddLattice(xf, cell=ucell, fmt="s3")

  call cmlFinishFile(xf)

end program test

program test

  use FoX_wcml
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  real :: sym_ops(3,3,2)
  real :: sym_disps(3,2)

  sym_ops(:,:,1) = reshape((/1.0, 0.0, 0.0, &
                             0.0, 1.0, 0.0, &
                             0.0, 0.0, 1.0/), (/3,3/))

  sym_ops(:,:,2) = reshape((/1.0, 0.0, 0.0, &
                             0.0, 1.0, 0.0, &
                             0.0, 0.0, 1.0/), (/3,3/))

  sym_disps(:,1) = (/0.5, 0.5, 0.5/)
  sym_disps(:,2) = (/-0.5, -0.5, -0.5/)

  call cmlBeginFile(xf, filename, unit=-1)
  call cmlStartCml(xf)
  call cmlAddSymmetry(xf, spaceGroup="P -4 21 m", &
    sym_ops=sym_ops, sym_disps=sym_disps)
  call cmlFinishFile(xf)

end program test

! This file is AUTOGENERATED
! To change, edit m_wcml_molecule.m4 and regenerate

module m_wcml_molecule

  use fox_m_fsys_realtypes, only: sp, dp
  use FoX_wxml, only: xmlf_t

#ifndef DUMMYLIB
  use fox_m_fsys_format, only: str
  use m_common_error, only: FoX_error
  use FoX_wxml, only: xml_NewElement, xml_EndElement
  use FoX_wxml, only: xml_AddAttribute, xml_AddCharacters, xml_AddNewline

! Fix for pgi, requires this explicitly:
  use m_wxml_overloads
#endif

  implicit none
  private

  interface cmlAddMolecule
    module procedure cmlAddMoleculeSP
    module procedure cmlAddMoleculeSP_sh
    module procedure cmlAddMolecule_3_SP
    module procedure cmlAddMolecule_3_SP_sh
    module procedure cmlAddMoleculeDP
    module procedure cmlAddMoleculeDP_sh
    module procedure cmlAddMolecule_3_DP
    module procedure cmlAddMolecule_3_DP_sh
  end interface

  interface cmlAddAtoms
    module procedure cmlAddAtomsSP
    module procedure cmlAddAtomsSP_sh
    module procedure cmlAddAtoms_3_SP
    module procedure cmlAddAtoms_3_SP_sh
    module procedure cmlAddAtomsDP
    module procedure cmlAddAtomsDP_sh
    module procedure cmlAddAtoms_3_DP
    module procedure cmlAddAtoms_3_DP_sh
  end interface

  interface cmlAddParticles
    module procedure cmlAddParticlesSP
    module procedure cmlAddParticlesSP_sh
    module procedure cmlAddParticles_3_SP
    module procedure cmlAddParticles_3_SP_sh
    module procedure cmlAddParticlesDP
    module procedure cmlAddParticlesDP_sh
    module procedure cmlAddParticles_3_DP
    module procedure cmlAddParticles_3_DP_sh
  end interface

#ifndef DUMMYLIB
  interface cmlAddCoords
    module procedure cmlAddCoords_sp
    module procedure cmlAddCoords_dp
  end interface

  interface addDlpolyMatrix
    module procedure addDlpolyMatrix_sp
    module procedure addDlpolyMatrix_3_sp
    module procedure addDlpolyMatrix_dp
    module procedure addDlpolyMatrix_3_dp
  end interface
#endif

  public :: cmlStartMolecule
  public :: cmlEndMolecule

  public :: cmlAddAtoms
  public :: cmlAddParticles

  public :: cmlAddMolecule

contains

  subroutine cmlStartMolecule(xf &
,dictRef,convention,title,id,ref,formula,chirality,role)
    type(xmlf_t), intent(inout) :: xf

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: formula
    character(len=*), intent(in), optional :: chirality
    character(len=*), intent(in), optional :: role



#ifndef DUMMYLIB
    
    call xml_NewElement(xf, "molecule")

    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(formula)) call xml_addAttribute(xf, "formula", formula)
    if (present(chirality)) call xml_addAttribute(xf, "chirality", chirality)
    if (present(role)) call xml_addAttribute(xf, "role", role)



#endif
  end subroutine cmlStartMolecule

  subroutine cmlEndMolecule(xf)
    type(xmlf_t), intent(inout) :: xf

#ifndef DUMMYLIB
    call xml_EndElement(xf, "molecule")
#endif
  end subroutine cmlEndMolecule

  subroutine cmlAddMoleculesp(xf, elements, atomRefs, coords, occupancies, atomIds, style, fmt &
,dictRef,convention,title,id,ref,formula,chirality,role)
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)              :: coords(:, :)
    character(len=*), intent(in)           :: elements(:)
    character(len=*), intent(in), optional :: atomRefs(:) 
    real(kind=sp), intent(in), optional :: occupancies(:)
    character(len=*), intent(in), optional :: atomIds(:)
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: formula
    character(len=*), intent(in), optional :: chirality
    character(len=*), intent(in), optional :: role



#ifndef DUMMYLIB

    call cmlStartMolecule(xf &
,dictRef,convention,title,id,ref,formula,chirality,role)
    call cmlAddAtoms(xf, elements, atomRefs, coords, occupancies, atomIds, style, fmt)
    call cmlEndMolecule(xf)

#endif DUMMYLIB

  end subroutine cmlAddMoleculesp


  subroutine cmlAddMoleculesp_sh(xf, natoms, elements, atomRefs, coords, occupancies, atomIds, style, fmt &
,dictRef,convention,title,id,ref,formula,chirality,role)
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) :: natoms
    real(kind=sp), intent(in)              :: coords(3, natoms)
    character(len=*), intent(in)           :: elements(natoms)
    character(len=*), intent(in), optional :: atomRefs(natoms) 
    real(kind=sp), intent(in), optional :: occupancies(natoms) 
    character(len=*), intent(in), optional :: atomIds(natoms) 
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: formula
    character(len=*), intent(in), optional :: chirality
    character(len=*), intent(in), optional :: role



#ifndef DUMMYLIB
    call cmlStartMolecule(xf &
,dictRef,convention,title,id,ref,formula,chirality,role)
    call cmlAddAtoms(xf, natoms, elements, atomRefs, coords, occupancies, atomIds, style, fmt)
    call cmlEndMolecule(xf)
#endif

  end subroutine cmlAddMoleculesp_sh


  subroutine cmlAddMolecule_3_sp(xf, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt &
,dictRef,convention,title,id,ref,formula,chirality,role)
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)              :: x(:)
    real(kind=sp), intent(in)              :: y(:)
    real(kind=sp), intent(in)              :: z(:)
    character(len=*), intent(in)           :: elements(:)
    character(len=*), intent(in), optional :: atomRefs(:) 
    character(len=*), intent(in), optional :: atomIds(:) 
    real(kind=sp), intent(in), optional :: occupancies(:) 
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: formula
    character(len=*), intent(in), optional :: chirality
    character(len=*), intent(in), optional :: role



#ifndef DUMMYLIB
    call cmlStartMolecule(xf &
,dictRef,convention,title,id,ref,formula,chirality,role)
    call cmlAddAtoms(xf, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt)
    call cmlEndMolecule(xf)
#endif

  end subroutine cmlAddMolecule_3_sp


  subroutine cmlAddMolecule_3_sp_sh(xf, natoms, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt &
,dictRef,convention,title,id,ref,formula,chirality,role)
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) :: natoms
    real(kind=sp), intent(in)              :: x(natoms)
    real(kind=sp), intent(in)              :: y(natoms)
    real(kind=sp), intent(in)              :: z(natoms)
    character(len=*), intent(in)           :: elements(natoms)
    character(len=*), intent(in), optional :: atomRefs(natoms)
    character(len=*), intent(in), optional :: atomIds(natoms)
    real(kind=sp), intent(in), optional :: occupancies(natoms)
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: formula
    character(len=*), intent(in), optional :: chirality
    character(len=*), intent(in), optional :: role



#ifndef DUMMYLIB
    call cmlStartMolecule(xf &
,dictRef,convention,title,id,ref,formula,chirality,role)
    call cmlAddAtoms(xf, natoms, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt)
    call cmlEndMolecule(xf)
#endif

  end subroutine cmlAddMolecule_3_sp_sh

  subroutine cmlAddAtomssp(xf, elements, atomRefs, coords, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)              :: coords(:, :)
    character(len=*), intent(in)           :: elements(:)
    character(len=*), intent(in), optional :: atomRefs(:) 
    real(kind=sp), intent(in), optional :: occupancies(:)
    character(len=*), intent(in), optional :: atomIds(:)
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i, natoms

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, coords, elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")

    natoms = size(coords,2)

    do i = 1, natoms
      call xml_NewElement(xf, "atom")
      call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=coords(:,i), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "atom")
     enddo


    call xml_EndElement(xf, "atomArray")
#endif

  end subroutine cmlAddAtomssp

  subroutine cmlAddAtomssp_sh(xf, natoms, elements, atomRefs, coords, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) :: natoms
    real(kind=sp), intent(in)              :: coords(3, natoms)
    character(len=*), intent(in)           :: elements(natoms)
    character(len=*), intent(in), optional :: atomRefs(natoms) 
    real(kind=sp), intent(in), optional :: occupancies(natoms) 
    character(len=*), intent(in), optional :: atomIds(natoms) 
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, coords(:,:natoms), elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")


    do i = 1, natoms
      call xml_NewElement(xf, "atom")
      call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=coords(:,i), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "atom")
     enddo


    call xml_EndElement(xf, "atomArray")
#endif

  end subroutine cmlAddAtomssp_sh

  subroutine cmlAddAtoms_3_sp(xf, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)              :: x(:)
    real(kind=sp), intent(in)              :: y(:)
    real(kind=sp), intent(in)              :: z(:)
    character(len=*), intent(in)           :: elements(:)
    character(len=*), intent(in), optional :: atomRefs(:) 
    character(len=*), intent(in), optional :: atomIds(:) 
    real(kind=sp), intent(in), optional :: occupancies(:) 
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i, natoms

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, x, y, z, elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")

    natoms = size(x)

    do i = 1, natoms
      call xml_NewElement(xf, "atom")
      call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=(/x(i),y(i),z(i)/), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "atom")
     enddo


    call xml_EndElement(xf, "atomArray")

#endif

  end subroutine cmlAddAtoms_3_sp

  subroutine cmlAddAtoms_3_sp_sh(xf, natoms, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) :: natoms
    real(kind=sp), intent(in)              :: x(natoms)
    real(kind=sp), intent(in)              :: y(natoms)
    real(kind=sp), intent(in)              :: z(natoms)
    character(len=*), intent(in)           :: elements(natoms)
    character(len=*), intent(in), optional :: atomRefs(natoms)
    character(len=*), intent(in), optional :: atomIds(natoms)
    real(kind=sp), intent(in), optional :: occupancies(natoms)
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, x(:natoms), y(:natoms), z(:natoms), elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")


    do i = 1, natoms
      call xml_NewElement(xf, "atom")
      call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=(/x(i),y(i),z(i)/), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "atom")
     enddo


    call xml_EndElement(xf, "atomArray")
#endif

  end subroutine cmlAddAtoms_3_sp_sh

  subroutine cmlAddParticlessp(xf, elements, atomRefs, coords, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)              :: coords(:, :)
    character(len=*), intent(in), optional :: elements(:)
    character(len=*), intent(in), optional :: atomRefs(:) 
    real(kind=sp), intent(in), optional :: occupancies(:)
    character(len=*), intent(in), optional :: atomIds(:)
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i, natoms

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, coords, elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")

    natoms = size(coords,2)

    do i = 1, natoms
      call xml_NewElement(xf, "particle")
      if (present(elements)) call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=coords(:,i), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "particle")
     enddo


    call xml_EndElement(xf, "atomArray")
#endif

  end subroutine cmlAddParticlessp

  subroutine cmlAddParticlessp_sh(xf, natoms, elements, atomRefs, coords, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) :: natoms
    real(kind=sp), intent(in)              :: coords(3, natoms)
    character(len=*), intent(in), optional :: elements(natoms)
    character(len=*), intent(in), optional :: atomRefs(natoms) 
    real(kind=sp), intent(in), optional :: occupancies(natoms) 
    character(len=*), intent(in), optional :: atomIds(natoms) 
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, coords(:,:natoms), elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")


    do i = 1, natoms
      call xml_NewElement(xf, "particle")
      if (present(elements)) call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=coords(:,i), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "particle")
     enddo


    call xml_EndElement(xf, "atomArray")
#endif

  end subroutine cmlAddParticlessp_sh

  subroutine cmlAddParticles_3_sp(xf, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)              :: x(:)
    real(kind=sp), intent(in)              :: y(:)
    real(kind=sp), intent(in)              :: z(:)
    character(len=*), intent(in), optional :: elements(:)
    character(len=*), intent(in), optional :: atomRefs(:) 
    character(len=*), intent(in), optional :: atomIds(:) 
    real(kind=sp), intent(in), optional :: occupancies(:) 
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i, natoms

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, x, y, z, elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")

    natoms = size(x)

    do i = 1, natoms
      call xml_NewElement(xf, "particle")
      if (present(elements)) call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=(/x(i),y(i),z(i)/), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "particle")
     enddo


    call xml_EndElement(xf, "atomArray")

#endif

  end subroutine cmlAddParticles_3_sp

  subroutine cmlAddParticles_3_sp_sh(xf, natoms, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) :: natoms
    real(kind=sp), intent(in)              :: x(natoms)
    real(kind=sp), intent(in)              :: y(natoms)
    real(kind=sp), intent(in)              :: z(natoms)
    character(len=*), intent(in), optional :: elements(natoms)
    character(len=*), intent(in), optional :: atomRefs(natoms)
    character(len=*), intent(in), optional :: atomIds(natoms)
    real(kind=sp), intent(in), optional :: occupancies(natoms)
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, x(:natoms), y(:natoms), z(:natoms), elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")


    do i = 1, natoms
      call xml_NewElement(xf, "particle")
      if (present(elements)) call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=(/x(i),y(i),z(i)/), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "particle")
     enddo


    call xml_EndElement(xf, "atomArray")
#endif

  end subroutine cmlAddParticles_3_sp_sh

#ifndef DUMMYLIB

  subroutine cmlAddCoords_sp(xf, coords, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in), dimension(:) :: coords
    character(len=*), intent(in), optional  :: style
    character(len=*), intent(in), optional  :: fmt

    if (present(style)) then
      select case(style)
      case ("x3") 
        call addcoords_x3_sp(xf, coords, fmt)
      case ("cartesian") 
        call addcoords_x3_sp(xf, coords, fmt)
      case ("xFrac")
        call addcoords_xfrac_sp(xf, coords, fmt)
      case ("fractional")
        call addcoords_xfrac_sp(xf, coords, fmt)
      case ("xyz3")
        call addcoords_xyz3_sp(xf, coords, fmt)
      case ("xyzFrac")
        call addcoords_xyzfrac_sp(xf, coords, fmt)
      case default
        call FoX_error("Invalid style specification for atomic coordinates")
      end select
    else
      call addcoords_x3_sp(xf, coords, fmt)
    endif

  end subroutine cmlAddCoords_sp

  subroutine addcoords_xyz3_sp(xf, coords, fmt)
    type(xmlf_t), intent(inout)              :: xf
    real(kind=sp), intent(in), dimension(:) :: coords
    character(len=*), intent(in), optional   :: fmt

    select case (size(coords))
    case (2)
      call xml_AddAttribute(xf, "xy2", coords,fmt)
    case(3)
      call xml_AddAttribute(xf, "xyz3", coords,fmt)
    end select

  end subroutine addcoords_xyz3_sp


  subroutine addcoords_xyzfrac_sp(xf, coords, fmt)
    type(xmlf_t), intent(inout)             :: xf
    real(kind=sp), intent(in), dimension(:) :: coords
    character(len=*), intent(in), optional  :: fmt

    select case (size(coords))
    case (2)
      call xml_AddAttribute(xf, "xyFract", coords, fmt)
    case(3)
      call xml_AddAttribute(xf, "xyzFract", coords, fmt)
    end select

  end subroutine addcoords_xyzfrac_sp


  subroutine addcoords_x3_sp(xf, coords, fmt)
    type(xmlf_t), intent(inout)            :: xf
    real(kind=sp), intent(in), dimension(:):: coords
    character(len=*), intent(in), optional :: fmt

    select case(size(coords))
    case(2)
      call xml_AddAttribute(xf, "x2", coords(1), fmt)
      call xml_AddAttribute(xf, "y2", coords(2), fmt)
    case(3)
      call xml_AddAttribute(xf, "x3", coords(1), fmt)
      call xml_AddAttribute(xf, "y3", coords(2), fmt)
      call xml_AddAttribute(xf, "z3", coords(3), fmt)
    end select

  end subroutine addcoords_x3_sp


  subroutine addcoords_xfrac_sp(xf, coords, fmt)
    type(xmlf_t), intent(inout)             :: xf
    real(kind=sp), intent(in), dimension(:) :: coords
    character(len=*), intent(in), optional  :: fmt

    call xml_AddAttribute(xf, "xFract", coords(1), fmt)
    call xml_AddAttribute(xf, "yFract", coords(2), fmt)
    call xml_AddAttribute(xf, "zFract", coords(3), fmt)

  end subroutine addcoords_xfrac_sp

  subroutine addDlpolyMatrix_sp(xf, coords, elems)
    type(xmlf_t), intent(inout)                :: xf
    real(kind=sp), intent(in), dimension(:, :) :: coords
    character(len=2), intent(in), dimension(:) :: elems

    integer :: natoms, i

    natoms = size(elems)
    
    call xml_NewElement(xf, "matrix")
    call xml_AddAttribute(xf, "nrows", size(elems))
    call xml_AddAttribute(xf, "ncols", 11)
    call xml_AddAttribute(xf, "dataType", "xsd:string")
    
    call xml_AddNewline(xf)
    do i = 1, natoms
      call xml_AddCharacters(xf, elems(i)//"  "//str(i))
      call xml_AddNewline(xf)
      call xml_AddCharacters(xf, str(coords(1,i))//" "//str(coords(2,i))//" "//str(coords(3,i)))
      call xml_AddNewline(xf)
      call xml_AddCharacters(xf, "0 0 0")
      call xml_AddNewline(xf)
      call xml_AddCharacters(xf, "0 0 0")
      call xml_AddNewline(xf)
    enddo
    call xml_EndElement(xf, "matrix")
  end subroutine addDlpolyMatrix_sp

  subroutine addDlpolyMatrix_3_sp(xf, x, y, z, elems)
    type(xmlf_t), intent(inout)                :: xf
    real(kind=sp), intent(in), dimension(:)    :: x, y, z
    character(len=2), intent(in), dimension(:) :: elems

    integer :: natoms, i

    natoms = size(elems)
    
    call xml_NewElement(xf, "matrix")
    call xml_AddAttribute(xf, "nrows", size(elems))
    call xml_AddAttribute(xf, "ncols", 11)
    call xml_AddAttribute(xf, "dataType", "xsd:string")
    
    call xml_AddNewline(xf)
    do i = 1, natoms
      call xml_AddCharacters(xf, elems(i)//"  "//str(i))
      call xml_AddNewline(xf)
      call xml_AddCharacters(xf, str(x(i))//" "//str(y(i))//" "//str(z(i)))
      call xml_AddNewline(xf)
      call xml_AddCharacters(xf, "0 0 0")
      call xml_AddNewline(xf)
      call xml_AddCharacters(xf, "0 0 0")
      call xml_AddNewline(xf)
    enddo
    call xml_EndElement(xf, "matrix")
  end subroutine addDlpolyMatrix_3_sp
#endif



  subroutine cmlAddMoleculedp(xf, elements, atomRefs, coords, occupancies, atomIds, style, fmt &
,dictRef,convention,title,id,ref,formula,chirality,role)
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)              :: coords(:, :)
    character(len=*), intent(in)           :: elements(:)
    character(len=*), intent(in), optional :: atomRefs(:) 
    real(kind=dp), intent(in), optional :: occupancies(:)
    character(len=*), intent(in), optional :: atomIds(:)
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: formula
    character(len=*), intent(in), optional :: chirality
    character(len=*), intent(in), optional :: role



#ifndef DUMMYLIB

    call cmlStartMolecule(xf &
,dictRef,convention,title,id,ref,formula,chirality,role)
    call cmlAddAtoms(xf, elements, atomRefs, coords, occupancies, atomIds, style, fmt)
    call cmlEndMolecule(xf)

#endif DUMMYLIB

  end subroutine cmlAddMoleculedp


  subroutine cmlAddMoleculedp_sh(xf, natoms, elements, atomRefs, coords, occupancies, atomIds, style, fmt &
,dictRef,convention,title,id,ref,formula,chirality,role)
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) :: natoms
    real(kind=dp), intent(in)              :: coords(3, natoms)
    character(len=*), intent(in)           :: elements(natoms)
    character(len=*), intent(in), optional :: atomRefs(natoms) 
    real(kind=dp), intent(in), optional :: occupancies(natoms) 
    character(len=*), intent(in), optional :: atomIds(natoms) 
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: formula
    character(len=*), intent(in), optional :: chirality
    character(len=*), intent(in), optional :: role



#ifndef DUMMYLIB
    call cmlStartMolecule(xf &
,dictRef,convention,title,id,ref,formula,chirality,role)
    call cmlAddAtoms(xf, natoms, elements, atomRefs, coords, occupancies, atomIds, style, fmt)
    call cmlEndMolecule(xf)
#endif

  end subroutine cmlAddMoleculedp_sh


  subroutine cmlAddMolecule_3_dp(xf, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt &
,dictRef,convention,title,id,ref,formula,chirality,role)
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)              :: x(:)
    real(kind=dp), intent(in)              :: y(:)
    real(kind=dp), intent(in)              :: z(:)
    character(len=*), intent(in)           :: elements(:)
    character(len=*), intent(in), optional :: atomRefs(:) 
    character(len=*), intent(in), optional :: atomIds(:) 
    real(kind=dp), intent(in), optional :: occupancies(:) 
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: formula
    character(len=*), intent(in), optional :: chirality
    character(len=*), intent(in), optional :: role



#ifndef DUMMYLIB
    call cmlStartMolecule(xf &
,dictRef,convention,title,id,ref,formula,chirality,role)
    call cmlAddAtoms(xf, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt)
    call cmlEndMolecule(xf)
#endif

  end subroutine cmlAddMolecule_3_dp


  subroutine cmlAddMolecule_3_dp_sh(xf, natoms, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt &
,dictRef,convention,title,id,ref,formula,chirality,role)
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) :: natoms
    real(kind=dp), intent(in)              :: x(natoms)
    real(kind=dp), intent(in)              :: y(natoms)
    real(kind=dp), intent(in)              :: z(natoms)
    character(len=*), intent(in)           :: elements(natoms)
    character(len=*), intent(in), optional :: atomRefs(natoms)
    character(len=*), intent(in), optional :: atomIds(natoms)
    real(kind=dp), intent(in), optional :: occupancies(natoms)
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: formula
    character(len=*), intent(in), optional :: chirality
    character(len=*), intent(in), optional :: role



#ifndef DUMMYLIB
    call cmlStartMolecule(xf &
,dictRef,convention,title,id,ref,formula,chirality,role)
    call cmlAddAtoms(xf, natoms, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt)
    call cmlEndMolecule(xf)
#endif

  end subroutine cmlAddMolecule_3_dp_sh

  subroutine cmlAddAtomsdp(xf, elements, atomRefs, coords, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)              :: coords(:, :)
    character(len=*), intent(in)           :: elements(:)
    character(len=*), intent(in), optional :: atomRefs(:) 
    real(kind=dp), intent(in), optional :: occupancies(:)
    character(len=*), intent(in), optional :: atomIds(:)
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i, natoms

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, coords, elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")

    natoms = size(coords,2)

    do i = 1, natoms
      call xml_NewElement(xf, "atom")
      call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=coords(:,i), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "atom")
     enddo


    call xml_EndElement(xf, "atomArray")
#endif

  end subroutine cmlAddAtomsdp

  subroutine cmlAddAtomsdp_sh(xf, natoms, elements, atomRefs, coords, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) :: natoms
    real(kind=dp), intent(in)              :: coords(3, natoms)
    character(len=*), intent(in)           :: elements(natoms)
    character(len=*), intent(in), optional :: atomRefs(natoms) 
    real(kind=dp), intent(in), optional :: occupancies(natoms) 
    character(len=*), intent(in), optional :: atomIds(natoms) 
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, coords(:,:natoms), elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")


    do i = 1, natoms
      call xml_NewElement(xf, "atom")
      call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=coords(:,i), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "atom")
     enddo


    call xml_EndElement(xf, "atomArray")
#endif

  end subroutine cmlAddAtomsdp_sh

  subroutine cmlAddAtoms_3_dp(xf, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)              :: x(:)
    real(kind=dp), intent(in)              :: y(:)
    real(kind=dp), intent(in)              :: z(:)
    character(len=*), intent(in)           :: elements(:)
    character(len=*), intent(in), optional :: atomRefs(:) 
    character(len=*), intent(in), optional :: atomIds(:) 
    real(kind=dp), intent(in), optional :: occupancies(:) 
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i, natoms

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, x, y, z, elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")

    natoms = size(x)

    do i = 1, natoms
      call xml_NewElement(xf, "atom")
      call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=(/x(i),y(i),z(i)/), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "atom")
     enddo


    call xml_EndElement(xf, "atomArray")

#endif

  end subroutine cmlAddAtoms_3_dp

  subroutine cmlAddAtoms_3_dp_sh(xf, natoms, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) :: natoms
    real(kind=dp), intent(in)              :: x(natoms)
    real(kind=dp), intent(in)              :: y(natoms)
    real(kind=dp), intent(in)              :: z(natoms)
    character(len=*), intent(in)           :: elements(natoms)
    character(len=*), intent(in), optional :: atomRefs(natoms)
    character(len=*), intent(in), optional :: atomIds(natoms)
    real(kind=dp), intent(in), optional :: occupancies(natoms)
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, x(:natoms), y(:natoms), z(:natoms), elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")


    do i = 1, natoms
      call xml_NewElement(xf, "atom")
      call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=(/x(i),y(i),z(i)/), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "atom")
     enddo


    call xml_EndElement(xf, "atomArray")
#endif

  end subroutine cmlAddAtoms_3_dp_sh

  subroutine cmlAddParticlesdp(xf, elements, atomRefs, coords, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)              :: coords(:, :)
    character(len=*), intent(in), optional :: elements(:)
    character(len=*), intent(in), optional :: atomRefs(:) 
    real(kind=dp), intent(in), optional :: occupancies(:)
    character(len=*), intent(in), optional :: atomIds(:)
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i, natoms

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, coords, elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")

    natoms = size(coords,2)

    do i = 1, natoms
      call xml_NewElement(xf, "particle")
      if (present(elements)) call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=coords(:,i), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "particle")
     enddo


    call xml_EndElement(xf, "atomArray")
#endif

  end subroutine cmlAddParticlesdp

  subroutine cmlAddParticlesdp_sh(xf, natoms, elements, atomRefs, coords, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) :: natoms
    real(kind=dp), intent(in)              :: coords(3, natoms)
    character(len=*), intent(in), optional :: elements(natoms)
    character(len=*), intent(in), optional :: atomRefs(natoms) 
    real(kind=dp), intent(in), optional :: occupancies(natoms) 
    character(len=*), intent(in), optional :: atomIds(natoms) 
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, coords(:,:natoms), elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")


    do i = 1, natoms
      call xml_NewElement(xf, "particle")
      if (present(elements)) call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=coords(:,i), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "particle")
     enddo


    call xml_EndElement(xf, "atomArray")
#endif

  end subroutine cmlAddParticlesdp_sh

  subroutine cmlAddParticles_3_dp(xf, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)              :: x(:)
    real(kind=dp), intent(in)              :: y(:)
    real(kind=dp), intent(in)              :: z(:)
    character(len=*), intent(in), optional :: elements(:)
    character(len=*), intent(in), optional :: atomRefs(:) 
    character(len=*), intent(in), optional :: atomIds(:) 
    real(kind=dp), intent(in), optional :: occupancies(:) 
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i, natoms

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, x, y, z, elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")

    natoms = size(x)

    do i = 1, natoms
      call xml_NewElement(xf, "particle")
      if (present(elements)) call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=(/x(i),y(i),z(i)/), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "particle")
     enddo


    call xml_EndElement(xf, "atomArray")

#endif

  end subroutine cmlAddParticles_3_dp

  subroutine cmlAddParticles_3_dp_sh(xf, natoms, elements, x, y, z, atomRefs, occupancies, atomIds, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) :: natoms
    real(kind=dp), intent(in)              :: x(natoms)
    real(kind=dp), intent(in)              :: y(natoms)
    real(kind=dp), intent(in)              :: z(natoms)
    character(len=*), intent(in), optional :: elements(natoms)
    character(len=*), intent(in), optional :: atomRefs(natoms)
    character(len=*), intent(in), optional :: atomIds(natoms)
    real(kind=dp), intent(in), optional :: occupancies(natoms)
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: style

#ifndef DUMMYLIB
    integer          :: i

    if (present(style)) then
      if (style=="DL_POLY") then
        if (present(atomRefs).or.present(occupancies).or.present(atomIds).or.present(fmt)) &
          call FoX_error("With DL_POLY style, no optional arguments permitted.")
        call addDlpolyMatrix(xf, x(:natoms), y(:natoms), z(:natoms), elements)
        return
      endif
    endif


    call xml_NewElement(xf, "atomArray")


    do i = 1, natoms
      call xml_NewElement(xf, "particle")
      if (present(elements)) call xml_AddAttribute(xf, "elementType", trim(elements(i)))
      call cmlAddCoords(xf, coords=(/x(i),y(i),z(i)/), style=style, fmt=fmt)
      if (present(occupancies)) call xml_AddAttribute(xf, "occupancy", occupancies(i))
      if (present(atomRefs)) call xml_AddAttribute(xf, "ref", atomRefs(i))
      if (present(atomIds)) call xml_AddAttribute(xf, "id", atomIds(i))
      call xml_EndElement(xf, "particle")
     enddo


    call xml_EndElement(xf, "atomArray")
#endif

  end subroutine cmlAddParticles_3_dp_sh

#ifndef DUMMYLIB

  subroutine cmlAddCoords_dp(xf, coords, style, fmt)
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in), dimension(:) :: coords
    character(len=*), intent(in), optional  :: style
    character(len=*), intent(in), optional  :: fmt

    if (present(style)) then
      select case(style)
      case ("x3") 
        call addcoords_x3_dp(xf, coords, fmt)
      case ("cartesian") 
        call addcoords_x3_dp(xf, coords, fmt)
      case ("xFrac")
        call addcoords_xfrac_dp(xf, coords, fmt)
      case ("fractional")
        call addcoords_xfrac_dp(xf, coords, fmt)
      case ("xyz3")
        call addcoords_xyz3_dp(xf, coords, fmt)
      case ("xyzFrac")
        call addcoords_xyzfrac_dp(xf, coords, fmt)
      case default
        call FoX_error("Invalid style specification for atomic coordinates")
      end select
    else
      call addcoords_x3_dp(xf, coords, fmt)
    endif

  end subroutine cmlAddCoords_dp

  subroutine addcoords_xyz3_dp(xf, coords, fmt)
    type(xmlf_t), intent(inout)              :: xf
    real(kind=dp), intent(in), dimension(:) :: coords
    character(len=*), intent(in), optional   :: fmt

    select case (size(coords))
    case (2)
      call xml_AddAttribute(xf, "xy2", coords,fmt)
    case(3)
      call xml_AddAttribute(xf, "xyz3", coords,fmt)
    end select

  end subroutine addcoords_xyz3_dp


  subroutine addcoords_xyzfrac_dp(xf, coords, fmt)
    type(xmlf_t), intent(inout)             :: xf
    real(kind=dp), intent(in), dimension(:) :: coords
    character(len=*), intent(in), optional  :: fmt

    select case (size(coords))
    case (2)
      call xml_AddAttribute(xf, "xyFract", coords, fmt)
    case(3)
      call xml_AddAttribute(xf, "xyzFract", coords, fmt)
    end select

  end subroutine addcoords_xyzfrac_dp


  subroutine addcoords_x3_dp(xf, coords, fmt)
    type(xmlf_t), intent(inout)            :: xf
    real(kind=dp), intent(in), dimension(:):: coords
    character(len=*), intent(in), optional :: fmt

    select case(size(coords))
    case(2)
      call xml_AddAttribute(xf, "x2", coords(1), fmt)
      call xml_AddAttribute(xf, "y2", coords(2), fmt)
    case(3)
      call xml_AddAttribute(xf, "x3", coords(1), fmt)
      call xml_AddAttribute(xf, "y3", coords(2), fmt)
      call xml_AddAttribute(xf, "z3", coords(3), fmt)
    end select

  end subroutine addcoords_x3_dp


  subroutine addcoords_xfrac_dp(xf, coords, fmt)
    type(xmlf_t), intent(inout)             :: xf
    real(kind=dp), intent(in), dimension(:) :: coords
    character(len=*), intent(in), optional  :: fmt

    call xml_AddAttribute(xf, "xFract", coords(1), fmt)
    call xml_AddAttribute(xf, "yFract", coords(2), fmt)
    call xml_AddAttribute(xf, "zFract", coords(3), fmt)

  end subroutine addcoords_xfrac_dp

  subroutine addDlpolyMatrix_dp(xf, coords, elems)
    type(xmlf_t), intent(inout)                :: xf
    real(kind=dp), intent(in), dimension(:, :) :: coords
    character(len=2), intent(in), dimension(:) :: elems

    integer :: natoms, i

    natoms = size(elems)
    
    call xml_NewElement(xf, "matrix")
    call xml_AddAttribute(xf, "nrows", size(elems))
    call xml_AddAttribute(xf, "ncols", 11)
    call xml_AddAttribute(xf, "dataType", "xsd:string")
    
    call xml_AddNewline(xf)
    do i = 1, natoms
      call xml_AddCharacters(xf, elems(i)//"  "//str(i))
      call xml_AddNewline(xf)
      call xml_AddCharacters(xf, str(coords(1,i))//" "//str(coords(2,i))//" "//str(coords(3,i)))
      call xml_AddNewline(xf)
      call xml_AddCharacters(xf, "0 0 0")
      call xml_AddNewline(xf)
      call xml_AddCharacters(xf, "0 0 0")
      call xml_AddNewline(xf)
    enddo
    call xml_EndElement(xf, "matrix")
  end subroutine addDlpolyMatrix_dp

  subroutine addDlpolyMatrix_3_dp(xf, x, y, z, elems)
    type(xmlf_t), intent(inout)                :: xf
    real(kind=dp), intent(in), dimension(:)    :: x, y, z
    character(len=2), intent(in), dimension(:) :: elems

    integer :: natoms, i

    natoms = size(elems)
    
    call xml_NewElement(xf, "matrix")
    call xml_AddAttribute(xf, "nrows", size(elems))
    call xml_AddAttribute(xf, "ncols", 11)
    call xml_AddAttribute(xf, "dataType", "xsd:string")
    
    call xml_AddNewline(xf)
    do i = 1, natoms
      call xml_AddCharacters(xf, elems(i)//"  "//str(i))
      call xml_AddNewline(xf)
      call xml_AddCharacters(xf, str(x(i))//" "//str(y(i))//" "//str(z(i)))
      call xml_AddNewline(xf)
      call xml_AddCharacters(xf, "0 0 0")
      call xml_AddNewline(xf)
      call xml_AddCharacters(xf, "0 0 0")
      call xml_AddNewline(xf)
    enddo
    call xml_EndElement(xf, "matrix")
  end subroutine addDlpolyMatrix_3_dp
#endif



end module m_wcml_molecule

program test

  use FoX_wcml
  use FoX_common, only: str
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  call cmlBeginFile(xf, filename, unit=-1)
  call cmlStartCml(xf)
  call cmlAddProperty(xf, title="name", &
    value=reshape((/"value1", "value2", "value3", "value4"/), (/2,2/)))

  call cmlFinishFile(xf)

end program test

module m_sax_xml_source

#ifndef DUMMYLIB
  use fox_m_fsys_array_str, only: str_vs, vs_str_alloc
  use fox_m_fsys_format, only: operator(//)
  use m_common_error,  only: error_stack, add_error, in_error
  use m_common_charset, only: XML_WHITESPACE, XML_INITIALENCODINGCHARS, &
    XML_ENCODINGCHARS, XML1_0, XML1_1, isXML1_0_NameChar, &
    isLegalChar, isUSASCII, allowed_encoding
  use m_common_io, only: io_eor, io_eof
  
  use FoX_utils, only: URI

  implicit none
  private

  type buffer_t
    character, dimension(:), pointer :: s
    integer :: pos = 1
  end type buffer_t

  type xml_source_t
    !FIXME private
    integer            :: lun = -1
    integer            :: xml_version = XML1_0
    character, pointer :: encoding(:) => null()
    logical            :: isUSASCII
    character, pointer :: filename(:) => null()
    type(URI), pointer :: baseURI => null()
    integer            :: line = 0
    integer            :: col = 0
    integer            :: startChar = 1 ! First character after XML decl
    character, pointer :: next_chars(:) => null()   ! pushback buffer
    type(buffer_t), pointer :: input_string => null()
    logical :: pe = .false. ! is this a parameter entity?
    logical :: eof = .false.! need to keep track of this at the end of pes
  end type xml_source_t

  public :: buffer_t
  public :: xml_source_t

  public :: get_char_from_file
  public :: push_file_chars
  public :: parse_declaration

contains


  function get_char_from_file(f, xv, eof, es) result(string)
    type(xml_source_t), intent(inout) :: f
    integer, intent(in) :: xv
    logical, intent(out) :: eof
    type(error_stack), intent(inout) :: es
    character(len=1) :: string

    integer :: iostat
    logical :: pending
    character :: c, c2

    pending = .false.
    eof = .false.
    c = read_single_char(f, iostat)
    if (iostat==io_eof) then
      eof = .true.
      return
    elseif (iostat/=0) then
      call add_error(es, "Error reading "//str_vs(f%filename))
      return
    endif
    if (.not.isLegalChar(c, f%isUSASCII, xv)) then
      call add_error(es, "Illegal character found at " &
        //str_vs(f%filename)//":"//f%line//":"//f%col)
      return
    endif
    if (c==achar(13)) then
      c = achar(10)
      c2 = read_single_char(f, iostat)
      if (iostat==io_eof) then
        ! the file has just ended on a single CR. Report is as a LF.
        ! Ignore the eof just now, it'll be picked up if we need to 
        ! perform another read.
        eof = .false.
      elseif (iostat/=0) then
        call add_error(es, "Error reading "//str_vs(f%filename))
        return
      elseif (c2/=achar(10)) then
        ! then we keep c2, otherwise we'd just ignore it.
        pending = .true.
      endif
    endif
    string = c

    if (pending) then
      ! we have one character left over, put in the pushback buffer
      deallocate(f%next_chars)
      allocate(f%next_chars(1))
      f%next_chars = c2
    endif

    if (c==achar(10)) then
      f%line = f%line + 1
      f%col = 0
    else
      f%col = f%col + 1
    endif

  end function get_char_from_file

  function read_single_char(f, iostat) result(c)
    type(xml_source_t), intent(inout) :: f
    integer, intent(out) :: iostat
    character :: c

    if (f%eof) then
      c = ""
      iostat = io_eof
      return
    endif
    if (f%lun==-1) then
      if (f%input_string%pos>size(f%input_string%s)) then
        c = ""
        if (f%pe) then
          iostat = 0
        else
          iostat = io_eof
        endif
        f%eof = .true.
      else
        iostat = 0
        c = f%input_string%s(f%input_string%pos)
        f%input_string%pos = f%input_string%pos + 1
      endif
    else
      read (unit=f%lun, iostat=iostat, advance="no", fmt="(a1)") c
      if (iostat==io_eor) then
        iostat = 0
#ifdef FC_EOR_LF
        c = achar(10)
#else
        c = achar(13)
#endif
      elseif (iostat==io_eof) then
        if (f%pe) iostat = 0
        c = ""
        f%eof = .true.
      endif
    endif
  end function read_single_char

  subroutine rewind_source(f)
    type(xml_source_t), intent(inout) :: f

    if (f%lun==-1) then
      f%input_string%pos = 1
    else
      rewind(f%lun)
    endif
  end subroutine rewind_source

  subroutine push_file_chars(f, s)
    type(xml_source_t), intent(inout) :: f
    character(len=*), intent(in) :: s
    character, dimension(:), pointer :: nc

    nc => vs_str_alloc(s//str_vs(f%next_chars))
    deallocate(f%next_chars)
    f%next_chars => nc

  end subroutine push_file_chars


  subroutine parse_declaration(f, eof, es, standalone)
    type(xml_source_t), intent(inout) :: f
    logical, intent(out) :: eof
    type(error_stack), intent(inout) :: es
    logical, intent(out), optional :: standalone

    integer :: parse_state, xd_par
    character :: c, q
    character, pointer :: ch(:), ch2(:)

    integer, parameter :: XD_0      = 0
    integer, parameter :: XD_START  = 1
    integer, parameter :: XD_TARGET = 2
    integer, parameter :: XD_MISC   = 3
    integer, parameter :: XD_PA     = 4
    integer, parameter :: XD_EQ     = 5
    integer, parameter :: XD_QUOTE  = 6
    integer, parameter :: XD_PV     = 7
    integer, parameter :: XD_END    = 8
    integer, parameter :: XD_SPACE  = 9

    integer, parameter :: xd_nothing = 0
    integer, parameter :: xd_version = 1
    integer, parameter :: xd_encoding = 2
    integer, parameter :: xd_standalone = 3

    f%xml_version = XML1_0
    if (present(standalone)) standalone = .false.

    f%startChar = 1

    parse_state = XD_0
    xd_par = xd_nothing
    ch => null()
    do
      c = get_char_from_file(f, XML1_0, eof, es)
      if (eof) then
        call rewind_source(f)
        exit
      elseif (in_error(es)) then
        goto 100
      endif
      f%startChar = f%startChar + 1

      select case (parse_state)

      case (XD_0)
        if (c=="<") then
          parse_state = XD_START
        else
          call rewind_source(f)
          exit
        endif

      case (XD_START)
        if (c=="?") then
          parse_state = XD_TARGET
          ch => vs_str_alloc("")
        else
          call rewind_source(f)
          exit
        endif

      case (XD_TARGET)
        if (isXML1_0_NameChar(c)) then
          ch2 => vs_str_alloc(str_vs(ch)//c)
          deallocate(ch)
          ch => ch2
        elseif (verify(c, XML_WHITESPACE)==0 &
          .and.str_vs(ch)=="xml") then
          deallocate(ch)
          parse_state = XD_MISC
        else
          call rewind_source(f)
          deallocate(ch)
          exit
        endif

      case (XD_SPACE)
        if (verify(c, XML_WHITESPACE)==0) then
          parse_state = XD_MISC
        elseif (c=="?") then
          parse_state = XD_END
        else
          call add_error(es, &
            "Missing space in XML declaration")
        endif

      case (XD_MISC)
        if (c=="?") then
          parse_state = XD_END
        elseif (isXML1_0_NameChar(c)) then
          ch => vs_str_alloc(c)
          parse_state = XD_PA
        elseif (verify(c, XML_WHITESPACE)>0) then
          call add_error(es, &
            "Unexpected character in XML declaration")
        endif

      case (XD_PA)
        if (isXML1_0_NameChar(c)) then
          ch2 => vs_str_alloc(str_vs(ch)//c)
          deallocate(ch)
          ch => ch2
        elseif (verify(c, XML_WHITESPACE//"=")==0) then
          select case (str_vs(ch))

          case ("version")
            select case (xd_par)
            case (xd_nothing)
              xd_par = xd_version
            case default
              call add_error(es, &
                "Cannot specify version twice in XML declaration")
            end select

          case ("encoding")
            select case (xd_par)
            case (xd_nothing)
              if (present(standalone)) then
                call add_error(es, &
                  "Must specify version before encoding in XML declaration")
              else
                xd_par = xd_encoding
              endif
            case (xd_version)
              xd_par = xd_encoding
            case (xd_encoding)
              call add_error(es, &
                "Cannot specify encoding twice in XML declaration")
            case (xd_standalone)
              call add_error(es, &
                "Cannot specify encoding after standalone in XML declaration")
            end select

          case ("standalone")
            if (.not.present(standalone)) &
              call add_error(es, &
              "Cannot specify standalone in text declaration")
            select case (xd_par)
            case (xd_nothing)
              call add_error(es, &
                "Must specify version before standalone in XML declaration")
            case (xd_version, xd_encoding)
              xd_par = xd_standalone
            case (xd_standalone)
              call add_error(es, &
                "Cannot specify standalone twice in XML declaration")
            end select

          case default
            call add_error(es, &
              "Unknown parameter "//str_vs(ch)//" in XML declaration, "//&
              "expecting version, encoding or standalone")

          end select

          deallocate(ch)
          if (c=="=") then
            parse_state = XD_QUOTE
          else
            parse_state = XD_EQ
          endif
        else
          call add_error(es, &
            "Unexpected character found in XML declaration")
        endif

      case (XD_EQ)
        if (c=="=") then
          parse_state = XD_QUOTE
        elseif (verify(c, XML_WHITESPACE)>0) then
          call add_error(es, &
            "Unexpected character found in XML declaration; expecting ""=""")
        endif

      case (XD_QUOTE)
        if (verify(c, "'""")==0) then
          q = c
          parse_state = XD_PV
          ch => vs_str_alloc("")
        elseif (verify(c, XML_WHITESPACE)>0) then
          call add_error(es, &
            "Unexpected character found in XML declaration; expecting "" or '")
        endif

      case (XD_PV)
        if (c==q) then
          select case (xd_par)
          case (xd_version)
            if (str_vs(ch)//"x"=="1.0x") then
              f%xml_version = XML1_0
              deallocate(ch)
            elseif (str_vs(ch)//"x"=="1.1x") then
              f%xml_version = XML1_1
              deallocate(ch)
            else
              call add_error(es, &
                "Unknown version number "//str_vs(ch)//" found in XML declaration; expecting 1.0 or 1.1")
            endif
          case (xd_encoding)
            if (size(ch)==0) then
              call add_error(es, &
                "Empty value for encoding not allowed in XML declaration")
            elseif (size(ch)==1.and.verify(ch(1), XML_INITIALENCODINGCHARS)>0) then
              call add_error(es, &
                "Invalid encoding found in XML declaration; illegal characters in encoding name")
            elseif (size(ch)>1.and. &
              (verify(ch(1), XML_INITIALENCODINGCHARS)>0 &
              .or.verify(str_vs(ch(2:)), XML_ENCODINGCHARS)>0)) then
              call add_error(es, &
                "Invalid encoding found in XML declaration; illegal characters in encoding name")
            elseif (.not.allowed_encoding(str_vs(ch))) then
              call add_error(es, "Unknown character encoding in XML declaration")
            else
              f%encoding => ch
              f%isUSASCII = isUSASCII(str_vs(ch))
              ch => null()
            endif
          case (xd_standalone)
            if (str_vs(ch)//"x"=="yesx") then
              standalone = .true.
              deallocate(ch)
            elseif (str_vs(ch)//"x"=="nox") then
              standalone = .false.
              deallocate(ch)
            else
              call add_error(es, &
                "Invalid value for standalone found in XML declaration; expecting yes or no")

            endif
          end select
          parse_state = XD_SPACE
        else
          ch2 => vs_str_alloc(str_vs(ch)//c)
          deallocate(ch)
          ch => ch2
        endif

      case (XD_END)
        if (c==">") then
          exit
        else
          call add_error(es, &
            "Unexpected character found in XML declaration; expecting >")
        endif

      end select

    end do

    if (.not.associated(f%encoding)) then
      if (present(standalone).or.parse_state/=XD_END) then
        f%encoding => vs_str_alloc("utf-8")
      else
        call add_error(es, "Missing encoding in text declaration")
      endif
    endif
    
100 if (associated(ch)) deallocate(ch)
    ! if there is no XML declaraion, or if parsing caused an error, then
    if (parse_state/=XD_END.or.in_error(es)) f%startChar = 1

  end subroutine parse_declaration
#endif

end module m_sax_xml_source

module m_common_realtypes

  implicit none
  private

  integer, parameter :: sp = selected_real_kind(6,30)
  integer, parameter :: dp = selected_real_kind(14,100)

  public :: sp
  public :: dp

end module m_common_realtypes

!
! This file is AUTOGENERATED
! To update, edit m_wcml_lattice.m4 and regenerate

module m_wcml_lattice

!FIXME: unimplemented bits:
! periodicity of latticevectors ...
! conversion between lattices & crystals ...
! <lattice> can also contain xtal coords or a <matrix>

  use fox_m_fsys_realtypes, only: sp, dp
  use FoX_wxml, only: xmlf_t

#ifndef DUMMYLIB
  use FoX_wxml, only: xml_NewElement, xml_EndElement
  use FoX_wxml, only: xml_AddAttribute, xml_AddCharacters

! Fix for pgi, requires this explicitly:
  use m_wxml_overloads
#endif

  implicit none
  private

  character(len=*), parameter :: U_ANGSTR = "units:angstrom"
  character(len=*), parameter :: U_DEGREE = "units:degree"

  interface cmlAddCrystal
     module procedure cmlAddCrystalSP
     module procedure cmlAddCrystalDP
  end interface

  interface cmlAddLattice
    module procedure cmlAddLatticeSP
    module procedure cmlAddLatticeDP
  end interface

  public :: cmlAddCrystal
  public :: cmlAddLattice

contains

  subroutine cmlAddCrystalsp(xf, a, b, c, alpha, beta, gamma, z,&
    id, title, dictref, convention, lenunits, angunits, spaceGroup, lenfmt, angfmt)
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)               :: a, b, c
    real(kind=sp), intent(in)               :: alpha
    real(kind=sp), intent(in)               :: beta
    real(kind=sp), intent(in)               :: gamma
    integer, intent(in), optional           :: z
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: lenunits
    character(len=*), intent(in), optional :: angunits
    character(len=*), intent(in), optional :: spaceGroup
    character(len=*), intent(in), optional :: lenfmt
    character(len=*), intent(in), optional :: angfmt

#ifndef DUMMYLIB
    call xml_NewElement(xf=xf, name="crystal")
    if (present(id))      call xml_AddAttribute(xf, "id", id)
    if (present(title))   call xml_AddAttribute(xf, "title", title)
    if (present(dictref)) call xml_AddAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_AddAttribute(xf, "convention", convention)
    if (present(z)) call xml_AddAttribute(xf, "z", z)

    call xml_NewElement(xf=xf, name="cellParameter")
    call xml_AddAttribute(xf=xf, name="latticeType", value="real")
    call xml_AddAttribute(xf=xf, name="parameterType", value="length")
    if (present(lenunits)) then
      call xml_AddAttribute(xf=xf, name="units", value=lenunits)
    else
      call xml_AddAttribute(xf=xf, name="units", value=U_ANGSTR)
    endif
    call xml_AddCharacters(xf=xf, chars=(/a, b, c/), fmt=lenfmt)
    call xml_EndElement(xf=xf, name="cellParameter")

    call xml_NewElement(xf=xf, name="cellParameter")
    call xml_AddAttribute(xf=xf, name="latticeType", value="real")
    call xml_AddAttribute(xf=xf, name="parameterType", value="angle")
    if (present(angunits)) then
      call xml_AddAttribute(xf=xf, name="units", value=angunits)
    else
      call xml_AddAttribute(xf=xf, name="units", value=U_DEGREE)
    endif
    call xml_AddCharacters(xf=xf, chars=(/alpha, beta, gamma/), fmt=angfmt)
    call xml_EndElement(xf=xf, name="cellParameter")

    if (present(spaceGroup)) then
      call xml_NewElement(xf, "symmetry")
      call xml_AddAttribute(xf, "spaceGroup", spaceGroup)
      call xml_EndElement(xf, "symmetry")
    endif
    call xml_EndElement(xf, "crystal")
#endif

  end subroutine cmlAddCrystalsp

  subroutine cmlAddLatticesp(xf, cell, units, title, id, dictref, convention, latticeType, spaceType, fmt)
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)              :: cell(3,3)
    character(len=*), intent(in), optional :: units       
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: latticeType
    character(len=*), intent(in), optional :: spaceType
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    integer :: i

    call xml_NewElement(xf, "lattice")
    if (present(id)) call xml_AddAttribute(xf, "id", id)
    if (present(title)) call xml_AddAttribute(xf, "title", title)
    if (present(dictref)) call xml_AddAttribute(xf, "dictRef", dictref)
    if (present(convention)) call xml_AddAttribute(xf, "convention", convention)
    if (present(latticeType)) call xml_AddAttribute(xf, "latticeType", latticeType)
    if (present(spaceType)) call xml_AddAttribute(xf, "spaceType", spaceType)

    do i = 1,3
      call xml_NewElement(xf, "latticeVector")
      if (present(units)) then
        call xml_AddAttribute(xf, "units", units)
      else
        call xml_AddAttribute(xf, "units", U_ANGSTR)
      endif
      call xml_AddAttribute(xf, "dictRef", "cml:latticeVector")
      call xml_AddCharacters(xf, cell(:,i), fmt)
      call xml_EndElement(xf, "latticeVector")
    enddo
    call xml_EndElement(xf, "lattice")
#endif

  end subroutine cmlAddLatticesp



  subroutine cmlAddCrystaldp(xf, a, b, c, alpha, beta, gamma, z,&
    id, title, dictref, convention, lenunits, angunits, spaceGroup, lenfmt, angfmt)
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)               :: a, b, c
    real(kind=dp), intent(in)               :: alpha
    real(kind=dp), intent(in)               :: beta
    real(kind=dp), intent(in)               :: gamma
    integer, intent(in), optional           :: z
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: lenunits
    character(len=*), intent(in), optional :: angunits
    character(len=*), intent(in), optional :: spaceGroup
    character(len=*), intent(in), optional :: lenfmt
    character(len=*), intent(in), optional :: angfmt

#ifndef DUMMYLIB
    call xml_NewElement(xf=xf, name="crystal")
    if (present(id))      call xml_AddAttribute(xf, "id", id)
    if (present(title))   call xml_AddAttribute(xf, "title", title)
    if (present(dictref)) call xml_AddAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_AddAttribute(xf, "convention", convention)
    if (present(z)) call xml_AddAttribute(xf, "z", z)

    call xml_NewElement(xf=xf, name="cellParameter")
    call xml_AddAttribute(xf=xf, name="latticeType", value="real")
    call xml_AddAttribute(xf=xf, name="parameterType", value="length")
    if (present(lenunits)) then
      call xml_AddAttribute(xf=xf, name="units", value=lenunits)
    else
      call xml_AddAttribute(xf=xf, name="units", value=U_ANGSTR)
    endif
    call xml_AddCharacters(xf=xf, chars=(/a, b, c/), fmt=lenfmt)
    call xml_EndElement(xf=xf, name="cellParameter")

    call xml_NewElement(xf=xf, name="cellParameter")
    call xml_AddAttribute(xf=xf, name="latticeType", value="real")
    call xml_AddAttribute(xf=xf, name="parameterType", value="angle")
    if (present(angunits)) then
      call xml_AddAttribute(xf=xf, name="units", value=angunits)
    else
      call xml_AddAttribute(xf=xf, name="units", value=U_DEGREE)
    endif
    call xml_AddCharacters(xf=xf, chars=(/alpha, beta, gamma/), fmt=angfmt)
    call xml_EndElement(xf=xf, name="cellParameter")

    if (present(spaceGroup)) then
      call xml_NewElement(xf, "symmetry")
      call xml_AddAttribute(xf, "spaceGroup", spaceGroup)
      call xml_EndElement(xf, "symmetry")
    endif
    call xml_EndElement(xf, "crystal")
#endif

  end subroutine cmlAddCrystaldp

  subroutine cmlAddLatticedp(xf, cell, units, title, id, dictref, convention, latticeType, spaceType, fmt)
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)              :: cell(3,3)
    character(len=*), intent(in), optional :: units       
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: latticeType
    character(len=*), intent(in), optional :: spaceType
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    integer :: i

    call xml_NewElement(xf, "lattice")
    if (present(id)) call xml_AddAttribute(xf, "id", id)
    if (present(title)) call xml_AddAttribute(xf, "title", title)
    if (present(dictref)) call xml_AddAttribute(xf, "dictRef", dictref)
    if (present(convention)) call xml_AddAttribute(xf, "convention", convention)
    if (present(latticeType)) call xml_AddAttribute(xf, "latticeType", latticeType)
    if (present(spaceType)) call xml_AddAttribute(xf, "spaceType", spaceType)

    do i = 1,3
      call xml_NewElement(xf, "latticeVector")
      if (present(units)) then
        call xml_AddAttribute(xf, "units", units)
      else
        call xml_AddAttribute(xf, "units", U_ANGSTR)
      endif
      call xml_AddAttribute(xf, "dictRef", "cml:latticeVector")
      call xml_AddCharacters(xf, cell(:,i), fmt)
      call xml_EndElement(xf, "latticeVector")
    enddo
    call xml_EndElement(xf, "lattice")
#endif

  end subroutine cmlAddLatticedp



end module m_wcml_lattice

! This file is AUTOGENERATED!!!!
! Do not edit this file; edit m_wcml_quantity.m4 and regenerate.
!
!
module m_wcml_parameter

  use fox_m_fsys_realtypes, only: sp, dp
  use FoX_wxml, only: xmlf_t

#ifndef DUMMYLIB
  use FoX_wxml, only: xml_NewElement, xml_AddAttribute
  use FoX_wxml, only: xml_EndElement
  use m_wcml_stml, only: stmAddValue

! Fix for pgi, requires this explicitly:
  use m_wxml_overloads
#endif

  implicit none
  private

  interface cmlAddparameter
     module procedure parameterCmplxDpSca
     module procedure parameterCmplxDpArrSi
     module procedure parameterCmplxDpArrSh
     module procedure parameterCmplxDpMatSi
     module procedure parameterCmplxDpMatSh
     module procedure parameterCmplxSpSca
     module procedure parameterCmplxSpArrSi
     module procedure parameterCmplxSpArrSh
     module procedure parameterCmplxSpMatSi
     module procedure parameterCmplxSpMatSh
     module procedure parameterRealDpSca
     module procedure parameterRealDpArrSi
     module procedure parameterRealDpArrSh
     module procedure parameterRealDpMatSi
     module procedure parameterRealDpMatSh
     module procedure parameterRealSpSca
     module procedure parameterRealSpArrSi
     module procedure parameterRealSpArrSh
     module procedure parameterRealSpMatSi
     module procedure parameterRealSpMatSh
     module procedure parameterIntSca
     module procedure parameterIntArrSi
     module procedure parameterIntArrSh
     module procedure parameterIntMatSi
     module procedure parameterIntMatSh
     module procedure parameterLgSca
     module procedure parameterLgArrSi
     module procedure parameterLgArrSh
     module procedure parameterLgMatSi
     module procedure parameterLgMatSh
     module procedure parameterChSca
     module procedure parameterChArrSi
     module procedure parameterChArrSh
     module procedure parameterChMatSi
     module procedure parameterChMatSh

  end interface

  public :: cmlAddparameter

contains

  subroutine parameterCmplxDpSca &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in)   :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterCmplxDpSca

  subroutine parameterCmplxSpSca &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in)   :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterCmplxSpSca

  subroutine parameterRealDpSca &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in)   :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterRealDpSca

  subroutine parameterRealSpSca &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in)   :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterRealSpSca

  subroutine parameterIntSca &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in)   :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterIntSca

  subroutine parameterLgSca &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in)   :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterLgSca

  subroutine parameterChSca &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in)   :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterChSca


  subroutine parameterCmplxDpArrSi &
    (xf, value,nitems,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterCmplxDpArrSi

  subroutine parameterCmplxSpArrSi &
    (xf, value,nitems,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterCmplxSpArrSi

  subroutine parameterRealDpArrSi &
    (xf, value,nitems,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterRealDpArrSi

  subroutine parameterRealSpArrSi &
    (xf, value,nitems,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterRealSpArrSi

  subroutine parameterIntArrSi &
    (xf, value,nitems,  ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterIntArrSi

  subroutine parameterLgArrSi &
    (xf, value,nitems,  ref, title, id, convention, dictRef, constraint, name, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems))
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterLgArrSi

  subroutine parameterChArrSi &
    (xf, value,nitems,  ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterChArrSi


  subroutine parameterCmplxDpArrSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterCmplxDpArrSh

  subroutine parameterCmplxSpArrSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterCmplxSpArrSh

  subroutine parameterRealDpArrSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterRealDpArrSh

  subroutine parameterRealSpArrSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterRealSpArrSh

  subroutine parameterIntArrSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterIntArrSh

  subroutine parameterLgArrSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterLgArrSh

  subroutine parameterChArrSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterChArrSh


  subroutine parameterCmplxDpMatSi &
    (xf, value,nrows, ncols,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterCmplxDpMatSi

  subroutine parameterCmplxSpMatSi &
    (xf, value,nrows, ncols,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterCmplxSpMatSi

  subroutine parameterRealDpMatSi &
    (xf, value,nrows, ncols,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterRealDpMatSi

  subroutine parameterRealSpMatSi &
    (xf, value,nrows, ncols,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterRealSpMatSi

  subroutine parameterIntMatSi &
    (xf, value,nrows, ncols,  ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterIntMatSi

  subroutine parameterLgMatSi &
    (xf, value,nrows, ncols,  ref, title, id, convention, dictRef, constraint, name, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols))
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterLgMatSi

  subroutine parameterChMatSi &
    (xf, value,nrows, ncols,  ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterChMatSi


  subroutine parameterCmplxDpMatSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterCmplxDpMatSh

  subroutine parameterCmplxSpMatSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterCmplxSpMatSh

  subroutine parameterRealDpMatSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterRealDpMatSh

  subroutine parameterRealSpMatSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterRealSpMatSh

  subroutine parameterIntMatSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterIntMatSh

  subroutine parameterLgMatSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterLgMatSh

  subroutine parameterChMatSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "parameter")
#endif
 
  end subroutine parameterChMatSh


end module m_wcml_parameter

module m_sax_parser

#ifndef DUMMYLIB
  use fox_m_fsys_array_str, only: str_vs, vs_str_alloc, vs_vs_alloc
  use fox_m_fsys_string_list, only: string_list, destroy_string_list, &
    tokenize_to_string_list, registered_string, init_string_list, &
    add_string, tokenize_and_add_strings, destroy
  use m_common_attrs, only: init_dict, destroy_dict, reset_dict, &
    add_item_to_dict, has_key, get_value, get_att_index_pointer, &
    getLength, setIsId, setBase
  use m_common_charset, only: XML1_0, XML1_1, XML_WHITESPACE
  use m_common_element, only: element_t, existing_element, add_element, &
    get_element, parse_dtd_element, parse_dtd_attlist, report_declarations, &
    declared_element, attribute_t, att_value_normalize, &
    get_attribute_declaration, &
    ATT_CDATA, ATT_ID, ATT_IDREF, ATT_IDREFS, ATT_ENTITY, ATT_ENTITIES, &
    ATT_NMTOKEN, ATT_NMTOKENS, ATT_NOTATION, ATT_ENUM, &
    ATT_REQUIRED, ATT_IMPLIED, ATT_DEFAULT, ATT_FIXED
  use m_common_elstack, only: push_elstack, pop_elstack, init_elstack, &
    destroy_elstack, is_empty, len, get_top_elstack, checkContentModel, &
    elementContent, emptyContent, checkContentModelToEnd
  use m_common_entities, only: existing_entity, init_entity_list, &
    destroy_entity_list, add_internal_entity, is_unparsed_entity, &
    expand_entity, expand_char_entity, pop_entity_list, size, &
    entity_t, getEntityByIndex, getEntityByName
  use m_common_entity_expand, only: expand_entity_value_alloc
  use m_common_error, only: FoX_error, add_error, &
    init_error_stack, destroy_error_stack, in_error
  use m_common_namecheck, only: checkName, checkPublicId, &
    checkCharacterEntityReference, likeCharacterEntityReference, &
    checkQName, checkNCName, checkPITarget, checkNmtoken, checkNmtokens, &
    checkRepCharEntityReference, checkNames, checkNCNames
  use m_common_namespaces, only: getnamespaceURI, invalidNS, &
    checkNamespaces, checkEndNamespaces, namespaceDictionary, &
    initNamespaceDictionary, destroyNamespaceDictionary
  use m_common_notations, only: init_notation_list, destroy_notation_list, &
    add_notation, notation_exists
  use m_common_struct, only: init_xml_doc_state, &
    destroy_xml_doc_state, register_internal_PE, register_external_PE, &
    register_internal_GE, register_external_GE

  use FoX_utils, only: URI, parseURI, rebaseURI, copyURI, destroyURI, &
    hasFragment, expressURI

  use m_sax_reader, only: file_buffer_t, pop_buffer_stack, open_new_string, &
    open_new_file, parse_xml_declaration, parse_text_declaration, &
    reading_main_file, reading_first_entity
  use m_sax_tokenizer, only: sax_tokenize, normalize_attribute_text, &
    expand_pe_text
  use m_sax_types ! everything, really

  implicit none
  private

  public :: getNSDict

  public :: sax_parser_init
  public :: sax_parser_destroy
  public :: sax_parse

contains

  function getNSDict(fx) result(ns)
    type(sax_parser_t), target :: fx
    type(namespaceDictionary), pointer :: ns

    ns => fx%nsDict
  end function getNSDict

  subroutine sax_parser_init(fx, fb)
    type(sax_parser_t), intent(out) :: fx
    type(file_buffer_t), intent(in) :: fb

    allocate(fx%token(0))

    call init_error_stack(fx%error_stack)
    call init_elstack(fx%elstack)
    call init_dict(fx%attributes)

    call initNamespaceDictionary(fx%nsdict)
    call init_notation_list(fx%nlist)
    ! FIXME do we copy correctly from fx%nlist to fx%xds%nlist?
    allocate(fx%xds)
    call init_xml_doc_state(fx%xds)
    deallocate(fx%xds%inputEncoding)
    fx%xds%inputEncoding => vs_str_alloc("us-ascii")
    ! because it always is ...
    if (fb%f(1)%lun>0) then
      fx%xds%documentURI => vs_vs_alloc(fb%f(1)%filename)
    else
      fx%xds%documentURI => vs_str_alloc("")
    endif

    fx%xds%standalone = fb%standalone

    call init_entity_list(fx%forbidden_ge_list)
    call init_entity_list(fx%forbidden_pe_list)
    call init_entity_list(fx%predefined_e_list)

    call add_internal_entity(fx%predefined_e_list, 'amp', '&', null(), .false.)
    call add_internal_entity(fx%predefined_e_list, 'lt', '<', null(), .false.)
    call add_internal_entity(fx%predefined_e_list, 'gt', '>', null(), .false.)
    call add_internal_entity(fx%predefined_e_list, 'apos', "'", null(), .false.)
    call add_internal_entity(fx%predefined_e_list, 'quot', '"', null(), .false.)
  end subroutine sax_parser_init

  subroutine sax_parser_destroy(fx)
    type(sax_parser_t), intent(inout) :: fx

    fx%context = CTXT_NULL
    fx%state = ST_NULL

    if (associated(fx%token)) deallocate(fx%token)
    if (associated(fx%root_element)) deallocate(fx%root_element)

    call destroy_error_stack(fx%error_stack)
    call destroy_elstack(fx%elstack)
    call destroy_dict(fx%attributes)
    call destroyNamespaceDictionary(fx%nsdict)
    call destroy_notation_list(fx%nlist)
    if (.not.fx%xds_used) then
      call destroy_xml_doc_state(fx%xds)
      deallocate(fx%xds)
    endif

    call destroy_entity_list(fx%forbidden_ge_list)
    call destroy_entity_list(fx%forbidden_pe_list)
    call destroy_entity_list(fx%predefined_e_list)

    if (associated(fx%token)) deallocate(fx%token)
    if (associated(fx%content)) deallocate(fx%content)
    if (associated(fx%name)) deallocate(fx%name)
    if (associated(fx%attname)) deallocate(fx%attname)
    if (associated(fx%publicId)) deallocate(fx%publicId)
    if (associated(fx%systemId)) deallocate(fx%systemId)
    if (associated(fx%Ndata)) deallocate(fx%Ndata)

  end subroutine sax_parser_destroy

  recursive subroutine sax_parse(fx, fb, &
                                ! org.xml.sax
                                ! SAX ContentHandler
    characters_handler,            &
    endDocument_handler,           &
    endElement_handler,            &
    endPrefixMapping_handler,      &
    ignorableWhitespace_handler,   &
    processingInstruction_handler, &
                                ! setDocumentLocator
    skippedEntity_handler,         &
    startDocument_handler,         & 
    startElement_handler,          &
    startPrefixMapping_handler,    &
                                ! SAX DTDHandler
    notationDecl_handler,          &
    unparsedEntityDecl_handler,    &
                                ! SAX ErrorHandler
    error_handler,                 &
    fatalError_handler,            &
    warning_handler,               &
                                ! org.xml.sax.ext
                                ! SAX DeclHandler
    attributeDecl_handler,         &
    elementDecl_handler,           &
    externalEntityDecl_handler,    &
    internalEntityDecl_handler,    &
                                ! SAX LexicalHandler
    comment_handler,               &
    endCdata_handler,              &
    endDTD_handler,                &
    endEntity_handler,             &
    startCdata_handler,            &
    startDTD_handler,              &
    startEntity_handler,           &
    namespaces,                    &
    namespace_prefixes,            &
    xmlns_uris,                    &
    validate,                      &
    FoX_endDTD_handler,            &
    startInCharData,               &
    externalEntity,                &
    xmlVersion,                    &
    initial_entities)

    type(sax_parser_t), intent(inout) :: fx
    type(file_buffer_t), intent(inout) :: fb
    optional :: characters_handler
    optional :: endDocument_handler
    optional :: endElement_handler
    optional :: endPrefixMapping_handler
    optional :: ignorableWhitespace_handler
    optional :: processingInstruction_handler
    optional :: skippedEntity_handler
    optional :: startElement_handler
    optional :: startDocument_handler
    optional :: startPrefixMapping_handler
    optional :: notationDecl_handler
    optional :: unparsedEntityDecl_handler
    optional :: error_handler
    optional :: fatalError_handler
    optional :: warning_handler
    optional :: attributeDecl_handler
    optional :: elementDecl_handler
    optional :: externalEntityDecl_handler
    optional :: internalEntityDecl_handler
    optional :: comment_handler
    optional :: endCdata_handler
    optional :: endEntity_handler
    optional :: endDTD_handler
    optional :: FoX_endDTD_handler
    optional :: startCdata_handler
    optional :: startDTD_handler
    optional :: startEntity_handler

    logical, intent(in), optional :: namespaces
    logical, intent(in), optional :: namespace_prefixes
    logical, intent(in), optional :: xmlns_uris

    logical, intent(in), optional :: validate
    logical, intent(in), optional :: startInCharData
    logical, intent(in), optional :: externalEntity
    character(len=*), intent(in), optional :: xmlVersion

    type(entity_list), optional :: initial_entities

    interface

      subroutine characters_handler(chunk)
        character(len=*), intent(in) :: chunk
      end subroutine characters_handler

      subroutine endDocument_handler()     
      end subroutine endDocument_handler

      subroutine endElement_handler(namespaceURI, localName, name)
        character(len=*), intent(in)     :: namespaceURI
        character(len=*), intent(in)     :: localName
        character(len=*), intent(in)     :: name
      end subroutine endElement_handler

      subroutine endPrefixMapping_handler(prefix)
        character(len=*), intent(in) :: prefix
      end subroutine endPrefixMapping_handler

      subroutine ignorableWhitespace_handler(chars)
        character(len=*), intent(in) :: chars
      end subroutine ignorableWhitespace_handler

      subroutine processingInstruction_handler(name, content)
        character(len=*), intent(in)     :: name
        character(len=*), intent(in)     :: content
      end subroutine processingInstruction_handler

      subroutine skippedEntity_handler(name)
        character(len=*), intent(in) :: name
      end subroutine skippedEntity_handler

      subroutine startDocument_handler()   
      end subroutine startDocument_handler

      subroutine startElement_handler(namespaceURI, localName, name, attributes)
        use FoX_common
        character(len=*), intent(in)     :: namespaceUri
        character(len=*), intent(in)     :: localName
        character(len=*), intent(in)     :: name
        type(dictionary_t), intent(in)   :: attributes
      end subroutine startElement_handler

      subroutine startPrefixMapping_handler(namespaceURI, prefix)
        character(len=*), intent(in) :: namespaceURI
        character(len=*), intent(in) :: prefix
      end subroutine startPrefixMapping_handler

      subroutine notationDecl_handler(name, publicId, systemId)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: publicId
        character(len=*), intent(in) :: systemId
      end subroutine notationDecl_handler

      subroutine unparsedEntityDecl_handler(name, publicId, systemId, notation)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: publicId
        character(len=*), intent(in) :: systemId
        character(len=*), intent(in) :: notation
      end subroutine unparsedEntityDecl_handler

      subroutine error_handler(msg)
        character(len=*), intent(in)     :: msg
      end subroutine error_handler

      subroutine fatalError_handler(msg)
        character(len=*), intent(in)     :: msg
      end subroutine fatalError_handler

      subroutine warning_handler(msg)
        character(len=*), intent(in)     :: msg
      end subroutine warning_handler

      subroutine attributeDecl_handler(eName, aName, type, mode, value)
        character(len=*), intent(in) :: eName
        character(len=*), intent(in) :: aName
        character(len=*), intent(in) :: type
        character(len=*), intent(in), optional :: mode
        character(len=*), intent(in), optional :: value
      end subroutine attributeDecl_handler

      subroutine elementDecl_handler(name, model)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: model
      end subroutine elementDecl_handler

      subroutine externalEntityDecl_handler(name, publicId, systemId)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: publicId
        character(len=*), intent(in) :: systemId
      end subroutine externalEntityDecl_handler

      subroutine internalEntityDecl_handler(name, value)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: value
      end subroutine internalEntityDecl_handler

      subroutine comment_handler(comment)
        character(len=*), intent(in) :: comment
      end subroutine comment_handler

      subroutine endCdata_handler()
      end subroutine endCdata_handler

      subroutine endDTD_handler()
      end subroutine endDTD_handler

      subroutine FoX_endDTD_handler(state)
        use m_common_struct, only: xml_doc_state
        type(xml_doc_state), pointer :: state
      end subroutine FoX_endDTD_handler

      subroutine endEntity_handler(name)
        character(len=*), intent(in) :: name
      end subroutine endEntity_handler

      subroutine startCdata_handler()
      end subroutine startCdata_handler

      subroutine startDTD_handler(name, publicId, systemId)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: publicId
        character(len=*), intent(in) :: systemId
      end subroutine startDTD_handler

      subroutine startEntity_handler(name)
        character(len=*), intent(in) :: name
      end subroutine startEntity_handler

    end interface

    logical :: validCheck, startInCharData_, processDTD, pe, nameOK, eof
    logical :: namespaces_, namespace_prefixes_, xmlns_uris_, externalEntity_
    integer :: i, iostat, temp_i, nextState, ignoreDepth, declSepValue
    character, pointer :: tempString(:)
    character :: dummy
    type(element_t), pointer :: elem
    type(attribute_t), pointer :: attDecl
    type(entity_t), pointer :: ent
    type(URI), pointer :: extSubsetURI, URIref, newURI
    integer, pointer :: wf_stack(:), temp_wf_stack(:), extEntStack(:)
    logical :: inExtSubset
    type(string_list) :: id_list, idref_list

    tempString => null()
    elem => null()
    attDecl => null()

    if (present(namespaces)) then
      namespaces_ = namespaces
    else
      namespaces_ = .true.
    endif
    if (present(namespace_prefixes)) then
      namespace_prefixes_ = namespace_prefixes
    else
      namespace_prefixes_ = .false.
    endif
    if (present(xmlns_uris)) then
      xmlns_uris_ = xmlns_uris
    else
      xmlns_uris_ = .false.
    endif
    if (present(validate)) then
      validCheck = validate
    else
      validCheck = .false.
    endif
    if (present(startInCharData)) then
      startInCharData_ = startInCharData
    else
      startInCharData_ = .false.
    endif
    if (present(externalEntity)) then
      externalEntity_ = externalEntity
    else
      externalEntity_ = .false.
    endif
    if (present(initial_entities)) then
      do i = 1, size(initial_entities)
        ent => getEntityByIndex(initial_entities, i)
        if (ent%external) then
          call register_external_GE(fx%xds, &
            name=str_vs(ent%name), systemId=str_vs(ent%systemId), &
            publicId=str_vs(ent%publicId), &
            wfc=ent%wfc, baseURI=copyURI(ent%baseURI))
        else
          call register_internal_GE(fx%xds, &
            name=str_vs(ent%name), text=str_vs(ent%text), &
            wfc=ent%wfc, baseURI=copyURI(ent%baseURI))
        endif
      enddo
    endif

    allocate(wf_stack(1))
    wf_stack(1) = 0
    allocate(extEntStack(0))
    fx%inIntSubset = .false.
    extSubsetURI => null()
    inExtSubset = .false.
    declSepValue = 0
    processDTD = .true.
    iostat = 0

    if (startInCharData_) then
      fx%context = CTXT_IN_CONTENT
      fx%state = ST_CHAR_IN_CONTENT
      fx%well_formed = .true.
      if (externalEntity_) call parse_text_declaration(fb, fx%error_stack)
      if (in_error(fx%error_stack)) goto 100
      if (present(xmlVersion)) then
        if (xmlVersion=="1.0") then
          fx%xds%xml_version = XML1_0
        elseif (xmlVersion=="1.1") then
          fx%xds%xml_version = XML1_1
        endif
      endif
    elseif (reading_main_file(fb)) then
      fx%context = CTXT_BEFORE_DTD
      fx%state = ST_MISC
      if (present(startDocument_handler)) then
        call startDocument_handler()
        if (fx%state==ST_STOP) goto 100
      endif
      call parse_xml_declaration(fb, fx%xds%xml_version, fx%xds%encoding, fx%xds%standalone, fx%error_stack)
      if (in_error(fx%error_stack)) goto 100
      call init_string_list(id_list)
      call init_string_list(idref_list)
    endif

    do
      call sax_tokenize(fx, fb, eof)
      if (in_error(fx%error_stack)) then
        ! Any error, we want to quit sax_tokenizer
        call add_error(fx%error_stack, 'Error getting token')
        goto 100
      elseif (eof.and..not.reading_main_file(fb)) then
        if (inExtSubset.and.reading_first_entity(fb)) then
          if (wf_stack(1)>0) then
            call add_error(fx%error_stack, &
              "Unclosed conditional section or markup in external subset")
            goto 100
          elseif (fx%state_dtd/=ST_DTD_SUBSET) then
            call add_error(fx%error_stack, &
              "Markup not terminated in external subset")
            goto 100
          endif
          call endDTDchecks
          if (in_error(fx%error_stack)) goto 100
          if (fx%state==ST_STOP) goto 100
          inExtSubset = .false.
          fx%state = ST_MISC
          fx%context = CTXT_BEFORE_CONTENT
        elseif (fx%context==CTXT_IN_DTD) then
          if (validCheck) then
            if (wf_stack(1)/=0) then
              call add_error(fx%error_stack, &
                "Markup not terminated in parameter entity")
              goto 100
            endif
          endif
          if (declSepValue==size(wf_stack)) then
            if (wf_stack(1)/=0) then
              call add_error(fx%error_stack, &
                "Markup not terminated in parameter entity")
              goto 100
            else
              declSepValue = 0
            endif
          endif
          if (present(endEntity_handler)) then
            call endEntity_handler('%'//pop_entity_list(fx%forbidden_pe_list))
            if (fx%state==ST_STOP) goto 100
          else
            dummy = pop_entity_list(fx%forbidden_pe_list)
          endif
          if (fx%state_dtd==ST_DTD_ATTLIST_CONTENTS &
            .or.fx%state_dtd==ST_DTD_ELEMENT_CONTENTS) then
            ! stick the token back in contents ...
            fx%content => fx%token
            fx%token => vs_str_alloc("")
          endif
          if (reading_main_file(fb)) &
            fx%inIntSubset = .true.
        elseif (fx%context==CTXT_IN_CONTENT) then
          if (fx%state==ST_TAG_IN_CONTENT) fx%state = ST_CHAR_IN_CONTENT
          ! because CHAR_IN_CONTENT *always* leads to TAG_IN_CONTENT
          ! *except* when it is the end of an entity expansion
          if (present(endEntity_handler)) then
            call endEntity_handler(pop_entity_list(fx%forbidden_ge_list))
            if (fx%state==ST_STOP) goto 100
          else
            dummy = pop_entity_list(fx%forbidden_ge_list)
          endif
          if (fx%state/=ST_CHAR_IN_CONTENT.or.wf_stack(1)/=0) then
            call add_error(fx%error_stack, 'Ill-formed entity')
            goto 100
          endif
        endif
        temp_wf_stack => wf_stack
        allocate(wf_stack(size(temp_wf_stack)-1))
        wf_stack = temp_wf_stack(2:)
        ! If we are not doing validity checking, we might have 
        ! finished PE expansion with wf_stack(1) non-zero
        wf_stack(1) = wf_stack(1) + temp_wf_stack(1)
        deallocate(temp_wf_stack)
        temp_wf_stack => extEntStack
        allocate(extEntStack(size(temp_wf_stack)-1))
        extEntStack = temp_wf_stack(2:)
        deallocate(temp_wf_stack)
        call pop_buffer_stack(fb)
        cycle
      endif
      if (fx%tokenType==TOK_NULL) then
        call add_error(fx%error_stack, 'Internal error! No token found!')
        goto 100
      endif

      nextState = ST_NULL

      select case (fx%state)

      case (ST_MISC)
        !write(*,*) 'ST_MISC', str_vs(fx%token)
        select case (fx%tokenType)
        case (TOK_PI_TAG)
          wf_stack(1) = wf_stack(1) + 1
          nextState = ST_START_PI
        case (TOK_BANG_TAG)
          wf_stack(1) = wf_stack(1) + 1
          nextState = ST_BANG_TAG
        case (TOK_OPEN_TAG)
          wf_stack(1) = wf_stack(1) + 1
          nextState = ST_START_TAG
        end select


      case (ST_BANG_TAG)
        !write(*,*) 'ST_BANG_TAG'
        select case (fx%tokenType)
        case (TOK_OPEN_SB)
          nextState = ST_START_CDATA_DECLARATION
        case (TOK_OPEN_COMMENT)
          nextState = ST_START_COMMENT
        case (TOK_NAME)
          if (str_vs(fx%token)=='DOCTYPE') then
            fx%context = CTXT_IN_DTD
            nextState = ST_IN_DOCTYPE
          endif
        end select


      case (ST_START_PI)
        !write(*,*)'ST_START_PI'
        select case (fx%tokenType)
        case (TOK_NAME)
          if (namespaces_) then
            nameOk = checkNCName(str_vs(fx%token), fx%xds%xml_version)
          else
            nameOk = checkName(str_vs(fx%token), fx%xds%xml_version)
          endif
          if (nameOk) then
            if (str_vs(fx%token)=='xml') then
              call add_error(fx%error_stack, "XML declaration must be at start of document")
              goto 100
            elseif (checkPITarget(str_vs(fx%token), fx%xds%xml_version)) then
              nextState = ST_PI_CONTENTS
              fx%name => fx%token
              fx%token => null()
            else
              call add_error(fx%error_stack, "Invalid PI target name")
              goto 100
            endif
          endif
        end select

      case (ST_PI_CONTENTS)
        !write(*,*)'ST_PI_CONTENTS'
        if (validCheck) then
          if (emptyContent(fx%elstack)) then
            call add_error(fx%error_stack, "Content inside empty element")
            goto 100
          endif
        endif
        wf_stack(1) = wf_stack(1) - 1
          
        select case(fx%tokenType)
        case (TOK_CHAR)
          if (present(processingInstruction_handler)) then
            call processingInstruction_handler(str_vs(fx%name), str_vs(fx%token))
            if (fx%state==ST_STOP) goto 100
          endif
          deallocate(fx%name)
          nextState = ST_PI_END
        case (TOK_PI_END)
          if (present(processingInstruction_handler)) then
            call processingInstruction_handler(str_vs(fx%name), "")
            if (fx%state==ST_STOP) goto 100
          endif
          deallocate(fx%name)
          if (fx%context==CTXT_IN_CONTENT) then
            nextState = ST_CHAR_IN_CONTENT
          else
            nextState = ST_MISC
          endif
        end select

      case (ST_PI_END)
        !write(*,*)'ST_PI_END'
        select case(fx%tokenType)
        case (TOK_PI_END)
          if (fx%context==CTXT_IN_CONTENT) then
            nextState = ST_CHAR_IN_CONTENT
          else
            nextState = ST_MISC
          endif
        end select

      case (ST_START_COMMENT)
        !write(*,*)'ST_START_COMMENT'
        select case (fx%tokenType)
        case (TOK_CHAR)
          fx%name => fx%token
          nullify(fx%token)
          nextState = ST_COMMENT_END
        end select

      case (ST_COMMENT_END)
        !write(*,*)'ST_COMMENT_END'
        if (validCheck) then
          if (emptyContent(fx%elstack)) then
            call add_error(fx%error_stack, "Content inside empty element")
            goto 100
          endif
        endif
        wf_stack(1) = wf_stack(1) - 1

        select case (fx%tokenType)
        case (TOK_COMMENT_END)
          if (present(comment_handler)) then
            call comment_handler(str_vs(fx%name))
            if (fx%state==ST_STOP) goto 100
          endif
          deallocate(fx%name)
          if (fx%context==CTXT_IN_CONTENT) then
            nextState = ST_CHAR_IN_CONTENT
          else
            nextState = ST_MISC
          endif
        end select

      case (ST_START_TAG)
        !write(*,*)'ST_START_TAG', fx%context
        select case (fx%tokenType)
        case (TOK_NAME)
          if (fx%context==CTXT_BEFORE_DTD &
            .or. fx%context==CTXT_BEFORE_CONTENT &
            .or. fx%context==CTXT_IN_CONTENT) then
            if (namespaces_) then
              nameOk = checkQName(str_vs(fx%token), fx%xds%xml_version)
            else
              nameOk = checkName(str_vs(fx%token), fx%xds%xml_version)
            endif
            if (.not.nameOk) then
              call add_error(fx%error_stack, "Illegal element name")
              goto 100
            endif
            fx%name => fx%token
            nullify(fx%token)
            nextState = ST_IN_TAG
          elseif (fx%context == CTXT_AFTER_CONTENT) then
            call add_error(fx%error_stack, "Cannot open second root element")
            goto 100
          elseif (fx%context == CTXT_IN_DTD) then
            call add_error(fx%error_stack, "Cannot open root element before DTD is finished")
            goto 100
          endif
        end select

      case (ST_START_CDATA_DECLARATION)
        !write(*,*) "ST_START_CDATA_DECLARATION"
        select case (fx%tokenType)
        case (TOK_NAME)
          if (str_vs(fx%token)=="CDATA") then
            if (fx%context/=CTXT_IN_CONTENT) then
              call add_error(fx%error_stack, "CDATA section only allowed in text content.")
              goto 100
            else
              nextState = ST_FINISH_CDATA_DECLARATION
            endif
          else
            call add_error(fx%error_stack, "Unknown keyword found in marked section declaration.")
          endif
        end select

      case (ST_FINISH_CDATA_DECLARATION)
        !write(*,*) "ST_FINISH_CDATA_DECLARATION"
        select case (fx%tokenType)
        case (TOK_OPEN_SB)
          nextState = ST_CDATA_CONTENTS
        end select


      case (ST_CDATA_CONTENTS)
        !write(*,*)'ST_CDATA_CONTENTS'
        select case (fx%tokenType)
        case (TOK_CHAR)
          fx%name => fx%token
          nullify(fx%token)
          nextState = ST_CDATA_END
        end select

      case (ST_CDATA_END)
        !write(*,*)'ST_CDATA_END'
        if (validCheck) then
          if (emptyContent(fx%elstack).or.elementContent(fx%elstack)) then
            call add_error(fx%error_stack, "Content inside empty element")
            goto 100
          endif
        endif
        wf_stack(1) = wf_stack(1) - 1

        select case(fx%tokenType)
        case (TOK_SECTION_END)
          if (present(startCdata_handler)) then
            call startCdata_handler
            if (fx%state==ST_STOP) goto 100
          endif
          if (size(fx%name)>0) then
            if (present(characters_handler)) then
              call characters_handler(str_vs(fx%name))
              if (fx%state==ST_STOP) goto 100
            endif
          endif
          if (present(endCdata_handler)) then
            call endCdata_handler
            if (fx%state==ST_STOP) goto 100
          endif
          deallocate(fx%name)
          nextState = ST_CHAR_IN_CONTENT
        end select

      case (ST_IN_TAG)
        !write(*,*)'ST_IN_TAG'
        select case (fx%tokenType)
        case (TOK_END_TAG)
          if (fx%context /= CTXT_IN_CONTENT) then
            if (associated(fx%root_element)) then
              if (validCheck) then
                if (str_vs(fx%name)/=str_vs(fx%root_element)) then
                  call add_error(fx%error_stack, "Root element name does not match document name")
                  goto 100
                endif
              endif
              deallocate(fx%root_element)
            elseif (validCheck) then
              call add_error(fx%error_stack, "No DTD defined")
              goto 100
            else
              ! We havent had a DTD, so we havent handed xds 
              ! over to the DOM.
              if (present(FoX_endDTD_handler)) then
                fx%xds_used = .true.
                call FoX_endDTD_handler(fx%xds)
              endif
            endif
            fx%context = CTXT_IN_CONTENT
          endif
          call open_tag
          if (in_error(fx%error_stack)) goto 100
          if (fx%state==ST_STOP) goto 100
          deallocate(fx%name)
          nextState = ST_CHAR_IN_CONTENT

        case (TOK_END_TAG_CLOSE)
          if (fx%context==CTXT_IN_CONTENT) then
            nextState = ST_CHAR_IN_CONTENT
          else
            ! only a single element in this doc
            if (associated(fx%root_element)) then
              if (validCheck) then
                if (str_vs(fx%name)/=str_vs(fx%root_element)) then
                  call add_error(fx%error_stack, "Root element name does not match document name")
                  goto 100
                endif
              endif
              deallocate(fx%root_element)
            elseif (validCheck) then
              call add_error(fx%error_stack, "No DTD defined")
              goto 100
            else
              ! No DTD, so we havent handed over xds
              if (present(FoX_endDTD_handler)) then
                fx%xds_used = .true.
                call FoX_endDTD_handler(fx%xds)
              endif
            endif
          endif
          call open_tag
          if (in_error(fx%error_stack)) goto 100
          if (fx%state==ST_STOP) goto 100
          call close_tag
          if (in_error(fx%error_stack)) goto 100
          if (fx%state==ST_STOP) goto 100
          deallocate(fx%name)
          if (fx%context/=CTXT_IN_CONTENT) then
            fx%well_formed = .true.
            fx%context = CTXT_AFTER_CONTENT
            nextState = ST_MISC
          endif

        case (TOK_NAME)
          if (namespaces_) then
            nameOk = checkQName(str_vs(fx%token), fx%xds%xml_version)
          else
            nameOk = checkName(str_vs(fx%token), fx%xds%xml_version)
          endif
          if (.not.nameOk) then
            call add_error(fx%error_stack, "Illegal attribute name")
            goto 100
          endif
          !Have we already had this dictionary item?
          if (has_key(fx%attributes, str_vs(fx%token))) then
            call add_error(fx%error_stack, "Duplicate attribute name")
            goto 100
          endif
          fx%attname => fx%token
          nullify(fx%token)
          if (associated(elem)) then
            attDecl => get_attribute_declaration(elem, str_vs(fx%attname))
          else
            attDecl => null()
          endif
          nextState = ST_ATT_NAME
        end select

      case (ST_ATT_NAME)
        !write(*,*)'ST_ATT_NAME'
        select case (fx%tokenType)
        case (TOK_EQUALS)
          nextState = ST_ATT_EQUALS
        end select

      case (ST_ATT_EQUALS)
        !write(*,*)'ST_ATT_EQUALS'
        ! token is pre-processed attribute value.
        ! fx%name still contains attribute name
        select case (fx%tokenType)
        case (TOK_CHAR)
          !First, expand all entities:
          tempString => normalize_attribute_text(fx, fx%token)
          deallocate(fx%token)
          fx%token => tempString
          tempString => null()
          !If this attribute is not CDATA, we must process further;
          if (associated(attDecl)) then
            temp_i = attDecl%attType
          else
            temp_i = ATT_CDATA
          endif
          if (temp_i==ATT_CDATA) then
            call add_item_to_dict(fx%attributes, str_vs(fx%attname), &
              str_vs(fx%token), itype=ATT_CDATA, declared=associated(attDecl))
          else
            if (validCheck) then
              if (fx%xds%standalone.and..not.attDecl%internal &
                .and.(str_vs(fx%token)//"x"/=att_value_normalize(str_vs(fx%token))//"x")) then
                call add_error(fx%error_stack,  &
                  "Externally-declared attribute value normalization results in changed value "// &
                  "in standalone document")
                goto 100
              endif
            endif
            call add_item_to_dict(fx%attributes, str_vs(fx%attname), &
              att_value_normalize(str_vs(fx%token)), itype=temp_i, &
              declared=.true.)
          endif
          deallocate(fx%attname)
          nextState = ST_IN_TAG
        end select

      case (ST_CHAR_IN_CONTENT)
        !write(*,*)'ST_CHAR_IN_CONTENT'
        select case (fx%tokenType)
        case (TOK_CHAR)
          if (size(fx%token)>0) then
            if (validCheck) then
              if (elementContent(fx%elstack)) then
                if (verify(str_vs(fx%token), XML_WHITESPACE)==0) then
                  if (fx%xds%standalone.and..not.elem%internal) then
                    call add_error(fx%error_stack, &
                      "Externally-specified ignorable whitespace used in standalone document")
                    goto 100
                  endif
                  if (present(ignorableWhitespace_handler)) then
                    call ignorableWhitespace_handler(str_vs(fx%token))
                    if (fx%state==ST_STOP) goto 100
                  endif
                else
                  call add_error(fx%error_stack, "Forbidden content inside elementc: "//get_top_elstack(fx%elstack))
                  goto 100
                endif
              elseif (emptyContent(fx%elstack)) then
                call add_error(fx%error_stack, "Forbidden content inside element: "//get_top_elstack(fx%elstack))
                goto 100
              else
                if (present(characters_handler)) then
                  call characters_handler(str_vs(fx%token))
                  if (fx%state==ST_STOP) goto 100
                endif
              endif
            else
              if (present(characters_handler)) then
                call characters_handler(str_vs(fx%token))
                if (fx%state==ST_STOP) goto 100
              endif
            endif
          endif
          nextState = ST_TAG_IN_CONTENT
        end select

      case (ST_TAG_IN_CONTENT)
        !write(*,*) 'ST_TAG_IN_CONTENT'
        select case (fx%tokenType)
        case (TOK_ENTITY)
          nextState = ST_START_ENTITY
        case (TOK_PI_TAG)
          wf_stack(1) = wf_stack(1) + 1
          nextState = ST_START_PI
        case (TOK_BANG_TAG)
          wf_stack(1) = wf_stack(1) + 1
          nextState = ST_BANG_TAG
        case (TOK_CLOSE_TAG)
          nextState = ST_CLOSING_TAG
        case (TOK_OPEN_TAG)
          wf_stack(1) = wf_stack(1) + 1
          nextState = ST_START_TAG
        end select

      case (ST_START_ENTITY)
        !write(*,*) 'ST_START_ENTITY'
        select case (fx%tokenType)
        case (TOK_NAME)
          if (validCheck) then
            elem => get_element(fx%xds%element_list, get_top_elstack(fx%elstack))
            if (associated(elem)) then
              if (elem%empty) then
                call add_error(fx%error_stack, &
                  "Forbidden content inside element")
                goto 100
              endif
            else
              call add_error(fx%error_stack, &
                'Encountered reference to undeclared entity')
            endif
          endif
          ent => getEntityByName(fx%forbidden_ge_list, str_vs(fx%token))
          if (associated(ent)) then
            call add_error(fx%error_stack, 'Recursive entity reference')
            goto 100
          endif
          ent => getEntityByName(fx%predefined_e_list, str_vs(fx%token))
          if (associated(ent)) then
            if (present(startEntity_handler)) then
              call startEntity_handler(str_vs(fx%token))
              if (fx%state==ST_STOP) goto 100
            endif
            if (validCheck) then
              if (associated(elem)) then
                if (.not.elem%mixed.and..not.elem%any) then
                  call add_error(fx%error_stack, &
                    "Forbidden content inside element")
                  goto 100
                endif
              endif
            endif
            if (present(characters_handler)) then
              call characters_handler(expand_entity(fx%predefined_e_list, str_vs(fx%token)))
              if (fx%state==ST_STOP) goto 100
            endif
            if (present(endEntity_handler)) then
              call endEntity_handler(str_vs(fx%token))
              if (fx%state==ST_STOP) goto 100
            endif
          elseif (likeCharacterEntityReference(str_vs(fx%token))) then
            if (checkRepCharEntityReference(str_vs(fx%token), fx%xds%xml_version)) then
              if (validCheck) then
                if (associated(elem)) then
                  if (.not.elem%mixed.and..not.elem%any) then
                    call add_error(fx%error_stack, &
                      "Forbidden content inside element")
                    goto 100
                  endif
                endif
              endif
              if (present(characters_handler)) then
                call characters_handler(expand_char_entity(str_vs(fx%token)))
                if (fx%state==ST_STOP) goto 100
              endif
            elseif (checkCharacterEntityReference(str_vs(fx%token), fx%xds%xml_version)) then
              call add_error(fx%error_stack, "Unable to digest character entity reference in content, sorry.")
              goto 100
            else
              call add_error(fx%error_stack, "Illegal character reference")
              goto 100
            endif
          elseif (existing_entity(fx%xds%entityList, str_vs(fx%token))) then
            ent => getEntityByName(fx%xds%entityList, str_vs(fx%token))
            if (ent%wfc.and.fx%xds%standalone) then
              call add_error(fx%error_stack, &
                'Externally declared entity referenced in standalone document')
              goto 100
            elseif (str_vs(ent%notation)/="") then
              call add_error(fx%error_stack, &
                'Cannot reference unparsed entity in content')
              goto 100
            elseif (ent%external) then
              call open_new_file(fb, ent%baseURI, iostat)
              if (iostat/=0) then
                if (validCheck) then
                  call add_error(fx%error_stack, &
                    "Unable to retrieve external entity "//str_vs(fx%token))
                  goto 100
                endif
                if (present(skippedEntity_handler)) then
                  call skippedEntity_handler(str_vs(fx%token))
                  if (fx%state==ST_STOP) goto 100
                endif
              else
                if (present(startEntity_handler)) then
                  call startEntity_handler(str_vs(fx%token))
                  if (fx%state==ST_STOP) goto 100
                endif
                call add_internal_entity(fx%forbidden_ge_list, str_vs(fx%token), "", null(), .false.)
                temp_wf_stack => wf_stack
                allocate(wf_stack(size(temp_wf_stack)+1))
                wf_stack = (/0, temp_wf_stack/)
                deallocate(temp_wf_stack)
                temp_wf_stack => extEntStack
                allocate(extEntStack(size(temp_wf_stack)+1))
                extEntStack = (/len(fx%elstack), temp_wf_stack/)
                deallocate(temp_wf_stack)
                call parse_text_declaration(fb, fx%error_stack)
                if (in_error(fx%error_stack)) goto 100
              endif
            else
              if (validCheck.and.associated(elem)) then
                if (elem%empty) then
                  call add_error(fx%error_stack, &
                    "Forbidden content inside element")
                  goto 100
                endif
              endif
              if (present(startEntity_handler)) then
                call startEntity_handler(str_vs(fx%token))
                if (fx%state==ST_STOP) goto 100
              endif
              call add_internal_entity(fx%forbidden_ge_list, str_vs(fx%token), "", null(), .false.)
              call open_new_string(fb, expand_entity(fx%xds%entityList, str_vs(fx%token)), str_vs(fx%token), baseURI=ent%baseURI)
              temp_wf_stack => wf_stack
              allocate(wf_stack(size(temp_wf_stack)+1))
              wf_stack = (/0, temp_wf_stack/)
              deallocate(temp_wf_stack)
            endif
          else
            ! Unknown entity check standalone etc
            if (fx%skippedExternal.and..not.fx%xds%standalone) then
              if (present(skippedEntity_handler)) then
                call skippedEntity_handler(str_vs(fx%token))
                if (fx%state==ST_STOP) goto 100
              endif
            else
              call add_error(fx%error_stack, &
                'Encountered reference to undeclared entity')
            endif
          endif
          nextState = ST_CHAR_IN_CONTENT
        end select

      case (ST_CLOSING_TAG)
        !write(*,*)'ST_CLOSING_TAG'
        select case (fx%tokenType)
        case (TOK_NAME)
          if (checkName(str_vs(fx%token), fx%xds%xml_version)) then
            fx%name => fx%token
            nullify(fx%token)
            nextState = ST_IN_CLOSING_TAG
          else
            call add_error(fx%error_stack, "Closing tag: expecting a Name")
            goto 100
          end if
        end select

      case (ST_IN_CLOSING_TAG)
        !write(*,*)'ST_IN_CLOSING_TAG'
        select case (fx%tokenType)
        case (TOK_END_TAG)
          call close_tag
          if (in_error(fx%error_stack)) goto 100
          if (fx%state==ST_STOP) goto 100
          deallocate(fx%name)
          if (is_empty(fx%elstack)) then
            if (startInCharData_) then
              fx%well_formed = .true.
              nextState = ST_CHAR_IN_CONTENT
            else
              !we're done
              if (validCheck) then
                call checkIdRefs
                if (in_error(fx%error_stack)) goto 100
              endif
              fx%well_formed = .true.
              nextState = ST_MISC
              fx%context = CTXT_AFTER_CONTENT
            endif
          else
            nextState = ST_CHAR_IN_CONTENT
          endif
        end select

      case (ST_IN_DOCTYPE)
        !write(*,*)'ST_IN_DOCTYPE'
        select case (fx%tokenType)
        case (TOK_NAME)
          if (namespaces_) then
            nameOk = checkQName(str_vs(fx%token), fx%xds%xml_version)
          else
            nameOk = checkName(str_vs(fx%token), fx%xds%xml_version)
          endif
          if (.not.nameOk) then
            call add_error(fx%error_stack, "Invalid document name")
            goto 100
          endif
          fx%root_element => fx%token
          nullify(fx%token)
          nextState = ST_DOC_NAME
        end select

      case (ST_DOC_NAME)
        !write(*,*) 'ST_DOC_NAME ', str_vs(fx%token)
        select case (fx%tokenType)
        case (TOK_NAME)
          if (str_vs(fx%token)=='SYSTEM') then
            nextState = ST_DOC_SYSTEM
          elseif (str_vs(fx%token)=='PUBLIC') then
            nextState = ST_DOC_PUBLIC
          endif
        case (TOK_OPEN_SB)
          if (present(startDTD_handler)) then
            call startDTD_handler(str_vs(fx%root_element), "", "")
            if (fx%state==ST_STOP) goto 100
          endif
          wf_stack(1) = wf_stack(1) + 1
          nextState = ST_IN_SUBSET
          fx%inIntSubset = .true.
        case (TOK_END_TAG)
          if (present(startDTD_handler)) then
            call startDTD_handler(str_vs(fx%root_element), "", "")
            if (fx%state==ST_STOP) goto 100
          endif
          wf_stack(1) = wf_stack(1) - 1
          call endDTDchecks
          if (in_error(fx%error_stack)) goto 100
          if (fx%state==ST_STOP) goto 100
          fx%context = CTXT_BEFORE_CONTENT
          nextState = ST_MISC
        case default
          call add_error(fx%error_stack, "Unexpected token")
          goto 100
        end select

      case (ST_DOC_PUBLIC)
        !write(*,*) 'ST_DOC_PUBLIC'
        select case (fx%tokenType)
        case (TOK_CHAR)
          if (checkPublicId(str_vs(fx%token))) then
            fx%publicId => fx%token
            fx%token => null()
            nextState = ST_DOC_SYSTEM
          else
            call add_error(fx%error_stack, "Invalid document public id")
            goto 100
          endif
        end select

      case (ST_DOC_SYSTEM)
        !write(*,*) 'ST_DOC_SYSTEM'
        select case (fx%tokenType)
        case (TOK_CHAR)
          fx%systemId => fx%token
          fx%token => null()
          nextState = ST_DOC_DECL
        end select

      case (ST_DOC_DECL)
        !write(*,*) 'ST_DOC_DECL'
        select case (fx%tokenType)
        case (TOK_OPEN_SB)
          if (present(startDTD_handler)) then
            if (associated(fx%publicId)) then
              call startDTD_handler(str_vs(fx%root_element), &
                publicId=str_vs(fx%publicId), systemId=str_vs(fx%systemId))
            elseif (associated(fx%systemId)) then
              call startDTD_handler(str_vs(fx%root_element), &
                publicId="", systemId=str_vs(fx%systemId))
            else
              call startDTD_handler(str_vs(fx%root_element), "", "")
            endif
            if (fx%state==ST_STOP) goto 100
          endif
          if (associated(fx%systemId)) then
            extSubsetURI => parseURI(str_vs(fx%systemId))
            deallocate(fx%systemId)
          endif
          if (associated(fx%publicId)) deallocate(fx%publicId)
          fx%inIntSubset = .true.
          wf_stack(1) = wf_stack(1) + 1
          nextState = ST_IN_SUBSET
        case (TOK_END_TAG)
          if (present(startDTD_handler)) then
            if (associated(fx%publicId)) then
              call startDTD_handler(str_vs(fx%root_element), publicId=str_vs(fx%publicId), systemId=str_vs(fx%systemId))
              deallocate(fx%publicId)
            elseif (associated(fx%systemId)) then
              call startDTD_handler(str_vs(fx%root_element), publicId="", systemId=str_vs(fx%systemId))
            else
              call startDTD_handler(str_vs(fx%root_element), "", "")
            endif
            if (fx%state==ST_STOP) goto 100
          endif
          if (associated(fx%systemId)) then
            extSubsetURI => parseURI(str_vs(fx%systemId))
            if (.not.associated(extSubsetURI)) then
              call add_error(fx%error_stack, "Invalid URI specified for DTD SYSTEM")
              goto 100
            endif
            call open_new_file(fb, extSubsetURI, iostat)
            if (iostat==0) then
              fx%inIntSubset=.false.
              call parse_text_declaration(fb, fx%error_stack)
              if (in_error(fx%error_stack)) goto 100
              temp_wf_stack => wf_stack
              allocate(wf_stack(size(temp_wf_stack)+1))
              wf_stack = (/0, temp_wf_stack/)
              deallocate(temp_wf_stack)
              inExtSubset = .true.
              nextState = ST_IN_SUBSET
            else
              if (validCheck) then
                call add_error(fx%error_stack, &
                  "Unable to retrieve external subset "//str_vs(fx%systemId))
                goto 100
              endif
              call endDTDchecks
              if (in_error(fx%error_stack)) goto 100
              if (fx%state==ST_STOP) goto 100
              fx%context = CTXT_BEFORE_CONTENT
              nextState = ST_MISC
            endif
            call destroyURI(extSubsetURI)
          else
            call endDTDchecks
            if (in_error(fx%error_stack)) goto 100
            if (fx%state==ST_STOP) goto 100
            fx%context = CTXT_BEFORE_CONTENT
            nextState = ST_MISC
          endif
          if (associated(fx%systemId)) deallocate(fx%systemId)
          if (associated(fx%publicId)) deallocate(fx%publicId)
        case default
          call add_error(fx%error_stack, "Unexpected token in DTD")
          goto 100
        end select


      case (ST_CLOSE_DOCTYPE)
        !write(*,*) "ST_CLOSE_DOCTYPE"
        select case (fx%tokenType)
        case (TOK_END_TAG)
          if (wf_stack(1)>1) then
            call add_error(fx%error_stack, "Cannot end DTD while conditional section is still open")
            goto 100
          endif
          if (associated(extSubsetURI)) then
            call open_new_file(fb, extSubsetURI, iostat)
            call destroyURI(extSubsetURI)
            if (iostat==0) then
              fx%inIntSubset = .false.
              call parse_text_declaration(fb, fx%error_stack)
              if (in_error(fx%error_stack)) goto 100
              temp_wf_stack => wf_stack
              allocate(wf_stack(size(temp_wf_stack)+1))
              wf_stack = (/0, temp_wf_stack/)
              deallocate(temp_wf_stack)
              inExtSubset = .true.
              nextState = ST_IN_SUBSET
            else
              if (validCheck) then
                call add_error(fx%error_stack, &
                  "Unable to retrieve external subset")
                goto 100
              endif
              call endDTDchecks
              if (in_error(fx%error_stack)) goto 100
              if (fx%state==ST_STOP) goto 100
              wf_stack(1) = wf_stack(1) - 1
              nextState = ST_MISC
              fx%context = CTXT_BEFORE_CONTENT
            endif
          else
            call endDTDchecks
            if (in_error(fx%error_stack)) goto 100
            if (fx%state==ST_STOP) goto 100
            wf_stack(1) = wf_stack(1) - 1
            nextState = ST_MISC
            fx%context = CTXT_BEFORE_CONTENT
          endif
        end select

      case (ST_IN_SUBSET)
        select case(fx%tokenType)
        case (TOK_ENTITY)
          nextState = ST_START_PE
        case default
          call parseDTD
          if (in_error(fx%error_stack)) goto 100
          if (fx%state==ST_STOP) goto 100
          if (fx%state_dtd==ST_DTD_DONE) &
            fx%state_dtd = ST_DTD_SUBSET
        end select

      case (ST_START_PE)
        !write(*,*) 'ST_START_PE'
        select case (fx%tokenType)
        case (TOK_NAME)
          if (existing_entity(fx%forbidden_pe_list, str_vs(fx%token))) then
            call add_error(fx%error_stack, &
              'Recursive entity reference')
            goto 100
          endif
          ent => getEntityByName(fx%xds%PEList, str_vs(fx%token))
          if (associated(ent)) then
            if (ent%wfc.and.fx%xds%standalone) then
              call add_error(fx%error_stack, &
                "Externally declared entity used in standalone document")
              goto 100
            elseif (ent%external) then
              if (present(startEntity_handler)) then
                call startEntity_handler('%'//str_vs(fx%token))
                if (fx%state==ST_STOP) goto 100
              endif
              call add_internal_entity(fx%forbidden_pe_list, &
                str_vs(fx%token), "", null(), .false.)
              call open_new_file(fb, ent%baseURI, iostat, pe=.true.)
              if (iostat/=0) then
                if (validCheck) then
                  call add_error(fx%error_stack, &
                    "Unable to retrieve external parameter entity "//str_vs(fx%token))
                  goto 100
                endif
                if (present(skippedEntity_handler)) then
                  call skippedEntity_handler('%'//str_vs(fx%token))
                  if (fx%state==ST_STOP) goto 100
                endif
                ! having skipped a PE, we must now not process
                ! declarations any further (unless we are declared standalone)
                ! (XML section 5.1)
                fx%skippedExternal = .true.
                processDTD = fx%xds%standalone
              else
                fx%inIntSubset = .false.
                if (present(startEntity_handler)) then
                  call startEntity_handler('%'//str_vs(fx%token))
                  if (fx%state==ST_STOP) goto 100
                endif
                call add_internal_entity(fx%forbidden_pe_list, &
                  str_vs(fx%token), "", null(), .false.)
                call parse_text_declaration(fb, fx%error_stack)
                if (in_error(fx%error_stack)) goto 100
                allocate(temp_wf_stack(size(wf_stack)+1))
                temp_wf_stack = (/0, wf_stack/)
                deallocate(wf_stack)
                wf_stack => temp_wf_stack
                if (fx%state_dtd==ST_DTD_SUBSET) &
                  declSepValue = size(wf_stack)
              endif
            else
              ! Expand the entity,
              if (present(startEntity_handler)) then
                call startEntity_handler('%'//str_vs(fx%token))
                if (fx%state==ST_STOP) goto 100
              endif
              call add_internal_entity(fx%forbidden_pe_list, &
                str_vs(fx%token), "", null(), .false.)
              call open_new_string(fb, &
                expand_entity(fx%xds%PEList, str_vs(fx%token)), str_vs(fx%token), baseURI=null(), pe=.true.)
              ! NB because we are just expanding a string here, anything
              ! evaluated as a result of this string is evaluated in the
              ! context of the currently open file, so has a baseURI of
              ! this file
              allocate(temp_wf_stack(size(wf_stack)+1))
              temp_wf_stack = (/0, wf_stack/)
              deallocate(wf_stack)
              wf_stack => temp_wf_stack
              if (fx%state_dtd==ST_DTD_SUBSET) &
                declSepValue = size(wf_stack)
            endif
            ! and do nothing else, carry on ...
          else
            ! Have we previously skipped an external entity?
            if (fx%skippedExternal.and..not.fx%xds%standalone) then
              if (processDTD) then
                if (present(skippedEntity_handler)) then
                  call skippedEntity_handler('%'//str_vs(fx%token))
                  if (fx%state==ST_STOP) goto 100
                endif
              endif
            else
              ! If not, 
              call add_error(fx%error_stack, &
                "Reference to undeclared parameter entity.")
              goto 100
            endif
          endif
          nextState = ST_IN_SUBSET

        end select

      end select

      if (nextState/=ST_NULL) then
        fx%state = nextState
      else
        call add_error(fx%error_stack, "Internal error in parser - no suitable token found")
        goto 100
      endif

    end do

100 if (associated(tempString)) deallocate(tempString)
    if (associated(extSubsetURI)) call destroyURI(extSubsetURI)
    call destroy_string_list(id_list)
    call destroy_string_list(idref_list)
    deallocate(wf_stack)
    if (associated(extEntStack)) deallocate(extEntStack)

    if (fx%state==ST_STOP) return
    if (.not.eof) then
      ! We have encountered an error before the end of a file
      if (.not.reading_main_file(fb)) then !we are parsing an entity
        if (inExtSubset) then
          call add_error(fx%error_stack, "Error encountered processing external subset.")
        else
          call add_error(fx%error_stack, "Error encountered processing entity.")
        endif
        call sax_error(fx, fatalError_handler)
      else
        call sax_error(fx, fatalError_handler)
      endif
    else
      ! EOF of main file
      if (startInChardata_) then
        if (fx%well_formed) then
          if (fx%state==ST_CHAR_IN_CONTENT.and.associated(fx%token)) then
            if (size(fx%token)>0.and.present(characters_handler)) &
              call characters_handler(str_vs(fx%token))
          endif
        else
          if (present(fatalError_handler)) &
            call fatalError_handler("Ill-formed XML fragment")
        endif
      elseif (fx%well_formed.and.fx%state==ST_MISC) then
        if (present(endDocument_handler)) &
          call endDocument_handler()
      else
        call add_error(fx%error_stack, "File is not well-formed")
        call sax_error(fx, fatalError_handler)
      endif
    endif

  contains

    subroutine parseDTD

      integer :: nextDTDState

      nextDTDState = ST_DTD_NULL

      select case (fx%state_dtd)

      case (ST_DTD_SUBSET)
        !write(*,*) "ST_DTD_SUBSET"
        select case (fx%tokenType)
        case (TOK_CLOSE_SB)
          if (.not.reading_main_file(fb)) then
            call add_error(fx%error_stack, "Cannot close DOCTYPE in external entity")
            return
          endif
          wf_stack(1) = wf_stack(1) - 1
          fx%inIntSubset = .false.
          nextState = ST_CLOSE_DOCTYPE
          nextDTDState = ST_DTD_DONE
        case (TOK_SECTION_END)
          if (wf_stack(1)==0) then
            call add_error(fx%error_stack, "Unbalanced conditional section in parameter entity")
            return
          endif
          wf_stack(1) = wf_stack(1) - 2
          nextDTDState = ST_DTD_SUBSET
        case (TOK_PI_TAG)
          wf_stack(1) = wf_stack(1) + 1
          nextDTDState = ST_DTD_START_PI
        case (TOK_BANG_TAG)
          wf_stack(1) = wf_stack(1) + 1
          nextDTDState = ST_DTD_BANG_TAG
        case default
          call add_error(fx%error_stack, "Unexpected token in document subset")
          return
        end select


      case (ST_DTD_BANG_TAG)
        !write(*,*) 'ST_DTD_BANG_TAG'
        select case (fx%tokenType)
        case (TOK_OPEN_SB)
          nextDTDState = ST_DTD_START_SECTION_DECL
        case (TOK_OPEN_COMMENT)
          nextDTDState = ST_DTD_START_COMMENT
        case (TOK_NAME)
          if (str_vs(fx%token)=='ATTLIST') then
            nextDTDState = ST_DTD_ATTLIST
          elseif (str_vs(fx%token)=='ELEMENT') then
            nextDTDState = ST_DTD_ELEMENT
          elseif (str_vs(fx%token)=='ENTITY') then
            nextDTDState = ST_DTD_ENTITY
          elseif (str_vs(fx%token)=='NOTATION') then
            nextDTDState = ST_DTD_NOTATION
          endif
        end select

      case (ST_DTD_START_SECTION_DECL)
        !write(*,*) "ST_DTD_START_SECTION_DECL"
        select case (fx%tokenType)
        case (TOK_NAME)
          if (str_vs(fx%token)=="IGNORE") then
            if (fx%context/=CTXT_IN_DTD.or.reading_main_file(fb)) then
              call add_error(fx%error_stack, "IGNORE section only allowed in external subset.")
              return
            else
              ignoreDepth = 0
              fx%context = CTXT_IGNORE
              nextDTDState = ST_DTD_FINISH_SECTION_DECL
            endif
          elseif (str_vs(fx%token)=="INCLUDE") then
            if (fx%context/=CTXT_IN_DTD.or.reading_main_file(fb)) then
              call add_error(fx%error_stack, "INCLUDE section only allowed in external subset.")
              return
            else
              nextDTDState = ST_DTD_FINISH_SECTION_DECL
            endif
          else
            call add_error(fx%error_stack, "Unknown keyword found in marked section declaration.")
          endif
        end select


      case (ST_DTD_FINISH_SECTION_DECL)
        !write(*,*) "ST_FINISH_SECTION_DECL"
        select case (fx%tokenType)
        case (TOK_OPEN_SB)
          wf_stack(1) = wf_stack(1) + 1
          if (fx%context==CTXT_IGNORE) then
            nextDTDState = ST_DTD_IN_IGNORE_SECTION
            ignoreDepth = ignoreDepth + 1
          else
            nextDTDState = ST_DTD_SUBSET
          endif
        end select


      case (ST_DTD_IN_IGNORE_SECTION)
        !write(*,*) "ST_IN_IGNORE_SECTION"
        select case (fx%tokenType)
        case (TOK_SECTION_START)
          wf_stack(1) = wf_stack(1) + 2
          ignoreDepth = ignoreDepth + 1
          nextDTDState = ST_DTD_IN_IGNORE_SECTION
        case (TOK_SECTION_END)
          wf_stack(1) = wf_stack(1) - 2
          ignoreDepth = ignoreDepth - 1
          if (ignoreDepth==0) then
            fx%context = CTXT_IN_DTD
            nextDTDState = ST_DTD_SUBSET
          else
            nextDTDState = ST_DTD_IN_IGNORE_SECTION
          endif
        end select

      case (ST_DTD_START_PI)
        !write(*,*)'ST_DTD_START_PI'
        select case (fx%tokenType)
        case (TOK_NAME)
          if (namespaces_) then
            nameOk = checkNCName(str_vs(fx%token), fx%xds%xml_version)
          else
            nameOk = checkName(str_vs(fx%token), fx%xds%xml_version)
          endif
          if (nameOk) then
            if (str_vs(fx%token)=='xml') then
              call add_error(fx%error_stack, "XML declaration must be at start of document")
              return
            elseif (checkPITarget(str_vs(fx%token), fx%xds%xml_version)) then
              nextDTDState = ST_DTD_PI_CONTENTS
              fx%name => fx%token
              fx%token => null()
            else
              call add_error(fx%error_stack, "Invalid PI target name")
              return
            endif
          endif
        end select

      case (ST_DTD_PI_CONTENTS)
        !write(*,*)'ST_DTD_PI_CONTENTS'
        if (validCheck) then
          if (fx%context==CTXT_IN_DTD.and.wf_stack(1)==0) then
            call add_error(fx%error_stack, &
              "PI not balanced in parameter entity")
            return
          endif
          if (len(fx%elstack)>0) then
            elem => &
              get_element(fx%xds%element_list, get_top_elstack(fx%elstack))
            if (associated(elem)) then
              if (elem%empty) then
                call add_error(fx%error_stack, "Content inside empty element")
              endif
            endif
          endif
        endif
        wf_stack(1) = wf_stack(1) - 1
          
        select case(fx%tokenType)
        case (TOK_CHAR)
          if (present(processingInstruction_handler)) then
            call processingInstruction_handler(str_vs(fx%name), str_vs(fx%token))
            if (fx%state==ST_STOP) return
          endif
          deallocate(fx%name)
          nextDTDState = ST_DTD_PI_END
        case (TOK_PI_END)
          if (present(processingInstruction_handler)) then
            call processingInstruction_handler(str_vs(fx%name), '')
            if (fx%state==ST_STOP) return
          endif
          deallocate(fx%name)
          nextDTDState = ST_DTD_SUBSET
        end select

      case (ST_DTD_PI_END)
        !write(*,*)'ST_DTD_PI_END'
        select case(fx%tokenType)
        case (TOK_PI_END)
          nextDTDState = ST_DTD_SUBSET
        end select

      case (ST_DTD_START_COMMENT)
        !write(*,*)'ST_DTD_START_COMMENT'
        select case (fx%tokenType)
        case (TOK_CHAR)
          fx%name => fx%token
          nullify(fx%token)
          nextDTDState = ST_DTD_COMMENT_END
        end select

      case (ST_DTD_COMMENT_END)
        !write(*,*)'ST_DTD_COMMENT_END'
        if (validCheck) then
          if (wf_stack(1)==0) then
            call add_error(fx%error_stack, &
              "Comment not balanced in entity")
            return
          endif
          if (len(fx%elstack)>0) then
            elem => &
              get_element(fx%xds%element_list, get_top_elstack(fx%elstack))
            if (associated(elem)) then
              if (elem%empty) then
                call add_error(fx%error_stack, "Content inside empty element")
              endif
            endif
          endif
        endif
        wf_stack(1) = wf_stack(1) - 1

        select case (fx%tokenType)
        case (TOK_COMMENT_END)
          if (present(comment_handler)) then
            call comment_handler(str_vs(fx%name))
            if (fx%state==ST_STOP) return
          endif
          deallocate(fx%name)
          nextDTDState = ST_DTD_SUBSET
        end select

      case (ST_DTD_ATTLIST)
        !write(*,*) 'ST_DTD_ATTLIST'
        select case (fx%tokenType)
        case (TOK_NAME)
          if (namespaces_) then
            nameOk = checkQName(str_vs(fx%token), fx%xds%xml_version)
          else
            nameOk = checkName(str_vs(fx%token), fx%xds%xml_version)
          endif
          if (.not.nameOk) then
            call add_error(fx%error_stack, "Invalid element name for ATTLIST")
            return
          endif
          if (existing_element(fx%xds%element_list, str_vs(fx%token))) then
            elem => get_element(fx%xds%element_list, str_vs(fx%token))
          else
            elem => add_element(fx%xds%element_list, str_vs(fx%token))
          endif
          nextDTDState = ST_DTD_ATTLIST_CONTENTS
        end select

      case (ST_DTD_ATTLIST_CONTENTS)
        !write(*,*) 'ST_DTD_ATTLIST_CONTENTS'
        select case (fx%tokenType)
        case (TOK_ENTITY)
          !Weve found a PEref in the middle of the element contents
          ! Leave DTD state as it is & expand the entity ...
          nextState = ST_START_PE
        case (TOK_DTD_CONTENTS)
          if (processDTD) then
            call parse_dtd_attlist(str_vs(fx%token), fx%xds%xml_version, &
              namespaces_, validCheck, fx%error_stack, elem, &
              internal=reading_main_file(fb))
          else
            call parse_dtd_attlist(str_vs(fx%token), fx%xds%xml_version, &
              namespaces_, validCheck, fx%error_stack, null(), &
              internal=reading_main_file(fb))
          endif
          if (in_error(fx%error_stack)) return
          ! Normalize attribute values in attlist
          if (processDTD) then
            do i = 1, size(elem%attlist%list)
              if (associated(elem%attlist%list(i)%default)) then
                tempString => elem%attlist%list(i)%default
                elem%attlist%list(i)%default => &
                  normalize_attribute_text(fx, tempString)
                deallocate(tempString)
                if (in_error(fx%error_stack)) return
              endif
            enddo
          endif
          nextDTDState = ST_DTD_ATTLIST_END
        case (TOK_END_TAG)
          if (validCheck) then
            if (wf_stack(1)==0) then
              call add_error(fx%error_stack, &
                "ATTLIST not balanced in parameter entity")
              return
            endif
          endif
          wf_stack(1) = wf_stack(1) - 1
          if (processDTD) then
            call parse_dtd_attlist("", fx%xds%xml_version, &
              namespaces_, validCheck, fx%error_stack, elem, &
              internal=reading_main_file(fb))
          else
            call parse_dtd_attlist("", fx%xds%xml_version, &
              namespaces_, validCheck, fx%error_stack, null(), &
              internal=reading_main_file(fb))
          endif
          if (in_error(fx%error_stack)) return
          if (processDTD) then
            if (present(attributeDecl_handler)) then
              call report_declarations(elem, attributeDecl_handler)
              if (fx%state==ST_STOP) return
            endif
          endif
          nextDTDState = ST_DTD_SUBSET
        end select

      case (ST_DTD_ATTLIST_END)
        !write(*,*) 'ST_DTD_ATTLIST_END'
        select case (fx%tokenType)
        case (TOK_END_TAG)
          if (validCheck) then
            if (wf_stack(1)==0) then
              call add_error(fx%error_stack, &
                "ATTLIST not balanced in parameter entity")
              return
            endif
          endif
          wf_stack(1) = wf_stack(1) - 1
          if (processDTD) then
            if (present(attributeDecl_handler)) then
              call report_declarations(elem, attributeDecl_handler)
              if (fx%state==ST_STOP) return
            endif
          endif
          nextDTDState = ST_DTD_SUBSET
        end select

      case (ST_DTD_ELEMENT)
        select case (fx%tokenType)
        case (TOK_NAME)
          if (namespaces_) then
            nameOk = checkQName(str_vs(fx%token), fx%xds%xml_version)
          else
            nameOk = checkName(str_vs(fx%token), fx%xds%xml_version)
          endif
          if (.not.nameOk) then
            call add_error(fx%error_stack, "Invalid name for ELEMENT")
            return
          endif
          fx%name => fx%token
          fx%token => null()
          nextDTDState = ST_DTD_ELEMENT_CONTENTS
        end select

      case (ST_DTD_ELEMENT_CONTENTS)
        !write(*,*)'ST_DTD_ELEMENT_CONTENTS'
        select case (fx%tokenType)
        case (TOK_OPEN_PAR)
          ! increment well_formedness
          wf_stack(1) = wf_stack(1) + 1
          nextDTDState = ST_DTD_ELEMENT_CONTENTS
        case (TOK_CLOSE_PAR)
          ! increment well_formedness
          wf_stack(1) = wf_stack(1) - 1
          nextDTDState = ST_DTD_ELEMENT_CONTENTS
        case (TOK_ENTITY)
          !Weve found a PEref in the middle of the element contents
          ! Leave DTD state as it is & expand the entity ...
          nextState = ST_START_PE
        case (TOK_DTD_CONTENTS)
          if (declared_element(fx%xds%element_list, str_vs(fx%name))) then
            if (validCheck) then
              call add_error(fx%error_stack, "Duplicate Element declaration")
              return
            else
              ! Ignore contents ...
              elem => null()
            endif
          elseif (processDTD) then
            if (existing_element(fx%xds%element_list, str_vs(fx%name))) then
              elem => get_element(fx%xds%element_list, str_vs(fx%name))
            else
              elem => add_element(fx%xds%element_list, str_vs(fx%name))
            endif
          else
            elem => null()
          endif
          call parse_dtd_element(str_vs(fx%token), fx%xds%xml_version, fx%error_stack, &
            elem, reading_main_file(fb))
          if (in_error(fx%error_stack)) return
          nextDTDState = ST_DTD_ELEMENT_END
        end select

      case (ST_DTD_ELEMENT_END)
        !write(*,*)'ST_DTD_ELEMENT_END'
        select case (fx%tokenType)
        case (TOK_END_TAG)
          if (validCheck) then
            if (wf_stack(1)==0) then
              call add_error(fx%error_stack, &
                "ELEMENT not balanced in parameter entity")
              return
            endif
          endif
          wf_stack(1) = wf_stack(1) - 1
          if (processDTD.and.associated(elem)) then
            if (present(elementDecl_handler)) then
              call elementDecl_handler(str_vs(fx%name), str_vs(elem%model))
              if (fx%state==ST_STOP) return
            endif
          endif
          deallocate(fx%name)
          nextDTDState = ST_DTD_SUBSET
        end select

      case (ST_DTD_ENTITY)
        !write(*,*) 'ST_DTD_ENTITY'
        select case (fx%tokenType)
        case (TOK_NAME)
          if (str_vs(fx%token)=="%") then
            pe = .true.
            ! this will be a PE
            nextDTDState = ST_DTD_ENTITY_PE
          else
            pe = .false.
            if (namespaces_) then
              nameOk = checkNCName(str_vs(fx%token), fx%xds%xml_version)
            else
              nameOk = checkName(str_vs(fx%token), fx%xds%xml_version)
            endif
            if (.not.nameOk) then
              call add_error(fx%error_stack, &
                "Illegal name for general entity")
              return
            endif
            fx%name => fx%token
            fx%token => null()
            nextDTDState = ST_DTD_ENTITY_ID
          endif
        end select

      case (ST_DTD_ENTITY_PE)
        !write(*,*) 'ST_DTD_ENTITY_PE'
        select case (fx%tokenType)
        case (TOK_NAME)
          if (namespaces_) then
            nameOk = checkNCName(str_vs(fx%token), fx%xds%xml_version)
          else
            nameOk = checkName(str_vs(fx%token), fx%xds%xml_version)
          endif
          if (.not.nameOk) then
            call add_error(fx%error_stack, &
              "Illegal name for parameter entity")
            return
          endif
          fx%name => fx%token
          fx%token => null()
          nextDTDState = ST_DTD_ENTITY_ID
        end select

      case (ST_DTD_ENTITY_ID)
        !write(*,*) 'ST_DTD_ENTITY_ID'
        select case (fx%tokenType)
        case (TOK_NAME)
          if (str_vs(fx%token) == "PUBLIC") then
            nextDTDState = ST_DTD_ENTITY_PUBLIC
          elseif (str_vs(fx%token) == "SYSTEM") then
            nextDTDState = ST_DTD_ENTITY_SYSTEM
          else
            call add_error(fx%error_stack, "Unexpected token in ENTITY")
            return
          endif
        case (TOK_CHAR)
          if (reading_main_file(fb)) then
            tempString => fx%token
          else
            tempString => expand_pe_text(fx, fx%token, fb)
          endif
          fx%attname => expand_entity_value_alloc(tempString, fx%xds, fx%error_stack)
          if (reading_main_file(fb)) then
            tempString => null()
          else
            deallocate(tempString)
          endif
          if (in_error(fx%error_stack)) return
          nextDTDState = ST_DTD_ENTITY_END
        case default
          call add_error(fx%error_stack, "Unexpected token in ENTITY")
          return
        end select

      case (ST_DTD_ENTITY_PUBLIC)
        !write(*,*) 'ST_DTD_ENTITY_PUBLIC'
        select case (fx%tokenType)
        case (TOK_CHAR)
          if (checkPublicId(str_vs(fx%token))) then
            fx%publicId => fx%token
            fx%token => null()
            nextDTDState = ST_DTD_ENTITY_SYSTEM
          else
            call add_error(fx%error_stack, "Invalid PUBLIC id in ENTITY")
            return
          endif
        case default
          call add_error(fx%error_stack, "Unexpected token in ENTITY")
          return
        end select

      case (ST_DTD_ENTITY_SYSTEM)
        !write(*,*) 'ST_DTD_ENTITY_SYSTEM'
        select case (fx%tokenType)
        case (TOK_CHAR)
          fx%systemId => fx%token
          fx%token => null()
          nextDTDState = ST_DTD_ENTITY_NDATA
        case default
          call add_error(fx%error_stack, "Unexpected token in ENTITY")
          return
        end select

      case (ST_DTD_ENTITY_NDATA)
        !write(*,*) 'ST_DTD_ENTITY_NDATA'
        select case (fx%tokenType)
        case (TOK_END_TAG)
          if (validCheck) then
            if (wf_stack(1)==0) then
              call add_error(fx%error_stack, &
                "ENTITY not balanced in parameter entity")
              return
            endif
          endif
          wf_stack(1) = wf_stack(1) - 1
          if (processDTD) then
            call add_entity
            if (in_error(fx%error_stack)) return
            if (fx%state==ST_STOP) return
          endif
          deallocate(fx%name)
          if (associated(fx%attname)) deallocate(fx%attname)
          if (associated(fx%systemId)) deallocate(fx%systemId)
          if (associated(fx%publicId)) deallocate(fx%publicId)
          if (associated(fx%Ndata)) deallocate(fx%Ndata)
          nextDTDState = ST_DTD_SUBSET
        case (TOK_NAME)
          if (str_vs(fx%token)=='NDATA') then
            if (pe) then
              call add_error(fx%error_stack, "Parameter entity cannot have NDATA declaration")
              return
            endif
            nextDTDState = ST_DTD_ENTITY_NDATA_VALUE
          else
            call add_error(fx%error_stack, "Unexpected token in ENTITY")
            return
          endif
        case default
          call add_error(fx%error_stack, "Unexpected token in ENTITY")
          return
        end select

      case (ST_DTD_ENTITY_NDATA_VALUE)
        !write(*,*) 'ST_DTD_ENTITY_NDATA_VALUE'
        !check is a name and exists in notationlist
        select case (fx%tokenType)
        case (TOK_NAME)
          if (namespaces_) then
            nameOk = checkNCName(str_vs(fx%token), fx%xds%xml_version)
          else
            nameOk = checkName(str_vs(fx%token), fx%xds%xml_version)
          endif
          if (.not.nameOk) then
            call add_error(fx%error_stack, "Invalid name for Notation")
            return
          endif
          fx%Ndata => fx%token
          fx%token => null()
          nextDTDState = ST_DTD_ENTITY_END
        case default
          call add_error(fx%error_stack, "Unexpected token in ENTITY")
          return
        end select

      case (ST_DTD_ENTITY_END)
        !write(*,*) 'ST_DTD_ENTITY_END'
        select case (fx%tokenType)
        case (TOK_END_TAG)
          if (validCheck) then
            if (wf_stack(1)==0) then
              call add_error(fx%error_stack, &
                "ENTITY not balanced in parameter entity")
              return
            endif
          endif
          wf_stack(1) = wf_stack(1) - 1
          if (processDTD) then
            call add_entity
            if (in_error(fx%error_stack)) return
            if (fx%state==ST_STOP) return
          endif
          deallocate(fx%name)
          if (associated(fx%attname)) deallocate(fx%attname)
          if (associated(fx%systemId)) deallocate(fx%systemId)
          if (associated(fx%publicId)) deallocate(fx%publicId)
          if (associated(fx%Ndata)) deallocate(fx%Ndata)
          nextDTDState = ST_DTD_SUBSET
        case default
          call add_error(fx%error_stack, "Unexpected token at end of ENTITY")
          return
        end select

      case (ST_DTD_NOTATION)
        !write(*,*) 'ST_DTD_NOTATION'
        select case (fx%tokenType)
        case (TOK_NAME)
          if (namespaces_) then
            nameOk = checkNCName(str_vs(fx%token), fx%xds%xml_version)
          else
            nameOk = checkName(str_vs(fx%token), fx%xds%xml_version)
          endif
          if (.not.nameOk) then
            call add_error(fx%error_stack, "Invalid name for Notation")
            return
          endif
          fx%name => fx%token
          fx%token => null()
          nextDTDState = ST_DTD_NOTATION_ID
        case default
          call add_error(fx%error_stack, "Unexpected token in NOTATION")
          return
        end select

      case (ST_DTD_NOTATION_ID)
        !write(*,*)'ST_DTD_NOTATION_ID'
        select case (fx%tokenType)
        case (TOK_NAME)
          if (str_vs(fx%token)=='SYSTEM') then
            nextDTDState = ST_DTD_NOTATION_SYSTEM
          elseif (str_vs(fx%token)=='PUBLIC') then
            nextDTDState = ST_DTD_NOTATION_PUBLIC
          else
            call add_error(fx%error_stack, "Unexpected token after NOTATION")
            return
          endif
        case default
          call add_error(fx%error_stack, "Unexpected token after NOTATION")
          return
        end select

      case (ST_DTD_NOTATION_SYSTEM)
        !write(*,*)'ST_DTD_NOTATION_SYSTEM'
        select case (fx%tokenType)
        case (TOK_CHAR)
          fx%systemId => fx%token
          fx%token => null()
          nextDTDState = ST_DTD_NOTATION_END
        case default
          call add_error(fx%error_stack, "Unexpected token in NOTATION")
          return
        end select

      case (ST_DTD_NOTATION_PUBLIC)
        !write(*,*)'ST_DTD_NOTATION_PUBLIC'
        select case (fx%tokenType)
        case (TOK_CHAR)
          if (checkPublicId(str_vs(fx%token))) then
            fx%publicId => fx%token
            fx%token => null()
            nextDTDState = ST_DTD_NOTATION_PUBLIC_2
          else
            call add_error(fx%error_stack, "Invalid PUBLIC id in NOTATION")
            return
          endif
        case default
          call add_error(fx%error_stack, "Unexpected token in NOTATION")
          return
        end select

      case (ST_DTD_NOTATION_PUBLIC_2)
        !write(*,*)'ST_DTD_NOTATION_PUBLIC_2'
        select case (fx%tokenType)
        case (TOK_END_TAG)
          if (validCheck) then
            if (wf_stack(1)==0) then
              call add_error(fx%error_stack, &
                "NOTATION not balanced in parameter entity")
              return
            endif
            if (notation_exists(fx%nlist, str_vs(fx%name))) then
              call add_error(fx%error_stack, "Duplicate notation declaration")
              return
            endif
          endif
          wf_stack(1) = wf_stack(1) - 1
          if (processDTD) then
            call add_notation(fx%nlist, str_vs(fx%name), publicId=str_vs(fx%publicId))
            if (present(notationDecl_handler)) then
              call notationDecl_handler(str_vs(fx%name), publicId=str_vs(fx%publicId), systemId="")
              if (fx%state==ST_STOP) return
            endif
          endif
          deallocate(fx%name)
          deallocate(fx%publicId)
          nextDTDState = ST_DTD_SUBSET
        case (TOK_CHAR)
          fx%systemId => fx%token
          fx%token => null()
          nextDTDState = ST_DTD_NOTATION_END
        end select

      case (ST_DTD_NOTATION_END)
        !write(*,*)'ST_DTD_NOTATION_END'
        select case (fx%tokenType)
        case (TOK_END_TAG)
          if (validCheck) then
            if (wf_stack(1)==0) then
              call add_error(fx%error_stack, &
                "NOTATION not balanced in parameter entity")
              return
            endif
            if (notation_exists(fx%nlist, str_vs(fx%name))) then
              call add_error(fx%error_stack, "Duplicate notation declaration")
              return
            endif
          endif
          wf_stack(1) = wf_stack(1) - 1
          if (processDTD) then
            URIref => parseURI(str_vs(fx%systemId))
            if (.not.associated(URIref)) then
              call add_error(fx%error_stack, "Invalid SYSTEM literal")
              return
            endif
            if (hasFragment(URIref)) then
              call destroyURI(URIref)
              call add_error(fx%error_stack, "SYSTEM literal may not contain fragment")
              return
            endif
            ! We aren't ever going to do anything with this URI,
            ! since we don't do NOTATIONs.
            ! Throw it away again
            call destroyURI(URIref)
            if (associated(fx%publicId)) then
              call add_notation(fx%nlist, str_vs(fx%name), &
                publicId=str_vs(fx%publicId), systemId=str_vs(fx%systemId))
              if (present(notationDecl_handler)) then
                call notationDecl_handler(str_vs(fx%name), &
                publicId=str_vs(fx%publicId), systemId=str_vs(fx%systemId))
                if (fx%state==ST_STOP) return
              endif
            else
              call add_notation(fx%nlist, str_vs(fx%name), &
                systemId=str_vs(fx%systemId))
              if (present(notationDecl_handler)) then
                call notationDecl_handler(str_vs(fx%name), &
                publicId="", systemId=str_vs(fx%systemId))
                if (fx%state==ST_STOP) return
              endif
            endif
          endif
          if (associated(fx%publicId)) deallocate(fx%publicId)
          deallocate(fx%systemId)
          deallocate(fx%name)
          nextDTDState = ST_DTD_SUBSET
        case default
          call add_error(fx%error_stack, "Unexpected token in NOTATION")
          return
        end select

      end select

      if (nextDTDState==ST_DTD_NULL) then
        call add_error(fx%error_stack, &
          "Bad token found in DTD parsing")
      else
        fx%state_dtd = nextDTDState
      endif
      if (nextState==ST_NULL) &
        nextState = ST_IN_SUBSET

    end subroutine parseDTD

    subroutine open_tag
      elem => get_element(fx%xds%element_list, str_vs(fx%name))
      if (associated(elem)) then
        if (validCheck) then
          call checkAttributes(elem, fx%attributes)
          if (.not.checkContentModel(fx%elstack, str_vs(fx%name))) then
            call add_error(fx%error_stack, &
              "Element "//str_vs(fx%name)//" not permitted in this context")
            return
          endif
        else
          call getDefaultAttributes(elem, fx%attributes)
        endif
      else
        if (validCheck) then
          call add_error(fx%error_stack, &
          "Trying to use an undeclared element")
          return
        endif
      endif
      ! Check for namespace changes
      if (namespaces_) then
        call checkNamespaces(fx%attributes, fx%nsDict, &
        len(fx%elstack), fx%xds, namespace_prefixes_, xmlns_uris_, &
        fx%error_stack, startInCharData_, &
        startPrefixMapping_handler, endPrefixMapping_handler)
        if (fx%state==ST_STOP) return
      endif
      if (in_error(fx%error_stack)) return
      call checkXmlAttributes
      if (in_error(fx%error_stack)) return
      if (size(extEntStack)>0) then
        if (len(fx%elstack)==extEntStack(1)) &
          ! This is a top-level element in the current entity
          call setBase(fx%attributes, expressURI(fb%f(1)%baseURI))
      endif
      if (namespaces_.and.getURIofQName(fx,str_vs(fx%name))==invalidNS) then
        ! no namespace was found for the current element
        if (.not.startInCharData_) then
          ! but we ignore this if we are parsing an entity through DOM
          call add_error(fx%error_stack, "No namespace found for current element")
          return
        elseif (present(startElement_handler)) then
          ! Record it as having an empty URI
          call startElement_handler("", &
            getlocalNameofQName(str_vs(fx%name)), &
            str_vs(fx%name), fx%attributes)
          if (fx%state==ST_STOP) return
        endif
      elseif (namespaces_) then
        ! Normal state of affairs
        if (present(startElement_handler)) then
          call startElement_handler(getURIofQName(fx, str_vs(fx%name)), &
          getlocalNameofQName(str_vs(fx%name)), &
          str_vs(fx%name), fx%attributes)
          if (fx%state==ST_STOP) return
        endif
      else
        ! Non-namespace aware processing
        if (present(startElement_handler)) then
          call startElement_handler("", "", &
          str_vs(fx%name), fx%attributes)
          if (fx%state==ST_STOP) return
        endif
      endif
      if (validCheck) then
        call push_elstack(fx%elstack, str_vs(fx%name), elem%cp)
      else
        call push_elstack(fx%elstack, str_vs(fx%name))
      endif
      call reset_dict(fx%attributes)
    end subroutine open_tag

    subroutine close_tag
      wf_stack(1) = wf_stack(1) - 1
      if (wf_stack(1)<0) then
        call add_error(fx%error_stack, &
          'Ill-formed entity')
        return
      endif
      if (str_vs(fx%name)/=get_top_elstack(fx%elstack)) then
        call add_error(fx%error_stack, &
          "Mismatching close tag: trying to close "//get_top_elstack(fx%elstack) &
          //" with "//str_vs(fx%name))
        return
      endif
      if (validCheck) then
        if (.not.checkContentModelToEnd(fx%elstack)) then
          call add_error(fx%error_stack, &
            "Failed to fulfil content model for "//str_vs(fx%name))
          return
        endif
      endif
      fx%name = pop_elstack(fx%elstack)
      if (present(endElement_handler)) then
        if (namespaces_.and.getURIofQName(fx,str_vs(fx%name))==invalidNS) then
          ! no namespace was found for the current element, we must be
          ! closing inside a DOM entity.
          ! Record it as having an empty URI
          call endElement_handler("", &
            getlocalNameofQName(str_vs(fx%name)), &
            str_vs(fx%name))
        elseif (namespaces_) then
          ! Normal state of affairs
          call endElement_handler(getURIofQName(fx, str_vs(fx%name)), &
            getlocalnameofQName(str_vs(fx%name)), &
            str_vs(fx%name))
        else
          ! Non-namespace-aware processing:
          call endElement_handler("", "", &
            str_vs(fx%name))
        endif
        if (fx%state==ST_STOP) return
      endif
      if (namespaces_) then
        call checkEndNamespaces(fx%nsDict, len(fx%elstack), &
        endPrefixMapping_handler)
        if (fx%state==ST_STOP) return
      endif
    end subroutine close_tag

    subroutine add_entity
      !Parameter or General Entity?
      logical :: wfc
      wfc = fb%f(1)%pe.or.inExtSubset
      if (pe) then
        !Does entity with this name exist?
        if (.not.existing_entity(fx%xds%PEList, str_vs(fx%name))) then
          ! Internal or external?
          if (associated(fx%attname)) then ! it's internal
            call register_internal_PE(fx%xds, &
              name=str_vs(fx%name), text=str_vs(fx%attname), &
              wfc=wfc, baseURI=copyURI(fb%f(1)%baseURI))
            ! FIXME need to expand value here before reporting ...
            if (present(internalEntityDecl_handler)) then
              call internalEntityDecl_handler('%'//str_vs(fx%name), str_vs(fx%attname))
              if (fx%state==ST_STOP) return
            endif
          else ! PE can't have Ndata declaration
            URIref => parseURI(str_vs(fx%systemId))
            if (.not.associated(URIref)) then
              call add_error(fx%error_stack, "Invalid URI specified for SYSTEM")
            elseif (hasFragment(URIref)) then
              call add_error(fx%error_stack, "Fragment not permitted on SYSTEM URI")
              call destroyURI(URIref)
            else
              newURI => rebaseURI(fb%f(1)%baseURI, URIref)
              call destroyURI(URIref)
              if (associated(fx%publicId)) then
                call register_external_PE(fx%xds, name=str_vs(fx%name), &
                  systemId=str_vs(fx%systemId), publicId=str_vs(fx%publicId), &
                  wfc=wfc, baseURI=newURI)
                if (present(externalEntityDecl_handler)) &
                  call externalEntityDecl_handler('%'//str_vs(fx%name), &
                  systemId=str_vs(fx%systemId), publicId=str_vs(fx%publicId))
              else
                call register_external_PE(fx%xds, name=str_vs(fx%name), &
                  systemId=str_vs(fx%systemId), &
                  wfc=wfc, baseURI=newURI)
                if (present(externalEntityDecl_handler)) &
                  call externalEntityDecl_handler('%'//str_vs(fx%name), &
                  systemId=str_vs(fx%systemId), publicId="")
              endif
            endif
          endif
          ! else we ignore it
        endif
      else !It's a general entity
        if (.not.existing_entity(fx%xds%entityList, str_vs(fx%name))) then
          ! Internal or external?
          if (associated(fx%attname)) then ! it's internal
            call register_internal_GE(fx%xds, name=str_vs(fx%name), &
              text=str_vs(fx%attname), &
              wfc=wfc, baseURI=copyURI(fb%f(1)%baseURI))
            if (present(internalEntityDecl_handler)) then
              call internalEntityDecl_handler(str_vs(fx%name),&
              str_vs(fx%attname))
              if (fx%state==ST_STOP) return
            endif
          else
            URIref => parseURI(str_vs(fx%systemId))
            if (.not.associated(URIref)) then
              call add_error(fx%error_stack, "Invalid URI specified for SYSTEM")
            elseif (hasFragment(URIref)) then
              call add_error(fx%error_stack, "Fragment not permitted on SYSTEM URI")
              call destroyURI(URIref)
            else
              newURI => rebaseURI(fb%f(1)%baseURI, URIref)
              call destroyURI(URIref)
              if (associated(fx%publicId).and.associated(fx%Ndata)) then
                call register_external_GE(fx%xds, name=str_vs(fx%name), &
                  systemId=str_vs(fx%systemId), publicId=str_vs(fx%publicId), &
                  notation=str_vs(fx%Ndata), &
                  wfc=wfc, baseURI=newURI)
                if (present(unparsedEntityDecl_handler)) &
                  call unparsedEntityDecl_handler(str_vs(fx%name), &
                  systemId=str_vs(fx%systemId), publicId=str_vs(fx%publicId), &
                  notation=str_vs(fx%Ndata))
              elseif (associated(fx%Ndata)) then
                call register_external_GE(fx%xds, name=str_vs(fx%name), &
                  systemId=str_vs(fx%systemId), notation=str_vs(fx%Ndata), &
                  wfc=wfc, baseURI=newURI)
                if (present(unparsedEntityDecl_handler)) &
                  call unparsedEntityDecl_handler(str_vs(fx%name), publicId="", &
                  systemId=str_vs(fx%systemId), notation=str_vs(fx%Ndata))
              elseif (associated(fx%publicId)) then
                call register_external_GE(fx%xds, name=str_vs(fx%name), &
                  systemId=str_vs(fx%systemId), publicId=str_vs(fx%publicId), &
                  wfc=wfc, baseURI=newURI)
                if (present(externalEntityDecl_handler)) &
                  call externalEntityDecl_handler(str_vs(fx%name), &
                  systemId=str_vs(fx%systemId), publicId=str_vs(fx%publicId))
              else
                call register_external_GE(fx%xds, name=str_vs(fx%name), &
                  systemId=str_vs(fx%systemId), wfc=wfc, baseURI=newURI)
                if (present(externalEntityDecl_handler)) &
                  call externalEntityDecl_handler(str_vs(fx%name), &
                  systemId=str_vs(fx%systemId), publicId="")
              endif
            endif
          endif
        endif
      endif
    end subroutine add_entity

    subroutine getDefaultAttributes(el, dict)
      type(element_t), pointer :: el
      type(dictionary_t), intent(inout) :: dict

      type(attribute_t), pointer :: att
      integer :: i, ind
      character, pointer :: attValue(:)

      do i = 1, size(el%attlist%list)
        att => el%attlist%list(i)
        call get_att_index_pointer(dict, str_vs(att%name), ind, attValue)
        if (.not.associated(attValue)) then
          if (att%attDefault==ATT_DEFAULT &
            .or.att%attDefault==ATT_FIXED) then
            call add_item_to_dict(dict, &
              str_vs(att%name), str_vs(att%default), &
              specified=.false., declared=.true.)
          endif
        endif
      end do
    end subroutine getDefaultAttributes

    subroutine checkAttributes(el, dict)
      type(element_t), pointer :: el
      type(dictionary_t), intent(inout) :: dict

      integer :: i, j

      type(attribute_t), pointer :: att
      type(string_list) :: s_list
      character, pointer :: attValue(:), s(:)

      integer :: ind
      logical, allocatable :: attributesLeft(:)
      allocate(attributesLeft(getLength(dict)))
      attributesLeft = .true.

      do i = 1, size(el%attlist%list)
        att => el%attlist%list(i)
        call get_att_index_pointer(dict, str_vs(att%name), ind, attValue)
        if (associated(attValue)) attributesLeft(ind) = .false.
        select case(att%attDefault)
        case (ATT_REQUIRED, ATT_IMPLIED, ATT_DEFAULT)
          if (.not.associated(attValue)) then
            if (att%attDefault==ATT_REQUIRED) then
              ! Validity Constraint: Required Attribute
              call add_error(fx%error_stack, &
                "REQUIRED attribute "//str_vs(att%name)//" not present")
              return
            elseif (att%attDefault==ATT_DEFAULT) then
              if (fx%xds%standalone.and..not.att%internal) then
                ! VC: Standalone document declaration"
                call add_error(fx%error_stack, &
                  "Externally-specifid default attribute used in non-standalone document")
                return
              else
                call add_item_to_dict(dict, &
                  str_vs(att%name), str_vs(att%default), &
                  specified=.false., declared=.true.)
              endif
            endif
          else
            select case(att%attType)
            case (ATT_ID)
              ! VC: ID
              if (namespaces_) then
                nameOk = checkNCName(str_vs(attValue), fx%xds%xml_version)
              else
                nameOk = checkName(str_vs(attValue), fx%xds%xml_version)
              endif
              if (.not.nameOk) then
                call add_error(fx%error_stack, &
                  "Attributes of type ID must have a value which is an XML Name")
                return
              endif
              if (registered_string(id_list, str_vs(attValue))) then
                call add_error(fx%error_stack, &
                  "Cannot declare the same ID twice")
                return
              endif
              call add_string(id_list, str_vs(attValue))
              call setIsId(dict, ind, .true.)
              ! We don't need to check for duplicate ID & xml:ids on the same
              ! element - if we are validating we'd already have noticed,
              ! if we're not, it's not possible
            case (ATT_IDREF)
              ! VC: IDREF
              if (namespaces_) then
                nameOk = checkNCName(str_vs(attValue), fx%xds%xml_version)
              else
                nameOk = checkName(str_vs(attValue), fx%xds%xml_version)
              endif
              if (.not.nameOk) then
                call add_error(fx%error_stack, &
                  "Attributes of type IDREF must have a value which is an XML Name")
                return
              endif
              ! FIXME in a namespaced document they must match QName
              if (.not.registered_string(idref_list, str_vs(attValue))) &
                call add_string(idref_list, str_vs(attValue))
            case (ATT_IDREFS)
              ! VC: IDREF
              if (namespaces_) then
                nameOk = checkNCNames(str_vs(attValue), fx%xds%xml_version)
              else
                nameOk = checkNames(str_vs(attValue), fx%xds%xml_version)
              endif
              if (.not.nameOk) then
                call add_error(fx%error_stack, &
                  "Attributes of type IDREFS must have a value which contains only XML Names")
                return
              endif
              call tokenize_and_add_strings(idref_list, str_vs(attValue), .true.)
            case (ATT_ENTITY)
              ! VC: Entity Name
              if (namespaces_) then
                nameOk = checkNCName(str_vs(attValue), fx%xds%xml_version)
              else
                nameOk = checkName(str_vs(attValue), fx%xds%xml_version)
              endif
              if (.not.nameOk) then
                call add_error(fx%error_stack, &
                  "Attributes of type ENTITY must have a value which is an XML Name")
                return
              endif
              ent => getEntityByName(fx%xds%entityList, str_vs(attValue))
              if (associated(ent)) then
                if (.not.is_unparsed_entity(ent)) then
                  ! Validity Constraint: Entity Name
                  call add_error(fx%error_stack, &
                    "Attribute "//str_vs(att%name) &
                    //" of element "//str_vs(el%name) &
                    //" declared as ENTITY refers to parsed entity")
                  return
                endif
              else
                ! Validity Constraint: Entity Name
                call add_error(fx%error_stack, &
                  "Attribute "//str_vs(att%name) &
                  //" of element "//str_vs(el%name) &
                  //" declared as ENTITY refers to non-existent entity")
                return
              endif
            case (ATT_ENTITIES)
              ! VC: Entity Name
              if (namespaces_) then
                nameOk = checkNCNames(str_vs(attValue), fx%xds%xml_version)
              else
                nameOk = checkNames(str_vs(attValue), fx%xds%xml_version)
              endif
              if (.not.nameOk) then
                call add_error(fx%error_stack, &
                  "Attributes of type ENTITIES must have a value which contains only XML Names")
                return
              endif
              s_list = tokenize_to_string_list(str_vs(attValue))
              do j = 1, size(s_list%list)
                s => s_list%list(j)%s
                ent => getEntityByName(fx%xds%entityList, str_vs(s))
                if (associated(ent)) then
                  if (.not.is_unparsed_entity(ent)) then
                    ! Validity Constraint: Entity Name
                    call add_error(fx%error_stack, &
                      "Attribute "//str_vs(att%name) &
                      //" of element "//str_vs(el%name) &
                      //" declared as ENTITIES refers to parsed entity "&
                      //str_vs(s))
                    call destroy_string_list(s_list)
                    return
                  endif
                else
                  ! Validity Constraint: Entity Name
                  call add_error(fx%error_stack, &
                    "Attribute "//str_vs(att%name) &
                    //" of element "//str_vs(el%name) &
                    //" declared as ENTITIES refers to non-existent entity "&
                    //str_vs(s))
                  call destroy_string_list(s_list)
                  return
                endif
              enddo
              call destroy_string_list(s_list)
            case (ATT_NMTOKEN)
              ! VC Name Token
              if (.not.checkNmtoken(str_vs(attValue), fx%xds%xml_version)) then
                call add_error(fx%error_stack, &
                  "Attributes of type NMTOKEN must have a value which is a NMTOKEN")
                return
              endif
            case (ATT_NMTOKENS)
              ! VC: Name Token
              if (.not.checkNmtokens(str_vs(attValue), fx%xds%xml_version)) then
                call add_error(fx%error_stack, &
                  "Attributes of type NMTOKENS must have a value which contain only NMTOKENs")
                return
              endif
            case (ATT_NOTATION)
              ! VC: Notation Attributes
              if (namespaces_) then
                nameOk = checkNCName(str_vs(attValue), fx%xds%xml_version)
              else
                nameOk = checkName(str_vs(attValue), fx%xds%xml_version)
              endif
              if (.not.nameOk) then
                call add_error(fx%error_stack, &
                  "Attributes of type NOTATION must have a value which is an XML Name")
                return
              endif
              if (.not.notation_exists(fx%nlist, str_vs(attValue))) then
                ! Validity Constraint: Notation Attributes
                call add_error(fx%error_stack, &
                  "Attribute "//str_vs(att%name) &
                  //" declared as NOTATION refers to non-existent notation "&
                  //str_vs(attValue))
                return
              endif
              if (att%attDefault==ATT_REQUIRED) then
                if (.not.registered_string(att%enumerations, str_vs(attValue))) &
                  call add_error(fx%error_stack, &
                  "NOTATION attribute is not among declared values.")
              endif
            case (ATT_ENUM)
              ! VC: Notation Attributes
              if (.not.checkNmtoken(str_vs(attValue), fx%xds%xml_version)) then
                call add_error(fx%error_stack, &
                  "Attributes of type ENUM must have a value which is an NMTOKEN")
                return
              endif
              if (.not.registered_string(att%enumerations, str_vs(attValue))) then
                ! Validity Constraint: Enumeration
                call add_error(fx%error_stack, &
                  "Attribute "//str_vs(att%name) &
                  //" of element "//str_vs(el%name) &
                  //" declared as ENUM refers to undeclared enumeration "&
                  //str_vs(attValue))
                return
              endif
            end select
          endif
        case (ATT_FIXED)
          if (associated(attValue)) then
            if (str_vs(att%default)//"x"/=str_vs(attValue)//"x") then
              ! Validity Constraint: Fixed Attribute Default
              call add_error(fx%error_stack, &
                "FIXED attribute has wrong value")
              return
            endif
          else
            if (fx%xds%standalone.and..not.att%internal) then
              ! VC: Standalone document declaration"
              call add_error(fx%error_stack, &
                "Externally-specified default attribute used in non-standalone document")
              return
            else
              call add_item_to_dict(dict, &
                str_vs(att%name), str_vs(att%default), &
                specified=.false., declared=.true.)
            endif
          endif
        end select
      enddo

      if (any(attributesLeft)) &
        call add_error(fx%error_stack, &
        "Undeclared attributes forbidden")

    end subroutine checkAttributes

    subroutine checkXMLAttributes
      integer :: ind
      character, pointer :: attValue(:)
      ! These must all be done with the name of the attribute,
      ! not the nsURI/localname pair, in case we are
      ! processing for a non-namespace aware application
      if (has_key(fx%attributes, 'xml:space')) then
        if (get_value(fx%attributes, 'xml:space')/='default' &
          .and. get_value(fx%attributes, 'xml:space')/='preserve') then
          call add_error(fx%error_stack, 'Illegal value of xml:space attribute')
          return
        endif
      endif
      call get_att_index_pointer(fx%attributes, "xml:id", ind, attValue)
      if (associated(attValue)) then
        ! Per xml:id spec, NCName even in non-namespace aware document
        if (.not.checkNCName(str_vs(attValue), fx%xds%xml_version)) then
          call add_error(fx%error_stack, &
            "xml:id attributes must have values which are NCNames")
          return
        elseif (registered_string(id_list, str_vs(attValue))) then
          call add_error(fx%error_stack, &
            "xml:id attributes must be unique within a document")
          return
        endif
        call add_string(id_list, str_vs(attValue))
        call setIsId(fx%attributes, ind, .true.)
      endif
      if (has_key(fx%attributes, "xml:base")) then
        URIref => parseURI(get_value(fx%attributes,"xml:base"))
        if (.not.associated(URIref)) then
          call add_error(fx%error_stack, &
            "Invalid URI reference specified for xml:base attribute")
        else
          call destroyURI(URIref)
        endif
      endif
      !if (has_key(fx%attributes, 'xml:lang')) then
      !   We never care about this at the SAX level.
      !endif
    end subroutine checkXMLAttributes

    subroutine endDTDchecks
      type(element_t), pointer :: el
      type(attribute_t), pointer :: att
      type(entity_t), pointer :: ent
      type(string_list) :: s_list
      character, pointer :: s(:)
      integer :: i, j, k

      if (present(FoX_endDTD_handler)) then
        fx%xds_used = .true.
        call FoX_endDTD_handler(fx%xds)
      endif
      if (present(endDTD_handler)) then
        call endDTD_handler
        if (fx%state==ST_STOP) return
      endif
      ! Check that all notations used have been declared:
      if (validCheck) then
        do i = 1, size(fx%xds%entityList)
          ent => getEntityByIndex(fx%xds%entityList, i)
          if (str_vs(ent%notation)/="" &
            .and..not.notation_exists(fx%nlist, str_vs(ent%notation))) then
            ! Validity Constraint: Notation Declared
            call add_error(fx%error_stack, "Attempt to use undeclared notation")
            exit
          endif
        enddo
        validLoop: do i = 1, size(fx%xds%element_list%list)
          el => fx%xds%element_list%list(i)
          do j = 1, size(el%attlist%list)
            att => el%attlist%list(j)
            ! For NOTATION, need to check enumerated as well as default ...
            if (att%attType==ATT_NOTATION) then
              do k = 1, size(att%enumerations%list)
                s => att%enumerations%list(k)%s
                if (.not.notation_exists(fx%nlist, str_vs(s))) then
                  ! Validity Constraint: Notation Attributes
                  call add_error(fx%error_stack, &
                    "Enumerated NOTATION in "//str_vs(att%name) &
                    //" of element "//str_vs(el%name) &
                    //" refers to non-existent notation")
                  call destroy(s_list)
                  exit validLoop
                endif
              enddo
              if (associated(att%default)) then
                s_list = tokenize_to_string_list(str_vs(att%default))
                do k = 1, size(s_list%list)
                  s => s_list%list(k)%s
                  if (.not.notation_exists(fx%nlist, str_vs(s))) then
                    ! Validity Constraint: Notation Attributes
                    call add_error(fx%error_stack, &
                      "Attribute "//str_vs(att%name) &
                      //" of element "//str_vs(el%name) &
                      //" declared as NOTATION refers to non-existent notation")
                    call destroy(s_list)
                    exit validLoop
                  endif
                enddo
                call destroy(s_list)
              endif
            endif
          enddo
        enddo validLoop
      endif
    end subroutine endDTDchecks

    subroutine checkIdRefs
      integer :: i
      character, pointer :: s(:)
      do i = 1, size(idRef_list%list)
        s => idRef_list%list(i)%s
        if (.not.registered_string(id_list, str_vs(s))) then
          call add_error(fx%error_stack, &
            "Reference to undeclared ID "//str_vs(s))
          return
        endif
      enddo
    end subroutine checkIdRefs
  end subroutine sax_parse


  subroutine sax_error(fx, error_handler)
    type(sax_parser_t), intent(inout) :: fx
    optional :: error_handler
    interface
      subroutine error_handler(msg)
        character(len=*), intent(in)     :: msg
      end subroutine error_handler
    end interface

    character, dimension(:), pointer :: errmsg

    integer :: i, m, n, n_err
    n = size(fx%error_stack%stack)
    n_err = n

    do i = 1, n
      n_err = n_err + size(fx%error_stack%stack(i)%msg) ! + spaces + size of entityref
    enddo
    allocate(errmsg(n_err))
    errmsg = ''
    n = 1
    do i = 1, size(fx%error_stack%stack)
      m = size(fx%error_stack%stack(i)%msg)
      errmsg(n:n+m-1) = fx%error_stack%stack(i)%msg
      errmsg(n+m:n+m) = " "
      n = n + m + 1
    enddo
    ! FIXME put location information in here
    if (present(error_handler)) then
      call error_handler(str_vs(errmsg))
      deallocate(errmsg)
      if (fx%state==ST_STOP) return
    else
      call FoX_error(str_vs(errmsg))
    endif

  end subroutine sax_error

  pure function URIlength(fx, qname) result(l_u)
    type(sax_parser_t), intent(in) :: fx
    character(len=*), intent(in) :: qName
    integer :: l_u
    integer :: n
    n = index(QName, ':')
    if (n > 0) then
      l_u = len(getnamespaceURI(fx%nsDict, QName(1:n-1)))
    else
      l_u = len(getnamespaceURI(fx%nsDict))
    endif
  end function URIlength

  pure function getURIofQName(fx, qname) result(URI)
    type(sax_parser_t), intent(in) :: fx
    character(len=*), intent(in) :: qName
    character(len=URIlength(fx, qname)) :: URI

    integer :: n
    n = index(QName, ':')
    if (n > 0) then
      URI = getnamespaceURI(fx%nsDict, QName(1:n-1))
    else
      URI = getnamespaceURI(fx%nsDict)
    endif

  end function getURIofQName

  pure function getLocalNameofQName(qname) result(localName)
    character(len=*), intent(in) :: qName
    character(len=len(QName)-index(QName,':')) :: localName

    localName = QName(index(QName,':')+1:)
  end function getLocalNameofQName
#endif

end module m_sax_parser

module m_dom_parse

  use fox_m_fsys_array_str, only: str_vs, vs_str_alloc
  use fox_m_utils_uri, only: URI, parseURI, rebaseURI, expressURI, destroyURI
  use m_common_attrs, only: hasKey, getValue, getIndex, getIsId, getBase,      &
    add_item_to_dict
  use m_common_entities, only: entity_t, size, getEntityByIndex
  use m_common_error, only: FoX_error
  use m_common_struct, only: xml_doc_state
  use FoX_common, only: dictionary_t, getLength
  use FoX_common, only: getQName, getValue, getURI, isSpecified
  use m_sax_parser, only: sax_parse
  use FoX_sax, only: xml_t
  use FoX_sax, only: open_xml_file, open_xml_string, close_xml_t

  ! Public interfaces
  use m_dom_dom, only: DOMConfiguration, Node, NamedNodeMap,                   &
    TEXT_NODE,                                                                 &
    getAttributes, getData, getDocType, getEntities, getImplementation,        &
    getLastChild, getNodeType,         &
    getNotations, getParameter, getParentNode, getXmlVersion,                  &
    setAttribute, setAttributeNS, setData, setValue,                           &
    appendChild, createAttribute, createAttributeNS, createCdataSection,       &
    createComment, createDocumentType, createElement, createElementNS,         &
    createEntityReference, createProcessingInstruction, createTextNode,        &
    getNamedItem, setAttributeNode, setAttributeNodeNS, setNamedItem,          &
    getFoX_checks

  ! Private interfaces
  use m_dom_dom, only: copyDOMConfig, createEmptyDocument, setDocumentElement, &
    createEmptyEntityReference, createEntity, createNotation,    &
    getReadOnly, getStringValue, getXds, destroy, destroyAllNodesRecursively,  &
    namespaceFixup, setDocType, setDomConfig, setGCstate, setIllFormed,        &
    setIsElementContentWhitespace, setIsId, setReadOnlyMap, setReadonlyNode,   &
    setSpecified, setXds, setStringValue
    
  use m_dom_error, only: DOMException, inException, throw_exception,           &
    getExceptionCode, PARSE_ERR

  implicit none
  private

  public :: parsefile
  public :: parsestring

  type(xml_t), target, save :: fxml

  type(Node), pointer, save  :: mainDoc => null()
  type(Node), pointer, save  :: current => null()

  type(DOMConfiguration), pointer :: domConfig
  
  logical :: cdata
  character, pointer :: error(:) => null()
  character, pointer :: inEntity(:) => null()

contains

  subroutine startElement_handler(nsURI, localname, name, attrs)
    character(len=*),   intent(in) :: nsURI
    character(len=*),   intent(in) :: localname
    character(len=*),   intent(in) :: name
    type(dictionary_t), intent(in) :: attrs
   
    type(URI), pointer :: URIref, URIbase, newURI
    type(Node), pointer :: el, attr, dummy
    character, pointer :: baseURI(:)
    integer :: i

    if (getParameter(domConfig, "namespaces")) then
      el => createElementNS(mainDoc, nsURI, name)
    else
      el => createElement(mainDoc, name)
    endif

    if (getBase(attrs)/="") then
      i = getIndex(attrs, "xml:base")
      if (i>0) then
        URIbase => parseURI(getBase(attrs))
        URIref => parseURI(getValue(attrs, i))
        newURI => rebaseURI(URIbase, URIref)
        call destroyURI(URIbase)
        call destroyURI(URIref)
        baseURI => vs_str_alloc(expressURI(newURI))
        call destroyURI(newURI)
      else
        baseURI => vs_str_alloc(getBase(attrs))
      endif
      if (getParameter(domConfig, "namespaces")) then
        attr => createAttributeNS(mainDoc, &
          "http://www.w3.org/XML/1998/namespace", "xml:base")
      else
        attr => createAttribute(mainDoc, "xml:base")
      endif
      call setValue(attr, str_vs(baseURI))
      deallocate(baseURI)
      if (i>0) then
        call setSpecified(attr, isSpecified(attrs, i))
        call setIsId(attr, getIsId(attrs, i))
      endif
      if (getParameter(domConfig, "namespaces")) then
        dummy => setAttributeNodeNS(el, attr)
      else
        dummy => setAttributeNode(el, attr)
      endif
    endif

    do i = 1, getLength(attrs)
      if (getQName(attrs, i)=="xml:base") cycle
      if (getParameter(domConfig, "namespaces")) then
        attr => createAttributeNS(mainDoc, getURI(attrs, i), getQName(attrs, i))
      else
        attr => createAttribute(mainDoc, getQName(attrs, i))
      endif
      call setValue(attr, getValue(attrs, i))
      call setSpecified(attr, isSpecified(attrs, i))
      call setIsId(attr, getIsId(attrs, i))
      if (getParameter(domConfig, "namespaces")) then
        dummy => setAttributeNodeNS(el, attr)
      else
        dummy => setAttributeNode(el, attr)
      endif
      if (associated(inEntity)) call setReadOnlyNode(attr, .true., .true.)
    enddo

    if (associated(current, mainDoc)) then
      current => appendChild(current,el)
      call setDocumentElement(mainDoc, current)
    else
      current => appendChild(current,el)
    endif
    if (getParameter(domConfig, "namespaces")) &
       call namespaceFixup(current, .false.)

    if (associated(inEntity)) &
      call setReadOnlyMap(getAttributes(current), .true.)

    cdata = .false.

  end subroutine startElement_handler

  subroutine endElement_handler(URI, localName, name)
    character(len=*), intent(in)     :: URI
    character(len=*), intent(in)     :: localname
    character(len=*), intent(in)     :: name

    if (associated(inEntity)) call setReadOnlyNode(current, .true., .false.)

    current => getParentNode(current)
  end subroutine endElement_handler

  ! FIXME to pick up entity references within attribute values, we need
  ! separate just_the_element, start_attribute, attribute_text etc. calls.

  subroutine characters_handler(chunk)
    character(len=*), intent(in) :: chunk

    type(Node), pointer :: temp
    logical :: readonly

    temp => getLastChild(current)
    if (associated(temp)) then
      if (.not.cdata.and.getNodeType(temp)==TEXT_NODE) then
        readonly = getReadOnly(temp) ! Reset readonly status quickly
        call setReadOnlyNode(temp, .false., .false.)
        call setData(temp, getData(temp)//chunk)
        call setReadOnlyNode(temp, readonly, .false.)
        return
      endif
    endif
    if (cdata) then
      temp => createCdataSection(mainDoc, chunk)
      temp => appendChild(current, temp)
    else
      temp => createTextNode(mainDoc, chunk)
      temp => appendChild(current, temp)
    endif

    if (associated(inEntity)) call setReadOnlyNode(temp, .true., .false.)

  end subroutine characters_handler

  subroutine ignorableWhitespace_handler(chunk)
    character(len=*), intent(in) :: chunk

    type(Node), pointer :: temp
    logical :: readonly

    if (getParameter(domConfig, "element-content-whitespace")) then
      temp => getLastChild(current)
      if (associated(temp)) then
        if (getNodeType(temp)==TEXT_NODE) then
          readonly = getReadOnly(temp) ! Reset readonly status quickly
          call setReadOnlyNode(temp, .false., .false.)
          call setData(temp, getData(temp)//chunk)
          call setReadOnlyNode(temp, readonly, .false.)
          call setIsElementContentWhitespace(temp, .true.)
          return
        endif
      endif
      temp => createTextNode(mainDoc, chunk)
      temp => appendChild(current, temp)
      call setIsElementContentWhitespace(temp, .true.)
      if (associated(inEntity)) call setReadOnlyNode(temp, .true., .false.)
    endif

  end subroutine ignorableWhitespace_handler

  subroutine comment_handler(comment)
    character(len=*), intent(in) :: comment

    type(Node), pointer :: temp

    if (getParameter(domConfig, "comments")) then
      temp => appendChild(current, createComment(mainDoc, comment))
      if (associated(inEntity)) call setReadOnlyNode(temp, .true., .false.)
    endif

  end subroutine comment_handler

  subroutine processingInstruction_handler(target, data)
    character(len=*), intent(in) :: target
    character(len=*), intent(in) :: data

    type(Node), pointer :: temp

    temp => appendChild(current, &
      createProcessingInstruction(mainDoc, target, data))

    if (associated(inEntity)) call setReadOnlyNode(temp, .true., .false.)
  end subroutine processingInstruction_handler

  subroutine startDocument_handler
    mainDoc => createEmptyDocument()
    current => mainDoc
    call setGCstate(mainDoc, .false.)
    call setDomConfig(mainDoc, domConfig)
  end subroutine startDocument_handler

  subroutine endDocument_Handler
    call setGCstate(mainDoc, .true.)
  end subroutine endDocument_Handler

  subroutine startDTD_handler(name, publicId, systemId)
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: publicId
    character(len=*), intent(in) :: systemId

    type(Node), pointer :: np

    np => createDocumentType(getImplementation(mainDoc), name, publicId=publicId, systemId=systemId)
    np => appendChild(mainDoc, np)
    call setDocType(mainDoc, np)

  end subroutine startDTD_handler

  subroutine endDTD_handler

    type(Node), pointer :: np, oldcurrent
    type(NamedNodeMap), pointer :: entities
    type(xml_t) :: subsax
    type(xml_doc_state), pointer :: xds
    type(entity_t), pointer :: ent
    integer :: i, ios
    logical :: ok

    entities => getEntities(getDocType(mainDoc))
    xds => getXds(mainDoc)

    do i = 1, size(xds%entityList)
      ent => getEntityByIndex(xds%entityList, i)
      np => getNamedItem(entities, str_vs(ent%name))

      ok = .false.
      if (ent%external) then
        if (size(ent%notation)==0) then
          call open_xml_file(subsax, expressURI(ent%baseURI), iostat=ios)
          if (ios/=0) then
            call setIllFormed(np, .true.)
          else
            ok = .true.
          endif
        endif
      else
        call open_xml_string(subsax, getStringValue(np))
        ok = .true.
      endif
      if (ok) then
        oldcurrent => current
        current => np
        ! Run the parser over value
        ! We do this with all entities already declared.
        call sax_parse(subsax%fx, subsax%fb,                           &
          startElement_handler=startElement_handler,                   &
          endElement_handler=endElement_handler,                       &
          characters_handler=characters_handler,                       &
          startCdata_handler=startCdata_handler,                       &
          endCdata_handler=endCdata_handler,                           &
          comment_handler=comment_handler,                             &
          processingInstruction_handler=processingInstruction_handler, &
          fatalError_handler=entityErrorHandler,                       &
          startInCharData = .true.,                                    &
          externalEntity = ent%external,                               &
          xmlVersion = getXmlVersion(mainDoc),                         &
          namespaces=getParameter(domConfig, "namespaces"),            &
          initial_entities = xds%entityList)
        call close_xml_t(subsax)

        current => oldcurrent
      endif
    enddo

    if (associated(getDocType(mainDoc))) then
      call setReadonlyMap(getEntities(getDocType(mainDoc)), .true.)
      call setReadonlyMap(getNotations(getDocType(mainDoc)), .true.)
    endif

  end subroutine endDTD_handler

  subroutine FoX_endDTD_handler(state)
    type(xml_doc_state), pointer :: state

    call setXds(mainDoc, state)

  end subroutine FoX_endDTD_handler

  subroutine notationDecl_handler(name, publicId, systemId)
    character(len=*), intent(in) :: name
    character(len=*), intent(in) ::  publicId
    character(len=*), intent(in) :: systemId
    
    type(Node), pointer :: np

    np => createNotation(mainDoc, name, publicId=publicId, systemId=systemId)
    np => setNamedItem(getNotations(getDocType(mainDoc)), np)
    ! The SAX parser will never give us duplicate entities,
    ! so there is no need to check

  end subroutine notationDecl_handler

  subroutine startCdata_handler()
    if (getParameter(domConfig, "cdata-sections")) cdata = .true.
  end subroutine startCdata_handler
  subroutine endCdata_handler()
    cdata = .false.
  end subroutine endCdata_handler

  subroutine internalEntityDecl_handler(name, value)
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: value

    type(Node), pointer :: np
    
    if (name(1:1)=="%") return
    ! Do nothing with parameter entities

    ! We only note that these exist here.
    ! A second parsing stage is triggered at the end
    ! of the DTD, in order to resolve entity references (which
    ! need not be declared in order)

    np => createEntity(mainDoc, name, "", "", "")
    call setStringValue(np, value)
    np => setNamedItem(getEntities(getDocType(mainDoc)), np)

  end subroutine internalEntityDecl_handler

  subroutine normalErrorHandler(msg)
    character(len=*), intent(in) :: msg
    ! This is called if the main parsing routine fails
    error => vs_str_alloc(msg)
  end subroutine normalErrorHandler

  subroutine entityErrorHandler(msg)
    character(len=*), intent(in) :: msg

    !This gets called if parsing of an entity failed. If so,
    !then we need to destroy all nodes which were being generated as
    !children of this entity, then mark the entity as ill-formed - but
    !otherwise carry on parsing the document, and only throw an error
    !if a reference is made to it.

    call destroyAllNodesRecursively(current, except=.true.)
    call setIllFormed(current, .true.)
  end subroutine entityErrorHandler

  subroutine externalEntityDecl_handler(name, publicId, systemId)
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: publicId
    character(len=*), intent(in) :: systemId
    type(Node), pointer :: np

    if (name(1:1)=="%") return
    ! Do nothing with parameter entities

    np => createEntity(mainDoc, name, &
      publicId=publicId, systemId=systemId, notationName="")
    np => setNamedItem(getEntities(getDocType(mainDoc)), np)

  end subroutine externalEntityDecl_handler

  subroutine unparsedEntityDecl_handler(name, publicId, systemId, notationName)
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: publicId
    character(len=*), intent(in) :: systemId
    character(len=*), intent(in) :: notationName
    type(Node), pointer :: np

    np => getNamedItem(getEntities(getDocType(mainDoc)), name)
    if (.not.associated(np)) then
      np => createEntity(mainDoc, name, publicId=publicId, systemId=systemId, notationName=notationName)
      np => setNamedItem(getEntities(getDocType(mainDoc)), np)
    endif

  end subroutine unparsedEntityDecl_handler

  subroutine startEntity_handler(name)
    character(len=*), intent(in) :: name

    if (name(1:1)=="%") return
    ! Do nothing with parameter entities

    if (getParameter(domConfig, "entities")) then
      if (.not.associated(inEntity)) then
        inEntity => vs_str_alloc(name)
      endif
      current => appendChild(current, createEmptyEntityReference(mainDoc, name))
    endif
  end subroutine startEntity_handler

  subroutine endEntity_handler(name)
    character(len=*), intent(in) :: name

    if (name(1:1)=="%") return
    ! Do nothing with parameter entities
    
    if (getParameter(domConfig, "entities")) then
      call setReadOnlyNode(current, .true., .false.)
      if (str_vs(inEntity)==name) deallocate(inEntity)
      current => getParentNode(current)
    endif

  end subroutine endEntity_handler

  subroutine skippedEntity_handler(name)
    character(len=*), intent(in) :: name
    
    type(Node), pointer :: temp

    if (name(1:1)=="%") return
    ! Do nothing with parameter entities

    temp => appendChild(current, createEntityReference(mainDoc, name))
    if (associated(inEntity)) call setReadonlyNode(temp, .true., .false.)
  end subroutine skippedEntity_handler


  subroutine runParser(fxml, configuration, ex)
    type(DOMException), intent(out), optional :: ex
    type(xml_t), intent(inout) :: fxml
    type(DOMConfiguration), pointer, optional :: configuration

    allocate(DOMConfig)
    if (present(configuration)) call copyDOMConfig(DOMConfig, configuration)

! We use internal sax_parse rather than public interface in order
! to use internal callbacks to get extra info.
    call sax_parse(fx=fxml%fx, fb=fxml%fb,&
      characters_handler=characters_handler,            &
      endDocument_handler=endDocument_handler,           &
      endElement_handler=endElement_handler,            &
      !endPrefixMapping_handler,      &
      ignorableWhitespace_handler=ignorableWhitespace_handler,   &
      processingInstruction_handler=processingInstruction_handler, &
      ! setDocumentLocator
      skippedEntity_handler=skippedEntity_handler,         &
      startDocument_handler=startDocument_handler,         & 
      startElement_handler=startElement_handler,          &
      !startPrefixMapping_handler,    &
      notationDecl_handler=notationDecl_handler,          &
      unparsedEntityDecl_handler=unparsedEntityDecl_handler, &
      !error_handler,            &
      fatalError_handler=normalErrorHandler,                 &
      !warning_handler,               &
      !attributeDecl_handler,         &
      !elementDecl_handler,           &
      externalEntityDecl_handler=externalEntityDecl_handler, &
      internalEntityDecl_handler=internalEntityDecl_handler,    &
      comment_handler=comment_handler,              &
      endCdata_handler=endCdata_handler,             &
      endDTD_handler=endDTD_handler,                &
      endEntity_handler=endEntity_handler,             &
      startCdata_handler=startCdata_handler,    &
      startDTD_handler=startDTD_handler,          &
      startEntity_handler=startEntity_handler, &
      FoX_endDTD_handler=FoX_endDTD_handler, &
      namespaces = getParameter(domConfig, "namespaces"),     &
      namespace_prefixes = .true., &
      validate = getParameter(domConfig, "validate"), & ! FIXME what about validate-if-present ...
      xmlns_uris = .true.)

    call close_xml_t(fxml)

    if (associated(error)) then
      if (associated(inEntity)) deallocate(inEntity)
      ! FIXME pass the value of the error through
      ! when we let exceptions do that
      deallocate(error)
      call destroy(mainDoc)
      if (getFoX_checks().or.PARSE_ERR<200) then
  call throw_exception(PARSE_ERR, "runParser", ex)
  if (present(ex)) then
    if (inException(ex)) then
       return
    endif
  endif
endif

    endif

  end subroutine runParser


  function parsefile(filename, configuration, iostat, ex) 
    type(DOMException), intent(out), optional :: ex
    character(len=*), intent(in) :: filename
    type(DOMConfiguration), pointer, optional :: configuration
    integer, intent(out), optional :: iostat
    type(Node), pointer :: parsefile

    type(DOMException) :: ex_
    integer :: iostat_

    call open_xml_file(fxml, filename, iostat_)
    if (present(iostat)) then
      iostat = iostat_
      if (iostat/=0) return
    elseif (iostat_/=0) then
      call FoX_error("Cannot open file")
    endif

    if (present(ex)) then
      call runParser(fxml, configuration, ex)
    elseif (present(iostat)) then
      call runParser(fxml, configuration, ex_)
    else
      call runParser(fxml, configuration)
    endif

    if (present(iostat).and.inException(ex_)) then
      iostat = getExceptionCode(ex_)
    endif

    parsefile => mainDoc
    mainDoc => null()

  end function parsefile


  function parsestring(string, configuration, ex) 
    type(DOMException), intent(out), optional :: ex
    character(len=*), intent(in) :: string
    type(DOMConfiguration), pointer, optional :: configuration
    type(Node), pointer :: parsestring

    call open_xml_string(fxml, string)

    call runParser(fxml, configuration, ex)

    parsestring => mainDoc
    mainDoc => null()
    
  end function parsestring

end module m_dom_parse

module m_common_format

!Note that there are several oddities to this package,
!to get round assorted compiler bugs.

!All the _matrix_ subroutines should be straight
!call-throughs to the relevant _array_ subroutine,
!but with flattened arrays. (this would allow easy
!generation of all functions up to 7 dimensions)
!but unfortunately that breaks PGI-6.1, and causes
!errors on Pathscale-2.4.

!The Logical array/matrix functions should be able
!to COUNT their length inline in the specification
!expression, but Pathscale-2.4 gives an error on that.

  use m_common_realtypes, only: sp, dp
  use m_common_error, only: FoX_error
!  use pxf, only: pure_pxfabort

  implicit none
  private

  integer, parameter :: sig_sp = digits(1.0_sp)/4
  integer, parameter :: sig_dp = digits(1.0_dp)/4 ! Approximate precision worth outputting of each type.

  character(len=*), parameter :: digit = "0123456789:"
  character(len=*), parameter :: hexdigit = "0123456789abcdefABCDEF"

  interface str
! This is for external use only: str should not be called within this
! file.
! All *_chk subroutines check that the fmt they are passed is valid.
    module procedure str_string, str_string_array, str_string_matrix, &
                     str_integer, str_integer_array, str_integer_matrix, &
                     str_integer_fmt, str_integer_array_fmt, str_integer_matrix_fmt, &
                     str_logical, str_logical_array, str_logical_matrix, &
                     str_real_sp, str_real_sp_fmt_chk, &
                     str_real_sp_array, str_real_sp_array_fmt_chk, &
                     str_real_sp_matrix, str_real_sp_matrix_fmt_chk, &
                     str_real_dp, str_real_dp_fmt_chk, &
                     str_real_dp_array, str_real_dp_array_fmt_chk, &
                     str_real_dp_matrix, str_real_dp_matrix_fmt_chk, &
                     str_complex_sp, str_complex_sp_fmt_chk, &
                     str_complex_sp_array, str_complex_sp_array_fmt_chk, &
                     str_complex_sp_matrix, str_complex_sp_matrix_fmt_chk, &
                     str_complex_dp, str_complex_dp_fmt_chk, &
                     str_complex_dp_array, str_complex_dp_array_fmt_chk, &
                     str_complex_dp_matrix, str_complex_dp_matrix_fmt_chk
  end interface str

  interface safestr
! This is for internal use only - no check is made on the validity of 
! any fmt input.
    module procedure str_string, str_string_array, str_string_matrix, &
                     str_integer, str_integer_array, str_integer_matrix, &
                     str_logical, str_logical_array, str_logical_matrix, &
                     str_real_sp, str_real_sp_fmt, &
                     str_real_sp_array, str_real_sp_array_fmt, &
                     str_real_sp_matrix, str_real_sp_matrix_fmt, &
                     str_real_dp, str_real_dp_fmt, &
                     str_real_dp_array, str_real_dp_array_fmt, &
                     str_real_dp_matrix, str_real_dp_matrix_fmt, &
                     str_complex_sp, str_complex_sp_fmt, &
                     str_complex_sp_array, str_complex_sp_array_fmt, &
                     str_complex_sp_matrix, str_complex_sp_matrix_fmt, &
                     str_complex_dp, str_complex_dp_fmt, &
                     str_complex_dp_array, str_complex_dp_array_fmt, &
                     str_complex_dp_matrix, str_complex_dp_matrix_fmt
  end interface safestr

  interface len
    module procedure str_integer_len, str_integer_array_len, str_integer_matrix_len, &
                     str_integer_fmt_len, str_integer_array_fmt_len, str_integer_matrix_fmt_len, &
                     str_logical_len, str_logical_array_len, str_logical_matrix_len, &
                     str_real_sp_len, str_real_sp_fmt_len, &
                     str_real_sp_array_len, str_real_sp_array_fmt_len, &
                     str_real_sp_matrix_len, str_real_sp_matrix_fmt_len, &
                     str_real_dp_len, str_real_dp_fmt_len, &
                     str_real_dp_array_len, str_real_dp_array_fmt_len, &
                     str_real_dp_matrix_len, str_real_dp_matrix_fmt_len, &
                     str_complex_sp_len, str_complex_sp_fmt_len, &
                     str_complex_sp_array_len, str_complex_sp_array_fmt_len, &
                     str_complex_sp_matrix_len, str_complex_sp_matrix_fmt_len, &
                     str_complex_dp_len, str_complex_dp_fmt_len, &
                     str_complex_dp_array_len, str_complex_dp_array_fmt_len, &
                     str_complex_dp_matrix_len, str_complex_dp_matrix_fmt_len
  end interface

  interface operator(//)
    module procedure concat_str_int, concat_int_str, &
      concat_str_logical, concat_logical_str, &
      concat_real_sp_str, concat_str_real_sp, &
      concat_real_dp_str, concat_str_real_dp, &
      concat_complex_sp_str, concat_str_complex_sp, &
      concat_complex_dp_str, concat_str_complex_dp
  end interface

  public :: str
  public :: operator(//)

  public :: str_to_int_10
  public :: str_to_int_16

contains

  pure function str_to_int_10(str) result(n)
    ! Takes a string containing digits, and returns
    ! the integer representable by those digits.
    ! Does not deal with negative numbers, and
    ! presumes that the number is representable
    ! in a default integer
    ! Error is flagged by returning -1
    character(len=*), intent(in) :: str
    integer :: n

    integer :: max_power, i, j

    if (verify(str, digit) > 0) then
      n = -1
      return
    endif

    max_power = len(str) - 1

    n = 0
    do i = 0, max_power
      j = max_power - i + 1
      n = n + (index(digit, str(j:j)) - 1) * 10**i
    enddo

  end function str_to_int_10

  pure function str_to_int_16(str) result(n)
    ! Takes a string containing hexadecimal digits, and returns
    ! the integer representable by those digits.
    ! Does not deal with negative numbers, and
    ! presumes that the number is representable
    ! in a default integer
    ! Error is flagged by returning -1
    character(len=*), intent(in) :: str
    integer :: n
    
    character(len=len(str)) :: str_l
    integer :: max_power, i, j

    if (verify(str, hexdigit) == 0) then
       str_l = to_lower(str)
    else
      n = -1
      return
    endif

    max_power = len(str) - 1

    n = 0
    do i = 0, max_power
      j = max_power - i + 1
      n = n + (index(hexdigit, str_l(j:j)) - 1) * 16**i
    enddo

  contains
    pure function to_lower(s) result(s2)
      character(len=*), intent(in) :: s
      character(len=len(s)) :: s2
      character(len=*), parameter :: hex = "abcdef"
      integer :: j, k
      do j = 1, len(s)
        k = index('ABCDEF', s(j:j))
        if (k > 0) then
          s2(j:j) = hex(k:k)
        else
          s2(j:j) = s(j:j)
        endif
      enddo
    end function to_lower
         
  end function str_to_int_16


  pure function str_string(st) result(s)
    character(len=*), intent(in) :: st
    character(len=len(st)) :: s

    s = st
  end function str_string


  pure function str_string_array_len(st) result(n)
    character(len=*), dimension(:), intent(in) :: st
    integer :: n

    integer :: k

    n = size(st) - 1
    do k = 1, size(st)
      n = n + len(st(k))
    enddo

  end function str_string_array_len


  pure function str_string_array(st, delimiter) result(s)
    character(len=*), dimension(:), intent(in) :: st
    character(len=1), intent(in), optional :: delimiter
    character(len=str_string_array_len(st)) :: s
    
    integer :: k, n
    character(len=1) :: d
    
    if (present(delimiter)) then
      d = delimiter
    else
      d = " "
    endif

    n = 1
    do k = 1, size(st) - 1
      s(n:n+len(st(k))) = st(k)//d
      n = n + len(st(k)) + 1
    enddo
    s(n:) = st(k)

  end function str_string_array


  pure function str_string_matrix_len(st) result(n)
    character(len=*), dimension(:, :), intent(in) :: st
    integer :: n

    n = len(st) * size(st) + size(st) - 1
  end function str_string_matrix_len

  pure function str_string_matrix(st, delimiter) result(s)
    character(len=*), dimension(:, :), intent(in) :: st
    character(len=1), intent(in), optional :: delimiter
    character(len=str_string_matrix_len(st)) :: s
    
    integer :: j, k, n
    character(len=1) :: d

    if (present(delimiter)) then
      d = delimiter
    else
      d = " "
    endif

    s(1:len(st)) = st(1,1)
    n = len(st) + 1
    do j = 2, size(st, 1)
      s(n:n+len(st)) = d//st(j,1)
        n = n + len(st) + 1
    enddo
    do k = 2, size(st, 2)
      do j = 1, size(st, 1)
        s(n:n+len(st(j,k))) = d//st(j,k)
        n = n + len(st) + 1
      enddo
    enddo

  end function str_string_matrix


  pure function str_integer_len(i) result(n)
    integer, intent(in) :: i
    integer :: n
    
    n = int(log10(real(max(abs(i),1)))) + 1 + dim(-i,0)/max(abs(i),1)

  end function str_integer_len

  pure function str_integer_base_len(i, b) result(n)
    integer, intent(in) :: i, b
    integer :: n
    
    n = int(log10(real(max(abs(i),1)))/log10(real(b))) &
      + 1 + dim(-i,0)/max(abs(i),1)

  end function str_integer_base_len


  pure function str_integer_fmt_len(i, fmt) result(n)
    integer, intent(in) :: i
    character(len=*), intent(in) :: fmt
    integer :: n
    
    select case (len(fmt))
    case(0)
      n = 0
    case(1)
      if (fmt=="x") then
        n = int(log10(real(max(abs(i),1)))/log10(16.0)) + 1 + dim(-i,0)/max(abs(i),1)
      elseif (fmt=="d") then
        n = int(log10(real(max(abs(i),1)))) + 1 + dim(-i,0)/max(abs(i),1)
      else
        return
      endif
    case default
      if (fmt(1:1)/='x'.and.fmt(1:1)/='d') then
        n = 0
      elseif (verify(fmt(2:), digit)==0) then
        n = str_to_int_10(fmt(2:))
      else
        n = 0 
      endif
    end select

  end function str_integer_fmt_len


  pure function str_integer(i) result(s)
    integer, intent(in) :: i
    character(len=str_integer_len(i)) :: s

    integer :: b, ii, j, k, n

    b = 10

    if (i < 0) then
      s(1:1) = "-"
      n = 2
    else
      n = 1
    endif
    ii = abs(i)
    do k = len(s) - n, 0, -1
      j = ii/(b**k)
      ii = ii - j*(b**k)
      s(n:n) = digit(j+1:j+1)
      n = n + 1
    enddo

  end function str_integer


  pure function str_integer_fmt(i, fmt) result(s)
    integer, intent(in) :: i
    character(len=*), intent(in):: fmt
    character(len=str_integer_fmt_len(i, fmt)) :: s

    character :: f
    integer :: b, ii, j, k, n, ls
 
    if (len(fmt)>0) then
      if (fmt(1:1)=="d") then
        f = 'd'
        b = 10
      elseif (fmt(1:1)=="x") then
        f = 'x'
        b = 16
      else
        ! Undefined outcome
        s = ""
        return
      endif
    else
      ! Undefined outcome
      s = ""
      return
    endif

    ls = str_integer_base_len(i, b)
    n = len(s) - ls + 1

    if (i < 0) then
      if (n>0) s(:n) = "-"//repeat("0", n-1)
      n = n + 1
    else
      if (n>1) s(:n) = repeat("0", n)
    endif

    ii = abs(i)
    do k = 1, -n + 1
      j = ii/(b**k)
      ii = ii - j*(b**k)
      n = n + 1
    enddo
    do k = len(s) - n, 0, -1
      j = ii/(b**k)
      ii = ii - j*(b**k)
      s(n:n) = hexdigit(j+1:j+1)
      n = n + 1
    enddo

  end function str_integer_fmt


  pure function str_integer_array_len(ia) result(n)
    integer, dimension(:), intent(in) :: ia
    integer :: n
    
    integer :: j

    n = size(ia) - 1

    do j = 1, size(ia)
      n = n + len(str(ia(j)))
    enddo

  end function str_integer_array_len


  pure function str_integer_array_fmt_len(ia, fmt) result(n)
    integer, dimension(:), intent(in) :: ia
    character, intent(in) :: fmt
    integer :: n
    
    integer :: j

    n = size(ia) - 1

    do j = 1, size(ia)
      n = n + len(ia(j), fmt)
    enddo

  end function str_integer_array_fmt_len


  pure function str_integer_array(ia) result(s)
    integer, dimension(:), intent(in) :: ia
    character(len=len(ia, "d")) :: s

    integer :: j, k, n

    n = 1
    do k = 1, size(ia) - 1
      j = len(ia(k))
      s(n:n+j) = str(ia(k))//" "
      n = n + j + 1
    enddo
    s(n:) = str(ia(k))

  end function str_integer_array


  pure function str_integer_array_fmt(ia, fmt) result(s)
    integer, dimension(:), intent(in) :: ia
    character, intent(in) :: fmt
    character(len=len(ia, fmt)) :: s

    integer :: j, k, n

    n = 1
    do k = 1, size(ia) - 1
      j = len(ia(k), fmt)
      s(n:n+j) = str(ia(k), fmt)//" "
      n = n + j + 1
    enddo
    s(n:) = str(ia(k), fmt)

  end function str_integer_array_fmt

 
  pure function str_integer_matrix_len(ia) result(n)
    integer, dimension(:,:), intent(in) :: ia
    integer :: n

    integer :: j, k

    n = size(ia) - 1

    do k = 1, size(ia, 2)
      do j = 1, size(ia, 1)
        n = n + len(ia(j, k))
      enddo
    enddo

  end function str_integer_matrix_len


  pure function str_integer_matrix_fmt_len(ia, fmt) result(n)
    integer, dimension(:,:), intent(in) :: ia
    character, intent(in) :: fmt
    integer :: n

    integer :: j, k

    n = size(ia) - 1

    do k = 1, size(ia, 2)
      do j = 1, size(ia, 1)
        n = n + len(ia(j, k), fmt)
      enddo
    enddo

   end function str_integer_matrix_fmt_len

  pure function str_integer_matrix(ia) result(s)
    integer, dimension(:,:), intent(in) :: ia
    character(len=len(ia, "d")) :: s

    integer :: j, k, n

    s(:len(ia(1,1))) = str(ia(1,1))
    n = len(ia(1,1)) + 1
    do j = 2, size(ia, 1)
      s(n:n+len(ia(j,1))) = " "//str(ia(j,1))
      n = n + len(ia(j,1)) + 1
    enddo
    do k = 2, size(ia, 2) 
      do j = 1, size(ia, 1)
        s(n:n+len(ia(j,k))) = " "//str(ia(j,k))
        n = n + len(ia(j,k)) + 1
      enddo
    enddo

  end function str_integer_matrix


  pure function str_integer_matrix_fmt(ia, fmt) result(s)
    integer, dimension(:,:), intent(in) :: ia
    character, intent(in) :: fmt
    character(len=len(ia, fmt)) :: s

    integer :: j, k, n

    s(:len(ia(1,1), fmt)) = str(ia(1,1), fmt)
    n = len(ia(1,1), fmt) + 1
    do j = 2, size(ia, 1)
      s(n:n+len(ia(j,1), fmt)) = " "//str(ia(j,1), fmt)
      n = n + len(ia(j,1), fmt) + 1
    enddo
    do k = 2, size(ia, 2) 
      do j = 1, size(ia, 1)
        s(n:n+len(ia(j,k), fmt)) = " "//str(ia(j,k), fmt)
        n = n + len(ia(j,k), fmt) + 1
      enddo
    enddo

  end function str_integer_matrix_fmt

  pure function str_logical_len(l) result (n)
    logical, intent(in) :: l
    integer :: n
    
    if (l) then
      n = 4
    else
      n = 5
    endif
  end function str_logical_len
  
  pure function str_logical(l) result(s)
    logical, intent(in) :: l
    character(len=merge(4,5,l)) :: s
    
    if (l) then
      s="true"
    else
      s="false"
    endif
  end function str_logical


  pure function str_logical_array_len(la) result(n)
! This function should be inlined in the declarations of
! str_logical_array below but PGI and pathscale don't like it.
    logical, dimension(:), intent(in)   :: la
    integer :: n
    n = 5*size(la) - 1 + count(.not.la)
  end function str_logical_array_len
  

  pure function str_logical_array(la, delimiter) result(s)
    logical, dimension(:), intent(in)   :: la
    character(len=1), optional, intent(in) :: delimiter
    character(len=len(la)) :: s
    
    integer :: k, n
    character(len=1) :: d
    if (present(delimiter)) then
      d = delimiter
    else
      d = " "
    endif

    n = 1
    do k = 1, size(la) - 1
      if (la(k)) then
        s(n:n+3) = "true"
        n = n + 5
      else
        s(n:n+4) = "false"
        n = n + 6
      endif
      s(n-1:n-1) = d
    enddo
    if (la(k)) then
      s(n:) = "true"
    else
      s(n:) = "false"
    endif

  end function str_logical_array


  pure function str_logical_matrix_len(la) result(n)
! This function should be inlined in the declarations of
! str_logical_matrix below but PGI and pathscale don't like it.
    logical, dimension(:,:), intent(in)   :: la
    integer :: n
    n = 5*size(la) - 1 + count(.not.la)
  end function str_logical_matrix_len


  pure function str_logical_matrix(la, delimiter) result(s)
    logical, dimension(:,:), intent(in)   :: la
    character(len=1), optional, intent(in) :: delimiter
    character(len=len(la)) :: s

    integer :: j, k, n
    character(len=1) :: d

    if (present(delimiter)) then
      d = delimiter
    else
      d = " "
    endif

    if (la(1,1)) then
       s(:4) = "true"
       n = 5
    else
       s(:5) = "false"
       n = 6
    endif
    do j = 2, size(la, 1)
      s(n:n) = d
      if (la(j,1)) then
        s(n+1:n+4) = "true"
        n = n + 5
      else
        s(n+1:n+5) = "false"
        n = n + 6
      endif
    enddo
    do k = 2, size(la, 2)
      do j = 1, size(la, 1)
        s(n:n) = d
        if (la(j,k)) then
          s(n+1:n+4) = "true"
          n = n + 5
        else
          s(n+1:n+5) = "false"
          n = n + 6
        endif
      enddo
    enddo

  end function str_logical_matrix
  

  ! In order to convert real numbers to strings, we need to
  ! perform an internal write - but how long will the 
  ! resultant string be? We don't know & there is no way
  ! to discover for an arbitrary format. Therefore, 
  ! (if we have the capability; f95 or better)
  ! we assume it will be less than 100 characters, write
  ! it to a string of that length, then remove leading &
  ! trailing whitespace. (this means that if the specified
  ! format includes whitespace, this will be lost.)
  !
  ! If we are working with an F90-only compiler, then
  ! we cannot do this trick - the output string will
  ! always be 100 chars in length, though we will remove
  ! leading whitespace. 


  ! The standard Fortran format functions do not give us
  ! enough control, so we write our own real number formatting
  ! routines here. For each real type, we optionally take a
  ! format like so:
  ! "r<integer>" which will produce output without an exponent,
  ! and <integer> digits after the decimal point.
  ! or
  ! "s<integer>": which implies scientific notation, with an 
  ! exponent, with <integer> significant figures.
  ! If the integer is absent, then the precision will be
  ! half of the number of significant figures available
  ! for that real type.
  ! The absence of a format implies scientific notation, with
  ! the default precision.

  ! These routines are fairly imperfect - they are inaccurate for
  ! the lower-end bits of the number, since they work by simple
  ! multiplications by 10.
  ! Also they will probably be orders of magnitude slower than library IO.
  ! Ideally they'd be rewritten to convert from teh native format by
  ! bit-twidding. Not sure how to do that portably though.

  ! The format specification could be done more nicely - but unfortunately
  ! not in F95 due to *stupid* restrictions on specification expressions.

  ! And I wouldn't have to invent my own format specification if Fortran
  ! had a proper IO library anyway.

!FIXME Signed zero is not handled correctly; don't quite understand why.
!FIXME too much duplication between sp & dp, we should m4.

  pure function real_sp_str(x, sig) result(s)
    real(sp), intent(in) :: x
    integer, intent(in) :: sig
    character(len=sig) :: s
    ! make a string of numbers sig long of x.
    integer :: e, i, j, k, n
    real(sp) :: x_

    if (sig < 1) then
      s ="" 
      return
    endif

    if (x == 0.0_sp) then
      e = 1
    else
      e = floor(log10(abs(x)))
    endif
    x_ = abs(x)
    ! Have to do this next in a loop rather than just exponentiating in
    ! order to  avoid under/over-flow.
    do i = 1, abs(e)
      ! Have to multiply by 10^-e rather than divide by 10^e
      ! to avoid rounding errors.
      x_ = x_ * (10.0_sp**(-abs(e)/e))
    enddo
    n = 1
    do k = sig - 2, 0, -1
      ! This baroque way of taking int() ensures the optimizer 
      ! stores it in j without keeping a different value in cache.
      j = iachar(digit(int(x_)+1:int(x_)+1)) - 48
      if (j==10) then
        ! This can happen if, on the previous cycle, int(x_) in 
        ! the line above gave a result approx. 1.0 less than
        ! expected.
        ! In this case we want to quit the cycle & just get 999... to the end
        s(n:) = repeat("9", sig - n + 1)
        return
      endif
      s(n:n) = digit(j+1:j+1)
      n = n + 1
      x_ = (x_ - j) * 10.0_sp
    enddo
    j = nint(x_)
    if (j == 10) then
      ! Now round ...
      s(n:n) = "9"
      ! Are they all 9's?
      i = verify(s, "9", .true.)
      if (i == 0) then
        s(1:1) = "!"
        ! overflow
        return
      endif
      j = index(digit, s(i:i))
      s(i:i) = digit(j+1:j+1)
      s(i+1:) = repeat("0", sig - i + 1)
    else
      s(n:n) = digit(j+1:j+1)
    endif

  end function real_sp_str

  pure function str_real_sp_fmt_len(x, fmt) result(n)
    real(sp), intent(in) :: x
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: dec, sig
    integer :: e

    if (.not.checkFmt(fmt)) then
      n = 0
      return
    endif

    if (x == 0.0_sp) then
      e = 1
    else
      e = floor(log10(abs(x)))
    endif
      
    if (x < 0.0_sp) then
      n = 1
    else
      n = 0
    endif
      
    if (len(fmt) == 0) then
      sig = sig_sp

      n = n + sig + 2 + len(e) 
      ! for the decimal point and the e

    elseif (fmt(1:1) == "s") then
      if (len(fmt) > 1) then
        sig = str_to_int_10(fmt(2:))
      else
        sig = sig_sp
      endif
      sig = max(sig, 1)
      sig = min(sig, digits(1.0_sp))

      if (sig > 1) n = n + 1 
      ! for the decimal point
      
      n = n + sig + 1 + len(e)

    elseif (fmt(1:1) == "r") then

      if (len(fmt) > 1) then
        dec = str_to_int_10(fmt(2:))
      else
        dec = sig_sp - e - 1
      endif
      dec = min(dec, digits(1.0_sp)-e)
      dec = max(dec, 0)

      if (dec > 0) n = n + 1
      if (abs(x) >= 1.0_sp) n = n + 1

      ! Need to know if there's an overflow ....
      if (e+dec+1 > 0) then
        if (index(real_sp_str(abs(x), e+dec+1), "!") == 1) &
             e = e + 1
      endif

      n = n + abs(e) + dec

    endif

  end function str_real_sp_fmt_len

  function str_real_sp_fmt_chk(x, fmt) result(s)
    real(sp), intent(in) :: x
    character(len=*), intent(in) :: fmt
    character(len=len(x, fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(x, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif
  end function str_real_sp_fmt_chk

  pure function str_real_sp_fmt(x, fmt) result(s)
    real(sp), intent(in) :: x
    character(len=*), intent(in) :: fmt
    character(len=len(x, fmt)) :: s

    integer :: sig, dec
    integer :: e, n
    character(len=len(x, fmt)) :: num !this will always be enough memory.

    if (x == 0.0_sp) then
      e = 0
    else
      e = floor(log10(abs(x)))
    endif

    if (x < 0.0_sp) then
      s(1:1) = "-"
      n = 2
    else
      n = 1
    endif

    if (len(fmt) == 0) then

      sig = sig_sp

      num = real_sp_str(abs(x), sig)
      if (num(1:1) == "!") then
        e = e + 1
        num = "1"//repeat("0",len(num)-1)
      endif

      if (sig == 1) then
        s(n:n) = num
        n = n + 1
      else
        s(n:n+1) = num(1:1)//"."
        s(n+2:n+sig) = num(2:)
        n = n + sig + 1
      endif

      s(n:n) = "e"
      s(n+1:) = str(e)

    elseif (fmt(1:1) == "s") then

      if (len(fmt) > 1) then
        sig = str_to_int_10(fmt(2:))
      else
        sig = sig_sp
      endif
      sig = max(sig, 1)
      sig = min(sig, digits(1.0_sp))

      num = real_sp_str(abs(x), sig)
      if (num(1:1) == "!") then
        e = e + 1
        num = "1"//repeat("0",len(num)-1)
      endif

      if (sig == 1) then
        s(n:n) = num
        n = n + 1
      else
        s(n:n+1) = num(1:1)//"."
        s(n+2:n+sig) = num(2:)
        n = n + sig + 1
      endif

      s(n:n) = "e"
      s(n+1:) = str(e)

    elseif (fmt(1:1) == "r") then

      if (len(fmt) > 1) then
        dec = str_to_int_10(fmt(2:))
      else
        dec = sig_sp - e - 1
      endif
      dec = min(dec, digits(1.0_sp)-e-1)
      dec = max(dec, 0)

      if (e+dec+1 > 0) then
        num = real_sp_str(abs(x), e+dec+1)
      else
        num = ""
      endif
      if (num(1:1) == "!") then
        e = e + 1
        num = "1"//repeat("0",len(num)-1)
      endif

      if (abs(x) >= 1.0_sp) then
        s(n:n+e) = num(:e+1)
        n = n + e + 1
        if (dec > 0) then
          s(n:n) = "."
          n = n + 1
          s(n:) = num(e+2:)
        endif
      else
        s(n:n) = "0"
        if (dec > 0) then
          s(n+1:n+1) = "."
          n = n + 2
          if (dec < -e-1) then
            s(n:) = repeat("0", dec)
          else
            s(n:n-e-2) = repeat("0", max(-e-1,0))
            n = n - min(e,-1) - 1
            if (n <= len(s)) then
              s(n:) = num
            endif
          endif
        endif
      endif

    endif

  end function str_real_sp_fmt


  pure function str_real_sp_len(x) result(n)
    real(sp), intent(in) :: x
    integer :: n

    n = len(x, "")

  end function str_real_sp_len


  pure function str_real_sp(x) result(s)
    real(sp), intent(in) :: x
    character(len=len(x)) :: s

    s = safestr(x, "")

  end function str_real_sp

     
  pure function str_real_sp_array_len(xa) result(n)
    real(sp), dimension(:), intent(in) :: xa
    integer :: n

    integer :: k

    n = size(xa) - 1
    do k = 1, size(xa)
      n = n + len(xa(k), "")
    enddo

  end function str_real_sp_array_len

  pure function str_real_sp_array(xa) result(s)
    real(sp), dimension(:), intent(in) :: xa
    character(len=len(xa)) :: s
    
    integer :: j, k, n

    n = 1
    do k = 1, size(xa) - 1
      j = len(xa(k), "")
      s(n:n+j) = safestr(xa(k), "")//" "
      n = n + j + 1
    enddo
    s(n:) = safestr(xa(k), "")

  end function str_real_sp_array
 
  pure function str_real_sp_array_fmt_len(xa, fmt) result(n)
    real(sp), dimension(:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: k

    n = size(xa) - 1
    do k = 1, size(xa)
      n = n + len(xa(k), fmt)
    enddo
    
  end function str_real_sp_array_fmt_len
     
  pure function str_real_sp_array_fmt(xa, fmt, delimiter) result(s)
    real(sp), dimension(:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    character(len=1), intent(in), optional :: delimiter
    character(len=len(xa, fmt)) :: s
    
    integer :: j, k, n
    character(len=1) :: d

    if (present(delimiter)) then
      d = delimiter
    else
      d = " "
    endif

    n = 1
    do k = 1, size(xa) - 1
      j = len(xa(k), fmt)
      s(n:n+j) = safestr(xa(k), fmt)//d
      n = n + j + 1
    enddo
    s(n:) = safestr(xa(k), fmt)

  end function str_real_sp_array_fmt

  function str_real_sp_array_fmt_chk(xa, fmt, delimiter) result(s)
    real(sp), dimension(:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    character(len=1), intent(in), optional :: delimiter
    character(len=len(xa, fmt)) :: s
    
    if (checkFmt(fmt)) then
      s = safestr(xa, fmt, delimiter)
    else
      call FoX_error("Invalid format: "//fmt)
    endif
  end function str_real_sp_array_fmt_chk


  pure function str_real_sp_matrix_fmt_len(xa, fmt) result(n)
    real(sp), dimension(:,:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: j, k

    n = size(xa) - 1
    do k = 1, size(xa, 2)
      do j = 1, size(xa, 1)
        n = n + len(xa(j,k), fmt)
      enddo
    enddo

  end function str_real_sp_matrix_fmt_len

  pure function str_real_sp_matrix_len(xa) result(n)
    real(sp), dimension(:,:), intent(in) :: xa
    integer :: n

    n = len(xa, "")
  end function str_real_sp_matrix_len

  pure function str_real_sp_matrix_fmt(xa, fmt) result(s)
    real(sp), dimension(:,:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    character(len=len(xa,fmt)) :: s

    integer :: i, j, k, n

    i = len(xa(1,1), fmt)
    s(:i) = safestr(xa(1,1), fmt)
    n = i + 1
    do j = 2, size(xa, 1)
      i = len(xa(j,1), fmt)
      s(n:n+i) = " "//safestr(xa(j,1), fmt)
      n = n + i + 1
    enddo
    do k = 2, size(xa, 2)
      do j = 1, size(xa, 1)
        i = len(xa(j,k), fmt)
        s(n:n+i) = " "//safestr(xa(j,k), fmt)
        n = n + i + 1
      enddo
    enddo

  end function str_real_sp_matrix_fmt

  function str_real_sp_matrix_fmt_chk(xa, fmt) result(s)
    real(sp), dimension(:,:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    character(len=len(xa,fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(xa, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    end if

  end function str_real_sp_matrix_fmt_chk

  pure function str_real_sp_matrix(xa) result(s)
    real(sp), dimension(:,:), intent(in) :: xa
    character(len=len(xa)) :: s

    s = safestr(xa, "")
  end function str_real_sp_matrix
    

  pure function real_dp_str(x, sig) result(s)
    real(dp), intent(in) :: x
    integer, intent(in) :: sig
    character(len=sig) :: s
    ! make a string of numbers sig long of x.
    integer :: e, i, j, k, n
    real(dp) :: x_

    if (sig < 1) then
      s ="" 
      return
    endif

    if (x == 0.0_dp) then
      e = 1
    else
      e = floor(log10(abs(x)))
    endif
    x_ = abs(x)
    ! Have to do this next in a loop rather than just exponentiating in
    ! order to  avoid under/over-flow.
    do i = 1, abs(e)
      ! Have to multiply by 10^-e rather than divide by 10^e
      ! to avoid rounding errors.
      x_ = x_ * (10.0_dp**(-abs(e)/e))
    enddo
    n = 1
    do k = sig - 2, 0, -1
      ! This baroque way of taking int() ensures the optimizer definitely
      ! stores it in j without keeping a different value in cache.
      j = iachar(digit(int(x_)+1:int(x_)+1)) - 48
      if (j==10) then
        ! This can happen if, on the previous cycle, int(x_) in 
        ! the line above gave a result almost exactly 1.0 less than
        ! expected - but FP arithmetic is not consistent.
        ! In this case we want to quit the cycle & just get 999... to the end
        s(n:) = repeat("9", sig - n + 1)
        return
      endif
      s(n:n) = digit(j+1:j+1)
      n = n + 1
      x_ = (x_ - j) * 10.0_dp
    enddo
    j = nint(x_)
    if (j == 10) then
      ! Now round ...
      s(n:n) = "9"
      i = verify(s, "9", .true.)
      if (i == 0) then
        s(1:1) = "!"
        !overflow
        return
      endif
      j = index(digit, s(i:i))
      s(i:i) = digit(j+1:j+1)
      s(i+1:) = repeat("0", sig - i + 1)
    else
      s(n:n) = digit(j+1:j+1)
    endif

  end function real_dp_str


  pure function str_real_dp_fmt_len(x, fmt) result(n)
    real(dp), intent(in) :: x
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: dec, sig
    integer :: e

    if (.not.checkFmt(fmt)) then
      n = 0
      return
    endif

    if (x == 0.0_dp) then
      e = 1
    else
      e = floor(log10(abs(x)))
    endif
      
    if (x < 0.0_dp) then
      n = 1
    else
      n = 0
    endif
      
    if (len(fmt) == 0) then
      sig = sig_dp

      n = n + sig + 2 + len(e) 
      ! for the decimal point and the e

    elseif (fmt(1:1) == "s") then
      if (len(fmt) > 1) then
        sig = str_to_int_10(fmt(2:))
      else
        sig = sig_dp
      endif
      sig = max(sig, 1)
      sig = min(sig, digits(1.0_dp))

      if (sig > 1) n = n + 1 
      ! for the decimal point
      
      n = n + sig + 1 + len(e)

    elseif (fmt(1:1) == "r") then

      if (len(fmt) > 1) then
        dec = str_to_int_10(fmt(2:))
      else
        dec = sig_dp - e - 1
      endif
      dec = min(dec, digits(1.0_dp)-e)
      dec = max(dec, 0)

      if (dec > 0) n = n + 1
      if (abs(x) >= 1.0_dp) n = n + 1

      ! Need to know if there's an overflow ....
      if (e+dec+1 > 0) then
        if (index(real_dp_str(abs(x), e+dec+1), "!") == 1) &
             e = e + 1
      endif

      n = n + abs(e) + dec

    endif

  end function str_real_dp_fmt_len

  function str_real_dp_fmt_chk(x, fmt) result(s)
    real(dp), intent(in) :: x
    character(len=*), intent(in) :: fmt
    character(len=len(x, fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(x, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif
  end function str_real_dp_fmt_chk
  
  pure function str_real_dp_fmt(x, fmt) result(s)
    real(dp), intent(in) :: x
    character(len=*), intent(in) :: fmt
    character(len=len(x, fmt)) :: s

    integer :: sig, dec
    integer :: e, n
    character(len=len(x, fmt)) :: num !this will always be enough memory.

    if (x == 0.0_dp) then
      e = 0
    else
      e = floor(log10(abs(x)))
    endif

    if (x < 0.0_dp) then
      s(1:1) = "-"
      n = 2
    else
      n = 1
    endif

    if (len(fmt) == 0) then

      sig = sig_dp

      num = real_dp_str(abs(x), sig)
      if (num(1:1) == "!") then
        e = e + 1
        num = "1"//repeat("0",len(num)-1)
      endif

      if (sig == 1) then
        s(n:n) = num
        n = n + 1
      else
        s(n:n+1) = num(1:1)//"."
        s(n+2:n+sig) = num(2:)
        n = n + sig + 1
      endif

      s(n:n) = "e"
      s(n+1:) = safestr(e)

    elseif (fmt(1:1) == "s") then

      if (len(fmt) > 1) then
        sig = str_to_int_10(fmt(2:))
      else
        sig = sig_dp
      endif
      sig = max(sig, 1)
      sig = min(sig, digits(1.0_dp))

      num = real_dp_str(abs(x), sig)
      if (num(1:1) == "!") then
        e = e + 1
        num = "1"//repeat("0",len(num)-1)
      endif

      if (sig == 1) then
        s(n:n) = num
        n = n + 1
      else
        s(n:n+1) = num(1:1)//"."
        s(n+2:n+sig) = num(2:)
        n = n + sig + 1
      endif

      s(n:n) = "e"
      s(n+1:) = safestr(e)

    elseif (fmt(1:1) == "r") then

      if (len(fmt) > 1) then
        dec = str_to_int_10(fmt(2:))
      else
        dec = sig_dp - e - 1
      endif
      dec = min(dec, digits(1.0_dp)-e-1)
      dec = max(dec, 0)

      if (e+dec+1 > 0) then
        num = real_dp_str(abs(x), e+dec+1)
      else
        num = ""
      endif
      if (num(1:1) == "!") then
        e = e + 1
        num = "1"//repeat("0",len(num)-1)
      endif

      if (abs(x) >= 1.0_dp) then
        s(n:n+e) = num(:e+1)
        n = n + e + 1
        if (dec > 0) then
          s(n:n) = "."
          n = n + 1
          s(n:) = num(e+2:)
        endif
      else
        s(n:n) = "0"
        if (dec > 0) then
          s(n+1:n+1) = "."
          n = n + 2
          if (dec < -e-1) then
            s(n:) = repeat("0", dec)
          else
            s(n:n-e-2) = repeat("0", max(-e-1,0))
            n = n - min(e,-1) - 1
            if (n <= len(s)) then
              s(n:) = num
            endif
          endif
        endif
      endif

    endif

  end function str_real_dp_fmt


  pure function str_real_dp_len(x) result(n)
    real(dp), intent(in) :: x
    integer :: n

    n = len(x, "")

  end function str_real_dp_len


  pure function str_real_dp(x) result(s)
    real(dp), intent(in) :: x
    character(len=len(x)) :: s

    s = safestr(x, "")
  end function str_real_dp

     
  pure function str_real_dp_array_len(xa) result(n)
    real(dp), dimension(:), intent(in) :: xa
    integer :: n

    integer :: k

    n = size(xa) - 1
    do k = 1, size(xa)
      n = n + len(xa(k), "")
    enddo
    
  end function str_real_dp_array_len
     

  pure function str_real_dp_array(xa) result(s)
    real(dp), dimension(:), intent(in) :: xa
    character(len=len(xa)) :: s
    
    integer :: j, k, n

    n = 1
    do k = 1, size(xa) - 1
      j = len(xa(k), "")
      s(n:n+j) = safestr(xa(k), "")//" "
      n = n + j + 1
    enddo
    s(n:) = safestr(xa(k))

  end function str_real_dp_array


  pure function str_real_dp_array_fmt_len(xa, fmt) result(n)
    real(dp), dimension(:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: k

    n = size(xa) - 1
    do k = 1, size(xa)
      n = n + len(xa(k), fmt)
    enddo
    
  end function str_real_dp_array_fmt_len

  pure function str_real_dp_array_fmt(xa, fmt, delimiter) result(s)
    real(dp), dimension(:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    character(len=1), intent(in), optional :: delimiter
    character(len=len(xa, fmt)) :: s
    
    integer :: j, k, n
    character(len=1) :: d

    if (present(delimiter)) then
      d = delimiter
    else
      d = " "
    endif

    n = 1
    do k = 1, size(xa) - 1
      j = len(xa(k), fmt)
      s(n:n+j) = safestr(xa(k), fmt)//d
      n = n + j + 1
    enddo
    s(n:) = safestr(xa(k), fmt)

  end function str_real_dp_array_fmt

  function str_real_dp_array_fmt_chk(xa, fmt, delimiter) result(s)
    real(dp), dimension(:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    character(len=1), intent(in), optional :: delimiter
    character(len=len(xa, fmt)) :: s
    
    if (checkFmt(fmt)) then
      s = safestr(xa, fmt, delimiter)
    else
      call FoX_error("Invalid format: "//fmt)
    endif
  end function str_real_dp_array_fmt_chk



  pure function str_real_dp_matrix_fmt_len(xa, fmt) result(n)
    real(dp), dimension(:,:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: j, k

    n = size(xa) - 1
    do k = 1, size(xa, 2)
      do j = 1, size(xa, 1)
        n = n + len(xa(j,k), fmt)
      enddo
    enddo

  end function str_real_dp_matrix_fmt_len


  pure function str_real_dp_matrix_len(xa) result(n)
    real(dp), dimension(:,:), intent(in) :: xa
    integer :: n

    n = len(xa, "")
  end function str_real_dp_matrix_len


  function str_real_dp_matrix_fmt(xa, fmt) result(s)
    real(dp), dimension(:,:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    character(len=len(xa,fmt)) :: s

    integer :: i, j, k, n

    i = len(xa(1,1), fmt)
    s(:i) = safestr(xa(1,1), fmt)
    n = i + 1
    do j = 2, size(xa, 1)
      i = len(xa(j,1), fmt)
      s(n:n+i) = " "//safestr(xa(j,1), fmt)
      n = n + i + 1
    enddo
    do k = 2, size(xa, 2)
      do j = 1, size(xa, 1)
        i = len(xa(j,k), fmt)
        s(n:n+i) = " "//safestr(xa(j,k), fmt)
        n = n + i + 1
      enddo
    enddo

  end function str_real_dp_matrix_fmt

  function str_real_dp_matrix_fmt_chk(xa, fmt) result(s)
    real(dp), dimension(:,:), intent(in) :: xa
    character(len=*), intent(in) :: fmt
    character(len=len(xa,fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(xa, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    end if

  end function str_real_dp_matrix_fmt_chk

  function str_real_dp_matrix(xa) result(s)
    real(dp), dimension(:,:), intent(in) :: xa
    character(len=len(xa)) :: s

    s = safestr(xa, "")
  end function str_real_dp_matrix


! For complex numbers, there's not really much prior art, so
! we use the easy solution: a+bi, where a & b are real numbers
! as output above.

  pure function str_complex_sp_fmt_len(c, fmt) result(n)
    complex(sp), intent(in) :: c
    character(len=*), intent(in) :: fmt
    integer :: n

    real(sp) :: re, im
    re = real(c)
    im = aimag(c)

    n = len(re, fmt) + len(im, fmt) + 6
  end function str_complex_sp_fmt_len

  function str_complex_sp_fmt_chk(c, fmt) result(s)
    complex(sp), intent(in) :: c
    character(len=*), intent(in) :: fmt
    character(len=len(c, fmt)) :: s
    
    if (checkFmt(fmt)) then
      s = safestr(c, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif

  end function str_complex_sp_fmt_chk

  pure function str_complex_sp_fmt(c, fmt) result(s)
    complex(sp), intent(in) :: c
    character(len=*), intent(in) :: fmt
    character(len=len(c, fmt)) :: s
    
    real(sp) :: re, im
    integer :: i
    re = real(c)
    im = aimag(c)
    i = len(re, fmt)
    s(:i+4) = "("//safestr(re, fmt)//")+i"
    s(i+5:)="("//safestr(im,fmt)//")"
  end function str_complex_sp_fmt

  pure function str_complex_sp_len(c) result(n)
    complex(sp), intent(in) :: c
    integer :: n

    n = len(c, "")
  end function str_complex_sp_len

  pure function str_complex_sp(c) result(s)
    complex(sp), intent(in) :: c
    character(len=len(c, "")) :: s

    s = safestr(c, "")
  end function str_complex_sp

  pure function str_complex_sp_array_fmt_len(ca, fmt) result(n)
    complex(sp), dimension(:), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: i

    n = size(ca) - 1
    do i = 1, size(ca)
      n = n + len(ca(i), fmt) 
    enddo
  end function str_complex_sp_array_fmt_len
     
  pure function str_complex_sp_array_fmt(ca, fmt) result(s)
    complex(sp), dimension(:), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    character(len=len(ca, fmt)) :: s

    integer :: i, n
 
    s(1:len(ca(1), fmt)) = safestr(ca(1), fmt)
    n = len(ca(1), fmt)+1
    do i = 2, size(ca) 
      s(n:n+len(ca(i), fmt)) = " "//safestr(ca(i), fmt)
      n = n + len(ca(i), fmt)+1
    enddo
  end function str_complex_sp_array_fmt

  function str_complex_sp_array_fmt_chk(ca, fmt) result(s)
    complex(sp), dimension(:), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    character(len=len(ca, fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(ca, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif

  end function str_complex_sp_array_fmt_chk

  pure function str_complex_sp_array_len(ca) result(n)
    complex(sp), dimension(:), intent(in) :: ca
    integer :: n

    n = len(ca, "")
  end function str_complex_sp_array_len
  
  pure function str_complex_sp_array(ca) result(s)
    complex(sp), dimension(:), intent(in) :: ca
    character(len=len(ca)) :: s

    s = safestr(ca, "")
  end function str_complex_sp_array


  pure function str_complex_sp_matrix_fmt_len(ca, fmt) result(n)
    complex(sp), dimension(:, :), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: i, j

    n = size(ca) - 1
    do i = 1, size(ca, 1)
      do j = 1, size(ca, 2)
        n = n + len(ca(i, j), fmt)
      enddo
    enddo
  end function str_complex_sp_matrix_fmt_len
     
  pure function str_complex_sp_matrix_fmt(ca, fmt) result(s)
    complex(sp), dimension(:, :), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    character(len=len(ca, fmt)) :: s

    integer :: i, j, k, n

    i = len(ca(1,1), fmt)
    s(:i) = safestr(ca(1,1), fmt)
    n = i + 1
    do j = 2, size(ca, 1)
      i = len(ca(j,1), fmt)
      s(n:n+i) = " "//safestr(ca(j,1), fmt)
      n = n + i + 1
    enddo
    do k = 2, size(ca, 2)
      do j = 1, size(ca, 1)
        i = len(ca(j,k), fmt)
        s(n:n+i) = " "//safestr(ca(j,k), fmt)
        n = n + i + 1
      enddo
    enddo

  end function str_complex_sp_matrix_fmt

  function str_complex_sp_matrix_fmt_chk(ca, fmt) result(s)
    complex(sp), dimension(:, :), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    character(len=len(ca, fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(ca, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif

  end function str_complex_sp_matrix_fmt_chk

  pure function str_complex_sp_matrix_len(ca) result(n)
    complex(sp), dimension(:, :), intent(in) :: ca
    integer :: n

    n = len(ca, "")
  end function str_complex_sp_matrix_len
  
  pure function str_complex_sp_matrix(ca) result(s)
    complex(sp), dimension(:, :), intent(in) :: ca
    character(len=len(ca)) :: s

    s = safestr(ca, "")
  end function str_complex_sp_matrix
  

  pure function str_complex_dp_fmt_len(c, fmt) result(n)
    complex(dp), intent(in) :: c
    character(len=*), intent(in) :: fmt
    integer :: n

    real(dp) :: re, im
    re = real(c)
    im = aimag(c)

    n = len(re, fmt) + len(im, fmt) + 6
  end function str_complex_dp_fmt_len

  function str_complex_dp_fmt_chk(c, fmt) result(s)
    complex(dp), intent(in) :: c
    character(len=*), intent(in) :: fmt
    character(len=len(c, fmt)) :: s
    
    if (checkFmt(fmt)) then
      s = safestr(c, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif

  end function str_complex_dp_fmt_chk

  pure function str_complex_dp_fmt(c, fmt) result(s)
    complex(dp), intent(in) :: c
    character(len=*), intent(in) :: fmt
    character(len=len(c, fmt)) :: s
    
    real(dp) :: re, im
    integer :: i
    re = real(c)
    im = aimag(c)
    i = len(re, fmt)
    s(:i+4) = "("//safestr(re, fmt)//")+i"
    s(i+5:)="("//safestr(im,fmt)//")"
  end function str_complex_dp_fmt

  pure function str_complex_dp_len(c) result(n)
    complex(dp), intent(in) :: c
    integer :: n

    n = len(c, "")
  end function str_complex_dp_len

  pure function str_complex_dp(c) result(s)
    complex(dp), intent(in) :: c
    character(len=len(c, "")) :: s

    s = safestr(c, "")
  end function str_complex_dp

  pure function str_complex_dp_array_fmt_len(ca, fmt) result(n)
    complex(dp), dimension(:), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: i

    n = size(ca) - 1
    do i = 1, size(ca)
      n = n + len(ca(i), fmt)
    enddo
  end function str_complex_dp_array_fmt_len
     
  pure function str_complex_dp_array_fmt(ca, fmt) result(s)
    complex(dp), dimension(:), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    character(len=len(ca, fmt)) :: s

    integer :: i, n

    s(1:len(ca(1), fmt)) = safestr(ca(1), fmt)
    n = len(ca(1), fmt)+1
    do i = 2, size(ca) 
      s(n:n+len(ca(i), fmt)) = " "//safestr(ca(i), fmt)
      n = n + len(ca(i), fmt)+1
    enddo
  end function str_complex_dp_array_fmt

  function str_complex_dp_array_fmt_chk(ca, fmt) result(s)
    complex(dp), dimension(:), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    character(len=len(ca, fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(ca, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif

  end function str_complex_dp_array_fmt_chk

  pure function str_complex_dp_array_len(ca) result(n)
    complex(dp), dimension(:), intent(in) :: ca
    integer :: n

    n = len(ca, "")
  end function str_complex_dp_array_len
  
  pure function str_complex_dp_array(ca) result(s)
    complex(dp), dimension(:), intent(in) :: ca
    character(len=len(ca)) :: s

    s = safestr(ca, "")
  end function str_complex_dp_array

  pure function str_complex_dp_matrix_fmt_len(ca, fmt) result(n)
    complex(dp), dimension(:, :), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    integer :: n

    integer :: i, j

    n = size(ca) - 1
    do i = 1, size(ca, 1)
      do j = 1, size(ca, 2)
        n = n + len(ca(i, j), fmt)
      enddo
    enddo
  end function str_complex_dp_matrix_fmt_len
     
  pure function str_complex_dp_matrix_fmt(ca, fmt) result(s)
    complex(dp), dimension(:, :), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    character(len=len(ca, fmt)) :: s

    integer :: i, j, k, n

    i = len(ca(1,1), fmt)
    s(:i) = safestr(ca(1,1), fmt)
    n = i + 1
    do j = 2, size(ca, 1)
      i = len(ca(j,1), fmt)
      s(n:n+i) = " "//safestr(ca(j,1), fmt)
      n = n + i + 1
    enddo
    do k = 2, size(ca, 2)
      do j = 1, size(ca, 1)
        i = len(ca(j,k), fmt)
        s(n:n+i) = " "//safestr(ca(j,k), fmt)
        n = n + i + 1
      enddo
    enddo

  end function str_complex_dp_matrix_fmt

  function str_complex_dp_matrix_fmt_chk(ca, fmt) result(s)
    complex(dp), dimension(:, :), intent(in) :: ca
    character(len=*), intent(in) :: fmt
    character(len=len(ca, fmt)) :: s

    if (checkFmt(fmt)) then
      s = safestr(ca, fmt)
    else
      call FoX_error("Invalid format: "//fmt)
    endif

  end function str_complex_dp_matrix_fmt_chk

  pure function str_complex_dp_matrix_len(ca) result(n)
    complex(dp), dimension(:, :), intent(in) :: ca
    integer :: n

    n = len(ca, "")
  end function str_complex_dp_matrix_len
  
  pure function str_complex_dp_matrix(ca) result(s)
    complex(dp), dimension(:, :), intent(in) :: ca
    character(len=len(ca)) :: s

    s = safestr(ca, "")
  end function str_complex_dp_matrix


  pure function checkFmt(fmt) result(good)
    character(len=*), intent(in) :: fmt
    logical :: good

    ! should be ([rs]\d*)?

    if (len(fmt) > 0) then
      if (fmt(1:1) == "r" .or. fmt(1:1) == "s") then
        if (len(fmt) > 1) then
          good = (verify(fmt(2:), digit) == 0)
        else
          good = .true.
        endif
      else
        good = .false.
      endif
    else
      good = .true.
    endif
  end function checkFmt

  pure function concat_str_int(s1, s2) result(s3)
    character(len=*), intent(in) :: s1
    integer, intent(in) :: s2
    character(len=len(s1)+len(s2)) :: s3
    s3 = s1//str(s2)
  end function concat_str_int
  pure function concat_int_str(s1, s2) result(s3)
    integer, intent(in) :: s1
    character(len=*), intent(in) :: s2
    character(len=len(s1)+len(s2)) :: s3
    s3 = str(s1)//s2
  end function concat_int_str

  pure function concat_str_logical(s1, s2) result(s3)
    character(len=*), intent(in) :: s1
    logical, intent(in) :: s2
    character(len=len(s1)+len(s2)) :: s3
    s3 = s1//str(s2)
  end function concat_str_logical
  pure function concat_logical_str(s1, s2) result(s3)
    logical, intent(in) :: s1
    character(len=*), intent(in) :: s2
    character(len=len(s1)+len(s2)) :: s3
    s3 = str(s1)//s2
  end function concat_logical_str

  pure function concat_str_real_sp(s1, s2) result(s3)
    character(len=*), intent(in) :: s1
    real(sp), intent(in) :: s2
    character(len=len(s1)+len(s2)) :: s3
    s3 = s1//str(s2)
  end function concat_str_real_sp
  pure function concat_real_sp_str(s1, s2) result(s3)
    real(sp), intent(in) :: s1
    character(len=*), intent(in) :: s2
    character(len=len(s1)+len(s2)) :: s3
    s3 = str(s1)//s2
  end function concat_real_sp_str

  pure function concat_str_real_dp(s1, s2) result(s3)
    character(len=*), intent(in) :: s1
    real(dp), intent(in) :: s2
    character(len=len(s1)+len(s2)) :: s3
    s3 = s1//str(s2)
  end function concat_str_real_dp
  pure function concat_real_dp_str(s1, s2) result(s3)
    real(dp), intent(in) :: s1
    character(len=*), intent(in) :: s2
    character(len=len(s1)+len(s2)) :: s3
    s3 = str(s1)//s2
  end function concat_real_dp_str

  pure function concat_str_complex_sp(s1, s2) result(s3)
    character(len=*), intent(in) :: s1
    complex(sp), intent(in) :: s2
    character(len=len(s1)+len(s2)) :: s3
    s3 = s1//str(s2)
  end function concat_str_complex_sp
  pure function concat_complex_sp_str(s1, s2) result(s3)
    complex(sp), intent(in) :: s1
    character(len=*), intent(in) :: s2
    character(len=len(s1)+len(s2)) :: s3
    s3 = str(s1)//s2
  end function concat_complex_sp_str

  pure function concat_str_complex_dp(s1, s2) result(s3)
    character(len=*), intent(in) :: s1
    complex(dp), intent(in) :: s2
    character(len=len(s1)+len(s2)) :: s3
    s3 = s1//str(s2)
  end function concat_str_complex_dp
  pure function concat_complex_dp_str(s1, s2) result(s3)
    complex(dp), intent(in) :: s1
    character(len=*), intent(in) :: s2
    character(len=len(s1)+len(s2)) :: s3
    s3 = str(s1)//s2
  end function concat_complex_dp_str
end module m_common_format

program test

  use m_common_charset, only : XML1_0, XML1_1
  use m_common_struct, only : xml_doc_state
  use m_common_namecheck, only : checkSystemID
  implicit none

  type(xml_doc_state) :: xds

  write(*,'(l1)') checkSystemID('abcd')
  write(*,'(l1)') checkSystemID('1abcd /"()+,/=?;!*#@$%')
  write(*,'(l1)') checkSystemID('1abcd /"()+,/=?;!*#@$%'//achar(13))
  write(*,'(l1)') checkSystemID('1abcd /(")+,/=?;!*#@$%&')
  write(*,'(l1)') checkSystemID('1abcd /(")+,/=?;!*#@$%&'//"'")

end program test

program test

  use m_common_charset, only : XML1_0, XML1_1
  use m_common_struct, only : xml_doc_state
  use m_common_namecheck, only : checkEncName
  implicit none

  write(*,'(l1)') checkEncName('abcd')
  write(*,'(l1)') checkEncName('1abcd')
  write(*,'(l1)') checkEncName(':abcd')
  write(*,'(l1)') checkEncName('#abcd')
  write(*,'(l1)') checkEncName('e:abcd')
  write(*,'(l1)') checkEncName('e-abcd')

end program test

program dom_example

  use FoX_dom
  implicit none

  type(Node), pointer :: myDoc
  real :: t1, t2

  call cpu_time(t1)
  ! Load in the document
  myDoc => parseFile("h2o.xml")

  ! Tell the normalizer to canonicalize it
  call setParameter(getDomConfig(myDoc), "canonical-form", .true.)

  ! and write it out again (which automatically does normalization.
  call serialize(myDoc, "out.xml")
  call cpu_time(t2)

  print*, "Elapsed time:", t2-t1

  ! Clear up all allocated memory
  call destroy(myDoc)
end program dom_example

module m_common_entities

#ifndef DUMMYLIB
  ! Entity management

  ! It deals with: 
  !    1. The five standard entities (gt,lt,amp,apos,quot)
  !    2. Character entities  (but only within the range of the char intrinsic)
  !    3. Parameter entities
  !    4. Internal entities
  ! In addition, it has the capacity to make lists of
  !    1. External parsed entities
  !    2. External unparsed entities
  ! Though nothing is done with them currently elsewhere in FoX.


  use m_common_array_str, only: str_vs, vs_str_alloc
  use m_common_charset, only: digits, hexdigits
  use m_common_error, only: FoX_error
  use m_common_format, only: str_to_int_10, str_to_int_16

  implicit none
  private

  type entity_t
    private
    logical :: external
    character(len=1), dimension(:), pointer :: code => null()
    character(len=1), dimension(:), pointer :: repl => null()
    character(len=1), dimension(:), pointer :: publicId => null()
    character(len=1), dimension(:), pointer :: systemId => null()
    character(len=1), dimension(:), pointer :: notation => null()
  end type entity_t

  type entity_list
    private
    type(entity_t), dimension(:), pointer :: list => null()
  end type entity_list

  public :: is_unparsed_entity
  public :: is_external_entity

  public :: expand_entity_text
  public :: expand_entity_text_len
  public :: existing_entity

  public :: expand_char_entity

  public :: expand_entity
  public :: expand_entity_len

  public :: entity_t
  public :: entity_list
  public :: init_entity_list
  public :: reset_entity_list
  public :: destroy_entity_list
  public :: print_entity_list
  public :: add_internal_entity
  public :: add_external_entity
  public :: pop_entity_list

  interface size
    module procedure size_el
  end interface

  public :: getEntityByIndex
  public :: getEntityNameByIndex
  public :: getEntityTextByIndex
  public :: getEntityTextByName
  public :: getEntityNotationByIndex
  public :: size

contains

  function shallow_copy_entity(ent1) result(ent2)
    type(entity_t), intent(in) :: ent1
    type(entity_t) :: ent2
    
    ent2%external = ent1%external
    ent2%code => ent1%code
    ent2%repl => ent1%repl
    ent2%publicId => ent1%publicId
    ent2%systemId => ent1%systemId
    ent2%notation => ent1%notation

  end function shallow_copy_entity

  function getEntityByIndex(el, i) result(e)
    type(entity_list), intent(in) :: el
    integer, intent(in) :: i
    type(entity_t) :: e

    e = el%list(i)
  end function getEntityByIndex

  function getEntityNameByIndex(el, i) result(c)
    type(entity_list), intent(in) :: el
    integer, intent(in) :: i
    character(len=size(el%list(i)%code)) :: c

    c = str_vs(el%list(i)%code)
  end function getEntityNameByIndex

  function getEntityTextByIndex(el, i) result(c)
    type(entity_list), intent(in) :: el
    integer, intent(in) :: i
    character(len=size(el%list(i)%repl)) :: c

    c = str_vs(el%list(i)%repl)
  end function getEntityTextByIndex

  pure function getEntityTextByName_len(el, name) result(n)
    type(entity_list), intent(in) :: el
    character(len=*), intent(in) :: name
    integer :: n

    integer :: i
    n = 0
    do i = 1, size(el%list)
      if (str_vs(el%list(i)%code)==name) then
        n = size(el%list(i)%repl)
        exit
      endif
    enddo
  end function getEntityTextByName_len
  
  function getEntityTextByName(el, name) result(c)
    type(entity_list), intent(in) :: el
    character(len=*), intent(in) :: name
    character(len=getEntityTextByName_len(el, name)) :: c

    integer :: i
    c = ""
    do i = 1, size(el%list)
      if (str_vs(el%list(i)%code)==name) then
        c = str_vs(el%list(i)%repl)
        exit
      endif
    enddo
  end function getEntityTextByName

  function getEntityNotationByIndex(el, i) result(c)
    type(entity_list), intent(in) :: el
    integer, intent(in) :: i
    character(len=size(el%list(i)%notation)) :: c

    c = str_vs(el%list(i)%notation)
  end function getEntityNotationByIndex

  function size_el(el) result(n)
    type(entity_list), intent(in) :: el
    integer :: n

    n = ubound(el%list, 1)
  end function size_el


  subroutine destroy_entity(ent)
    type(entity_t), intent(inout) :: ent
    
    deallocate(ent%code)
    deallocate(ent%repl)
    deallocate(ent%publicId)
    deallocate(ent%systemId)
    deallocate(ent%notation)

  end subroutine destroy_entity


  subroutine init_entity_list(ents)
    type(entity_list), intent(inout) :: ents

    if (associated(ents%list)) deallocate(ents%list)
    allocate(ents%list(0))

  end subroutine init_entity_list


  subroutine reset_entity_list(ents)
    type(entity_list), intent(inout) :: ents

    call destroy_entity_list(ents)
    call init_entity_list(ents)

  end subroutine reset_entity_list


  subroutine destroy_entity_list(ents)
    type(entity_list), intent(inout) :: ents

    integer :: i, n

    n = size(ents%list)
    do i = 1, n
      call destroy_entity(ents%list(i))
    enddo
    deallocate(ents%list)
  end subroutine destroy_entity_list

  function pop_entity_list(ents) result(name)
    type(entity_list), intent(inout) :: ents
    character(len=size(ents%list(size(ents%list))%code)) :: name
    
    type(entity_t), pointer :: ents_tmp(:)
    integer :: i, n
    n = size(ents%list)

    ents_tmp => ents%list
    allocate(ents%list(n-1))
    do i = 1, n - 1
      ents%list(i) = shallow_copy_entity(ents_tmp(i))
    enddo
    name = str_vs(ents_tmp(i)%code)
    call destroy_entity(ents_tmp(i))
    deallocate(ents_tmp)
  end function pop_entity_list

  subroutine print_entity_list(ents)
    type(entity_list), intent(in) :: ents

    integer :: i, n

    n = size(ents%list)
    write(*,'(a)') '>ENTITYLIST'
    do i = 1, n
      write(*,'(a)') str_vs(ents%list(i)%code)
      write(*,'(a)') str_vs(ents%list(i)%repl)
      write(*,'(a)') str_vs(ents%list(i)%publicId)
      write(*,'(a)') str_vs(ents%list(i)%systemId)
      write(*,'(a)') str_vs(ents%list(i)%notation)
    enddo
    write(*,'(a)') '<ENTITYLIST'
  end subroutine print_entity_list


  subroutine add_entity(ents, code, repl, publicId, systemId, notation, external)
    type(entity_list), intent(inout) :: ents
    character(len=*), intent(in) :: code
    character(len=*), intent(in) :: repl
    character(len=*), intent(in) :: publicId
    character(len=*), intent(in) :: systemId
    character(len=*), intent(in) :: notation
    logical, intent(in) :: external

    type(entity_t), pointer :: ents_tmp(:)
    integer :: i, n

    ! This should only ever be called by add_internal_entity or add_external_entity
    ! below, so we don't bother sanity-checking input. Note especially we don't 
    ! check for duplication of entities, so this will happily add another entity
    ! of the same name if you ask it to. This should't matter though, since the
    ! first defined will always be picked up first, which is what the XML spec
    ! requires.

    n = size(ents%list)
    ents_tmp => ents%list
    allocate(ents%list(n+1))
    do i = 1, n
      ents%list(i) = shallow_copy_entity(ents_tmp(i))
    enddo
    deallocate(ents_tmp)
    ents%list(i)%external = external
    ents%list(i)%code => vs_str_alloc(code)
    ents%list(i)%repl => vs_str_alloc(repl)
    ents%list(i)%publicId => vs_str_alloc(publicId)
    ents%list(i)%systemId => vs_str_alloc(systemId)
    ents%list(i)%notation => vs_str_alloc(notation)
  end subroutine add_entity


  subroutine add_internal_entity(ents, code, repl)
    type(entity_list), intent(inout) :: ents
    character(len=*), intent(in) :: code
    character(len=*), intent(in) :: repl

    call add_entity(ents, code, repl, "", "", "", .false.)
  end subroutine add_internal_entity

  
  subroutine add_external_entity(ents, code, systemId, publicId, notation)
    type(entity_list), intent(inout) :: ents
    character(len=*), intent(in) :: code
    character(len=*), intent(in) :: systemId
    character(len=*), intent(in), optional :: publicId
    character(len=*), intent(in), optional :: notation

    if (present(publicId) .and. present(notation)) then
      call add_entity(ents, code, "", systemId, publicId, notation, .true.)
    elseif (present(publicId)) then
      call add_entity(ents, code, "", systemId, publicId, "", .true.)
    elseif (present(notation)) then
      call add_entity(ents, code, "", systemId, "", notation, .true.)
    else
      call add_entity(ents, code, "", systemId, "", "", .true.)
    endif
  end subroutine add_external_entity


  function is_unparsed_entity(ents, code) result(p)
    type(entity_list), intent(in) :: ents
    character(len=*), intent(in) :: code
    logical :: p

    integer :: i

    p = .false.

    do i = 1, size(ents%list)
      if (code == str_vs(ents%list(i)%code)) then
        p = (size(ents%list(i)%notation)>0)
        exit
      endif
    enddo
  end function is_unparsed_entity

  function is_external_entity(ents, code) result(p)
    type(entity_list), intent(in) :: ents
    character(len=*), intent(in) :: code
    logical :: p

    integer :: i

    p = .false.

    do i = 1, size(ents%list)
      if (code == str_vs(ents%list(i)%code)) then
        p = ents%list(i)%external
        exit
      endif
    enddo
  end function is_external_entity
 
  pure function expand_char_entity_len(code) result(n)
    character(len=*), intent(in) :: code
    integer :: n

    integer :: number

    if (code(1:1) == "#") then
      if (code(2:2) == "x") then       ! hex character reference
        if (verify(code(3:), hexdigits) == 0) then
          number = str_to_int_16(code(3:))   
          if (0 <= number .and. number <= 128) then
            n = 1
          else
            n = len(code) + 2
          endif
        else 
           n = 0
        endif
      else                             ! decimal character reference
        if (verify(code(3:), digits) == 0) then
          number = str_to_int_10(code(2:))
          if (0 <= number .and. number <= 128) then
            n = 1
          else
            n = len(code) + 2
          endif
        else 
          n = 0
        endif
      endif
    else
      n = 0
    endif
  end function expand_char_entity_len


  function expand_char_entity(code) result(repl)
    character(len=*), intent(in) :: code
    character(len=expand_char_entity_len(code)) :: repl

    integer :: number

    select case (len(repl))
    case (0)
      call FoX_error("Invalid character entity reference")
    case (1)  
      if (code(2:2) == "x") then       ! hex character reference
        number = str_to_int_16(code(3:))   
      else                             ! decimal character reference
        number = str_to_int_10(code(2:))
      endif
      repl = achar(number)
      ! FIXME what about > 127 ...
    case default
      repl = "&"//code//";"
    end select

  end function expand_char_entity


  pure function existing_entity(ents, code) result(p)
    type(entity_list), intent(in) :: ents
    character(len=*), intent(in)  :: code
    logical :: p

    integer :: i

    p = .false.
    
!FIXME the following test is not entirely in accordance with the valid chars check we do elsewhere...

    do i = 1, size(ents%list)
      if (code == str_vs(ents%list(i)%code)) then
        p = .true.
        return
      endif
    enddo

  end function existing_entity


  pure function expand_entity_text_len(ents, code) result(n)
    type(entity_list), intent(in) :: ents
    character(len=*), intent(in)  :: code
    integer :: n

    integer :: i

    do i = 1, size(ents%list)
      if (code == str_vs(ents%list(i)%code)) then
        n = size(ents%list(i)%repl)
      endif
    enddo

  end function expand_entity_text_len


  function expand_entity_text(ents, code) result(repl)
    type(entity_list), intent(in) :: ents
    character(len=*), intent(in)  :: code
    character(len=expand_entity_text_len(ents, code)) :: repl

    integer :: i

    ! No error checking - make sure entity exists before calling it.

    do i = 1, size(ents%list)
      if (code == str_vs(ents%list(i)%code)) then
        repl = str_vs(ents%list(i)%repl)
        exit
      endif
    enddo

  end function expand_entity_text


  pure function expand_entity_len(ents, code) result(n)
    type(entity_list), intent(in) :: ents
    character(len=*), intent(in)  :: code
    integer :: n

    integer :: i

    do i = 1, size(ents%list)
      if (code == str_vs(ents%list(i)%code)) then
        n = size(ents%list(i)%repl)
      endif
    enddo

  end function expand_entity_len


  function expand_entity(ents, code) result(repl)
    type(entity_list), intent(in) :: ents
    character(len=*), intent(in)  :: code
    character(len=expand_entity_len(ents, code)) :: repl
    
    integer :: i
    
    do i = 1, size(ents%list)
      if (code == str_vs(ents%list(i)%code)) then
        repl = str_vs(ents%list(i)%repl)
      endif
    enddo

  end function expand_entity

#endif
end module m_common_entities

program test

  use FoX_wcml
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  call cmlBeginFile(xf, filename, unit=-1)
  call cmlStartCml(xf)
  call cmlAddKpoint(xf, coords=(/1.0d0, 2.0d0, 3.0d0/), weight=0.75d0)
  call cmlFinishFile(xf)

end program test

module m_common_charset

  ! Written to use ASCII charset only. Full UNICODE would
  ! take much more work and need a proper unicode library.

  implicit none
  private

  interface operator(.in.)
    module procedure belongs
  end interface

!!$  character(len=1), parameter :: ASCII = &
!!$achar(0)//achar(1)//achar(2)//achar(3)//achar(4)//achar(5)//achar(6)//achar(7)//achar(8)//achar(9)//&
!!$achar(10)//achar(11)//achar(12)//achar(13)//achar(14)//achar(15)//achar(16)//achar(17)//achar(18)//achar(19)//&
!!$achar(20)//achar(21)//achar(22)//achar(23)//achar(24)//achar(25)//achar(26)//achar(27)//achar(28)//achar(29)//&
!!$achar(30)//achar(31)//achar(32)//achar(33)//achar(34)//achar(35)//achar(36)//achar(37)//achar(38)//achar(39)//&
!!$achar(40)//achar(41)//achar(42)//achar(43)//achar(44)//achar(45)//achar(46)//achar(47)//achar(48)//achar(49)//&
!!$achar(50)//achar(51)//achar(52)//achar(53)//achar(54)//achar(55)//achar(56)//achar(57)//achar(58)//achar(59)//&
!!$achar(60)//achar(61)//achar(62)//achar(63)//achar(64)//achar(65)//achar(66)//achar(67)//achar(68)//achar(69)//&
!!$achar(70)//achar(71)//achar(72)//achar(73)//achar(74)//achar(75)//achar(76)//achar(77)//achar(78)//achar(79)//&
!!$achar(80)//achar(81)//achar(82)//achar(83)//achar(84)//achar(85)//achar(86)//achar(87)//achar(88)//achar(89)//&
!!$achar(90)//achar(91)//achar(92)//achar(93)//achar(94)//achar(95)//achar(96)//achar(97)//achar(98)//achar(99)//&
!!$achar(100)//achar(101)//achar(102)//achar(103)//achar(104)//achar(105)//achar(106)//achar(107)//achar(108)//achar(109)//&
!!$achar(110)//achar(111)//achar(112)//achar(113)//achar(114)//achar(115)//achar(116)//achar(117)//achar(118)//achar(119)//&
!!$achar(120)//achar(121)//achar(122)//achar(123)//achar(124)//achar(125)//achar(126)//achar(127)

  character(len=1), parameter :: SPACE           = achar(32)
  character(len=1), parameter :: NEWLINE         = achar(10)
  character(len=1), parameter :: CARRIAGE_RETURN = achar(13)
  character(len=1), parameter :: TAB             = achar(9)

  character(len=*), parameter :: whitespace = SPACE//NEWLINE//CARRIAGE_RETURN//TAB

  character(len=*), parameter :: lowerCase = "abcdefghijklmnopqrstuvwxyz"
  character(len=*), parameter :: upperCase = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
  character(len=*), parameter :: digits = "0123456789"
  character(len=*), parameter :: hexdigits = "0123456789abcdefABCDEF"
  character(len=*), parameter :: NameChars = lowerCase//upperCase//digits//".-_:"
  character(len=*), parameter :: InitialNameChars = lowerCase//upperCase//"_:"

  character(len=*), parameter :: PubIdChars = NameChars//whitespace//"'()+,/=?;!*#@$%"
  character(len=*), parameter :: validchars = &
    whitespace//"!""#$%&'()*+,-./"//digits// &
    ":;<=>?@"//upperCase//"[\]^_`"//lowerCase//"{|}~"
  ! these are all the standard ASCII printable characters: whitespace + (33-126)
  ! which are the only characters we can guarantee to know how to handle properly.

  integer, parameter :: XML1_0 = 10      ! NB 0x7F was legal in XML-1.0, but illegal in XML-1.1

  integer, parameter :: XML1_1 = 11

  character(len=*), parameter :: XML1_0_ILLEGALCHARS = achar(0)
  character(len=*), parameter :: XML1_1_ILLEGALCHARS = NameChars

  character(len=*), parameter :: XML1_0_NAMECHARS = NameChars
  character(len=*), parameter :: XML1_1_NAMECHARS = NameChars

  character(len=*), parameter :: XML1_0_INITIALNAMECHARS = InitialNameChars
  character(len=*), parameter :: XML1_1_INITIALNAMECHARS = InitialNameChars

  character(len=*), parameter :: XML_WHITESPACE = whitespace
  character(len=*), parameter :: XML_INITIALENCODINGCHARS = lowerCase//upperCase
  character(len=*), parameter :: XML_ENCODINGCHARS = lowerCase//upperCase//digits//'._-'

  public :: operator(.in.)

  public :: validchars
  public :: whitespace
  public :: uppercase

  public :: digits
  public :: hexdigits

  public :: XML1_0
  public :: XML1_1
  public :: XML1_0_NAMECHARS
  public :: XML1_1_NAMECHARS
  public :: XML1_0_INITIALNAMECHARS
  public :: XML1_1_INITIALNAMECHARS
  public :: XML_WHITESPACE
  public :: XML_INITIALENCODINGCHARS
  public :: XML_ENCODINGCHARS

  public :: isLegalChar
  public :: isLegalCharRef
  public :: isRepCharRef
  public :: isInitialNameChar
  public :: isNameChar
  public :: isInitialNCNameChar
  public :: isNCNameChar
  public :: isXML1_0_NameChar
  public :: isXML1_1_NameChar
  public :: checkChars

contains

  function belongs(c, str) result(p)
    character, intent(in) :: c
    character(len=*), intent(in) :: str
    logical :: p
    p = (verify(c, str)==0)
  end function belongs

  pure function isLegalChar(c, xml_version) result(p)
    character, intent(in) :: c
    integer, intent(in) :: xml_version
    logical :: p 
    ! Is this character legal as a source character in the document?
    integer :: i
    i = iachar(c)
    if (i<0.or.i>127) then
      p = .false. ! FIXME but it's processor dependent ...
    endif
    select case(xml_version)
    case (XML1_0)
      p = (i==9.or.i==10.or.i==13.or.(i>31.and.i<127))
    case (XML1_1)
      p = (i==9.or.i==10.or.i==13.or.(i>31.and.i<128))
      ! NB 0x7F was legal in XML-1.0, but illegal in XML-1.1
    end select
  end function isLegalChar

  pure function isLegalCharRef(i, xml_version) result(p)
    integer, intent(in) :: i
    integer, intent(in) :: xml_version
    logical :: p 

    ! Is Unicode character #i legal as a character reference?

    if (xml_version==XML1_0) then
      p = (i==9).or.(i==10).or.(i==13).or.(i>31.and.i<55296).or.(i>57343.and.i<65534).or.(i>65535.and.i<1114112)
    elseif (xml_version==XML1_1) then
      p = (i>0.and.i<55296).or.(i>57343.and.i<65534).or.(i>65535.and.i<1114112)
      ! XML 1.1 made all control characters legal as character references.
    end if
  end function isLegalCharRef

  pure function isRepCharRef(i, xml_version) result(p)
    integer, intent(in) :: i
    integer, intent(in) :: xml_version
    logical :: p 

    ! Is Unicode character #i legal and representable here?

    if (xml_version==XML1_0) then
      p = (i==9).or.(i==10).or.(i==13).or.(i>31.and.i<127)
    elseif (xml_version==XML1_1) then
      p = (i>0.and.i<128)
      ! XML 1.1 made all control characters legal as character references.
    end if
  end function isRepCharRef

  pure function isInitialNameChar(c, xml_version) result(p)
    character, intent(in) :: c
    integer, intent(in) :: xml_version
    logical :: p

    select case(xml_version)
    case (XML1_0)
      p = (verify(c, XML1_0_INITIALNAMECHARS)==0)
    case (XML1_1)
      p = (verify(c, XML1_1_INITIALNAMECHARS)==0)
    end select

  end function isInitialNameChar

  pure function isNameChar(c, xml_version) result(p)
    character, intent(in) :: c
    integer, intent(in) :: xml_version
    logical :: p

    select case(xml_version)
    case (XML1_0)
      p = (verify(c, XML1_0_NAMECHARS)==0)
    case (XML1_1)
      p = (verify(c, XML1_1_NAMECHARS)==0)
    end select

  end function isNameChar

  pure function isInitialNCNameChar(c, xml_version) result(p)
    character, intent(in) :: c
    integer, intent(in) :: xml_version
    logical :: p

    if (c==":") then
      p = .false.
    else
      select case(xml_version)
      case (XML1_0)
        p = (verify(c, XML1_0_INITIALNAMECHARS)==0)
      case (XML1_1)
        p = (verify(c, XML1_1_INITIALNAMECHARS)==0)
      end select
    endif
  end function isInitialNCNameChar

  pure function isNCNameChar(c, xml_version) result(p)
    character, intent(in) :: c
    integer, intent(in) :: xml_version
    logical :: p

    if (c==":") then
      p = .false.
    else
      select case(xml_version)
      case (XML1_0)
        p = (verify(c, XML1_0_NAMECHARS)==0)
      case (XML1_1)
        p = (verify(c, XML1_1_NAMECHARS)==0)
      end select
    endif
  end function isNCNameChar

  function isXML1_0_NameChar(c) result(p)
    character, intent(in) :: c
    logical :: p

    p = (verify(c, XML1_0_NAMECHARS)==0)

  end function isXML1_0_NameChar

  function isXML1_1_NameChar(c) result(p)
    character, intent(in) :: c
    logical :: p

    p = (verify(c, XML1_1_NAMECHARS)==0)

  end function isXML1_1_NameChar

  pure function checkChars(value, xv) result(p)
    character(len=*), intent(in) :: value
    integer, intent(in) :: xv
    logical :: p

    ! This checks if value only contains values
    ! legal to appear (escaped or unescaped) 
    ! according to whichever XML version is in force.
    integer :: i

    p = .true.
    do i = 1, len(value)
      if (xv == XML1_0) then
        select case(iachar(value(i:i)))
        case (0,8)
          p = .false.
        case (11,12)
          p = .false.
        end select
      else
        if (iachar(value(i:i))==0) p =.false.
      endif
    enddo
  end function checkChars

end module m_common_charset

module m_common_array_str

  implicit none
  private

  type string_t
    character, pointer :: s(:) => null()
  end type string_t

  type string_list
    type(string_t), pointer :: list(:) => null()
  end type string_list

  public :: string_t
  public :: string_list

  public :: init_string_list
  public :: destroy_string_list
  public :: add_string

  public :: str_vs
  public :: vs_str
  public :: vs_str_alloc

  public :: devnull

contains

  subroutine init_string_list(s_list)
    type(string_list), intent(inout) :: s_list

    allocate(s_list%list(0))
  end subroutine init_string_list

  subroutine destroy_string_list(s_list)
    type(string_list), intent(inout) :: s_list

    integer :: i

    do i = 1, size(s_list%list)
      deallocate(s_list%list(i)%s)
    enddo
    deallocate(s_list%list)
  end subroutine destroy_string_list

  subroutine add_string(s_list, s)
    type(string_list), intent(inout) :: s_list
    character(len=*), intent(in) :: s

    integer :: i
    type(string_t), pointer :: temp(:)

    temp => s_list%list
    allocate(s_list%list(size(temp)+1))
    do i = 1, size(temp)
      s_list%list(i)%s => temp(i)%s
    enddo
    deallocate(temp)
    s_list%list(i)%s => vs_str_alloc(s)
  end subroutine add_string

  pure function str_vs(vs) result(s)
    character, dimension(:), intent(in) :: vs
    character(len=size(vs)) :: s

    s = transfer(vs, s)
  end function str_vs


  pure function vs_str(s) result(vs)
    character(len=*), intent(in) :: s
    character, dimension(len(s)) :: vs

    vs = transfer(s, vs)
  end function vs_str

  pure function vs_str_alloc(s) result(vs)
    character(len=*), intent(in) :: s
    character, dimension(:), pointer :: vs

    allocate(vs(len(s)))
    vs = vs_str(s)
  end function vs_str_alloc

  subroutine devnull(in)
    character(len=*), intent(in) :: in
    ! just so we can call string functions for their side-effects
  end subroutine devnull

end module m_common_array_str

module m_sax_converters

use m_sax_debug, only : debug

implicit none
private
!
! Takes a string and turns it into useful data structures,
! such as numerical arrays.
!
! NOTE: The string must contain *homogeneous* data, i.e.: all real numbers,
! all integers, etc.
!
public :: build_data_array

interface build_data_array
      module procedure build_data_array_real_sp,  &
                       build_data_array_real_dp,  &
                       build_data_array_integer
end interface
private :: build_data_array_real_sp
private :: build_data_array_real_dp
private :: build_data_array_integer

private :: token_analysis, is_separator, is_CR_or_LF

CONTAINS

!---------------------------------------------------------------
subroutine build_data_array_real_dp(str,x,n)
integer, parameter  :: dp = selected_real_kind(14)
!
character(len=*), intent(in)                ::  str
real(kind=dp), dimension(:), intent(inout)  ::    x
integer, intent(inout)                      ::    n

integer                            :: ntokens, status, last_pos
character(len=len(str))  :: s

s = str
call token_analysis(s,ntokens,last_pos)
if (debug) print *, "ntokens, last_pos ", ntokens, last_pos
if (debug) print *, s
if ((n + ntokens) > size(x)) STOP "data array full"
read(unit=s(1:last_pos),fmt=*,iostat=status) x(n+1:n+ntokens)
if (status /= 0) STOP "real conversion error"
n = n + ntokens

end subroutine build_data_array_real_dp
!---------------------------------------------------------------

subroutine build_data_array_real_sp(str,x,n)
integer, parameter  :: sp = selected_real_kind(6)
!
character(len=*), intent(in)                :: str
real(kind=sp), dimension(:), intent(inout)  ::    x
integer, intent(inout)                      ::    n

integer                            :: ntokens, status, last_pos
character(len=len(str))  :: s

s = str
call token_analysis(s,ntokens,last_pos)
if (debug) print *, "ntokens, last_pos ", ntokens, last_pos
if (debug) print *, s
if ((n + ntokens) > size(x)) STOP "data array full"
read(unit=s(1:last_pos),fmt=*,iostat=status) x(n+1:n+ntokens)
if (status /= 0) STOP "real conversion error"
n = n + ntokens

end subroutine build_data_array_real_sp

!---------------------------------------------------------------
subroutine build_data_array_integer(str,x,n)
integer, parameter  :: sp = selected_real_kind(14)
!
character(len=*), intent(in)                :: str
integer, dimension(:), intent(inout)        ::    x
integer, intent(inout)                      ::    n

integer                            :: ntokens, status, last_pos
character(len=len(str))  :: s

s = str
call token_analysis(s,ntokens,last_pos)
if (debug) print *, "ntokens, last_pos ", ntokens, last_pos
if (debug) print *, s
if ((n + ntokens) > size(x)) STOP "data array full"
read(unit=s(1:last_pos),fmt=*,iostat=status) x(n+1:n+ntokens)
if (status /= 0) STOP "integer conversion error"
n = n + ntokens

end subroutine build_data_array_integer


!==================================================================

function is_separator(c) result(sep)
character(len=1), intent(in)          :: c
logical                               :: sep

 sep = ((c == char(32)) .or. (c == char(10))             &
         .or. (c == char(9)) .or. (c == char(13)))

end function is_separator
!----------------------------------------------------------------
function is_CR_or_LF(c) result(res)
character(len=1), intent(in)          :: c
logical                               :: res

 res = ((c == char(10)) .or. (c == char(13)))

end function is_CR_or_LF

!==================================================================

subroutine token_analysis(str,ntokens,last_pos)
!
character(len=*), intent(inout)          :: str
integer, intent(out)                     :: ntokens, last_pos
!
!
! Checks the contents of a string and finds the number of tokens it contains
! The standard separator is generalized whitespace (space, tab, CR, or LF)
! It also returns the last useful position in the string (excluding
! separator characters which are not blanks, and thus not caught by the
! (len_)trim fortran intrinsic). This is necessary to perform list-directed
! I/O in the string as an internal file.
! 
! Also, replace on the fly CR and LF by blanks. This is necessary if
! str spans more than one record. In that case, internal reads only 
! look at the first record. 
! -- ** Compiler limits on size of internal record??
!
integer           :: i, str_length
logical           :: in_token
character(len=1)  :: c

in_token = .false.
ntokens = 0
last_pos = 0

str_length = len_trim(str)
!print *, "string length: ", str_length

do i = 1, str_length
      c = str(i:i)

      if (in_token) then
         if (is_separator(c)) then
            in_token = .false.
            if (is_CR_or_LF(c)) str(i:i) = " "
         else
            last_pos = i
         endif

      else   ! not in token
         
         if (is_separator(c)) then
            if (is_CR_or_LF(c)) str(i:i) = " "
            ! do nothing
         else
            in_token = .true.
            last_pos = i
            ntokens = ntokens + 1
         endif
      endif
enddo
!print *, "ntokens, last_pos: ", ntokens, last_pos

end subroutine token_analysis


end module m_sax_converters

program test

  use FoX_wxml
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  call xml_OpenFile(filename, xf)
  call xml_AddXMLStylesheet(xf, "display.xsl", "text/stylesheet")
  call xml_NewElement(xf, "a")
  call xml_Close(xf)

end program test

program test_sax_reader

  use m_sax_reader

  type(file_buffer_t) :: fb

  integer :: iostat

  call open_file(fb, file="test_sax_reader_1.in",  iostat=iostat)

  write(*,'(2a)') 'char:', read_char(fb, iostat)
  write(*,'(a,i0)') 'iost:', iostat

  call close_file(fb) 

end program test_sax_reader

module m_common_array_str
#ifndef DUMMYLIB
  use m_common_realtypes, only: dp

  implicit none
  private

  type string_t
    character, pointer :: s(:) => null()
  end type string_t

  type string_list
    type(string_t), pointer :: list(:) => null()
  end type string_list

  public :: string_t
  public :: string_list

  public :: init_string_list
  public :: destroy_string_list
  public :: add_string

  interface destroy
    module procedure destroy_vs
  end interface destroy

  interface concat
    module procedure vs_s_concat
  end interface

  interface alloc
    module procedure vs_str_alloc
  end interface

  interface logical
    module procedure vs_logical
  end interface logical
  interface int
    module procedure vs_int
  end interface int
  interface real
    module procedure vs_real
  end interface

  public :: str_vs
  public :: vs_str
  public :: vs_str_alloc
  public :: vs_vs_alloc

  public :: vs_logical
  public :: vs_int
  public :: vs_real

  public :: logical
  public :: int
  public :: real

  public :: concat
  public :: alloc

  public :: destroy

contains

  subroutine init_string_list(s_list)
    type(string_list), intent(inout) :: s_list

    allocate(s_list%list(0))
  end subroutine init_string_list

  subroutine destroy_string_list(s_list)
    type(string_list), intent(inout) :: s_list

    integer :: i

    do i = 1, size(s_list%list)
      deallocate(s_list%list(i)%s)
    enddo
    deallocate(s_list%list)
  end subroutine destroy_string_list

  subroutine add_string(s_list, s)
    type(string_list), intent(inout) :: s_list
    character(len=*), intent(in) :: s

    integer :: i
    type(string_t), pointer :: temp(:)

    temp => s_list%list
    allocate(s_list%list(size(temp)+1))
    do i = 1, size(temp)
      s_list%list(i)%s => temp(i)%s
    enddo
    deallocate(temp)
    s_list%list(i)%s => vs_str_alloc(s)
  end subroutine add_string

  pure function str_vs(vs) result(s)
    character, dimension(:), intent(in) :: vs
    character(len=size(vs)) :: s
#ifdef PGF90
!PGI crashes on this use of transfer. Knob-ends.
    integer :: i
    do i = 1, size(vs)
      s(i:i) = vs(i)
    enddo
#else
    s = transfer(vs, s)
#endif
  end function str_vs


  pure function vs_str(s) result(vs)
    character(len=*), intent(in) :: s
    character, dimension(len(s)) :: vs

    vs = transfer(s, vs)
  end function vs_str

  pure function vs_str_alloc(s) result(vs)
    character(len=*), intent(in) :: s
    character, dimension(:), pointer :: vs

    allocate(vs(len(s)))
    vs = vs_str(s)
  end function vs_str_alloc

  pure function vs_vs_alloc(s) result(vs)
    character, dimension(:), intent(in) :: s
    character, dimension(:), pointer :: vs

    allocate(vs(size(s)))
    vs = s
  end function vs_vs_alloc

  pure function vs_s_concat(vs, s) result(vs2)
    character, dimension(:), intent(in) :: vs
    character(len=*), intent(in) :: s
    character, dimension(:), pointer :: vs2

    allocate(vs2(size(vs)+len(s)))
    vs2(:size(vs)) = vs
    vs2(size(vs)+1:) = vs_str(s)
  end function vs_s_concat

  pure function vs_logical(vs) result(p)
    character, dimension(:), intent(in) :: vs
    logical :: p

    integer :: ios
    character(len=size(vs)) :: s
    s = str_vs(vs)
! FIXME really this should be done by bit-twiddling
! to avoid recursive IO
    read(s, *, iostat=ios) p
    if (ios/=0) p = .false.
  end function vs_logical

  pure function vs_int(vs) result(i)
    character, dimension(:), intent(in) :: vs
    integer :: i

    integer :: ios
    character(len=size(vs)) :: s
    s = str_vs(vs)
! FIXME really this should be done by bit-twiddling
! to avoid recursive IO
    read(s, *, iostat=ios) i
    if (ios/=0) i = 0
  end function vs_int

  pure function vs_real(vs) result(r)
    character, dimension(:), intent(in) :: vs
    real(dp) :: r

    integer :: ios
    character(len=size(vs)) :: s
    s = str_vs(vs)
! FIXME really this should be done by bit-twiddling
! to avoid recursive IO
    read(s, *, iostat=ios) r
    if (ios/=0) r = 0
  end function vs_real

  subroutine destroy_vs(vs)
    character, dimension(:), pointer :: vs

    deallocate(vs)
  end subroutine destroy_vs

#endif
end module m_common_array_str

module m_wxml_core

#ifndef DUMMYLIB
  use m_common_attrs, only: dictionary_t, getLength, get_key, get_value, &
    hasKey, add_item_to_dict, init_dict, reset_dict, destroy_dict, &
    getWhitespaceHandling
  use m_common_array_str, only: vs_str, str_vs, vs_str_alloc
  use m_common_buffer, only: buffer_t, len, add_to_buffer, reset_buffer, &
    dump_buffer
  use m_common_charset, only: XML1_0, XML1_1, checkChars
  use m_common_elstack, only: elstack_t, len, get_top_elstack, pop_elstack, &
    is_empty, init_elstack, push_elstack, destroy_elstack
  use m_common_entities, only: existing_entity, is_unparsed_entity
  use m_common_error, only: FoX_warning_base, FoX_error_base, FoX_fatal_base
  use m_common_io, only: get_unit
  use m_common_namecheck, only: checkEncName, checkName, checkPITarget, &
    checkCharacterEntityReference, checkPublicId, checkSystemId, &
    checkQName, prefixOfQName, localpartofQName, checkPEDef, checkPseudoAttValue, &
    checkAttValue
  use m_common_namespaces, only: namespaceDictionary, getnamespaceURI, &
  initnamespaceDictionary, destroynamespaceDictionary, addDefaultNS, &
  addPrefixedNS, isPrefixInForce, checkNamespacesWriting, checkEndNamespaces
  use m_common_notations, only: add_notation, notation_exists
  use m_common_struct, only: xml_doc_state, init_xml_doc_state, destroy_xml_doc_state, &
    register_internal_PE, register_external_PE, register_internal_GE, register_external_GE
  use m_wxml_escape, only: escape_string

  use pxf, only: pxfabort
#endif

  implicit none
  private

#ifndef DUMMYLIB
  integer, parameter :: indent_inc = 2
  ! TOHW should we let this be set?

  !Output State Machines
  ! status wrt root element:
  integer, parameter :: WXML_STATE_1_JUST_OPENED = 0 
  !File is just opened, nothing written to it yet. 
  integer, parameter :: WXML_STATE_1_BEFORE_ROOT = 1
  !File has been opened, something has been written, but no root element yet.
  integer, parameter :: WXML_STATE_1_DURING_ROOT = 2
  !The root element has been opened but not closed
  integer, parameter :: WXML_STATE_1_AFTER_ROOT = 3
  !The root element has been opened but not closed

  ! status wrt tags:
  integer, parameter :: WXML_STATE_2_OUTSIDE_TAG = 0
  !We are not within a tag.
  integer, parameter :: WXML_STATE_2_INSIDE_PI = 1
  !We are inside a Processing Instruction tag
  integer, parameter :: WXML_STATE_2_INSIDE_ELEMENT = 2
  !We are inside an element tag.
  integer, parameter :: WXML_STATE_2_IN_CHARDATA = 3
  !We are inside deliberately-constructed text. (this is only necessary for preserve_whitespace)

  ! status wrt DTD
  integer, parameter :: WXML_STATE_3_BEFORE_DTD = 0
  ! No DTD has been encountered yet.
  integer, parameter :: WXML_STATE_3_DURING_DTD = 1
  ! Halfway throught outputting a DTD
  integer, parameter :: WXML_STATE_3_INSIDE_INTSUBSET = 2
  !We are inside the internal subset definition
  integer, parameter :: WXML_STATE_3_AFTER_DTD = 3
  ! Finished outputting a DTD
#endif


  type xmlf_t
    private
#ifdef DUMMYLIB
    integer :: i
#else
    type(xml_doc_state) :: xds
    integer                   :: lun = -1
    type(buffer_t)            :: buffer
    type(elstack_t)           :: stack
    type(dictionary_t)        :: dict
    integer                   :: state_1 = -1
    integer                   :: state_2 = -1
    integer                   :: state_3 = -1
    logical                   :: preserve_whitespace
    integer                   :: indent = 0
    character, pointer        :: name(:)
    type(namespaceDictionary) :: nsDict
#endif
  end type xmlf_t

  public :: xmlf_t

  public :: xml_OpenFile
  public :: xml_NewElement
  public :: xml_EndElement
  public :: xml_Close
  public :: xml_AddXMLDeclaration
  public :: xml_AddXMLStylesheet
  public :: xml_AddXMLPI
  public :: xml_AddComment
  public :: xml_AddCharacters
  public :: xml_AddNewline
  public :: xml_AddEntityReference
  public :: xml_AddAttribute
  public :: xml_AddPseudoAttribute
  public :: xml_DeclareNamespace
  public :: xml_UnDeclareNamespace
  public :: xml_AddDOCTYPE
  public :: xml_AddParameterEntity
  public :: xml_AddInternalEntity
  public :: xml_AddExternalEntity
  public :: xml_AddNotation
  public :: xml_AddElementToDTD
  public :: xml_AddAttlistToDTD
  public :: xml_AddPEreferenceToDTD

  public :: xmlf_Name
  public :: xmlf_OpenTag

  interface xml_AddCharacters
    module procedure xml_AddCharacters_Ch
  end interface
  interface xml_AddAttribute
    module procedure xml_AddAttribute_Ch
  end interface
  interface xml_AddPseudoAttribute
    module procedure xml_AddPseudoAttribute_Ch
  end interface
 
#ifndef DUMMYLIB
  !overload error handlers to allow file info
  interface wxml_warning
    module procedure wxml_warning_xf, FoX_warning_base
  end interface
  interface wxml_error
    module procedure wxml_error_xf, FoX_error_base
  end interface
  interface wxml_fatal
    module procedure wxml_fatal_xf, FoX_fatal_base
  end interface

  ! Heuristic (approximate) target for justification of output
  ! only gets used for outputting attributes
  integer, parameter  :: COLUMNS = 80

  ! TOHW - This is the longest string that may be output without
  ! a newline. The buffer must not be larger than this, but its size 
  ! can be tuned for performance.
  !lowest value found so far is 4096, for NAG. We use 1024 just in case.
  integer, parameter  :: xml_recl = 1024
#endif

contains

  subroutine xml_OpenFile(filename, xf, unit, iostat, preserve_whitespace, broken_indenting, replace, addDecl, warning, valid)
    character(len=*), intent(in)  :: filename
    type(xmlf_t), intent(inout)   :: xf
    integer, intent(in), optional :: unit
    integer, intent(out), optional :: iostat
    logical, intent(in), optional :: preserve_whitespace
    logical, intent(in), optional :: broken_indenting
    logical, intent(in), optional :: replace
    logical, intent(in), optional :: addDecl
    logical, intent(in), optional :: warning
    logical, intent(in), optional :: valid
    
#ifndef DUMMYLIB
    logical :: repl, decl
    integer :: iostat_

    if (xf%lun /= -1) &
      call wxml_fatal("Trying to reopen an already-open XML file")
    
    if (present(replace)) then
      repl = replace
    else
      repl = .true.
    endif
    if (present(addDecl)) then
      decl = addDecl
    else
      decl = .true.
    endif
    if (present(iostat)) iostat = 0

    allocate(xf%name(0))
    
    if (present(unit)) then
      if (unit==-1) then
        call get_unit(xf%lun,iostat_)
        if (iostat_ /= 0) then
          if (present(iostat)) iostat = iostat_
          return
        endif
      else
        xf%lun = unit
      endif
    else
      call get_unit(xf%lun,iostat_)
      if (iostat_ /= 0) then
        if (present(iostat)) iostat = iostat_
        return
      endif
    endif
    
    ! Use large I/O buffer in case the O.S./Compiler combination
    ! has hard-limits by default (i.e., NAGWare f95's 1024 byte limit)
    ! This is related to the maximum size of the buffer.
    ! TOHW - This is the longest string that may be output without
    ! a newline. The buffer must not be larger than this, but its size 
    ! can be tuned for performance.
    
    if (repl) then
      ! NAG insists on unnecessary duplication of iostat etc here
      if (present(iostat)) then
        open(unit=xf%lun, file=filename, form="formatted", status="replace", &
          action="write", recl=xml_recl, iostat=iostat)
      else	
        open(unit=xf%lun, file=filename, form="formatted", status="replace", &
          action="write", recl=xml_recl)
      endif
    else 
      if (present(iostat)) then
        open(unit=xf%lun, file=filename, form="formatted", status="new", &
          action="write", recl=xml_recl, iostat=iostat)
      else	
        open(unit=xf%lun, file=filename, form="formatted", status="new", &
          action="write", recl=xml_recl)
      endif
    endif

    call init_elstack(xf%stack)

    call init_dict(xf%dict)
    !NB it can make no difference which XML version we are using
    !until after we output the XML declaration. So we set it to
    !1.0 for the moment & reset below.
    ! Actually, this is done automatically in initializing xf%xds
    call init_xml_doc_state(xf%xds)
    xf%xds%documentURI => vs_str_alloc(filename)

    if (present(warning)) xf%xds%warning = warning
    if (present(valid)) xf%xds%valid = valid 
    
    xf%state_1 = WXML_STATE_1_JUST_OPENED
    xf%state_2 = WXML_STATE_2_OUTSIDE_TAG
    xf%state_3 = WXML_STATE_3_BEFORE_DTD
    
    if (present(preserve_whitespace)) then
      xf%preserve_whitespace = preserve_whitespace
    elseif (present(broken_indenting)) then
      xf%preserve_whitespace = .not.broken_indenting
    else
      xf%preserve_whitespace = .false.
    endif
      
    xf%indent = 0
    
    if (decl) then
      call xml_AddXMLDeclaration(xf,encoding='UTF-8')
      ! which will reset the buffer itself
    else
      call reset_buffer(xf%buffer, xf%lun, xf%xds%xml_version)
    endif
    
    call initNamespaceDictionary(xf%nsDict)
#endif
  end subroutine xml_OpenFile


  subroutine xml_AddXMLDeclaration(xf, version, encoding, standalone)
    type(xmlf_t), intent(inout)   :: xf
    character(len=*), intent(in), optional :: version
    character(len=*), intent(in), optional :: encoding
    logical, intent(in), optional :: standalone

#ifndef DUMMYLIB
    call check_xf(xf)
    ! Don't need to call checkChars on args, everything is checked
    ! fully below anyway.
    
    if (xf%state_1 /= WXML_STATE_1_JUST_OPENED) &
      call wxml_error("Tried to put XML declaration in wrong place")
    
    call reset_buffer(xf%buffer, xf%lun, xf%xds%xml_version)
    
    call xml_AddXMLPI(xf, "xml", xml=.true.)
    if (present(version)) then
      if (version =="1.0") then
        xf%xds%xml_version = XML1_0
        call xml_AddPseudoAttribute(xf, "version", version)
      elseif (version=="1.1") then
        xf%xds%xml_version = XML1_1
        call xml_AddPseudoAttribute(xf, "version", version)
      else
        call wxml_error("Invalid XML version.")
      endif
    else
      call xml_AddPseudoAttribute(xf, "version", "1.0")
      xf%xds%xml_version = XML1_0
    endif
    if (present(encoding)) then
      if (.not.checkEncName(encoding)) &
        call wxml_error("Invalid encoding name: "//encoding)
      if (encoding /= 'UTF-8' .and. encoding /= 'utf-8') &
        call wxml_warning(xf, "Non-default encoding specified: "//encoding)
      call xml_AddPseudoAttribute(xf, "encoding", encoding)
    endif
    if (present(standalone)) then
      xf%xds%standalone_declared = .true.
      xf%xds%standalone = standalone
      if (standalone) then
        call xml_AddPseudoAttribute(xf, "standalone", "yes")
      else
        call xml_AddPseudoAttribute(xf, "standalone", "no")
      endif
    endif
    call close_start_tag(xf)
    ! We have to close explicitly here to ensure nothing gets tied
    ! up in the XML declaration
    xf%state_1 = WXML_STATE_1_BEFORE_ROOT
#endif
  end subroutine xml_AddXMLDeclaration


  subroutine xml_AddDOCTYPE(xf, name, system, public)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    character(len=*), intent(in), optional :: system, public
#ifndef DUMMYLIB
    call check_xf(xf)
    if (.not.checkChars(name,xf%xds%xml_version)) call wxml_error("xml_AddDOCTYPE: Invalid character in name")
    if (present(system)) then
      if (.not.checkChars(system,xf%xds%xml_version)) call wxml_error("xml_AddDOCTYPE: Invalid character in system")
    endif
    if (present(public)) then
      if (.not.checkChars(public,xf%xds%xml_version)) call wxml_error("xml_AddDOCTYPE: Invalid character in public")
    endif
    
    if (present(public).and..not.present(system)) &
      call wxml_error('xml_AddDOCTYPE: PUBLIC supplied without SYSTEM for: '//name)

    ! By having an external ID we render this non-standalone (unless we've said that it is in the declaration)
    if (present(system).and..not.xf%xds%standalone_declared) &
      xf%xds%standalone=.false.

    call close_start_tag(xf)
    
    if (xf%state_1 /= WXML_STATE_1_BEFORE_ROOT) &
      call wxml_error("Tried to put XML DOCTYPE in wrong place: "//name)

    if (xf%state_3 /= WXML_STATE_3_BEFORE_DTD) then
      call wxml_error("Tried to output more than one DOCTYPE declaration: "//name)
    else
      xf%state_3 = WXML_STATE_3_DURING_DTD
    endif

    if (.not.checkName(name, xf%xds)) &
         call wxml_error("Invalid Name in DTD "//name)
    
    call add_eol(xf)
    call add_to_buffer("<!DOCTYPE "//name, xf%buffer, .false.)

    deallocate(xf%name)
    allocate(xf%name(len(name)))
    xf%name = vs_str(name)

    if (present(system)) then
      if (present(public)) then
        if (.not.checkPublicId(public)) &
          call wxml_error("Invalid PUBLIC ID "//public)
        call add_to_buffer(' PUBLIC', xf%buffer, .false.)
        call add_to_buffer(' "'//public//'"', xf%buffer, .true.)
      else
        call add_to_buffer(' SYSTEM', xf%buffer, .false.)
      endif
      if (scan(system, "'")/=0) then
        if (scan(system, '"')/=0) &
          call wxml_error("Invalid SYSTEM ID "//system)
        call add_to_buffer(' "'//system//'"', xf%buffer, .true.)
      else
        call add_to_buffer(" '"//system//"'", xf%buffer, .true.)
      endif
    endif
#endif
  end subroutine xml_AddDOCTYPE


  subroutine xml_AddParameterEntity(xf, name, PEdef, system, public)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    character(len=*), intent(in), optional :: PEDef
    character(len=*), intent(in), optional :: system
    character(len=*), intent(in), optional :: public
#ifndef DUMMYLIB
    call check_xf(xf)
    if (.not.checkChars(name,xf%xds%xml_version)) call wxml_error("xml_AddParameterEntity: Invalid character in name")
    if (present(PEDef)) then
      if (.not.checkChars(PEDef,xf%xds%xml_version)) call wxml_error("xml_AddParameterEntity: Invalid character in PEDef")
    endif
    if (present(system)) then
      if (.not.checkChars(system,xf%xds%xml_version)) call wxml_error("xml_AddParameterEntity: Invalid character in system")
    endif
    if (present(public)) then
      if (.not.checkChars(public,xf%xds%xml_version)) call wxml_error("xml_AddParameterEntity: Invalid character in public")
    endif
    
    ! By adding a parameter entity (internal or external) we make this
    ! a non-standalone document.
    if (.not.xf%xds%standalone_declared) &
      xf%xds%standalone = .false.

    if (xf%state_3 == WXML_STATE_3_DURING_DTD) then
      call add_to_buffer(" [", xf%buffer, .false.)
      xf%state_3 = WXML_STATE_3_INSIDE_INTSUBSET
    endif

    if (xf%state_3 /= WXML_STATE_3_INSIDE_INTSUBSET) &
      call wxml_fatal("Cannot define Parameter Entity here: "//name)
      
    if (xf%state_2 == WXML_STATE_2_INSIDE_PI) then
      call close_start_tag(xf)
      xf%state_2 = WXML_STATE_2_OUTSIDE_TAG
    endif

    if (present(PEdef)) then
      if (present(system) .or. present(public)) &
        call wxml_fatal("Parameter entity "//name//" cannot have both a PEdef and an External ID")
    else
      if (.not.present(system)) &
        call wxml_fatal("Parameter entity "//name//" must have either a PEdef or an External ID")
    endif
    if (present(PEdef)) then
      if (.not.checkPEDef(PEDef, xf%xds)) &
        call wxml_fatal("Parameter entity definition is invalid: "//PEDef)
      if (xf%xds%standalone) then
        if (.not.checkExistingRefs()) &
          call wxml_error("Tried to reference unregistered parameter entity")
      else
        if (.not.checkExistingRefs()) &
          call wxml_warning(xf, "Reference to unknown parameter entity")
      endif
      call register_internal_PE(xf%xds, name, PEdef)
    else
      if (.not.checkSystemID(system)) &
        call wxml_fatal("Parameter entity System ID is invalid: "//system)
      if (present(public)) then
        if (.not.checkPublicID(public)) &
          call wxml_fatal("Parameter entity Public ID is invalid: "//public)
      endif
      call register_external_PE(xf%xds, name, system, public)
    endif

    call add_eol(xf)

    call add_to_buffer('<!ENTITY % '//name, xf%buffer, .false.) ! name can never contain whitespace
    if (present(PEdef)) then
      if (index(PEdef, '"') > 0) then
        call add_to_buffer(" '"//PEdef//"'", xf%buffer, .true.)
      else
        call add_to_buffer(' "'//PEdef//'"', xf%buffer, .true.)
      endif
        call add_to_buffer('>', xf%buffer, .false.)
    else
      if (present(public)) then
        call add_to_buffer(' PUBLIC', xf%buffer, .false.)
        call add_to_buffer(' "'//public//'"', xf%buffer, .true.)
      else
        call add_to_buffer(' SYSTEM', xf%buffer, .false.)
      endif
      if (scan(system, "'")/=0) then
        if (scan(system, '"')/=0) &
          call wxml_error("Invalid SYSTEM ID "//system)
        call add_to_buffer(' "'//system//'"', xf%buffer, .true.)
      else
        call add_to_buffer(" '"//system//"'", xf%buffer, .true.)
      endif
      call add_to_buffer(">", xf%buffer)
    endif

  contains
    function checkExistingRefs() result(p)
      logical :: p
      
      integer :: i1, i2
      
      ! Here we assume we have syntactic well-formedness as
      ! checked by checkPEDef.
      
      p = .false.
      i1 = index(PEDef, '%')
      i2 = 0 
      do while (i1 > 0)
        i1 = i2 + i1
        i2 = index(PEDef(i1+1:),';')
        if (i2 == 0) return
        i2 = i1 + i2
        if (.not.existing_entity(xf%xds%PEList, PEDef(i1+1:i2-1))) &
          return
        i1 = index(PEDef(i2+1:), '%')
      enddo
      p = .true.
      
    end function checkExistingRefs
#endif
  end subroutine xml_AddParameterEntity


  subroutine xml_AddInternalEntity(xf, name, value)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: value

#ifndef DUMMYLIB
    call check_xf(xf)
    if (.not.checkChars(name,xf%xds%xml_version)) call wxml_error("xml_AddInternalEntity: Invalid character in name")
    if (.not.checkChars(value,xf%xds%xml_version)) call wxml_error("xml_AddInternalEntity: Invalid character in value")
    
    if (xf%state_3 == WXML_STATE_3_DURING_DTD) then
      call add_to_buffer(" [", xf%buffer)
      xf%state_3 = WXML_STATE_3_INSIDE_INTSUBSET
    endif

    if (xf%state_3 /= WXML_STATE_3_INSIDE_INTSUBSET) &
      call wxml_fatal("Cannot define Entity here: "//name)
      
    if (xf%state_2 == WXML_STATE_2_INSIDE_PI) then
      call close_start_tag(xf)
      xf%state_2 = WXML_STATE_2_OUTSIDE_TAG
    endif

    if (.not.checkName(name, xf%xds)) &
      call wxml_error("xml_AddInternalEntity: Invalid Name: "//name)
    call register_internal_GE(xf%xds, name, value)

    call add_eol(xf)
    
    !FIXME - valid entity values?
    call add_to_buffer('<!ENTITY '//name//' ', xf%buffer, .false.) ! name cannot contain whitespace
    if (index(value, '"') > 0) then
      call add_to_buffer("'"//value//"'>", xf%buffer, .true.)
    else
      call add_to_buffer('"'//value//'">', xf%buffer, .true.)
    endif
#endif
  end subroutine xml_AddInternalEntity


  subroutine xml_AddExternalEntity(xf, name, system, public, notation)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: system
    character(len=*), intent(in), optional :: public
    character(len=*), intent(in), optional :: notation

#ifndef DUMMYLIB
    call check_xf(xf)
    if (.not.checkChars(name,xf%xds%xml_version)) call wxml_error("xml_AddExternalEntity: Invalid character in name")
    if (.not.checkChars(system,xf%xds%xml_version)) call wxml_error("xml_AddExternalEntity: Invalid character in system")
    if (present(public)) then
      if (.not.checkChars(public,xf%xds%xml_version)) call wxml_error("xml_AddExternalEntity: Invalid character in public")
    endif
    if (present(notation)) then
      if (.not.checkChars(notation,xf%xds%xml_version)) call wxml_error("xml_AddExternalEntity: Invalid character in notation")
    endif
    
    if (xf%state_3 == WXML_STATE_3_DURING_DTD) then
      call add_to_buffer(" [", xf%buffer, .false.)
      xf%state_3 = WXML_STATE_3_INSIDE_INTSUBSET
    endif

    if (xf%state_3 /= WXML_STATE_3_INSIDE_INTSUBSET) &
      call wxml_fatal("Cannot define Entity here: "//name)

    if (xf%state_2 == WXML_STATE_2_INSIDE_PI) then
      call close_start_tag(xf)
      xf%state_2 = WXML_STATE_2_OUTSIDE_TAG
    endif

    if (present(notation)) then
      if (.not.notation_exists(xf%xds%nList, notation)) then
        if (.not.xf%xds%standalone) then
          call wxml_warning(xf, "Tried to add possibly unregistered notation to entity: "//name)
          if (.not.checkName(notation, xf%xds)) &
            call wxml_error("xml_AddExternalEntity: Invalid notation "//notation)
        else
          call wxml_error("Tried to add non-existent notation to entity: "//name)
        endif
      endif
    endif
  
    if (.not.checkName(name, xf%xds)) &
      call wxml_error("xml_AddExternalEntity: Invalid Name: "//name)
    if (.not.checkSystemID(system)) &
      call wxml_error("xml_AddExternalEntity: Invalid System: "//system)
    if (present(public)) then
      if (.not.checkPublicID(public)) &
        call wxml_error("xml_AddExternalEntity: Invalid Public: "//public)
    endif
    ! Notation only needs checked if not already registered - done above.
    call register_external_GE(xf%xds, name, system, public, notation)
    
    call add_eol(xf)
    
    call add_to_buffer('<!ENTITY '//name, xf%buffer, .false.)
    if (present(public)) then
      call add_to_buffer(" PUBLIC", xf%buffer, .false.)
      call add_to_buffer(' "'//public//'"', xf%buffer, .true.)
    else
      call add_to_buffer(' SYSTEM', xf%buffer, .false.)
    endif
    if (scan(system, "'")/=0) then
      if (scan(system, '"')/=0) &
        call wxml_error("Invalid SYSTEM ID "//system)
      call add_to_buffer(' "'//system//'"', xf%buffer, .true.)
    else
      call add_to_buffer(" '"//system//"'", xf%buffer, .true.)
    endif
    if (present(notation)) then
      ! FIXME Has notation been declared yet?
      call add_to_buffer(' NDATA '//notation, xf%buffer, .false.) ! notation cannot contain whitespace
    endif
    call add_to_buffer('>', xf%buffer, .false.)
#endif
  end subroutine xml_AddExternalEntity


  subroutine xml_AddNotation(xf, name, system, public)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    character(len=*), intent(in), optional :: system
    character(len=*), intent(in), optional :: public

#ifndef DUMMYLIB
    call check_xf(xf)
    if (.not.checkChars(name,xf%xds%xml_version)) call wxml_error("xml_AddNotation: Invalid character in name")
    if (present(system)) then
      if (.not.checkChars(system,xf%xds%xml_version)) call wxml_error("xml_AddNotation: Invalid character in system")
    endif
    if (present(public)) then
      if (.not.checkChars(public,xf%xds%xml_version)) call wxml_error("xml_AddNotation: Invalid character in public")
    endif
    
    if (xf%state_3 == WXML_STATE_3_DURING_DTD) then
      call add_to_buffer(" [", xf%buffer, .false.)
      xf%state_3 = WXML_STATE_3_INSIDE_INTSUBSET
    endif

    if (xf%state_3 /= WXML_STATE_3_INSIDE_INTSUBSET) &
      call wxml_fatal("Cannot define Notation here: "//name)
    
    if (xf%state_2 == WXML_STATE_2_INSIDE_PI) then
      call close_start_tag(xf)
      xf%state_2 = WXML_STATE_2_OUTSIDE_TAG
    endif

    if (notation_exists(xf%xds%nList, name)) &
      call wxml_error("Tried to create duplicate notation: "//name)
    
    call add_eol(xf)

    if (.not.checkName(name, xf%xds)) &
      call wxml_error("Notation name is illegal in xml_AddNotation: "//name)
    if (present(system)) then
      if (.not.checkSystemId(system)) &
        call wxml_error("System ID name is illegal in xml_AddNotation: "//system)
    endif
    if (present(public)) then
      if (.not.checkPublicId(public)) &
        call wxml_error("Public ID name is illegal in xml_AddNotation: "//public)
    endif
    
    call add_notation(xf%xds%nList, name, system, public)
    call add_to_buffer('<!NOTATION '//name, xf%buffer, .false.)
    if (present(public)) then
      call add_to_buffer(" PUBLIC", xf%buffer, .false.)
      call add_to_buffer(' "'//public//'"', xf%buffer, .true.)
    elseif (present(system)) then
      call add_to_buffer(' SYSTEM', xf%buffer, .false.)
    endif
    if (present(system)) then
      if (index(system, '"') > 0) then
        call add_to_buffer(' "'//system//'"', xf%buffer, .true.)
      else
        call add_to_buffer(" '"//system//"'", xf%buffer, .true.)
      endif
    endif
    call add_to_buffer('>', xf%buffer, .false.)
#endif
  end subroutine xml_AddNotation


  subroutine xml_AddElementToDTD(xf, name, declaration)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: declaration

#ifndef DUMMYLIB
    call check_xf(xf)
    if (.not.checkChars(name,xf%xds%xml_version)) call wxml_error("xml_AddElementToDTD: Invalid character in name")
    if (.not.checkChars(declaration,xf%xds%xml_version)) call wxml_error("xml_AddElementToDTD: Invalid character in declaration")

    if (.not.checkName(name, xf%xds)) &
      call wxml_error("Element name is illegal in xml_AddElementToDTD: "//name)

    !FIXME we should check declaration syntax too.
    call wxml_warning(xf, "Adding ELEMENT declaration to DTD. Cannot guarantee well-formedness")
    
    if (xf%state_3 == WXML_STATE_3_DURING_DTD) then
      call add_to_buffer(" [", xf%buffer, .false.)
      xf%state_3 = WXML_STATE_3_INSIDE_INTSUBSET
    endif

    if (xf%state_3 /= WXML_STATE_3_INSIDE_INTSUBSET) &
      call wxml_fatal("Cannot write to DTD here: xml_AddElementToDTD")

    if (xf%state_2 == WXML_STATE_2_INSIDE_PI) then
      call close_start_tag(xf)
      xf%state_2 = WXML_STATE_2_OUTSIDE_TAG
    endif

    call add_eol(xf)
    call add_to_buffer('<!ELEMENT '//name//' '//declaration//'>', xf%buffer, .false.)
#endif
  end subroutine xml_AddElementToDTD


  subroutine xml_AddAttlistToDTD(xf, name, declaration)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: declaration

#ifndef DUMMYLIB
    call check_xf(xf)
    if (.not.checkChars(name,xf%xds%xml_version)) call wxml_error("xml_AddAttListToDTD: Invalid character in name")
    if (.not.checkChars(declaration,xf%xds%xml_version)) call wxml_error("xml_AddAttListToDTD: Invalid character in declaration")

    if (.not.checkName(name, xf%xds)) &
      call wxml_error("Attlist name is illegal in xml_AddAttlistToDTD: "//name)

    !FIXME we should check declaration syntax too.
    call wxml_warning(xf, "Adding ATTLIST declaration to DTD. Cannot guarantee well-formedness")
    
    if (xf%state_3 == WXML_STATE_3_DURING_DTD) then
      call add_to_buffer(" [", xf%buffer, .false.)
      xf%state_3 = WXML_STATE_3_INSIDE_INTSUBSET
    endif

    if (xf%state_3 /= WXML_STATE_3_INSIDE_INTSUBSET) &
      call wxml_fatal("Cannot write to DTD here: xml_AddAttlistToDTD")

    if (xf%state_2 == WXML_STATE_2_INSIDE_PI) then
      call close_start_tag(xf)
      xf%state_2 = WXML_STATE_2_OUTSIDE_TAG
    endif

    call add_eol(xf)
    call add_to_buffer('<!ATTLIST '//name//' '//declaration//'>', xf%buffer, .false.)
#endif
  end subroutine xml_AddAttlistToDTD
    

  subroutine xml_AddPEReferenceToDTD(xf, name)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name

#ifndef DUMMYLIB
    call check_xf(xf)
    if (.not.checkChars(name,xf%xds%xml_version)) call wxml_error("xml_AddPEReferenceToDTD: Invalid character in name")

    if (.not.checkName(name, xf%xds)) &
      call wxml_error("Trying to add illegal name in xml_AddPEReferenceToDTD: "//name)

    call wxml_warning(xf, "Adding PEReference to DTD. Cannot guarantee well-formedness")
    if (.not.existing_entity(xf%xds%PEList, name)) then
      if (.not.xf%xds%standalone) then
        call wxml_warning(xf, "Tried to reference possibly unregistered parameter entity in DTD: "//name)
      else
        call wxml_error("Tried to reference unregistered parameter entity in DTD "//name)
      endif
    else
      if (is_unparsed_entity(xf%xds%PEList, name)) &
        call wxml_error("Tried to reference unparsed parameter entity in DTD "//name)
    endif
    
    if (xf%state_3 == WXML_STATE_3_DURING_DTD) then
      call add_to_buffer(" [", xf%buffer, .false.)
      xf%state_3 = WXML_STATE_3_INSIDE_INTSUBSET
    endif

    if (xf%state_3 /= WXML_STATE_3_INSIDE_INTSUBSET) &
      call wxml_fatal("Cannot write to DTD here: xml_AddPEReferenceToDTD")

    if (xf%state_2 == WXML_STATE_2_INSIDE_PI) then
      call close_start_tag(xf)
      xf%state_2 = WXML_STATE_2_OUTSIDE_TAG
    endif

    call add_eol(xf)
    call add_to_buffer('%'//name//';', xf%buffer, .false.)

#endif
  end subroutine xml_AddPEReferenceToDTD


  subroutine xml_AddXMLStylesheet(xf, href, type, title, media, charset, alternate)
    type(xmlf_t), intent(inout)   :: xf
    character(len=*), intent(in) :: href
    character(len=*), intent(in) :: type
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: media
    character(len=*), intent(in), optional :: charset
    logical,          intent(in), optional :: alternate

#ifndef DUMMYLIB
    call check_xf(xf)
    ! Don't bother doing checkChars - all pseudoatts get checked anyway.
    
    if (xf%state_1 /= WXML_STATE_1_JUST_OPENED &
         .and. xf%state_1 /= WXML_STATE_1_BEFORE_ROOT) &
      call wxml_error("Cannot add stylesheet here: "//href)

    call close_start_tag(xf)
    
    call xml_AddXMLPI(xf, 'xml-stylesheet', xml=.true.)
    call xml_AddPseudoAttribute(xf, 'href', href)
    call xml_AddPseudoAttribute(xf, 'type', type)
    
    if (present(title)) call xml_AddPseudoAttribute(xf, 'title', title)
    if (present(media)) call xml_AddPseudoAttribute(xf, 'media', media)
    if (present(charset)) call xml_AddPseudoAttribute(xf, 'charset', charset)
    if (present(alternate)) then
      if (alternate) then
        call xml_AddPseudoAttribute(xf, 'alternate', 'yes')
      else
        call xml_AddPseudoAttribute(xf, 'alternate', 'no')
      endif
    endif
    if (xf%state_1 == WXML_STATE_1_JUST_OPENED) &
         xf%state_1 = WXML_STATE_1_BEFORE_ROOT 
    xf%state_2 = WXML_STATE_2_INSIDE_PI
#endif
  end subroutine xml_AddXMLStylesheet
  

  subroutine xml_AddXMLPI(xf, name, data, xml, ws_significant)
    type(xmlf_t), intent(inout)            :: xf
    character(len=*), intent(in)           :: name
    character(len=*), intent(in), optional :: data
    logical, intent(in), optional :: xml
    logical, intent(in), optional :: ws_significant

#ifndef DUMMYLIB
    call check_xf(xf)
    if (.not.checkChars(name,xf%xds%xml_version)) call wxml_error("xml_AddXMLPI: Invalid character in name")
    if (present(data)) then
      if (.not.checkChars(data,xf%xds%xml_version)) call wxml_error("xml_AddXMLPI: Invalid character in data")
    endif
    
    select case (xf%state_1)
    case (WXML_STATE_1_JUST_OPENED) 
      xf%state_1 = WXML_STATE_1_BEFORE_ROOT
    case default
      call close_start_tag(xf)
      call add_eol(xf)
    end select

    if (present(xml)) then
      if (.not.checkName(name, xf%xds)) &
        call wxml_error(xf, "Invalid PI Target "//name)
    else
      if (.not.checkPITarget(name, xf%xds)) &
        call wxml_error(xf, "Invalid PI Target "//name)
    endif
    call add_to_buffer("<?" // name, xf%buffer, .false.)
    if (present(data)) then
      if (index(data, '?>') > 0) &
           call wxml_error(xf, "Tried to output invalid PI data "//data)
      call add_to_buffer(' ', xf%buffer, .false.)
      call add_to_buffer(data//'?>', xf%buffer, ws_significant)
      ! state_2 is now OUTSIDE_TAG from close_start_tag
    else
      xf%state_2 = WXML_STATE_2_INSIDE_PI
      call reset_dict(xf%dict)
    endif
#endif
  end subroutine xml_AddXMLPI


  subroutine xml_AddComment(xf, comment, ws_significant)
    type(xmlf_t), intent(inout)   :: xf
    character(len=*), intent(in)  :: comment
    logical, intent(in), optional :: ws_significant

#ifndef DUMMYLIB
    call check_xf(xf)
    if (.not.checkChars(comment,xf%xds%xml_version)) call wxml_error("xml_AddComment: Invalid character in comment")
    
    select case (xf%state_1)
    case (WXML_STATE_1_JUST_OPENED) 
      xf%state_1 = WXML_STATE_1_BEFORE_ROOT
    case (WXML_STATE_1_BEFORE_ROOT)
      call close_start_tag(xf)
      call add_eol(xf)
    case (WXML_STATE_1_DURING_ROOT)
      call close_start_tag(xf)
      if (.not.xf%preserve_whitespace.and.xf%state_2 == WXML_STATE_2_OUTSIDE_TAG) call add_eol(xf)
    case (WXML_STATE_1_AFTER_ROOT)
      call close_start_tag(xf)
      call add_eol(xf)
    end select

    if (index(comment,'--') > 0 .or. comment(len(comment):) == '-') &
         call wxml_error("Tried to output invalid comment "//comment)

    call add_to_buffer("<!--", xf%buffer, .false.)
    call add_to_buffer(comment, xf%buffer, ws_significant)
    call add_to_buffer("-->", xf%buffer, .false.)
#endif
  end subroutine xml_AddComment


  subroutine xml_NewElement(xf, name)
    type(xmlf_t), intent(inout)   :: xf
    character(len=*), intent(in)  :: name

#ifndef DUMMYLIB
    call check_xf(xf)
    if (.not.checkChars(name,xf%xds%xml_version)) call wxml_error("xml_NewElement: Invalid character in name")
    
    select case (xf%state_1)
    case (WXML_STATE_1_JUST_OPENED, WXML_STATE_1_BEFORE_ROOT)
      if (size(xf%name) > 0) then
        if (str_vs(xf%name) /= name) & 
          call wxml_error(xf, "Root element name does not match DTD: "//name)
      endif
      call close_start_tag(xf)
      if (xf%state_3 /= WXML_STATE_3_BEFORE_DTD) then
        select case (xf%state_3)
        case (WXML_STATE_3_DURING_DTD)
          call add_to_buffer('>', xf%buffer, .false.)
          xf%state_3 = WXML_STATE_3_AFTER_DTD
        case (WXML_STATE_3_INSIDE_INTSUBSET)
          xf%state_3 = WXML_STATE_3_AFTER_DTD
          call add_eol(xf)
          call add_to_buffer(']>', xf%buffer, .false.)
        end select
      endif
      call add_eol(xf)
    case (WXML_STATE_1_DURING_ROOT)
      call close_start_tag(xf)
      if (.not.xf%preserve_whitespace.and.xf%state_2 == WXML_STATE_2_OUTSIDE_TAG) call add_eol(xf)
    case (WXML_STATE_1_AFTER_ROOT)
      call wxml_error(xf, "Two root elements: "//name)
    end select
    
    if (.not.checkQName(name, xf%xds)) then
      call wxml_error(xf, 'Element name '//name//' is not valid')
    endif

    if (len(prefixOfQName(name)) > 0) then
      if (.not.isPrefixInForce(xf%nsDict, prefixOfQName(name))) &
        call wxml_error(xf, "Namespace prefix not registered: "//prefixOfQName(name))
    endif
    
    call push_elstack(name,xf%stack)
    call add_to_buffer("<"//name, xf%buffer, .false.)
    xf%state_2 = WXML_STATE_2_INSIDE_ELEMENT
    call reset_dict(xf%dict)
    xf%indent = xf%indent + indent_inc
    xf%state_1 = WXML_STATE_1_DURING_ROOT
#endif
  end subroutine xml_NewElement
  

  subroutine xml_AddCharacters_ch(xf, chars, parsed, ws_significant)
    type(xmlf_t), intent(inout)   :: xf
    character(len=*), intent(in)  :: chars
    logical, intent(in), optional :: parsed
    logical, intent(in), optional :: ws_significant

#ifndef DUMMYLIB
    logical :: pc

    call check_xf(xf)
    if (.not.checkChars(chars, xf%xds%xml_version)) call wxml_error("xml_AddCharacters: Invalid character in chars")
    
    if (xf%state_1 /= WXML_STATE_1_DURING_ROOT) &
         call wxml_fatal("Tried to add text section in wrong place: "//chars)
    
    if (present(parsed)) then
      pc = parsed
    else
      pc = .true.
    endif
    
    call close_start_tag(xf)

    if (pc) then
      call add_to_buffer(escape_string(chars, xf%xds%xml_version), xf%buffer, ws_significant)
    else
      if (index(chars,']]>') > 0) &
           call wxml_fatal("Tried to output invalid CDATA: "//chars)
      call add_to_buffer("<![CDATA["//chars//"]]>", xf%buffer, ws_significant)
    endif
    
    xf%state_2 = WXML_STATE_2_IN_CHARDATA
#endif
  end subroutine xml_AddCharacters_Ch


  subroutine xml_AddNewline(xf)
    type(xmlf_t), intent(inout) :: xf

#ifndef DUMMYLIB
    call xml_AddCharacters(xf, "") ! FIXME Does this line do anything?
    call add_eol(xf)
#endif
  end subroutine xml_AddNewline

  
  subroutine xml_AddEntityReference(xf, entityref)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: entityref

#ifndef DUMMYLIB
    call check_xf(xf)
    if (.not.checkChars(entityref, xf%xds%xml_version)) call wxml_error("xml_AddEntityReference: Invalid character in entityref")
    
    !Where can we add this? If we allow the full gamut
    !of entities, we can no longer properly ensure
    !well-formed output, unless we tie the sax parser
    !in as well ...

    call close_start_tag(xf)

    if (xf%state_2 /= WXML_STATE_2_OUTSIDE_TAG .and. &
      xf%state_2 /= WXML_STATE_2_IN_CHARDATA)         &
      call wxml_fatal("Tried to add entity reference in wrong place: "//entityref)

    if (.not.checkCharacterEntityReference(entityref, xf%xds%xml_version)) then
      !it's not just a unicode entity
      call wxml_warning(xf, "Entity reference added - document may not be well-formed")
      if (.not.existing_entity(xf%xds%entityList, entityref)) then
        if (xf%xds%standalone) then
          call wxml_error("Tried to reference unregistered entity")
        else
          call wxml_warning(xf, "Tried to reference unregistered entity")
        endif
      else
        if (is_unparsed_entity(xf%xds%entityList, entityref)) &
          call wxml_error("Tried to reference unparsed entity")
      endif
    endif

    call add_to_buffer('&'//entityref//';', xf%buffer, .false.)
    xf%state_2 = WXML_STATE_2_IN_CHARDATA
#endif
  end subroutine xml_AddEntityReference


  subroutine xml_AddAttribute_Ch(xf, name, value, escape, type, ws_significant)
    type(xmlf_t), intent(inout)             :: xf
    character(len=*), intent(in)            :: name
    character(len=*), intent(in)            :: value
    logical, intent(in), optional           :: escape
    character(len=*), intent(in), optional  :: type
    logical, intent(in), optional           :: ws_significant

#ifndef DUMMYLIB
    logical :: esc
    character, pointer :: type_(:)

    ! if (name=="xml:space") then
    ! The value can only be "default" or "preserve", by 2.10
    ! However, that value can be obscured behind entities,
    ! and we can't check that without full entity expansion
    ! available to the output processor.
    ! FIXME check when we have the ability

    if (present(type)) then
      if (type/='CDATA'.and.type/='ID'.and.type/='IDREF'.and.type/='IDREFS'.and.type/='NMTOKEN'.and.type/='NMTOKENS' &
        .and.type/='ENTITY'.and.type/='ENTITIES'.and.type/='NOTATION') then
        call wxml_fatal("Invalid type in xml_AddAttribute: "//type)
      endif
      type_ => vs_str_alloc(type)
    else
      ! We assume CDATA, but need to worry about whether the caller cares about whitespace ...
      if (present(ws_significant)) then
        if (ws_significant) then
          type_ => vs_str_alloc('CDATA')
        else
          type_ => vs_str_alloc('CDANO') ! CDAta, whitespace Not significant
        endif
      else
        type_ => vs_str_alloc('CDAMB')   ! CDAta, whitespace MayBe significant
      endif
    endif

    call check_xf(xf)
    if (.not.checkChars(name, xf%xds%xml_version)) call wxml_error("xml_AddAttribute: Invalid character in name")
    if (.not.checkChars(value, xf%xds%xml_version)) call wxml_error("xml_AddAttribute: Invalid character in value")
    
    if (present(escape)) then
      esc = escape
    else
      esc = .true.
    endif

    ! FIXME when escape is false we should still verify somehow.
    ! minimal check: only extra allowed is character entity references.
    ! We check they exist, and are not unparsed.
    ! Ideally we would fully expand all entity references (at least for
    ! a standalone document where we can) and then
    ! match the resultant production against [XML]-3.3.1. This is
    ! initially too much work though, so we just check simple
    ! syntactic constraint.

    if (.not.esc) then
      if (.not.checkAttValue(value, xf%xds)) &
        call wxml_error(xf, "Invalid attribute value: "//value)
      if (index(value, '&') > 0) then
        ! There are entity references
        ! They should exist (unless we are not standalone) and they must not be unparsed.
        if (.not.checkExistingRefsInAttValue()) then
          if (xf%xds%standalone) then
            call wxml_error(xf, "outputting unknown entity. Cannot guarantee validity.")
          else
            call wxml_warning(xf, "Warning: outputting unknown entity. Cannot guarantee validity.")
          endif
        endif
        if (.not.checkParsedRefsInAttValue()) &
          call wxml_error(xf, "Warning: outputting unknown entity. Cannot guarantee validity.")
      endif
    endif

    if (xf%state_2 /= WXML_STATE_2_INSIDE_ELEMENT) &
         call wxml_error(xf, "attributes outside element content: "//name)

    if (hasKey(xf%dict,name)) then
      call wxml_error(xf, "duplicate att name: "//name)
    elseif (hasKey(xf%dict, &
      getnamespaceURI(xf%nsDict,prefixOfQname(name)), localpartofQname(name))) then
      call wxml_error(xf, "duplicate att after namespace processing: "//name)
    endif

    if (.not.checkQName(name, xf%xds)) &
         call wxml_error(xf, "invalid attribute name: "//name)

    if (len(prefixOfQName(name))>0) then
      if (prefixOfQName(name)/="xml".and.prefixOfQName(name)/="xmlns") then
        if (.not.isPrefixInForce(xf%nsDict, prefixOfQName(name))) &
          call wxml_error(xf, "namespace prefix not registered: "//prefixOfQName(name))
      endif
      if (esc) then
        call add_item_to_dict(xf%dict, localpartofQname(name), escape_string(value, xf%xds%xml_version), prefixOfQName(name), &
          getnamespaceURI(xf%nsDict,prefixOfQname(name)), type=str_vs(type_))
      else
        call add_item_to_dict(xf%dict, localpartofQname(name), value, prefixOfQName(name), &
          getnamespaceURI(xf%nsDict,prefixOfQName(name)), type=str_vs(type_))
      endif

    else
      if (esc) then
        call add_item_to_dict(xf%dict, name, escape_string(value, xf%xds%xml_version), type=str_vs(type_))
      else
        call add_item_to_dict(xf%dict, name, value, type=str_vs(type_))
      endif
    endif

    !FIXME need to deallocate this when we move to better error handling
    deallocate(type_)

  contains
    function checkExistingRefsInAttValue() result(p)
      logical :: p
      
      integer :: i1, i2
      
      ! Here we assume we have syntactic well-formedness as
      ! checked by checkAttValue.
      ! We also assume we do not have simply one entity as
      ! the contents - that is checked by checkAttValueEntity
      
      p = .false.
      i1 = index(value, '&')
      i2 = 0 
      do while (i1 > 0)
        i1 = i2 + i1
        i2 = index(value(i1+1:),';')
        if (i2 == 0) return
        i2 = i1 + i2
        if (.not.existing_entity(xf%xds%entityList, value(i1+1:i2-1)) .and. &
          .not.checkCharacterEntityReference(value(i1+1:i2-1), xf%xds%xml_version)) &
          return
        i1 = index(value(i2+1:), '&')
      enddo
      p = .true.
      
    end function checkExistingRefsInAttValue
    
    function checkParsedRefsInAttValue() result(p)
      logical :: p
      
      integer :: i1, i2
      
      ! Here we assume we have syntactic well-formedness as
      ! checked by checkAttValue.
      
      p = .false.
      i1 = index(value, '&')
      i2 = 0
      do while (i1 > 0)
        i1 = i1 + i2
        i2 = index(value(i1+1:),';')
        if (i2 == 0) return
        i2  = i1 + i2
        if (is_unparsed_entity(xf%xds%entityList, value(i1+1:i2-1))) &
          return
        i1 = index(value(i2+1:), '&')
      enddo
      p = .true.

    end function checkParsedRefsInAttValue
#endif
  end subroutine xml_AddAttribute_Ch


  subroutine xml_AddPseudoAttribute_Ch(xf, name, value, escape, ws_significant)
    type(xmlf_t), intent(inout)   :: xf
    character(len=*), intent(in)  :: name
    character(len=*), intent(in)  :: value
    logical, intent(in), optional :: escape
    logical, intent(in), optional :: ws_significant

#ifndef DUMMYLIB
    logical :: esc
    character(len=5) :: type

    call check_xf(xf)
    if (.not.checkChars(name, xf%xds%xml_version)) call wxml_error("xml_AddPseudoAttribute: Invalid character in name")
    if (.not.checkChars(value, xf%xds%xml_version)) call wxml_error("xml_AddPseudoAttribute: Invalid character in value")
    
    if (present(escape)) then
      esc = escape
    else
      esc = .true.
    endif
    if (present(ws_significant)) then
      if (ws_significant) then
        type='CDATA'
      else
        type='CDANO' ! CDAta, whitespace Not significant
      endif
    else
      type='CDAMB'   ! CDAta, whitespace MayBe significant
    endif

    if (index(value, '?>') > 0) &
        call wxml_error(xf, "Invalid pseudo-attribute value: "//value)
    if (.not.esc) then
      if (.not.checkPseudoAttValue(value, xf%xds)) &
        call wxml_error(xf, "Invalid pseudo-attribute value: "//value)
    endif

    if (xf%state_2 /= WXML_STATE_2_INSIDE_PI) &
         call wxml_error("PI pseudo-attribute outside PI: "//name)

    ! This is mostly ad-hoc, pseudo-attribute names are not defined anywhere.
    if (.not.checkName(name, xf%xds)) &
         call wxml_error("Invalid pseudo-attribute name: "//name)

    if (hasKey(xf%dict,name)) &
         call wxml_error(xf, "duplicate pseudo-attribute name: "//name)

    if (index(value, '?>') > 0) &
         call wxml_error(xf, "Invalid pseudo-attribute data: "//value)
    
    if (esc) then
      call add_item_to_dict(xf%dict, name, escape_string(value, xf%xds%xml_version), type=type)
    else
      call add_item_to_dict(xf%dict, name, value, type=type)
    endif
#endif
  end subroutine xml_AddPseudoAttribute_Ch


  subroutine xml_EndElement(xf, name)
    type(xmlf_t), intent(inout)             :: xf
    character(len=*), intent(in)            :: name

    character :: dummy
#ifndef DUMMYLIB
    call check_xf(xf)
    ! No point in doing checkChars, name is compared to stack anyway.

    if (len(xf%stack) == 0) &
      call wxml_fatal(xf,'Trying to close '//name//' but no tags are open.')

    if (get_top_elstack(xf%stack) /= name) &
      call wxml_fatal(xf, 'Trying to close '//name//' but '//get_top_elstack(xf%stack)// &
      ' is open. Either you have failed to open '//get_top_elstack(xf%stack)//&
      ' or you have failed to close '//name//'.') 
    xf%indent = xf%indent - indent_inc

    select case (xf%state_2)
    case (WXML_STATE_2_INSIDE_ELEMENT)
      call checkNamespacesWriting(xf%dict, xf%nsDict, len(xf%stack))
      if (getLength(xf%dict) > 0) call write_attributes(xf)
      if (xf%preserve_whitespace) call add_eol(xf)
      call add_to_buffer("/>",xf%buffer, .false.)
      dummy = pop_elstack(xf%stack)
    case (WXML_STATE_2_OUTSIDE_TAG, WXML_STATE_2_IN_CHARDATA, WXML_STATE_2_INSIDE_PI)
      if (xf%state_2==WXML_STATE_2_INSIDE_PI) call close_start_tag(xf)
      if (.not.xf%preserve_whitespace.and.xf%state_2==WXML_STATE_2_OUTSIDE_TAG) call add_eol(xf)
! XLF does a weird thing here, and if pop_elstack is called as an 
! argument to the call, it gets called twice. So we have to separate
! out get_top_... from pop_...
      call add_to_buffer("</" //get_top_elstack(xf%stack), xf%buffer, .false.)
      dummy = pop_elstack(xf%stack)
      if (xf%preserve_whitespace) call add_eol(xf)
      call add_to_buffer(">", xf%buffer, .false.)
    end select

    call checkEndNamespaces(xf%nsDict, len(xf%stack)+1)
    if (is_empty(xf%stack)) then
      xf%state_1 = WXML_STATE_1_AFTER_ROOT
    endif
    xf%state_2 = WXML_STATE_2_OUTSIDE_TAG
#endif
  end subroutine xml_EndElement


  subroutine xml_DeclareNamespace(xf, nsURI, prefix, xml)
    type(xmlf_t), intent(inout)   :: xf
    character(len=*), intent(in) :: nsURI
    character(len=*), intent(in), optional :: prefix
    logical, intent(in), optional :: xml

#ifndef DUMMYLIB
    call check_xf(xf)
    if (.not.checkChars(nsURI, xf%xds%xml_version)) call wxml_error("xml_DeclareNamespace: Invalid character in nsURI")
    if (present(prefix)) then
      if (.not.checkChars(prefix, xf%xds%xml_version)) call wxml_error("xml_DeclareNamespace: Invalid character in prefix")
    endif

    if (xf%state_1 == WXML_STATE_1_AFTER_ROOT) &
      call wxml_error(xf, "adding namespace outside element content")

    if (len(nsURI) == 0) &
      call wxml_error(xf, "adding namespace with empty URI")
    
    if (present(prefix)) then
      call addPrefixedNS(xf%nsDict, prefix, nsURI, len(xf%stack)+1, xf%xds, xml)
    else
      call addDefaultNS(xf%nsDict, nsURI, len(xf%stack)+1)
    endif
#endif
  end subroutine xml_DeclareNamespace


  subroutine xml_UndeclareNamespace(xf, prefix)
    type(xmlf_t), intent(inout)   :: xf
    character(len=*), intent(in), optional :: prefix

#ifndef DUMMYLIB
    call check_xf(xf)
    !No need to checkChars, prfix is checked against stack

    if (xf%xds%xml_version == XML1_0) &
      call wxml_error("cannot undeclare namespaces in XML 1.0")
    
    if (xf%state_1 == WXML_STATE_1_AFTER_ROOT) &
      call wxml_error(xf, "Undeclaring namespace outside element content")
    
    if (present(prefix)) then
      call addPrefixedNS(xf%nsDict, prefix, "", len(xf%stack)+1, xf%xds)
    else
      call addDefaultNS(xf%nsDict, "", len(xf%stack)+1)
    endif
#endif
  end subroutine xml_UndeclareNamespace


  subroutine xml_Close(xf, empty)
    type(xmlf_t), intent(inout)   :: xf
    logical, optional :: empty

#ifndef DUMMYLIB
    logical :: empty_

    if (present(empty)) then
      empty_ = empty
    else
      empty_ = .false.
    endif

    if (xf%lun == -1) &
      call wxml_fatal('Tried to close XML file which is not open')

    if (xf%state_2 == WXML_STATE_2_INSIDE_PI) &
      call close_start_tag(xf)

    if (xf%state_3 /= WXML_STATE_3_BEFORE_DTD &
      .and. xf%state_3 /= WXML_STATE_3_AFTER_DTD) then
      select case (xf%state_3)
      case (WXML_STATE_3_DURING_DTD)
        call add_to_buffer('>', xf%buffer, .false.)
      case (WXML_STATE_3_INSIDE_INTSUBSET)
        call add_eol(xf)
        call add_to_buffer(']>', xf%buffer, .false.)
      end select
      xf%state_3 = WXML_STATE_3_AFTER_DTD
    endif
    
    do while (xf%state_1 == WXML_STATE_1_DURING_ROOT)
      call xml_EndElement(xf, get_top_elstack(xf%stack))
    enddo

    if (xf%state_1 /= WXML_STATE_1_AFTER_ROOT) then
      if (empty_) then
        call wxml_warning(xf, 'Invalid XML document produced: No root element')
      else
        call wxml_error(xf, 'Invalid XML document produced: No root element')
      endif
    endif
    
    call dump_buffer(xf%buffer)
    close(unit=xf%lun)
    xf%lun = -1

    call destroy_dict(xf%dict)
    call destroy_elstack(xf%stack)
    
    call destroyNamespaceDictionary(xf%nsDict)
    call destroy_xml_doc_state(xf%xds)
    
    deallocate(xf%name)
#endif
  end subroutine xml_Close


  pure function xmlf_name(xf) result(fn)
    type (xmlf_t), intent(in) :: xf
#ifdef DUMMYLIB
    character(len=1) :: fn
    fn = " "
#else
    character(len=size(xf%xds%documentURI)) :: fn
    fn = str_vs(xf%xds%documentURI)
#endif
  end function xmlf_name

#ifndef DUMMYLIB
  pure function xmlf_opentag_len(xf) result(n)
    type (xmlf_t), intent(in) :: xf
    integer :: n
    
    if (xf%lun == -1) then
      n = 0
    elseif (is_empty(xf%stack)) then
      n = 0
    else
      n = len(get_top_elstack(xf%stack))
    endif
  end function xmlf_opentag_len
#endif

  function xmlf_opentag(xf) result(fn)
    type (xmlf_t), intent(in) :: xf
#ifdef DUMMYLIB
    character(len=1) :: fn
    fn = " "
#else
    character(len=xmlf_opentag_len(xf)) :: fn
    
    if (xf%lun == -1) then
      fn = ''
    elseif (is_empty(xf%stack)) then
      fn = ''
    else
      fn = get_top_elstack(xf%stack)
    endif
#endif
  end function xmlf_opentag

#ifndef DUMMYLIB

  subroutine check_xf(xf)
    type(xmlf_t), intent(inout)   :: xf
    if (xf%lun == -1) &
      call wxml_fatal("Tried to manipulate an XML File which is not open")

  end subroutine check_xf


  subroutine add_eol(xf)
    type(xmlf_t), intent(inout)   :: xf
    
    integer :: indent_level
    
    ! In case we still have a zero-length stack, we must make
    ! sure indent_level is not less than zero.
    if (xf%state_3 == WXML_STATE_3_INSIDE_INTSUBSET) then
      indent_level = indent_inc
    else
      indent_level = xf%indent
    endif
    
    !We must flush here (rather than just adding an eol character)
    !since we don't know what the eol character is on this system.
    !Flushing with a linefeed will get it automatically, though.
    call dump_buffer(xf%buffer, lf=.true.)
    call reset_buffer(xf%buffer, xf%lun, xf%xds%xml_version)
    
    if (.not.xf%preserve_whitespace) &
      call add_to_buffer(repeat(' ',indent_level),xf%buffer, .false.)

  end subroutine add_eol
  

  subroutine close_start_tag(xf)
    type(xmlf_t), intent(inout)   :: xf

    select case (xf%state_2)
    case (WXML_STATE_2_INSIDE_ELEMENT)
      call checkNamespacesWriting(xf%dict, xf%nsDict, len(xf%stack))
      if (getLength(xf%dict) > 0)  call write_attributes(xf)
      if (.not.xf%preserve_whitespace) then
        call add_to_buffer('>', xf%buffer, .false.)
      else
        call add_eol(xf)
        call add_to_buffer('>', xf%buffer, .false.)
      endif
      xf%state_2 = WXML_STATE_2_OUTSIDE_TAG
    case (WXML_STATE_2_INSIDE_PI)
      if (getLength(xf%dict) > 0)  call write_attributes(xf)
      call add_to_buffer('?>', xf%buffer, .false.)
      xf%state_2 = WXML_STATE_2_OUTSIDE_TAG
    case (WXML_STATE_2_IN_CHARDATA)
      continue
    case (WXML_STATE_2_OUTSIDE_TAG)
      continue
    end select

  end subroutine close_start_tag


  subroutine write_attributes(xf)
    type(xmlf_t), intent(inout)   :: xf

    integer  :: i, j, size
    
    if (xf%state_2 /= WXML_STATE_2_INSIDE_PI .and. &
      xf%state_2 /= WXML_STATE_2_INSIDE_ELEMENT) &
      call wxml_fatal("Internal library error")
    
    do i = 1, getLength(xf%dict)
      size = len(get_key(xf%dict, i)) + len(get_value(xf%dict, i)) + 4
      if ((len(xf%buffer) + size) > COLUMNS) then
        call add_eol(xf)
      else
        call add_to_buffer(" ", xf%buffer, .false.)
      endif
      call add_to_buffer(get_key(xf%dict, i), xf%buffer, .false.)
      call add_to_buffer("=", xf%buffer, .false.)
      call add_to_buffer('"',xf%buffer, .false.)
      j = getWhiteSpaceHandling(xf%dict, i)
      if (j==0) then
        call add_to_buffer(get_value(xf%dict, i), xf%buffer, .true.)
      elseif (j==1) then
        call add_to_buffer(get_value(xf%dict, i), xf%buffer)
      else
        call add_to_buffer(get_value(xf%dict, i), xf%buffer, .false.)
      endif
      call add_to_buffer('"', xf%buffer, .false.)
    enddo

  end subroutine write_attributes
  
  subroutine wxml_warning_xf(xf, msg)
    ! Emit warning, but carry on.
    type(xmlf_t), intent(in) :: xf
    character(len=*), intent(in) :: msg
    
    if (xf%xds%warning) then
      write(6,'(a)') 'WARNING(wxml) in writing to file ', xmlf_name(xf)
      write(6,'(a)')  msg
    endif
    
  end subroutine wxml_warning_xf
  
  
  subroutine wxml_error_xf(xf, msg)
    ! Emit error message, clean up file and stop.
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: msg
    
    write(6,'(a)') 'ERROR(wxml) in writing to file ', xmlf_name(xf)
    write(6,'(a)')  msg
    
    !call xml_Close(xf)
    stop
    
  end subroutine wxml_error_xf
  
  
  subroutine wxml_fatal_xf(xf, msg)
    !Emit error message and abort with coredump. Does not try to
    !close file, so should be used from anything xml_Close might
    !itself call (to avoid infinite recursion!)
    
    type(xmlf_t), intent(in) :: xf
    character(len=*), intent(in) :: msg
    
    write(6,'(a)') 'ERROR(wxml) in writing to file ', xmlf_name(xf)
    write(6,'(a)')  msg
    
    call pxfabort()
    stop
    
  end subroutine wxml_fatal_xf

#endif

end module m_wxml_core

program test

  use m_common_charset, only : XML1_0, XML1_1
  use m_common_struct, only : xml_doc_state
  use m_common_namecheck, only : checkCharacterEntityReference
  implicit none

  type(xml_doc_state) :: xds

  write(*,'(l1)') checkCharacterEntityReference('#x00', XML1_0)
  write(*,'(l1)') checkCharacterEntityReference('#x01', XML1_0)
  write(*,'(l1)') checkCharacterEntityReference('#x0A', XML1_0)
  write(*,'(l1)') checkCharacterEntityReference('#x0b', XML1_0)
  write(*,'(l1)') checkCharacterEntityReference('#x20', XML1_0)
  write(*,'(l1)') checkCharacterEntityReference('#xd7ff', XML1_0)
  write(*,'(l1)') checkCharacterEntityReference('#xd800', XML1_0)
  write(*,'(l1)') checkCharacterEntityReference('#00', XML1_0)
  write(*,'(l1)') checkCharacterEntityReference('#01', XML1_0)
  write(*,'(l1)') checkCharacterEntityReference('#10', XML1_0)
  write(*,'(l1)') checkCharacterEntityReference('#11', XML1_0)
  write(*,'(l1)') checkCharacterEntityReference('#32', XML1_0)
  write(*,'(l1)') checkCharacterEntityReference('#55295', XML1_0)
  write(*,'(l1)') checkCharacterEntityReference('#55296', XML1_0)

  xds%xml_version = XML1_1

  write(*,'(l1)') checkCharacterEntityReference('#x00', XML1_1)
  write(*,'(l1)') checkCharacterEntityReference('#x01', XML1_1)
  write(*,'(l1)') checkCharacterEntityReference('#x0A', XML1_1)
  write(*,'(l1)') checkCharacterEntityReference('#x0b', XML1_1)
  write(*,'(l1)') checkCharacterEntityReference('#x20', XML1_1)
  write(*,'(l1)') checkCharacterEntityReference('#xd7ff', XML1_1)
  write(*,'(l1)') checkCharacterEntityReference('#xd800', XML1_1)
  write(*,'(l1)') checkCharacterEntityReference('#00', XML1_1)
  write(*,'(l1)') checkCharacterEntityReference('#01', XML1_1)
  write(*,'(l1)') checkCharacterEntityReference('#10', XML1_1)
  write(*,'(l1)') checkCharacterEntityReference('#11', XML1_1)
  write(*,'(l1)') checkCharacterEntityReference('#32', XML1_1)
  write(*,'(l1)') checkCharacterEntityReference('#55295', XML1_1)
  write(*,'(l1)') checkCharacterEntityReference('#55296', XML1_1)

end program test

module m_common_namespaces

  use m_common_array_str, only: str_vs, vs_str
  use m_common_attrs, only: dictionary_t, get_key, get_value, remove_key, getLength
  use m_common_attrs, only: set_nsURI, set_localName, get_prefix, add_item_to_dict
  use m_common_error, only: FoX_error
  use m_common_namecheck, only: checkNCName, checkIRI

  implicit none
  private

  character(len=*), parameter :: invalidNS = '::INVALID::'
  ! an invalid URI name to indicate a namespace error.

  type URIMapping
    character, dimension(:), pointer :: URI
    integer :: ix ! link back to node depth
  end type URIMapping
  !This is a single URI, and the node depth under which
  !its namespace applies.

  type prefixMapping
    character, dimension(:), pointer :: prefix
    type(URIMapping), dimension(:), pointer :: urilist
  end type prefixMapping
  !This is the mapping for a single prefix; with the
  !list of namespaces which are in force at various
  !depths

  type namespaceDictionary
    private
    type(URIMapping), dimension(:), pointer :: defaults
    type(prefixMapping), dimension(:), pointer :: prefixes
  end type namespaceDictionary
  !This is the full namespace dictionary; defaults is
  !the list of default namespaces in force; prefix a
  !list of all prefixes in force.

  public :: invalidNS

  public :: initNamespaceDictionary
  public :: destroyNamespaceDictionary
  public :: namespaceDictionary
  public :: checkNamespaces
  public :: checkNamespacesWriting
  public :: checkEndNamespaces
  public :: getnamespaceURI
  interface getnamespaceURI
     module procedure getURIofDefaultNS, getURIofPrefixedNS
  end interface
  public :: isPrefixInForce
  public :: isDefaultNSInForce

  public :: dumpnsdict !FIXME

  public :: addDefaultNS
  public :: removeDefaultNS
  public :: addPrefixedNS
  public :: removePrefixedNS

contains


  subroutine initNamespaceDictionary(nsDict)
    type(namespaceDictionary), intent(inout) :: nsDict

    !We need to properly initialize 0th elements
    !(which are never used) in order to provide
    !sensible behaviour when trying to manipulate
    !an empty dictionary.

    allocate(nsDict%defaults(0:0))
    allocate(nsDict%defaults(0)%URI(0))
    !The 0th element of the defaults NS is the empty namespace
    nsDict%defaults(0)%ix = -1
    
    allocate(nsDict%prefixes(0:0))
    allocate(nsDict%prefixes(0)%prefix(0))
    allocate(nsDict%prefixes(0)%urilist(0:0))
    allocate(nsDict%prefixes(0)%urilist(0)%URI(len(invalidNS)))
    nsDict%prefixes(0)%urilist(0)%URI = vs_str(invalidNS)
    nsDict%prefixes(0)%urilist(0)%ix = -1
    
  end subroutine initNamespaceDictionary


  subroutine destroyNamespaceDictionary(nsDict)
    type(namespaceDictionary), intent(inout) :: nsDict

    integer :: i, j

    do i = 0, ubound(nsDict%defaults,1)
       deallocate(nsDict%defaults(i)%URI)
    enddo
    deallocate(nsDict%defaults)
    do i = 0, ubound(nsDict%prefixes,1)
       do j = 0, ubound(nsDict%prefixes(i)%urilist,1)
          deallocate(nsDict%prefixes(i)%urilist(j)%URI)
       enddo
       deallocate(nsDict%prefixes(i)%prefix)
       deallocate(nsDict%prefixes(i)%urilist)
    enddo
    deallocate(nsDict%prefixes)
  end subroutine destroyNamespaceDictionary


  subroutine copyURIMapping(urilist1, urilist2, l_m)
    type(URIMapping), dimension(0:), intent(inout) :: urilist1
    type(URIMapping), dimension(0:), intent(inout) :: urilist2
    integer, intent(in):: l_m
    integer :: i

    if (ubound(urilist1,1) < l_m .or. ubound(urilist2,1) < l_m) then
       call FoX_error('Internal error in m_sax_namespaces:copyURIMapping')
    endif
    ! Now copy all defaults across (or rather - add pointers to them)
    do i = 0, l_m
       urilist2(i)%ix = urilist1(i)%ix
       urilist2(i)%URI => urilist1(i)%URI
    enddo

  end subroutine copyURIMapping
    
  
  subroutine addDefaultNS(nsDict, uri, ix)
    type(namespaceDictionary), intent(inout) :: nsDict
    character(len=*), intent(in) :: uri
    integer, intent(in) :: ix

    type(URIMapping), dimension(:), allocatable :: tempMap
    integer :: l_m, l_s

    if (.not.checkIRI(URI)) &
      call FoX_error("Attempt to declare invalid namespace IRI: "//URI)

    l_m = ubound(nsDict%defaults,1)
    allocate(tempMap(0:l_m))
    ! Now copy all defaults across ...
    call copyURIMapping(nsDict%defaults, tempMap, l_m)
    deallocate(nsDict%defaults)
    l_m = l_m + 1
    allocate(nsDict%defaults(0:l_m))
    !Now copy everything back ...
    call copyURIMapping(tempMap, nsDict%defaults, l_m-1)
    deallocate(tempMap)
    ! And finally, add the new default NS
    nsDict%defaults(l_m)%ix = ix
    l_s = len(uri)
    allocate(nsDict%defaults(l_m)%URI(l_s))
    nsDict%defaults(l_m)%URI = vs_str(uri)

  end subroutine addDefaultNS
  

  subroutine addPrefixedURI(nsPrefix, uri, ix)
    type(PrefixMapping), intent(inout) :: nsPrefix
    character, dimension(:), intent(in) :: uri
    integer, intent(in) :: ix

    type(URIMapping), dimension(:), allocatable :: tempMap
    integer :: l_m, l_s

    l_m = ubound(nsPrefix%urilist,1)
    allocate(tempMap(0:l_m))
    ! Now copy all across ...
    call copyURIMapping(nsPrefix%urilist, tempMap, l_m)
    deallocate(nsPrefix%urilist)
    l_m = l_m + 1
    allocate(nsPrefix%urilist(0:l_m))
    !Now copy everything back ...
    call copyURIMapping(tempMap, nsPrefix%urilist, l_m-1)
    deallocate(tempMap)
    ! And finally, add the new default NS
    nsPrefix%urilist(l_m)%ix = ix
    l_s = size(uri)
    allocate(nsPrefix%urilist(l_m)%URI(l_s))
    nsPrefix%urilist(l_m)%URI = uri

  end subroutine addPrefixedURI
   
  subroutine removeDefaultNS(nsDict)
    type(namespaceDictionary), intent(inout) :: nsDict

    type(URIMapping), dimension(:), allocatable :: tempMap
    integer :: l_m

    l_m = ubound(nsDict%defaults,1)
    allocate(tempMap(0:l_m-1))
    ! Now copy all defaults across ...
    call copyURIMapping(nsDict%defaults, tempMap, l_m-1)
    !And remove tail-end charlie
    deallocate(nsDict%defaults(l_m)%URI)
    deallocate(nsDict%defaults)
    l_m = l_m - 1
    allocate(nsDict%defaults(0:l_m))
    !Now copy everything back ...
    call copyURIMapping(tempMap, nsDict%defaults, l_m)
    deallocate(tempMap)

  end subroutine removeDefaultNS

  subroutine removePrefixedURI(nsPrefix)
    type(PrefixMapping), intent(inout) :: nsPrefix

    type(URIMapping), dimension(:), allocatable :: tempMap
    integer :: l_m

    l_m = ubound(nsPrefix%urilist,1)
    allocate(tempMap(0:l_m-1))
    ! Now copy all defaults across ...
    call copyURIMapping(nsPrefix%urilist, tempMap, l_m-1)
    !And remove tail-end charlie
    deallocate(nsPrefix%urilist(l_m)%URI)
    deallocate(nsPrefix%urilist)
    l_m = l_m - 1
    allocate(nsPrefix%urilist(0:l_m))
    !Now copy everything back ...
    call copyURIMapping(tempMap, nsPrefix%urilist, l_m)
    deallocate(tempMap)

  end subroutine removePrefixedURI

  subroutine addPrefixedNS(nsDict, prefix, URI, ix, xv, xml)
    type(namespaceDictionary), intent(inout) :: nsDict
    character(len=*), intent(in) :: prefix
    character(len=*), intent(in) :: uri
    integer, intent(in) :: ix
    integer, intent(in) :: xv
    logical, intent(in), optional :: xml
    
    integer :: l_p, p_i, i
    logical :: xml_

    if (present(xml)) then
      xml_ = xml
    else
      xml_ = .false.
    endif

    !check prefix is not reserved
    if (len(prefix) > 2) then
      if ((verify(prefix(1:1), 'xX') == 0) &
           .and. (verify(prefix(2:2), 'mM') == 0) &
           .and. (verify(prefix(3:3), 'lL') == 0)) then
        if (prefix == 'xml' .and. &
          .not. URI == 'http://www.w3.org/XML/1998/namespace') then
          call FoX_error("Attempt to assign incorrect URI to prefix 'xml'")
        elseif (prefix == 'xmlns') then
          call FoX_error("Attempt to declare 'xmlns' prefix")
        else
          if (.not.xml_) &
            call FoX_error("Attempt to declare reserved prefix: "//prefix)
        endif
      endif
    endif

    if (.not.checkNCName(prefix, xv)) &
      call FoX_error("Attempt to declare invalid prefix: "//prefix)

    if (.not.checkIRI(URI)) &
      call FoX_error("Attempt to declare invalid namespace IRI: "//URI)

    l_p = ubound(nsDict%prefixes, 1)
    
    p_i = 0
    do i = 1, l_p
       if (str_vs(nsDict%prefixes(i)%prefix) == prefix) then
          p_i = i
          exit
       endif
    enddo

    if (p_i == 0) then
       call addPrefix(nsDict, vs_str(prefix))
       p_i = l_p + 1
    endif
 
    call addPrefixedURI(nsDict%prefixes(p_i), vs_str(URI), ix)

  end subroutine addPrefixedNS

  subroutine removePrefixedNS(nsDict, prefix)
    type(namespaceDictionary), intent(inout) :: nsDict
    character, dimension(:), intent(in) :: prefix
    integer :: l_p, p_i, i
    l_p = ubound(nsDict%prefixes, 1)

    p_i = 0
    do i = 1, l_p
      if (str_vs(nsDict%prefixes(i)%prefix) == str_vs(prefix)) then
        p_i = i
        exit
      endif
    enddo

    if (p_i /= 0) then
      call removePrefixedURI(nsDict%prefixes(p_i))
      if (ubound(nsDict%prefixes(p_i)%urilist,1) == 0) then
        !that was the last mapping for that prefix
        call removePrefix(nsDict, p_i)
      endif
    else
      call FoX_error('Internal error in m_sax_namespaces:removePrefixedNS')
    endif
    
  end subroutine removePrefixedNS

  subroutine addPrefix(nsDict, prefix)
    type(namespaceDictionary), intent(inout) :: nsDict
    character, dimension(:), intent(in) :: prefix
    integer :: l_p

    type(prefixMapping), dimension(:), pointer :: tempPrefixMap

    integer :: i

    !Add a new prefix to the namespace dictionary.
    !Unfortunately this involves copying the entire
    !prefixes dictionary to a temporary structure, then
    !reallocating the prefixes dictionary to be one
    !longer, then copying everything back:

    l_p = ubound(nsDict%prefixes, 1)
    allocate(tempPrefixMap(0:l_p))

    !for each current prefix, append everything to temporary structure
    do i = 0, l_p
       tempPrefixMap(i)%prefix => nsDict%prefixes(i)%prefix
       tempPrefixMap(i)%urilist => nsDict%prefixes(i)%urilist
    enddo
    deallocate(nsDict%prefixes)
    !extend prefix dictionary by one ...
    l_p = l_p + 1
    allocate(nsDict%prefixes(0:l_p))
    !and copy back ...
    do i = 0, l_p-1
       nsDict%prefixes(i)%prefix => tempPrefixMap(i)%prefix
       nsDict%prefixes(i)%urilist => tempPrefixMap(i)%urilist
    enddo
    deallocate(tempPrefixMap)

    allocate(nsDict%prefixes(l_p)%prefix(size(prefix)))
    nsDict%prefixes(l_p)%prefix = prefix
    allocate(nsDict%prefixes(l_p)%urilist(0:0))
    allocate(nsDict%prefixes(l_p)%urilist(0)%URI(len(invalidNS)))
    nsDict%prefixes(l_p)%urilist(0)%URI = vs_str(invalidNS)
    nsDict%prefixes(l_p)%urilist(0)%ix = -1
    
  end subroutine addPrefix

  subroutine removePrefix(nsDict, i_p)
    type(namespaceDictionary), intent(inout) :: nsDict
    integer, intent(in) :: i_p
    integer :: l_p

    type(prefixMapping), dimension(:), pointer :: tempPrefixMap

    integer :: i

    !Remove a prefix from the namespace dictionary.
    !Unfortunately this involves copying the entire
    !prefixes dictionary to a temporary structure, then
    !reallocating the prefixes dictionary to be one
    !shorter, then copying everything back:

    l_p = ubound(nsDict%prefixes, 1)
    allocate(tempPrefixMap(0:l_p-1))

    !for each current prefix, append everything to temporary structure
    do i = 0, i_p-1
       tempPrefixMap(i)%prefix => nsDict%prefixes(i)%prefix
       tempPrefixMap(i)%urilist => nsDict%prefixes(i)%urilist
    enddo
    deallocate(nsDict%prefixes(i_p)%urilist(0)%URI)
    deallocate(nsDict%prefixes(i_p)%urilist)
    deallocate(nsDict%prefixes(i_p)%prefix)
    !this subroutine will only get called if the urilist is already
    !empty, so no need to deallocate it.
    do i = i_p+1, l_p
       tempPrefixMap(i-1)%prefix => nsDict%prefixes(i)%prefix
       tempPrefixMap(i-1)%urilist => nsDict%prefixes(i)%urilist
    enddo
    deallocate(nsDict%prefixes)
    !shorten prefix dictionary by one ...
    l_p = l_p - 1
    allocate(nsDict%prefixes(0:l_p))
    !and copy back ...
    do i = 0, l_p
       nsDict%prefixes(i)%prefix => tempPrefixMap(i)%prefix
       nsDict%prefixes(i)%urilist => tempPrefixMap(i)%urilist
    enddo
    deallocate(tempPrefixMap)

  end subroutine removePrefix


  subroutine checkNamespaces(atts, nsDict, ix, xv, start_prefix_handler)
    type(dictionary_t), intent(inout) :: atts
    type(namespaceDictionary), intent(inout) :: nsDict
    integer, intent(in) :: ix ! depth of nesting of current element.
    integer, intent(in) :: xv

    optional :: start_prefix_handler ! what to do when we find a new prefix

    interface
      subroutine start_prefix_handler(namespaceURI, prefix)
        character(len=*), intent(in) :: namespaceURI
        character(len=*), intent(in) :: prefix
      end subroutine start_prefix_handler
    end interface

    character(len=6) :: xmlns
    character, dimension(:), allocatable :: prefix, QName, URI
    integer :: i, j, n, xmlnsLength, URIlength

    !Check for namespaces; *and* remove xmlns references from 
    !the attributes dictionary.

    ! we can't do a simple loop across the attributes,
    ! because we need to remove some as we go along ...
    i = 1
    do while (i <= getLength(atts))
       xmlns = get_key(atts, i)
       if (xmlns == 'xmlns ') then
          !Default namespace is being set
          URIlength = len(get_value(atts, i))
          allocate(URI(URIlength))
          URI = vs_str(get_value(atts, i))
          call checkURI(URI)
          if (present(start_prefix_handler)) &
               call start_prefix_handler(str_vs(URI), "")
          call addDefaultNS(nsDict, str_vs(URI), ix)
          deallocate(URI)
          call remove_key(atts, i)
       elseif (xmlns == 'xmlns:') then
          !Prefixed namespace is being set
          URIlength = len(get_value(atts, i))
          allocate(URI(URIlength))
          URI = vs_str(get_value(atts, i))
          call checkURI(URI)
          xmlnsLength = len(get_key(atts, i))
          allocate(QName(xmlnsLength))
          allocate(prefix(xmlnsLength - 6))
          QName = vs_str(get_key(atts, i))
          prefix = QName(7:)
          call addPrefixedNS(nsDict, str_vs(prefix), str_vs(URI), ix, xv)
          if (present(start_prefix_handler)) &
               call start_prefix_handler(str_vs(URI), str_vs(prefix))
          deallocate(URI)
          deallocate(QName)
          deallocate(prefix)
          call remove_key(atts, i)
       else
          ! we only increment if we haven't removed a key
          i = i+1
       endif
    enddo

    ! having done that, now resolve all attribute namespaces:
    do i = 1, getLength(atts)
       ! get name
       allocate(QName(len(get_key(atts, i))))
       QName = vs_str(get_key(atts,i))
       n = 0
       do j = 1, size(QName)
          if (QName(j) == ':') then
             n = j
             exit
          endif
       enddo
       if (n > 0) then
          call set_nsURI(atts, i, getnamespaceURI(nsDict, str_vs(QName(1:n-1))))
       else
          call set_nsURI(atts, i, '') ! no such thing as a default namespace on attributes
       endif
       call set_localName(atts, i, QName(n+1:))
       deallocate(QName)
    enddo

  end subroutine checkNamespaces

  
  subroutine checkNamespacesWriting(atts, nsdict, ix)
    type(dictionary_t), intent(inout) :: atts
    type(namespaceDictionary), intent(inout) :: nsDict
    integer, intent(in) :: ix
    ! Read through a list of attributes, check with currently
    ! active namespaces & add any necessary declarations

    integer :: i, i_p, l_d, l_ps, n

    n = getLength(atts) ! we need the length before we fiddle with it

    !Does the default NS need added?
    l_d = ubound(nsDict%defaults,1)
    if (nsDict%defaults(l_d)%ix == ix) then
      !It's not been registered yet:
      call add_item_to_dict(atts, "xmlns", &
           str_vs(nsDict%defaults(l_d)%URI), type="CDATA")
    endif

    !next, add any overdue prefixed NS's in the same way:
    ! there should only ever be one. More would be an error,
    ! but the check should have been done earlier.
    do i_p = 0, ubound(nsDict%prefixes, 1)
      l_ps = ubound(nsDict%prefixes(i_p)%urilist,1)
      if (nsDict%prefixes(i_p)%urilist(l_ps)%ix == ix) then
        call add_item_to_dict(atts, &
             "xmlns:"//str_vs(nsDict%prefixes(i_p)%prefix), &
             str_vs(nsDict%prefixes(i_p)%urilist(l_ps)%URI), &
             type="CDATA")
      endif
    enddo
    

    !Finally, we may have some we've added for attribute QNames
    ! have to get those too:
    do i = 1, getLength(atts)
      ! get prefix, and identify the relevant NS mapping
      i_p = getPrefixIndex(nsDict, get_prefix(atts, i))
      l_ps = ubound(nsDict%prefixes(i_p)%urilist,1)
      !If the index is greater than what it should be:
      if (nsDict%prefixes(i_p)%urilist(l_ps)%ix > ix) then
        !we only just added this, so we need to declare it
        call add_item_to_dict(atts, "xmlns:"//get_prefix(atts, i), &
             str_vs(nsDict%prefixes(i_p)%urilist(l_ps)%URI), &
             type="CDATA")
        !Reset the index to the right value:
        nsDict%prefixes(i_p)%urilist(l_ps)%ix = ix
      endif
    enddo

  end subroutine checkNamespacesWriting


  subroutine checkEndNamespaces(nsDict, ix, end_prefix_handler)
    type(namespaceDictionary), intent(inout) :: nsDict
    integer, intent(in) :: ix

    optional :: end_prefix_handler
    
    interface
      subroutine end_prefix_handler(prefix)
        character(len=*), intent(in) :: prefix
      end subroutine end_prefix_handler
    end interface

    integer :: l_d, l_p, l_ps, i

    !It will only ever be the final elements in the list which
    ! might have expired.

    l_d = ubound(nsDict%defaults,1)
    do while (nsDict%defaults(l_d)%ix == ix)
      if (present(end_prefix_handler)) &
           call end_prefix_handler("")
      call removeDefaultNS(nsDict)
      l_d = ubound(nsDict%defaults,1)
    enddo

    l_p = ubound(nsDict%prefixes, 1)
    i = 1
    prefixes: do while (i <= l_p)
      l_ps = ubound(nsDict%prefixes(l_p)%urilist,1)
      do while (nsDict%prefixes(l_p)%urilist(l_ps)%ix == ix)
        if (present(end_prefix_handler)) &
             call end_prefix_handler(str_vs(nsDict%prefixes(i)%prefix))
        call removePrefixedNS(nsDict, nsDict%prefixes(i)%prefix)
        if (l_p > ubound(nsDict%prefixes, 1)) then
          ! since we might have just removed a prefix
          l_p = ubound(nsDict%prefixes, 1)
          cycle prefixes
        endif
        l_ps = ubound(nsDict%prefixes(l_p)%urilist,1)
      enddo
      i = i + 1
    enddo prefixes

  end subroutine checkEndNamespaces


  subroutine dumpnsdict(nsdict)
    type(namespaceDictionary), intent(in) :: nsdict
    integer :: i, j
    write(*,'(a)')'* default namespaces *'

    do i = 1, ubound(nsdict%defaults, 1)
      write(*,'(i0,a)') nsdict%defaults(i)%ix, str_vs(nsdict%defaults(i)%URI)
    enddo
    write(*,'(a)') '* Prefixed namespaces *'
    do i = 1, ubound(nsdict%prefixes, 1)
       write(*,'(2a)') '* prefix: ', str_vs(nsdict%prefixes(i)%prefix)
       do j = 1, ubound(nsdict%prefixes(i)%urilist, 1)
          write(*,'(i0,a)') nsdict%prefixes(i)%urilist(j)%ix, str_vs(nsdict%prefixes(i)%urilist(j)%URI)
       enddo
    enddo

  end subroutine dumpnsdict


  pure function getURIofDefaultNS(nsDict) result(uri)
    type(namespaceDictionary), intent(in) :: nsDict
    character(len=size(nsDict%defaults(ubound(nsDict%defaults,1))%URI)) :: URI
    
    integer :: l_d
    l_d = ubound(nsDict%defaults,1)
    uri = str_vs(nsDict%defaults(l_d)%URI)
  end function getURIofDefaultNS


  pure function isPrefixInForce(nsDict, prefix) result(force)
    type(namespaceDictionary), intent(in) :: nsDict
    character(len=*), intent(in) :: prefix
    logical :: force
    integer :: i, l_s

    force = .false.
    do i = 1, ubound(nsDict%prefixes, 1)
       if (str_vs(nsDict%prefixes(i)%prefix) == prefix) then
         l_s = ubound(nsDict%prefixes(i)%urilist, 1)
         force = (size(nsdict%prefixes(i)%urilist(l_s)%URI) > 0)
         exit
       endif
    enddo

  end function isPrefixInForce


  pure function isDefaultNSInForce(nsDict) result(force)
    type(namespaceDictionary), intent(in) :: nsDict
    logical :: force
    integer :: l_s

    force = .false.
    l_s = ubound(nsDict%defaults, 1)
    if (l_s > 0) &
      force = (size(nsdict%defaults(l_s)%URI) > 0)

  end function isDefaultNSInForce


  pure function getPrefixIndex(nsDict, prefix) result(p)
    type(namespaceDictionary), intent(in) :: nsDict
    character(len=*), intent(in) :: prefix
    integer :: p
    
    integer :: i
    p = 0
    do i = 1, ubound(nsDict%prefixes, 1)
      if (str_vs(nsDict%prefixes(i)%prefix) == prefix) then
           p = i
           exit
       endif
    enddo
  end function getPrefixIndex


  pure function getURIofPrefixedNS(nsDict, prefix) result(uri)
    type(namespaceDictionary), intent(in) :: nsDict
    character(len=*), intent(in) :: prefix
    character(len=size( &
              nsDict%prefixes( &
           getPrefixIndex(nsDict,prefix) &
                             ) &
                     %urilist( &
           ubound(nsDict%prefixes(getPrefixIndex(nsDict,prefix))%urilist, 1) &
                             ) & 
                      %uri)) :: URI
    integer :: p_i, l_m
    p_i = getPrefixIndex(nsDict, prefix)
    l_m = ubound(nsDict%prefixes(p_i)%urilist, 1)
    uri = str_vs(nsDict%prefixes(p_i)%urilist(l_m)%URI)

  end function getURIofPrefixedNS


  subroutine checkURI(URI)
    character, dimension(:) :: URI

    !FIXMETOHW check that the string is a valid URI
    !TOHW actually, namespaces 1.1 says just a valid QName

  end subroutine checkURI


end module m_common_namespaces

 
 
! This file is AUTOGENERATED!!!!
! Do not edit this file; edit m_wcml_quantity.m4 and regenerate.
!
!
module m_wcml_property

  use m_common_realtypes, only: sp, dp
  use FoX_wxml, only: xmlf_t
  use FoX_wxml, only: xml_NewElement, xml_AddAttribute
  use FoX_wxml, only: xml_EndElement
  use m_wcml_stml, only: stmAddValue

  implicit none
  private

  interface cmlAddproperty
     module procedure propertyCmplxDpSca
     module procedure propertyCmplxDpArrSi
     module procedure propertyCmplxDpArrSh
     module procedure propertyCmplxDpMatSi
     module procedure propertyCmplxDpMatSh
     module procedure propertyCmplxSpSca
     module procedure propertyCmplxSpArrSi
     module procedure propertyCmplxSpArrSh
     module procedure propertyCmplxSpMatSi
     module procedure propertyCmplxSpMatSh
     module procedure propertyRealDpSca
     module procedure propertyRealDpArrSi
     module procedure propertyRealDpArrSh
     module procedure propertyRealDpMatSi
     module procedure propertyRealDpMatSh
     module procedure propertyRealSpSca
     module procedure propertyRealSpArrSi
     module procedure propertyRealSpArrSh
     module procedure propertyRealSpMatSi
     module procedure propertyRealSpMatSh
     module procedure propertyIntSca
     module procedure propertyIntArrSi
     module procedure propertyIntArrSh
     module procedure propertyIntMatSi
     module procedure propertyIntMatSh
     module procedure propertyLgSca
     module procedure propertyLgArrSi
     module procedure propertyLgArrSh
     module procedure propertyLgMatSi
     module procedure propertyLgMatSh
     module procedure propertyChSca
     module procedure propertyChArrSi
     module procedure propertyChArrSh
     module procedure propertyChMatSi
     module procedure propertyChMatSh

  end interface cmlAddproperty

  public :: cmlAddproperty

contains

  subroutine propertyCmplxDpSca &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in)   :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyCmplxDpSca

  subroutine propertyCmplxSpSca &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in)   :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyCmplxSpSca

  subroutine propertyRealDpSca &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in)   :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyRealDpSca

  subroutine propertyRealSpSca &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in)   :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyRealSpSca

  subroutine propertyIntSca &
    (xf, value, dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in)   :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyIntSca

  subroutine propertyLgSca &
    (xf, value, dictRef, convention, title, id, ref, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in)   :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role


    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyLgSca

  subroutine propertyChSca &
    (xf, value, dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in)   :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyChSca


  subroutine propertyCmplxDpArrSi &
    (xf, value,nitems,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyCmplxDpArrSi

  subroutine propertyCmplxSpArrSi &
    (xf, value,nitems,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyCmplxSpArrSi

  subroutine propertyRealDpArrSi &
    (xf, value,nitems,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyRealDpArrSi

  subroutine propertyRealSpArrSi &
    (xf, value,nitems,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyRealSpArrSi

  subroutine propertyIntArrSi &
    (xf, value,nitems,  dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyIntArrSi

  subroutine propertyLgArrSi &
    (xf, value,nitems,  dictRef, convention, title, id, ref, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role


    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems))
    call xml_EndElement(xf, "property")
 
  end subroutine propertyLgArrSi

  subroutine propertyChArrSi &
    (xf, value,nitems,  dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyChArrSi


  subroutine propertyCmplxDpArrSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyCmplxDpArrSh

  subroutine propertyCmplxSpArrSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyCmplxSpArrSh

  subroutine propertyRealDpArrSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyRealDpArrSh

  subroutine propertyRealSpArrSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyRealSpArrSh

  subroutine propertyIntArrSh &
    (xf, value, dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyIntArrSh

  subroutine propertyLgArrSh &
    (xf, value, dictRef, convention, title, id, ref, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role


    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyLgArrSh

  subroutine propertyChArrSh &
    (xf, value, dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyChArrSh


  subroutine propertyCmplxDpMatSi &
    (xf, value,nrows, ncols,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyCmplxDpMatSi

  subroutine propertyCmplxSpMatSi &
    (xf, value,nrows, ncols,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyCmplxSpMatSi

  subroutine propertyRealDpMatSi &
    (xf, value,nrows, ncols,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyRealDpMatSi

  subroutine propertyRealSpMatSi &
    (xf, value,nrows, ncols,  dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyRealSpMatSi

  subroutine propertyIntMatSi &
    (xf, value,nrows, ncols,  dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyIntMatSi

  subroutine propertyLgMatSi &
    (xf, value,nrows, ncols,  dictRef, convention, title, id, ref, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role


    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols))
    call xml_EndElement(xf, "property")
 
  end subroutine propertyLgMatSi

  subroutine propertyChMatSi &
    (xf, value,nrows, ncols,  dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyChMatSi


  subroutine propertyCmplxDpMatSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyCmplxDpMatSh

  subroutine propertyCmplxSpMatSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyCmplxSpMatSh

  subroutine propertyRealDpMatSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyRealDpMatSh

  subroutine propertyRealSpMatSh &
    (xf, value, dictRef, convention, title, id, ref, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyRealSpMatSh

  subroutine propertyIntMatSh &
    (xf, value, dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyIntMatSh

  subroutine propertyLgMatSh &
    (xf, value, dictRef, convention, title, id, ref, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role


    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyLgMatSh

  subroutine propertyChMatSh &
    (xf, value, dictRef, convention, title, id, ref, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

    call xml_NewElement(xf, "property")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "property")
 
  end subroutine propertyChMatSh


end module m_wcml_property

program test_sax_reader

  use m_sax_reader

  type(file_buffer_t) :: fb

  character(len=1) :: c
  character(len=3) :: s
  integer :: iostat

  call open_file(fb, file="test_sax_reader_3.in", iostat=iostat)

  s = read_chars(fb, 3, iostat)

  call push_chars(fb, 'x')

  c = read_char(fb, iostat)

  write(*,'(3a)') 'char:', s, ':'
  write(*,'(3a)') 'char:', c, ':'
  write(*,'(a,i0)') 'iost:', iostat

  call close_file(fb) 

end program test_sax_reader

module m_pxf_abort_flush

  implicit none

  public :: pxfflush
  public :: pxfabort
  public :: pure_pxfabort

  ! pxf.F90 - assortment of Fortran wrappers to various
  ! unix-y system calls.
  !
  ! Copyright Toby White, <tow21@cam.ac.uk> 2005

  ! The name pxf is intended to be reminiscent of the POSIX
  ! fortran interfaces defined by IEEE 1003.9-1992, although
  ! in fact I don't think that either flush or abort were
  ! covered by said standard.

  ! Of the preprocessor defines used here, only xlC is
  ! automatically defined by the appropriate compiler. All
  ! others must be defined by some other mechanism - I
  ! recommend autoconf.


  ! FLUSH: flushes buffered output on a given unit. Not guaranteed
  ! to do anything at all (particularly under MPI when even FLUSHed 
  ! buffers may not make it to the host cpu after an abort.
  !
  ! IMPLEMENTATION: in F2003, this is a native operation called by the
  ! FLUSH statement.
  ! In almost every compiler, there is a FLUSH intrinsic subroutine 
  ! available which takes one argument, the unit to be flushed.
  ! (some will flush all open units when no argument is given - this 
  !  facility is not used here.
  ! NAG complicates matters by having to USE a module to get at flush.
  ! 
  ! If no FLUSH is available, the subroutine is a no-op.


CONTAINS

  subroutine pxfflush(unit)
#ifdef __NAG__
    use f90_unix_io, only : flush
#endif
    integer, intent(in) :: unit

#if defined(F2003)
    flush(unit)
#elif defined(xlC)
    call flush_(unit)
#elif defined (FC_HAVE_FLUSH)
    call flush(unit)
#else
    continue
#endif

  end subroutine pxfflush

  ! ABORT: terminates program execution in such a way that a backtrace
  ! is produced. (see abort() in the C Standard Library). No arguments.
  !
  ! IMPLEMENTATION: In F2003, the C interoperability features mean that
  ! the abort in stdlib.h is available to be linked against.
  ! In several other compilers an ABORT intrinsic subroutine is available.
  ! Again, NAG complicates matters by needing to USE a module.
  !
  ! In the case where no native ABORT can be found, we emulate one
  ! by dereferencing a null pointer. This has reliably produced coredumps
  ! on every platform I've tried it with. Just in case it doesn't (it need
  ! not even stop execution) a stop is given to force termination.

  subroutine pxfabort()
#ifdef __NAG__
    use f90_unix_proc, only : abort
#endif
#ifdef F2003
    interface
      subroutine abort() bind(c)
      end subroutine abort
    end interface
#define FC_HAVE_ABORT
#endif
#ifndef FC_HAVE_ABORT
    integer, pointer :: i
#endif

    call pxfflush(6)

#ifdef FC_HAVE_ABORT
#ifdef FC_ABORT_UNDERSCORE
    call abort_()
#elif defined(FC_ABORT_ARG)
    call abort("")
#else
    call abort()
#endif ! FC_ABORT_TYPE
#else
    i=>null()
    Print*,i
#endif ! FC_HAVE_ABORT
    stop

  end subroutine pxfabort

  ! For where we need a pxfabort that is pure, we have
  ! this below. I am less sure of its working everywhe
  ! also it must be used as a function not a subroutine
  ! (otherwise it would be optimized away as side-effect
  ! free

  pure function pure_pxfabort() result (crash)
    integer :: crash
    integer, pointer :: i
    nullify(i)
    crash = i
  end function pure_pxfabort

end module m_pxf_abort_flush

program test_sax_reader

  use m_sax_reader

  character(40) :: buf
  character :: c
  type(file_buffer_t) :: fb

  integer :: iostat

  ! test 1: move 40 chars in, and then pick up the name

  call open_file(fb, file="test_sax_reader_12a.in", iostat=iostat)

  buf = get_characters(fb, 40, iostat) 

  call get_characters_until_not_one_of(fb, 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ', iostat) 

  write(*,'(3a)') 'char:', retrieve_namebuffer(fb), ':'
  write(*,'(a,i0)') 'iost:', iostat

  call close_file(fb) 

  ! test 2: move 40 chars in, and then pick up the name, which is now 2004 chars long.

  call open_file(fb, file="test_sax_reader_12b.in", iostat=iostat) 

  buf = get_characters(fb, 40, iostat) 

  call get_characters_until_not_one_of(fb, 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ', iostat) 

  print*, len_namebuffer(fb)

  write(*,'(3a)') 'char:', retrieve_namebuffer(fb), ':'
  write(*,'(a,i0)') 'iost:', iostat

  call get_characters_until_not_one_of(fb, 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ', iostat) 

  print*, len_namebuffer(fb)

  write(*,'(3a)') 'char:', retrieve_namebuffer(fb), ':'
  write(*,'(a,i0)') 'iost:', iostat

  call close_file(fb) 

end program test_sax_reader

! This file is AUTOGENERATED!!!!
! Do not edit this file; edit m_wcml_metadata.m4 and regenerate.
!

module m_wcml_lists

  use FoX_wxml, only: xmlf_t

#ifndef DUMMYLIB
  use FoX_common, only: str
  use FoX_wxml, only: xml_NewElement, xml_EndElement
  use FoX_wxml, only: xml_AddAttribute
#endif

  implicit none
  private

  public :: cmlStartMetadataList
  public :: cmlEndMetadataList

  public :: cmlStartPropertyList
  public :: cmlEndPropertyList

  public :: cmlStartParameterList
  public :: cmlEndParameterList

  public :: cmlStartBandList
  public :: cmlEndBandList

  public :: cmlStartKpointList
  public :: cmlEndKpointList

  public :: cmlStartModule
  public :: cmlEndModule

  public :: cmlStartStep
  public :: cmlEndStep

contains


  subroutine cmlStartmetadataList(xf, dictRef, convention, title, id, name, role)

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "metadataList")

    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

#endif

  end subroutine cmlStartmetadataList

  subroutine cmlEndmetadataList(xf)
    type(xmlf_t), intent(inout) :: xf
#ifndef DUMMYLIB
    call xml_EndElement(xf, "metadataList")
#endif
  end subroutine cmlEndmetadataList




  subroutine cmlStartpropertyList(xf, dictRef, convention, title, id, ref, role)

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "propertyList")

    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

#endif

  end subroutine cmlStartpropertyList

  subroutine cmlEndpropertyList(xf)
    type(xmlf_t), intent(inout) :: xf
#ifndef DUMMYLIB
    call xml_EndElement(xf, "propertyList")
#endif
  end subroutine cmlEndpropertyList




  subroutine cmlStartparameterList(xf, dictRef, convention, title, id, ref, role)

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "parameterList")

    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

#endif

  end subroutine cmlStartparameterList

  subroutine cmlEndparameterList(xf)
    type(xmlf_t), intent(inout) :: xf
#ifndef DUMMYLIB
    call xml_EndElement(xf, "parameterList")
#endif
  end subroutine cmlEndparameterList




  subroutine cmlStartbandList(xf, dictRef, convention, title, id, ref, role)

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "bandList")

    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

#endif

  end subroutine cmlStartbandList

  subroutine cmlEndbandList(xf)
    type(xmlf_t), intent(inout) :: xf
#ifndef DUMMYLIB
    call xml_EndElement(xf, "bandList")
#endif
  end subroutine cmlEndbandList


!FIXME what attributes

  subroutine cmlStartkpointList(xf, dictRef, convention, title, id, ref, role)

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "kpointList")

    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(role)) call xml_addAttribute(xf, "role", role)

#endif

  end subroutine cmlStartkpointList

  subroutine cmlEndkpointList(xf)
    type(xmlf_t), intent(inout) :: xf
#ifndef DUMMYLIB
    call xml_EndElement(xf, "kpointList")
#endif
  end subroutine cmlEndkpointList


!FIXME what attributes

  subroutine cmlStartmodule(xf, serial, title, id, convention, dictRef, role)

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in), optional :: serial
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: role


#ifndef DUMMYLIB
    call xml_NewElement(xf, "module")

    if (present(serial)) call xml_addAttribute(xf, "serial", serial)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(role)) call xml_addAttribute(xf, "role", role)

#endif

  end subroutine cmlStartmodule

  subroutine cmlEndmodule(xf)
    type(xmlf_t), intent(inout) :: xf
#ifndef DUMMYLIB
    call xml_EndElement(xf, "module")
#endif
  end subroutine cmlEndmodule



  subroutine cmlStartStep(xf, type, index, id, title, convention)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in), optional :: type
    character(len=*), intent(in), optional :: id
    integer, intent(in), optional :: index
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: convention

#ifndef DUMMYLIB
    if (present(index)) then
      call cmlStartModule(xf=xf, id=id, title=title, convention=convention, &
        dictRef=type, role='step', serial=str(index))
    else
      call cmlStartModule(xf=xf, id=id, title=title, convention=convention, &
        dictRef=type, role='step')
    endif
#endif
    
  end subroutine cmlStartStep


  subroutine cmlEndStep(xf)
    type(xmlf_t), intent(inout) :: xf
#ifndef DUMMYLIB
    call xml_EndElement(xf, 'module')
#endif
  end subroutine cmlEndStep


end module m_wcml_lists

program test

  use FoX_wcml
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  real, dimension(3,4) :: coords
  character(len=2), dimension(4) :: elems

  coords = reshape((/  0.0,    0.0, 0.0,   &
                       0.0,  1.203, 0.0,   &
                    -0.934, -0.579, 0.0,   &
                     0.934, -0.579, 0.0/), &
                   (/3,4/))

  elems = (/"C ", "O ", "H ", "H "/)

  call cmlBeginFile(xf, filename, unit=-1)
  call cmlStartCml(xf)
  
  call cmlAddMolecule(xf, coords=coords, elements=elems, title="Formaldehyde")

  call cmlFinishFile(xf)

end program test

module fox_m_utils_mtprng
!---------------------------------------------------------------------
! From the Algorithmic Conjurings of Scott Robert Ladd comes...
!---------------------------------------------------------------------
!
!  mtprng.f90 (a Fortran 95 module)
!
!  An implementation of the Mersenne Twister algorithm for generating
!  psuedo-random sequences.
!
!  History
!  -------
!   1.0.0   Initial release
!
!   1.1.0   6 February 2002
!           Updated to support algorithm revisions posted
!           by Matsumoto and Nishimura on 26 January 2002
!
!   1.5.0   12 December 2003
!           Added to hypatia project
!           Minor style changes
!           Tightened code
!           Now state based; no static variables
!           Removed mtprng_rand_real53
!
!   2.0.0   4 January 2004
!           Corrected erroneous unsigned bit manipulations
!           Doubled resolution by using 64-bit math
!           Added mtprng_rand64
!
!  ORIGINAL ALGORITHM COPYRIGHT
!  ============================
!  Copyright (C) 1997,2002 Makoto Matsumoto and Takuji Nishimura.
!  Any feedback is very welcome. For any question, comments, see
!  http://www.math.keio.ac.jp/matumoto/emt.html or email
!  matumoto@math.keio.ac.jp
!---------------------------------------------------------------------
!
!  COPYRIGHT NOTICE, DISCLAIMER, and LICENSE:
!
!  This notice applies *only* to this specific expression of this
!  algorithm, and does not imply ownership or invention of the
!  implemented algorithm.
!  
!  If you modify this file, you may insert additional notices
!  immediately following this sentence.
!  
!  Copyright 2001, 2002, 2004 Scott Robert Ladd.
!  All rights reserved, except as noted herein.
!
!  This computer program source file is supplied "AS IS". Scott Robert
!  Ladd (hereinafter referred to as "Author") disclaims all warranties,
!  expressed or implied, including, without limitation, the warranties
!  of merchantability and of fitness for any purpose. The Author
!  assumes no liability for direct, indirect, incidental, special,
!  exemplary, or consequential damages, which may result from the use
!  of this software, even if advised of the possibility of such damage.
!  
!  The Author hereby grants anyone permission to use, copy, modify, and
!  distribute this source code, or portions hereof, for any purpose,
!  without fee, subject to the following restrictions:
!  
!      1. The origin of this source code must not be misrepresented.
!  
!      2. Altered versions must be plainly marked as such and must not
!         be misrepresented as being the original source.
!  
!      3. This Copyright notice may not be removed or altered from any
!         source or altered source distribution.
!  
!  The Author specifically permits (without fee) and encourages the use
!  of this source code for entertainment, education, or decoration. If
!  you use this source code in a product, acknowledgment is not required
!  but would be appreciated.
!  
!  Acknowledgement:
!      This license is based on the wonderful simple license that
!      accompanies libpng.
!
!-----------------------------------------------------------------------
!
!  For more information on this software package, please visit
!  Scott's web site, Coyote Gulch Productions, at:
!
!      http://www.coyotegulch.com
!  
!-----------------------------------------------------------------------

    implicit none

    ! Kind types for 64-, 32-, 16-, and 8-bit signed integers
    integer, parameter :: INT64 = selected_int_kind(18)
    integer, parameter :: INT32 = selected_int_kind(9)
    integer, parameter :: INT16 = selected_int_kind(4)
    integer, parameter :: INT08 = selected_int_kind(2)

    ! Kind types for IEEE 754/IEC 60559 single- and double-precision reals
    integer, parameter :: IEEE32 = selected_real_kind(  6,  37 )
    integer, parameter :: IEEE64 = selected_real_kind( 15, 307 )

    !------------------------------------------------------------------------------
    ! Everything is private unless explicitly made public
    private

    public :: mtprng_state, &
              mtprng_init, mtprng_init_by_array, &
              mtprng_rand64, mtprng_rand, mtprng_rand_range, &
              mtprng_rand_real1, mtprng_rand_real2, mtprng_rand_real3

    !------------------------------------------------------------------------------
    ! Constants
    integer(INT32), parameter :: N = 624_INT32
    integer(INT32), parameter :: M = 397_INT32

    !------------------------------------------------------------------------------
    ! types
    type mtprng_state
        integer(INT32)                   :: mti = -1
        integer(INT64), dimension(0:N-1) :: mt
    end type 

contains
    !--------------------------------------------------------------------------
    !  Initializes the generator with "seed"
    subroutine mtprng_init(seed, state)
    
        ! arguments
        integer(INT32),     intent(in)  :: seed
        type(mtprng_state), intent(out) :: state
        
        ! working storage
        integer :: i

        ! save seed        
        state%mt(0) = seed
        
        ! Set the seed using values suggested by Matsumoto & Nishimura, using
        !   a generator by Knuth. See original source for details.
        do i = 1, N - 1
            state%mt(i) = iand(4294967295_INT64,1812433253_INT64 * ieor(state%mt(i-1),ishft(state%mt(i-1),-30_INT64)) + i)
        end do
        
        state%mti = N

    end subroutine mtprng_init
    
    !--------------------------------------------------------------------------
    ! Initialize with an array of seeds
    subroutine mtprng_init_by_array(init_key, state)
    
        ! arguments
        integer(INT32), dimension(:), intent(in) :: init_key
        type(mtprng_state), intent(out) :: state
        
        ! working storage
        integer :: key_length
        integer :: i
        integer :: j
        integer :: k
        
        call mtprng_init(19650218_INT32,state)
        
        i = 1
        j = 0
        key_length = size(init_key)
        
        do k = max(N,key_length), 0, -1
            state%mt(i) = ieor(state%mt(i),(ieor(state%mt(i-1),ishft(state%mt(i-1),-30_INT64) * 1664525_INT64))) + init_key(j) + j
            
            i = i + 1
            j = j + 1
            
            if (i >= N) then
                state%mt(0) = state%mt(N-1)
                i = 1
            end if
            
            if (j >= key_length) j = 0
        end do
        
        do k = N-1, 0, -1
            state%mt(i) = ieor(state%mt(i),(ieor(state%mt(i-1),ishft(state%mt(i-1),-30_INT64) * 1566083941_INT64))) - i
            
            i = i + 1
            
            if (i>=N) then
                state%mt(0) = state%mt(N-1)
                i = 1
            end if
        end do

        state%mt(0) = 1073741824_INT64 ! 0x40000000, assuring non-zero initial array 
        
    end subroutine mtprng_init_by_array
    
    !--------------------------------------------------------------------------
    !   Obtain the next 32-bit integer in the psuedo-random sequence
    function mtprng_rand64(state) result(r)
    
        ! arguments
        type(mtprng_state), intent(inout) :: state
    
        !return type
        integer(INT64) :: r

        ! internal constants
        integer(INT64), dimension(0:1), parameter :: mag01 = (/ 0_INT64, -1727483681_INT64 /)

        ! Period parameters
        integer(INT64), parameter :: UPPER_MASK =  2147483648_INT64
        integer(INT64), parameter :: LOWER_MASK =  2147483647_INT64

        ! Tempering parameters
        integer(INT64), parameter :: TEMPERING_B = -1658038656_INT64
        integer(INT64), parameter :: TEMPERING_C =  -272236544_INT64
        
        ! Note: variable names match those in original example
        integer(INT32) :: kk
        
        ! Generate N words at a time
        if (state%mti >= N) then
            ! The value -1 acts as a flag saying that the seed has not been set.
            if (state%mti == -1) call mtprng_init(4357_INT32,state)
            
            ! Fill the mt array
            do kk = 0, N - M - 1
                r = ior(iand(state%mt(kk),UPPER_MASK),iand(state%mt(kk+1),LOWER_MASK))
                state%mt(kk) = ieor(ieor(state%mt(kk + M),ishft(r,-1_INT64)),mag01(iand(r,1_INT64)))
            end do
            
            do kk = N - M, N - 2
                r = ior(iand(state%mt(kk),UPPER_MASK),iand(state%mt(kk+1),LOWER_MASK))
                state%mt(kk) = ieor(ieor(state%mt(kk + (M - N)),ishft(r,-1_INT64)),mag01(iand(r,1_INT64)))
            end do
            
            r = ior(iand(state%mt(N-1),UPPER_MASK),iand(state%mt(0),LOWER_MASK))
            state%mt(N-1) = ieor(ieor(state%mt(M-1),ishft(r,-1)),mag01(iand(r,1_INT64)))
            
            ! Start using the array from first element
            state%mti = 0
        end if
        
        ! Here is where we actually calculate the number with a series of
        !   transformations 
        r = state%mt(state%mti)
        state%mti = state%mti + 1
        
        r = ieor(r,ishft(r,-11))
        r = iand(4294967295_INT64,ieor(r,iand(ishft(r, 7),TEMPERING_B)))
        r = iand(4294967295_INT64,ieor(r,iand(ishft(r,15),TEMPERING_C)))
        r = ieor(r,ishft(r,-18))
        
    end function mtprng_rand64
    
    !--------------------------------------------------------------------------
    !   Obtain the next 32-bit integer in the psuedo-random sequence
    function mtprng_rand(state) result(r)
    
        ! arguments
        type(mtprng_state), intent(inout) :: state
    
        !return type
        integer(INT32) :: r
        
        ! working storage
        integer(INT64) :: x
        
        ! done
        x = mtprng_rand64(state)
        
        if (x > 2147483647_INT64) then
            r = x - 4294967296_INT64
        else
            r = x
        end if
        
    end function mtprng_rand
    
    !---------------------------------------------------------------------------
    !   Obtain a psuedorandom integer in the range [lo,hi]
    function mtprng_rand_range(state, lo, hi) result(r)

        ! arguments
        type(mtprng_state), intent(inout) :: state
        integer, intent(in) :: lo
        integer, intent(in) :: hi
        
        ! return type
        integer(INT32) :: r
        
        ! Use real value to caluclate range
        r = lo + floor((hi - lo + 1.0_IEEE64) * mtprng_rand_real2(state))
        
    end function mtprng_rand_range

    !--------------------------------------------------------------------------
    !   Obtain a psuedorandom real number in the range [0,1], i.e., a number
    !   greater than or equal to 0 and less than or equal to 1.
    function mtprng_rand_real1(state) result(r)

        ! arguments
        type(mtprng_state), intent(inout) :: state
    
        ! return type
        real(IEEE64) :: r
        
        ! Local constant; precalculated to avoid division below
        real(IEEE64), parameter :: factor = 1.0_IEEE64 / 4294967295.0_IEEE64
        
        ! compute
        r = real(mtprng_rand64(state),IEEE64) * factor
        
    end function mtprng_rand_real1

    !--------------------------------------------------------------------------
    !   Obtain a psuedorandom real number in the range [0,1), i.e., a number
    !   greater than or equal to 0 and less than 1.
    function mtprng_rand_real2(state) result(r)

        ! arguments
        type(mtprng_state), intent(inout) :: state
    
        ! return type
        real(IEEE64) :: r
        
        ! Local constant; precalculated to avoid division below
        real(IEEE64), parameter :: factor = 1.0_IEEE64 / 4294967296.0_IEEE64
        
        ! compute
        r = real(mtprng_rand64(state),IEEE64) * factor
        
    end function mtprng_rand_real2

    !--------------------------------------------------------------------------
    !   Obtain a psuedorandom real number in the range (0,1), i.e., a number
    !   greater than 0 and less than 1.
    function mtprng_rand_real3(state) result(r)

        ! arguments
        type(mtprng_state), intent(inout) :: state
    
        ! return type
        real(IEEE64) :: r
        
        ! Local constant; precalculated to avoid division below
        real(IEEE64), parameter :: factor = 1.0_IEEE64 / 4294967296.0_IEEE64
        
        r = (real(mtprng_rand64(state),IEEE64) + 0.5_IEEE64) * factor
        
    end function mtprng_rand_real3

end module fox_m_utils_mtprng

module m_ieee

  implicit none
  private

  public :: generate_nan

contains

  function generate_nan() result(nan)
    real :: nan
    real :: zero
    zero = 0.0
    nan = 0.0/zero
  end function generate_nan 

end module m_ieee 

program test

  use FoX_wcml
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  real :: sym_ops(3,3,2)

  sym_ops(:,:,1) = reshape((/1.0, 0.0, 0.0, &
                             0.0, 1.0, 0.0, &
                             0.0, 0.0, 1.0/), (/3,3/))

  sym_ops(:,:,2) = reshape((/1.0, 0.0, 0.0, &
                             0.0, 1.0, 0.0, &
                             0.0, 0.0, 1.0/), (/3,3/))

  call cmlBeginFile(xf, filename, unit=-1)
  call cmlStartCml(xf)
  call cmlAddSymmetry(xf, pointGroup="C2v", sym_ops=sym_ops)
  call cmlFinishFile(xf)

end program test

program test

  use FoX_common, only: str
  use FoX_wcml, only : xmlf_t, cmlBeginFile, cmlFinishFile, cmlStartCml, cmlEndCml, cmlAddProperty
  use FoX_wxml, only: xml_AddCharacters
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  call cmlBeginFile(xf, filename, unit=-1)
  call cmlStartCml(xf)
  call cmlAddProperty(xf, title="name", value=(/(1.0,2.0), (3.0,-4.0)/), fmt="s3", units="siUnits:m")

  call cmlFinishFile(xf)

end program test

program test

  use m_common_charset, only : XML1_0, XML1_1
  use m_common_struct, only : xml_doc_state
  use m_common_namecheck, only : checkPITarget
  implicit none

  type(xml_doc_state) :: xds

  write(*,'(l1)') checkPITarget('abcd', xds)
  write(*,'(l1)') checkPITarget('1abcd', xds)
  write(*,'(l1)') checkPITarget(':abcd', xds)
  write(*,'(l1)') checkPITarget('#abcd', xds)
  write(*,'(l1)') checkPITarget('e:abcd', xds)
  write(*,'(l1)') checkPITarget('xmle:abcd', xds)
  write(*,'(l1)') checkPITarget('xMle:abcd', xds)

  xds%xml_version = XML1_1

  write(*,'(l1)') checkPITarget('abcd', xds)
  write(*,'(l1)') checkPITarget('1abcd', xds)
  write(*,'(l1)') checkPITarget(':abcd', xds)
  write(*,'(l1)') checkPITarget('#abcd', xds)
  write(*,'(l1)') checkPITarget('e:abcd', xds)
  write(*,'(l1)') checkPITarget('xmle:abcd', xds)
  write(*,'(l1)') checkPITarget('xMle:abcd', xds)

end program test

module fox_m_utils_uuid

  !This generates UUIDs according to RFC 4122

  ! Only types 1 (time-based) and 4 (pseudo-RNG-based) are implemented.

  use fox_m_utils_mtprng, only : mtprng_state, mtprng_init, mtprng_rand64
  implicit none
  private
  
  integer, parameter :: i4b = selected_int_kind(9)
  integer, parameter :: i8b = selected_int_kind(18)
  
  character, parameter :: hexdigits(0:15) = &
    (/'0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f'/)
  
  type(mtprng_state), save :: rng_state
  logical, save :: initialized = .false.
  integer, save :: values_save
  integer, save :: hires_count = 0

! clock-seq holds a random number constant for the lifetime of the program
! using this module. That's the best we can do per S 4.1.5
  integer, save :: clock_seq = 0

  public :: generate_uuid
  
contains
  
  function generate_uuid(version) result(uuid)
    integer, intent(in), optional :: version
    character(len=36) :: uuid

    integer(kind=i8b) :: timestamp, node
    integer(kind=i4b) :: clock_sequence

    integer(kind=i4b) :: time_low, time_mid, time_hi_and_version
    integer(kind=i4b) :: clk_seq_hi_res, clk_seq_low

    integer :: values(8)
    integer :: variant, v


    if (.not.initialized) then
      call mtprng_init(values(7)*10000+values(8), rng_state)
      clock_seq = int(mtprng_rand64(rng_state), i4b)
      initialized = .true.
    endif

    variant = 1

    if (present(version)) then
      v = version
    else
      v = 4
    endif

    select case (v)
    case (0)
      ! Nil UUID  - S 4.1.7
      uuid = repeat('0',8)//'-'//repeat('0',4)//'-'//repeat('0',4)// &
        '-'//repeat('0',4)//'-'//repeat('0',12)
      return
    case(1)
      call date_and_time(values=values)
      ! In case of too-frequent requests, we will replace time_low
      ! with the count below ...
      if (all(values==values_save)) then
        hires_count = hires_count + 1
      else
        hires_count = 0
      endif
    case(2-3)
      !Unimplemented
      uuid = ''
      return
    case(4)
      continue
    case(5)
      !Unimplemented
      uuid = ''
      return
    case default
      !Unspecified
      uuid = ''
      return
    end select

!4.1.4 Timestamp

    select case(v)
    case(1)
      timestamp = get_utc_since_1582(values)
    case(4)
      timestamp = ior(mtprng_rand64(rng_state), ishft(mtprng_rand64(rng_state), 28))
    end select

!4.1.5 Clock Sequence
    ! 14 bits
    select case(v)
    case(1)
      clock_sequence = clock_seq
    case(4)
      clock_sequence = int(mtprng_rand64(rng_state), i4b)
    end select

!4.1.6 Node
    ! 48 bits
    select case(v)
    case(1)
      node = ior(mtprng_rand64(rng_state), ishft(mtprng_rand64(rng_state), 16))
      ! No MAC address accessible - see section 4.5 !FIXME
    case(4)
      node = ior(mtprng_rand64(rng_state), ishft(mtprng_rand64(rng_state), 16))
    end select

    time_low = ibits(timestamp, 0, 32)
    time_mid = ibits(timestamp, 32, 16)
    if (hires_count==0) then
      time_hi_and_version = ior(int(ibits(timestamp, 48, 12), i4b), ishft(v, 12))
    else
      time_hi_and_version = ior(hires_count, ishft(v, 12))
    endif

    clk_seq_low = ibits(clock_sequence, 0, 8)
    clk_seq_hi_res = ior(ibits(clock_sequence, 8, 6), ishft(variant, 6))

    uuid = int32ToHexOctets(time_low, 4)//"-"// &
      int32ToHexOctets(time_mid, 2)//"-"// &
      int32ToHexOctets(time_hi_and_version, 2)//"-"// & 
      int32ToHexOctets(clk_seq_hi_res, 1)// &
      int32ToHexOctets(clk_seq_low, 1)//"-"// &
      int64ToHexOctets(node, 6)

  contains

    function int32ToHexOctets(b, n) result(s)
      integer(i4b), intent(in) :: b
      integer, intent(in) :: n ! number of octets to print
      character(len=2*n) :: s
      
      integer :: i
      
      do i = 0, 2*n-1
        s(2*n-i:2*n-i) = hexdigits(ibits(b, i*4, 4))
      enddo
      
    end function int32ToHexOctets
    function int64ToHexOctets(b, n) result(s)
      integer(i8b), intent(in) :: b
      integer, intent(in) :: n ! number of octets to print
      character(len=2*n) :: s
      
      integer :: i
      
      do i = 0, 2*n-1
        s(2*n-i:2*n-i) = hexdigits(ibits(b, i*4, 4))
      enddo
      
    end function int64ToHexOctets
    
  end function generate_uuid
  

  function get_utc_since_1582(values) result(ns)
    ! This subroutine is a little broken. It only works
    ! for times after 1/1/2006 and takes no account
    ! of any future leapseconds. It ought to serve regardless.

    ! It returns the number of 100-ns intervals since 1582-10-15-00-00-00

    integer, dimension(8), intent(in) :: values
    integer(kind=i8b) :: ns

    integer :: days
    integer :: years

    integer, parameter :: days_in_normal_year(12) = &
      (/31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/)

    ns = 23_i8b * 1000_i8b * 1000_i8b * 10_i8b ! 23 leap seconds until 24:00:00 31/12/2005

    ! A count of the 100-nanosecond intervals since the
    ! beginning of the day.
    ns = ns &
      ! milliseconds
      + int(values(8), i8b)             * 10_i8b * 1000_i8b &
      ! seconds
      + int(values(7), i8b)             * 10_i8b * 1000_i8b * 1000_i8b &
      ! minutes (with timezone adjustment)
      + int(values(6) + values(4), i8b) * 10_i8b * 1000_i8b * 1000_i8b * 60_i8b &
      ! hours
      + int(values(5), i8b)             * 10_i8b * 1000_i8b * 1000_i8b * 60_i8b * 60_i8b

    ! Number of days this year:
    days = sum(days_in_normal_year(:values(2)-1))
    days = days + values(3) - 1 !add days in current month
    if (values(2)>2 .and. isLeapYear(values(1))) then
      days = days + 1
    endif
    !That's all the time since the turn of this year

    days = days + 78 ! From the start of 15th Oct to the end of 31st Dec in 1582
    !That's the additional time before the turn of the year 1583

    days = days + 102  ! 102 leap years from 1584 to 2000 inclusive
    ! That's all the intercalataed days until 2000
    
    years = values(1) - 2000 - 1 ! years since 2000 - not including this year

    days = days + years/4 - years/100 + years/400 !Add extra leap days to this total:
    ! That's all out intercalated days - remaining years are all 365 days long.

    years = years + 418 ! Add the years from 1583-2000 inclusive back on.

    ! Multiply by number of time units in one day & add to today's total.
    ns = ns + 864000000000_i8b * (int(days,i8b) + 365_i8b * int(years,i8b))

  contains
    function isLeapYear(y) result(p)
      integer, intent(in) :: y
      logical :: p
      p = (mod(y,4)==0 .and. .not.mod(y,100)==0 .or. mod(y,400)==0)
    end function isLeapYear

  end function get_utc_since_1582


end module fox_m_utils_uuid

module m_wcml_coma
  ! Implements routines relating to electronic structure

  use m_common_realtypes, only: sp, dp
  use FoX_wxml, only: xmlf_t
#ifndef DUMMYLIB
  use FoX_wxml, only: xml_NewElement, xml_AddAttribute
  use FoX_wxml, only: xml_EndElement
  use m_wcml_stml, only: stmAddValue

! Fix for pgi, requires this explicitly:
  use m_wxml_overloads
#endif

  implicit none
  private

  public :: cmlStartKpoint
  public :: cmlEndKpoint
  public :: cmlAddKpoint

  public :: cmlStartBand
  public :: cmlEndBand
  public :: cmlAddBandList
  public :: cmlAddEigenValue
  public :: cmlAddEigenValueVector

  public :: cmlAddSymmetry

  interface cmlAddEigenValue
    module procedure cmlAddEigenValueSP
    module procedure cmlAddEigenValueDP
  end interface

  interface cmlAddEigenValueVector
    module procedure cmlAddEigenValueVectorSP
    module procedure cmlAddEigenValueVectorDP
    module procedure cmlAddEigenValueVectorCmplxSP
    module procedure cmlAddEigenValueVectorCmplxDP
  end interface

  interface cmlStartKpoint
    module procedure cmlStartKpointSP
    module procedure cmlStartKpointDP
  end interface

  interface cmlAddKpoint
    module procedure cmlAddKpointSP
    module procedure cmlAddKpointDP
  end interface

  interface cmlAddBandList
    module procedure cmlAddBandListSP
    module procedure cmlAddBandListDP
  end interface

  interface cmlAddSymmetry
    module procedure cmlAddSymmetrySP
    module procedure cmlAddSymmetryDP
    module procedure cmlAddSymmetryNoOps
  end interface

contains


  subroutine cmlStartKPointsp(xf, coords, weight, kptfmt, wtfmt &
,dictRef,convention,title,id,ref,label)
    type(xmlf_t), intent(inout)              :: xf
    real(kind=sp), dimension(3), intent(in)  :: coords
    real(kind=sp), intent(in), optional      :: weight
    character(len=*), intent(in), optional   :: kptfmt
    character(len=*), intent(in), optional   :: wtfmt
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: label



#ifndef DUMMYLIB
    call xml_NewElement(xf, "kpoint")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(label)) call xml_addAttribute(xf, "label", label)



    call xml_AddAttribute(xf, "coords", coords, kptfmt)
    if (present(weight)) &
       call xml_AddAttribute(xf, "weight", weight, wtfmt)
#endif

  end subroutine cmlStartKPointsp

  subroutine cmlAddKPointsp(xf, coords, weight, kptfmt, wtfmt &
,dictRef,convention,title,id,ref,label)
    type(xmlf_t), intent(inout)             :: xf
    real(kind=sp), dimension(3), intent(in) :: coords
    real(kind=sp), intent(in), optional     :: weight
    character(len=*), intent(in), optional   :: kptfmt
    character(len=*), intent(in), optional   :: wtfmt
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: label



#ifndef DUMMYLIB
    call cmlStartKpoint(xf, coords, weight, kptfmt, wtfmt &
,dictRef,convention,title,id,ref,label)
    call cmlEndKpoint(xf)
#endif

  end subroutine cmlAddKPointsp

  subroutine cmlAddEigenValuesp(xf, value, units, fmt &
,dictRef,convention,title,id,type)
    type(xmlf_t), intent(inout)            :: xf
    real(kind=sp), intent(in)              :: value
    character(len=*), intent(in)           :: units
    character(len=*), intent(in), optional :: fmt

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: type



#ifndef DUMMYLIB
    call xml_NewElement(xf, "eigen")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(type)) call xml_addAttribute(xf, "type", type)



    call stmAddValue(xf=xf, value=value, fmt=fmt, units=units)
    call xml_EndElement(xf, "eigen")
#endif

  end subroutine cmlAddEigenValuesp

  subroutine cmlAddEigenValueVectorsp(xf, eigval, eigvec, units, valfmt, vecfmt &
,dictRef,convention,title,id,type)
    type(xmlf_t), intent(inout)            :: xf
    real(kind=sp), intent(in)              :: eigval
    real(kind=sp), intent(in)              :: eigvec(:,:)
    character(len=*), intent(in)           :: units
    character(len=*), intent(in), optional :: valfmt
    character(len=*), intent(in), optional :: vecfmt

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: type



#ifndef DUMMYLIB
    call xml_NewElement(xf, "eigen")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(type)) call xml_addAttribute(xf, "type", type)



    call stmAddValue(xf=xf, value=eigval, fmt=valfmt, units=units)
!FIXME check 2nd dimension of matrix is 3
    call stmAddValue(xf=xf, value=eigvec, fmt=vecfmt, units="units:dimensionless")
    call xml_EndElement(xf, "eigen")
#endif

  end subroutine cmlAddEigenValueVectorsp

  subroutine cmlAddEigenValueVectorCmplxsp(xf, eigval, eigvec, units, vecfmt, valfmt &
,dictRef,convention,title,id,type)
    type(xmlf_t), intent(inout)            :: xf
    real(kind=sp), intent(in)              :: eigval
    complex(kind=sp), intent(in)           :: eigvec(:,:)
    character(len=*), intent(in)           :: units
    character(len=*), intent(in), optional :: vecfmt
    character(len=*), intent(in), optional :: valfmt

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: type



#ifndef DUMMYLIB
    call xml_NewElement(xf, "eigen")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(type)) call xml_addAttribute(xf, "type", type)



    call stmAddValue(xf=xf, value=eigval, fmt=valfmt, units=units)
    call stmAddValue(xf=xf, value=eigvec, fmt=vecfmt, units="units:dimensionless")
    call xml_EndElement(xf, "eigen")
#endif

  end subroutine cmlAddEigenValueVectorCmplxsp

  subroutine cmlAddBandListsp(xf, values, fmt, units, spin &
,dictRef,convention,title,id,type)
    type(xmlf_t), intent(inout)            :: xf
    real(kind=sp), intent(in)              :: values(:)
    character(len=*), intent(in)           :: units
    character(len=*), intent(in), optional :: spin
    character(len=*), intent(in), optional :: fmt

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: type



#ifndef DUMMYLIB
    call xml_NewElement(xf, "bandList")
    if (present(spin)) then
      if (spin=="up".or.spin=="down") then
        call xml_AddAttribute(xf, "spin", spin)
      else
        !error
      endif
    endif
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(type)) call xml_addAttribute(xf, "type", type)


    call xml_NewElement(xf, "eigen")
    call stmAddValue(xf=xf, value=values, fmt=fmt, units=units)
    call xml_EndElement(xf, "eigen")
    call xml_EndElement(xf, "bandList")
#endif

  end subroutine cmlAddBandListsp

  subroutine cmlAddSymmetrysp(xf, sym_ops, sym_disps, spaceGroup, pointGroup &
,dictRef,convention,title,id,type)
    type(xmlf_t), intent(inout)                 :: xf
    real(kind=sp), intent(in)                   :: sym_ops(:,:,:)
    real(kind=sp), intent(in), optional         :: sym_disps(:,:)
    character(len=*), intent(in), optional      :: spaceGroup
    character(len=*), intent(in), optional      :: pointGroup

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: type



#ifndef DUMMYLIB
    integer :: i, n
    real(kind=sp) :: seitzMatrix(4,4)

    call xml_NewElement(xf, "symmetry")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(type)) call xml_addAttribute(xf, "type", type)


    if (present(spaceGroup)) &
      call xml_AddAttribute(xf, "spaceGroup", spaceGroup)
    if (present(pointGroup)) &
      call xml_AddAttribute(xf, "pointGroup", pointGroup)

    if (present(sym_disps)) then
      if (size(sym_ops, 3)/=size(sym_disps, 2)) then
        ! FIXME error
      endif
    endif
    n = size(sym_ops, 3)

    do i = 1, n
      !Convert the 3x3 rotation and 1x3 translation into a 4x4 Seitz matrix
      if (.not.present(sym_disps)) then
        seitzMatrix = reshape((/sym_ops(:,1,i), 0.0_sp, &
                                sym_ops(:,2,i), 0.0_sp, &
                                sym_ops(:,3,i), 0.0_sp, &
                                0.0_sp, 0.0_sp, 0.0_sp, 1.0_sp/), (/4,4/))
      else
        seitzMatrix = reshape((/sym_ops(:,1,i), sym_disps(1,i), &
                                sym_ops(:,2,i), sym_disps(2,i), &
                                sym_ops(:,3,i), sym_disps(3,i), &
                                0.0_sp, 0.0_sp, 0.0_sp, 1.0_sp/), (/4,4/))
      endif
      call xml_NewElement(xf, "transform3")
      call xml_AddCharacters(xf, chars=seitzMatrix) 
      call xml_EndElement(xf, "transform3")
    end do
    call xml_EndElement(xf, "symmetry")
#endif

    end subroutine cmlAddSymmetrysp



  subroutine cmlStartKPointdp(xf, coords, weight, kptfmt, wtfmt &
,dictRef,convention,title,id,ref,label)
    type(xmlf_t), intent(inout)              :: xf
    real(kind=dp), dimension(3), intent(in)  :: coords
    real(kind=dp), intent(in), optional      :: weight
    character(len=*), intent(in), optional   :: kptfmt
    character(len=*), intent(in), optional   :: wtfmt
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: label



#ifndef DUMMYLIB
    call xml_NewElement(xf, "kpoint")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(label)) call xml_addAttribute(xf, "label", label)



    call xml_AddAttribute(xf, "coords", coords, kptfmt)
    if (present(weight)) &
       call xml_AddAttribute(xf, "weight", weight, wtfmt)
#endif

  end subroutine cmlStartKPointdp

  subroutine cmlAddKPointdp(xf, coords, weight, kptfmt, wtfmt &
,dictRef,convention,title,id,ref,label)
    type(xmlf_t), intent(inout)             :: xf
    real(kind=dp), dimension(3), intent(in) :: coords
    real(kind=dp), intent(in), optional     :: weight
    character(len=*), intent(in), optional   :: kptfmt
    character(len=*), intent(in), optional   :: wtfmt
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: label



#ifndef DUMMYLIB
    call cmlStartKpoint(xf, coords, weight, kptfmt, wtfmt &
,dictRef,convention,title,id,ref,label)
    call cmlEndKpoint(xf)
#endif

  end subroutine cmlAddKPointdp

  subroutine cmlAddEigenValuedp(xf, value, units, fmt &
,dictRef,convention,title,id,type)
    type(xmlf_t), intent(inout)            :: xf
    real(kind=dp), intent(in)              :: value
    character(len=*), intent(in)           :: units
    character(len=*), intent(in), optional :: fmt

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: type



#ifndef DUMMYLIB
    call xml_NewElement(xf, "eigen")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(type)) call xml_addAttribute(xf, "type", type)



    call stmAddValue(xf=xf, value=value, fmt=fmt, units=units)
    call xml_EndElement(xf, "eigen")
#endif

  end subroutine cmlAddEigenValuedp

  subroutine cmlAddEigenValueVectordp(xf, eigval, eigvec, units, valfmt, vecfmt &
,dictRef,convention,title,id,type)
    type(xmlf_t), intent(inout)            :: xf
    real(kind=dp), intent(in)              :: eigval
    real(kind=dp), intent(in)              :: eigvec(:,:)
    character(len=*), intent(in)           :: units
    character(len=*), intent(in), optional :: valfmt
    character(len=*), intent(in), optional :: vecfmt

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: type



#ifndef DUMMYLIB
    call xml_NewElement(xf, "eigen")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(type)) call xml_addAttribute(xf, "type", type)



    call stmAddValue(xf=xf, value=eigval, fmt=valfmt, units=units)
!FIXME check 2nd dimension of matrix is 3
    call stmAddValue(xf=xf, value=eigvec, fmt=vecfmt, units="units:dimensionless")
    call xml_EndElement(xf, "eigen")
#endif

  end subroutine cmlAddEigenValueVectordp

  subroutine cmlAddEigenValueVectorCmplxdp(xf, eigval, eigvec, units, vecfmt, valfmt &
,dictRef,convention,title,id,type)
    type(xmlf_t), intent(inout)            :: xf
    real(kind=dp), intent(in)              :: eigval
    complex(kind=dp), intent(in)           :: eigvec(:,:)
    character(len=*), intent(in)           :: units
    character(len=*), intent(in), optional :: vecfmt
    character(len=*), intent(in), optional :: valfmt

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: type



#ifndef DUMMYLIB
    call xml_NewElement(xf, "eigen")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(type)) call xml_addAttribute(xf, "type", type)



    call stmAddValue(xf=xf, value=eigval, fmt=valfmt, units=units)
    call stmAddValue(xf=xf, value=eigvec, fmt=vecfmt, units="units:dimensionless")
    call xml_EndElement(xf, "eigen")
#endif

  end subroutine cmlAddEigenValueVectorCmplxdp

  subroutine cmlAddBandListdp(xf, values, fmt, units, spin &
,dictRef,convention,title,id,type)
    type(xmlf_t), intent(inout)            :: xf
    real(kind=dp), intent(in)              :: values(:)
    character(len=*), intent(in)           :: units
    character(len=*), intent(in), optional :: spin
    character(len=*), intent(in), optional :: fmt

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: type



#ifndef DUMMYLIB
    call xml_NewElement(xf, "bandList")
    if (present(spin)) then
      if (spin=="up".or.spin=="down") then
        call xml_AddAttribute(xf, "spin", spin)
      else
        !error
      endif
    endif
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(type)) call xml_addAttribute(xf, "type", type)


    call xml_NewElement(xf, "eigen")
    call stmAddValue(xf=xf, value=values, fmt=fmt, units=units)
    call xml_EndElement(xf, "eigen")
    call xml_EndElement(xf, "bandList")
#endif

  end subroutine cmlAddBandListdp

  subroutine cmlAddSymmetrydp(xf, sym_ops, sym_disps, spaceGroup, pointGroup &
,dictRef,convention,title,id,type)
    type(xmlf_t), intent(inout)                 :: xf
    real(kind=dp), intent(in)                   :: sym_ops(:,:,:)
    real(kind=dp), intent(in), optional         :: sym_disps(:,:)
    character(len=*), intent(in), optional      :: spaceGroup
    character(len=*), intent(in), optional      :: pointGroup

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: type



#ifndef DUMMYLIB
    integer :: i, n
    real(kind=dp) :: seitzMatrix(4,4)

    call xml_NewElement(xf, "symmetry")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(type)) call xml_addAttribute(xf, "type", type)


    if (present(spaceGroup)) &
      call xml_AddAttribute(xf, "spaceGroup", spaceGroup)
    if (present(pointGroup)) &
      call xml_AddAttribute(xf, "pointGroup", pointGroup)

    if (present(sym_disps)) then
      if (size(sym_ops, 3)/=size(sym_disps, 2)) then
        ! FIXME error
      endif
    endif
    n = size(sym_ops, 3)

    do i = 1, n
      !Convert the 3x3 rotation and 1x3 translation into a 4x4 Seitz matrix
      if (.not.present(sym_disps)) then
        seitzMatrix = reshape((/sym_ops(:,1,i), 0.0_dp, &
                                sym_ops(:,2,i), 0.0_dp, &
                                sym_ops(:,3,i), 0.0_dp, &
                                0.0_dp, 0.0_dp, 0.0_dp, 1.0_dp/), (/4,4/))
      else
        seitzMatrix = reshape((/sym_ops(:,1,i), sym_disps(1,i), &
                                sym_ops(:,2,i), sym_disps(2,i), &
                                sym_ops(:,3,i), sym_disps(3,i), &
                                0.0_dp, 0.0_dp, 0.0_dp, 1.0_dp/), (/4,4/))
      endif
      call xml_NewElement(xf, "transform3")
      call xml_AddCharacters(xf, chars=seitzMatrix) 
      call xml_EndElement(xf, "transform3")
    end do
    call xml_EndElement(xf, "symmetry")
#endif

    end subroutine cmlAddSymmetrydp



  subroutine cmlStartBand(xf, spin &
,dictRef,convention,title,id,ref,label)
    type(xmlf_t), intent(inout)            :: xf
    character(len=*), intent(in), optional :: spin
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: label



#ifndef DUMMYLIB
    call xml_NewElement(xf, "band")
    if (present(spin)) then
      if (spin=="up".or.spin=="down") then
        call xml_AddAttribute(xf, "spin", spin)
      else
        !error
      endif
    endif
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(label)) call xml_addAttribute(xf, "label", label)


#endif

  end subroutine cmlStartBand

  subroutine cmlEndKpoint(xf)
    type(xmlf_t), intent(inout) :: xf
#ifndef DUMMYLIB
    call xml_EndElement(xf, "kpoint")
#endif
  end subroutine cmlEndKpoint

  subroutine cmlEndBand(xf)
    type(xmlf_t), intent(inout) :: xf
#ifndef DUMMYLIB
    call xml_EndElement(xf, "band")
#endif
  end subroutine cmlEndBand

  subroutine cmlAddSymmetryNoOps(xf, spaceGroup, pointGroup &
,dictRef,convention,title,id,type)
    type(xmlf_t), intent(inout)                 :: xf
    character(len=*), intent(in), optional      :: spaceGroup
    character(len=*), intent(in), optional      :: pointGroup

    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: type



#ifndef DUMMYLIB

    call xml_NewElement(xf, "symmetry")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(type)) call xml_addAttribute(xf, "type", type)


    if (present(spaceGroup)) &
      call xml_AddAttribute(xf, "spaceGroup", spaceGroup)
    if (present(pointGroup)) &
      call xml_AddAttribute(xf, "pointGroup", pointGroup)

#endif

    end subroutine cmlAddSymmetryNoOps




end module m_wcml_coma

program test

  use FoX_wcml
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  call cmlBeginFile(xf, filename, unit=-1)
  call cmlStartCml(xf)
  call cmlStartBand(xf)
  call cmlAddEigenValueVector(xf, eigval=5.43, &
    eigvec=reshape((/1.0, 2.0, 3.0/), (/1,3/)), units="units:eV")
  call cmlEndBand(xf)
  call cmlFinishFile(xf)

end program test

program test

  use FoX_wxml, only : xmlf_t, xml_OpenFile, xml_Close
  use FoX_wxml, only : xml_NewElement, xml_DeclareNamespace, xml_UndeclareNamespace
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  call xml_OpenFile(filename, xf)
  call xml_DeclareNamespace(xf, "http://www.xml-cml.org/schema", "cml")
  call xml_NewElement(xf, "cml:cml")
  call xml_DeclareNamespace(xf, "http://www.w3.org/1999/svg", "svg")
  call xml_NewElement(xf, "svg:svg")
  call xml_UndeclareNamespace(xf, "cml")
  call xml_NewElement(xf, "svg:toby")
  call xml_NewElement(xf, "cml:toby")

  call xml_Close(xf)

end program test

program test_xml_Openfile

  use FoX_wcml
  implicit none

  character(len=*), parameter :: filename = 'test.xml'

  type(xmlf_t) :: xf1

  integer :: n

  call cmlBeginFile(xf1, filename, unit=20)

  inquire(file=filename, number=n)

  if (n==20) then
    write(*,'(a)') "file is attached"
  else
    write(*,'(a)') "file is not attached"
  endif

end program test_xml_Openfile

program short_test

  use m_common_parse_input, only : rts
  use m_common_realtypes, only: sp, dp

  print*, "test.0.1.1"
  call stringdatascalar("abcd", "abcd", 1, 0)
  print*, "test.0.1.2"
  call stringdatascalar(" abcd ", "abcd", 1, 0)
  print*, "test.0.1.3"
  call stringdatascalar(" abc d ", "abc d", 1, 0)
  print*, "test.0.1.4"
  call stringdatascalar(" abc  d ", "abc d", 1, 0)
  print*, "test.0.1.5"
  call stringdatascalar(" abc "//achar(13)//"  d ", "abc d", 1, 0)

  print*, "test.0.2.1"
  call logicaldatascalar("true", .true., 1, 0)
  print*, "test.0.2.2"
  call logicaldatascalar("false", .false., 1, 0)
  print*, "test.0.2.3"
  call logicaldatascalar("1", .true., 1, 0)
  print*, "test.0.2.4"
  call logicaldatascalar("0", .false., 1, 0)
  print*, "test.0.2.5"
  call logicaldatascalar("  true  ", .true., 1, 0)
  print*, "test.0.2.6"
  call logicaldatascalar("  false  ", .false., 1, 0)
  print*, "test.0.2.7"
  call logicaldatascalar("  1 ", .true., 1, 0)
  print*, "test.0.2.8"
  call logicaldatascalar("  0 ", .false., 1, 0)
  print*, "test.0.2.9"
  call logicaldatascalar("  .tru ", .false., 0, 2)
  print*, "test.0.2.10"
  call logicaldatascalar("  false. ", .false., 0, 2)

  print*, "test.0.3.1"
  call integerdatascalar(" 1 ", 1, 1, 0)
  print*, "test.0.3.2"
  call integerdatascalar(" -10 ", -10, 1, 0)
  print*, "test.0.3.3"
  call integerdatascalar(" -1.3 ", 0, 0, 2)

  print*, "test.0.4.1"
  call realspdatascalar(" 1 ", 1.0, 1, 0)
  print*, "test.0.4.2"
  call realspdatascalar(" -1.35D2", -1.35e2, 1, 0)
  print*, "test.0.4.3"
  call realspdatascalar(" -1.35FG", 0.0, 0, 2)

  print*, "test.0.5.1"
  call realdpdatascalar(" 1 ", 1.0_dp, 1, 0)
  print*, "test.0.5.2"
  call realdpdatascalar(" -1.35D2", -1.35e2_dp, 1, 0)
  print*, "test.0.5.3"
  call realdpdatascalar(" -1.35FG", 0.0_dp, 0, 2)

  print*, "test.0.6.1"
  call complexspdatascalar(" 1,2 ", (1.0,2.0), 1, 0)
  print*, "test.0.6.2"
  call complexspdatascalar(" (1)+i(2)", (1.0,2.0), 1, 0)
  print*, "test.0.6.3"
  call complexspdatascalar(" arse", (0.0,0.0), 0, 2)

  print*, "test.0.7.1"
  call complexdpdatascalar(" 1,2 ", (1.0_dp,2.0_dp), 1, 0)
  print*, "test.0.7.2"
  call complexdpdatascalar(" (1)+i(2)", (1.0_dp,2.0_dp), 1, 0)
  print*, "test.0.7.3"
  call complexdpdatascalar(" arse", (0.0_dp,0.0_dp), 0, 2)

  print*,"test.1.1.1"
  call stringdataarray("a b c d e", (/"a", "b", "c", "d", "e"/), 5, 0)
  print*,"test.1.1.2"
  call stringdataarray("a b c d", (/"a", "b", "c", "d", " "/), 4, -1)
  print*,"test.1.1.3"
  call stringdataarray("a b c d e f", (/"a", "b", "c", "d", "e"/), 5, 1)

  print*,"test.1.2.1"
  call stringdataarray("a, b, c, d, e", (/"a ", " b", " c", " d", " e"/), &
    5, 0, ",")
  print*,"test.1.2.2"
  call stringdataarray("a, b, c, d", (/"a ", " b", " c", " d", "  "/), &
    4, -1, ",")
  print*,"test.1.2.3"
  call stringdataarray("a, b, c, d, e, f", (/"a ", " b", " c", " d", " e"/), &
    5, 1, ",")
  print*,"test.1.2.4"
  call stringdataarray("a, b, c, d, e, ", (/"a ", " b", " c", " d", " e"/), &
    5, 1, ",")
  print*,"test.1.2.5"
  call stringdataarray("a, b, c, d, e,", (/"a ", " b", " c", " d", " e"/), &
    5, 0, ",")

  print*,"test.1.2.6"
  call stringdataarray("a, b, c, d, e", (/"a ", " b", " c", " d", " e"/), &
    5, 0, csv=.true.)
  print*,"test.1.2.7"
  call stringdataarray("a, b, c, d", (/"a ", " b", " c", " d", "  "/), &
    4, -1, csv=.true.)
  print*,"test.1.2.8"
  call stringdataarray("a, b, c, d, e, f", (/"a ", " b", " c", " d", " e"/), &
    5, 1, csv=.true.)
  print*,"test.1.2.9" 
  call stringdataarray("a, b, c, d, e, ", (/"a ", " b", " c", " d", " e"/), &
    5, 1, csv=.true.)
  print*,"test.1.2.10"
  call stringdataarray("a, b, c, d, e,", (/"a ", " b", " c", " d", " e"/), &
    5, 1, csv=.true.)
  print*,"test.1.2.11"
  call stringdataarray("a, b, c,, e", (/"a ", " b", " c", "  ", " e"/), & 
    5, 0, csv=.true.)
  print*,"test.1.2.12"
  call stringdataarray("a, b, c, d,", (/"a ", " b", " c", " d", "  "/), &  
    5, 0, csv=.true.)
  print*,"test.1.2.13"
  call stringdataarray(", b, c, d, e", (/"  ", " b", " c", " d", " e"/), & 
    5, 0, csv=.true.)

  print*,"test.1.3.1"
  call stringdatamatrix("a b c d e f", &
    reshape((/"a", "b", "c", "d", "e", "f"/), (/2,3/)), &
    6, 0)
  print*,"test.1.3.2"
  call stringdatamatrix("a b c d", &
    reshape((/"a", "b", "c", "d", " ", " "/), (/2,3/)), &
    4, -1)
  print*,"test.1.3.3"
  call stringdatamatrix("a b c d e f g", &
    reshape((/"a", "b", "c", "d", "e", "f"/), (/2,3/)), &
    6, 1)

  print*,"test.1.4.1"
  call stringdatamatrix("a, b, c, d, e, f", &
    reshape((/"a ", " b", " c", " d", " e", " f"/), (/2,3/)), &
    6, 0, ",")
  print*,"test.1.4.2"
  call stringdatamatrix("a, b, c, d", &
    reshape((/"a ", " b", " c", " d", "  ", "  "/), (/2,3/)), &
    4, -1, ",")
  print*,"test.1.4.3"
  call stringdatamatrix("a, b, c, d, e, f, g", &
    reshape((/"a ", " b", " c", " d", " e", " f"/), (/2,3/)), &
    6, 1, ",")
  print*,"test.1.4.4"
  call stringdatamatrix("a, b, c, d, e, f, ", &
    reshape((/"a ", " b", " c", " d", " e", " f"/), (/2,3/)), &
    6, 1, ",")
  print*,"test.1.4.5"
  call stringdatamatrix("a, b, c, d, e, f,", &
    reshape((/"a ", " b", " c", " d", " e", " f"/), (/2,3/)), &
    6, 0, ",")

  print*, "test.2.1.1"
  call logicaldataarray("true false false false true", &
    (/.true., .false., .false., .false., .true./), 5, 0)
  print*, "test.2.1.2"
  call logicaldataarray("true false false false", &
    (/.true., .false., .false., .false., .false./), 4, -1)
  print*, "test.2.1.3"
  call logicaldataarray("true false false false true true", &
    (/.true., .false., .false., .false., .true./), 5, 1)
  print*, "test.2.1.4"
  call logicaldataarray("true, false, false, false true", &
    (/.true., .false., .false., .false., .true./), 5, 0)
  print*, "test.2.1.5"
  call logicaldataarray("true, false, false, ,false true", &
    (/.true., .false., .false., .false., .false./), 3, 2)

  print*, "test.2.2.1"
  call logicaldatamatrix("true false false false true true", &
    reshape((/.true., .false., .false., .false., .true., .true./), (/2,3/)), &
    6, 0)
  print*, "test.2.2.2"
  call logicaldatamatrix("true false false false", &
    reshape((/.true., .false., .false., .false., .false., .false./), (/2,3/)), &
    4, -1)
  print*, "test.2.2.3"
  call logicaldatamatrix("true false false false true true false", &
    reshape((/.true., .false., .false., .false., .true., .true./), (/2,3/)), &
    6, 1)

  print*, "test.3.1.1"
  call integerdataarray("1 2 3 4 5", &
    (/1, 2, 3, 4, 5/), 5, 0)
  print*, "test.3.1.2"
  call integerdataarray("1 2 3 4", &
    (/1, 2, 3, 4, 0/), 4, -1)
  print*, "test.3.1.3"
  call integerdataarray("1 2 3 4 5 6", &
    (/1, 2, 3, 4, 5/), 5, 1)

  print*, "test.3.1.4"
  call integerdataarray("1, 2, 3, 4, 5", & 
    (/1, 2, 3, 4, 5/), 5, 0)
  print*, "test.3.1.5"
  call integerdataarray("1, 2, 3, 4,", & 
    (/1, 2, 3, 4, 0/), 4, -1)
  print*, "test.3.1.6"
  call integerdataarray("1, 2, 3, 4, 5, 6,", & 
    (/1, 2, 3, 4, 5/), 5, 1)

  print*, "test.4.1.1"
  call realspdataarray("1.0 -2.e5 +3.44e-3 4. 5.09090909", & 
    (/1.0e0, -2.e5, 3.44e-3, 4.e0, 5.09090909e0/), 5, 0)
  print*, "test.4.1.2"
  call realspdataarray("1.0 -2.e5 +3.44e-3 4.", & 
    (/1.0e0, -2.e5, 3.44e-3, 4.e0, 0.0e0/), 4, -1)
  print*, "test.4.1.3"
  call realspdataarray("1.0 -2.e5 +3.44e-3 4. 5.09090909 -0.3", & 
    (/1.0e0, -2.e5, 3.44e-3, 4.e0, 5.09090909e0/), 5, 1)

  print*, "test.4.1.4"
  call realspdataarray("1.0, -2.e5 +3.44e-3, 4. 5.09090909", & 
    (/1.0e0, -2.e5, 3.44e-3, 4.e0, 5.09090909e0/), 5, 0)
  print*, "test.4.1.5"
  call realspdataarray("1.0, -2.e5 +3.44e-3, 4.", &  
    (/1.0e0, -2.e5, 3.44e-3, 4.e0, 0.0e0/), 4, -1)
  print*, "test.4.1.6"
  call realspdataarray("1.0, -2.e5 +3.44e-3, 4. 5.09090909, -0.3", & 
    (/1.0e0, -2.e5, 3.44e-3, 4.e0, 5.09090909e0/), 5, 1)

  print*, "test.5.1.1"
  call realdpdataarray("1.0 -2.e5 +3.44e-3 4. 5.09090909", & 
    (/1.0d0, -2.d5, 3.44d-3, 4.d0, 5.09090909d0/), 5, 0)
  print*, "test.5.1.2"
  call realdpdataarray("1.0 -2.e5 +3.44e-3 4.", &  
    (/1.0d0, -2.d5, 3.44d-3, 4.d0, 0.0d0/), 4, -1)
  print*, "test.5.1.3"
  call realdpdataarray("1.0 -2.e5 +3.44e-3 4. 5.09090909 -0.3", & 
    (/1.0d0, -2.d5, 3.44d-3, 4.d0, 5.09090909d0/), 5, 1)

  print*, "test.5.1.4"
  call realdpdataarray("1.0, -2.e5 +3.44e-3, 4. 5.09090909", & 
    (/1.0d0, -2.d5, 3.44d-3, 4.d0, 5.09090909d0/), 5, 0)
  print*, "test.5.1.5"
  call realdpdataarray("1.0, -2.e5 +3.44e-3, 4.", &  
    (/1.0d0, -2.d5, 3.44d-3, 4.d0, 0.0d0/), 4, -1)
  print*, "test.5.1.6"
  call realdpdataarray("1.0, -2.e5 +3.44e-3, 4. 5.09090909, -0.3", & 
    (/1.0d0, -2.d5, 3.44d-3, 4.d0, 5.09090909d0/), 5, 1)

  print*, "test.6.1.1"
  call cmplxspdataarray("(1.0)+i(-2.e5) (+3.44e-3)+i(4.) (5.09090909)+i(1.0) (-2e5)+i(+3.44e-3) (4.)+i(5.09090909)", & 
    (/(1.0e0,-2.e5), (3.44e-3,4.e0), (5.09090909e0,1.0e0), (-2e5,3.44e-3), (4.,5.09090909)/), 5, 0)
  print*, "test.6.1.2"
  call cmplxspdataarray("(1.0)+i(-2.e5) (+3.44e-3)+i(4.) (5.09090909)+i(1.0) (-2e5)+i(+3.44e-3)", & 
    (/(1.0e0,-2.e5), (3.44e-3,4.e0), (5.09090909e0,1.0e0), (-2e5,3.44e-3), (0.,0.)/), 4, -1)
  print*, "test.6.1.3"
  call cmplxspdataarray("(1.0)+i(-2.e5) (+3.44e-3)+i(4.) (5.09090909)+i(1.0) (-2e5)+i(+3.44e-3) (4.)+i(5.09090909) (1)+i(1)", & 
    (/(1.0e0,-2.e5), (3.44e-3,4.e0), (5.09090909e0,1.0e0), (-2e5,3.44e-3), (4.,5.09090909)/), 5, 1)

  print*, "test.6.1.4"
  call cmplxspdataarray("1.0,-2.e5 +3.44e-3,4. 5.09090909,1.0 -2e5,+3.44e-3 4.,5.09090909", & 
    (/(1.0e0,-2.e5), (3.44e-3,4.e0), (5.09090909e0,1.0e0), (-2e5,3.44e-3), (4.,5.09090909)/), 5, 0)
  print*, "test.6.1.5"
  call cmplxspdataarray("1.0,-2.e5 +3.44e-3,4. 5.09090909,1.0 -2e5,+3.44e-3", & 
    (/(1.0e0,-2.e5), (3.44e-3,4.e0), (5.09090909e0,1.0e0), (-2e5,3.44e-3), (0.,0.)/), 4, -1)
  print*, "test.6.1.6"
  call cmplxspdataarray("1.0,-2.e5 +3.44e-3,4. 5.09090909,1.0 -2e5,+3.44e-3 4.,5.09090909 1,1", & 
    (/(1.0e0,-2.e5), (3.44e-3,4.e0), (5.09090909e0,1.0e0), (-2e5,3.44e-3), (4.,5.09090909)/), 5, 1)

contains


    subroutine stringdatascalar(string, array, num, iostat)
      character(len=*), intent(in) :: string
      character(len=*), intent(in) :: array
      integer, intent(in) :: num, iostat

      character(len=len(array)) :: temp
      integer :: n, i 

      call rts(string, temp, num=n, iostat=i)

      if (temp/=array) &
        print*, "Different array"
      if (i/=iostat) &
        print*, "Wrong iostat" 
      if (n/=num) &
        print*, "Wrong num"

    end subroutine stringdatascalar

    subroutine logicaldatascalar(string, array, num, iostat) 
      character(len=*), intent(in) :: string
      logical, intent(in) :: array
      integer, intent(in) :: num, iostat

      logical :: temp 
      integer :: n, i 

      call rts(string, temp, num=n, iostat=i)

      if (temp.neqv.array) &
        print*, "Different array"
      if (i/=iostat) &
        print*, "Wrong iostat" 
      if (n/=num) &
        print*, "Wrong num"

    end subroutine logicaldatascalar

    subroutine integerdatascalar(string, array, num, iostat) 
      character(len=*), intent(in) :: string
      integer, intent(in) :: array
      integer, intent(in) :: num, iostat

      integer :: temp 
      integer :: n, i 

      call rts(string, temp, num=n, iostat=i)

      if (temp/=array) &
        print*, "Different array"
      if (i/=iostat) &
        print*, "Wrong iostat" 
      if (n/=num) &
        print*, "Wrong num"

    end subroutine integerdatascalar

    subroutine realspdatascalar(string, array, num, iostat) 
      character(len=*), intent(in) :: string
      real(sp), intent(in) :: array
      integer, intent(in) :: num, iostat

      real(sp) :: temp 
      integer :: n, i 

      call rts(string, temp, num=n, iostat=i)

      if (array==0.0) then
        if (temp>1e-5) then
          print*, "Different array"
        endif   
      elseif (abs(temp-array)/temp>1e-5) then
        print*, "Different array"
      endif  
      if (i/=iostat) &
        print*, "Wrong iostat" 
      if (n/=num) &
        print*, "Wrong num"

    end subroutine realspdatascalar

    subroutine realdpdatascalar(string, array, num, iostat) 
      character(len=*), intent(in) :: string
      real(dp), intent(in) :: array
      integer, intent(in) :: num, iostat

      real(dp) :: temp 
      integer :: n, i 

      call rts(string, temp, num=n, iostat=i)

      if (array==0.0) then
        if (temp>1e-5) then
          print*, "Different array"
        endif   
      elseif (abs(temp-array)/temp>1e-5) then
        print*, "Different array"
      endif  
      if (i/=iostat) &
        print*, "Wrong iostat" 
      if (n/=num) &
        print*, "Wrong num"

    end subroutine realdpdatascalar

    subroutine complexspdatascalar(string, array, num, iostat) 
      character(len=*), intent(in) :: string
      complex(sp), intent(in) :: array
      integer, intent(in) :: num, iostat

      complex(sp) :: temp 
      integer :: n, i 

      call rts(string, temp, num=n, iostat=i)

      if (real(array)==0.0) then
        if (real(temp)>1e-5) then
          print*, "Different array"
        endif   
      elseif (abs(real(temp)-real(array))/real(temp)>1e-5) then
        print*, "Different array"
      endif  
      if (imag(array)==0.0) then
        if (imag(temp)>1e-5) then
          print*, "Different array"
        endif   
      elseif (abs(imag(temp)-imag(array))/imag(temp)>1e-5) then
        print*, "Different array"
      endif  
      if (i/=iostat) &
        print*, "Wrong iostat" 
      if (n/=num) &
        print*, "Wrong num"

    end subroutine complexspdatascalar

    subroutine complexdpdatascalar(string, array, num, iostat) 
      character(len=*), intent(in) :: string
      complex(dp), intent(in) :: array
      integer, intent(in) :: num, iostat

      complex(dp) :: temp 
      integer :: n, i 

      call rts(string, temp, num=n, iostat=i)

      if (real(array)==0.0) then
        if (real(temp)>1e-5) then
          print*, "Different array"
        endif   
      elseif (abs(real(temp)-real(array))/real(temp)>1e-5) then
        print*, "Different array"
      endif  
      if (imag(array)==0.0) then
        if (imag(temp)>1e-5) then
          print*, "Different array"
        endif   
      elseif (abs(imag(temp)-imag(array))/imag(temp)>1e-5) then
        print*, "Different array"
      endif  
      if (i/=iostat) &
        print*, "Wrong iostat" 
      if (n/=num) &
        print*, "Wrong num"

    end subroutine complexdpdatascalar

    subroutine stringdataarray(string, array, num, iostat, sep, csv)
      character(len=*), intent(in) :: string
      character(len=*), dimension(:), intent(in) :: array
      integer, intent(in) :: num, iostat
      character, intent(in), optional :: sep
      logical, intent(in), optional :: csv

      character(len=len(array)) :: temp(size(array))
      integer :: n, i

      call rts(string, temp, separator=sep, csv=csv, num=n, iostat=i)

      if (any(temp/=array)) &
        print*, "Different array"
      if (i/=iostat) &
        print*, "Wrong iostat"
      if (n/=num) &
        print*, "Wrong num"

    end subroutine stringdataarray

    subroutine stringdatamatrix(string, array, num, iostat, sep, csv)
      character(len=*), intent(in) :: string
      character(len=*), dimension(:, :), intent(in) :: array
      integer, intent(in) :: num, iostat
      character, intent(in), optional :: sep
      logical, intent(in), optional :: csv

      character(len=len(array)) :: temp(size(array,1),size(array,2))
      integer :: n, i

      call rts(string, temp, separator=sep, csv=csv, num=n, iostat=i)

      if (any(temp/=array)) &
        print*, "Different array"
      if (i/=iostat) &
        print*, "Wrong iostat"
      if (n/=num) &
        print*, "Wrong num"
    end subroutine stringdatamatrix

    subroutine logicaldataarray(string, array, num, iostat)
      character(len=*), intent(in) :: string
      logical, dimension(:), intent(in) :: array
      integer, intent(in) :: num, iostat

      logical :: temp(size(array))
      integer :: n, i

      call rts(string, temp, n, i)

      if (any(temp.neqv.array)) &
        print*, "Different array"
      if (i/=iostat) &
        print*, "Wrong iostat"
      if (n/=num) &
        print*, "Wrong num"
    end subroutine logicaldataarray

    subroutine logicaldatamatrix(string, array, num, iostat)
      character(len=*), intent(in) :: string
      logical, dimension(:, :), intent(in) :: array
      integer, intent(in) :: num, iostat

      logical :: temp(size(array,1),size(array,2))
      integer :: n, i

      call rts(string, temp, n, i)

      if (any(temp.neqv.array)) &
        print*, "Different array"
      if (i/=iostat) &
        print*, "Wrong iostat"
      if (n/=num) &
        print*, "Wrong num"
    end subroutine logicaldatamatrix

    subroutine integerdataarray(string, array, num, iostat)
      character(len=*), intent(in) :: string
      integer, dimension(:), intent(in) :: array
      integer, intent(in) :: num, iostat

      integer :: temp(size(array))
      integer :: n, i

      call rts(string, temp, n, i)

      if (any(temp/=array)) &
        print*, "Different array"
      if (i/=iostat) &
        print*, "Wrong iostat"
      if (n/=num) &
        print*, "Wrong num"
    end subroutine integerdataarray

    subroutine integerdatamatrix(string, array, num, iostat)
      character(len=*), intent(in) :: string
      integer, dimension(:, :), intent(in) :: array
      integer, intent(in) :: num, iostat

      integer :: temp(size(array,1),size(array,2))
      integer :: n, i

      call rts(string, temp, n, i)

      if (any(temp/=array)) &
        print*, "Different array"
      if (i/=iostat) &
        print*, "Wrong iostat"
      if (n/=num) &
        print*, "Wrong num"
    end subroutine integerdatamatrix

    subroutine realspdataarray(string, array, num, iostat)
      character(len=*), intent(in) :: string
      real(sp), dimension(:), intent(in) :: array
      integer, intent(in) :: num, iostat

      real(sp) :: temp(size(array))
      integer :: n, i, j

      call rts(string, temp, n, i)

      do j = 1, size(array)
        if (array(j)==0.0) then
          if (temp(j)>1e-5) then
            print*, "Different array"
            exit
          endif
        elseif (abs(temp(j)-array(j))/temp(j)>1e-5) then
          print*, "Different array"
          exit
        endif
      enddo 
      if (i/=iostat) &
        print*, "Wrong iostat"
      if (n/=num) &
        print*, "Wrong num"
    end subroutine realspdataarray

    subroutine realspdatamatrix(string, array, num, iostat)
      character(len=*), intent(in) :: string
      real(sp), dimension(:, :), intent(in) :: array
      integer, intent(in) :: num, iostat

      real(sp) :: temp(size(array,1),size(array,2))
      integer :: n, i, j, k

      call rts(string, temp, n, i)

      loop: do j = 1, size(array,1)
        do k = 1, size(array,2)
          if (array(j,k)==0.0) then
            if (temp(j,k)>1e-5) then
              exit loop
            endif
           elseif (abs(temp(j,k)-array(j,k))/temp(j,k)>1e-5) then
            print*, "Different array"
            exit loop
          endif
        enddo
      enddo loop
      if (i/=iostat) &
        print*, "Wrong iostat"
      if (n/=num) &
        print*, "Wrong num"
    end subroutine realspdatamatrix

    subroutine realdpdataarray(string, array, num, iostat)
      character(len=*), intent(in) :: string
      real(dp), dimension(:), intent(in) :: array
      integer, intent(in) :: num, iostat

      real(dp) :: temp(size(array))
      integer :: n, i, j

      call rts(string, temp, n, i)

      do j = 1, size(array)
        if (array(j)==0.0) then
          if (temp(j)>1e-5) then
            print*, "Different array"
            exit
          endif
        elseif (abs(temp(j)-array(j))/temp(j)>1e-5) then
          print*, "Different array"
          exit
        endif
      enddo 
      if (i/=iostat) &
        print*, "Wrong iostat"
      if (n/=num) &
        print*, "Wrong num"
    end subroutine realdpdataarray

    subroutine realdpdatamatrix(string, array, num, iostat)
      character(len=*), intent(in) :: string
      real(dp), dimension(:, :), intent(in) :: array
      integer, intent(in) :: num, iostat

      real(dp) :: temp(size(array,1),size(array,2))
      integer :: n, i, j, k

      call rts(string, temp, n, i)

      loop: do j = 1, size(array,1)
        do k = 1, size(array,2)
          if (array(j,k)==0.0) then
            if (temp(j,k)>1e-5) then
              print*, "Different array"
              exit loop
            endif
           elseif (abs(temp(j,k)-array(j,k))/temp(j,k)>1e-5) then
            print*, "Different array"
            exit loop
          endif
        enddo
      enddo loop
      if (i/=iostat) &
        print*, "Wrong iostat"
      if (n/=num) &
        print*, "Wrong num"
    end subroutine realdpdatamatrix

    subroutine cmplxspdataarray(string, array, num, iostat)
      character(len=*), intent(in) :: string
      complex(sp), dimension(:), intent(in) :: array
      integer, intent(in) :: num, iostat

      complex(sp) :: temp(size(array))
      real(sp) :: a(2), t(2)
      integer :: n, i, j, m

      call rts(string, temp, n, i)

      do j = 1, size(array)
        a = transfer(array(j), a)
        t = transfer(array(j), t)
        do m = 1, 2
          if (a(m)==0.0) then
            if (t(m)>1e-5) then
              print*, "Different array"
              exit
            endif
          elseif (abs(t(m)-a(m))/t(m)>1e-5) then
            print*, "Different array"
            exit
          endif
        enddo
      enddo 
      if (i/=iostat) &
        print*, "Wrong iostat"
      if (n/=num) &
        print*, "Wrong num"
    end subroutine cmplxspdataarray

    subroutine cmplxspdatamatrix(string, array, num, iostat)
      character(len=*), intent(in) :: string
      complex(sp), dimension(:, :), intent(in) :: array
      integer, intent(in) :: num, iostat

      complex(sp) :: temp(size(array,1),size(array,2))
      real(sp) :: a(2), t(2)
      integer :: n, i, j, k, m

      call rts(string, temp, n, i)

      loop: do j = 1, size(array,1)
        do k = 1, size(array,2)
          a = transfer(array(j,k), a)
          t = transfer(array(j,k), t)
          do m = 1, 2
            if (a(m)==0.0) then
              if (t(m)>1e-5) then
                print*, "Different array"
                exit loop
              endif
            elseif (abs(t(m)-a(m))/t(m)>1e-5) then
              print*, "Different array"
              exit loop
            endif
          enddo
        enddo
      enddo loop
      if (i/=iostat) &
        print*, "Wrong iostat"
      if (n/=num) &
        print*, "Wrong num"
    end subroutine cmplxspdatamatrix

    subroutine cmplxdpdataarray(string, array, num, iostat)
      character(len=*), intent(in) :: string
      complex(dp), dimension(:), intent(in) :: array
      integer, intent(in) :: num, iostat

      complex(dp) :: temp(size(array))
      real(dp) :: a(2), t(2)
      integer :: n, i, j, m

      call rts(string, temp, n, i)

      do j = 1, size(array)
        a = transfer(array(j), a)
        t = transfer(array(j), t)
        do m = 1, 2
          if (a(m)==0.0) then
            if (t(m)>1e-5) then
              print*, "Different array"
              exit
            endif
          elseif (abs(t(m)-a(m))/t(m)>1e-5) then
            print*, "Different array"
            exit
          endif
        enddo
      enddo 
      if (i/=iostat) &
        print*, "Wrong iostat"
      if (n/=num) &
        print*, "Wrong num"
    end subroutine cmplxdpdataarray

    subroutine cmplxdpdatamatrix(string, array, num, iostat)
      character(len=*), intent(in) :: string
      complex(dp), dimension(:, :), intent(in) :: array
      integer, intent(in) :: num, iostat

      complex(dp) :: temp(size(array,1),size(array,2))
      real(dp) :: a(2), t(2)
      integer :: n, i, j, k, m

      call rts(string, temp, n, i)

      loop: do j = 1, size(array,1)
        do k = 1, size(array,2)
          a = transfer(array(j,k), a)
          t = transfer(array(j,k), t)
          do m = 1, 2
            if (a(m)==0.0) then
              if (t(m)>1e-5) then
                print*, "Different array"
                exit loop
              endif
            elseif (abs(t(m)-a(m))/t(m)>1e-5) then
              print*, "Different array"
              exit loop
            endif
          enddo
        enddo
      enddo loop
      if (i/=iostat) &
        print*, "Wrong iostat"
      if (n/=num) &
        print*, "Wrong num"
    end subroutine cmplxdpdatamatrix

end program short_test

module m_common_io

  use m_common_error, only : FoX_error

  implicit none
  private

  ! Basic  I/O tools

  integer, save :: io_eor
  integer, save :: io_eof
  integer, save :: io_err

  public :: io_eor
  public :: io_eof
  public :: io_err
  public :: get_unit
  public :: setup_io

contains

  subroutine setup_io()
    call find_eor_eof(io_eor, io_eof)
  end subroutine setup_io


  subroutine get_unit(lun,iostat)
    ! Get an available Fortran unit number
    integer, intent(out)  :: lun
    integer, intent(out)  :: iostat

    integer :: i
    logical :: unit_used

    do i = 10, 99
      lun = i
      inquire(unit=lun,opened=unit_used)
      if (.not. unit_used) then
        iostat = 0
        return
      endif
    enddo
    iostat = -1
    lun = -1
  end subroutine get_unit


  subroutine find_eor_eof(io_eor,io_eof)
    ! Determines the values of the iostat values for End of File and 
    ! End of Record (in non-advancing I/O)
    integer, intent(out)           :: io_eor
    integer, intent(out)           :: io_eof

    integer           :: lun, iostat
    character(len=1)  :: c

    call get_unit(lun,iostat)

    if (iostat /= 0) call FoX_error("Out of unit numbers")

    open(unit=lun,status="scratch",form="formatted", &
      action="readwrite",position="rewind",iostat=iostat)
    if (iostat /= 0) call FoX_error("Cannot open test file")

    write(unit=lun,fmt=*)  "a"
    write(unit=lun,fmt=*)  "b"

    rewind(unit=lun)

    io_eor = 0
    do
      read(unit=lun,fmt="(a1)",advance="no",iostat=io_eor) c
      if (io_eor /= 0) exit
    enddo

    io_eof = 0
    do
      read(unit=lun,fmt=*,iostat=io_eof)
      if (io_eof /= 0) exit
    enddo

    close(unit=lun,status="delete")
    
    ! Invent an io_err ...
    io_err = 1
    do
      if (io_err/=0.and.io_err/=io_eor.and.io_err/=io_eof) exit
      io_err = io_err + 1
    end do

  end subroutine find_eor_eof

end module m_common_io

module FoX_sax

  use FoX_common
  use m_sax_operate

  implicit none
  private

  public :: open_xml_file
  public :: open_xml_string
  public :: close_xml_t
  public :: parse
  public :: stop_parser

  public :: xml_t

  public :: dictionary_t
!SAX functions
  public :: getIndex 
  public :: getLength
  public :: getLocalName
  public :: getQName
  public :: getURI
  public :: getValue
  public :: getType
!For convenience
  public :: len
  public :: hasKey

  public :: print_dict

end module FoX_sax

module m_common_struct

  ! Common parts of an XML document. Shared by both SAX & WXML.

  use m_common_charset, only: XML1_0, XML1_1
  use m_common_entities, only: entity_list, init_entity_list, destroy_entity_list, &
    add_internal_entity, add_external_entity
  use m_common_notations, only: notation_list, init_notation_list, destroy_notation_list

  implicit none
  private

  type xml_doc_state
    logical :: building = .false. ! Are we in the middle of building this doc?
    integer :: xml_version = XML1_0
    logical :: standalone_declared = .false.
    logical :: standalone = .true.
    type(entity_list) :: entityList
    type(entity_list) :: PEList
    type(notation_list) :: nList
    logical :: warning = .false. ! Do we care about warnings?
    logical :: valid = .true. ! Do we care about validity?
    logical :: liveNodeLists = .true. ! Do we want live nodelists?
  end type xml_doc_state

  public :: xml_doc_state
  
  public :: init_xml_doc_state
  public :: destroy_xml_doc_state
  
  public :: register_internal_PE
  public :: register_external_PE
  public :: register_internal_GE
  public :: register_external_GE

contains
  
  subroutine init_xml_doc_state(xds)
    type(xml_doc_state), intent(inout) :: xds
    call init_entity_list(xds%entityList)
    call init_entity_list(xds%PEList)
    call init_notation_list(xds%nList)
  end subroutine init_xml_doc_state

  subroutine destroy_xml_doc_state(xds)
    type(xml_doc_state), intent(inout) :: xds
    call destroy_entity_list(xds%entityList)
    call destroy_entity_list(xds%PEList)
    call destroy_notation_list(xds%nList)
  end subroutine destroy_xml_doc_state

  subroutine register_internal_PE(xds, name, value)
    type(xml_doc_state), intent(inout) :: xds
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: value

    call add_internal_entity(xds%PEList, name, value)

  end subroutine register_internal_PE

  subroutine register_external_PE(xds, name, system, public)
    type(xml_doc_state), intent(inout) :: xds
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: system
    character(len=*), intent(in), optional :: public

    call add_external_entity(xds%PEList, name, system, public)
  end subroutine register_external_PE

  subroutine register_internal_GE(xds, name, value)
    type(xml_doc_state), intent(inout) :: xds
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: value

    call add_internal_entity(xds%entityList, name, value)

  end subroutine register_internal_GE

  subroutine register_external_GE(xds, name, system, public, notation)
    type(xml_doc_state), intent(inout) :: xds
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: system
    character(len=*), intent(in), optional :: public
    character(len=*), intent(in), optional :: notation

    call add_external_entity(xds%entityList, name, system, public, notation)
  end subroutine register_external_GE

end module m_common_struct

program test

  use FoX_wxml
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  call xml_OpenFile(filename, xf, addDecl=.false.)
  call xml_AddXMLDeclaration(xf, encoding='UTF-8')
  call xml_NewElement(xf, "a")
  call xml_Close(xf)

end program test

module m_sax_types

  use m_common_attrs, only: dictionary_t
  use m_common_element, only: element_list
  use m_common_elstack, only: elstack_t
  use m_common_entities, only: entity_list
  use m_common_error, only: error_stack
  use m_common_namespaces, only: namespacedictionary
  use m_common_notations, only: notation_list
  use m_common_struct, only: xml_doc_state

  use m_sax_reader, only: file_buffer_t

  implicit none

  ! Context

  integer, parameter :: CTXT_NULL = -1
  integer, parameter :: CTXT_INIT = 0
  integer, parameter :: CTXT_BEFORE_DTD = 1
  integer, parameter :: CTXT_IN_DTD = 2
  integer, parameter :: CTXT_BEFORE_CONTENT = 3
  integer, parameter :: CTXT_IN_CONTENT = 4
  integer, parameter :: CTXT_AFTER_CONTENT = 5

  ! State

  integer, parameter :: ST_NULL = -1
  integer, parameter :: ST_MISC = 0
  integer, parameter :: ST_BANG_TAG = 1 
  integer, parameter :: ST_START_PI = 2
  integer, parameter :: ST_START_COMMENT = 3
  integer, parameter :: ST_START_TAG = 4 
  integer, parameter :: ST_START_CDATA_1 = 5
  integer, parameter :: ST_START_CDATA_2 = 6
  integer, parameter :: ST_IN_TAG = 7
  integer, parameter :: ST_ATT_NAME = 8
  integer, parameter :: ST_ATT_EQUALS = 9
  integer, parameter :: ST_CHAR_IN_CONTENT = 10
  integer, parameter :: ST_CLOSING_TAG = 11
  integer, parameter :: ST_PI_END = 13
  integer, parameter :: ST_COMMENT_END_1 = 14
  integer, parameter :: ST_COMMENT_END_2 = 15
  integer, parameter :: ST_PI_CONTENTS = 16
  integer, parameter :: ST_CDATA_CONTENTS = 17
  integer, parameter :: ST_IN_CLOSING_TAG = 18
  integer, parameter :: ST_TAG_IN_CONTENT = 19
  integer, parameter :: ST_CDATA_END = 20
  integer, parameter :: ST_IN_DTD = 21
  integer, parameter :: ST_DTD_NAME = 22
  integer, parameter :: ST_DTD_SYSTEM = 23
  integer, parameter :: ST_DTD_PUBLIC = 24
  integer, parameter :: ST_INT_SUBSET = 25
  integer, parameter :: ST_DTD_ATTLIST = 26
  integer, parameter :: ST_DTD_ELEMENT = 27
  integer, parameter :: ST_DTD_ENTITY= 28
  integer, parameter :: ST_DTD_NOTATION = 29
  integer, parameter :: ST_DTD_NOTATION_ID = 30
  integer, parameter :: ST_DTD_NOTATION_SYSTEM = 31
  integer, parameter :: ST_DTD_NOTATION_PUBLIC = 32
  integer, parameter :: ST_DTD_NOTATION_PUBLIC_2 = 33
  integer, parameter :: ST_DTD_NOTATION_END = 34
  integer, parameter :: ST_DTD_DECL = 35
  integer, parameter :: ST_CLOSE_DTD = 36
  integer, parameter :: ST_DTD_ENTITY_PE = 37
  integer, parameter :: ST_DTD_ENTITY_ID = 38
  integer, parameter :: ST_DTD_ENTITY_PUBLIC = 39
  integer, parameter :: ST_DTD_ENTITY_SYSTEM = 40
  integer, parameter :: ST_DTD_ENTITY_NDATA = 41
  integer, parameter :: ST_DTD_ENTITY_NDATA_VALUE = 42
  integer, parameter :: ST_DTD_ENTITY_END = 43
  integer, parameter :: ST_DTD_ATTLIST_CONTENTS = 44
  integer, parameter :: ST_DTD_ATTLIST_END = 45
  integer, parameter :: ST_DTD_ELEMENT_CONTENTS = 46
  integer, parameter :: ST_DTD_ELEMENT_END = 47
  
  ! Whitespace
  
  integer, parameter :: WS_FORBIDDEN = 0
  integer, parameter :: WS_PRESERVE = 1
  integer, parameter :: WS_MANDATORY = 2
  integer, parameter :: WS_DISCARD = 3
  
  type sax_parser_t
    type(xml_doc_state) :: xds
    integer :: whitespace
    integer :: context 
    integer :: state
    integer :: parse_stack = 0
    integer, pointer :: wf_stack(:) => null()
    logical :: well_formed = .false.
    logical :: skippedExternal = .false.
    character, dimension(:), pointer :: token => null()
    character, dimension(:), pointer :: next_token => null()
    character, dimension(:), pointer :: name => null()
    character, dimension(:), pointer :: attname => null()
    logical :: error = .false.
    type(error_stack) :: error_stack 
    ! Aspects of document structure
    integer :: xml_version
    character, dimension(:), pointer :: encoding => null()
    character, dimension(:), pointer :: root_element => null()
    type(elstack_t) :: elstack
    type(dictionary_t) :: attributes
    type(namespacedictionary) :: nsdict
    type(notation_list) :: nlist
    type(entity_list) :: predefined_e_list
    type(entity_list) :: forbidden_pe_list
    type(entity_list) :: forbidden_ge_list
    type(element_list) :: element_list
    character(len=1), dimension(:), pointer :: PublicId => null()
    character(len=1), dimension(:), pointer :: SystemId => null()
    character(len=1), dimension(:), pointer :: Ndata => null()
  end type sax_parser_t


  type xml_t
    type(file_buffer_t) :: fb
    type(sax_parser_t) :: fx
    integer :: sax_signal
  end type xml_t


end module m_sax_types

program test_sax_reader

  use m_sax_parser
  use m_sax_reader
  use m_sax_types

  type(file_buffer_t) :: fb
  type(sax_parser_t) :: fx

  integer :: iostat

  call open_file(fb, file="test_sax_fsm_1.in", iostat=iostat)

  call sax_parser_init(fx)

  call sax_parse(fx, fb, iostat)

  print*, fx%xml_version
  print*, fx%encoding
  print*, fx%standalone

  call sax_parser_destroy(fx)
  call close_file(fb) 

end program test_sax_reader

program wxml_example

use FoX_wxml

type(xmlf_t) :: xf

integer :: age = 34
real, dimension(20)  :: x
real, dimension(4,4)  :: y

call xml_OpenFile("simple.xml",xf)
call xml_AddDOCTYPE(xf, "john", "hellodtd")
call xml_AddParameterEntity(xf, 'pe', '<!ENTITY def "what a load of nonsense">')
call xml_AddInternalEntity(xf, "abc", "A B C")
call xml_AddElementToDTD(xf, "br", "EMPTY")
call xml_AddAttlistToDTD(xf, "p", "class NMTOKENS #IMPLIED")
call xml_AddPEreferenceToDTD(xf, "pe")
call xml_AddXMLPI(xf, name="robots")
call xml_AddPseudoAttribute(xf, "index", "yes")
call xml_AddPseudoAttribute(xf, "follow", "no")
call xml_AddNotation(xf, name="GIF", system="http://lzw.org")
call xml_AddComment(xf, "a comment ...")
call xml_AddExternalEntity(xf, "def", "http://blah", public="h", notation="GIF")

call xml_AddXMLStylesheet(xf,href="simple.css",type="text/css",media="braille")
call xml_AddXMLPI(xf,name="ccode", data="{hello_world();}")

call xml_NewElement(xf,"john")
call xml_AddAttribute(xf,"age",age)


call xml_AddAttribute(xf,"with_markup","O'Reilly & Assoc is < OUP but > Wiley")
call xml_NewElement(xf,"peter")
call xml_AddComment(xf, "another comment ...")
call xml_NewElement(xf,"tim")
call xml_AddAttribute(xf,"age",37)
call xml_AddAttribute(xf,"weight",123.45d0,fmt="r3")
call xml_AddAttribute(xf,"cholesterol",167.0d0,fmt="r0")
call xml_AddCharacters(xf,"Ping-pong")
call xml_AddCharacters(xf,"champion")
call xml_EndElement(xf,"tim")

call xml_AddCharacters(xf," in years < 2004")

call xml_AddXMLPI(xf, name="robots2")
call xml_AddPseudoAttribute(xf, "index", "if you're nice")
call xml_AddEntityReference(xf, 'abc')

call xml_AddCharacters(xf, repeat("abcd   ",500))

call xml_NewElement(xf,"data")
call xml_AddAttribute(xf,"units","eV")
call random_number(x)
!call xml_AddArray(xf,x)
call xml_EndElement(xf,"data")
call xml_NewElement(xf,"data")
call xml_AddAttribute(xf,"units","Ryd")

call xml_AddEntityReference(xf, '#x2A9')

call xml_DeclareNamespace(xf, "http://www.w3.org/1999/xhtml", "h")
call xml_DeclareNamespace(xf, "http://www.w3.org/1999/svg", "svg")
call xml_NewElement(xf, "h:html")
call xml_NewElement(xf, "svg:svg")
call xml_EndElement(xf, "svg:svg")
call xml_NewElement(xf, "h:head")
call xml_DeclareNamespace(xf,"http://www.xml-cml.org/schema", "cml")
call xml_AddAttribute(xf, "cml:convention", "eMinerals")
call xml_EndElement(xf, "h:head")

!call xml_AddCharacters(xf,(/1, 2, 3, 4, 16 /))

! xml_Close will take care to close all outstanding elements

call xml_Close(xf)

! Equivalent code:
!
!!call xml_EndElement(xf,"data")
!!call xml_EndElement(xf,"peter")
!!call xml_EndElement(xf,"john")


end program wxml_example

program test

  use m_common_charset, only : XML1_0, XML1_1
  use m_common_struct, only : xml_doc_state
  use m_common_namecheck, only : checkPEDef
  implicit none

  type(xml_doc_state) :: xds

  write(*,'(l1)') checkPEDef('abcd', xds)
  write(*,'(l1)') checkPEDef('1abcd', xds)
  write(*,'(l1)') checkPEDef('abcd%', xds)
  write(*,'(l1)') checkPEDef('1abc&d', xds)
  write(*,'(l1)') checkPEDef(':abcd%;', xds)
  write(*,'(l1)') checkPEDef('#abcd&;', xds)
  write(*,'(l1)') checkPEDef('e:abcd%a;', xds)
  write(*,'(l1)') checkPEDef('e:abcd&a;', xds)
  write(*,'(l1)') checkPEDef('e:abcd%a1;', xds)
  write(*,'(l1)') checkPEDef('e:abcd&a1;', xds)
  write(*,'(l1)') checkPEDef('e:abcd%a!;', xds)
  write(*,'(l1)') checkPEDef('e:abcd&a!;', xds)
  write(*,'(l1)') checkPEDef('e:abcd%%a;', xds)
  write(*,'(l1)') checkPEDef('e:abcd&%a;', xds)
  write(*,'(l1)') checkPEDef('e:abcd%&a;', xds)
  write(*,'(l1)') checkPEDef('e:abcd&&a;', xds)
  write(*,'(l1)') checkPEDef('e:a%b;cd%a;', xds)
  write(*,'(l1)') checkPEDef('e:a&b;cd&a;', xds)
  write(*,'(l1)') checkPEDef('&e:;a%b;cd%a1;', xds)
  write(*,'(l1)') checkPEDef('%e:;a&b;cd&a1;', xds)
  write(*,'(l1)') checkPEDef('%e:;a&b;cd&a1; &#x33;', xds)
  write(*,'(l1)') checkPEDef('%e:;a&b;cd&a1; %#x33;', xds)
  write(*,'(l1)') checkPEDef('%e:;a&b;cd&a1; &#x07;', xds)
  write(*,'(l1)') checkPEDef('%e:;a&b;cd&a1; %#x07;', xds)

  xds%xml_version = XML1_1

  write(*,'(l1)') checkPEDef('abcd', xds)
  write(*,'(l1)') checkPEDef('1abcd', xds)
  write(*,'(l1)') checkPEDef('abcd%', xds)
  write(*,'(l1)') checkPEDef('1abc&d', xds)
  write(*,'(l1)') checkPEDef(':abcd%;', xds)
  write(*,'(l1)') checkPEDef('#abcd&;', xds)
  write(*,'(l1)') checkPEDef('e:abcd%a;', xds)
  write(*,'(l1)') checkPEDef('e:abcd&a;', xds)
  write(*,'(l1)') checkPEDef('e:abcd%a1;', xds)
  write(*,'(l1)') checkPEDef('e:abcd&a1;', xds)
  write(*,'(l1)') checkPEDef('e:abcd%a!;', xds)
  write(*,'(l1)') checkPEDef('e:abcd&a!;', xds)
  write(*,'(l1)') checkPEDef('e:abcd%%a;', xds)
  write(*,'(l1)') checkPEDef('e:abcd&%a;', xds)
  write(*,'(l1)') checkPEDef('e:abcd%&a;', xds)
  write(*,'(l1)') checkPEDef('e:abcd&&a;', xds)
  write(*,'(l1)') checkPEDef('e:a%b;cd%a;', xds)
  write(*,'(l1)') checkPEDef('e:a&b;cd&a;', xds)
  write(*,'(l1)') checkPEDef('&e:;a%b;cd%a1;', xds)
  write(*,'(l1)') checkPEDef('%e:;a&b;cd&a1;', xds)
  write(*,'(l1)') checkPEDef('%e:;a&b;cd&a1; &#x33;', xds)
  write(*,'(l1)') checkPEDef('%e:;a&b;cd&a1; %#x33;', xds)
  write(*,'(l1)') checkPEDef('%e:;a&b;cd&a1; &#x07;', xds)
  write(*,'(l1)') checkPEDef('%e:;a&b;cd&a1; %#x07;', xds)

end program test

module m_sax_reader

  ! This module implements a reader for XML documents.
  ! That is, functionally, it simply takes care of new-line
  ! handling, such that all newlines are converted to ASCII 0xA
  ! according to the algorithm in s2.11 of XML 1.0 or 1.1

  ! It offers several shortcut functions for seeking through
  ! the file for particular sequences of characters useful
  ! for XML parsing.

  ! It also offers the ability to push characters back into 
  ! the reader, onto a stack of additional buffers, which
  ! we need for entity expansion.

  ! Furthermore, readahead and pushback is available on
  ! all buffers.

  ! In addition, it includes a layer for caching, whereby 
  ! (except during entity expansion) it actually reads from 
  ! the file READLENGTH(512) characters at a time, into
  ! a large buffer with all newline conversion already done.
  ! Thus most of the tokenizer/parser's seeking is done in memory, not through
  ! IO.


  use m_common_array_str, only : vs_str, str_vs, vs_str_alloc, vs_vs_alloc
  use m_common_charset, only: XML1_0, XML1_1
  use m_common_error,  only: FoX_error
  use m_common_io, only: setup_io, io_eor, io_eof, get_unit
  use m_common_format, only: str

  implicit none
  private

  ! FIXME need to check that io_eor & io_eof cannot be -2048
  integer, parameter             :: BUFFER_NOT_CONNECTED = -2048
  ! We need a longish character buffer to a) minimize IO and
  ! b) allow stepping backwards in the lexer/parser.
  integer, parameter             :: BUFLENGTH = 1024
  ! The above must be an even number, and greater than 20
  integer, parameter             :: READLENGTH = BUFLENGTH/2

  type buffer_t
    character, dimension(:), pointer :: s
    integer :: pos = 1
  end type buffer_t

  type file_buffer_t
    !FIXME private
    logical                  :: connected=.false.   ! Are we connected?
    logical                  :: xml_decl=.false.    ! Have we seen an XML
    ! declaration yet? - we need to know for whitespace handling.
    integer                  :: xml_version = XML1_0
    integer                  :: lun                 ! Which unit number
    ! If lun = -1, then we are reading from a string ....
    character, pointer       :: input_string(:) => null()    ! If input is from a string
    integer                  :: input_pos
    logical                  :: eof                 ! have we read past eof?
    ! Necessary since we don't want to report eof to user until
    ! fb%pos gets there, but we don't want to issue another read.
    character, pointer       :: filename(:) => null()        ! filename
    character(len=BUFLENGTH) :: buffer              ! character buffer.
    type(buffer_t),  pointer :: buffer_stack(:) => null()  ! stack of expansion buffers
    character, pointer       :: namebuffer(:) => null()    ! temporary buffer for
    ! retrieving strings potentially greater than 1024 chars
    logical                  :: eor                 ! read_really needs to
    ! remember if we have a pending newline
    character, pointer       :: next_chars(:)  => null()     ! read_really needs its
    ! own pushback buffer
    integer                  :: pos                 ! which char are we at?
    integer                  :: nchars              ! How many chars in buffer?
    integer                  :: line                ! which line of file?
    integer                  :: col                 ! which column of file?
    logical                  :: debug               ! debug messages?
  end type file_buffer_t




  interface index
    module procedure index_fb
  end interface
  interface scan
    module procedure scan_fb
  end interface
  interface verify
    module procedure verify_fb
  end interface


  public :: buffer_t
  public :: file_buffer_t
  public :: line
  public :: column

  public :: open_file
  public :: rewind_file
  public :: close_file

  public :: read_char
  public :: read_chars
  public :: push_chars

  public :: get_characters
  public :: get_characters_until_condition
  public :: get_characters_until_not_one_of
  public :: get_characters_until_one_of
  public :: get_characters_until_all_of
  public :: put_characters

  public :: next_chars_are

  public :: dump_string

  public :: push_buffer_stack
  public :: pop_buffer_stack

contains

  subroutine open_file(fb, iostat, file, lun, string)
    type(file_buffer_t), intent(out)  :: fb
    character(len=*), intent(in), optional :: file
    integer, intent(out)              :: iostat
    integer, intent(in), optional     :: lun
    character(len=*), intent(in), optional :: string

    iostat = 0

    call setup_io()

    if (present(string)) then
      if (present(file)) then
        call FoX_error("Cannot specify both file and string input to open_xml")
      elseif (present(lun)) then
        call FoX_error("Cannot specify lun for string input to open_xml")
      endif
      fb%lun = -1
      fb%input_string => vs_str_alloc(string)
      allocate(fb%filename(0))
      fb%input_pos = 1
    else
      if (present(lun)) then
        fb%lun = lun
      else
        call get_unit(fb%lun, iostat)
        if (iostat/=0) then
          if (fb%debug) write(*,'(a)') "Cannot find free unit"
          return
        endif
      endif
      open(unit=fb%lun, file=file, form="formatted", status="old", &
        action="read", position="rewind", iostat=iostat)
      if (iostat /= 0) then
        if (fb%debug) write(*,'(a)') "Cannot open file "//file//" iostat: "//str(iostat)
        return
      endif
      fb%filename => vs_str_alloc(file)
      allocate(fb%input_string(0))
    endif

    if (.true.) then
      fb%debug = .true.
    else
      fb%debug = .false.
    endif

    fb%connected = .true.
    fb%eor = .false.
    fb%eof = .false.
    fb%line = 1
    fb%col = 0
    fb%pos = 1
    fb%nchars = 0
    allocate(fb%buffer_stack(0))

    allocate(fb%next_chars(0))

  end subroutine open_file


  subroutine rewind_file(fb)
    type(file_buffer_t), intent(inout)  :: fb

    integer :: i

    fb%eor = .false.
    fb%eof = .false.
    fb%line = 1
    fb%col = 0
    fb%pos = 1
    fb%nchars = 0
    fb%buffer = ""
    do i = 1, size(fb%buffer_stack)
      deallocate(fb%buffer_stack(i)%s)
    enddo
    deallocate(fb%buffer_stack)
    allocate(fb%buffer_stack(0))

    deallocate(fb%next_chars)
    allocate(fb%next_chars(0))

    fb%input_pos = 1
    if (fb%lun/=-1) then
      rewind(unit=fb%lun)
    endif

  end subroutine rewind_file


  subroutine close_file(fb)
    type(file_buffer_t), intent(inout)  :: fb

    integer :: i

    if (fb%connected) then
      deallocate(fb%filename)
      if (associated(fb%namebuffer)) deallocate(fb%namebuffer)
      do i = 1, size(fb%buffer_stack)
        deallocate(fb%buffer_stack(i)%s)
      enddo
      deallocate(fb%buffer_stack)
      deallocate(fb%next_chars)
      if (fb%lun/=-1) close(fb%lun)
      deallocate(fb%input_string)
      fb%connected = .false.
    endif

  end subroutine close_file


  ! For the first few characters, we need to be reading directly,
  ! not via the buffering below - in order that we can read the
  ! XML declaration (if it is there) under special rules.
  ! We still need to check the dynamic buffer, because we need
  ! pushback to cope with newline handling

  ! The implementation below is very inefficient, but simple,
  ! since we must be sure not to read past the end of the XML
  ! declaration with it (thereafter, rules change - we may be 
  ! dealing with XML 1.1 newlines.)
  !  
  ! It only needs to be used until we have finished dealing
  ! with the XML declaration though, so inefficiency is not
  ! important

  ! The put_characters mechanism can't be used here, so we 
  ! have an additional way to put characters back in the buffer
  ! through fb%next_chars which are read first.


  function read_char(fb, iostat) result(c)
    type(file_buffer_t), intent(inout) :: fb
    integer, intent(out) :: iostat
    character :: c

    character :: c2

    c = really_read_char(iostat)
    if (iostat/=0) return
    if (c == achar(10)) then
      c2 = really_read_char(iostat)
      if (iostat/=0) return
      if (c2 /= achar(13)) then
        call put_characters(fb, 1)
        ! else discard it.
      endif
      fb%line = fb%line + 1
      fb%col = 0
      c = achar(13)
    endif

  contains
    function really_read_char(iostat) result(rc)
      integer, intent(out) :: iostat
      character :: rc
      character, dimension(:), pointer :: nc
      if (size(fb%next_chars)>0) then
        iostat = 0
        rc = fb%next_chars(1)
        nc => vs_vs_alloc(fb%next_chars(2:))
        deallocate(fb%next_chars)
        fb%next_chars => nc
      else
        if (fb%lun==-1) then
          if (fb%input_pos>size(fb%input_string)) then
            rc = achar(0)
            iostat = io_eof
          else
            rc = fb%input_string(fb%input_pos)
            fb%input_pos = fb%input_pos + 1
            iostat = 0
          endif
        else
          read(unit=fb%lun, iostat=iostat, advance="no", fmt="(a1)") rc
          if (iostat == io_eor) then
            rc = achar(13)
            iostat = 0
          endif
        endif
        ! Don't need to do any EOF checking here, we are only
        ! reading one char at a time without buffering
      endif
    end function really_read_char
  end function read_char

  function read_chars(fb, n, iostat) result(s)
    type(file_buffer_t), intent(inout) :: fb
    integer, intent(in) :: n
    integer, intent(out) :: iostat
    character(len=n) :: s

    integer :: i

    do i = 1, n
      s(i:i) = read_char(fb, iostat)
      if (iostat/=0) return
    enddo
  end function read_chars

  subroutine push_chars(fb, s)
    type(file_buffer_t), intent(inout) :: fb
    character(len=*), intent(in) :: s
    character, dimension(:), pointer :: nc

    nc => vs_str_alloc(str_vs(fb%next_chars)//s)
    deallocate(fb%next_chars)
    fb%next_chars => nc
  end subroutine push_chars

  ! This subroutine will read in 512 chars; do XML-compliant new-line
  ! replacement (shortening the string) and repeat until either it has
  ! filled a 512-length string, it encounters a file error, or eof.
  ! In every loop of the recursion, we may have to read one extra
  ! char to check it. If we do & need to keep it around, we put it back.

  ! It will return a 512-length string. Output from the subroutine
  ! are l_s, the number of chars in the string (always 512 except in
  ! case of eof), iostat (either zero, eof, or error).

  ! It will assume XML-1.0 end of line semantics, unless version 1.1
  ! is specified.

  subroutine fill_buffer(fb, iostat)
    type(file_buffer_t), intent(inout) :: fb
    integer, intent(out) :: iostat

    integer :: l_s ! number of chars read
    integer :: z ! number of chars left to be read

    ! This subroutine has three layers.

    ! read_really actually interacts with the file and provides
    ! raw characters. It reads lines repeatedly, with non-advancing
    ! IO, adding 0xD every time it hits a newline (== end of record)
    ! until enough characters have been gathered.

    ! fill_buffer_really fills the buffer with READLENGTH chars from 
    ! read_really, then does newline replacement, shortening the
    ! string in the buffer accordingly.

    ! The main part of the subroutine then calls fill_buffer_really
    ! repeatedly until we've definitely got 512 characters after
    ! newline replacement.

    ! The buffer should then only be accessed through one of the 
    ! get_characters routine below, which take care of the pushback
    ! buffer.

    ! fill_buffer returns an iostat. This is zero if ok - if we have
    ! encountered an eof but there are still characters in the buffer,
    ! it is still zero. It is only non-zero when the buffer is empty,
    ! and we've hit eof - or when we've hit an IO error in reading.

    if (fb%pos > READLENGTH) then
      fb%buffer(:READLENGTH) = fb%buffer(READLENGTH+1:)
      fb%pos = fb%pos - READLENGTH
      fb%nchars = fb%nchars - READLENGTH
    endif

    l_s = 0
    z = READLENGTH - l_s

    do while (z>0)
      call fill_buffer_really
      if (iostat/=0) exit
    enddo

    fb%nchars = fb%nchars + l_s

    if (iostat == io_eof) then
      if (fb%nchars - fb%pos >= 0) iostat = 0
    endif

  contains

    subroutine fill_buffer_really

      integer :: i, n, p, q
      character :: c
      character(len=z) :: string

      if (z==0) then
        iostat = 0
        return
      endif

      string = read_really(z, p)
      ! p now holds useful length of current string
      if (iostat /= 0) return

      ! Now replace newline characters according to 
      ! XML 1.0/1.1 section 2.11
      i = 1
      if (fb%xml_version == XML1_0) then
        n = scan(string(:p), achar(10))
      elseif (fb%xml_version == XML1_1) then
        ! n = scan(string(:p), achar(10)//achar(133))
        ! Really we should check for 133, but we can't do >128 chars
        ! anywhere else, and some compilers complain when we try.
        n = scan(string(:p), achar(10)//achar(133))
      endif
      do while (n > 0) 
        if (n == p) then
          ! We're at the end of the string ... we need the next character
          c = read_really(1, q)
          ! unless this is the end of the file
          if (iostat /= 0) then
            if ((fb%xml_version==XML1_0.and.c/=achar(13)).or. &
              ! (fb%xml_version==XML1_1.and.c/=achar(13).and.c/=achar(133))) then
              ! Really we should check for 133, but we can't do >128 chars
              (fb%xml_version==XML1_0.and.c/=achar(13))) then
              continue
              ! else we'd be throwing it away below anyway
            endif
          else
            if (iostat /= io_eof) return
            ! Hard error, return
          endif
          ! else it really is the end of the file, carry on for the moment.
          ! Now: it's not the end of the string, what's the next character?
        elseif ((fb%xml_version==XML1_0.and.string(n+1:n+1)==achar(13)).or. &
          ! Really we should check for 133, but we can't do >128 chars
          ! (fb%xml_version==XML1_1.and.string(n+1:n+1)/=achar(13).and.string(n+1:n+1)/=achar(133))) then
          (fb%xml_version==XML1_1.and.string(n+1:n+1)/=achar(13))) then
          ! We must discard it, and thus shorten the string we have.
          string(n+1:p-1) = string(n+2:p)
          p = p - 1
        endif
        ! Finally, we must change the 
        ! change the newline char to achar(13) & finish.
        string(n:n) = achar(13)
        ! and find the next one ...
        if (fb%xml_version == XML1_0) then
          n = index(string(n+1:p), achar(10))
        elseif (fb%xml_version == XML1_1) then
          ! Really we should check for 133, but we can't do >128 chars
          ! n = scan(string(n+1:p), achar(10)//achar(133))
          n = scan(string(n+1:p), achar(10))
        endif
      enddo

      fb%buffer(fb%nchars+l_s+1:fb%nchars+l_s+p) = string(:p)
      l_s = l_s + p
      z = READLENGTH - l_s

    end subroutine fill_buffer_really

    function read_really(n_chars, ncr) result (string)
      integer, intent(in) :: n_chars
      integer, intent(out) :: ncr ! number characters read
      character(len=n_chars) :: string
      integer :: nc

      ! This should only return EOF if it is EOF , and we've read no
      ! character at all.

      ! We may have a pending newline
      if (fb%eor) then
        string(1:1) = achar(13)
        fb%eor = .false.
        ncr = 1
      else
        ncr = 0
      endif
      do while (n_chars > ncr)
        if (fb%eof) then
          ! Don't read again if we've already encountered eof
          nc = 0
          if (ncr==0) then
            iostat = io_eof
            return
          endif
          ! else we don't want to return just yet - we might have
          ! picked up some chars from previous reads
        else
          if (fb%lun == -1) then
            ! get chars from string
            if (size(fb%input_string) - fb%input_pos + 1 < n_chars) then
              iostat = io_eof
              nc = size(fb%input_string) - fb%input_pos + 1
              string(:nc) = str_vs(fb%input_string(fb%input_pos:))
              fb%input_pos = size(fb%input_string) + 1
            else
              iostat = 0
              nc = n_chars
              string(:nc) = str_vs(fb%input_string(fb%input_pos:fb%input_pos+n_chars-1))
              fb%input_pos = fb%input_pos+n_chars
            endif
          else
            ! These two initializations to shut the Intel compiler up.
            nc = 0
            iostat = 0
            read(unit=fb%lun, iostat=iostat, advance="no", &
              size=nc, fmt="("//str(n_chars-ncr)//"a1)") string(ncr+1:)
          endif
        endif
        ncr = ncr + nc
        if (iostat==io_eor) then ! we hit a newline, need to record it
          if (ncr < n_chars) then
            ! we can just add it to the string
            ncr = ncr + 1
            string(ncr:ncr) = achar(13)
          else
            ! we already have enough characters, remember for next time.
            fb%eor = .true.
          endif
          iostat = 0 ! and forget about the error
        elseif (iostat == io_eof) then
          fb%eof = .true.
          iostat = 0 ! since we may still be returning some chars
          return
        elseif (iostat/=0) then
          !either we've read an eof, or we've hit an error. Either way:
          return
        endif
      enddo

    end function read_really

  end subroutine fill_buffer

  subroutine push_buffer_stack(fb, string)
    type(file_buffer_t), intent(inout) :: fb
    character(len=*), intent(in) :: string

    ! Add a new buffer to the stack.
    integer :: i
    type(buffer_t), dimension(:), pointer :: tempStack

    allocate(tempStack(size(fb%buffer_stack)+1))
    do i = 1, size(fb%buffer_stack)
      tempStack(i+1)%s => fb%buffer_stack(i)%s
      tempStack(i+1)%pos = fb%buffer_stack(i)%pos
    enddo
    tempStack(1)%s => vs_str_alloc(string)
    deallocate(fb%buffer_stack)
    fb%buffer_stack => tempStack
  end subroutine push_buffer_stack

  subroutine pop_buffer_stack(fb)
    type(file_buffer_t), intent(inout) :: fb

    ! Pop active buffer from the stack.
    integer :: i
    type(buffer_t), dimension(:), pointer :: tempStack

    deallocate(fb%buffer_stack(1)%s)
    allocate(tempStack(size(fb%buffer_stack)-1))
    do i = 1, size(tempStack)
      tempStack(i)%s => fb%buffer_stack(i+1)%s
      tempStack(i)%pos = fb%buffer_stack(i+1)%pos
    enddo
    deallocate(fb%buffer_stack)
    fb%buffer_stack => tempStack

  end subroutine pop_buffer_stack

  function get_characters(fb, n, iostat) result(string)
    type(file_buffer_t), intent(inout) :: fb
    integer, intent(in) :: n
    integer, intent(out) :: iostat
    character(len=n) :: string

    integer :: n_held
    type(buffer_t), pointer :: cb

    if (.not.fb%connected) then
      iostat = BUFFER_NOT_CONNECTED
      return
    endif

    ! Which is current buffer?
    if (size(fb%buffer_stack) > 0) then
      cb => fb%buffer_stack(1)
      n_held = size(cb%s) - cb%pos + 1
      if (n <= n_held) then
        string = str_vs(cb%s(cb%pos:cb%pos+n-1))
        cb%pos = cb%pos + n
        iostat = 0 
      else
        ! Not enough characters here
        string = ''
        iostat = io_eof
        return
      endif
    else
      ! We're reading straight from the file.
      ! Refill the buffer if necessary
      if ((fb%nchars-fb%pos)<READLENGTH) then
        ! This will happen if a) this is the 1st/2nd time we are called
        ! b) Last buffer access was through a get_characters_until...
        call fill_buffer(fb, iostat)
        if (iostat/=0) return
      endif
      if (n <= fb%nchars-fb%pos+1) then
        string = fb%buffer(fb%pos:fb%pos+n)
        fb%pos = fb%pos + n
        iostat = 0
      else
        ! Not enough characters left
        string = ''
        iostat = io_eof
        return
      endif
    endif

    call move_cursor(fb, string)

  end function get_characters


  subroutine get_characters_until_condition(fb, condition, true, iostat)
    type(file_buffer_t), intent(inout) :: fb
    interface
      function condition(c) result(p)
        character, intent(in) :: c
        logical :: p
      end function condition
    end interface
    logical, intent(in) :: true
    integer, intent(out) :: iostat

    type(buffer_t), pointer :: cb
    character, dimension(:), pointer :: tempbuf, buf
    integer :: m_i

    if (size(fb%buffer_stack)>0) then
      cb => fb%buffer_stack(1)
      if (cb%pos>size(cb%s)) then
        iostat = io_eof
        return
      endif
    elseif (fb%eof.and.fb%pos>fb%nchars) then
      iostat = io_eof
      return
    endif

    allocate(buf(0))
    m_i = check_fb(fb, condition, true)
    do while (size(fb%buffer_stack)==0.and.m_i==0)
      tempbuf => vs_str_alloc(str_vs(buf)//fb%buffer(fb%pos:fb%nchars))
      deallocate(buf)
      buf => tempbuf
      fb%pos = fb%nchars + 1
      call fill_buffer(fb, iostat)
      if (iostat==io_eof) then
        ! just return with what we have
        ! we'll reset iostat = 0 below
        m_i = fb%nchars - fb%pos + 1
        if (m_i==0) m_i = 1
        exit
      elseif (iostat/=0) then
        return
      else
        m_i = check_fb(fb, condition, true)
      endif
    enddo
    ! We're ok, and we'll definitely return something
    iostat = 0

    if (size(fb%buffer_stack)>0) then
      deallocate(buf)
      if (m_i==0) then
        buf => vs_vs_alloc(cb%s(cb%pos:))
        cb%pos = size(cb%s) + 1
      else
        buf => vs_vs_alloc(cb%s(cb%pos:cb%pos+m_i-2))
        cb%pos = cb%pos + m_i - 1
      endif
    else
      tempbuf => vs_str_alloc(str_vs(buf)//fb%buffer(fb%pos:fb%pos+m_i-2))
      deallocate(buf)
      buf => tempbuf
      fb%pos = fb%pos + m_i - 1
    endif

    if (associated(fb%namebuffer)) deallocate(fb%namebuffer)
    fb%namebuffer => buf
    call move_cursor(fb, str_vs(fb%namebuffer))

  end subroutine get_characters_until_condition


  subroutine get_chars_with_condition(fb, marker, condition, iostat)
    type(file_buffer_t), intent(inout) :: fb
    character(len=*), intent(in) :: marker
    integer, external :: condition
    integer, intent(out) :: iostat

    type(buffer_t), pointer :: cb
    character, dimension(:), pointer :: tempbuf, buf
    integer :: m_i

    if (size(fb%buffer_stack)>0) then
      cb => fb%buffer_stack(1)
      if (cb%pos>size(cb%s)) then
        iostat = io_eof
        return
      endif
    elseif (fb%eof.and.fb%pos>fb%nchars) then
      iostat = io_eof
      return
    endif

    allocate(buf(0))
    m_i = condition(fb, marker)
    do while (size(fb%buffer_stack)==0.and.m_i==0)
      tempbuf => vs_str_alloc(str_vs(buf)//fb%buffer(fb%pos:fb%nchars))
      deallocate(buf)
      buf => tempbuf
      fb%pos = fb%nchars + 1
      call fill_buffer(fb, iostat)
      if (iostat==io_eof) then
        m_i = fb%nchars - fb%pos + 1
        if (m_i==0) m_i = 1
        exit
      elseif (iostat/=0) then
        return
      else
        m_i = condition(fb, marker)
      endif
    enddo
    iostat = 0

    if (size(fb%buffer_stack)>0) then
      deallocate(buf)
      if (m_i==0) then
        buf => vs_vs_alloc(cb%s(cb%pos:))
        cb%pos = size(cb%s)+1
      else
        buf => vs_vs_alloc(cb%s(cb%pos:cb%pos+m_i-2))
        cb%pos = cb%pos + m_i - 1
      endif
    else
      tempbuf => vs_str_alloc(str_vs(buf)//fb%buffer(fb%pos:fb%pos+m_i-2))
      deallocate(buf)
      buf => tempbuf
      fb%pos = fb%pos + m_i - 1
    endif

    if (associated(fb%namebuffer)) deallocate(fb%namebuffer)
    fb%namebuffer => buf
    call move_cursor(fb, str_vs(fb%namebuffer))

  end subroutine get_chars_with_condition


  subroutine get_characters_until_not_one_of(fb, marker, iostat)
    type(file_buffer_t), intent(inout) :: fb
    character(len=*) :: marker
    integer, intent(out) :: iostat

    call get_chars_with_condition(fb, marker, verify_fb, iostat)

  end subroutine get_characters_until_not_one_of

  subroutine get_characters_until_one_of(fb, marker, iostat)
    type(file_buffer_t), intent(inout) :: fb
    character(len=*), intent(in) :: marker
    integer, intent(out) :: iostat

    call get_chars_with_condition(fb, marker, scan_fb, iostat)

  end subroutine get_characters_until_one_of

  subroutine get_characters_until_all_of(fb, marker, iostat)
    type(file_buffer_t), intent(inout) :: fb
    character(len=*), intent(in) :: marker
    integer, intent(out) :: iostat

    call get_chars_with_condition(fb, marker, index_fb, iostat)

  end subroutine get_characters_until_all_of

  function next_chars_are(fb, string, iostat) result(p)
    type(file_buffer_t), intent(inout) :: fb
    character(len=*), intent(in) :: string
    integer, intent(out) :: iostat
    logical :: p

    character(len=len(string)) :: s

    p = .false.
    s = get_characters(fb, len(string), iostat)
    if (iostat==io_eof) then
      s = ''
      return
    elseif (iostat/=0) then
      return
    endif
    p = (s==string) 
    if (.not.p) call put_characters(fb, len(string))

  end function next_chars_are


  subroutine move_cursor(fb, string)
    type(file_buffer_t), intent(inout) :: fb
    character(len=*) :: string

    integer :: newlines
    newlines = count(vs_str(string) == achar(13))
    if (newlines > 0) then
      fb%line = fb%line + newlines
      fb%col = index(string, achar(13), .true.) - 1
    else
      fb%col = len(string)
    endif

  end subroutine move_cursor


  subroutine put_characters(fb, n)
    type(file_buffer_t), intent(inout) :: fb
    integer, intent(in) :: n

    type(buffer_t), pointer :: cb

    if (size(fb%buffer_stack)>0) then
      cb => fb%buffer_stack(1)
      if (n > cb%pos) then
        ! make an error
      else
        cb%pos = cb%pos - n
      endif
    else
      if (n > fb%pos) then
        ! make an error
      else
        fb%pos = fb%pos - n
      endif
    endif

  end subroutine put_characters


  function line(fb) result(n)
    type(file_buffer_t), intent(in) :: fb
    integer :: n

    n = fb%line
  end function line


  function column(fb) result(n)
    type(file_buffer_t), intent(in) :: fb
    integer :: n

    n = fb%col
  end function column


  subroutine dump_string(string)
    character(len=*) :: string
    integer :: m, n
    m = 1
    n = index(string, achar(13))
    do while (n /= 0)
      print*, string(m:m+n-2)
      m = m + n
      n = index(string(m:), achar(13))
    enddo
    print*, string(m:)
  end subroutine dump_string

  function index_fb(fb, marker) result(p)
    type(file_buffer_t), intent(in) :: fb
    character(len=*), intent(in) :: marker
    integer :: p

    type(buffer_t), pointer :: cb

    if (size(fb%buffer_stack) > 0) then
      cb => fb%buffer_stack(1)
      p = index(str_vs(cb%s(cb%pos:)), marker)
    else
      p = index(fb%buffer(fb%pos:fb%nchars), marker)
    endif

  end function index_fb

  function scan_fb(fb, marker) result(p)
    type(file_buffer_t), intent(in) :: fb
    character(len=*), intent(in) :: marker
    integer :: p

    type(buffer_t), pointer :: cb

    if (size(fb%buffer_stack) > 0) then
      cb => fb%buffer_stack(1)
      p = scan(str_vs(cb%s(cb%pos:)), marker)
    else
      p = scan(fb%buffer(fb%pos:fb%nchars), marker)
    endif

  end function scan_fb

  function verify_fb(fb, marker) result(p)
    type(file_buffer_t), intent(in) :: fb
    character(len=*), intent(in) :: marker
    integer :: p

    type(buffer_t), pointer :: cb

    if (size(fb%buffer_stack) > 0) then
      cb => fb%buffer_stack(1)
      p = verify(str_vs(cb%s(cb%pos:)), marker)
    else
      p = verify(fb%buffer(fb%pos:fb%nchars), marker)
    endif

  end function verify_fb

  function check_fb(fb, check, true) result(n)
    type(file_buffer_t), intent(in) :: fb
    interface
      function check(c) result(p)
        character, intent(in) :: c
        logical :: p
      end function check
    end interface
    logical, intent(in) :: true
    integer :: n

    type(buffer_t), pointer :: cb
    integer :: i

    n = 0
    i = 1
    if (size(fb%buffer_stack) > 0) then
      cb => fb%buffer_stack(1)
      do while (cb%pos+i-1<=size(cb%s))
        if (true.eqv.check(cb%s(cb%pos+i-1))) then
          n = i
          exit
        else
          i = i + 1
        endif
      enddo
    else
      do while (fb%pos+i-1<=fb%nchars)
        if (true.eqv.check(fb%buffer(fb%pos+i-1:fb%pos+i-1))) then
          n = i
          exit
        else
          i = i + 1
        endif
      enddo
    endif

  end function check_fb

end module m_sax_reader

module FoX_dom

  use m_common_array_str
  use m_common_format
  use m_dom_dom
  use m_dom_error
  use m_dom_extras
  use m_dom_parse
  use m_dom_utils

  implicit none
  private

  public :: str_vs, vs_vs_alloc, vs_str_alloc
  public :: str, operator(//)

  public :: DOMImplementation
  public :: Node
  public :: NodeList
  public :: NamedNodeMap

  ! DOM DOMString
  ! no

  ! DOM DOMTimestamp
  !  public :: DOMTimestamp

  ! DOM Exceptions
  public :: DOMException
  public :: inException
  public :: getExceptionCode

  public :: INDEX_SIZE_ERR
  public :: DOMSTRING_SIZE_ERR
  public :: HIERARCHY_REQUEST_ERR
  public :: WRONG_DOCUMENT_ERR
  public :: INVALID_CHARACTER_ERR
  public :: NO_DATA_ALLOWED_ERR
  public :: NO_MODIFICATION_ALLOWED_ERR
  public :: NOT_FOUND_ERR
  public :: NOT_SUPPORTED_ERR
  public :: INUSE_ATTRIBUTE_ERR
  public :: INVALID_STATE_ERR
  public :: SYNTAX_ERR
  public :: INVALID_MODIFICATION_ERR
  public :: NAMESPACE_ERR
  public :: INVALID_ACCESS_ERR
  public :: VALIDATION_ERR
  public :: TYPE_MISMATCH_ERR
  ! XPath
  public :: INVALID_EXPRESSION_ERR
  public :: TYPE_ERR
  ! LS
  public :: PARSE_ERR
  public :: SERIALIZE_ERR

  ! DOM Implementation
  public :: hasFeature
  public :: createDocumentType
  public :: createDocument

  ! DOM Document
  public :: getDocumentElement
  public :: getDocType
  public :: getImplementation
  public :: createDocumentFragment
  public :: createElement
  public :: createTextNode
  public :: createComment
  public :: createCDATASection
  public :: createProcessingInstruction
  public :: createAttribute
  public :: createEntityReference
  public :: getElementsByTagName
  public :: getElementById

  public :: importNode
  public :: createElementNS
  public :: createAttributeNS
  public :: getElementsByTagNameNS

  public :: getXmlStandalone
  public :: setXmlStandalone
  public :: getXmlVersion
  public :: setXmlVersion
  public :: getXmlEncoding
  public :: getInputEncoding
  public :: getDocumentURI
  public :: setDocumentURI
  public :: getStrictErrorChecking
  public :: setStrictErrorChecking
  public :: getDomConfig
  public :: normalizeDocument

  ! DOM Node
  public :: ELEMENT_NODE
  public :: ATTRIBUTE_NODE
  public :: TEXT_NODE
  public :: CDATA_SECTION_NODE
  public :: ENTITY_REFERENCE_NODE
  public :: ENTITY_NODE
  public :: PROCESSING_INSTRUCTION_NODE
  public :: COMMENT_NODE
  public :: DOCUMENT_NODE
  public :: DOCUMENT_TYPE_NODE
  public :: DOCUMENT_FRAGMENT_NODE
  public :: NOTATION_NODE

  public :: getNodeName
  public :: getNodeValue
  public :: setNodeValue
  public :: getNodeType
  public :: getFirstChild
  public :: getLastChild
  public :: getAttributes
  public :: getNextSibling
  public :: getPreviousSibling
  public :: getParentNode
  public :: getChildNodes
  public :: getOwnerDocument
  public :: insertBefore
  public :: replaceChild
  public :: removeChild
  public :: appendChild
  public :: hasChildNodes
  public :: cloneNode
  public :: normalize

  public :: isSupported
  public :: getNamespaceURI
  public :: getPrefix
  public :: setPrefix
  public :: getLocalName
  public :: hasAttributes

  public :: getTextContent
  public :: setTextContent
  public :: isEqualNode
  public :: isSameNode
  public :: isDefaultNamespace
  public :: lookupNamespaceURI
  public :: lookupPrefix

  ! DOM NodeList
  public :: item
  public :: append

  ! DOM NamedNodeMap
  public :: getLength
  public :: getNamedItem
  public :: setNamedItem
  public :: removeNamedItem
!  public :: item
  public :: getNamedItemNS
  public :: setNamedItemNS
  public :: removeNamedItemNS

  ! DOM CharacterData
  ! NB We use the native Fortran string type here
  ! rather than inventing a DOM String, thus no
  ! string type to make public
! public :: getData
! public :: setData
  public :: substringData
  public :: appendData
  public :: insertData
  public :: deleteData
  public :: replaceData

  ! DOM Attr
!  public :: getName
  public :: getSpecified
  public :: getValue
  public :: setValue
  public :: getOwnerElement
  public :: getIsId

  ! DOM Element
  public :: getTagName
  public :: getAttribute
  public :: setAttribute
  public :: removeAttribute
  public :: getAttributeNode
  public :: setAttributeNode
  public :: removeAttributeNode
!  public :: getElementsByTagName
  public :: getAttributeNS
  public :: setAttributeNS
  public :: removeAttributeNS
  public :: getAttributeNodeNS
  public :: setAttributeNodeNS
!  public :: getElementsByTagNameNS
  public :: hasAttribute
  public :: hasAttributeNS

  !DOM Text
  public :: splitText
  public :: getIsElementContentWhitespace

  !DOM CData
! public :: getData
! public :: setData

  !DOM DocumentType
  public :: getEntities
  public :: getNotations
  public :: getInternalSubset
  
  !DOM Notation

  !DOM Entity
  public :: getNotationName

  !DOM EntityReference

  !DOM ProcessingInstruction
!  public :: getData
!  public :: setData
  public :: getTarget

  !DOM common
  public :: getData
  public :: setData
  public :: getName
  public :: getPublicId
  public :: getSystemId

  !DOM Configuration
  public :: DOMConfiguration
  public :: getParameter
  public :: setParameter
  public :: canSetParameter
  
  ! FoX-only interfaces
  public :: newDOMConfig

  public :: getNodePath

  public :: extractDataContent
  public :: extractDataAttribute
  public :: extractDataAttributeNS

  public :: parseFile
  public :: parseString
  public :: serialize

  public :: destroy
  public :: getFoX_checks
  public :: setFoX_checks
  public :: getLiveNodeLists
  public :: setLiveNodeLists
  public :: getNamespaceNodes

end module FoX_dom

module m_common_parse_input

  use m_common_charset, only : XML_WHITESPACE
  use m_common_realtypes, only: sp, dp

  implicit none
  private

  interface rts
    module procedure scalartostring
    module procedure scalartological
    module procedure scalartointeger
    module procedure scalartorealsp
    module procedure scalartorealdp
    module procedure scalartocomplexsp
    module procedure scalartocomplexdp
    module procedure arraytostring
    module procedure arraytological
    module procedure arraytointeger
    module procedure arraytorealsp
    module procedure arraytorealdp
    module procedure arraytocomplexsp
    module procedure arraytocomplexdp
    module procedure matrixtostring
    module procedure matrixtological
    module procedure matrixtointeger
    module procedure matrixtorealsp
    module procedure matrixtorealdp
    module procedure matrixtocomplexsp
    module procedure matrixtocomplexdp
  end interface

  public :: rts

contains

  subroutine scalartostring(s, data, num, iostat)
    character(len=*), intent(in) :: s
    character(len=*), intent(out) :: data
    integer, intent(out), optional :: num, iostat

    logical :: ws
    integer :: i, m

    m = 1
    ws = .true.
    do i = 1, len(s)
      if (m>len(data)) exit
      if (ws.and.verify(s(i:i), XML_WHITESPACE)==0) cycle
      if (verify(s(i:i), XML_WHITESPACE)==0) then
        data(m:m) = " "
        m = m + 1
        ws = .true.
      else
        data(m:m) = s(i:i)
        m = m + 1
        if (ws) ws = .false.
      endif
    enddo

    if (m<=len(data)) data(m:) = ""

    if (present(num)) num = 1
    if (present(iostat)) iostat = 0

  end subroutine scalartostring

  subroutine scalartological(s, data, num, iostat)
    character(len=*), intent(in) :: s
    logical, intent(out) :: data
    integer, intent(out), optional :: num, iostat
    integer :: i, ij, k, s_i, err, length


    s_i = 1
    err = 0
    data = .false.
    ij = 0
    length = 1
    loop: do i = 1, 1
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      if (s(s_i:s_i)==",") then
        if (s_i+1>len(s)) then
          err = 2
          exit loop
        endif
        k = verify(s(s_i+1:), XML_WHITESPACE)
        s_i = s_i + k - 1
      endif
      k = scan(s(s_i:), XML_WHITESPACE//",")
      if (k==0) then
        k = len(s)
      else
        k = s_i + k - 2
      endif
      if (s(s_i:k)=="true".or.s(s_i:k)=="1") then
        data = .true.
      elseif (s(s_i:k)=="false".or.s(s_i:k)=="0") then
        data = .false.
      else
        err = 2
        exit loop
      endif
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in scalartological"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in scalartological"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in scalartological"
        write(0, *) "Malformed input"
        stop
      end select
    end if

  end subroutine scalartological

  subroutine scalartointeger(s, data, num, iostat)
    character(len=*), intent(in) :: s
    integer, intent(out) :: data
    integer, intent(out), optional :: num, iostat

    integer :: i, ij, k, s_i, err, ios, length


    s_i = 1
    err = 0
    data = 0
    ij = 0
    length = 1
    loop: do i = 1, 1
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      if (s(s_i:s_i)==",") then
        if (s_i+1>len(s)) then
          err = 2
          exit loop
        endif
        k = verify(s(s_i+1:), XML_WHITESPACE)
        s_i = s_i + k - 1
      endif
      k = scan(s(s_i:), XML_WHITESPACE//",")
      if (k==0) then
        k = len(s)
      else
        k = s_i + k - 2
      endif
      read(s(s_i:k), *, iostat=ios) data
      if (ios/=0) then
        err = 2
        exit loop
      endif
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in scalartointeger"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in scalartointeger"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in scalartointeger"
        write(0, *) "Malformed input"
        stop
      end select
    end if

  end subroutine scalartointeger

  subroutine scalartorealsp(s, data, num, iostat)
    character(len=*), intent(in) :: s
    real(sp), intent(out) :: data
    integer, intent(out), optional :: num, iostat

    integer :: i, ij, k, s_i, err, ios, length


    s_i = 1
    err = 0
    data = 0.0_sp
    ij = 0
    length = 1
    loop: do i = 1, 1
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      if (s(s_i:s_i)==",") then
        if (s_i+1>len(s)) then
          err = 2
          exit loop
        endif
        k = verify(s(s_i+1:), XML_WHITESPACE)
        s_i = s_i + k - 1
      endif
      k = scan(s(s_i:), XML_WHITESPACE//",")
      if (k==0) then
        k = len(s)
      else
        k = s_i + k - 2
      endif
      read(s(s_i:k), *, iostat=ios) data
      if (ios/=0) then
        err = 2
        exit loop
      endif
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in scalartorealsp"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in scalartorealsp"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in scalartorealsp"
        write(0, *) "Malformed input"
        stop
      end select
    end if

  end subroutine scalartorealsp

  subroutine scalartorealdp(s, data, num, iostat)
    character(len=*), intent(in) :: s
    real(dp), intent(out) :: data
    integer, intent(out), optional :: num, iostat

    integer :: i, ij, k, s_i, err, ios, length


    s_i = 1
    err = 0
    data = 0.0_dp
    ij = 0
    length = 1
    loop: do i = 1, 1
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      if (s(s_i:s_i)==",") then
        if (s_i+1>len(s)) then
          err = 2
          exit loop
        endif
        k = verify(s(s_i+1:), XML_WHITESPACE)
        s_i = s_i + k - 1
      endif
      k = scan(s(s_i:), XML_WHITESPACE//",")
      if (k==0) then
        k = len(s)
      else
        k = s_i + k - 2
      endif
      read(s(s_i:k), *, iostat=ios) data
      if (ios/=0) then
        err = 2
        exit loop
      endif
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in scalartorealdp"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in scalartorealdp"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in scalartorealdp"
        write(0, *) "Malformed input"
        stop
      end select
    end if

  end subroutine scalartorealdp

  subroutine scalartocomplexsp(s, data, num, iostat)
    character(len=*), intent(in) :: s
    complex(sp), intent(out) :: data
    integer, intent(out), optional :: num, iostat

    logical :: bracketed
    integer :: i, ij, k, s_i, err, ios, length
    real :: r, c


    s_i = 1
    err = 0
    data = 0.0_sp
    ij = 0
    length = 1
    loop: do i = 1, 1
      bracketed = .false.
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      select case (s(s_i:s_i))
      case ("(")
        bracketed = .true.
        k = verify(s(s_i:), XML_WHITESPACE)
        if (k==0) then
          err = 2
          exit loop
        endif
        s_i = s_i + k
      case (",")
        k = verify(s(s_i:), XML_WHITESPACE)
        if (k==0) then
          err = 2
          exit loop
        endif
        s_i = s_i + k - 1
      case ("+", "-", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
        continue
      case default
        err = 2
        exit loop
      end select
      if (bracketed) then
        k = index(s(s_i:), ")+i(")
      else
        k = scan(s(s_i:), XML_WHITESPACE//",")
      endif
      if (k==0) then
        err = 2
        exit loop
      endif
      k = s_i + k - 2
      read(s(s_i:k), *, iostat=ios) r
      if (ios/=0) then
        err = 2
        exit loop
      endif
      if (bracketed) then
        s_i = k + 5
        if (s_i>len(s)) then
          err = 2
          exit loop
        endif
      else
        s_i = k + 2
      endif
      if (bracketed) then
        k = index(s(s_i:), ")")
        if (k==0) then
          err = 2
          exit loop
        endif
        k = s_i + k - 2
      else
        k = scan(s(s_i:), XML_WHITESPACE//",")
        if (k==0) then
          k = len(s)
        else
          k = s_i + k - 2
        endif
      endif
      read(s(s_i:k), *, iostat=ios) c
      if (ios/=0) then
        err = 2
        exit loop
      endif
      data = cmplx(r, c)
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in scalartocomplexsp"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in scalartocomplexsp"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in scalartocomplexsp"
        write(0, *) "Malformed input"
        stop
      end select
    end if

  end subroutine scalartocomplexsp

  subroutine scalartocomplexdp(s, data, num, iostat)
    character(len=*), intent(in) :: s
    complex(dp), intent(out) :: data
    integer, intent(out), optional :: num, iostat

    logical :: bracketed
    integer :: i, ij, k, s_i, err, ios, length
    real :: r, c


    s_i = 1
    err = 0
    data = 0.0_dp
    ij = 0
    length = 1
    loop: do i = 1, 1
      bracketed = .false.
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      select case (s(s_i:s_i))
      case ("(")
        bracketed = .true.
        k = verify(s(s_i:), XML_WHITESPACE)
        if (k==0) then
          err = 2
          exit loop
        endif
        s_i = s_i + k
      case (",")
        k = verify(s(s_i:), XML_WHITESPACE)
        if (k==0) then
          err = 2
          exit loop
        endif
        s_i = s_i + k - 1
      case ("+", "-", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
        continue
      case default
        err = 2
        exit loop
      end select
      if (bracketed) then
        k = index(s(s_i:), ")+i(")
      else
        k = scan(s(s_i:), XML_WHITESPACE//",")
      endif
      if (k==0) then
        err = 2
        exit loop
      endif
      k = s_i + k - 2
      read(s(s_i:k), *, iostat=ios) r
      if (ios/=0) then
        err = 2
        exit loop
      endif
      if (bracketed) then
        s_i = k + 5
        if (s_i>len(s)) then
          err = 2
          exit loop
        endif
      else
        s_i = k + 2
      endif
      if (bracketed) then
        k = index(s(s_i:), ")")
        if (k==0) then
          err = 2
          exit loop
        endif
        k = s_i + k - 2
      else
        k = scan(s(s_i:), XML_WHITESPACE//",")
        if (k==0) then
          k = len(s)
        else
          k = s_i + k - 2
        endif
      endif
      read(s(s_i:k), *, iostat=ios) c
      if (ios/=0) then
        err = 2
        exit loop
      endif
      data = cmplx(r, c)
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in scalartocomplexdp"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in scalartocomplexdp"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in scalartocomplexdp"
        write(0, *) "Malformed input"
        stop
      end select
    end if

  end subroutine scalartocomplexdp



  subroutine arraytostring(s, data, separator, csv, num, iostat)
    character(len=*) :: data(:)
    character, intent(in), optional :: separator
    logical, intent(in), optional :: csv
    character(len=*), intent(in) :: s
    integer, intent(out), optional :: num
    integer, intent(out), optional :: iostat


    integer :: i, ij, k, s_i, err, length

    character(len=len(s)) :: s2
    logical :: csv_, eof
    integer :: m

    csv_ = .false.
    if (present(csv)) then
      if (csv) csv_ = csv
    endif

    s_i = 1
    err = 0
    eof = .false.
    data = ""
    ij = 0
    length = size(data)
    loop: do i = 1, size(data)
      if (csv_) then
      if (s_i>len(s)) then
        data(i) = ""
        ij = ij + 1
        exit loop
      endif
      k = verify(s(s_i:), achar(10)//achar(13))
      if (k==0) then
        data(i) = ""
        ij = ij + 1
        exit loop
      elseif (s(s_i+k-1:s_i+k-1)=="""") then
        ! we have a quote-delimited string;
        s_i = s_i + k
        s2 = ""
        quote: do 
          k = index(s(s_i:), """")
          if (k==0) then
            err = 2
            exit loop
          endif
          k = s_i + k - 1
          s2(m:) = s(s_i:k)
          m = m + (k-s_i+1)
          k = k + 2
          if (k>len(s)) then
            err = 2
            exit loop
          endif
          if (s(k:k)/="""") exit
          s_i = k + 1
          if (s_i > len(s)) then
            err = 2
            exit loop
          endif
          m = m + 1
          s2(m:m) = """"
        enddo quote
        data(i) = s2
        k  = scan(s(s_i:), XML_WHITESPACE)
        if (k==0) then
          err = 2
          exit loop
        endif
      else
        s_i = s_i + k - 1
        k = scan(s(s_i:), achar(10)//achar(13)//",")
        if (k==0) then
          eof = .true.
          k = len(s)
        else
          if (ij+1==length.and.s(s_i+k-1:s_i+k-1)==",") err = 1
          k = s_i + k - 2
        endif
        data(i) = s(s_i:k)
        if (index(data(i), """")/=0) then
          err = 2
          exit loop
        endif
      endif
      ij = ij + 1
      s_i = k + 2
      if (eof) exit loop

      else
      if (present(separator)) then
        k = index(s(s_i:), separator)
      else
        k = verify(s(s_i:), XML_WHITESPACE)
        if (k==0) exit loop
        s_i = s_i + k - 1
        k = scan(s(s_i:), XML_WHITESPACE)
      endif
      if (k==0) then
        k = len(s)
      else
        k = s_i + k - 2
      endif
      data(i) = s(s_i:k)
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

      endif
    end do loop

    if (present(num)) num = ij
    if (ij<size(data)) then
      err = -1
    else
      if (present(separator)) then
        if (len(s)-s_i>=0) &
          err = 1
      else
        if (verify(s(s_i:), XML_WHITESPACE)/=0) &
          err = 1
      endif
    endif

    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in arraytostring"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in arraytostring"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in arraytostring"
        write(0, *) "Malformed input"
        stop
      end select
    end if


  end subroutine arraytostring

  subroutine matrixtostring(s, data, separator, csv, num, iostat)
    character(len=*) :: data(:,:)
    character, intent(in), optional :: separator
    logical, intent(in), optional :: csv
    character(len=*), intent(in) :: s
    integer, intent(out), optional :: num
    integer, intent(out), optional :: iostat


    integer :: i, ij, k, s_i, err, length

    character(len=len(s)) :: s2
    logical :: csv_, eof
    integer :: j, m

    csv_ = .false.
    if (present(csv)) then
      if (csv) csv_ = csv
    endif

    s_i = 1
    err = 0
    eof = .false.
    data = ""
    ij = 0
    length = size(data)
    loop: do j = 1, size(data, 2)
      do i = 1, size(data, 1)
        if (csv_) then
      if (s_i>len(s)) then
        data(i, j) = ""
        ij = ij + 1
        exit loop
      endif
      k = verify(s(s_i:), achar(10)//achar(13))
      if (k==0) then
        data(i, j) = ""
        ij = ij + 1
        exit loop
      elseif (s(s_i+k-1:s_i+k-1)=="""") then
        ! we have a quote-delimited string;
        s_i = s_i + k
        s2 = ""
        quote: do 
          k = index(s(s_i:), """")
          if (k==0) then
            err = 2
            exit loop
          endif
          k = s_i + k - 1
          s2(m:) = s(s_i:k)
          m = m + (k-s_i+1)
          k = k + 2
          if (k>len(s)) then
            err = 2
            exit loop
          endif
          if (s(k:k)/="""") exit
          s_i = k + 1
          if (s_i > len(s)) then
            err = 2
            exit loop
          endif
          m = m + 1
          s2(m:m) = """"
        enddo quote
        data(i, j) = s2
        k  = scan(s(s_i:), XML_WHITESPACE)
        if (k==0) then
          err = 2
          exit loop
        endif
      else
        s_i = s_i + k - 1
        k = scan(s(s_i:), achar(10)//achar(13)//",")
        if (k==0) then
          eof = .true.
          k = len(s)
        else
          if (ij+1==length.and.s(s_i+k-1:s_i+k-1)==",") err = 1
          k = s_i + k - 2
        endif
        data(i, j) = s(s_i:k)
        if (index(data(i, j), """")/=0) then
          err = 2
          exit loop
        endif
      endif
      ij = ij + 1
      s_i = k + 2
      if (eof) exit loop
        else
      if (present(separator)) then
        k = index(s(s_i:), separator)
      else
        k = verify(s(s_i:), XML_WHITESPACE)
        if (k==0) exit loop
        s_i = s_i + k - 1
        k = scan(s(s_i:), XML_WHITESPACE)
      endif
      if (k==0) then
        k = len(s)
      else
        k = s_i + k - 2
      endif
      data(i, j) = s(s_i:k)
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop
        endif
      end do
    end do loop

    if (present(num)) num = ij
    if (ij<size(data)) then
      err = -1
    else
      if (present(separator)) then
        if (len(s)-s_i>=0) &
          err = 1
      else
        if (verify(s(s_i:), XML_WHITESPACE)/=0) &
          err = 1
      endif
    endif

    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in matrixtostring"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in matrixtostring"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in matrixtostring"
        write(0, *) "Malformed input"
        stop
      end select
    end if


  end subroutine matrixtostring

  subroutine arraytological(s, data, num, iostat)
    logical, intent(out) :: data(:)
    character(len=*), intent(in) :: s
    integer, intent(out), optional :: num
    integer, intent(out), optional :: iostat


    integer :: i, ij, k, s_i, err, length


    s_i = 1
    err = 0
    data = .false.
    ij  = 0
    length = size(data)
    loop: do i = 1, size(data)
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      if (s(s_i:s_i)==",") then
        if (s_i+1>len(s)) then
          err = 2
          exit loop
        endif
        k = verify(s(s_i+1:), XML_WHITESPACE)
        s_i = s_i + k - 1
      endif
      k = scan(s(s_i:), XML_WHITESPACE//",")
      if (k==0) then
        k = len(s)
      else
        k = s_i + k - 2
      endif
      if (s(s_i:k)=="true".or.s(s_i:k)=="1") then
        data(i) = .true.
      elseif (s(s_i:k)=="false".or.s(s_i:k)=="0") then
        data(i) = .false.
      else
        err = 2
        exit loop
      endif
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in arraytological"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in arraytological"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in arraytological"
        write(0, *) "Malformed input"
        stop
      end select
    end if


  end subroutine arraytological

  subroutine matrixtological(s, data, num, iostat)
    logical, intent(out) :: data(:,:)
    character(len=*), intent(in) :: s
    integer, intent(out), optional :: num
    integer, intent(out), optional :: iostat


    integer :: i, ij, k, s_i, err, length

    integer :: j

    s_i = 1
    err = 0
    data = .false.
    ij = 0
    length = size(data)
    loop: do j = 1, size(data, 2)
    do i = 1, size(data, 1)
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      if (s(s_i:s_i)==",") then
        if (s_i+1>len(s)) then
          err = 2
          exit loop
        endif
        k = verify(s(s_i+1:), XML_WHITESPACE)
        s_i = s_i + k - 1
      endif
      k = scan(s(s_i:), XML_WHITESPACE//",")
      if (k==0) then
        k = len(s)
      else
        k = s_i + k - 2
      endif
      if (s(s_i:k)=="true".or.s(s_i:k)=="1") then
        data(i, j) = .true.
      elseif (s(s_i:k)=="false".or.s(s_i:k)=="0") then
        data(i, j) = .false.
      else
        err = 2
        exit loop
      endif
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do
    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in matrixtological"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in matrixtological"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in matrixtological"
        write(0, *) "Malformed input"
        stop
      end select
    end if


  end subroutine matrixtological

  subroutine arraytointeger(s, data, num, iostat)
    integer, intent(out) :: data(:)
    character(len=*), intent(in) :: s
    integer, intent(out), optional :: num
    integer, intent(out), optional :: iostat


    integer :: i, ij, k, s_i, err, ios, length

    s_i = 1
    err = 0
    data = 0
    ij  = 0
    length = size(data)
    loop: do i = 1, size(data)
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      if (s(s_i:s_i)==",") then
        if (s_i+1>len(s)) then
          err = 2
          exit loop
        endif
        k = verify(s(s_i+1:), XML_WHITESPACE)
        s_i = s_i + k - 1
      endif
      k = scan(s(s_i:), XML_WHITESPACE//",")
      if (k==0) then
        k = len(s)
      else
        k = s_i + k - 2
      endif
      read(s(s_i:k), *, iostat=ios) data(i)
      if (ios/=0) then
        err = 2
        exit loop
      endif
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in arraytointeger"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in arraytointeger"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in arraytointeger"
        write(0, *) "Malformed input"
        stop
      end select
    end if


  end subroutine arraytointeger

  subroutine matrixtointeger(s, data, num, iostat)
    integer, intent(out) :: data(:, :)
    character(len=*), intent(in) :: s
    integer, intent(out), optional :: num
    integer, intent(out), optional :: iostat


    integer :: i, ij, k, s_i, err, ios, length

   integer :: j

    s_i = 1
    err = 0
    data = 0
    ij = 0
    length = size(data)
    loop: do j = 1, size(data, 2)
    do i = 1, size(data, 1)
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      if (s(s_i:s_i)==",") then
        if (s_i+1>len(s)) then
          err = 2
          exit loop
        endif
        k = verify(s(s_i+1:), XML_WHITESPACE)
        s_i = s_i + k - 1
      endif
      k = scan(s(s_i:), XML_WHITESPACE//",")
      if (k==0) then
        k = len(s)
      else
        k = s_i + k - 2
      endif
      read(s(s_i:k), *, iostat=ios) data(i, j)
      if (ios/=0) then
        err = 2
        exit loop
      endif
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do
    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in matrixtointeger"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in matrixtointeger"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in matrixtointeger"
        write(0, *) "Malformed input"
        stop
      end select
    end if


  end subroutine matrixtointeger

  subroutine arraytorealsp(s, data, num, iostat)
    real(sp), intent(out) :: data(:)
    character(len=*), intent(in) :: s
    integer, intent(out), optional :: num
    integer, intent(out), optional :: iostat


    integer :: i, ij, k, s_i, err, ios, length


    s_i = 1
    err = 0
    data = 0
    ij  = 0
    length = size(data)
    loop: do i = 1, size(data)
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      if (s(s_i:s_i)==",") then
        if (s_i+1>len(s)) then
          err = 2
          exit loop
        endif
        k = verify(s(s_i+1:), XML_WHITESPACE)
        s_i = s_i + k - 1
      endif
      k = scan(s(s_i:), XML_WHITESPACE//",")
      if (k==0) then
        k = len(s)
      else
        k = s_i + k - 2
      endif
      read(s(s_i:k), *, iostat=ios) data(i)
      if (ios/=0) then
        err = 2
        exit loop
      endif
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in arraytorealsp"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in arraytorealsp"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in arraytorealsp"
        write(0, *) "Malformed input"
        stop
      end select
    end if


  end subroutine arraytorealsp

  subroutine matrixtorealsp(s, data, num, iostat)
    real(sp), intent(out) :: data(:,:)
    character(len=*), intent(in) :: s
    integer, intent(out), optional :: num
    integer, intent(out), optional :: iostat


    integer :: i, ij, k, s_i, err, ios, length

    integer :: j

    s_i = 1
    err = 0
    data = 0
    ij = 0
    length = size(data)
    loop: do j = 1, size(data, 2)
    do i = 1, size(data, 1)
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      if (s(s_i:s_i)==",") then
        if (s_i+1>len(s)) then
          err = 2
          exit loop
        endif
        k = verify(s(s_i+1:), XML_WHITESPACE)
        s_i = s_i + k - 1
      endif
      k = scan(s(s_i:), XML_WHITESPACE//",")
      if (k==0) then
        k = len(s)
      else
        k = s_i + k - 2
      endif
      read(s(s_i:k), *, iostat=ios) data(i, j)
      if (ios/=0) then
        err = 2
        exit loop
      endif
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do
    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in matrixtorealsp"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in matrixtorealsp"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in matrixtorealsp"
        write(0, *) "Malformed input"
        stop
      end select
    end if


  end subroutine matrixtorealsp

  subroutine arraytorealdp(s, data, num, iostat)
    real(dp), intent(out) :: data(:)
    character(len=*), intent(in) :: s
    integer, intent(out), optional :: num
    integer, intent(out), optional :: iostat


    integer :: i, ij, k, s_i, err, ios, length


    s_i = 1
    err = 0
    data = 0
    ij  = 0
    length = size(data)
    loop: do i = 1, size(data)
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      if (s(s_i:s_i)==",") then
        if (s_i+1>len(s)) then
          err = 2
          exit loop
        endif
        k = verify(s(s_i+1:), XML_WHITESPACE)
        s_i = s_i + k - 1
      endif
      k = scan(s(s_i:), XML_WHITESPACE//",")
      if (k==0) then
        k = len(s)
      else
        k = s_i + k - 2
      endif
      read(s(s_i:k), *, iostat=ios) data(i)
      if (ios/=0) then
        err = 2
        exit loop
      endif
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in arraytorealdp"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in arraytorealdp"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in arraytorealdp"
        write(0, *) "Malformed input"
        stop
      end select
    end if


  end subroutine arraytorealdp

  subroutine matrixtorealdp(s, data, num, iostat)
    real(dp), intent(out) :: data(:,:)
    character(len=*), intent(in) :: s
    integer, intent(out), optional :: num
    integer, intent(out), optional :: iostat


    integer :: i, ij, k, s_i, err, ios, length

    integer :: j

    s_i = 1
    err = 0
    data = cmplx(0,0)
    ij = 0
    length = size(data)
    loop: do j = 1, size(data, 2)
    do i = 1, size(data, 1)
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      if (s(s_i:s_i)==",") then
        if (s_i+1>len(s)) then
          err = 2
          exit loop
        endif
        k = verify(s(s_i+1:), XML_WHITESPACE)
        s_i = s_i + k - 1
      endif
      k = scan(s(s_i:), XML_WHITESPACE//",")
      if (k==0) then
        k = len(s)
      else
        k = s_i + k - 2
      endif
      read(s(s_i:k), *, iostat=ios) data(i, j)
      if (ios/=0) then
        err = 2
        exit loop
      endif
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do
    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in matrixtorealdp"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in matrixtorealdp"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in matrixtorealdp"
        write(0, *) "Malformed input"
        stop
      end select
    end if


  end subroutine matrixtorealdp

  subroutine arraytocomplexsp(s, data, num, iostat)
    complex(sp), intent(out) :: data(:)
    character(len=*), intent(in) :: s
    integer, intent(out), optional :: num
    integer, intent(out), optional :: iostat


    logical :: bracketed
    integer :: i, ij, k, s_i, err, ios, length
    real :: r, c


    s_i = 1
    err = 0
    data = cmplx(0,0)
    ij  = 0
    length = size(data)
    loop: do i = 1, size(data)
      bracketed = .false.
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      select case (s(s_i:s_i))
      case ("(")
        bracketed = .true.
        k = verify(s(s_i:), XML_WHITESPACE)
        if (k==0) then
          err = 2
          exit loop
        endif
        s_i = s_i + k
      case (",")
        k = verify(s(s_i:), XML_WHITESPACE)
        if (k==0) then
          err = 2
          exit loop
        endif
        s_i = s_i + k - 1
      case ("+", "-", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
        continue
      case default
        err = 2
        exit loop
      end select
      if (bracketed) then
        k = index(s(s_i:), ")+i(")
      else
        k = scan(s(s_i:), XML_WHITESPACE//",")
      endif
      if (k==0) then
        err = 2
        exit loop
      endif
      k = s_i + k - 2
      read(s(s_i:k), *, iostat=ios) r
      if (ios/=0) then
        err = 2
        exit loop
      endif
      if (bracketed) then
        s_i = k + 5
        if (s_i>len(s)) then
          err = 2
          exit loop
        endif
      else
        s_i = k + 2
      endif
      if (bracketed) then
        k = index(s(s_i:), ")")
        if (k==0) then
          err = 2
          exit loop
        endif
        k = s_i + k - 2
      else
        k = scan(s(s_i:), XML_WHITESPACE//",")
        if (k==0) then
          k = len(s)
        else
          k = s_i + k - 2
        endif
      endif
      read(s(s_i:k), *, iostat=ios) c
      if (ios/=0) then
        err = 2
        exit loop
      endif
      data(i) = cmplx(r, c)
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in arraytocomplexsp"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in arraytocomplexsp"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in arraytocomplexsp"
        write(0, *) "Malformed input"
        stop
      end select
    end if


  end subroutine arraytocomplexsp

  subroutine matrixtocomplexsp(s, data, num, iostat)
    complex(sp), intent(out) :: data(:,:)
    character(len=*), intent(in) :: s
    integer, intent(out), optional :: num
    integer, intent(out), optional :: iostat


    logical :: bracketed
    integer :: i, ij, k, s_i, err, ios, length
    real :: r, c

   integer :: j

    s_i = 1
    err = 0
    data = cmplx(0,0)
    ij = 0
    length = size(data)
    loop: do j = 1, size(data, 2)
    do i = 1, size(data, 1)
      bracketed = .false.
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      select case (s(s_i:s_i))
      case ("(")
        bracketed = .true.
        k = verify(s(s_i:), XML_WHITESPACE)
        if (k==0) then
          err = 2
          exit loop
        endif
        s_i = s_i + k
      case (",")
        k = verify(s(s_i:), XML_WHITESPACE)
        if (k==0) then
          err = 2
          exit loop
        endif
        s_i = s_i + k - 1
      case ("+", "-", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
        continue
      case default
        err = 2
        exit loop
      end select
      if (bracketed) then
        k = index(s(s_i:), ")+i(")
      else
        k = scan(s(s_i:), XML_WHITESPACE//",")
      endif
      if (k==0) then
        err = 2
        exit loop
      endif
      k = s_i + k - 2
      read(s(s_i:k), *, iostat=ios) r
      if (ios/=0) then
        err = 2
        exit loop
      endif
      if (bracketed) then
        s_i = k + 5
        if (s_i>len(s)) then
          err = 2
          exit loop
        endif
      else
        s_i = k + 2
      endif
      if (bracketed) then
        k = index(s(s_i:), ")")
        if (k==0) then
          err = 2
          exit loop
        endif
        k = s_i + k - 2
      else
        k = scan(s(s_i:), XML_WHITESPACE//",")
        if (k==0) then
          k = len(s)
        else
          k = s_i + k - 2
        endif
      endif
      read(s(s_i:k), *, iostat=ios) c
      if (ios/=0) then
        err = 2
        exit loop
      endif
      data(i, j) = cmplx(r, c)
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do
    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in matrixtocomplexsp"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in matrixtocomplexsp"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in matrixtocomplexsp"
        write(0, *) "Malformed input"
        stop
      end select
    end if


  end subroutine matrixtocomplexsp

  subroutine arraytocomplexdp(s, data, num, iostat)
    complex(dp), intent(out) :: data(:)
    character(len=*), intent(in) :: s
    integer, intent(out), optional :: num
    integer, intent(out), optional :: iostat


    logical :: bracketed
    integer :: i, ij, k, s_i, err, ios, length
    real :: r, c


    s_i = 1
    err = 0
    data = cmplx(0)
    ij  = 0
    length = size(data)
    loop: do i = 1, size(data)
      bracketed = .false.
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      select case (s(s_i:s_i))
      case ("(")
        bracketed = .true.
        k = verify(s(s_i:), XML_WHITESPACE)
        if (k==0) then
          err = 2
          exit loop
        endif
        s_i = s_i + k
      case (",")
        k = verify(s(s_i:), XML_WHITESPACE)
        if (k==0) then
          err = 2
          exit loop
        endif
        s_i = s_i + k - 1
      case ("+", "-", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
        continue
      case default
        err = 2
        exit loop
      end select
      if (bracketed) then
        k = index(s(s_i:), ")+i(")
      else
        k = scan(s(s_i:), XML_WHITESPACE//",")
      endif
      if (k==0) then
        err = 2
        exit loop
      endif
      k = s_i + k - 2
      read(s(s_i:k), *, iostat=ios) r
      if (ios/=0) then
        err = 2
        exit loop
      endif
      if (bracketed) then
        s_i = k + 5
        if (s_i>len(s)) then
          err = 2
          exit loop
        endif
      else
        s_i = k + 2
      endif
      if (bracketed) then
        k = index(s(s_i:), ")")
        if (k==0) then
          err = 2
          exit loop
        endif
        k = s_i + k - 2
      else
        k = scan(s(s_i:), XML_WHITESPACE//",")
        if (k==0) then
          k = len(s)
        else
          k = s_i + k - 2
        endif
      endif
      read(s(s_i:k), *, iostat=ios) c
      if (ios/=0) then
        err = 2
        exit loop
      endif
      data(i) = cmplx(r, c)
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in arraytocomplexdp"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in arraytocomplexdp"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in arraytocomplexdp"
        write(0, *) "Malformed input"
        stop
      end select
    end if


  end subroutine arraytocomplexdp

  subroutine matrixtocomplexdp(s, data, num, iostat)
    complex(dp), intent(out) :: data(:,:)
    character(len=*), intent(in) :: s
    integer, intent(out), optional :: num
    integer, intent(out), optional :: iostat


    logical :: bracketed
    integer :: i, ij, k, s_i, err, ios, length
    real :: r, c

    integer :: j

    s_i = 1
    err = 0
    data = cmplx(0,0)
    ij = 0
    length = size(data)
    loop: do j = 1, size(data, 2)
    do i = 1, size(data, 1)
      bracketed = .false.
      k = verify(s(s_i:), XML_WHITESPACE)
      if (k==0) exit loop
      s_i = s_i + k - 1
      select case (s(s_i:s_i))
      case ("(")
        bracketed = .true.
        k = verify(s(s_i:), XML_WHITESPACE)
        if (k==0) then
          err = 2
          exit loop
        endif
        s_i = s_i + k
      case (",")
        k = verify(s(s_i:), XML_WHITESPACE)
        if (k==0) then
          err = 2
          exit loop
        endif
        s_i = s_i + k - 1
      case ("+", "-", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
        continue
      case default
        err = 2
        exit loop
      end select
      if (bracketed) then
        k = index(s(s_i:), ")+i(")
      else
        k = scan(s(s_i:), XML_WHITESPACE//",")
      endif
      if (k==0) then
        err = 2
        exit loop
      endif
      k = s_i + k - 2
      read(s(s_i:k), *, iostat=ios) r
      if (ios/=0) then
        err = 2
        exit loop
      endif
      if (bracketed) then
        s_i = k + 5
        if (s_i>len(s)) then
          err = 2
          exit loop
        endif
      else
        s_i = k + 2
      endif
      if (bracketed) then
        k = index(s(s_i:), ")")
        if (k==0) then
          err = 2
          exit loop
        endif
        k = s_i + k - 2
      else
        k = scan(s(s_i:), XML_WHITESPACE//",")
        if (k==0) then
          k = len(s)
        else
          k = s_i + k - 2
        endif
      endif
      read(s(s_i:k), *, iostat=ios) c
      if (ios/=0) then
        err = 2
        exit loop
      endif
      data(i, j) = cmplx(r, c)
      ij = ij + 1
      s_i = k + 2
      if (ij<length.and.s_i>len(s)) exit loop

    end do
    end do loop

    if (present(num)) num = ij
    if (ij<length) then
      if (err==0) err = -1
    else
      if (verify(s(s_i:), XML_WHITESPACE)/=0) err = 1
    endif


    if (present(iostat)) then
      iostat = err
    else
      select case (err)
      case(-1)
        write(0, *) "Error in matrixtocomplexdp"
        write(0, *) "Too few elements found"
        stop
      case(1)
        write(0, *) "Error in matrixtocomplexdp"
        write(0, *) "Too many elements found"
        stop
      case(2)
        write(0, *) "Error in matrixtocomplexdp"
        write(0, *) "Malformed input"
        stop
      end select
    end if


  end subroutine matrixtocomplexdp
  
end module m_common_parse_input

program test_sax_reader

  use m_sax_reader

  type(file_buffer_t) :: fb

  character(len=5) :: s
  integer :: iostat

  call open_file(fb, file="test_sax_reader_5.in", iostat=iostat)

  call push_chars(fb, "abc")

  s = read_chars(fb, 5, iostat)
  write(*,'(3a)') 'char:', s, ':'
  write(*,'(a,i0)') 'iost:', iostat

  call close_file(fb) 

end program test_sax_reader

program test_sax_reader

  use m_sax_operate

  use m_handlers

  type(xml_t) :: xt

  call open_xml_string(xt, &
"<?xml version='1.0'?><!--comment--><?abc xyz?><pqr:aaa xmlns:pqr='lalala' "//&
"att='value' att2='valuejhg'> <!--c--><![CDATA[<>]]> <b/> jhg </pqr:aaa><")

  call parse(xt, &
       startDocument_handler=start_document_handler, &
       endDocument_handler=end_document_handler, &
       startElement_handler=begin_element_handler, &
       endElement_handler=end_element_handler, &
       startPrefixMapping_handler=start_prefix_handler, &
       endPrefixMapping_handler=end_prefix_handler, &
       characters_handler=characters_handler)

  call close_xml_t(xt)

end program test_sax_reader

program test_cmlBeginFile

  use FoX_wcml
  implicit none

  character(len=*), parameter :: filename = 'test.xml'

  type(xmlf_t) :: xf1

  call cmlBeginFile(xf1, filename, unit=-1)
  call cmlFinishFile(xf1)

end program test_cmlBeginFile

! XML tokenizer

module m_sax_tokenizer

  use m_common_array_str, only: vs_str, str_vs, vs_str_alloc, devnull
  use m_common_charset, only: XML_WHITESPACE, &
    XML_INITIALENCODINGCHARS, XML_ENCODINGCHARS, &
    XML1_0, XML1_1, operator(.in.), upperCase, digits, hexdigits, &
    isInitialNameChar, isXML1_0_NameChar, isXML1_1_NameChar
  use m_common_error, only: ERR_WARNING, add_error, in_error
  use m_common_entities, only: existing_entity, &
    is_unparsed_entity, is_external_entity, expand_entity_text, &
    expand_char_entity, add_internal_entity, pop_entity_list
  use m_common_namecheck, only: checkName, checkCharacterEntityReference

  use m_sax_reader, only: file_buffer_t, rewind_file, &
    read_char, read_chars, push_chars, get_characters, put_characters, &
    get_characters_until_all_of, &
    get_characters_until_one_of, &
    get_characters_until_not_one_of, &
    get_characters_until_condition
  use m_sax_types ! everything, really

  implicit none
  private

  public :: sax_tokenize
  public :: parse_xml_declaration
  public :: normalize_text

contains

  subroutine sax_tokenize(fx, fb, iostat)
    type(sax_parser_t), intent(inout) :: fx
    type(file_buffer_t), intent(inout) :: fb
    integer, intent(out) :: iostat

    character :: c, c2

    if (associated(fx%token)) deallocate(fx%token)
    nullify(fx%token)
    if (associated(fx%next_token)) then
      iostat = 0
      fx%token => fx%next_token
      nullify(fx%next_token)
      return
    endif

    if (fx%state==ST_START_PI) then
      c = get_characters(fb, 1, iostat)
      if (iostat/=0) return
      if (.not.isInitialNameChar(c, fx%xds%xml_version)) then
        call add_error(fx%error_stack, &
          'Invalid PI Name')
        return
      endif
      if (fx%xds%xml_version==XML1_0) then
        call get_characters_until_condition(fb, isXML1_0_NameChar, .false., iostat)
      elseif (fx%xds%xml_version==XML1_1) then
        call get_characters_until_condition(fb, isXML1_1_NameChar, .false., iostat)
      endif
      fx%token => vs_str_alloc(c//str_vs(fb%namebuffer))
      deallocate(fb%namebuffer)

    elseif (fx%state==ST_PI_CONTENTS) then
      call get_characters_until_not_one_of(fb, XML_WHITESPACE, iostat)
      if (iostat/=0) return
      if (size(fb%namebuffer)==0) then
        !token had better be '?>'
        deallocate(fb%namebuffer)
        fx%token => vs_str_alloc(get_characters(fb, 2, iostat))
        if (iostat/=0) return
        if (str_vs(fx%token)/='?>') then
          call add_error(fx%error_stack, "Unexpected token in PI")
          return
        endif
      else
        ! Otherwise token is all chars after whitespace until '?>'
        deallocate(fb%namebuffer)
        call get_characters_until_all_of(fb, '?>', iostat)
        if (iostat/=0) return
        fx%next_token => vs_str_alloc(get_characters(fb, 2, iostat))
        if (iostat/=0) return
        fx%token => fb%namebuffer
        nullify(fb%namebuffer)
      endif

    elseif (fx%state==ST_BANG_TAG) then
      c = get_characters(fb, 1, iostat)
      if (iostat/=0) return
      if (c=='-') then
        c = get_characters(fb, 1, iostat)
        if (iostat/=0) return
        if (c=='-') then
          fx%token => vs_str_alloc('--')
        else
          call add_error(fx%error_stack, &
            'Unexpected token after <!')
          return
        endif
      elseif (c=='[') then
        fx%token => vs_str_alloc('[')
      elseif (c.in.upperCase) then
        call get_characters_until_not_one_of(fb, upperCase, iostat)
        if (iostat/=0) return
        fx%token => vs_str_alloc(c//str_vs(fb%namebuffer))
        deallocate(fb%namebuffer)
      else
        call add_error(fx%error_stack, &
          'Unexpected token after <!')
        return
      endif

    elseif (fx%state==ST_START_COMMENT) then
      call get_characters_until_all_of(fb, '--', iostat)
      if (iostat/=0) return
      fx%next_token => vs_str_alloc(get_characters(fb, 2, iostat))
      if (iostat/=0) return
      fx%token => fb%namebuffer
      nullify(fb%namebuffer)

    elseif (fx%state==ST_COMMENT_END_2) then
      fx%token => vs_str_alloc(get_characters(fb, 1, iostat))
      if (iostat/=0) return

    elseif (fx%state==ST_CDATA_CONTENTS) then
      call get_characters_until_all_of(fb, ']]>', iostat)
      if (iostat/=0) return
      fx%next_token => vs_str_alloc(get_characters(fb, 3, iostat))
      if (iostat/=0) return
      fx%token => fb%namebuffer
      nullify(fb%namebuffer)

    elseif (fx%state==ST_CHAR_IN_CONTENT) then
      call get_characters_until_one_of(fb, '<&', iostat)
      fx%token => fb%namebuffer
      nullify(fb%namebuffer)
      if (iostat/=0) return

    elseif (fx%state==ST_DTD_ELEMENT_CONTENTS) then
      c = get_characters(fb, 1, iostat)
      if (iostat/=0) return
      if (c.in.XML_WHITESPACE) then
        call get_characters_until_all_of(fb, '>', iostat)
        if (iostat/=0) return
        fx%next_token => vs_str_alloc(get_characters(fb, 1, iostat))
        if (iostat/=0) return
        fx%token => fb%namebuffer
        nullify(fb%namebuffer)
      else
        call add_error(fx%error_stack, &
          'Missing whitespace in element declaration')
      endif

    elseif (fx%state==ST_DTD_ATTLIST_CONTENTS) then
      c = get_characters(fb, 1, iostat)
      if (iostat/=0) return
      if (c.in.XML_WHITESPACE) then
        call get_characters_until_all_of(fb, '>', iostat)
        if (iostat/=0) return
        fx%next_token => vs_str_alloc(get_characters(fb, 1, iostat))
        if (iostat/=0) return
        fx%token => fb%namebuffer
        nullify(fb%namebuffer)
      elseif (c==">") then
        fx%token => vs_str_alloc(">")
      else
        call add_error(fx%error_stack, &
          'Missing whitespace in attlist declaration')
      endif

    elseif (fx%state==ST_IN_TAG) then
      call get_characters_until_not_one_of(fb, XML_WHITESPACE, iostat)
      if (iostat/=0) return
      if (size(fb%namebuffer)==0) then
        deallocate(fb%namebuffer) ! which only contains whitespace now.
        ! This had better be the end of the tag.
        c = get_characters(fb, 1, iostat)
        if (iostat/=0) return
        if (c=='>') then
          fx%token => vs_str_alloc('>')
        elseif (c=='/') then
          c = get_characters(fb, 1, iostat)
          if (iostat/=0) return
          if (c=='>') then
            fx%token => vs_str_alloc('/>')
          endif
        else
          call add_error(fx%error_stack, "Unexpected character in tag.")
        endif
      else
        deallocate(fb%namebuffer) ! which only contains whitespace now.
        c = get_characters(fb, 1, iostat)
        if (iostat/=0) return
        if (c=='>') then
          fx%token => vs_str_alloc('>')
        elseif (c=='/') then
          c = get_characters(fb, 1, iostat)
          if (iostat/=0) return
          if (c=='>') then
            fx%token => vs_str_alloc('/>')
          endif
        elseif (isInitialNameChar(c, fx%xds%xml_version)) then 
          if (fx%xds%xml_version==XML1_0) then
            call get_characters_until_condition(fb, isXML1_0_NameChar, .false., iostat)
          elseif (fx%xds%xml_version==XML1_1) then
            call get_characters_until_condition(fb, isXML1_1_NameChar, .false., iostat)
          endif
          fx%token => vs_str_alloc(c//str_vs(fb%namebuffer))
          deallocate(fb%namebuffer)
        else
          call add_error(fx%error_stack, "Unexpected character in tag.")
        endif
      endif

    elseif (fx%state==ST_ATT_EQUALS) then
      call get_characters_until_not_one_of(fb, XML_WHITESPACE, iostat)
      if (iostat/=0) return
      c = get_characters(fb, 1, iostat)
      if (iostat/=0) return
      if (c/='"'.and.c/="'") then
        call add_error(fx%error_stack, "Expecting "" or '")
        return
      endif
      call get_characters_until_all_of(fb, c, iostat)
      if (iostat/=0) return
      fx%token => normalize_text(fx, fb%namebuffer)
      ! Next character is either quotechar or eof.
      c = get_characters(fb, 1, iostat)
      ! Either way, we return

    elseif (fx%context==CTXT_IN_DTD) then
      if (fx%whitespace==WS_FORBIDDEN) then
        ! This MUST be the end of a comment
        c = get_characters(fb, 1, iostat)
        if (iostat/=0) return
        fx%token => vs_str_alloc(c)
        ! it will either be a <!DIRECTIVE or a <?PINAME
        !call get_characters_until_one_of(fb, XML_WHITESPACE, iostat)
        !if (iostat/=0) return
        !fx%token => fb%namebuffer
        !nullify(fb%namebuffer)

      elseif (fx%whitespace==WS_MANDATORY) then
        !We are still allowed a '>' without space, ... check first.
        call get_characters_until_not_one_of(fb, XML_WHITESPACE, iostat)
        if (iostat/=0) return
        if (size(fb%namebuffer)==0) then
          c = get_characters(fb, 1, iostat)
          if (iostat/=0) return
          if (c=='>') then
            fx%token => vs_str_alloc(c)
          else
            call add_error(fx%error_stack, "Required whitespace omitted in DTD")
          endif
          return
        endif
        c = get_characters(fb, 1, iostat)
        if (iostat/=0) return
        ! do some stuff
        if (c.in."%>[]") then
          fx%token => vs_str_alloc(c)
        elseif (c=='<') then
          !it's a comment or a PI ... or a DTD keyword.
          c = get_characters(fb, 1, iostat)
          if (iostat/=0) return
          if (c=='?') then
            fx%token => vs_str_alloc('<?')
          elseif (c=='!') then
            fx%token => vs_str_alloc('<!')
          endif
        elseif (c=='"'.or.c=="'") then ! grab until next quote
          call get_characters_until_all_of(fb, c, iostat)
          if (iostat/=0) return
          c = get_characters(fb, 1, iostat)
          if (iostat/=0) return
          fx%token => vs_str_alloc(c//str_vs(fb%namebuffer)//c)
          deallocate(fb%namebuffer)
        else !it must be a NAME for some reason
          call put_characters(fb, 1)
          if (fx%xds%xml_version==XML1_0) then
            call get_characters_until_condition(fb, isXML1_0_NameChar, .false., iostat)
          elseif (fx%xds%xml_version==XML1_1) then
            call get_characters_until_condition(fb, isXML1_1_NameChar, .false., iostat)
          endif
          fx%token => fb%namebuffer
          nullify(fb%namebuffer)
        endif

      elseif (fx%whitespace==WS_DISCARD) then
        call get_characters_until_not_one_of(fb, XML_WHITESPACE, iostat)
        if (iostat/=0) return
        c = get_characters(fb, 1, iostat)
        if (iostat/=0) return
        if (c.in.">[]") then
          fx%token => vs_str_alloc(c)
        elseif (c=='<') then
          !it's a comment or a PI ... or a DTD keyword.
          c = get_characters(fb, 1, iostat)
          if (iostat/=0) return
          if (c=='?') then
            fx%token => vs_str_alloc('<?')
          elseif (c=='!') then
            fx%token => vs_str_alloc('<!')
          else
            call add_error(fx%error_stack, &
              "Invalid token found in DTD")
            return
          endif
        elseif (c=='%') then
          !It ought to be a parameter entity reference
          if (fx%xds%xml_version==XML1_0) then
            call get_characters_until_condition(fb, isXML1_0_NameChar, .false., iostat)
          elseif (fx%xds%xml_version==XML1_1) then
            call get_characters_until_condition(fb, isXML1_1_NameChar, .false., iostat)
          endif
          c = get_characters(fb, 1, iostat)
          if (iostat/=0) return
          if (c/=';') then
            call add_error(fx%error_stack, "Illegal parameter entity reference.")
            return
          endif
          fx%token => vs_str_alloc('%'//str_vs(fb%namebuffer)//';')
        else
          call add_error(fx%error_stack, &
            "Invalid token found in DTD")
          return
        endif
      endif
      return


    else

      if (fx%whitespace==WS_DISCARD) then
        call get_characters_until_not_one_of(fb, XML_WHITESPACE, iostat)
        if (iostat/=0) return

      elseif (fx%whitespace==WS_MANDATORY) then
        call get_characters_until_not_one_of(fb, XML_WHITESPACE, iostat)
        if (size(fb%namebuffer)==0) then
          call add_error(fx%error_stack, 'Tokenizer expected whitespace')
          return
        endif
      endif

      c = get_characters(fb, 1, iostat)
      if (iostat/=0) return

      if (c.in.'>=[') then
        !No further investigation needed, that's the token
        fx%token => vs_str_alloc(c)

      elseif (isInitialNameChar(c, fx%xds%xml_version)) then
        if (fx%xds%xml_version==XML1_0) then
          call get_characters_until_condition(fb, isXML1_0_NameChar, .false., iostat)
        elseif (fx%xds%xml_version==XML1_1) then
          call get_characters_until_condition(fb, isXML1_1_NameChar, .false., iostat)
        endif
        if (iostat/=0) return
        fx%token => vs_str_alloc(c//str_vs(fb%namebuffer))
        deallocate(fb%namebuffer)

      else
        select case(c)

        case ('<')
          c = get_characters(fb, 1, iostat)
          if (iostat/=0) return
          if (c=='?') then
            fx%token => vs_str_alloc('<?')
          elseif (c=='!') then
            fx%token => vs_str_alloc('<!')
          elseif (c=='/') then
            fx%token => vs_str_alloc('</')
          elseif (isInitialNameChar(c, fx%xds%xml_version)) then
            call put_characters(fb, 1)
            fx%token => vs_str_alloc('<')
          else
            call add_error(fx%error_stack,"Unexpected character found.")
          endif

        case ('/')
          c = get_characters(fb, 1, iostat)
          if (iostat/=0) return
          if (c=='>') then
            fx%token => vs_str_alloc('/>')
          else
            call add_error(fx%error_stack, "Unexpected character after /")
          endif

        case ('&')
          c = get_characters(fb, 1, iostat)
          if (iostat/=0) return
          if (c=='#') then
            c = get_characters(fb, 1, iostat)
            if (iostat/=0) return
            if (c=='x') then
              call get_characters_until_not_one_of(fb, hexdigits, iostat)
              if (size(fb%namebuffer)==0) then
                call add_error(fx%error_stack, 'Illegal character entity reference')
                return
              endif
              if (iostat/=0) return
              c2 = get_characters(fb, 1, iostat)
              if (iostat/=0) return
              if (c2/=';') then
                call add_error(fx%error_stack, &
                  'Illegal character entity reference')
                return
              endif
              fx%token => vs_str_alloc('&#x'//str_vs(fb%namebuffer)//';')
              deallocate(fb%namebuffer)
            elseif (c.in.digits) then
              call get_characters_until_not_one_of(fb, digits, iostat)
              if (iostat/=0) return
              c2 = get_characters(fb, 1, iostat)
              if (iostat/=0) return
              if (c2/=';') then
                call add_error(fx%error_stack, 'Illegal character entity reference')
                return
              endif
              fx%token => vs_str_alloc('&#'//c//str_vs(fb%namebuffer)//';')
              deallocate(fb%namebuffer)
            else
              call add_error(fx%error_stack, 'Illegal character entity reference')
            endif
          elseif (isInitialNameChar(c, fx%xds%xml_version)) then
            if (fx%xds%xml_version==XML1_0) then
              call get_characters_until_condition(fb, isXML1_0_NameChar, .false., iostat)
            elseif (fx%xds%xml_version==XML1_1) then
              call get_characters_until_condition(fb, isXML1_1_NameChar, .false., iostat)
            endif
            if (iostat/=0) return
            c2 = get_characters(fb, 1, iostat)
            if (iostat/=0) return
            if (c2/=';') then
              call add_error(fx%error_stack, "Illegal general entity reference")
              return
            endif
            fx%token => vs_str_alloc('&'//c//str_vs(fb%namebuffer)//';')
            deallocate(fb%namebuffer)
          else
            call add_error(fx%error_stack, &
              'Illegal general entity reference')
            return
          endif

        case ('"')
          if (fx%context==CTXT_IN_CONTENT) then !.an.d some other condition) then
            call get_characters_until_one_of(fb, '"', iostat)
            if (iostat/=0) return
            deallocate(fb%namebuffer)
            fx%token => vs_str_alloc('"'//str_vs(fb%namebuffer)//'"')
          else
            ! make an error
          endif

        case ("'")
          if (fx%context==CTXT_IN_CONTENT) then! .and. some other condition) then
            call get_characters_until_one_of(fb, "'", iostat)
            if (iostat/=0) return
            deallocate(fb%namebuffer)
            fx%token = vs_str_alloc("'"//str_vs(fb%namebuffer)//"'")

          else

            call add_error(fx%error_stack, "Unrecognized token.")
            return
          endif

        case default 
          ! return c as token anyway - probably meaningless though
          fx%token => vs_str_alloc(c)

        end select

      end if ! more than one-char token
    endif

  end subroutine sax_tokenize


  subroutine parse_xml_declaration(fx, fb, iostat)
    type(sax_parser_t), intent(inout) :: fx
    type(file_buffer_t), intent(inout) :: fb
    integer, intent(out) :: iostat
    ! Need to do this with read_* fns, not get_*
    ! FIXME below all read_chars should be error-checked.
    integer :: i
    character(len=*), parameter :: version="version", encoding="encoding", standalone="standalone"
    character :: c
    character(len=5) :: xml = "<?xml"
    character, allocatable :: ch(:)
    ! default values ...
    fx%xds%xml_version = XML1_0
    allocate(fx%encoding(5))
    fx%encoding = vs_str("UTF-8")
    fx%xds%standalone = .false.
    do i = 1, 5
      c = read_char(fb, iostat); if (iostat/=0) return
      if (c/=xml(i:i)) then
        call rewind_file(fb)
        return
      endif
    enddo
    c = read_char(fb, iostat); if (iostat/=0) return
    if (.not.(c.in.XML_WHITESPACE)) then
      call rewind_file(fb)
      return
    endif
    do while (c.in.XML_WHITESPACE)
      c = read_char(fb, iostat); if (iostat/=0) return
    enddo
    call push_chars(fb, c)
    allocate(ch(7))
    ch = vs_str(read_chars(fb, 7, iostat)); if (iostat/=0) return
    if (str_vs(ch)/="version") then
      deallocate(ch)
      call add_error(fx%error_stack, "Expecting XML version"); return
    endif
    deallocate(ch)
    call check_version
    if (iostat/=0) return
    c = read_char(fb, iostat); if (iostat/=0) return
    if (.not.(c.in.XML_WHITESPACE).and.c/='?') then
      call add_error(fx%error_stack, "Missing whitespace in XML declaration");return
    endif
    do while (c.in.XML_WHITESPACE)
      c = read_char(fb, iostat); if (iostat/=0) return
    enddo
    if (c=='?') then
      c = read_char(fb, iostat); if (iostat/=0) return
      ! FIXME read_char io_eor handling
      if (c/='>') then
        call add_error(fx%error_stack, "Expecting > to end XML declaration"); return
      endif
      return
    endif
    call push_chars(fb, c)
    allocate(ch(8))
    ch = vs_str(read_chars(fb, 8, iostat)); if (iostat/=0) return
    if (str_vs(ch)/="encoding") then
      call push_chars(fb, str_vs(ch))
      deallocate(ch)
      allocate(ch(10))
      ch = vs_str(read_chars(fb, 10, iostat)); if (iostat/=0) return
      if (str_vs(ch)/="standalone") then
        deallocate(ch)
        call add_error(fx%error_stack, "Expecting XML encoding or standalone declaration"); return
      endif
      deallocate(ch)
      call check_standalone
      if (iostat/=0) return
    else
      deallocate(ch)
      call check_encoding
      if (iostat/=0) return
      c = read_char(fb, iostat); if (iostat/=0) return
      if (.not.(c.in.XML_WHITESPACE).and.c/='?') then
        call add_error(fx%error_stack, "Missing whitespace in XML declaration");return
      endif
      do while (c.in.XML_WHITESPACE)
        c = read_char(fb, iostat); if (iostat/=0) return
      enddo
      if (c=='?') then
        c = read_char(fb, iostat); if (iostat/=0) return
        ! FIXME read_char io_eor handling
        if (c/='>') then
          call add_error(fx%error_stack, "Expecting > to end XML declaration"); return
        endif
        return
      endif
      call push_chars(fb, c)
      allocate(ch(10))
      ch = vs_str(read_chars(fb, 10, iostat)); if (iostat/=0) return
      if (str_vs(ch)/="standalone") then
        deallocate(ch)
        call add_error(fx%error_stack, "Expecting XML encoding or standalone declaration"); return
      endif
      deallocate(ch)
      call check_standalone
      if (iostat/=0) return
    endif
    c = read_char(fb, iostat); if (iostat/=0) return
    if (.not.(c.in.XML_WHITESPACE).and.c/='?') then
      call add_error(fx%error_stack, "Missing whitespace in XML declaration");return
    endif
    do while (c.in.XML_WHITESPACE)
      c = read_char(fb, iostat); if (iostat/=0) return
    enddo
    if (c=='?') then
      c = read_char(fb, iostat); if (iostat/=0) return
      ! FIXME read_char io_eor handling
      if (c/='>') then
        call add_error(fx%error_stack, "Expecting > to end XML declaration"); return
      endif
    endif

    if (str_vs(fx%encoding)/="UTF-8") then
      call add_error(fx%error_stack, "Unknown character encoding in XML declaration", ERR_WARNING)
    endif

  contains

    subroutine check_version
      character :: c, quotechar
      c = read_char(fb, iostat); if (iostat/=0) return
      do while (c.in.XML_WHITESPACE)
        c = read_char(fb, iostat); if (iostat/=0) return
      enddo
      if (c/="=") then
        call add_error(fx%error_stack, "Expecting ="); return
      endif
      c = read_char(fb, iostat); if (iostat/=0) return
      do while (c.in.XML_WHITESPACE)
        c = read_char(fb, iostat); if (iostat/=0) return
      enddo
      if (c/="'".and.c/='"') then
        call add_error(fx%error_stack, "Expecting "" or '"); return
      endif
      quotechar = c
      c = read_char(fb, iostat); if (iostat/=0) return
      if (c/="1") then
        call add_error(fx%error_stack, "Unknown XML version"); return
      endif
      c = read_char(fb, iostat); if (iostat/=0) return
      if (c/=".") then
        call add_error(fx%error_stack, "Unknown XML version"); return
      endif
      c = read_char(fb, iostat); if (iostat/=0) return
      if (c/="1".and.c/="0") then
        call add_error(fx%error_stack, "Unknown XML version"); return
      endif
      if (c=="1") then
        fx%xds%xml_version = XML1_1
      endif
      c = read_char(fb, iostat); if (iostat/=0) return
      if (c/=quotechar) then
        call add_error(fx%error_stack, "Expecting "//quotechar); return
      endif
    end subroutine check_version

    subroutine check_encoding
      character :: c, quotechar
      character, dimension(:), pointer :: buf, tempbuf
      integer :: i
      c = read_char(fb, iostat); if (iostat/=0) return
      do while (c.in.XML_WHITESPACE)
        c = read_char(fb, iostat); if (iostat/=0) return
      enddo
      if (c/="=") then
        call add_error(fx%error_stack, "Expecting ="); return
      endif
      c = read_char(fb, iostat); if (iostat/=0) return
      do while (c.in.XML_WHITESPACE)
        c = read_char(fb, iostat); if (iostat/=0) return
      enddo
      if (c/="'".and.c/='"') then
        call add_error(fx%error_stack, "Expecting "" or '"); return
      endif
      quotechar = c
      c = read_char(fb, iostat); if (iostat/=0) return
      if (.not.(c.in.XML_INITIALENCODINGCHARS)) then
        call add_error(fx%error_stack, "Illegal character at start of encoding declaration."); return
      endif
      i = 1
      buf => vs_str_alloc(c)
      c = read_char(fb, iostat)
      if (iostat/=0) then
        deallocate(buf)
        return
      endif
      do while (c.in.XML_ENCODINGCHARS)
        tempbuf => buf
        i = i+1
        allocate(buf(i))
        buf(:i-1) = tempbuf
        deallocate(tempbuf)
        buf(i) = c
        c = read_char(fb, iostat)
        if (iostat/=0) then
          deallocate(buf)
          return
        endif
      enddo
      if (c/=quotechar) then
        call add_error(fx%error_stack, "Illegal character in XML encoding declaration; expecting "//quotechar); 
        deallocate(buf)
        return
      endif
      deallocate(fx%encoding)
      fx%encoding => buf
    end subroutine check_encoding

    subroutine check_standalone
      character :: c, quotechar
      c = read_char(fb, iostat); if (iostat/=0) return
      do while (c.in.XML_WHITESPACE)
        c = read_char(fb, iostat); if (iostat/=0) return
      enddo
      if (c/="=") then
        call add_error(fx%error_stack, "Expecting ="); return
      endif
      c = read_char(fb, iostat); if (iostat/=0) return
      do while (c.in.XML_WHITESPACE)
        c = read_char(fb, iostat); if (iostat/=0) return
      enddo
      if (c/="'".and.c/='"') then
        call add_error(fx%error_stack, "Expecting "" or '"); return
      endif
      quotechar = c
      c = read_char(fb, iostat); if (iostat/=0) return
      if (c=="y") then
        c = read_char(fb, iostat); if (iostat/=0) return
        if (c=="e") then
          c = read_char(fb, iostat); if (iostat/=0) return
          if (c=="s") then
            fx%xds%standalone = .true.
          else
            call add_error(fx%error_stack, "standalone accepts only 'yes' or 'no'"); return
          endif
        else
          call add_error(fx%error_stack, "standalone accepts only 'yes' or 'no'"); return
        endif
      elseif (c=="n") then
        c = read_char(fb, iostat); if (iostat/=0) return
        if (c=="o") then
          fx%xds%standalone = .false.
        else
          call add_error(fx%error_stack, "standalone accepts only 'yes' or 'no'"); return
        endif
      else
        call add_error(fx%error_stack, "standalone accepts only 'yes' or 'no'"); return
      endif
      c = read_char(fb, iostat); if (iostat/=0) return
      if (c/=quotechar) then
        call add_error(fx%error_stack, "Expecting "" or '"); return
      endif
    end subroutine check_standalone

  end subroutine parse_xml_declaration


  recursive function normalize_text(fx, s_in) result(s_out)
    type(sax_parser_t), intent(inout) :: fx
    character, dimension(:), intent(in) :: s_in
    character, dimension(:), pointer :: s_out

    character, dimension(:), pointer :: s_temp, s_temp2, s_ent, tempString
    integer :: i, i2, j

    ! Condense all whitespace, only if we are validating,
    ! Expand all &
    ! Complain about < and &

    allocate(s_temp(size(s_in))) ! in the first instance
    allocate(s_out(0)) ! in case we return early ...
    s_ent => null()
    tempString => null()

    i2 = 1
    i = 1
    do 
      if (i > size(s_in)) exit
      ! Firstly, all whitespace must become 0x20
      if (s_in(i).in.XML_WHITESPACE) then
        s_temp(i2) = " "
        ! Then, < is always illegal
        i = i + 1
        i2 = i2 + 1
      elseif (s_in(i)=='<') then
        call add_error(fx%error_stack, "Illegal < found in attribute.")
        goto 100
        ! Then, expand <
      elseif (s_in(i)=='&') then
        j = index(str_vs(s_in(i+1:)), ';')
        if (j==0) then
          call add_error(fx%error_stack, "Illegal & found in attribute")
          goto 100
        elseif (j==1) then
          call add_error(fx%error_stack, "No entity reference found")
          goto 100
        endif
        allocate(tempString(j-1))
        tempString = s_in(i+1:i+j-1)
        if (existing_entity(fx%predefined_e_list, str_vs(tempString))) then
            ! Expand immediately
          s_temp(i2) = expand_entity_text(fx%predefined_e_list, str_vs(tempString))
          i = i + j + 1
          i2 = i2 + 1
        elseif (checkCharacterEntityReference(str_vs(tempString), fx%xds%xml_version)) then
          ! Expand all character entities
          s_temp(i2) = expand_char_entity(str_vs(tempString)) ! FIXME ascii
          i = i + j  + 1
          i2 = i2 + 1 ! fixme
        elseif (checkName(str_vs(tempString), fx%xds)) then
          if (existing_entity(fx%forbidden_ge_list, str_vs(tempString))) then
            call add_error(fx%error_stack, 'Recursive entity expansion')
            goto 100
          elseif (existing_entity(fx%xds%entityList, str_vs(tempString))) then
            !is it the right sort of entity?
            if (is_unparsed_entity(fx%xds%entityList, str_vs(tempString))) then
              call add_error(fx%error_stack, "Unparsed entity forbidden in attribute")
              goto 100
            elseif (is_external_entity(fx%xds%entityList, str_vs(tempString))) then
              call add_error(fx%error_stack, "External entity forbidden in attribute")
              goto 100
            endif
            call add_internal_entity(fx%forbidden_ge_list, str_vs(tempString), "")
            ! Recursively expand entity, checking for errors.
            s_ent => normalize_text(fx, vs_str(expand_entity_text(fx%xds%entityList, str_vs(tempString))))
            call devnull(pop_entity_list(fx%forbidden_ge_list))
            if (in_error(fx%error_stack)) then
              goto 100
            endif
            allocate(s_temp2(size(s_temp)+size(s_ent)-j))
            s_temp2(:i2-1) = s_temp(:i2-1)
            s_temp2(i2:i2+size(s_ent)-1) = s_ent
            deallocate(s_temp)
            s_temp => s_temp2
            nullify(s_temp2)
            i = i + j + 1
            i2 = i2 + size(s_ent)
            deallocate(s_ent)
          else
            s_temp(i2:i2+j) = s_in(i:i+j)
            i = i + j + 1
            i2 = i2 + j + 1
            if (.not.fx%skippedExternal.or.fx%xds%standalone) then
              call add_error(fx%error_stack, "Undeclared entity encountered in standalone document.")
              goto 100
            endif
          endif
        else
          call add_error(fx%error_stack, "Illegal entity reference")
          goto 100
        endif
        deallocate(tempString)
      else
        s_temp(i2) = s_in(i)
        i = i + 1
        i2 = i2 + 1
      endif
    enddo
    
    deallocate(s_out)
    allocate(s_out(i2-1))
    s_out = s_temp(:i2-1)
100 deallocate(s_temp)
    if (associated(s_ent))  deallocate(s_ent)
    if (associated(tempString)) deallocate(tempString)

  end function normalize_text
    
end module m_sax_tokenizer

module FoX_wxml

  use m_wxml_core
  use m_wxml_overloads

  implicit none
  private

  public :: xmlf_t
  public :: xml_OpenFile
  public :: xml_Close
  public :: xml_NewElement
  public :: xml_EndElement
  public :: xml_AddXMLDeclaration
  public :: xml_AddXMLStylesheet
  public :: xml_AddXMLPI
  public :: xml_AddComment
  public :: xml_AddEntityReference

  public :: xml_AddCharacters
  public :: xml_AddNewline
  public :: xml_AddAttribute
  public :: xml_AddPseudoAttribute

  public :: xml_DeclareNamespace
  public :: xml_UndeclareNamespace

  public :: xml_AddDOCTYPE
  public :: xml_AddParameterEntity
  public :: xml_AddInternalEntity
  public :: xml_AddExternalEntity
  public :: xml_AddNotation
  public :: xml_AddElementToDTD
  public :: xml_AddAttlistToDTD
  public :: xml_AddPEreferenceToDTD

  public :: xmlf_Name
  public :: xmlf_OpenTag

end module FoX_wxml

module m_handlers

  use FoX_common
  use FoX_sax

  implicit none
  private

  ! A prototype of a specific language processor.

  ! It defines the routines that are called from xml_parser in response
  ! to particular events.

  ! In this particular example we just print the names of the elements
  ! and the content of the pcdata chunks, as well as any comments, XML
  ! and SGML declarations, etc.

  ! A module such as this could use "utility routines" to convert pcdata
  ! to numerical arrays, and to populate specific data structures.
  
  public :: start_document_handler, end_document_handler
  public :: begin_element_handler, end_element_handler
  public :: characters_handler
  public :: comment_handler, processing_instruction_handler
  public :: start_prefix_handler, end_prefix_handler

contains  !=============================================================

  subroutine start_document_handler()
    print*,'Document begun!!'
  end subroutine start_document_handler

  subroutine end_document_handler()
    print*,'Document finished!!'
  end subroutine end_document_handler

  subroutine begin_element_handler(URI, localname, name,attributes)
    character(len=*), intent(in)   :: URI
    character(len=*), intent(in)   :: localname
    character(len=*), intent(in)   :: name
    type(dictionary_t), intent(in) :: attributes

    write(unit=*,fmt="(4a)") ">>Begin Element: {", URI, "}", localname
    write(unit=*,fmt="(a,i2,a)") "--- ", len(attributes), " attributes:"
    call print_dict(attributes)
  end subroutine begin_element_handler

  !--------------------------------------------------
  subroutine end_element_handler(URI, localname, name)
    character(len=*), intent(in)     :: URI
    character(len=*), intent(in)     :: localname
    character(len=*), intent(in)     :: name

    write(unit=*,fmt="(4a)") ">>End Element: {", URI, "}", localname

  end subroutine end_element_handler

  !--------------------------------------------------
  subroutine characters_handler(chunk)
    character(len=*), intent(in) :: chunk

    write(*,'(a)') "PCDATA:"
    write(unit=*,fmt="(a)",advance="no") chunk

  end subroutine characters_handler

  !--------------------------------------------------
  subroutine comment_handler(comment)
    character(len=*), intent(in) :: comment

    write(unit=*,fmt="(a)") ">>Comment: "
    write(unit=*,fmt="(a)") comment

  end subroutine comment_handler


  subroutine processing_instruction_handler(name, content, attributes)
    character(len=*), intent(in)   :: name
    character(len=*), intent(in)   :: content
    type(dictionary_t), intent(in) :: attributes

    write(unit=*,fmt="(2a)") ">>Processing Instruction: ", name
    write(unit=*, fmt="(a)") content
    call print_dict(attributes)

  end subroutine processing_instruction_handler


  subroutine start_prefix_handler(URI, prefix)
    character(len=*), intent(in) :: URI
    character(len=*), intent(in) :: prefix

    write(unit=*,fmt='(a)') "START NAMESPACE MAPPING"
    write(unit=*,fmt='(2a)') "PREFIX:", prefix
    write(unit=*,fmt='(2a)') "URI:", uri

  end subroutine start_prefix_handler


  subroutine end_prefix_handler(prefix)
    character(len=*), intent(in) :: prefix

    write(unit=*,fmt='(a)') "END NAMESPACE MAPPING"
    write(unit=*,fmt='(2a)') "PREFIX:", prefix

  end subroutine end_prefix_handler

end module m_handlers

program test

  use FoX_wcml, only : xmlf_t, cmlBeginFile, cmlFinishFile, cmlStartCml, cmlEndCml
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  call cmlBeginFile(xf, filename, unit=-1)
  call cmlEndCml(xf)
  call cmlFinishFile(xf)

end program test

program test_sax_reader

  use m_sax_reader

  character(15) :: buf
  type(file_buffer_t) :: fb

  integer :: iostat

  call open_file(fb, file="test_sax_reader_10.in", iostat=iostat)

  buf = get_characters(fb, 15, iostat) 

  call dump_string(buf)
  write(*,'(a,i0)') 'iost:', iostat

  call put_characters(fb, 7)

  buf = get_characters(fb, 15, iostat) 

  call dump_string(buf)
  write(*,'(a,i0)') 'iost:', iostat

  call close_file(fb) 

end program test_sax_reader

program test

  use m_common_charset, only : XML1_0, XML1_1
  use m_common_struct, only : xml_doc_state
  use m_common_namecheck, only : checkPublicID
  implicit none

  type(xml_doc_state) :: xds

  write(*,'(l1)') checkPublicID('abcd')
  write(*,'(l1)') checkPublicID('1abcd /()+,/=?;!*#@$%')
  write(*,'(l1)') checkPublicID('1abcd /()+,/=?;!*#@$%'//achar(13))
  write(*,'(l1)') checkPublicID('1abcd /()+,/=?;!*#@$%&')

end program test

 
! This file is AUTOGENERATED!!!!
! Do not edit this file; edit m_wxml_overloads.m4 and regenerate.
!
!
module m_wxml_overloads

  use m_common_format, only: str
  use m_common_realtypes, only: sp, dp
  use m_wxml_core, only: xmlf_t
  use m_wxml_core, only: xml_AddCharacters
  use m_wxml_core, only: xml_AddAttribute
  use m_wxml_core, only: xml_AddPseudoAttribute

  implicit none
  private

  interface xml_AddCharacters
    module procedure CharactersScalarCmplxDp
    module procedure CharactersScalarCmplxSp
    module procedure CharactersScalarRealDp
    module procedure CharactersScalarRealSp
    module procedure CharactersScalarInt
    module procedure CharactersScalarLg
    
    module procedure CharactersArrayCmplxDp
    module procedure CharactersArrayCmplxSp
    module procedure CharactersArrayRealDp
    module procedure CharactersArrayRealSp
    module procedure CharactersArrayInt
    module procedure CharactersArrayLg
    module procedure CharactersArrayCh
    module procedure CharactersMatrixCmplxDp
    module procedure CharactersMatrixCmplxSp
    module procedure CharactersMatrixRealDp
    module procedure CharactersMatrixRealSp
    module procedure CharactersMatrixInt
    module procedure CharactersMatrixLg
    module procedure CharactersMatrixCh
 end interface xml_AddCharacters

  interface xml_AddAttribute
    module procedure AttributeScalarCmplxDp
    module procedure AttributeScalarCmplxSp
    module procedure AttributeScalarRealDp
    module procedure AttributeScalarRealSp
    module procedure AttributeScalarInt
    module procedure AttributeScalarLg
    
    module procedure AttributeArrayCmplxDp
    module procedure AttributeArrayCmplxSp
    module procedure AttributeArrayRealDp
    module procedure AttributeArrayRealSp
    module procedure AttributeArrayInt
    module procedure AttributeArrayLg
    module procedure AttributeArrayCh
    module procedure AttributeMatrixCmplxDp
    module procedure AttributeMatrixCmplxSp
    module procedure AttributeMatrixRealDp
    module procedure AttributeMatrixRealSp
    module procedure AttributeMatrixInt
    module procedure AttributeMatrixLg
    module procedure AttributeMatrixCh
 end interface xml_AddAttribute

  interface xml_AddPseudoAttribute
    module procedure PseudoAttributeScalarCmplxDp
    module procedure PseudoAttributeScalarCmplxSp
    module procedure PseudoAttributeScalarRealDp
    module procedure PseudoAttributeScalarRealSp
    module procedure PseudoAttributeScalarInt
    module procedure PseudoAttributeScalarLg
    
    module procedure PseudoAttributeArrayCmplxDp
    module procedure PseudoAttributeArrayCmplxSp
    module procedure PseudoAttributeArrayRealDp
    module procedure PseudoAttributeArrayRealSp
    module procedure PseudoAttributeArrayInt
    module procedure PseudoAttributeArrayLg
    module procedure PseudoAttributeArrayCh
    module procedure PseudoAttributeMatrixCmplxDp
    module procedure PseudoAttributeMatrixCmplxSp
    module procedure PseudoAttributeMatrixRealDp
    module procedure PseudoAttributeMatrixRealSp
    module procedure PseudoAttributeMatrixInt
    module procedure PseudoAttributeMatrixLg
    module procedure PseudoAttributeMatrixCh
 end interface xml_AddPseudoAttribute

  public :: xml_AddCharacters
  public :: xml_AddAttribute
  public :: xml_AddPseudoAttribute

contains

  subroutine CharactersScalarCmplxDp &
    (xf, chars, fmt)

    type(xmlf_t), intent(inout) :: xf
    complex(dp), intent(in)   :: chars
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddCharacters(xf=xf, chars=str(chars, fmt))
    else
      call xml_AddCharacters(xf=xf, chars=str(chars))
    endif

  end subroutine CharactersScalarCmplxDp


  subroutine CharactersScalarCmplxSp &
    (xf, chars, fmt)

    type(xmlf_t), intent(inout) :: xf
    complex(sp), intent(in)   :: chars
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddCharacters(xf=xf, chars=str(chars, fmt))
    else
      call xml_AddCharacters(xf=xf, chars=str(chars))
    endif

  end subroutine CharactersScalarCmplxSp


  subroutine CharactersScalarRealDp &
    (xf, chars, fmt)

    type(xmlf_t), intent(inout) :: xf
    real(dp), intent(in)   :: chars
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddCharacters(xf=xf, chars=str(chars, fmt))
    else
      call xml_AddCharacters(xf=xf, chars=str(chars))
    endif

  end subroutine CharactersScalarRealDp


  subroutine CharactersScalarRealSp &
    (xf, chars, fmt)

    type(xmlf_t), intent(inout) :: xf
    real(sp), intent(in)   :: chars
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddCharacters(xf=xf, chars=str(chars, fmt))
    else
      call xml_AddCharacters(xf=xf, chars=str(chars))
    endif

  end subroutine CharactersScalarRealSp


  subroutine CharactersScalarInt &
    (xf, chars)

    type(xmlf_t), intent(inout) :: xf
    integer, intent(in)   :: chars

    call xml_AddCharacters(xf=xf, chars=str(chars))

  end subroutine CharactersScalarInt


  subroutine CharactersScalarLg &
    (xf, chars)

    type(xmlf_t), intent(inout) :: xf
    logical, intent(in)   :: chars

    call xml_AddCharacters(xf=xf, chars=str(chars))

  end subroutine CharactersScalarLg




  subroutine CharactersArrayCmplxDp &
    (xf, chars, fmt)

    type(xmlf_t), intent(inout) :: xf
    complex(dp), intent(in) , dimension(:)  :: chars
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddCharacters(xf=xf, chars=str(chars, fmt), ws_significant=.false.)
    else
      call xml_AddCharacters(xf=xf, chars=str(chars), ws_significant=.false.)
    endif

  end subroutine CharactersArrayCmplxDp


  subroutine CharactersArrayCmplxSp &
    (xf, chars, fmt)

    type(xmlf_t), intent(inout) :: xf
    complex(sp), intent(in) , dimension(:)  :: chars
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddCharacters(xf=xf, chars=str(chars, fmt), ws_significant=.false.)
    else
      call xml_AddCharacters(xf=xf, chars=str(chars), ws_significant=.false.)
    endif

  end subroutine CharactersArrayCmplxSp


  subroutine CharactersArrayRealDp &
    (xf, chars, fmt)

    type(xmlf_t), intent(inout) :: xf
    real(dp), intent(in) , dimension(:)  :: chars
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddCharacters(xf=xf, chars=str(chars, fmt), ws_significant=.false.)
    else
      call xml_AddCharacters(xf=xf, chars=str(chars), ws_significant=.false.)
    endif

  end subroutine CharactersArrayRealDp


  subroutine CharactersArrayRealSp &
    (xf, chars, fmt)

    type(xmlf_t), intent(inout) :: xf
    real(sp), intent(in) , dimension(:)  :: chars
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddCharacters(xf=xf, chars=str(chars, fmt), ws_significant=.false.)
    else
      call xml_AddCharacters(xf=xf, chars=str(chars), ws_significant=.false.)
    endif

  end subroutine CharactersArrayRealSp


  subroutine CharactersArrayInt &
    (xf, chars)

    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) , dimension(:)  :: chars

    call xml_AddCharacters(xf=xf, chars=str(chars), ws_significant=.false.)

  end subroutine CharactersArrayInt


  subroutine CharactersArrayLg &
    (xf, chars)

    type(xmlf_t), intent(inout) :: xf
    logical, intent(in) , dimension(:)  :: chars

    call xml_AddCharacters(xf=xf, chars=str(chars), ws_significant=.false.)

  end subroutine CharactersArrayLg


  subroutine CharactersArrayCh &
    (xf, chars, delimiter)

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) , dimension(:)  :: chars
    character(len=1), intent(in), optional :: delimiter

    call xml_AddCharacters(xf=xf, chars=str(chars, delimiter), ws_significant=.false.)

  end subroutine CharactersArrayCh


  subroutine CharactersMatrixCmplxDp &
    (xf, chars, fmt)

    type(xmlf_t), intent(inout) :: xf
    complex(dp), intent(in) , dimension(:,:)  :: chars
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddCharacters(xf=xf, chars=str(chars, fmt), ws_significant=.false.)
    else
      call xml_AddCharacters(xf=xf, chars=str(chars), ws_significant=.false.)
    endif

  end subroutine CharactersMatrixCmplxDp


  subroutine CharactersMatrixCmplxSp &
    (xf, chars, fmt)

    type(xmlf_t), intent(inout) :: xf
    complex(sp), intent(in) , dimension(:,:)  :: chars
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddCharacters(xf=xf, chars=str(chars, fmt), ws_significant=.false.)
    else
      call xml_AddCharacters(xf=xf, chars=str(chars), ws_significant=.false.)
    endif

  end subroutine CharactersMatrixCmplxSp


  subroutine CharactersMatrixRealDp &
    (xf, chars, fmt)

    type(xmlf_t), intent(inout) :: xf
    real(dp), intent(in) , dimension(:,:)  :: chars
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddCharacters(xf=xf, chars=str(chars, fmt), ws_significant=.false.)
    else
      call xml_AddCharacters(xf=xf, chars=str(chars), ws_significant=.false.)
    endif

  end subroutine CharactersMatrixRealDp


  subroutine CharactersMatrixRealSp &
    (xf, chars, fmt)

    type(xmlf_t), intent(inout) :: xf
    real(sp), intent(in) , dimension(:,:)  :: chars
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddCharacters(xf=xf, chars=str(chars, fmt), ws_significant=.false.)
    else
      call xml_AddCharacters(xf=xf, chars=str(chars), ws_significant=.false.)
    endif

  end subroutine CharactersMatrixRealSp


  subroutine CharactersMatrixInt &
    (xf, chars)

    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) , dimension(:,:)  :: chars

    call xml_AddCharacters(xf=xf, chars=str(chars), ws_significant=.false.)

  end subroutine CharactersMatrixInt


  subroutine CharactersMatrixLg &
    (xf, chars)

    type(xmlf_t), intent(inout) :: xf
    logical, intent(in) , dimension(:,:)  :: chars

    call xml_AddCharacters(xf=xf, chars=str(chars), ws_significant=.false.)

  end subroutine CharactersMatrixLg


  subroutine CharactersMatrixCh &
    (xf, chars, delimiter)

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) , dimension(:,:)  :: chars
    character(len=1), intent(in), optional :: delimiter

    call xml_AddCharacters(xf=xf, chars=str(chars, delimiter), ws_significant=.false.)

  end subroutine CharactersMatrixCh



  subroutine AttributeScalarCmplxDp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    complex(dp), intent(in)   :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddAttribute(xf=xf, name=name, value=str(value, fmt))
    else
      call xml_AddAttribute(xf=xf, name=name, value=str(value))
    endif
 
  end subroutine AttributeScalarCmplxDp

  subroutine AttributeScalarCmplxSp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    complex(sp), intent(in)   :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddAttribute(xf=xf, name=name, value=str(value, fmt))
    else
      call xml_AddAttribute(xf=xf, name=name, value=str(value))
    endif
 
  end subroutine AttributeScalarCmplxSp

  subroutine AttributeScalarRealDp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    real(dp), intent(in)   :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddAttribute(xf=xf, name=name, value=str(value, fmt))
    else
      call xml_AddAttribute(xf=xf, name=name, value=str(value))
    endif
 
  end subroutine AttributeScalarRealDp

  subroutine AttributeScalarRealSp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    real(sp), intent(in)   :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddAttribute(xf=xf, name=name, value=str(value, fmt))
    else
      call xml_AddAttribute(xf=xf, name=name, value=str(value))
    endif
 
  end subroutine AttributeScalarRealSp

  subroutine AttributeScalarInt &
    (xf, name, value) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    integer, intent(in)   :: value

    call xml_AddAttribute(xf=xf, name=name, value=str(value))
 
  end subroutine AttributeScalarInt

  subroutine AttributeScalarLg &
    (xf, name, value) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    logical, intent(in)   :: value

    call xml_AddAttribute(xf=xf, name=name, value=str(value))
 
  end subroutine AttributeScalarLg


  subroutine AttributeArrayCmplxDp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    complex(dp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine AttributeArrayCmplxDp

  subroutine AttributeArrayCmplxSp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    complex(sp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine AttributeArrayCmplxSp

  subroutine AttributeArrayRealDp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    real(dp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine AttributeArrayRealDp

  subroutine AttributeArrayRealSp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    real(sp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine AttributeArrayRealSp

  subroutine AttributeArrayInt &
    (xf, name, value) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    integer, intent(in) , dimension(:)  :: value

    call xml_AddAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
 
  end subroutine AttributeArrayInt

  subroutine AttributeArrayLg &
    (xf, name, value) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    logical, intent(in) , dimension(:)  :: value

    call xml_AddAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
 
  end subroutine AttributeArrayLg

  subroutine AttributeArrayCh &
    (xf, name, value, delimiter) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    character(len=*), intent(in) , dimension(:)  :: value
    character(len=1), intent(in), optional :: delimiter

    call xml_AddAttribute(xf=xf, name=name, value=str(value, delimiter), ws_significant=.false.)
 
  end subroutine AttributeArrayCh

  subroutine AttributeMatrixCmplxDp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    complex(dp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine AttributeMatrixCmplxDp

  subroutine AttributeMatrixCmplxSp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    complex(sp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine AttributeMatrixCmplxSp

  subroutine AttributeMatrixRealDp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    real(dp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine AttributeMatrixRealDp

  subroutine AttributeMatrixRealSp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    real(sp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine AttributeMatrixRealSp

  subroutine AttributeMatrixInt &
    (xf, name, value) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    integer, intent(in) , dimension(:,:)  :: value

    call xml_AddAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
 
  end subroutine AttributeMatrixInt

  subroutine AttributeMatrixLg &
    (xf, name, value) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    logical, intent(in) , dimension(:,:)  :: value

    call xml_AddAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
 
  end subroutine AttributeMatrixLg

  subroutine AttributeMatrixCh &
    (xf, name, value, delimiter) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    character(len=*), intent(in) , dimension(:,:)  :: value
    character(len=1), intent(in), optional :: delimiter

    call xml_AddAttribute(xf=xf, name=name, value=str(value, delimiter), ws_significant=.false.)
 
  end subroutine AttributeMatrixCh


  subroutine PseudoAttributeScalarCmplxDp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    complex(dp), intent(in)   :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value, fmt))
    else
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value))
    endif
 
  end subroutine PseudoAttributeScalarCmplxDp

  subroutine PseudoAttributeScalarCmplxSp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    complex(sp), intent(in)   :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value, fmt))
    else
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value))
    endif
 
  end subroutine PseudoAttributeScalarCmplxSp

  subroutine PseudoAttributeScalarRealDp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    real(dp), intent(in)   :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value, fmt))
    else
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value))
    endif
 
  end subroutine PseudoAttributeScalarRealDp

  subroutine PseudoAttributeScalarRealSp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    real(sp), intent(in)   :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value, fmt))
    else
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value))
    endif
 
  end subroutine PseudoAttributeScalarRealSp

  subroutine PseudoAttributeScalarInt &
    (xf, name, value) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    integer, intent(in)   :: value

    call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value))
 
  end subroutine PseudoAttributeScalarInt

  subroutine PseudoAttributeScalarLg &
    (xf, name, value) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    logical, intent(in)   :: value

    call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value))
 
  end subroutine PseudoAttributeScalarLg


  subroutine PseudoAttributeArrayCmplxDp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    complex(dp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine PseudoAttributeArrayCmplxDp

  subroutine PseudoAttributeArrayCmplxSp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    complex(sp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine PseudoAttributeArrayCmplxSp

  subroutine PseudoAttributeArrayRealDp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    real(dp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine PseudoAttributeArrayRealDp

  subroutine PseudoAttributeArrayRealSp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    real(sp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine PseudoAttributeArrayRealSp

  subroutine PseudoAttributeArrayInt &
    (xf, name, value) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    integer, intent(in) , dimension(:)  :: value

    call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
 
  end subroutine PseudoAttributeArrayInt

  subroutine PseudoAttributeArrayLg &
    (xf, name, value) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    logical, intent(in) , dimension(:)  :: value

    call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
 
  end subroutine PseudoAttributeArrayLg

  subroutine PseudoAttributeArrayCh &
    (xf, name, value, delimiter) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    character(len=*), intent(in) , dimension(:)  :: value
    character(len=1), intent(in), optional :: delimiter

    call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value, delimiter), ws_significant=.false.)
 
  end subroutine PseudoAttributeArrayCh

  subroutine PseudoAttributeMatrixCmplxDp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    complex(dp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine PseudoAttributeMatrixCmplxDp

  subroutine PseudoAttributeMatrixCmplxSp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    complex(sp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine PseudoAttributeMatrixCmplxSp

  subroutine PseudoAttributeMatrixRealDp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    real(dp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine PseudoAttributeMatrixRealDp

  subroutine PseudoAttributeMatrixRealSp &
    (xf, name, value, fmt) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    real(sp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: fmt

    if (present(fmt)) then
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value, fmt), ws_significant=.false.)
    else
      call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
    endif
 
  end subroutine PseudoAttributeMatrixRealSp

  subroutine PseudoAttributeMatrixInt &
    (xf, name, value) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    integer, intent(in) , dimension(:,:)  :: value

    call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
 
  end subroutine PseudoAttributeMatrixInt

  subroutine PseudoAttributeMatrixLg &
    (xf, name, value) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    logical, intent(in) , dimension(:,:)  :: value

    call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value), ws_significant=.false.)
 
  end subroutine PseudoAttributeMatrixLg

  subroutine PseudoAttributeMatrixCh &
    (xf, name, value, delimiter) 

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    character(len=*), intent(in) , dimension(:,:)  :: value
    character(len=1), intent(in), optional :: delimiter

    call xml_AddPseudoAttribute(xf=xf, name=name, value=str(value, delimiter), ws_significant=.false.)
 
  end subroutine PseudoAttributeMatrixCh


end module m_wxml_overloads

! public-facing SAX subroutine.

module m_sax_operate

  use m_common_error, only: FoX_error

  use m_sax_reader, only: open_file, close_file
  use m_sax_parser, only: sax_parser_init, sax_parser_destroy, sax_parse
  use m_sax_types, only: xml_t

  implicit none
  private

  public :: xml_t
  public :: open_xml_file
  public :: open_xml_string
  public :: close_xml_t
  public :: parse

contains

  subroutine open_xml_file(xt, file, iostat, lun)
    type(xml_t), intent(out) :: xt
    character(len=*), intent(in) :: file
    integer, intent(out), optional :: iostat
    integer, intent(in), optional :: lun
    integer :: i

    call open_file(xt%fb, file=file, iostat=i, lun=lun)

    if (present(iostat)) then
      iostat = i
    else
      if (i/=0) &
        call FoX_error("Error opening file in open_xml_file")
    endif
    call sax_parser_init(xt%fx, file)

  end subroutine open_xml_file

  subroutine open_xml_string(xt, string)
    type(xml_t), intent(out) :: xt
    character(len=*), intent(in) :: string

    integer :: iostat

    call open_file(xt%fb, string=string, iostat=iostat)
    call sax_parser_init(xt%fx, "")

  end subroutine open_xml_string

  subroutine close_xml_t(xt)
    type(xml_t), intent(inout) :: xt

    call close_file(xt%fb)
    call sax_parser_destroy(xt%fx)
  end subroutine close_xml_t

  subroutine parse(xt,      &
    characters_handler,            &
    endDocument_handler,           &
    endElement_handler,            &
    endPrefixMapping_handler,      &
    ignorableWhitespace_handler,   &
    processingInstruction_handler, &
    ! setDocumentLocator
    skippedEntity_handler,         &
    startDocument_handler,         & 
    startElement_handler,          &
    startPrefixMapping_handler,    &
    notationDecl_handler,          &
    unparsedEntityDecl_handler,    &
    error_handler,                 &
    fatalError_handler,            &
    warning_handler,               &
    attributeDecl_handler,         &
    elementDecl_handler,           &
    externalEntityDecl_handler,    &
    internalEntityDecl_handler,    &
    comment_handler,               &
    endCdata_handler,              &
    endDTD_handler,                &
    endEntity_handler,             &
    startCdata_handler,            &
    startDTD_handler,              &
    startEntity_handler,           &
! Features / properties
    namespaces,                    &
    namespace_prefixes,            &
    validation,                    &
    xmlns_uris)

    type(xml_t), intent(inout) :: xt
    optional :: characters_handler
    optional :: endDocument_handler
    optional :: endElement_handler
    optional :: endPrefixMapping_handler
    optional :: ignorableWhitespace_handler
    optional :: processingInstruction_handler
    optional :: skippedEntity_handler
    optional :: startElement_handler
    optional :: startDocument_handler
    optional :: startPrefixMapping_handler
    optional :: notationDecl_handler
    optional :: unparsedEntityDecl_handler
    optional :: error_handler
    optional :: fatalError_handler
    optional :: warning_handler
    optional :: attributeDecl_handler
    optional :: elementDecl_handler
    optional :: externalEntityDecl_handler
    optional :: internalEntityDecl_handler
    optional :: comment_handler
    optional :: endCdata_handler
    optional :: endEntity_handler
    optional :: endDTD_handler
    optional :: startCdata_handler
    optional :: startDTD_handler
    optional :: startEntity_handler

    logical, intent(in), optional :: namespaces
    logical, intent(in), optional :: namespace_prefixes
    logical, intent(in), optional :: validation
    logical, intent(in), optional :: xmlns_uris

    interface

      subroutine characters_handler(chunk)
        character(len=*), intent(in) :: chunk
      end subroutine characters_handler

      subroutine endDocument_handler()     
      end subroutine endDocument_handler

      subroutine endElement_handler(namespaceURI, localName, name)
        character(len=*), intent(in)     :: namespaceURI
        character(len=*), intent(in)     :: localName
        character(len=*), intent(in)     :: name
      end subroutine endElement_handler
      
      subroutine endPrefixMapping_handler(prefix)
        character(len=*), intent(in) :: prefix
      end subroutine endPrefixMapping_handler

      subroutine ignorableWhitespace_handler(chars)
        character(len=*), intent(in) :: chars
      end subroutine ignorableWhitespace_handler

      subroutine processingInstruction_handler(name, content)
        character(len=*), intent(in)     :: name
        character(len=*), intent(in)     :: content
      end subroutine processingInstruction_handler

      subroutine skippedEntity_handler(name)
        character(len=*), intent(in) :: name
      end subroutine skippedEntity_handler

      subroutine startDocument_handler()   
      end subroutine startDocument_handler

      subroutine startElement_handler(namespaceURI, localName, name, attributes)
        use FoX_common
        character(len=*), intent(in)     :: namespaceUri
        character(len=*), intent(in)     :: localName
        character(len=*), intent(in)     :: name
        type(dictionary_t), intent(in)   :: attributes
      end subroutine startElement_handler

      subroutine startPrefixMapping_handler(namespaceURI, prefix)
        character(len=*), intent(in) :: namespaceURI
        character(len=*), intent(in) :: prefix
      end subroutine startPrefixMapping_handler

      subroutine notationDecl_handler(name, publicId, systemId)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: publicId
        character(len=*), intent(in) :: systemId
      end subroutine notationDecl_handler

      subroutine unparsedEntityDecl_handler(name, publicId, systemId, notation)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: publicId
        character(len=*), intent(in) :: systemId
        character(len=*), intent(in) :: notation
      end subroutine unparsedEntityDecl_handler

      subroutine error_handler(msg)
        character(len=*), intent(in)     :: msg
      end subroutine error_handler

      subroutine fatalError_handler(msg)
        character(len=*), intent(in)     :: msg
      end subroutine fatalError_handler
      
      subroutine warning_handler(msg)
        character(len=*), intent(in)     :: msg
      end subroutine warning_handler

      subroutine attributeDecl_handler(eName, aName, type, mode, value)
        character(len=*), intent(in) :: eName
        character(len=*), intent(in) :: aName
        character(len=*), intent(in) :: type
        character(len=*), intent(in), optional :: mode
        character(len=*), intent(in), optional :: value
      end subroutine attributeDecl_handler

      subroutine elementDecl_handler(name, model)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: model
      end subroutine elementDecl_handler

      subroutine externalEntityDecl_handler(name, publicId, systemId)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: publicId
        character(len=*), intent(in) :: systemId
      end subroutine externalEntityDecl_handler

      subroutine internalEntityDecl_handler(name, value)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: value
      end subroutine internalEntityDecl_handler

      subroutine comment_handler(comment)
        character(len=*), intent(in) :: comment
      end subroutine comment_handler

      subroutine endCdata_handler()
      end subroutine endCdata_handler

      subroutine endDTD_handler()
      end subroutine endDTD_handler

      subroutine endEntity_handler(name)
        character(len=*), intent(in) :: name
      end subroutine endEntity_handler

      subroutine startCdata_handler()
      end subroutine startCdata_handler

      subroutine startDTD_handler(name, publicId, systemId)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: publicId
        character(len=*), intent(in) :: systemId
      end subroutine startDTD_handler

      subroutine startEntity_handler(name)
        character(len=*), intent(in) :: name
      end subroutine startEntity_handler

    end interface

    ! check xt is initialized

    call sax_parse(xt%fx, xt%fb,     &
      characters_handler,            &
      endDocument_handler,           &
      endElement_handler,            &
      endPrefixMapping_handler,      &
      ignorableWhitespace_handler,   &
      processingInstruction_handler, &
      ! setDocumentLocator
      skippedEntity_handler,         &
      startDocument_handler,         & 
      startElement_handler,          &
      startPrefixMapping_handler,    &
      notationDecl_handler,          &
      unparsedEntityDecl_handler,    &
      error_handler,                 &
      fatalError_handler,            &
      warning_handler,               &
      attributeDecl_handler,         &
      elementDecl_handler,           &
      externalEntityDecl_handler,    &
      internalEntityDecl_handler,    &
      comment_handler,               &
      endCdata_handler,              &
      endDTD_handler,                &
      endEntity_handler,             &
      startCdata_handler,            &
      startDTD_handler,              &
      startEntity_handler,           &
      namespaces=namespaces,                 &
      namespace_prefixes=namespace_prefixes, &
      validate=validation,                   &
      xmlns_uris=xmlns_uris)

  end subroutine parse

end module m_sax_operate

module m_common_elstack

  use m_common_array_str, only: str_vs, vs_str
  use m_common_error, only: FoX_fatal
  use pxf, only: pure_pxfabort

  implicit none
  private

  ! Simple stack to keep track of which elements have appeared so far

  ! Initial stack size:
  integer, parameter :: STACK_SIZE_INIT = 10
  ! Multiplier when stack is exceeded:
  real, parameter :: STACK_SIZE_MULT = 1.5

  type :: elstack_item
    character, dimension(:), pointer :: data
  end type elstack_item

  type :: elstack_t
    private
    integer                                   :: n_items
    type(elstack_item), pointer, dimension(:) :: stack
  end type elstack_t

  public :: elstack_t

  public  :: push_elstack, pop_elstack, init_elstack, destroy_elstack, reset_elstack, print_elstack
  public  :: get_top_elstack, is_empty, get_elstack_signature
  public  :: len

  interface len
    module procedure number_of_items
  end interface

  interface is_empty
    module procedure is_empty_elstack
  end interface

contains

  !-----------------------------------------------------------------
  subroutine init_elstack(elstack)
    type(elstack_t), intent(inout)  :: elstack

    ! We go from 0 (and initialize the 0th string to "")
    ! in order that we can safely check the top of an
    ! empty stack
    allocate(elstack%stack(0:STACK_SIZE_INIT))
    elstack%n_items = 0
    allocate(elstack%stack(0)%data(0))

  end subroutine init_elstack

  subroutine destroy_elstack(elstack)
    type(elstack_t), intent(inout)  :: elstack
    integer :: i
    do i = 0, elstack % n_items
      deallocate(elstack%stack(i)%data)
    enddo
    deallocate(elstack%stack)
  end subroutine destroy_elstack

  !-----------------------------------------------------------------
  subroutine reset_elstack(elstack)
    type(elstack_t), intent(inout)  :: elstack

    call destroy_elstack(elstack)
    call init_elstack(elstack)

  end subroutine reset_elstack

  !-----------------------------------------------------------------
  subroutine resize_elstack(elstack)
    type(elstack_t), intent(inout)  :: elstack
    type(elstack_item), dimension(0:ubound(elstack%stack,1)) :: temp
    integer :: i, s

    s = ubound(elstack%stack, 1)

    do i = 0, s
      temp(i)%data => elstack%stack(i)%data
    enddo
    deallocate(elstack%stack)
    allocate(elstack%stack(0:nint(s*STACK_SIZE_MULT)))
    do i = 0, s
      elstack%stack(i)%data => temp(i)%data
    enddo

  end subroutine resize_elstack

  !-----------------------------------------------------------------
  pure function is_empty_elstack(elstack) result(answer)
    type(elstack_t), intent(in)  :: elstack
    logical                    :: answer

    answer = (elstack%n_items == 0)
  end function is_empty_elstack

  !-----------------------------------------------------------------
  function number_of_items(elstack) result(n)
    type(elstack_t), intent(in)  :: elstack
    integer                      :: n

    n = elstack%n_items
  end function number_of_items

  !-----------------------------------------------------------------
  subroutine push_elstack(item,elstack)
    character(len=*), intent(in)      :: item
    type(elstack_t), intent(inout)  :: elstack

    integer :: n

    n = elstack%n_items
    n = n + 1
    if (n == size(elstack%stack)) then
      call resize_elstack(elstack)
    endif
    allocate(elstack%stack(n)%data(len(item)))
    elstack%stack(n)%data = vs_str(item)
    elstack%n_items = n

  end subroutine push_elstack

  !-----------------------------------------------------------------
  function pop_elstack(elstack) result(item)
    type(elstack_t), intent(inout)     :: elstack
    character(len=merge(size(elstack%stack(elstack%n_items)%data), 0, elstack%n_items > 0)) :: item

    integer :: n

    n = elstack%n_items
    if (n == 0) then
      call FoX_fatal("Element stack empty")
    endif
    item = str_vs(elstack%stack(n)%data)
    deallocate(elstack%stack(n)%data)
    elstack%n_items = n - 1

  end function pop_elstack

  !-----------------------------------------------------------------
  pure function get_top_elstack(elstack) result(item)
    !
    ! Get the top element of the stack, *without popping it*.
    !
    type(elstack_t), intent(in)        :: elstack
    character(len=merge(size(elstack%stack(elstack%n_items)%data), 0, elstack%n_items > 0)) :: item 

    integer   :: i, n

    n = elstack%n_items

    if (n == 0) &
      i = pure_pxfabort()

    item = str_vs(elstack%stack(n)%data)

  end function get_top_elstack

  !-----------------------------------------------------------------
  subroutine print_elstack(elstack,unit)
    type(elstack_t), intent(in)   :: elstack
    integer, intent(in)           :: unit
    integer   :: i

    do i = elstack%n_items, 1, -1
      write(unit=unit,fmt=*) elstack%stack(i)%data
    enddo

  end subroutine print_elstack

  !-------------------------------------------------------------
  function get_elstack_signature(elstack) result(string)
    type(elstack_t), intent(in)   :: elstack
    !FIXME TOHW character(len=sum(size(elstack%stack(:elstack%n_items)%data))+elstack%n_items) :: string
    character(len=200) :: string
    integer   :: i, length, j

    j = 0
    do i = 1, elstack%n_items
      length = size(elstack%stack(i)%data)
      string(j+1:j+1) = "/"
      j = j+1
      string(j+1:j+length) = str_vs(elstack%stack(i)%data)
      j = j + length
    enddo

  end function get_elstack_signature

end module m_common_elstack

module m_common_attrs

  use m_common_array_str, only : str_vs, vs_str_alloc
  use m_common_element, only: ATT_CDATA, ATT_ID, ATT_IDREF, &
    ATT_IDREFS, ATT_ENTITY, ATT_ENTITIES, ATT_NMTOKEN, &
    ATT_NMTOKENS, ATT_NOTATION, ATT_ENUM, ATT_CDANO, ATT_CDAMB, &
    ATT_TYPELENGTHS
  use m_common_error, only : FoX_error, FoX_fatal

  implicit none
  private

  !Initial length of dictionary
  integer, parameter :: DICT_INIT_LEN = 10 
  !Multiplier if we need to extend it.
  real, parameter :: DICT_LEN_MULT = 1.5

  type dict_item
    character(len=1), pointer, dimension(:) :: nsURI => null()
    character(len=1), pointer, dimension(:) :: localName => null()
    character(len=1), pointer, dimension(:) :: prefix => null()
    character(len=1), pointer, dimension(:) :: key => null()
    character(len=1), pointer, dimension(:) :: value => null()
    integer :: type = 11
  end type dict_item

  type dictionary_t
    private
    integer                                :: number_of_items ! = 0
    type(dict_item), dimension(:), pointer :: items => null()
  end type dictionary_t

  public :: dictionary_t

  ! Building procedures

  public :: init_dict
  public :: reset_dict
  public :: add_item_to_dict
  public :: destroy_dict

  ! Query and extraction procedures

  ! SAX names:
  public :: getIndex
  public :: getLength
  public :: getLocalName
  public :: getQName
  public :: getURI
  public :: getValue
  public :: getType
  public :: hasKey

  public :: len
  public :: get_key 
  public :: get_value
  public :: remove_key
  public :: has_key
  public :: print_dict

  ! Namespaces
  public :: get_prefix
  public :: get_localName
  public :: set_nsURI
  public :: set_prefix
  public :: set_localName

  ! For internal FoX use only:
  public :: getWhitespaceHandling

  interface len
    module procedure getLength
  end interface

  interface hasKey
    module procedure has_key, has_key_ns
  end interface hasKey

  interface getIndex
    module procedure get_key_index, get_key_index_ns
  end interface

  interface getQName
    module procedure get_key
  end interface

  interface getValue
    module procedure get_value_by_key, get_value_by_index, get_value_by_key_ns
  end interface
  interface get_value
    module procedure get_value_by_key, get_value_by_index
  end interface
  interface remove_key
    module procedure remove_key_by_index
  end interface

  interface getURI
    module procedure get_nsURI_by_index
  end interface
  interface get_prefix
    module procedure get_prefix_by_index
  end interface
  interface getLocalName
    module procedure get_localName_by_index
  end interface
  interface get_localName
    module procedure get_localName_by_index
  end interface
  interface set_nsURI
    module procedure set_nsURI_by_index
  end interface
  interface set_prefix
    module procedure set_prefix_by_index
  end interface
  interface set_localName
    module procedure set_localName_by_index_s
    module procedure set_localName_by_index_vs
  end interface

  interface getType
    module procedure getType_by_index, getType_by_keyname
  end interface

contains

  function getLength(dict) result(n)
    type(dictionary_t), intent(in)   :: dict
    integer                          :: n

    n = dict%number_of_items

  end function getLength


  function has_key(dict,key) result(found)
    type(dictionary_t), intent(in)   :: dict
    character(len=*), intent(in)     :: key
    logical                          :: found

    integer  ::  i
    found = .false.
    do  i = 1, dict%number_of_items
      if (key == str_vs(dict%items(i)%key)) then
        found = .true.
        exit
      endif
    enddo
  end function has_key

  function has_key_ns(dict, uri, localname) result(found)
    type(dictionary_t), intent(in)   :: dict
    character(len=*), intent(in)     :: uri, localname
    logical                          :: found

    integer  ::  i
    found = .false.
    do  i = 1, dict%number_of_items
      if (uri==str_vs(dict%items(i)%nsURI) &
        .and.localname==str_vs(dict%items(i)%localname)) then
        found = .true.
        exit
      endif
    enddo
  end function has_key_ns

  pure function get_key_index(dict,key) result(ind)
    type(dictionary_t), intent(in)   :: dict
    character(len=*), intent(in)     :: key
    integer                          :: ind

    integer  ::  i
    ind = -1
    do  i = 1, dict%number_of_items
      if (key == str_vs(dict%items(i)%key)) then
        ind = i
        exit
      endif
    enddo
  end function get_key_index

  pure function get_key_index_ns(dict, uri, localname) result(ind)
    type(dictionary_t), intent(in)   :: dict
    character(len=*), intent(in)     :: uri, localname
    integer                          :: ind

    integer  ::  i
    ind = -1
    do  i = 1, dict%number_of_items
      if (uri==str_vs(dict%items(i)%nsURI) &
        .and. localname==str_vs(dict%items(i)%localname)) then
        ind = i
        exit
      endif
    enddo
  end function get_key_index_ns


  function get_value_by_key(dict,key,status) result(value)
    type(dictionary_t), intent(in)       :: dict
    character(len=*), intent(in)              :: key
    integer, optional, intent(out)            :: status
    character(len = merge(size(dict%items(get_key_index(dict, key))%value), 0, (get_key_index(dict, key) > 0))) :: value
    !
    integer  :: i

    if (present(status)) status = -1
    do  i = 1, dict%number_of_items
      if (key == str_vs(dict%items(i)%key)) then
        value = str_vs(dict%items(i)%value)
        if (present(status)) status = 0
        exit
      endif
    enddo

  end function get_value_by_key

  function get_value_by_key_ns(dict, uri, localname, status) result(value)
    type(dictionary_t), intent(in)       :: dict
    character(len=*), intent(in)         :: uri, localname
    integer, optional, intent(out)       :: status
    character(len = merge(size(dict%items(get_key_index_ns(dict, uri, localname))%value), 0, &
      (get_key_index_ns(dict, uri, localname) > 0))) :: value
    !
    integer  :: i

    if (present(status)) status = -1
    do  i = 1, dict%number_of_items
       if (uri==str_vs(dict%items(i)%nsURI) &
         .and.localname==str_vs(dict%items(i)%localname)) then
          value = str_vs(dict%items(i)%value)
          if (present(status)) status = 0
          exit
       endif
    enddo

  end function get_value_by_key_ns

  subroutine remove_key_by_index(dict, key, status)
    type(dictionary_t), intent(inout)       :: dict
    integer, intent(in)                     :: key
    integer, optional, intent(out)          :: status
    
    integer :: i
    type(dict_item), dimension(dict%number_of_items-1) :: tempDict

    if (i<0 .or. i>dict%number_of_items) then
       if (present(status)) status = 0
    else
       if (present(status)) status = 1
    endif

    do i = 1, key-1
       tempDict(i)%key => dict%items(i)%key
       tempDict(i)%value => dict%items(i)%value
       tempDict(i)%nsURI => dict%items(i)%nsURI
       tempDict(i)%prefix => dict%items(i)%prefix
       tempDict(i)%localName => dict%items(i)%localName
    enddo
    deallocate(dict%items(i)%key)
    deallocate(dict%items(i)%value)
    deallocate(dict%items(i)%nsURI)
    deallocate(dict%items(i)%prefix)
    deallocate(dict%items(i)%localName)
    do i = key+1, dict%number_of_items
       tempDict(i-1)%key => dict%items(i)%key
       tempDict(i-1)%value => dict%items(i)%value
       tempDict(i-1)%nsURI => dict%items(i)%nsURI
       tempDict(i-1)%prefix => dict%items(i)%prefix
       tempDict(i-1)%localName => dict%items(i)%localName
    enddo
    !NB we don't resize here, because dictionaries only get
    !resized with MULT and LEN and stuff here.
    dict%number_of_items = dict%number_of_items - 1
    do i = 1, dict%number_of_items
       dict%items(i)%key => tempDict(i)%key
       dict%items(i)%value => tempDict(i)%value
       dict%items(i)%nsURI => tempDict(i)%nsURI
       dict%items(i)%prefix => tempDict(i)%prefix
       dict%items(i)%localName => tempDict(i)%localName
    enddo
  end subroutine remove_key_by_index
  
  function get_value_by_index(dict,i,status) result(value)
    type(dictionary_t), intent(in)       :: dict
    integer, intent(in)                       :: i
    integer, optional, intent(out)            :: status
    character(len = merge(size(dict%items(i)%value), 0, (i>0 .and. i<=dict%number_of_items))) :: value
    
    if (i>0 .and. i<=dict%number_of_items) then
       value = str_vs(dict%items(i)%value)
       if (present(status)) status = 0
    else
       if (present(status)) status = -1
    endif
    
  end function get_value_by_index
  
  function get_key(dict, i, status) result(key)
    !
    ! return the ith key
    !
    type(dictionary_t), intent(in)       :: dict
    integer, intent(in)                       :: i
    integer, optional, intent(out)            :: status
    character(len = merge(size(dict%items(i)%key), 0, (i>0 .and. i<=dict%number_of_items))) :: key
    
    if (i>0 .and. i<=dict%number_of_items)then
       key = str_vs(dict%items(i)%key)
       if (present(status)) status = 0
    else
       if (present(status)) status = -1
    endif
    
  end function get_key
  
  subroutine add_item_to_dict(dict, key, value, prefix, nsURI, type, itype)
    
    type(dictionary_t), intent(inout) :: dict
    character(len=*), intent(in)           :: key
    character(len=*), intent(in)           :: value
    character(len=*), intent(in), optional :: prefix
    character(len=*), intent(in), optional :: nsURI
    character(len=*), intent(in), optional :: type
    integer, intent(in), optional :: itype
    
    integer  :: n

    if (has_key(dict, key)) then
       call FoX_Error('Duplicate attribute')
    endif

    if (present(prefix) .eqv. .not.present(nsURI)) &
       call FoX_Error('Namespace improperly specified')
    
    n = dict%number_of_items
    if (n == size(dict%items)) then
       call resize_dict(dict)
    endif
    
    !FIXME why is this commented out?
    !if (.not.check_Name(key)) then
    !  call wxml_fatal('attribute name is invalid')
    !endif
    
    n = n + 1
    dict%items(n)%value => vs_str_alloc(value)

    if (present(prefix)) then
      dict%items(n)%key => vs_str_alloc(prefix//":"//key)
      dict%items(n)%localname => vs_str_alloc(key)
      dict%items(n)%prefix => vs_str_alloc(prefix)
      dict%items(n)%nsURI => vs_str_alloc(nsURI)
    else
      dict%items(n)%key => vs_str_alloc(key)
      dict%items(n)%localname => vs_str_alloc(key)
      allocate(dict%items(n)%prefix(0))
      allocate(dict%items(n)%nsURI(0))
    endif
    if (present(type)) then
      if (present(itype)) &
        call FoX_fatal("internal library error in add_item_to_dict")
      select case(type)
      case ('CDATA')
        dict%items(n)%type = ATT_CDATA
      case ('ID')
        dict%items(n)%type = ATT_ID
      case ('IDREF')
        dict%items(n)%type = ATT_IDREF
      case ('IDREFS')
        dict%items(n)%type = ATT_IDREFS
      case ('NMTOKEN')
        dict%items(n)%type = ATT_NMTOKEN
      case ('NMTOKENS')
        dict%items(n)%type = ATT_NMTOKENS
      case ('ENTITY')
        dict%items(n)%type = ATT_ENTITY
      case ('ENTITIES')
        dict%items(n)%type = ATT_ENTITIES
      case ('NOTATION')
        dict%items(n)%type = ATT_NOTATION
      case ('CDANO')
        dict%items(n)%type = ATT_CDANO
      case ('CDAMB')
        dict%items(n)%type = ATT_CDAMB
      end select
    elseif (present(itype)) then
      dict%items(n)%type = itype
    else
      dict%items(n)%type = ATT_CDAMB
    endif
        

    dict%number_of_items = n

  end subroutine add_item_to_dict
  
  subroutine set_nsURI_by_index(dict, i, nsURI)
    type(dictionary_t), intent(inout) :: dict
    integer, intent(in) :: i
    character(len=*), intent(in) :: nsURI

    if (associated(dict%items(i)%nsURI)) &
         deallocate(dict%items(i)%nsURI)
    dict%items(i)%nsURI => vs_str_alloc(nsURI)
  end subroutine set_nsURI_by_index

  subroutine set_prefix_by_index(dict, i, prefix)
    type(dictionary_t), intent(inout) :: dict
    integer, intent(in) :: i
    character(len=*), intent(in) :: prefix

    if (associated(dict%items(i)%prefix)) &
         deallocate(dict%items(i)%prefix)
    dict%items(i)%prefix => vs_str_alloc(prefix)
  end subroutine set_prefix_by_index

  subroutine set_localName_by_index_s(dict, i, localName)
    type(dictionary_t), intent(inout) :: dict
    integer, intent(in) :: i
    character(len=*), intent(in) :: localName

    if (associated(dict%items(i)%localName)) &
         deallocate(dict%items(i)%localName)
    dict%items(i)%localName => vs_str_alloc(localName)
  end subroutine set_localName_by_index_s

  subroutine set_localName_by_index_vs(dict, i, localName)
    type(dictionary_t), intent(inout) :: dict
    integer, intent(in) :: i
    character(len=1), dimension(:), intent(in) :: localName

    if (associated(dict%items(i)%localName)) &
         deallocate(dict%items(i)%localName)
    allocate(dict%items(i)%localName(size(localName)))
    dict%items(i)%localName = localName
  end subroutine set_localName_by_index_vs

  pure function get_nsURI_by_index(dict, i) result(nsURI)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
    character(len=size(dict%items(i)%nsURI)) :: nsURI
    
    nsURI = str_vs(dict%items(i)%nsURI)
  end function get_nsURI_by_index

  pure function get_prefix_by_index(dict, i) result(prefix)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
    character(len=size(dict%items(i)%prefix)) :: prefix
    
    prefix = str_vs(dict%items(i)%prefix)
  end function get_prefix_by_index

  pure function get_localName_by_index(dict, i) result(localName)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
    character(len=size(dict%items(i)%localName)) :: localName
    
    localName = str_vs(dict%items(i)%localName)
  end function get_localName_by_index
    
  pure function get_nsURI_by_keyname(dict, keyname) result(nsURI)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: keyname
    character(len=merge(size(dict%items(get_key_index(dict, keyname))%nsURI), 0, (get_key_index(dict, keyname) > 0))) :: nsURI
    integer :: i

    i = get_key_index(dict, keyname)
    nsURI = str_vs(dict%items(i)%nsURI)
  end function get_nsURI_by_keyname

  pure function get_prefix_by_keyname(dict, keyname) result(prefix)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: keyname
    character(len=merge(size(dict%items(get_key_index(dict, keyname))%prefix), 0, (get_key_index(dict, keyname) > 0))) :: prefix
    integer :: i

    i=get_key_index(dict, keyname)
    prefix = str_vs(dict%items(i)%prefix)

  end function get_prefix_by_keyname

  pure function get_localName_by_keyname(dict, keyname) result(localName)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: keyname
    character(len=merge(size(dict%items(get_key_index(dict, keyname))%localName), &
         0, (get_key_index(dict, keyname) > 0))) :: localName
    integer :: i

    i=get_key_index(dict, keyname)
    localName = str_vs(dict%items(i)%localName)

  end function get_localName_by_keyname

  function getType_by_index(dict, i) result(type)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
    character(len=ATT_TYPELENGTHS(merge(dict%items(i)%type,0,i<=size(dict%items)))) :: type

    if (i<=size(dict%items)) then
      select case(dict%items(i)%type)
      case (ATT_CDATA)
        type='CDATA'
      case (ATT_ID)
        type='ID'
      case (ATT_IDREF)
        type='IDREF'
      case (ATT_IDREFS)
        type='IDREFS'
      case (ATT_NMTOKEN)
        type='NMTOKENS'
      case (ATT_ENTITY)
        type='ENTITY'
      case (ATT_ENTITIES)
        type='ENTITIES'
      case (ATT_NOTATION)
        type='NOTATION'
      case (ATT_CDANO)
        type='CDATA'
      case (ATT_CDAMB)
        type='CDATA'
      end select
    else
      type = ''
    endif

  end function getType_by_index

  function getType_by_keyname(dict, keyname) result(type)
    type(dictionary_t), intent(in) :: dict
    character(len=*), intent(in) :: keyname
    character(len=ATT_TYPELENGTHS( &
      merge(dict%items(get_key_index(dict, keyname))%type, 0, get_key_index(dict, keyname)>0) &
      )) :: type

    if (get_key_index(dict, keyname)>0) then
      select case(dict%items(get_key_index(dict, keyname))%type)
      case (ATT_CDATA)
        type='CDATA'
      case (ATT_ID)
        type='ID'
      case (ATT_IDREF)
        type='IDREF'
      case (ATT_IDREFS)
        type='IDREFS'
      case (ATT_NMTOKEN)
        type='NMTOKENS'
      case (ATT_ENTITY)
        type='ENTITY'
      case (ATT_ENTITIES)
        type='ENTITIES'
      case (ATT_NOTATION)
        type='NOTATION'
      case (ATT_CDANO)
        type='CDATA'
      case (ATT_CDAMB)
        type='CDATA'
      end select
    else
      type = ''
    endif

  end function getType_by_keyname

  function getWhitespaceHandling(dict, i) result(j)
    type(dictionary_t), intent(in) :: dict
    integer, intent(in) :: i
    integer :: j

    if (i<=size(dict%items)) then
      select case(dict%items(i)%type)
      case (ATT_CDATA)
        j = 0 !
      case (ATT_CDAMB)
        j = 1
      case default
        j = 2
      end select
    else
      j = 2
    endif

  end function getWhitespaceHandling

  subroutine init_dict(dict)
    type(dictionary_t), intent(out)   :: dict
    
    integer :: i

    allocate(dict%items(DICT_INIT_LEN))
    do i = 1, DICT_INIT_LEN
       nullify(dict%items(i)%key)
       nullify(dict%items(i)%value)
       nullify(dict%items(i)%prefix)
       nullify(dict%items(i)%nsURI)
       nullify(dict%items(i)%localName)
    enddo
    
    dict % number_of_items = 0
    
  end subroutine init_dict

  subroutine resize_dict(dict)
    type(dictionary_t), intent(inout) :: dict
    type(dict_item), dimension(size(dict%items)) :: tempDict
    integer :: i, l_d_new, l_d_old

    l_d_old = size(dict%items)
    do i = 1, l_d_old
       tempDict(i)%key => dict%items(i)%key
       tempDict(i)%value => dict%items(i)%value
       tempDict(i)%prefix => dict%items(i)%prefix
       tempDict(i)%nsURI => dict%items(i)%nsURI
       tempDict(i)%localName => dict%items(i)%localName
       tempDict(i)%type = dict%items(i)%type
    enddo
    deallocate(dict%items)
    l_d_new = l_d_old * DICT_LEN_MULT
    allocate(dict%items(l_d_new))
    do i = 1, l_d_old
       dict%items(i)%key => tempDict(i)%key
       dict%items(i)%value => tempDict(i)%value
       dict%items(i)%nsURI => tempDict(i)%nsURI
       dict%items(i)%prefix => tempDict(i)%prefix
       dict%items(i)%localName => tempDict(i)%localName
       dict%items(i)%type = tempDict(i)%type
    enddo

  end subroutine resize_dict

  subroutine destroy_dict(dict)
    type(dictionary_t), intent(inout) :: dict
    integer :: i

    do i = 1, dict%number_of_items
      deallocate(dict%items(i)%key)
      deallocate(dict%items(i)%value)
      deallocate(dict%items(i)%nsURI)
      deallocate(dict%items(i)%prefix)
      deallocate(dict%items(i)%localName)
    enddo
    if (associated(dict%items)) deallocate(dict%items)

    dict%number_of_items = 0
  end subroutine destroy_dict
  

  subroutine reset_dict(dict)
    type(dictionary_t), intent(inout)   :: dict
    
    integer :: i
    do i = 1, dict%number_of_items
       deallocate(dict%items(i)%key)
       deallocate(dict%items(i)%value)
       deallocate(dict%items(i)%prefix)
       deallocate(dict%items(i)%nsURI)
       deallocate(dict%items(i)%localName)
    enddo
    
    dict%number_of_items = 0
    
  end subroutine reset_dict
  
  
  subroutine print_dict(dict)
    type(dictionary_t), intent(in)   :: dict
    
    integer  :: i
    
    do i = 1, dict%number_of_items
       write(*,'(7a)') str_vs(dict%items(i)%key), " [ {", str_vs(dict%items(i)%nsURI), &
          "}", str_vs(dict%items(i)%localName), " ]  = ", str_vs(dict%items(i)%value)
    enddo
    
  end subroutine print_dict

end module m_common_attrs

program dom_example

  use FoX_dom
  implicit none

  type(Node), pointer :: myDoc, p
  type(NodeList), pointer :: parameterList, children
  integer :: i, j

  real :: energy

  ! Load in the document
  myDoc => parseFile("h2o.xml")

  ! Find all the parameters:
  parameterList => getElementsByTagNameNS(myDoc, &
    "http://www.xml-cml.org/schema", "parameter")

  print*, "Found ", getLength(parameterList), " parameters."

  ! Loop over the parameter list. Note that the DOM
  ! counts from zero, not from one.
  do i = 0, getLength(parameterList)-1
    p => item(parameterList, i)
    ! Check for the existence of the attribute we're looking for
    if (hasAttribute(p, "name")) then
      if (getAttribute(p, "name")=="DM.EnergyTolerance") then
        ! The energy is in the text node which is the child of the <scalar> element under this node ...
        ! Check all the children of the node for the <scalar> element.
        children => getChildNodes(p)
        do j = 0, getLength(children)-1
          p => item(children, j)
          if (getLocalName(p) =="scalar") then
            ! This is the scalar node whose child we want:
            call extractDataContent(p, energy)
            print*, "Energy Tolerance is ", energy
          endif
        enddo
      endif
    endif
  enddo

  ! Clear up all allocated memory
  call destroy(myDoc)
end program dom_example

module m_common_error

  use m_common_array_str, only: vs_str_alloc
  use pxf, only: pxfabort, pxfflush

  implicit none
  private

  integer, parameter :: ERR_NULL = 0
  integer, parameter :: ERR_WARNING = 1
  integer, parameter :: ERR_ERROR = 2
  integer, parameter :: ERR_FATAL = 3

  type error_t
    integer :: severity = ERR_NULL
    integer :: error_code = 0
    character, dimension(:), pointer :: msg => null()
  end type error_t

  type error_stack
    type(error_t), dimension(:), pointer :: stack => null()
  end type error_stack

  interface FoX_warning
    module procedure FoX_warning_base
  end interface

  interface FoX_error
    module procedure FoX_error_base
  end interface

  interface FoX_fatal
    module procedure FoX_fatal_base
  end interface

  public :: ERR_NULL
  public :: ERR_WARNING
  public :: ERR_ERROR
  public :: ERR_FATAL

  public :: error_t
  public :: error_stack

  public :: init_error_stack
  public :: destroy_error_stack

  public :: FoX_warning
  public :: FoX_error
  public :: FoX_fatal

  public :: FoX_warning_base
  public :: FoX_error_base
  public :: FoX_fatal_base

  public :: add_error
  public :: in_error

contains

  subroutine FoX_warning_base(msg)
    ! Emit warning, but carry on.
    character(len=*), intent(in) :: msg

    write(0,'(a)') 'WARNING(FoX)'
    write(0,'(a)')  msg
    call pxfflush(0)

  end subroutine FoX_warning_base


  subroutine FoX_error_base(msg)
    ! Emit error message and stop.
    ! No clean up is done here, but this can
    ! be overridden to include clean-up routines
    character(len=*), intent(in) :: msg

    write(0,'(a)') 'ERROR(FoX)'
    write(0,'(a)')  msg
    call pxfflush(0)

    stop

  end subroutine FoX_error_base

  subroutine FoX_fatal_base(msg)
    !Emit error message and abort with coredump.
    !No clean-up occurs

    character(len=*), intent(in) :: msg

    write(0,'(a)') 'ABORT(FOX)'
    write(0,'(a)')  msg
    call pxfflush(0)

    call pxfabort()

  end subroutine FoX_fatal_base


  subroutine init_error_stack(stack)
    type(error_stack), intent(inout) :: stack
    
    allocate(stack%stack(0))
  end subroutine init_error_stack


  subroutine destroy_error_stack(stack)
    type(error_stack), intent(inout) :: stack
    
    integer :: i

    do i = 1, size(stack%stack)
      deallocate(stack%stack(i)%msg)
    enddo
    deallocate(stack%stack)
  end subroutine destroy_error_stack


  subroutine add_error(stack, msg, severity, error_code)
    type(error_stack), intent(inout) :: stack
    character(len=*), intent(in) :: msg
    integer, intent(in), optional :: severity
    integer, intent(in), optional :: error_code

    integer :: i, n
    type(error_t), dimension(:), pointer :: temp_stack 

    if (.not.associated(stack%stack)) &
      call init_error_stack(stack)

    n = size(stack%stack)
    
    temp_stack => stack%stack
    allocate(stack%stack(n+1))
    do i = 1, size(temp_stack)
      stack%stack(i)%msg => temp_stack(i)%msg
      stack%stack(i)%severity = temp_stack(i)%severity
      stack%stack(i)%error_code = temp_stack(i)%error_code
    enddo
    deallocate(temp_stack)

    stack%stack(n+1)%msg => vs_str_alloc(msg)
    if (present(severity)) then
      stack%stack(n+1)%severity = severity
    else
      stack%stack(n+1)%severity = ERR_ERROR
    endif
    if (present(error_code)) then
      stack%stack(n+1)%error_code = error_code
    else
      stack%stack(n+1)%error_code = -1
    endif

  end subroutine add_error


  function in_error(stack) result(p)
    type(error_stack), intent(in) :: stack
    logical :: p

    if (associated(stack%stack)) then
      p = (size(stack%stack) > 0)
    else
      p = .false.
    endif
  end function in_error


end module m_common_error

module m_common_entity_expand

  use m_common_array_str, only: str_vs, vs_str
  use m_common_entities, only: expand_char_entity
  use m_common_error, only: error_stack, add_error
  use m_common_namecheck, only: checkName, checkCharacterEntityReference, &
    checkRepCharEntityReference
  use m_common_struct, only: xml_doc_state

  implicit none
  private

  public :: expand_entity_value_alloc

  ! This does the first level of expansion of the contents of an entity
  ! reference, for storage during processing. Only character references
  ! are expanded.

contains

  function expand_entity_value_alloc(repl, xds, stack) result(repl_new)
    !perform expansion of character entity references
    ! check that no parameter entities are present
    ! and check that all general entity references are well-formed.
    !before storing it.
    !
    ! This is only ever called from the SAX parser
    ! (might it be called from WXML?)
    ! so input & output is with character arrays, not strings.
    character, dimension(:), intent(in) :: repl
    type(xml_doc_state), intent(in) :: xds
    type(error_stack), intent(inout) :: stack
    character, dimension(:), pointer :: repl_new

    character, dimension(size(repl)) :: repl_temp
    integer :: i, i2, j
    
    allocate(repl_new(0))
    if (index(str_vs(repl),'%')/=0) then
      call add_error(stack, "Not allowed % in internal subset general entity value")
      return
    endif

    i = 1
    i2 = 1
    do
      if (i>size(repl)) exit
      if (repl(i)=='&') then
        j = index(str_vs(repl(i+1:)),';')
        if (j==0) then
          call add_error(stack, "Not allowed bare & in entity value")
          return
        elseif (checkName(str_vs(repl(i+1:i+j-1)), xds)) then
          repl_temp(i2:i2+j) = repl(i:i+j)
          i = i + j + 1
          i2 = i2 + j + 1
          ! For SAX, we need to be able to represent the character:
        elseif (checkRepCharEntityReference(str_vs(repl(i+1:i+j-1)), xds%xml_version)) then
          !if it is ascii then
          repl_temp(i2:i2) = vs_str(expand_char_entity(str_vs(repl(i+1:i+j-1))))
          i = i + j + 1
          i2 = i2 + 1
        elseif (checkCharacterEntityReference(str_vs(repl(i+1:i+j-1)), xds%xml_version)) then
          ! We can't represent it. Issue an error and stop.
          call add_error(stack, "Unable to digest character entity reference in entity value, sorry.")
          return
        else
          call add_error(stack, "Invalid entity reference in entity value")
          return
        endif
      else
        repl_temp(i2) = repl(i)
        i = i + 1
        i2 = i2 + 1
      endif
    enddo

    deallocate(repl_new)
    allocate(repl_new(i2-1))
    repl_new = repl_temp(:i2-1)

  end function expand_entity_value_alloc

end module m_common_entity_expand

program test

  use FoX_wxml
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  call xml_OpenFile(filename, xf)
  call xml_AddDOCTYPE(xf, 'html', public='-//W3C//DTD XHTML 1.0 Strict//EN', &
                      system='http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd')
  call xml_NewElement(xf, 'html')
  call xml_Close(xf)

end program test

 ! This file is AUTOGENERATED!!!!
! Do not edit this file; edit m_wcml_stml.m4 and regenerate.
!
!
module m_wcml_stml

#ifndef DUMMYLIB
  use FoX_wxml, only: xmlf_t
  use FoX_wxml, only: xml_NewElement, xml_EndElement
  use FoX_wxml, only: xml_AddCharacters, xml_AddAttribute

! Fix for pgi, requires this explicitly:
  use m_wxml_overloads

  implicit none
  private

  integer, private, parameter ::  sp = selected_real_kind(6,30)
  integer, private, parameter ::  dp = selected_real_kind(14,100)

  interface stmAddValue
     module procedure stmAddCmplxDpSca
     module procedure stmAddCmplxSpSca
     module procedure stmAddRealDpSca
     module procedure stmAddRealSpSca
     module procedure stmAddIntSca
     module procedure stmAddLgSca
     module procedure stmAddChSca

     module procedure stmAddCmplxDpArr
     module procedure stmAddCmplxSpArr
     module procedure stmAddRealDpArr
     module procedure stmAddRealSpArr
     module procedure stmAddIntArr
     module procedure stmAddLgArr
     module procedure stmAddChArr

     module procedure stmAddCmplxDpMat
     module procedure stmAddCmplxSpMat
     module procedure stmAddRealDpMat
     module procedure stmAddRealSpMat
     module procedure stmAddIntMat
     module procedure stmAddLgMat
     module procedure stmAddChMat

  end interface stmAddValue

  interface stmAddScalar
     module procedure stmAddCmplxDpSca
     module procedure stmAddCmplxSpSca
     module procedure stmAddRealDpSca
     module procedure stmAddRealSpSca
     module procedure stmAddIntSca
     module procedure stmAddLgSca
     module procedure stmAddChSca

  end interface stmAddScalar

  interface stmAddArray
     module procedure stmAddCmplxDpArr
     module procedure stmAddCmplxSpArr
     module procedure stmAddRealDpArr
     module procedure stmAddRealSpArr
     module procedure stmAddIntArr
     module procedure stmAddLgArr
     module procedure stmAddChArr

  end interface stmAddArray

  interface stmAddMatrix
     module procedure stmAddCmplxDpMat
     module procedure stmAddCmplxSpMat
     module procedure stmAddRealDpMat
     module procedure stmAddRealSpMat
     module procedure stmAddIntMat
     module procedure stmAddLgMat
     module procedure stmAddChMat

  end interface stmAddMatrix

  public :: stmAddValue
  public :: stmAddScalar
  public :: stmAddArray
  public :: stmAddMatrix

contains

  subroutine stmAddCmplxDpSca(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, fmt)

    type(xmlf_t), intent(inout) :: xf
    complex(dp), intent(in)  :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: fmt
    call xml_NewElement(xf, "scalar")
    call xml_AddAttribute(xf, "dataType", "fpx:complex")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value, fmt)

    call xml_EndElement(xf, "scalar")


  end subroutine stmAddCmplxDpSca

  subroutine stmAddCmplxSpSca(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, fmt)

    type(xmlf_t), intent(inout) :: xf
    complex(sp), intent(in)  :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: fmt
    call xml_NewElement(xf, "scalar")
    call xml_AddAttribute(xf, "dataType", "fpx:complex")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value, fmt)

    call xml_EndElement(xf, "scalar")


  end subroutine stmAddCmplxSpSca

  subroutine stmAddRealDpSca(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, fmt)

    type(xmlf_t), intent(inout) :: xf
    real(dp), intent(in)  :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: fmt
    call xml_NewElement(xf, "scalar")
    call xml_AddAttribute(xf, "dataType", "fpx:real")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value, fmt)

    call xml_EndElement(xf, "scalar")


  end subroutine stmAddRealDpSca

  subroutine stmAddRealSpSca(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, fmt)

    type(xmlf_t), intent(inout) :: xf
    real(sp), intent(in)  :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: fmt
    call xml_NewElement(xf, "scalar")
    call xml_AddAttribute(xf, "dataType", "fpx:real")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value, fmt)

    call xml_EndElement(xf, "scalar")


  end subroutine stmAddRealSpSca

  subroutine stmAddIntSca(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units)

    type(xmlf_t), intent(inout) :: xf
    integer, intent(in)  :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, "scalar")
    call xml_AddAttribute(xf, "dataType", "xsd:integer")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value)

    call xml_EndElement(xf, "scalar")


  end subroutine stmAddIntSca

  subroutine stmAddLgSca(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
)

    type(xmlf_t), intent(inout) :: xf
    logical, intent(in)  :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    call xml_NewElement(xf, "scalar")
    call xml_AddAttribute(xf, "dataType", "xsd:boolean")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    call xml_AddCharacters(xf, value)

    call xml_EndElement(xf, "scalar")


  end subroutine stmAddLgSca

  subroutine stmAddChSca(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, dataType )

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in)  :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: dataType

    call xml_NewElement(xf, "scalar")
    if (present(dataType)) then
      call xml_addAttribute(xf, "dataType", dataType)
    else
    call xml_AddAttribute(xf, "dataType", "xsd:string")
    endif

    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value)

    call xml_EndElement(xf, "scalar")


  end subroutine stmAddChSca


  subroutine stmAddCmplxDpArr(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, fmt)

    type(xmlf_t), intent(inout) :: xf
    complex(dp), intent(in) , dimension(:) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: fmt
    call xml_NewElement(xf, "array")
    call xml_AddAttribute(xf, "size", size(value))
    call xml_AddAttribute(xf, "dataType", "fpx:complex")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value, fmt)

    call xml_EndElement(xf, "array")


  end subroutine stmAddCmplxDpArr

  subroutine stmAddCmplxSpArr(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, fmt)

    type(xmlf_t), intent(inout) :: xf
    complex(sp), intent(in) , dimension(:) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: fmt
    call xml_NewElement(xf, "array")
    call xml_AddAttribute(xf, "size", size(value))
    call xml_AddAttribute(xf, "dataType", "fpx:complex")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value, fmt)

    call xml_EndElement(xf, "array")


  end subroutine stmAddCmplxSpArr

  subroutine stmAddRealDpArr(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, fmt)

    type(xmlf_t), intent(inout) :: xf
    real(dp), intent(in) , dimension(:) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: fmt
    call xml_NewElement(xf, "array")
    call xml_AddAttribute(xf, "size", size(value))
    call xml_AddAttribute(xf, "dataType", "fpx:real")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value, fmt)

    call xml_EndElement(xf, "array")


  end subroutine stmAddRealDpArr

  subroutine stmAddRealSpArr(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, fmt)

    type(xmlf_t), intent(inout) :: xf
    real(sp), intent(in) , dimension(:) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: fmt
    call xml_NewElement(xf, "array")
    call xml_AddAttribute(xf, "size", size(value))
    call xml_AddAttribute(xf, "dataType", "fpx:real")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value, fmt)

    call xml_EndElement(xf, "array")


  end subroutine stmAddRealSpArr

  subroutine stmAddIntArr(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units)

    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) , dimension(:) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, "array")
    call xml_AddAttribute(xf, "size", size(value))
    call xml_AddAttribute(xf, "dataType", "xsd:integer")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value)

    call xml_EndElement(xf, "array")


  end subroutine stmAddIntArr

  subroutine stmAddLgArr(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
)

    type(xmlf_t), intent(inout) :: xf
    logical, intent(in) , dimension(:) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    call xml_NewElement(xf, "array")
    call xml_AddAttribute(xf, "size", size(value))
    call xml_AddAttribute(xf, "dataType", "xsd:boolean")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    call xml_AddCharacters(xf, value)

    call xml_EndElement(xf, "array")


  end subroutine stmAddLgArr

  subroutine stmAddChArr(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, dataType , delimiter)

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) , dimension(:) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: dataType

    character(len=1), intent(in), optional :: delimiter
    call xml_NewElement(xf, "array")
    call xml_AddAttribute(xf, "size", size(value))
    if (present(delimiter)) then
      call xml_AddAttribute(xf, "delimiter", delimiter)
    else
      call xml_AddAttribute(xf, "delimiter", " ")
    endif
    if (present(dataType)) then
      call xml_addAttribute(xf, "dataType", dataType)
    else
    call xml_AddAttribute(xf, "dataType", "xsd:string")
    endif

    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value, delimiter)

    call xml_EndElement(xf, "array")


  end subroutine stmAddChArr


  subroutine stmAddCmplxDpMat(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, fmt)

    type(xmlf_t), intent(inout) :: xf
    complex(dp), intent(in) , dimension(:,:) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: fmt
    call xml_NewElement(xf, "matrix")
    call xml_AddAttribute(xf, "rows", size(value,1))
    call xml_AddAttribute(xf, "columns", size(value,2))
    call xml_AddAttribute(xf, "dataType", "fpx:complex")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value, fmt)

    call xml_EndElement(xf, "matrix")


  end subroutine stmAddCmplxDpMat

  subroutine stmAddCmplxSpMat(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, fmt)

    type(xmlf_t), intent(inout) :: xf
    complex(sp), intent(in) , dimension(:,:) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: fmt
    call xml_NewElement(xf, "matrix")
    call xml_AddAttribute(xf, "rows", size(value,1))
    call xml_AddAttribute(xf, "columns", size(value,2))
    call xml_AddAttribute(xf, "dataType", "fpx:complex")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value, fmt)

    call xml_EndElement(xf, "matrix")


  end subroutine stmAddCmplxSpMat

  subroutine stmAddRealDpMat(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, fmt)

    type(xmlf_t), intent(inout) :: xf
    real(dp), intent(in) , dimension(:,:) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: fmt
    call xml_NewElement(xf, "matrix")
    call xml_AddAttribute(xf, "rows", size(value,1))
    call xml_AddAttribute(xf, "columns", size(value,2))
    call xml_AddAttribute(xf, "dataType", "fpx:real")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value, fmt)

    call xml_EndElement(xf, "matrix")


  end subroutine stmAddRealDpMat

  subroutine stmAddRealSpMat(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, fmt)

    type(xmlf_t), intent(inout) :: xf
    real(sp), intent(in) , dimension(:,:) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: fmt
    call xml_NewElement(xf, "matrix")
    call xml_AddAttribute(xf, "rows", size(value,1))
    call xml_AddAttribute(xf, "columns", size(value,2))
    call xml_AddAttribute(xf, "dataType", "fpx:real")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value, fmt)

    call xml_EndElement(xf, "matrix")


  end subroutine stmAddRealSpMat

  subroutine stmAddIntMat(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units)

    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) , dimension(:,:) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, "matrix")
    call xml_AddAttribute(xf, "rows", size(value,1))
    call xml_AddAttribute(xf, "columns", size(value,2))
    call xml_AddAttribute(xf, "dataType", "xsd:integer")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value)

    call xml_EndElement(xf, "matrix")


  end subroutine stmAddIntMat

  subroutine stmAddLgMat(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
)

    type(xmlf_t), intent(inout) :: xf
    logical, intent(in) , dimension(:,:) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    call xml_NewElement(xf, "matrix")
    call xml_AddAttribute(xf, "rows", size(value,1))
    call xml_AddAttribute(xf, "columns", size(value,2))
    call xml_AddAttribute(xf, "dataType", "xsd:boolean")


    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    call xml_AddCharacters(xf, value)

    call xml_EndElement(xf, "matrix")


  end subroutine stmAddLgMat

  subroutine stmAddChMat(xf, value, &
id, title, dictRef, convention, errorValue, errorBasis, min, max, ref &
, units, dataType , delimiter)

    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) , dimension(:,:) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: ref

    character(len=*), intent(in), optional :: units

    character(len=*), intent(in), optional :: dataType

    character(len=1), intent(in), optional :: delimiter
    call xml_NewElement(xf, "matrix")
    call xml_AddAttribute(xf, "rows", size(value,1))
    call xml_AddAttribute(xf, "columns", size(value,2))
    if (present(delimiter)) then
      call xml_AddAttribute(xf, "delimiter", delimiter)
    else
      call xml_AddAttribute(xf, "delimiter", " ")
    endif
    if (present(dataType)) then
      call xml_addAttribute(xf, "dataType", dataType)
    else
    call xml_AddAttribute(xf, "dataType", "xsd:string")
    endif

    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(errorValue)) call xml_addAttribute(xf, "errorValue", errorValue)
    if (present(errorBasis)) call xml_addAttribute(xf, "errorBasis", errorBasis)
    if (present(min)) call xml_addAttribute(xf, "min", min)
    if (present(max)) call xml_addAttribute(xf, "max", max)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)

    if (present(units)) call xml_addAttribute(xf, "units", units)

    call xml_AddCharacters(xf, value, delimiter)

    call xml_EndElement(xf, "matrix")


  end subroutine stmAddChMat


#endif
end module m_wcml_stml

module m_common_notations

#ifndef DUMMYLIB
  use m_common_array_str, only: vs_str, str_vs
  use m_common_error, only: FoX_error

  implicit none
  private

  type notation
    character(len=1), dimension(:), pointer :: name
    character(len=1), dimension(:), pointer :: systemID
    character(len=1), dimension(:), pointer :: publicId
  end type notation

  type notation_list
    type(notation), dimension(:), pointer :: notations
  end type notation_list

  public :: notation
  public :: notation_list
  public :: init_notation_list
  public :: destroy_notation_list
  public :: add_notation
  public :: notation_exists

contains

  subroutine init_notation_list(nlist)
! It is not clear how we should specify the 
! intent of this argument - different 
! compilers seem to have different semantics
    type(notation_list), intent(inout) :: nlist

    allocate(nlist%notations(0:0))
    allocate(nlist%notations(0)%name(0))
    allocate(nlist%notations(0)%systemId(0))
    allocate(nlist%notations(0)%publicId(0))
    
  end subroutine init_notation_list


  subroutine destroy_notation_list(nlist)
    type(notation_list), intent(inout) :: nlist

    integer :: i

    do i = 0, ubound(nlist%notations, 1)
      deallocate(nlist%notations(i)%name)
      deallocate(nlist%notations(i)%systemId)
      deallocate(nlist%notations(i)%publicId)
    enddo
    deallocate(nlist%notations)
  end subroutine destroy_notation_list
 

  subroutine add_notation(nlist, name, systemId, publicId)
    type(notation_list), intent(inout) :: nlist
    character(len=*), intent(in) :: name
    character(len=*), intent(in), optional :: systemId
    character(len=*), intent(in), optional :: publicId

    integer :: i
    type(notation), dimension(:), pointer :: temp
    ! pointer not allocatable to avoid bug on Lahey

    if (.not.present(systemId) .and. .not.present(publicId)) &
      call FoX_error("Neither System nor Public Id specified for notation: "//name)

    allocate(temp(0:ubound(nlist%notations,1)))
    do i = 0, ubound(nlist%notations, 1)
      temp(i)%name => nlist%notations(i)%name
      temp(i)%systemId => nlist%notations(i)%systemId
      temp(i)%publicId => nlist%notations(i)%publicId
    enddo

    deallocate(nlist%notations)
    allocate(nlist%notations(0:ubound(temp, 1)+1))
    do i = 0, ubound(temp, 1)
      nlist%notations(i)%name => temp(i)%name
      nlist%notations(i)%systemId => temp(i)%systemId
      nlist%notations(i)%publicId => temp(i)%publicId
    enddo
    deallocate(temp)

    allocate(nlist%notations(i)%name(len(name)))
    nlist%notations(i)%name = vs_str(name)
    if (present(systemId)) then
      allocate(nlist%notations(i)%systemId(len(systemId)))
      nlist%notations(i)%systemId = vs_str(systemId)
    else
      allocate(nlist%notations(i)%systemId(0))
    endif
    if (present(publicId)) then
      allocate(nlist%notations(i)%publicId(len(publicId)))
      nlist%notations(i)%publicId = vs_str(publicId)
    else
      allocate(nlist%notations(i)%publicId(0))
    endif
  end subroutine add_notation


  function notation_exists(nlist, name) result(p)
    type(notation_list), intent(in) :: nlist
    character(len=*), intent(in) :: name
    logical :: p

    integer :: i
    
    p = .false.
    do i = 1, ubound(nlist%notations, 1)
      if (str_vs(nlist%notations(i)%name) == name) then
        p = .true.
        exit
      endif
    enddo
  end function notation_exists

#endif
end module m_common_notations

program test

  use m_common_charset, only : XML1_0, XML1_1
  use m_common_struct, only : xml_doc_state
  use m_common_namecheck, only : checkNCName
  implicit none

  write(*,'(l1)') checkNCName('abcd', XML1_0)
  write(*,'(l1)') checkNCName('1abcd', XML1_0)
  write(*,'(l1)') checkNCName(':abcd', XML1_0)
  write(*,'(l1)') checkNCName('#abcd', XML1_0)
  write(*,'(l1)') checkNCName('e:abcd', XML1_0)

  write(*,'(l1)') checkNCName('abcd', XML1_1)
  write(*,'(l1)') checkNCName('1abcd', XML1_1)
  write(*,'(l1)') checkNCName(':abcd', XML1_1)
  write(*,'(l1)') checkNCName('#abcd', XML1_1)
  write(*,'(l1)') checkNCName('e:abcd', XML1_1)

end program test

program test

  use m_common_charset, only : XML1_0, XML1_1
  use m_common_struct, only : xml_doc_state
  use m_common_namecheck, only : checkPseudoAttValue
  implicit none

  type(xml_doc_state) :: xds

  write(*,'(l1)') checkPseudoAttValue('abcd', xds)
  write(*,'(l1)') checkPseudoAttValue('1abcd', xds)
  write(*,'(l1)') checkPseudoAttValue('1abc&d', xds)
  write(*,'(l1)') checkPseudoAttValue('#abcd&;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:abcd&a;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:abcd&a1;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:abcd&a!;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:abcd&amp;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:abcd&&a;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:a&amp;cd&gt;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:a&amp;cd&gt; &y;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:a&amp;cd&gt; &#x33;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:a&amp;cd&gt; &#x07;', xds)

  xds%xml_version = XML1_1

  write(*,'(l1)') checkPseudoAttValue('abcd', xds)
  write(*,'(l1)') checkPseudoAttValue('1abcd', xds)
  write(*,'(l1)') checkPseudoAttValue('1abc&d', xds)
  write(*,'(l1)') checkPseudoAttValue('#abcd&;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:abcd&a;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:abcd&a1;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:abcd&a!;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:abcd&amp;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:abcd&&a;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:a&amp;cd&gt;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:a&amp;cd&gt; &y;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:a&amp;cd&gt; &#x33;', xds)
  write(*,'(l1)') checkPseudoAttValue('e:a&amp;cd&gt; &#x07;', xds)

end program test

module m_common_buffer

  use m_common_charset, only: XML1_0, whitespace
  use m_common_error, only: FoX_error, FoX_warning
  use m_common_format, only: str

  implicit none
  private
  
  ! At this point we use a fixed-size buffer. 
  ! Note however that buffer overflows will only be
  ! triggered by overly long *unbroken* pcdata values, or
  ! by overly long attribute values. Hopefully
  ! element or attribute names are "short enough".
  !
  ! In a forthcoming implementation it could be made dynamical...
  
  ! MAX_BUFF_SIZE cannot be bigger than the maximum available
  ! record length for a compiler. In practice, this means
  ! 1024 seems to be the biggest available size.
  
  integer, parameter :: MAX_BUFF_SIZE  = 1024
  integer, parameter :: BUFF_SIZE_WARNING  = 0.9 * MAX_BUFF_SIZE
  
  type buffer_t
    private
    integer                       :: size
    character(len=MAX_BUFF_SIZE)  :: str
    integer                       :: unit
    integer                       :: xml_version
  end type buffer_t
  
  public :: buffer_t
  
  public :: add_to_buffer
  public :: print_buffer, str, char, len
  public :: buffer_to_chararray
  public :: buffer_nearly_full
  public :: reset_buffer
  public :: dump_buffer

  interface str
    module procedure buffer_to_str
  end interface
  
  interface char
    module procedure buffer_to_str
  end interface
  
  interface len
    module procedure buffer_length
  end interface
  
contains

  subroutine add_to_buffer(s, buffer, ws_significant)
!FIXME we should call check_buffer from here.
    character(len=*), intent(in)   :: s
    type(buffer_t), intent(inout)  :: buffer
    logical, intent(in), optional :: ws_significant
    
    integer   :: i, n, len_b
    character(len=(buffer%size+len(s))) :: s2

    ! Is whitespace significant in this context?
    ! If not, we can adjust the buffer without worrying
    ! about it.
    ! But if we are not told, we warn about it.
    ! And if we are told it definitely is - then we error out.

    !If we overreach our buffer size, we will be unable to
    !output any more characters without a newline.
    ! Go through new string, insert newlines
    ! at spaces just before MAX_BUFF_SIZE chars
    ! until we have less than MAX_BUFF_SIZE left to go,
    ! then put that in the buffer.

    ! If no whitespace is found in the newly-added string, then
    ! insert a new line immediately before it (at the end of the
    ! current buffer)

    call check_buffer(s, buffer%xml_version)

    if (buffer%size + len(s) > MAX_BUFF_SIZE) then
      if (.not.present(ws_significant)) then
        call FoX_warning( &
        "Output buffer too small. Need to insert a newline. If whitespace might be significant, check your output.")
      elseif (ws_significant) then
        call FoX_error( &
        "Output buffer too small. Need to insert a newline but whitespace is significant. Stopping now.")
      else
        continue ! without error or warning
      endif
    endif

    ! FIXME this is wrong. We should not ever insert whitespace into the
    ! existing buffer, we don't know if it might be whitespace-significant.

    s2 = buffer%str(:buffer%size)//s

    n = 1
    do while (n < len(s2)-MAX_BUFF_SIZE)
      i = scan(s2(n:n+MAX_BUFF_SIZE-1), whitespace, back=.true.)
      write(buffer%unit, '(a)') s2(n:n+i-1)
      n = n + i 
    enddo

    len_b = len(s2) - n + 1
    buffer%str(:len_b) = s2(n:)
    buffer%size = len_b

  end subroutine add_to_buffer


  subroutine reset_buffer(buffer, unit, xml_version)
    type(buffer_t), intent(inout)  :: buffer
    integer, intent(in), optional :: unit
    integer, intent(in) :: xml_version

    buffer%size = 0
    if (present(unit)) then
      buffer%unit = unit
    else 
      buffer%unit = 6
    endif
    buffer%xml_version = xml_version
    
  end subroutine reset_buffer
  

  subroutine print_buffer(buffer)
    type(buffer_t), intent(in)  :: buffer
    
    write(unit=6,fmt="(a)") buffer%str(:buffer%size)

  end subroutine print_buffer


  function buffer_to_str(buffer) result(str)
    type(buffer_t), intent(in)          :: buffer
    character(len=buffer%size)          :: str
    
    str = buffer%str(:buffer%size)
  end function buffer_to_str


  function buffer_to_chararray(buffer) result(str)
    type(buffer_t), intent(in)               :: buffer
    character(len=1), dimension(buffer%size) :: str
    integer :: i
    
    do i = 1, buffer%size
      str(i) = buffer%str(i:i)
    enddo
  end function buffer_to_chararray


  function buffer_nearly_full(buffer) result(warn)
    type(buffer_t), intent(in)          :: buffer
    logical                             :: warn
    
    warn = buffer%size > BUFF_SIZE_WARNING
    
  end function buffer_nearly_full


  function buffer_length(buffer) result(length)
    type(buffer_t), intent(in)          :: buffer
    integer                             :: length
    
    length = buffer%size 

  end function buffer_length

  
  subroutine dump_buffer(buffer, lf)
    type(buffer_t), intent(inout) :: buffer
    logical, intent(in), optional :: lf

    logical :: lf_

    if (present(lf)) then
      lf_ = lf
    else
      lf_ = .true.
    endif

    if (lf_) then
      write(buffer%unit, '(a)') buffer%str(:buffer%size)
    else
      write(buffer%unit, '(a)', advance='no') buffer%str(:buffer%size)
    endif
    buffer%size = 0
  end subroutine dump_buffer

  
  subroutine check_buffer(s, version)
    character(len=*), intent(in) :: s
    integer, intent(in) :: version

    integer :: i

!FIXME this is almost a duplicate of logic in wxml/m_wxml_escape.f90

    ! We have to do it this way (with achar etc) in case the native
    ! platform encoding is not ASCII

    do i = 1, len(s)
      select case (iachar(s(i:i)))
      case (0)
        call FoX_error("Tried to output a NUL character")
      case (1:8,11:12,14:31)
        if (version==XML1_0) then
          call FoX_error("Tried to output a character invalid under XML 1.0: &#"//str(iachar(s(i:i)))//";")
        endif
      case (128:)
        !TOHW we should maybe just disallow this ...
        call FoX_warning("emitting non-ASCII character. Platform-dependent result!")
      end select
    enddo 

  end subroutine check_buffer


end module m_common_buffer

module m_common_buffer

#ifndef DUMMYLIB
  use m_common_charset, only: XML1_0
  use m_common_error, only: FoX_error, FoX_warning
  use m_common_format, only: str

  implicit none
  private
  
  ! At this point we use a fixed-size buffer. 
  ! Note however that buffer overflows will only be
  ! triggered by overly long *unbroken* pcdata values, or
  ! by overly long attribute values. Hopefully
  ! element or attribute names are "short enough".
  !
  ! In a forthcoming implementation it could be made dynamical...
  
  ! MAX_BUFF_SIZE cannot be bigger than the maximum available
  ! record length for a compiler. In practice, this means
  ! 1024 seems to be the biggest available size.
  
  integer, parameter :: MAX_BUFF_SIZE  = 1024
  
  type buffer_t
    private
    integer                       :: size
    character(len=MAX_BUFF_SIZE)  :: str
    integer                       :: unit
    integer                       :: xml_version
  end type buffer_t
  
  public :: buffer_t
  
  public :: add_to_buffer
  public :: print_buffer, str, char, len
  public :: buffer_to_chararray
  public :: reset_buffer
  public :: dump_buffer

  interface str
    module procedure buffer_to_str
  end interface
  
  interface char
    module procedure buffer_to_str
  end interface
  
  interface len
    module procedure buffer_length
  end interface
  
contains

  subroutine add_to_buffer(s, buffer, ws_significant)
    character(len=*), intent(in)   :: s
    type(buffer_t), intent(inout)  :: buffer
    logical, intent(in), optional :: ws_significant
    
    character(len=(buffer%size+len(s))) :: s2
    integer :: i, n, len_b
    logical :: warning, ws_

    ! Is whitespace significant in this context?
    ! We have to assume so unless told otherwise.
    if (present(ws_significant)) then
      ws_ = ws_significant
    else
      ws_ = .true.
    endif

    ! FIXME The algorithm below unilaterally forces all
    ! line feeds and carriage returns to native EOL, regardless
    ! of input document. Thus it is impossible to output a
    ! document containing a literal non-native newline character
    ! Ideally we would put this under the control of the user.

    ! We check if whitespace is significant. If not, we can 
    ! adjust the buffer without worrying about it.
    ! But if we are not told, we warn about it.
    ! And if we are told it definitely is - then we error out.

    ! If we overreach our buffer size, we will be unable to
    ! output any more characters without a newline.
    ! Go through new string, insert newlines
    ! at spaces just before MAX_BUFF_SIZE chars
    ! until we have less than MAX_BUFF_SIZE left to go,
    ! then put that in the buffer.

    ! If no whitespace is found in the newly-added string, then
    ! insert a new line immediately before it (at the end of the
    ! current buffer)

    call check_buffer(s, buffer%xml_version)

    s2 = buffer%str(:buffer%size)//s

    ! output as much of this using existing newlines as possible.
    warning = .false.
    n = 1
    do while (n<=len(s2))
      ! Note this is an XML-1.0 only definition of newline
      i = scan(s2(n:), achar(10)//achar(13))
      if (i>0) then
        ! turn that newline into an output newline ...
        write(buffer%unit, '(a)') s2(n:n+i-2)
        n = n + i
      elseif (n<=len(s2)-MAX_BUFF_SIZE) then
        ! We need to insert a newline, or we'll overrun the buffer
        ! No suitable newline, so convert a space or tab into a newline.
        i = scan(s2(n:n+MAX_BUFF_SIZE-1), achar(9)//achar(32), back=.true.)
        ! If no space or tab is present, we fail.
        if (i>0.and..not.present(ws_significant)) then
          ! We can insert a newline, but we don't know whether it is significant. Warn:
          if (.not.warning) then
            ! We only output this warning once.
            call FoX_warning( &
            "Fortran made FoX insert a newline. "// &
            "If whitespace might be significant, check your output.")
            warning = .true.
          endif
        elseif (i==0) then
          call FoX_error( &
            "Fortran made FoX insert a newline but it can't. Stopping now.")
        elseif (ws_) then
          call FoX_error( &
            "Fortran made FoX insert a newline but whitespace is significant. Stopping now.")
        else
          continue ! without error or warning, because whitespace is not significant
        endif
        write(buffer%unit, '(a)') s2(n:n+i-1)
        n = n + i 
      else
        ! We don't need to do anything, just add the remainder to the buffer.
        exit
      endif
    enddo

    len_b = len(s2) - n + 1
    buffer%str(:len_b) = s2(n:)
    buffer%size = len_b

  end subroutine add_to_buffer


  subroutine reset_buffer(buffer, unit, xml_version)
    type(buffer_t), intent(inout)  :: buffer
    integer, intent(in), optional :: unit
    integer, intent(in) :: xml_version

    buffer%size = 0
    if (present(unit)) then
      buffer%unit = unit
    else 
      buffer%unit = 6
    endif
    buffer%xml_version = xml_version
    
  end subroutine reset_buffer
  

  subroutine print_buffer(buffer)
    type(buffer_t), intent(in)  :: buffer
    
    write(unit=6,fmt="(a)") buffer%str(:buffer%size)

  end subroutine print_buffer


  function buffer_to_str(buffer) result(str)
    type(buffer_t), intent(in)          :: buffer
    character(len=buffer%size)          :: str
    
    str = buffer%str(:buffer%size)
  end function buffer_to_str


  function buffer_to_chararray(buffer) result(str)
    type(buffer_t), intent(in)               :: buffer
    character(len=1), dimension(buffer%size) :: str
    integer :: i
    
    do i = 1, buffer%size
      str(i) = buffer%str(i:i)
    enddo
  end function buffer_to_chararray


  function buffer_length(buffer) result(length)
    type(buffer_t), intent(in)          :: buffer
    integer                             :: length
    
    length = buffer%size 

  end function buffer_length

  
  subroutine dump_buffer(buffer, lf)
    type(buffer_t), intent(inout) :: buffer
    logical, intent(in), optional :: lf

    integer :: i, n
    logical :: lf_

    if (present(lf)) then
      lf_ = lf
    else
      lf_ = .true.
    endif

    i = scan(buffer%str(:buffer%size), achar(10)//achar(13))
    n = 1
    do while (i>0)
      write(buffer%unit, '(a)', advance="yes") buffer%str(n:n+i-2)
      n = n + i
      if (n>buffer%size) exit
      i = scan(buffer%str(n:), achar(10)//achar(13))
    enddo
    
    if (n<=buffer%size) then
      if (lf_) then
        write(buffer%unit, '(a)', advance="yes") buffer%str(n:buffer%size)
      else
        write(buffer%unit, '(a)', advance="no") buffer%str(n:buffer%size)
      endif
    endif

    buffer%size = 0
  end subroutine dump_buffer

  
  subroutine check_buffer(s, version)
    character(len=*), intent(in) :: s
    integer, intent(in) :: version

    integer :: i

!FIXME this is almost a duplicate of logic in wxml/m_wxml_escape.f90

    ! We have to do it this way (with achar etc) in case the native
    ! platform encoding is not ASCII

    do i = 1, len(s)
      select case (iachar(s(i:i)))
      case (0)
        call FoX_error("Tried to output a NUL character")
      case (1:8,11:12,14:31)
        if (version==XML1_0) then
          call FoX_error("Tried to output a character invalid under XML 1.0: &#"//str(iachar(s(i:i)))//";")
        endif
      case (128:)
        !TOHW we should maybe just disallow this ...
        call FoX_warning("emitting non-ASCII character. Platform-dependent result!")
      end select
    enddo 

  end subroutine check_buffer

#endif
end module m_common_buffer

module FoX_wcml

  use FoX_wxml, only: xmlf_t

  use m_wcml_core
  use m_wcml_coma
  use m_wcml_geometry
  use m_wcml_lattice
  use m_wcml_lists
  use m_wcml_metadata
  use m_wcml_molecule
  use m_wcml_parameter
  use m_wcml_property
  use m_wcml_stml

  implicit none
  private

  public :: xmlf_t

  public :: cmlBeginFile
  public :: cmlFinishFile
  public :: cmlAddNamespace

  public :: cmlStartCml
  public :: cmlEndCml

  public :: cmlStartModule
  public :: cmlEndModule

  public :: cmlStartStep
  public :: cmlEndStep

!  public :: cmlAddLength
!  public :: cmlAddAngle
!  public :: cmlAddTorsion
!TOHW we don't use these ever

  public :: cmlAddCrystal
  public :: cmlAddLattice

  public :: cmlStartPropertyList
  public :: cmlEndPropertyList
  public :: cmlAddProperty

  public :: cmlStartParameterList
  public :: cmlEndParameterList
  public :: cmlAddParameter

  public :: cmlStartMetadataList
  public :: cmlEndMetadataList
  public :: cmlAddMetadata

  public :: cmlStartMolecule
  public :: cmlEndMolecule
  public :: cmlAddAtoms
  public :: cmlAddParticles
  public :: cmlAddMolecule

  public :: cmlStartBand
  public :: cmlEndBand

  public :: cmlAddBandList
  public :: cmlAddEigenValue
  public :: cmlAddEigenValueVector

  public :: cmlStartKPoint
  public :: cmlEndKPoint
  public :: cmlAddKPoint
  public :: cmlStartKPointList
  public :: cmlEndKPointList

  public :: cmlAddSymmetry

end module FoX_wcml

module m_handlers

  use FoX_common
  use FoX_sax

  implicit none
  private

    public :: error_handler
    public :: fatalError_handler

contains

  subroutine error_handler(msg)
    character(len=*), intent(in) :: msg
    write(*,'(a)') "Error encountered and caught"
    write(*,'(a)') msg
  end subroutine error_handler

  subroutine fatalError_handler(msg)
    character(len=*), intent(in) :: msg
    write(*,'(a)') "Fatal error encountered and caught"
    write(*,'(a)') msg
  end subroutine fatalError_handler

end module m_handlers

program sax_well_formed
  !
  ! Check for well-formedness - nothing happens on success;
  ! error message omitted and execution halt on any failure.
  !
  use FoX_sax
  use m_handlers
  implicit none

  integer :: iostat
  type(xml_t)  :: fxml

  call open_xml_file(fxml, "test.xml", iostat=iostat)
  if (iostat /= 0) then
    write(*,*) "Cannot open file."
    stop
  endif

  call parse(fxml,&
    error_handler=error_handler,                 &
    fatalError_handler=fatalError_handler,       &
    namespaces=.false., validation=.false.)

  call close_xml_t(fxml)

  print*, "Finished"

end program sax_well_formed

module m_wcml_attributes

  use m_wxml_core, only : xml_AddAttribute
  implicit none

  private

  public :: cmlAddAttribute

  contains

    subroutine cmlAddAttribute(xf, attr, value, check)
      type(xmlf_t), intent(inout) : xf
      character(len=*), intent(in) :: attr
      character(len=*), intent(in) :: value
      logical, intent(in), optional :: check

      if (present(check)) then
        if (check)  then
          if (checkAttribute('errorBasis')) then
            call pxfabort('Unknown attribute output')
          endif
        endif
      else
        if (checkAttribute('errorBasis')) then
          call pxfwarning('Unknown attribute output')
        endif
      endif

      call xml_Addattribute(xf, attr, value)

    end subroutine cmLAddAttribute
        

    function isValidFP(number) result(ok)
      character(len=*), intent(in) :: number
      logical :: ok

      integer :: i, state

      !This should implement [0-9]?\.*[0-9]*[Ee]*[0-9]?
      
      state = 0
      ok = i>0
      do i = 1, len(number)
        select case(state)
        case (0)
          if (index(number(i:i), digits) == -1) then
            if (index(number(i:i), '.')) then
              state = 1
            else
              ok = .false.
              exit
            endif
          endif
        case(1)
          if (index(number(i:i), digits) == -1) then
            if (index(number(i:i), 'Ee')) then
              state = 2
            else
              ok = .false.
              exit
            endif
          endif
        case(2)
          if (index(number(i:i), digits) == -1) then
            ok = .false.
            exit
          else
            state = 3
          endif
        case(3)
          if (index(number(i:i), digits) == -1) then
            ok = .false.
            exit
          endif
        end select
      end do
        
      if (state==2) ok = .false.
        
      return ok
  
    end function isValidFP

    function isValidQName

    function checkAttributeValue(attr, value) result(ok)
      character(len=*), intent(in) :: attr
      character(len=*), intent(in) :: value
      logical :: ok

      !FIXME some of these are probably required to be QNames

      ok = .false.
      select case(attr)
        case ('id'):
          ok = .true.
        case ('errorBasis'):
          if (value == 'observedRange' .or. &
              value == 'observedStandardDeviation' .or. &
              value == 'observedStandardError' .or. &
              value == 'estimatedStandardDeviation' .or. &
              value == 'estimatedStandardError') &
             ok = .true.
        case ('title')
          ok = .true.
        case ('dictRef')
          ok = .true.
        case ('dataType')
          ok = .true. !FIXME
        case ('convention')
          ok = .true.
        case ('errorValue')
          ok = isValidFP(value)
        case ('min')
          ok = isValidFP(value)
        case ('max')
          ok = isValidFP(value)
        case ('ref')
          ok = .true.
        case ('units')
          ok = .true.
        end select

module m_common_string

  ! Assorted generally useful string manipulation functions

  implicit none
  private

  character(len=26), parameter :: lowerAlphabet = &
    "abcdefghijklmnopqrstuvwxyz"
  character(len=26), parameter :: UPPERAlphabet = &
    "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

  public :: toLower

contains

  function toLower(s_in) result(s)
    character(len=*), intent(in) :: s_in
    character(len=len(s_in)) :: s

    integer :: i, n
    do i = 1, len(s)
      n = index(UPPERAlphabet, s_in(i:i))
      if (n>0) then
        s(i:i) = lowerAlphabet(n:n)
      else
        s(i:i) = s_in(i:i)
      endif
    enddo

  end function toLower

end module m_common_string
    

module m_handlers

  use FoX_common
  use FoX_sax

  implicit none
  private

  ! This module shows massive overkill with the quantity
  ! of callbacks specified. You will never need all of these
  ! unless you are implementing an alternative interface on
  ! top of SAX. (For example, the DOM interface uses all of 
  ! these.

  ! This is mainly for reference. Please see sax_example_2.f90
  ! for a more realistic example

  public :: characters_handler
  public :: endDocument_handler
  public :: endElement_handler
  public :: endPrefixMapping_handler
  public :: ignorableWhitespace_handler
  public :: processingInstruction_handler
  public :: skippedEntity_handler
  public :: startElement_handler
  public :: startDocument_handler
  public :: startPrefixMapping_handler
  public :: notationDecl_handler
  public :: unparsedEntityDecl_handler
  public :: error_handler
  public :: fatalError_handler
  public :: warning_handler
  public :: attributeDecl_handler
  public :: elementDecl_handler
  public :: externalEntityDecl_handler
  public :: internalEntityDecl_handler
  public :: comment_handler
  public :: endCdata_handler
  public :: endEntity_handler
  public :: endDTD_handler
  public :: startCdata_handler
  public :: startDTD_handler
  public :: startEntity_handler

contains

  subroutine characters_handler(chunk)
    character(len=*), intent(in) :: chunk

    write(*,'(a)') "PCDATA:"
    write(unit=*,fmt="(a)") chunk

  end subroutine characters_handler

  subroutine endDocument_handler
    write(*,'(a)') 'END DOCUMENT'
  end subroutine endDocument_handler

  subroutine endElement_handler(URI, localname, name)
    character(len=*), intent(in)     :: URI
    character(len=*), intent(in)     :: localname
    character(len=*), intent(in)     :: name

    write(unit=*,fmt="(4a)") ">>End Element: {", URI, "}", localname

  end subroutine endElement_handler
  
  subroutine endPrefixMapping_handler(prefix)
    character(len=*), intent(in) :: prefix

    write(unit=*,fmt='(a)') "END NAMESPACE MAPPING"
    write(unit=*,fmt='(2a)') "PREFIX:", prefix

  end subroutine endPrefixMapping_handler

  subroutine ignorableWhitespace_handler(chars)
    character(len=*), intent(in) :: chars
    write(*,'(2a)') str(len(chars))//" characters of ignorable whitespace found"
  end subroutine ignorableWhitespace_handler

  subroutine processingInstruction_handler(name, content)
    character(len=*), intent(in)   :: name
    character(len=*), intent(in)   :: content

    write(unit=*,fmt="(2a)") ">>Processing Instruction: ", name
    write(unit=*, fmt="(a)") content

  end subroutine processingInstruction_handler

  subroutine skippedEntity_handler(name)
    character(len=*), intent(in) :: name
    write(*,'(2a)') "Skipped entity, named "//name
  end subroutine skippedEntity_handler

  subroutine startDocument_handler
    write(*,'(a)') "Document started"
  end subroutine startDocument_handler
  
  subroutine startElement_handler(URI, localname, name,attributes)
    character(len=*), intent(in)   :: URI
    character(len=*), intent(in)   :: localname
    character(len=*), intent(in)   :: name
    type(dictionary_t), intent(in) :: attributes

    write(unit=*,fmt="(4a)") ">>Begin Element: {", URI, "}", localname
    write(unit=*,fmt="(a,i2,a)") "--- ", getLength(attributes), " attributes:"
    call print_dict(attributes)
  end subroutine startElement_handler

  subroutine startPrefixMapping_handler(URI, prefix)
    character(len=*), intent(in) :: URI
    character(len=*), intent(in) :: prefix

    write(unit=*,fmt='(a)') "START NAMESPACE MAPPING"
    write(unit=*,fmt='(2a)') "PREFIX:", prefix
    write(unit=*,fmt='(2a)') "URI:", uri

  end subroutine startPrefixMapping_handler

  subroutine notationDecl_handler(name, publicId, systemId)
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: publicId
    character(len=*), intent(in) :: systemId

    write(*,'(2a)') "Notation declaration, "//name
    write(*,'(2a)') "Public ID: ", publicId
    write(*,'(2a)') "System ID: ", systemId
  end subroutine notationDecl_handler

  subroutine unparsedEntityDecl_handler(name, publicId, systemId, notation)
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: publicId
    character(len=*), intent(in) :: systemId
    character(len=*), intent(in) :: notation

    write(*,'(2a)') "Unparsed entity declaration, "//name
    write(*,'(2a)') "Public ID: ", publicId
    write(*,'(2a)') "System ID: ", systemId
    write(*,'(2a)') "Notation: ", notation
  end subroutine unparsedEntityDecl_handler

  subroutine error_handler(msg)
    character(len=*), intent(in) :: msg
    write(*,'(a)') "Error encountered and caught"
    write(*,'(a)') msg
  end subroutine error_handler

  subroutine fatalError_handler(msg)
    character(len=*), intent(in) :: msg
    write(*,'(a)') "Fatal error encountered and caught"
    write(*,'(a)') msg
  end subroutine fatalError_handler

  subroutine warning_handler(msg)
    character(len=*), intent(in) :: msg
    write(*,'(a)') "Warning encountered and caught"
    write(*,'(a)') msg
  end subroutine warning_handler

  subroutine attributeDecl_handler(eName, aName, type, mode, value)
    character(len=*), intent(in) :: eName
    character(len=*), intent(in) :: aName
    character(len=*), intent(in) :: type
    character(len=*), intent(in), optional :: mode
    character(len=*), intent(in), optional :: value
    write(*,'(a)') "Attribute declared"
    write(*,'(a)') eName
    write(*,'(a)') aName
    write(*,'(a)') type
    if (present(mode)) write(*,'(a)') mode
    if (present(value)) write(*,'(a)') value
  end subroutine attributeDecl_handler

  subroutine elementDecl_handler(name, model)
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: model
    write(*,'(a)') "Element declared"
    write(*,'(a)') name
    write(*,'(a)') model
  end subroutine elementDecl_handler

  subroutine externalEntityDecl_handler(name, publicId, systemId)
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: publicId
    character(len=*), intent(in) :: systemId
    write(*,'(a)') "External entity declared: "//name
    write(*,'(a)') "Public Id "//publicId
    write(*,'(a)') "System Id "//systemId
  end subroutine externalEntityDecl_handler
  
  subroutine internalEntityDecl_handler(name, value)
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: value
    write(*,'(a)') 'Internal entity declared: '//name
    write(*,'(a)') value
  end subroutine internalEntityDecl_handler

  subroutine comment_handler(comment)
    character(len=*), intent(in) :: comment
    write(unit=*,fmt="(a)") ">>Comment: "
    write(unit=*,fmt="(a)") comment
  end subroutine comment_handler

  subroutine endCdata_handler()
    write(*,'(a)') 'End CDATA section'
  end subroutine endCdata_handler

  subroutine endDTD_handler()
    write(*,'(a)') 'End DTD'
  end subroutine endDTD_handler
  
  subroutine endEntity_handler(name)
    character(len=*), intent(in) :: name
    write(*,'(a)') 'End of entity expansion: '//name
  end subroutine endEntity_handler

  subroutine startCdata_handler()
    write(*,'(a)') 'Start CDATA section'
  end subroutine startCdata_handler

  subroutine startDTD_handler(name, publicId, systemId)
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: publicId
    character(len=*), intent(in) :: systemId
    write(*,'(a)') 'DTD started: '//name
    write(*,'(a)') 'Public Id: '//publicId
    write(*,'(a)') 'System Id: '//systemId
  end subroutine startDTD_handler

  subroutine startEntity_handler(name)
    character(len=*), intent(in) :: name
    write(*,'(a)') 'Start of entity expansion: '//name
  end subroutine startEntity_handler

end module m_handlers












program sax_example
  !
  ! Example driver for a stand-alone parsing of an xml document
  !
  use FoX_sax

  use m_handlers      ! Defines begin_element, end_element, pcdata_chunk, etc

  implicit none

  integer :: iostat
  type(xml_t)  :: fxml

  call open_xml_file(fxml, "staffNS.xml", iostat=iostat)
  if (iostat /= 0) then
    write(*,*) "Cannot open file."
    stop
  endif

  call parse(fxml,&
    characters_handler,            &
    endDocument_handler,           &
    endElement_handler,            &
    endPrefixMapping_handler,      &
    ignorableWhitespace_handler,   &
    processingInstruction_handler, &
    ! setDocumentLocator
    skippedEntity_handler,         &
    startDocument_handler,         & 
    startElement_handler,          &
    startPrefixMapping_handler,    &
    notationDecl_handler,          &
    unparsedEntityDecl_handler,    &
    error_handler,                 &
    fatalError_handler,            &
    warning_handler,               &
    attributeDecl_handler,         &
    elementDecl_handler,           &
    externalEntityDecl_handler,    &
    internalEntityDecl_handler,    &
    comment_handler,               &
    endCdata_handler,              &
    endDTD_handler,                &
    endEntity_handler,             &
    startCdata_handler,            &
    startDTD_handler,              &
    startEntity_handler, validation=.true.)

  call close_xml_t(fxml)

end program sax_example

 program wcml_example

   use FoX_wcml

  integer,  parameter ::  sp = selected_real_kind(6,30)
  integer,  parameter ::  dp = selected_real_kind(14,100)
!
! NB normally you will be writting to the xml file
! from mulitple fortran files/subroutines, therefore
! type(xmlf_t) :: myfile   (below)
! would normally need to be treated as a global
! variable, either in a module or a common block.
! 
  type(xmlf_t) :: myfile
!

  integer           :: num, na
  character(len=2)  :: elements(3)
  real(kind=dp)      :: coords(3,3)
  real(kind=dp)      :: adp, matrix(3,3)

  character(len=10) :: filename

  data coords(1:3,1)/0.0d0, 0.0d0, 0.0d0/
  data coords(1:3,2)/0.5d0, 0.5d0, 0.5d0/
  data coords(1:3,3)/0.4d0, 0.4d0, 0.4d0/

  matrix = 3.141_dp

  adp=1.234567890
  na=3
  elements(1) = 'Ca'
  elements(2) = 'Si'
  elements(3) = 'O'
  num = 20

  filename = 'mytest.cml'
  
  call cmlBeginFile(myfile, filename=filename, unit=-1)

  call cmlAddNamespace(myfile, prefix="myDict", URI="http://www.example.com/dict")

  call cmlStartCml(myfile)

  ! Add parameter
  call cmlStartParameterList(xf=myfile, title="Input parameters")
  call cmlAddParameter(xf=myfile, name='inputSize', value='True')
  call cmlAddParameter(xf=myfile, name='inputSize', value=.True.)
  call cmlAddParameter(xf=myfile, name='inputSize', value=3, units="cmlUnits:Angstrom")
  call cmlAddParameter(xf=myfile, name='inputSize', value=3.0, units="cmlUnits:Angstrom")
  call cmlAddParameter(xf=myfile, name='inputSize', value=3.0d0, units="cmlUnits:Angstrom")
  call cmlAddParameter(xf=myfile, name='inputSize', value=(3.0d0, 0.0d0), units="cmlUnits:Angstrom")
  call cmlEndParameterList(xf=myfile)

  call cmlStartPropertyList(xf=myfile, title="Scalars")
  call cmlAddProperty(xf=myfile, title='inputSize', value='True')
  call cmlAddProperty(xf=myfile, title='inputSize', value=.True.)
  call cmlAddProperty(xf=myfile, title='inputSize', value=3, units="cmlUnits:Angstrom")
  call cmlAddProperty(xf=myfile, title='inputSize', value=3.0, units="cmlUnits:Angstrom")
  call cmlAddProperty(xf=myfile, title='inputSize', value=3.0d0, units="cmlUnits:Angstrom")
  call cmlAddProperty(xf=myfile, title='inputSize', value=(3.0d0, 0.0d0), units="cmlUnits:Angstrom")
  call cmlEndPropertyList(xf=myfile)

  call cmlStartPropertyList(xf=myfile, title="Scalars")
  call cmlAddProperty(xf=myfile, title='inputArray', value=(/'one  ', 'two  ', 'three'/))
  call cmlAddProperty(xf=myfile, title='inputArray', value=(/.true., .false./))
  call cmlAddProperty(xf=myfile, title='inputArray', value=(/1, 2/), units="cmlUnits:Angstrom")
  call cmlAddProperty(xf=myfile, title='inputArray', value=(/1.0, 2.0/), units="cmlUnits:Angstrom")
  call cmlAddProperty(xf=myfile, title='inputArray', value=(/1.0d0, 2.0d0/), units="cmlUnits:Angstrom")
  call cmlAddProperty(xf=myfile, title='inputArray', value=(/(1.0d0,0.0d0), (2.0d0,0.0d0)/), units="cmlUnits:Angstrom")
  call cmlEndPropertyList(xf=myfile)

  call cmlStartPropertyList(xf=myfile, title="Scalars")

  call cmlStartPropertyList(myfile, dictref="castep:kpt_band")
  call cmlAddProperty(myfile, 1, dictref="castep:spin", &
             units="castepunits:spin")
  call cmlAddKpoint(myfile, (/1.0d0, 2.0d0, 3.0d0/), &
              weight=1.0d0, id="okpt:")
  call cmlAddProperty(myfile, (/1.0, 2.0/), title="Eigenvalues", &
              dictref="castep:eigenenergies", &
              units="castepunits:")
  call cmlEndPropertyList(myfile)

  call cmlAddProperty(xf=myfile, &
    value=matrix,&
    title='Elastic Constant Matrix',units='units:GPa')

  call cmlEndPropertyList(xf=myfile)

  ! Add molecule
  call cmlAddMolecule(xf=myfile, elements=elements,coords=coords)                               
  ! Add molecule output in short style
  call cmlAddMolecule(xf=myfile, elements=elements,coords=coords, style='xyz3')

  ! Add molecule output in short style in user supplied format
  call cmlAddMolecule(xf=myfile, elements=elements,coords=coords, style='xyz3', fmt='r6')

  call cmlAddCrystal(xf=myfile, a=1.0, b=1.0, c=1.0, alpha=90.0, beta=90.0, gamma=90.0)

  ! End and Close
  call cmlEndCml(myfile)
  call cmlFinishFile(myfile)
 
end program wcml_example

module m_wcml_core

  use FoX_wxml, only: xmlf_t

#ifndef DUMMYLIB
  use m_common_error, only: FoX_error

  use FoX_common, only: FoX_version
  use FoX_utils, only: generate_uuid
  use FoX_wxml, only: xml_OpenFile, xml_Close
  use FoX_wxml, only: xml_NewElement, xml_AddAttribute
  use FoX_wxml, only: xml_EndElement, xml_DeclareNamespace
  use FoX_wxml, only: xmlf_Name, xmlf_OpenTag

  use m_wcml_metadata, only: cmlAddMetadata
#endif

  implicit none
  private

  public :: cmlBeginFile
  public :: cmlFinishFile
  public :: cmlAddNamespace
  
  public :: cmlStartCml
  public :: cmlEndCml

contains

  subroutine cmlBeginFile(xf, filename, unit, replace)
    type(xmlf_t), intent(out) :: xf
    character(len=*), intent(in) :: filename
    integer, intent(in) :: unit
    logical, intent(in), optional :: replace

#ifndef DUMMYLIB
    if (unit==-1) then
      call xml_OpenFile(filename, xf, preserve_whitespace=.false., replace=replace)
    else
      call xml_OpenFile(filename, xf, preserve_whitespace=.false., unit=unit, replace=replace)
    endif
#endif

  end subroutine cmlBeginFile

  
  subroutine cmlFinishFile(xf)
    type(xmlf_t), intent(inout) :: xf

#ifndef DUMMYLIB
    call xml_Close(xf)
#endif

  end subroutine cmlFinishFile


  subroutine cmlAddNamespace(xf, prefix, URI)
    type(xmlf_t), intent(inout) :: xf  
    character(len=*), intent(in) :: prefix
    character(len=*), intent(in) :: URI

#ifndef DUMMYLIB
    if (xmlf_OpenTag(xf) /= "") &
      call FoX_error("Cannot do cmlAddNamespace after starting CML output")

    call xml_DeclareNamespace(xf, URI, prefix)
#endif

  end subroutine cmlAddNamespace


  subroutine cmlStartCml(xf, id, title, convention, dictref, fileId, version)
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: fileId
    character(len=*), intent(in), optional :: version

#ifndef DUMMYLIB
    call xml_DeclareNamespace(xf, 'http://www.xml-cml.org/schema')
    call xml_DeclareNamespace(xf, 'http://www.w3.org/2001/XMLSchema', 'xsd')
    call xml_DeclareNamespace(xf, 'http://www.uszla.me.uk/fpx', 'fpx')
    call xml_DeclareNamespace(xf, 'http://purl.org/dc/elements/1.1/title', 'dc')
    call xml_DeclareNamespace(xf, 'http://www.uszla.me.uk/FoX/units', 'units')
    call xml_DeclareNamespace(xf, 'http://www.xml-cml.org/units/units', 'cmlUnits')
    call xml_DeclareNamespace(xf, 'http://www.xml-cml.org/units/siUnits', 'siUnits')
    call xml_DeclareNamespace(xf, 'http://www.xml-cml.org/units/atomic', 'atomicUnits')
! FIXME TOHW we may want other namespaces in here - particularly for units
! once PMR has stabilized that.

    call xml_NewElement(xf, 'cml')
    if (present(id)) call xml_AddAttribute(xf, 'id', id)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(convention)) then
      call xml_AddAttribute(xf, 'convention', convention)
    else
      call xml_AddAttribute(xf, 'convention', 'FoX_wcml-2.0')
    endif
    if (present(fileId)) then
      call xml_AddAttribute(xf, 'fileId', fileId)
    else
      call xml_AddAttribute(xf, 'fileId', xmlf_Name(xf))
    endif
    if (present(version)) then
      call xml_AddAttribute(xf, 'version', version)
    else
      call xml_AddAttribute(xf, 'version', "2.4")
    endif

    call cmlAddMetadata(xf, name='UUID', content=generate_uuid(1))
#endif

  end subroutine cmlStartCml


  subroutine cmlEndCml(xf)
    type(xmlf_t), intent(inout) :: xf

#ifndef DUMMYLIB
    call cmlAddMetadata(xf, name='dc:contributor', content='FoX-'//FoX_version//' (http://www.uszla.me.uk/FoX)')
    call xml_EndElement(xf, 'cml')
#endif

  end subroutine cmlEndCml

end module m_wcml_core

program test

  use FoX_wxml, only : xmlf_t, xml_OpenFile, xml_Close
  use FoX_wxml, only : xml_NewElement, xml_DeclareNamespace
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  call xml_OpenFile(filename, xf)
  call xml_DeclareNamespace(xf, "ns1", "ns1")
  call xml_NewElement(xf, "ns1:svg")
  call xml_DeclareNamespace(xf, "ns2", "ns2")
  call xml_NewElement(xf, "ns2:svg")
  call xml_DeclareNamespace(xf, "ns3", "ns3")
  call xml_NewElement(xf, "ns3:svg")
  call xml_DeclareNamespace(xf, "ns4", "ns4")
  call xml_NewElement(xf, "ns4:svg")
  call xml_DeclareNamespace(xf, "ns5", "ns5")
  call xml_NewElement(xf, "ns5:svg")
  call xml_DeclareNamespace(xf, "ns6", "ns6")
  call xml_NewElement(xf, "ns6:svg")
  call xml_DeclareNamespace(xf, "ns7", "ns7")
  call xml_NewElement(xf, "ns7:svg")
  call xml_DeclareNamespace(xf, "ns8", "ns8")
  call xml_NewElement(xf, "ns8:svg")
  call xml_DeclareNamespace(xf, "ns9", "ns9")
  call xml_NewElement(xf, "ns9:svg")
  call xml_DeclareNamespace(xf, "ns10", "ns10")
  call xml_NewElement(xf, "ns10:svg")
  call xml_DeclareNamespace(xf, "ns11", "ns11")
  call xml_NewElement(xf, "ns11:svg")

  call xml_Close(xf)

end program test

program test_sax_reader

  use m_sax_reader

  character(21) :: buf
  character :: c
  type(file_buffer_t) :: fb

  integer :: iostat

  call open_file(fb, file="test_sax_reader_11a.in", iostat=iostat)

  buf = get_characters(fb, 21, iostat) 

  c = get_next_character_discarding_whitespace(fb, iostat) 

  write(*,'(3a)') 'char:', c, ':'
  write(*,'(a,i0)') 'iost:', iostat

  call close_file(fb) 
  call open_file(fb, file="test_sax_reader_11b.in", iostat=iostat) 

  buf = get_characters(fb, 21, iostat) 

  c = get_next_character_discarding_whitespace(fb, iostat) 

  write(*,'(3a)') 'char:', c, ':'
  write(*,'(a,i0)') 'iost:', iostat

  call put_characters(fb, 10)

  c = get_next_character_discarding_whitespace(fb, iostat) 

  write(*,'(3a)') 'char:', c, ':'
  write(*,'(a,i0)') 'iost:', iostat

  call close_file(fb) 

end program test_sax_reader

program test

  use FoX_wxml, only : xmlf_t, xml_OpenFile, xml_Close
  use FoX_wxml, only : xml_NewElement
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  call xml_OpenFile(filename, xf)
  call xml_NewElement(xf, "toby:root")
  call xml_Close(xf)

end program test

module m_wcml_metadata

  use FoX_wxml, only: xmlf_t
#ifndef DUMMYLIB
  use FoX_wxml, only: xml_NewElement, xml_EndElement
  use FoX_wxml, only: xml_AddAttribute
#endif

  implicit none
  private

  public :: cmlAddMetadata

contains

   subroutine cmlAddMetadata(xf, name, content, convention, dictRef, id, title )
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: content
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title

#ifndef DUMMYLIB
    call xml_NewElement(xf, "metadata")
    call xml_AddAttribute(xf, "name", name)
    call xml_AddAttribute(xf, name="content", value=content  )
    if (present(dictref)) call xml_AddAttribute(xf, "dictRef", dictref)
    if (present(id)) call xml_AddAttribute(xf, "id", title)
    if (present(title)) call xml_AddAttribute(xf, "title", title)
    if (present(convention)) call xml_AddAttribute(xf, "convention", convention)
    call xml_EndElement(xf, "metadata")
#endif

   end subroutine cmlAddMetadata

end module m_wcml_metadata

program example_xml_program

  use example_xml_module

  implicit none

  call initialize_xml_output('XML output by FoX')

  call add_paragraph('This output file was produced by FoX.', italic=.false.)

  call add_paragraph('FoX is an XML output library written in Fortran', italic=.true.)

  call end_xml_output

end program example_xml_program

module FoX_common

  use m_common_attrs
  use m_common_format

  implicit none
  private

  character(len=*), parameter :: FoX_version = '2.1.1'

  public :: FoX_version

  public :: str
  public :: operator(//)

!These are all exported through SAX now
  public :: dictionary_t
!SAX functions
  public :: getIndex 
  public :: getLength
  public :: getLocalName
  public :: getQName
  public :: getURI
  public :: getValue
  public :: getType
!For convenience
  public :: len
  public :: hasKey

  public :: print_dict

end module FoX_common

 
 
! This file is AUTOGENERATED!!!!
! Do not edit this file; edit m_wcml_quantity.m4 and regenerate.
!
!
module m_wcml_parameter

  use m_common_realtypes, only: sp, dp
  use FoX_wxml, only: xmlf_t
  use FoX_wxml, only: xml_NewElement, xml_AddAttribute
  use FoX_wxml, only: xml_EndElement
  use m_wcml_stml, only: stmAddValue

  implicit none
  private

  interface cmlAddparameter
     module procedure parameterCmplxDpSca
     module procedure parameterCmplxDpArrSi
     module procedure parameterCmplxDpArrSh
     module procedure parameterCmplxDpMatSi
     module procedure parameterCmplxDpMatSh
     module procedure parameterCmplxSpSca
     module procedure parameterCmplxSpArrSi
     module procedure parameterCmplxSpArrSh
     module procedure parameterCmplxSpMatSi
     module procedure parameterCmplxSpMatSh
     module procedure parameterRealDpSca
     module procedure parameterRealDpArrSi
     module procedure parameterRealDpArrSh
     module procedure parameterRealDpMatSi
     module procedure parameterRealDpMatSh
     module procedure parameterRealSpSca
     module procedure parameterRealSpArrSi
     module procedure parameterRealSpArrSh
     module procedure parameterRealSpMatSi
     module procedure parameterRealSpMatSh
     module procedure parameterIntSca
     module procedure parameterIntArrSi
     module procedure parameterIntArrSh
     module procedure parameterIntMatSi
     module procedure parameterIntMatSh
     module procedure parameterLgSca
     module procedure parameterLgArrSi
     module procedure parameterLgArrSh
     module procedure parameterLgMatSi
     module procedure parameterLgMatSh
     module procedure parameterChSca
     module procedure parameterChArrSi
     module procedure parameterChArrSh
     module procedure parameterChMatSi
     module procedure parameterChMatSh

  end interface cmlAddparameter

  public :: cmlAddparameter

contains

  subroutine parameterCmplxDpSca &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in)   :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterCmplxDpSca

  subroutine parameterCmplxSpSca &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in)   :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterCmplxSpSca

  subroutine parameterRealDpSca &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in)   :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterRealDpSca

  subroutine parameterRealSpSca &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in)   :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterRealSpSca

  subroutine parameterIntSca &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in)   :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterIntSca

  subroutine parameterLgSca &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in)   :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role


    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterLgSca

  subroutine parameterChSca &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in)   :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterChSca


  subroutine parameterCmplxDpArrSi &
    (xf, value,nitems,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterCmplxDpArrSi

  subroutine parameterCmplxSpArrSi &
    (xf, value,nitems,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterCmplxSpArrSi

  subroutine parameterRealDpArrSi &
    (xf, value,nitems,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterRealDpArrSi

  subroutine parameterRealSpArrSi &
    (xf, value,nitems,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterRealSpArrSi

  subroutine parameterIntArrSi &
    (xf, value,nitems,  ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterIntArrSi

  subroutine parameterLgArrSi &
    (xf, value,nitems,  ref, title, id, convention, dictRef, constraint, name, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role


    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems))
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterLgArrSi

  subroutine parameterChArrSi &
    (xf, value,nitems,  ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:)  :: value
    integer, intent(in) :: nitems
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nitems), units=units)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterChArrSi


  subroutine parameterCmplxDpArrSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterCmplxDpArrSh

  subroutine parameterCmplxSpArrSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterCmplxSpArrSh

  subroutine parameterRealDpArrSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterRealDpArrSh

  subroutine parameterRealSpArrSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterRealSpArrSh

  subroutine parameterIntArrSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterIntArrSh

  subroutine parameterLgArrSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role


    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterLgArrSh

  subroutine parameterChArrSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterChArrSh


  subroutine parameterCmplxDpMatSi &
    (xf, value,nrows, ncols,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterCmplxDpMatSi

  subroutine parameterCmplxSpMatSi &
    (xf, value,nrows, ncols,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterCmplxSpMatSi

  subroutine parameterRealDpMatSi &
    (xf, value,nrows, ncols,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterRealDpMatSi

  subroutine parameterRealSpMatSi &
    (xf, value,nrows, ncols,  ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterRealSpMatSi

  subroutine parameterIntMatSi &
    (xf, value,nrows, ncols,  ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterIntMatSi

  subroutine parameterLgMatSi &
    (xf, value,nrows, ncols,  ref, title, id, convention, dictRef, constraint, name, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role


    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols))
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterLgMatSi

  subroutine parameterChMatSi &
    (xf, value,nrows, ncols,  ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:,:)  :: value
    integer, intent(in) :: nrows
    integer, intent(in) :: ncols
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value(:nrows, :ncols), units=units)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterChMatSi


  subroutine parameterCmplxDpMatSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(dp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterCmplxDpMatSh

  subroutine parameterCmplxSpMatSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    complex(sp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterCmplxSpMatSh

  subroutine parameterRealDpMatSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(dp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterRealDpMatSh

  subroutine parameterRealSpMatSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units, fmt)

    type(xmlf_t), intent(inout)              :: xf
    real(sp), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units
    character(len=*), intent(in), optional :: fmt

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units, fmt=fmt)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterRealSpMatSh

  subroutine parameterIntMatSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    integer, intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in)   :: units

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterIntMatSh

  subroutine parameterLgMatSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role)

    type(xmlf_t), intent(inout)              :: xf
    logical, intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role


    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterLgMatSh

  subroutine parameterChMatSh &
    (xf, value, ref, title, id, convention, dictRef, constraint, name, role, units)

    type(xmlf_t), intent(inout)              :: xf
    character(len=*), intent(in) , dimension(:,:)  :: value
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: constraint
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role

    character(len=*), intent(in) , optional  :: units

    call xml_NewElement(xf, "parameter")
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(constraint)) call xml_addAttribute(xf, "constraint", constraint)
    if (present(name)) call xml_addAttribute(xf, "name", name)
    if (present(role)) call xml_addAttribute(xf, "role", role)

    call stmAddValue(xf=xf, value=value, units=units)
    call xml_EndElement(xf, "parameter")
 
  end subroutine parameterChMatSh


end module m_wcml_parameter

program test_sax_reader

  use m_sax_reader

  type(file_buffer_t) :: fb

  integer :: iostat
  character(3) :: c

  call open_file(fb, file="test_sax_reader_2.in", iostat=iostat)

  c = read_chars(fb, 3, iostat)
  write(*,'(2a)') 'char:', c
  write(*,'(a,i0)') 'iost:', iostat

  call close_file(fb) 

end program test_sax_reader

module m_sax_parser

  use m_common_array_str, only: str_vs, string_list, &
    destroy_string_list, vs_str_alloc
  use m_common_attrs, only: init_dict, destroy_dict, reset_dict, &
    add_item_to_dict, has_key, get_value
  use m_common_charset, only: XML_WHITESPACE, allowed_encoding
  use m_common_element, only: element_t, existing_element, add_element, &
    get_element, parse_dtd_element, parse_dtd_attlist, report_declarations, &
    get_att_type, get_default_atts, declared_element, ATT_CDATA
  use m_common_elstack, only: push_elstack, pop_elstack, init_elstack, &
    destroy_elstack, is_empty, len, get_top_elstack
  use m_common_entities, only: existing_entity, init_entity_list, &
    destroy_entity_list, add_internal_entity, &
    is_external_entity, expand_entity, expand_char_entity, &
    is_unparsed_entity, pop_entity_list, size, &
    getEntityTextByIndex, getEntityNameByIndex, getEntityNotationByIndex
  use m_common_entity_expand, only: expand_entity_value_alloc
  use m_common_error, only: FoX_error, add_error, &
    init_error_stack, destroy_error_stack, in_error
  use m_common_io, only: io_eof, io_err
  use m_common_namecheck, only: checkName, checkPublicId, &
    checkCharacterEntityReference, likeCharacterEntityReference, &
    checkQName, checkNCName, checkPITarget, resolveSystemId, &
    checkRepCharEntityReference
  use m_common_namespaces, only: getnamespaceURI, invalidNS, &
    checkNamespaces, checkEndNamespaces, namespaceDictionary, &
    initNamespaceDictionary, destroyNamespaceDictionary
  use m_common_notations, only: init_notation_list, destroy_notation_list, &
    add_notation, notation_exists
  use m_common_struct, only: init_xml_doc_state, &
    destroy_xml_doc_state, register_internal_PE, register_external_PE, &
    register_internal_GE, register_external_GE

  use m_sax_reader, only: file_buffer_t, pop_buffer_stack, push_buffer_stack
  use m_sax_tokenizer, only: sax_tokenize, parse_xml_declaration, normalize_text
  use m_sax_types ! everything, really

  implicit none
  private

  public :: getNSDict

  public :: sax_parser_init
  public :: sax_parser_destroy
  public :: sax_parse

contains

  function getNSDict(fx) result(ns)
    type(sax_parser_t), target :: fx
    type(namespaceDictionary), pointer :: ns

    ns => fx%nsDict
  end function getNSDict

  subroutine sax_parser_init(fx, filename)
    type(sax_parser_t), intent(out) :: fx
    character(len=*), intent(in) :: filename

    allocate(fx%token(0))

    call init_error_stack(fx%error_stack)
    call init_elstack(fx%elstack)
    call init_dict(fx%attributes)

    call initNamespaceDictionary(fx%nsdict)
    call init_notation_list(fx%nlist)
    allocate(fx%xds)
    call init_xml_doc_state(fx%xds)
    deallocate(fx%xds%inputEncoding)
    fx%xds%inputEncoding => vs_str_alloc("us-ascii")
    ! because it always is ...
    fx%xds%documentURI => vs_str_alloc(filename)

    allocate(fx%wf_stack(1))
    fx%wf_stack(1) = 0
    call init_entity_list(fx%forbidden_ge_list)
    call init_entity_list(fx%forbidden_pe_list)
    call init_entity_list(fx%predefined_e_list)

    call add_internal_entity(fx%predefined_e_list, 'amp', '&')
    call add_internal_entity(fx%predefined_e_list, 'lt', '<')
    call add_internal_entity(fx%predefined_e_list, 'gt', '>')
    call add_internal_entity(fx%predefined_e_list, 'apos', "'")
    call add_internal_entity(fx%predefined_e_list, 'quot', '"')
  end subroutine sax_parser_init

  subroutine sax_parser_destroy(fx)
    type(sax_parser_t), intent(inout) :: fx

    fx%context = CTXT_NULL
    fx%state = ST_NULL

    if (associated(fx%token)) deallocate(fx%token)
    if (associated(fx%root_element)) deallocate(fx%root_element)

    call destroy_error_stack(fx%error_stack)
    call destroy_elstack(fx%elstack)
    call destroy_dict(fx%attributes)
    call destroyNamespaceDictionary(fx%nsdict)
    call destroy_notation_list(fx%nlist)
    if (.not.fx%xds_used) then
      call destroy_xml_doc_state(fx%xds)
      deallocate(fx%xds)
    endif

    deallocate(fx%wf_stack)
    call destroy_entity_list(fx%forbidden_ge_list)
    call destroy_entity_list(fx%forbidden_pe_list)
    call destroy_entity_list(fx%predefined_e_list)

    if (associated(fx%token)) deallocate(fx%token)
    if (associated(fx%next_token)) deallocate(fx%next_token)
    if (associated(fx%name)) deallocate(fx%name)
    if (associated(fx%attname)) deallocate(fx%attname)
    if (associated(fx%publicId)) deallocate(fx%publicId)
    if (associated(fx%systemId)) deallocate(fx%systemId)
    if (associated(fx%Ndata)) deallocate(fx%Ndata)

  end subroutine sax_parser_destroy

  recursive subroutine sax_parse(fx, fb, &
! org.xml.sax
! SAX ContentHandler
    characters_handler,            &
    endDocument_handler,           &
    endElement_handler,            &
    endPrefixMapping_handler,      &
    ignorableWhitespace_handler,   &
    processingInstruction_handler, &
    ! setDocumentLocator
    skippedEntity_handler,         &
    startDocument_handler,         & 
    startElement_handler,          &
    startPrefixMapping_handler,    &
! SAX DTDHandler
    notationDecl_handler,          &
    unparsedEntityDecl_handler,    &
! SAX ErrorHandler
    error_handler,                 &
    fatalError_handler,            &
    warning_handler,               &
! org.xml.sax.ext
! SAX DeclHandler
    attributeDecl_handler,         &
    elementDecl_handler,           &
    externalEntityDecl_handler,    &
    internalEntityDecl_handler,    &
! SAX LexicalHandler
    comment_handler,               &
    endCdata_handler,              &
    endDTD_handler,                &
    endEntity_handler,             &
    startCdata_handler,            &
    startDTD_handler,              &
    startEntity_handler,           &
    namespaces,                    &
    namespace_prefixes,            &
    xmlns_uris,                    &
    validate,                      &
    FoX_endDTD_handler,            &
    startInCharData,               &
    initial_entities)

    type(sax_parser_t), intent(inout) :: fx
    type(file_buffer_t), intent(inout) :: fb
    optional :: characters_handler
    optional :: endDocument_handler
    optional :: endElement_handler
    optional :: endPrefixMapping_handler
    optional :: ignorableWhitespace_handler
    optional :: processingInstruction_handler
    optional :: skippedEntity_handler
    optional :: startElement_handler
    optional :: startDocument_handler
    optional :: startPrefixMapping_handler
    optional :: notationDecl_handler
    optional :: unparsedEntityDecl_handler
    optional :: error_handler
    optional :: fatalError_handler
    optional :: warning_handler
    optional :: attributeDecl_handler
    optional :: elementDecl_handler
    optional :: externalEntityDecl_handler
    optional :: internalEntityDecl_handler
    optional :: comment_handler
    optional :: endCdata_handler
    optional :: endEntity_handler
    optional :: endDTD_handler
    optional :: FoX_endDTD_handler
    optional :: startCdata_handler
    optional :: startDTD_handler
    optional :: startEntity_handler

    logical, intent(in), optional :: namespaces
    logical, intent(in), optional :: namespace_prefixes
    logical, intent(in), optional :: xmlns_uris

    logical, intent(in), optional :: validate
    logical, intent(in), optional :: startInCharData

    type(entity_list), optional :: initial_entities

    interface

      subroutine characters_handler(chunk)
        character(len=*), intent(in) :: chunk
      end subroutine characters_handler

      subroutine endDocument_handler()     
      end subroutine endDocument_handler

      subroutine endElement_handler(namespaceURI, localName, name)
        character(len=*), intent(in)     :: namespaceURI
        character(len=*), intent(in)     :: localName
        character(len=*), intent(in)     :: name
      end subroutine endElement_handler
      
      subroutine endPrefixMapping_handler(prefix)
        character(len=*), intent(in) :: prefix
      end subroutine endPrefixMapping_handler

      subroutine ignorableWhitespace_handler(chars)
        character(len=*), intent(in) :: chars
      end subroutine ignorableWhitespace_handler

      subroutine processingInstruction_handler(name, content)
        character(len=*), intent(in)     :: name
        character(len=*), intent(in)     :: content
      end subroutine processingInstruction_handler

      subroutine skippedEntity_handler(name)
        character(len=*), intent(in) :: name
      end subroutine skippedEntity_handler

      subroutine startDocument_handler()   
      end subroutine startDocument_handler

      subroutine startElement_handler(namespaceURI, localName, name, attributes)
        use FoX_common
        character(len=*), intent(in)     :: namespaceUri
        character(len=*), intent(in)     :: localName
        character(len=*), intent(in)     :: name
        type(dictionary_t), intent(in)   :: attributes
      end subroutine startElement_handler

      subroutine startPrefixMapping_handler(namespaceURI, prefix)
        character(len=*), intent(in) :: namespaceURI
        character(len=*), intent(in) :: prefix
      end subroutine startPrefixMapping_handler

      subroutine notationDecl_handler(name, publicId, systemId)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: publicId
        character(len=*), intent(in) :: systemId
      end subroutine notationDecl_handler

      subroutine unparsedEntityDecl_handler(name, publicId, systemId, notation)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: publicId
        character(len=*), intent(in) :: systemId
        character(len=*), intent(in) :: notation
      end subroutine unparsedEntityDecl_handler

      subroutine error_handler(msg)
        character(len=*), intent(in)     :: msg
      end subroutine error_handler

      subroutine fatalError_handler(msg)
        character(len=*), intent(in)     :: msg
      end subroutine fatalError_handler
      
      subroutine warning_handler(msg)
        character(len=*), intent(in)     :: msg
      end subroutine warning_handler

      subroutine attributeDecl_handler(eName, aName, type, mode, value)
        character(len=*), intent(in) :: eName
        character(len=*), intent(in) :: aName
        character(len=*), intent(in) :: type
        character(len=*), intent(in), optional :: mode
        character(len=*), intent(in), optional :: value
      end subroutine attributeDecl_handler

      subroutine elementDecl_handler(name, model)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: model
      end subroutine elementDecl_handler

      subroutine externalEntityDecl_handler(name, publicId, systemId)
        character(len=*), intent(in) :: name
        character(len=*), optional, intent(in) :: publicId
        character(len=*), intent(in) :: systemId
      end subroutine externalEntityDecl_handler

      subroutine internalEntityDecl_handler(name, value)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: value
      end subroutine internalEntityDecl_handler

      subroutine comment_handler(comment)
        character(len=*), intent(in) :: comment
      end subroutine comment_handler

      subroutine endCdata_handler()
      end subroutine endCdata_handler

      subroutine endDTD_handler()
      end subroutine endDTD_handler

      subroutine FoX_endDTD_handler(state)
        use m_common_struct, only: xml_doc_state
        type(xml_doc_state), pointer :: state
      end subroutine FoX_endDTD_handler

      subroutine endEntity_handler(name)
        character(len=*), intent(in) :: name
      end subroutine endEntity_handler

      subroutine startCdata_handler()
      end subroutine startCdata_handler

      subroutine startDTD_handler(name, publicId, systemId)
        character(len=*), intent(in) :: name
        character(len=*), intent(in) :: publicId
        character(len=*), intent(in) :: systemId
      end subroutine startDTD_handler

      subroutine startEntity_handler(name)
        character(len=*), intent(in) :: name
      end subroutine startEntity_handler

    end interface

    logical :: validCheck, startInCharData_, processDTD, pe, nameOK
    logical :: namespaces_, namespace_prefixes_, xmlns_uris_
    integer :: i, iostat, temp_i
    character, pointer :: tempString(:)
    character :: dummy
    type(element_t), pointer :: elem
    integer, pointer :: temp_wf_stack(:)

    nullify(tempString)
    nullify(elem)

! FIXME we don't do anything with the namespaces option at present
    if (present(namespaces)) then
      namespaces_ = namespaces
    else
      namespaces_ = .true.
    endif
    if (present(namespace_prefixes)) then
      namespace_prefixes_ = namespace_prefixes
    else
      namespace_prefixes_ = .false.
    endif
    if (present(xmlns_uris)) then
      xmlns_uris_ = xmlns_uris
    else
      xmlns_uris_ = .false.
    endif
    if (present(validate)) then
      validCheck = validate
    else
      validCheck = .false.
    endif
    if (present(startInCharData)) then
      startInCharData_ = startInCharData
    else
      startInCharData_ = .false.
    endif
    if (present(initial_entities)) then
      do i = 1, size(initial_entities)
        if (.not.is_external_entity(initial_entities, getEntityNameByIndex(initial_entities, i))) &
          call register_internal_PE(fx%xds, getEntityNameByIndex(initial_entities, i), getEntityTextByIndex(initial_entities, i))
      enddo
    endif

    processDTD = .true.
    iostat = 0

    if (startInCharData_) then
      fx%context = CTXT_IN_CONTENT
      fx%state = ST_CHAR_IN_CONTENT
      fx%whitespace = WS_PRESERVE
      fx%well_formed = .true.
    elseif (fx%parse_stack==0) then
      call parse_xml_declaration(fx, fb, iostat)
      if (iostat/=0) then
        call add_error(fx%error_stack, "Error in XML declaration")
      elseif (.not.allowed_encoding(str_vs(fx%xds%encoding))) then
        call add_error(fx%error_stack, "Unknown character encoding in XML declaration")
      endif
      if (in_error(fx%error_stack)) then ! double check since we might be in error, but iostat==0
        call sax_error(fx, error_handler)
        return
      endif
      fx%context = CTXT_BEFORE_DTD
      fx%state = ST_MISC
      fx%whitespace = WS_DISCARD
      if (present(startDocument_handler)) &
        call startDocument_handler()
    endif

    do

      call sax_tokenize(fx, fb, iostat)
      if (in_error(fx%error_stack)) iostat = io_err
      if (iostat==io_eof.and.fx%parse_stack>0) then
        if (fx%context==CTXT_IN_DTD) then
          ! that's just the end of a parameter entity expansion.
          ! pop the parse stack, and carry on ..
          if (present(endEntity_handler)) then
            call endEntity_handler('%'//pop_entity_list(fx%forbidden_pe_list))
          else
            dummy = pop_entity_list(fx%forbidden_pe_list)
          endif
        elseif (fx%context==CTXT_IN_CONTENT) then
          if (fx%state==ST_TAG_IN_CONTENT) fx%state = ST_CHAR_IN_CONTENT
          ! because CHAR_IN_CONTENT *always* leads to TAG_IN_CONTENT
          ! *except* when it is the end of an entity expansion
          ! it's the end of a general entity expansion
          if (present(endEntity_handler)) then
            call endEntity_handler(pop_entity_list(fx%forbidden_ge_list))
          else
             dummy = pop_entity_list(fx%forbidden_ge_list)
          endif
          if (fx%state/=ST_CHAR_IN_CONTENT.or.fx%wf_stack(1)/=0) then
            call add_error(fx%error_stack, 'Ill-formed entity')
            goto 100
          endif
          temp_wf_stack => fx%wf_stack
          allocate(fx%wf_stack(size(temp_wf_stack)-1))
          fx%wf_stack = temp_wf_stack(2:size(temp_wf_stack))
          deallocate(temp_wf_stack)
        endif
        iostat = 0
        call pop_buffer_stack(fb)
        fx%parse_stack = fx%parse_stack - 1
        cycle
      elseif (iostat/=0) then
        ! Any other error, we want to quit sax_tokenizer
        call add_error(fx%error_stack, 'Error getting token')
        goto 100
      endif
      if (.not.associated(fx%token)) then
        call add_error(fx%error_stack, 'Internal error! No token found!')
        goto 100
      endif

      select case (fx%state)

      case (ST_MISC)
        !write(*,*) 'ST_MISC', str_vs(fx%token)
        if (str_vs(fx%token) == '<?') then
          fx%state = ST_START_PI
          fx%whitespace = WS_FORBIDDEN
        elseif (str_vs(fx%token) ==  '<!') then
          fx%state = ST_BANG_TAG
          fx%whitespace = WS_FORBIDDEN
        elseif (str_vs(fx%token) == '<') then
          fx%state = ST_START_TAG
          fx%whitespace = WS_FORBIDDEN
        else
          call add_error(fx%error_stack, "Unexpected token found outside content")
          goto 100
        endif

      case (ST_BANG_TAG)
        !write(*,*)'ST_BANG_TAG'
        if (str_vs(fx%token)=='--') then
          fx%state = ST_START_COMMENT
        elseif (fx%context==CTXT_BEFORE_DTD) then
          if (str_vs(fx%token)=='DOCTYPE') then
            fx%whitespace = WS_MANDATORY
            fx%context = CTXT_IN_DTD
            fx%state = ST_IN_DTD
          endif
        elseif (fx%context==CTXT_IN_CONTENT) then
          if (str_vs(fx%token)=='[') then
            fx%state = ST_START_CDATA_1
          endif
        elseif (fx%context==CTXT_IN_DTD) then  
          if (str_vs(fx%token)=='ATTLIST') then
            fx%state = ST_DTD_ATTLIST
          elseif (str_vs(fx%token)=='ELEMENT') then
            fx%state = ST_DTD_ELEMENT
          elseif (str_vs(fx%token)=='ENTITY') then
            fx%state = ST_DTD_ENTITY
          elseif (str_vs(fx%token)=='NOTATION') then
            fx%state = ST_DTD_NOTATION
          endif
          fx%whitespace = WS_MANDATORY
        else
          call add_error(fx%error_stack, "Unexpected token after !")
          goto 100
        endif

      case (ST_START_PI)
        !write(*,*)'ST_START_PI'
        if (namespaces_) then
          nameOk = checkNCName(str_vs(fx%token), fx%xds)
        else
          nameOk = checkName(str_vs(fx%token), fx%xds)
        endif
        if (nameOk) then
          if (str_vs(fx%token)=='xml') then
            call add_error(fx%error_stack, "XML declaration must be at start of document")
            goto 100
          elseif (checkPITarget(str_vs(fx%token), fx%xds)) then
            fx%whitespace = WS_MANDATORY
            fx%state = ST_PI_CONTENTS
            fx%name => fx%token
            nullify(fx%token)
          else
            call add_error(fx%error_stack, "Invalid PI target name")
            goto 100
          endif
        else
          call add_error(fx%error_stack, "Unexpected token found for PI target; expecting Name")
          goto 100
        endif

      case (ST_PI_CONTENTS)
        !write(*,*)'ST_PI_CONTENTS'
        if (validCheck.and.len(fx%elstack)>0) then
          elem => get_element(fx%xds%element_list, get_top_elstack(fx%elstack))
          if (associated(elem)) then
            if (elem%empty) then
              call add_error(fx%error_stack, "Content inside empty element")
            endif
          endif
        endif
        if (str_vs(fx%token)=='?>') then
          ! No data for this PI
          if (present(processingInstruction_handler)) &
            call processingInstruction_handler(str_vs(fx%name), '')
          deallocate(fx%name)
          if (fx%context==CTXT_IN_CONTENT) then
            fx%state = ST_CHAR_IN_CONTENT
          else
            fx%whitespace = WS_DISCARD
            fx%state = ST_MISC
          endif
        else
          if (present(processingInstruction_handler)) &
            call processingInstruction_handler(str_vs(fx%name), str_vs(fx%token))
          deallocate(fx%name)
          fx%state = ST_PI_END
        endif

      case (ST_PI_END)
        !write(*,*)'ST_PI_END'
        if (str_vs(fx%token)=='?>') then
          if (fx%context==CTXT_IN_CONTENT) then
            fx%state = ST_CHAR_IN_CONTENT
            fx%whitespace = WS_PRESERVE
          elseif (fx%context==CTXT_IN_DTD) then
            fx%state = ST_INT_SUBSET
            fx%whitespace = WS_DISCARD
          else
            fx%state = ST_MISC
            fx%whitespace = WS_DISCARD
          endif
        else
          call add_error(fx%error_stack, "Internal error: unexpected token at end of PI, expecting ?>")
          goto 100
        endif

      case (ST_START_COMMENT)
        !write(*,*)'ST_START_COMMENT'
        fx%name => fx%token
        nullify(fx%token)
        fx%state = ST_COMMENT_END_1

      case (ST_COMMENT_END_1)
        !write(*,*)'ST_COMMENT_END_1'
        if (str_vs(fx%token)=='--') then
          fx%state = ST_COMMENT_END_2
        else
          call add_error(fx%error_stack, "Internal error: expecting --")
          goto 100
        endif

      case (ST_COMMENT_END_2)
        !write(*,*)'ST_COMMENT_END_2'
        if (str_vs(fx%token)=='>') then
          if (validCheck.and.len(fx%elstack)>0) then
            elem => get_element(fx%xds%element_list, get_top_elstack(fx%elstack))
            if (associated(elem)) then
              if (elem%empty) then
                call add_error(fx%error_stack, "Content inside empty element")
              endif
            endif
          endif
          if (present(comment_handler)) &
            call comment_handler(str_vs(fx%name))
          deallocate(fx%name)
          if (fx%context==CTXT_IN_CONTENT) then
            fx%state = ST_CHAR_IN_CONTENT
            fx%whitespace = WS_PRESERVE
          elseif (fx%context==CTXT_IN_DTD) then
            fx%state = ST_INT_SUBSET
            fx%whitespace = WS_DISCARD
          else
            fx%state = ST_MISC
            fx%whitespace = WS_DISCARD
          endif
        else
          call add_error(fx%error_stack, "Expecting > after -- in comment")
          goto 100
        endif

      case (ST_START_TAG)
        !write(*,*)'ST_START_TAG', fx%context
        if (fx%context==CTXT_BEFORE_DTD &
          .or. fx%context==CTXT_BEFORE_CONTENT &
          .or. fx%context==CTXT_IN_CONTENT) then
          fx%name => fx%token
          nullify(fx%token)
          ! FIXME check name is name? ought to be.
          fx%whitespace = WS_MANDATORY
          fx%state = ST_IN_TAG
        elseif (fx%context == CTXT_AFTER_CONTENT) then
          call add_error(fx%error_stack, "Cannot open second root element")
          goto 100
        elseif (fx%context == CTXT_IN_DTD) then
          call add_error(fx%error_stack, "Cannot open root element before DTD is finished")
          goto 100
        endif

      case (ST_START_CDATA_1)
        !write(*,*)'ST_START_CDATA_1'
        if (str_vs(fx%token) == 'CDATA') then
          fx%state = ST_START_CDATA_2
          fx%whitespace = WS_FORBIDDEN
        else
          call add_error(fx%error_stack, "Unexpected token found - expecting CDATA afte <![")
          goto 100
        endif

      case (ST_START_CDATA_2)
        !write(*,*)'ST_START_CDATA_2'
        if (str_vs(fx%token) == '[') then
          fx%state = ST_CDATA_CONTENTS
        else
          call add_error(fx%error_stack, "Unexpected token found - expecting [ after CDATA")
          goto 100
        endif

      case (ST_CDATA_CONTENTS)
        !write(*,*)'ST_CDATA_CONTENTS'
        fx%name => fx%token
        nullify(fx%token)
        fx%state = ST_CDATA_END

      case (ST_CDATA_END)
        !write(*,*)'ST_CDATA_END'
        if (validCheck) then
          elem => get_element(fx%xds%element_list, get_top_elstack(fx%elstack))
          if (associated(elem)) then
            if (elem%empty) then
              call add_error(fx%error_stack, "Content inside empty element")
              goto 100
            elseif (.not.elem%mixed.and..not.elem%any) then
              ! NB even whitespace-only CDATA section forbidden
              ! FIXME but is an empty CDATA section allowed?
              call add_error(fx%error_stack, "Forbidden content inside element")
              goto 100
            endif
          endif
        endif
        if (str_vs(fx%token) == ']]>') then
          if (present(startCdata_handler)) &
            call startCdata_handler
          if (size(fx%name)>0) then
            if (present(characters_handler)) &
              call characters_handler(str_vs(fx%name))
          endif
          if (present(endCdata_handler)) &
            call endCdata_handler
          deallocate(fx%name)
          fx%state = ST_CHAR_IN_CONTENT
        else
          call add_error(fx%error_stack, "Internal error, unexpected token in CDATA")
          goto 100
        endif

      case (ST_IN_TAG)
        !write(*,*)'ST_IN_TAG'
        if (str_vs(fx%token)=='>') then
          if (fx%context /= CTXT_IN_CONTENT) then
            if (associated(fx%root_element)) then
              if (validCheck) then
                if (str_vs(fx%name)/=str_vs(fx%root_element)) then
                  call add_error(fx%error_stack, "Root element name does not match document name")
                  goto 100
                endif
              endif
              deallocate(fx%root_element)
            elseif (validCheck) then
              call add_error(fx%error_stack, "No DTD defined")
              goto 100
            endif
            ! This is the root node, so we've finished populating
            ! the xml_doc_state. Hand it over to DOM if necessary:
            ! Here we hand over responsibility for the xds object
            ! The SAX caller must take care of it, and we don't
            ! need it any more. (We will destroy it shortly anyway)
            if (present(FoX_endDTD_handler)) then
              fx%xds_used = .true.
              call FoX_endDTD_handler(fx%xds)
            endif
            fx%context = CTXT_IN_CONTENT
          endif
          call open_tag
          if (in_error(fx%error_stack)) goto 100
          deallocate(fx%name)
          fx%state = ST_CHAR_IN_CONTENT

        elseif (str_vs(fx%token)=='/>') then
          if (fx%context==CTXT_IN_CONTENT) then
            fx%state = ST_CHAR_IN_CONTENT
          else
            ! only a single element in this doc
            if (associated(fx%root_element)) then
              if (validCheck) then
                if (str_vs(fx%name)/=str_vs(fx%root_element)) then
                  call add_error(fx%error_stack, "Root element name does not match document name")
                  goto 100
                endif
              endif
              deallocate(fx%root_element)
            elseif (validCheck) then
              call add_error(fx%error_stack, "No DTD defined")
              goto 100
            endif
            ! This is the root node, so we've finished populating
            ! the xml_doc_state. Hand it over to DOM if necessary:
            ! Here we hand over responsibility for the xds object
            ! The SAX caller must take care of it, and we don't
            ! need it any more. (We will destroy it shortly anyway)
            if (present(FoX_endDTD_handler)) then
              fx%xds_used = .true.
              call FoX_endDTD_handler(fx%xds)
            endif
          endif
          call open_tag
          if (in_error(fx%error_stack)) goto 100
          call close_tag
          if (in_error(fx%error_stack)) goto 100
          deallocate(fx%name)
          if (fx%context==CTXT_IN_CONTENT) then
            fx%whitespace = WS_PRESERVE
          else
            fx%well_formed = .true.
            fx%context = CTXT_AFTER_CONTENT
            fx%state = ST_MISC
            fx%whitespace = WS_DISCARD
          endif
        else
          ! FIXME It should be an XML name for the attribute
          ! pick up that it is a name:
          fx%attname => fx%token
          nullify(fx%token)
          fx%state = ST_ATT_NAME
          fx%whitespace = WS_DISCARD
        endif

      case (ST_ATT_NAME)
        !write(*,*)'ST_ATT_NAME'
        if (str_vs(fx%token)=='=') then
          fx%state = ST_ATT_EQUALS
        else
          call add_error(fx%error_stack, "Unexpected token in tag - expected =")
          goto 100
        endif

      case (ST_ATT_EQUALS)
        !write(*,*)'ST_ATT_EQUALS'
        ! token is pre-processed attribute value.
        ! fx%name still contains attribute name
        if (namespaces_) then
          nameOk = checkQName(str_vs(fx%attname), fx%xds)
        else
          nameOk = checkName(str_vs(fx%attname), fx%xds)
        endif
        if (.not.nameOk) then
          call add_error(fx%error_stack, "Invalid attribute name")
          goto 100
        endif
        !Have we already had this dictionary item?
        if (has_key(fx%attributes, str_vs(fx%attname))) then
          call add_error(fx%error_stack, "Duplicate attribute name")
          goto 100
        endif
        !If this attribute is not CDATA, we must process further;
        temp_i = get_att_type(fx%xds%element_list, str_vs(fx%name), str_vs(fx%attname))
        if (temp_i==ATT_CDATA) then
          call add_item_to_dict(fx%attributes, str_vs(fx%attname), &
            str_vs(fx%token), itype=ATT_CDATA)
        else
          call add_item_to_dict(fx%attributes, str_vs(fx%attname), &
            trim(NotCDataNormalize(str_vs(fx%token))), itype=temp_i)
        endif
        deallocate(fx%attname)
        fx%state = ST_IN_TAG

      case (ST_CHAR_IN_CONTENT)
        !write(*,*)'ST_CHAR_IN_CONTENT'
        if (index(str_vs(fx%token),']]>')/=0) then
          call add_error(fx%error_stack, "Cannot have ]]> in character context")
          goto 100
        endif
        if (size(fx%token)>0) then
          if (validCheck) then
            elem => get_element(fx%xds%element_list, get_top_elstack(fx%elstack))
            if (associated(elem)) then
              if (elem%empty) then
                call add_error(fx%error_stack, "Content inside empty element")
              elseif (.not.elem%mixed.and..not.elem%any) then
                if (verify(str_vs(fx%token), XML_WHITESPACE)==0) then
                  if (present(ignorableWhitespace_handler)) &
                  call ignorableWhitespace_handler(str_vs(fx%token))
                else
                  call add_error(fx%error_stack, "Forbidden content inside element: "//get_top_elstack(fx%elstack))
                  goto 100
                endif
              else ! FIXME check properly if allowed
                if (present(characters_handler)) call characters_handler(str_vs(fx%token))
              endif
            endif
          else
            if (present(characters_handler)) call characters_handler(str_vs(fx%token))
          endif
        endif
        fx%whitespace = WS_FORBIDDEN
        fx%state = ST_TAG_IN_CONTENT

      case (ST_TAG_IN_CONTENT)
        !write(*,*)'ST_TAG_IN_CONTENT', str_vs(fx%token)
        if (str_vs(fx%token)=='<') then
          fx%state = ST_START_TAG
        elseif (str_vs(fx%token)=='<!') then
          fx%state = ST_BANG_TAG
        elseif (str_vs(fx%token)=='<?') then
          fx%state = ST_START_PI
        elseif (str_vs(fx%token)=='</') then
          fx%state = ST_CLOSING_TAG
        elseif (fx%token(1)=='&') then
          tempString => vs_str_alloc(str_vs(fx%token(2:size(fx%token)-1)))
          elem => get_element(fx%xds%element_list, get_top_elstack(fx%elstack))
          ! tell tokenizer to expand it
          if (existing_entity(fx%forbidden_ge_list, str_vs(tempString))) then
            call add_error(fx%error_stack, 'Recursive entity reference')
            goto 100
          endif
          if (existing_entity(fx%predefined_e_list, str_vs(tempString))) then
            if (validCheck.and.associated(elem)) then
              if (.not.elem%mixed.and..not.elem%any) then
                call add_error(fx%error_stack, "Forbidden content inside element")
                goto 100
              endif
            endif
            if (present(startEntity_handler)) &
              call startEntity_handler(str_vs(tempString))
            if (present(characters_handler)) &
              call characters_handler(expand_entity(fx%predefined_e_list, str_vs(tempString)))
            if (present(endEntity_handler)) &
              call endEntity_handler(str_vs(tempString))
          elseif (likeCharacterEntityReference(str_vs(tempString))) then
            if (checkRepCharEntityReference(str_vs(tempString), fx%xds%xml_version)) then
              if (validCheck.and.associated(elem)) then
                if (elem%empty) then
                  call add_error(fx%error_stack, "Forbidden content inside element")
                  goto 100
                elseif (.not.elem%mixed.and..not.elem%any) then
                  call add_error(fx%error_stack, "Forbidden content inside element")
                  goto 100 
                endif
              endif
              if (present(characters_handler)) &
                call characters_handler(expand_char_entity(str_vs(tempString)))
            elseif (checkCharacterEntityReference(str_vs(tempString), fx%xds%xml_version)) then
              call add_error(fx%error_stack, "Unable to digest character entity reference in content, sorry.")
              goto 100
            else
              call add_error(fx%error_stack, "Illegal character reference")
              goto 100
            endif
          elseif (existing_entity(fx%xds%entityList, str_vs(tempString))) then
            if (is_unparsed_entity(fx%xds%entityList, str_vs(tempString))) then
              call add_error(fx%error_stack, &
                'Cannot reference unparsed entity in content')
              goto 100
            elseif (is_external_entity(fx%xds%entityList, str_vs(tempString))) then
              if (present(skippedEntity_handler)) &
                call skippedEntity_handler(str_vs(tempString))
            else
              if (validCheck.and.associated(elem)) then
                if (elem%empty) then
                  call add_error(fx%error_stack, "Forbidden content inside element")
                  goto 100
                  !elseif (.not.elem%mixed.and..not.elem%any) then FIXME
                  !c1 = getEntityTextByName(fx%xds%entityList, str_vs(tempString)
                  !if (verify(getEntityTextByName(fx%xds%entityList, str_vs(tempString)), XML_WHITESPACE)/=0 & 
                    !.and. c1/="<") then
                    !call add_error(fx%error_stack, "Forbidden content inside element")
                    !goto 100
                  !endif
                endif
              endif
              if (present(startEntity_handler)) &
                call startEntity_handler(str_vs(tempString))
              call add_internal_entity(fx%forbidden_ge_list, str_vs(tempString), "")
              call push_buffer_stack(fb, expand_entity(fx%xds%entityList, str_vs(tempString)))
              fx%parse_stack = fx%parse_stack + 1
              temp_wf_stack => fx%wf_stack
              allocate(fx%wf_stack(size(temp_wf_stack)+1))
              fx%wf_stack(2:size(fx%wf_stack)) = temp_wf_stack
              fx%wf_stack(1) = 0
              deallocate(temp_wf_stack)
            endif
          else
            ! Unknown entity check standalone etc
            if (fx%skippedExternal.and..not.fx%xds%standalone) then
              if (present(skippedEntity_handler)) &
                call skippedEntity_handler(str_vs(tempString))
            else
              call add_error(fx%error_stack, &
                'Encountered reference to undeclared entity')
            endif
          endif
          deallocate(tempString)
          fx%state = ST_CHAR_IN_CONTENT
        else
          call add_error(fx%error_stack, "Unexpected token found in character context")
          goto 100
        endif

      case (ST_CLOSING_TAG)
        !write(*,*)'ST_CLOSING_TAG'
        if (checkName(str_vs(fx%token), fx%xds)) then
          fx%name => fx%token
          nullify(fx%token)
          fx%whitespace = WS_DISCARD
          fx%state = ST_IN_CLOSING_TAG
        else
          call add_error(fx%error_stack, "Unexpected token found in closing tag: expecting a Name")
          goto 100
        endif

      case (ST_IN_CLOSING_TAG)
        !write(*,*)'ST_IN_CLOSING_TAG'
        if (str_vs(fx%token) == '>') then
          call close_tag
          if (in_error(fx%error_stack)) goto 100
          deallocate(fx%name)
          if (is_empty(fx%elstack)) then
            if (startInCharData_) then
              fx%well_formed = .true.
              fx%state = ST_CHAR_IN_CONTENT
              fx%whitespace = WS_PRESERVE
            else
              !we're done
              fx%well_formed = .true.
              fx%state = ST_MISC
              fx%context = CTXT_AFTER_CONTENT
              fx%whitespace = WS_DISCARD
            endif
          else
            fx%whitespace = WS_PRESERVE
            fx%state = ST_CHAR_IN_CONTENT
          endif
        else
          call add_error(fx%error_stack, "Unexpected token in closing tag - expecting Name")
          goto 100
        endif

      case (ST_IN_DTD)
        !write(*,*)'ST_IN_DTD'
        ! check token is name
        fx%root_element => fx%token
        nullify(fx%token)
        fx%whitespace = WS_MANDATORY
        fx%state = ST_DTD_NAME

      case (ST_DTD_NAME)
        !write(*,*) 'ST_DTD_NAME ', str_vs(fx%token)
        if (str_vs(fx%token)=='SYSTEM') then
          fx%state = ST_DTD_SYSTEM
        elseif (str_vs(fx%token)=='PUBLIC') then
          fx%state = ST_DTD_PUBLIC
        elseif (str_vs(fx%token)=='[') then
          if (present(startDTD_handler)) &
            call startDTD_handler(str_vs(fx%root_element), "", "")
          fx%whitespace = WS_DISCARD
          fx%state = ST_INT_SUBSET
        elseif (str_vs(fx%token)=='>') then
          if (present(startDTD_handler)) &
            call startDTD_handler(str_vs(fx%root_element), "", "")
          fx%context = CTXT_BEFORE_CONTENT
          fx%state = ST_MISC
        else
          call add_error(fx%error_stack, "Internal error: unexpected token")
          goto 100
        endif

      case (ST_DTD_PUBLIC)
        !write(*,*) 'ST_DTD_PUBLIC'
        if (fx%token(1)/='"'.and.fx%token(1)/="'" &
          .and.fx%token(1)/=fx%token(size(fx%token))) then
          call add_error(fx%error_stack, "Invalid Public Id literal")
          goto 100
        endif
        if (checkPublicId(str_vs(fx%token(2:size(fx%token)-1)))) then
          fx%publicId => vs_str_alloc(str_vs(fx%token(2:size(fx%token)-1)))
          deallocate(fx%token)
          fx%state = ST_DTD_SYSTEM
        else
          call add_error(fx%error_stack, "Invalid document public id")
          goto 100
        endif

      case (ST_DTD_SYSTEM)
        !write(*,*) 'ST_DTD_SYSTEM'
        if (fx%token(1)/='"'.and.fx%token(1)/="'" &
          .and.fx%token(1)/=fx%token(size(fx%token))) then
          call add_error(fx%error_stack, "Invalid System Id literal")
          goto 100
        endif
        fx%systemId => vs_str_alloc(str_vs(fx%token(2:size(fx%token)-1)))
        deallocate(fx%token)
        fx%whitespace = WS_DISCARD
        fx%state = ST_DTD_DECL

      case (ST_DTD_DECL)
        !write(*,*) 'ST_DTD_DECL ', str_vs(fx%token)
        if (str_vs(fx%token)=='[') then
          if (associated(fx%publicId).or.associated(fx%systemId)) &
            fx%skippedExternal = .true.
          if (present(startDTD_handler)) then
            if (associated(fx%publicId)) then
              call startDTD_handler(str_vs(fx%root_element), publicId=str_vs(fx%publicId), systemId=str_vs(fx%systemId))
            elseif (associated(fx%systemId)) then
              call startDTD_handler(str_vs(fx%root_element), publicId="", systemId=str_vs(fx%systemId))
            else
              call startDTD_handler(str_vs(fx%root_element), "", "")
            endif
          endif
          if (associated(fx%systemId)) deallocate(fx%systemId)
          if (associated(fx%publicId)) deallocate(fx%publicId)
          fx%whitespace = WS_DISCARD
          fx%state = ST_INT_SUBSET
        elseif (str_vs(fx%token)=='>') then
          if (associated(fx%publicId).or.associated(fx%systemId)) &
            fx%skippedExternal = .true.
          if (present(startDTD_handler)) then
            if (associated(fx%publicId)) then
              call startDTD_handler(str_vs(fx%root_element), publicId=str_vs(fx%publicId), systemId=str_vs(fx%systemId))
              deallocate(fx%publicId)
            elseif (associated(fx%systemId)) then
              call startDTD_handler(str_vs(fx%root_element), publicId="", systemId=str_vs(fx%systemId))
            else
              call startDTD_handler(str_vs(fx%root_element), "", "")
            endif
          endif
          if (associated(fx%systemId)) deallocate(fx%systemId)
          if (associated(fx%publicId)) deallocate(fx%publicId)
          if (present(endDTD_handler)) &
            call endDTD_handler

          fx%context = CTXT_BEFORE_CONTENT
          fx%state = ST_MISC
        else
          call add_error(fx%error_stack, "Internal error: unexpected token")
          goto 100
        endif

      case (ST_INT_SUBSET)
        !write(*,*) 'ST_INT_SUBSET'
        if (str_vs(fx%token)==']') then
          fx%state = ST_CLOSE_DTD
        elseif (fx%token(1)=='%') then
          tempString => vs_str_alloc(str_vs(fx%token(2:size(fx%token)-1)))
          if (existing_entity(fx%forbidden_pe_list, str_vs(tempString))) then
            call add_error(fx%error_stack, &
              'Recursive entity reference')
            goto 100
          endif
          if (existing_entity(fx%xds%PEList, str_vs(tempString))) then
            if (is_external_entity(fx%xds%PEList, str_vs(tempString))) then
              ! We are not validating, do not include external entities
              if (present(skippedEntity_handler)) &
                call skippedEntity_handler('%'//str_vs(tempString))
              !  then are we standalone?
              !   then look at XML section 5.1
              fx%skippedExternal = .true.
              processDTD = fx%xds%standalone !FIXME use this everywhere
            else
              ! Expand the entity, 
              if (present(startEntity_handler)) &
                call startEntity_handler('%'//str_vs(tempString))
              call add_internal_entity(fx%forbidden_pe_list, &
                str_vs(tempString), "")
              call push_buffer_stack(fb, &
                " "//expand_entity(fx%xds%PEList, str_vs(tempString))//" ")
              fx%parse_stack = fx%parse_stack + 1
            endif
            ! and do nothing else, carry on ...
          else
            ! Have we previously skipped an external entity?
            if (fx%skippedExternal.and..not.fx%xds%standalone) then
              if (processDTD) then
                if (present(skippedEntity_handler)) &
                  call skippedEntity_handler('%'//str_vs(tempString))
              endif
            else
              ! If not, 
              call add_error(fx%error_stack, &
                "Reference to undeclared parameter entity.")
              goto 100
            endif
          endif
          deallocate(tempString)
        elseif (str_vs(fx%token)=='<?') then
          fx%state = ST_START_PI
          fx%whitespace = WS_FORBIDDEN
        elseif (str_vs(fx%token)=='<!') then
          fx%state = ST_BANG_TAG
          fx%whitespace = WS_FORBIDDEN
        else
          call add_error(fx%error_stack, "Unexpected token in internal subset")
          goto 100
        endif

      case (ST_DTD_ATTLIST)
        !write(*,*) 'ST_DTD_ATTLIST'
        ! check is name
        fx%name => fx%token
        if (existing_element(fx%xds%element_list, str_vs(fx%name))) then
          elem => get_element(fx%xds%element_list, str_vs(fx%name))
        else
          elem => add_element(fx%xds%element_list, str_vs(fx%name))
        endif
        nullify(fx%token)
        fx%state = ST_DTD_ATTLIST_CONTENTS

      case (ST_DTD_ATTLIST_CONTENTS)
        !write(*,*) 'ST_DTD_ATTLIST_CONTENTS'
        if (str_vs(fx%token)==">") then
          deallocate(fx%name)
          if (processDTD) then
            if (present(attributeDecl_handler)) &
              call report_declarations(elem, attributeDecl_handler)
          endif
          fx%state = ST_INT_SUBSET
          fx%whitespace = WS_DISCARD
        else
          !token is everything up to >
          if (processDTD) then
            call parse_dtd_attlist(str_vs(fx%token), fx%xds%xml_version, fx%error_stack, elem)
          else
            call parse_dtd_attlist(str_vs(fx%token), fx%xds%xml_version, fx%error_stack)
          endif
          if (in_error(fx%error_stack)) goto 100
          ! Normalize attribute values in attlist
          if (processDTD) then
            do i = 1, size(elem%attlist%list)
              if (associated(elem%attlist%list(i)%default)) then
                tempString => elem%attlist%list(i)%default
                elem%attlist%list(i)%default => normalize_text(fx, tempString)
                deallocate(tempString)
                if (in_error(fx%error_stack)) goto 100
              endif
            enddo
          endif
          fx%state = ST_DTD_ATTLIST_END
        endif

      case (ST_DTD_ATTLIST_END)
        !write(*,*) 'ST_DTD_ATTLIST_END'
        if (str_vs(fx%token)=='>') then
          deallocate(fx%name)
          if (processDTD) then
            if (present(attributeDecl_handler)) &
              call report_declarations(elem, attributeDecl_handler)
          endif
          fx%state = ST_INT_SUBSET
          fx%whitespace = WS_DISCARD

        else
          call add_error(fx%error_stack, "Unexpected token in ATTLIST")
          goto 100
        endif

      case (ST_DTD_ELEMENT)
        !write(*,*) 'ST_DTD_ELEMENT'
        ! check is name
        fx%name => fx%token
        nullify(fx%token)
        fx%whitespace = WS_MANDATORY
        fx%state = ST_DTD_ELEMENT_CONTENTS

      case (ST_DTD_ELEMENT_CONTENTS)
        !token is everything up to >
        !write(*,*)'ST_DTD_ELEMENT_CONTENTS'
        if (declared_element(fx%xds%element_list, str_vs(fx%name))) then
          if (validCheck) then
            call add_error(fx%error_stack, "Duplicate Element declaration")
            goto 100
          else
            ! Ignore contents ...
            nullify(elem)
          endif
        elseif (processDTD) then
          if (existing_element(fx%xds%element_list, str_vs(fx%name))) then
            elem => get_element(fx%xds%element_list, str_vs(fx%name))
          else
            elem => add_element(fx%xds%element_list, str_vs(fx%name))
          endif
        else
          nullify(elem)
        endif
        call parse_dtd_element(str_vs(fx%token), fx%xds%xml_version, fx%error_stack, elem)
        if (in_error(fx%error_stack)) goto 100
        fx%state = ST_DTD_ELEMENT_END

      case (ST_DTD_ELEMENT_END)
        !write(*,*)'ST_DTD_ELEMENT_END'
        if (str_vs(fx%token)=='>') then
          if (processDTD.and.associated(elem)) then
            if (present(elementDecl_handler)) &
              call elementDecl_handler(str_vs(fx%name), str_vs(elem%model))
          endif
          deallocate(fx%name)
          fx%state = ST_INT_SUBSET
          fx%whitespace = WS_DISCARD
        else
          call add_error(fx%error_stack, "Unexpected token in ELEMENT")
          goto 100
          !FIXME this can't happen
        endif

      case (ST_DTD_ENTITY)
        !write(*,*) 'ST_DTD_ENTITY'
        if (str_vs(fx%token) == '%') then
          pe = .true.
          ! this will be a PE
          fx%state = ST_DTD_ENTITY_PE
        else
          pe = .false.
          if (namespaces_) then
            nameOk = checkNCName(str_vs(fx%token), fx%xds)
          else
            nameOk = checkName(str_vs(fx%token), fx%xds)
          endif
          if (.not.nameOk) then
            call add_error(fx%error_stack, &
              "Illegal name for general entity")
            goto 100
          endif
          fx%name => fx%token
          nullify(fx%token)
          fx%state = ST_DTD_ENTITY_ID
        endif

      case (ST_DTD_ENTITY_PE)
        !write(*,*) 'ST_DTD_ENTITY_PE'
        if (namespaces_) then
          nameOk = checkNCName(str_vs(fx%token), fx%xds)
        else
          nameOk = checkName(str_vs(fx%token), fx%xds)
        endif
        if (.not.nameOk) then
          call add_error(fx%error_stack, &
            "Illegal name for parameter entity")
          goto 100
        endif
        fx%name => fx%token
        nullify(fx%token)
        fx%state = ST_DTD_ENTITY_ID

      case (ST_DTD_ENTITY_ID)
        !write(*,*) 'ST_DTD_ENTITY_ID'
        if (str_vs(fx%token) == 'PUBLIC') then
          fx%state = ST_DTD_ENTITY_PUBLIC
        elseif (str_vs(fx%token) == 'SYSTEM') then
          fx%state = ST_DTD_ENTITY_SYSTEM
        elseif (fx%token(1)=="'".or.fx%token(1)=='"') then
          fx%attname => expand_entity_value_alloc(fx%token, fx%xds, fx%error_stack)
          if (in_error(fx%error_stack)) goto 100
          fx%state = ST_DTD_ENTITY_END
          fx%whitespace = WS_DISCARD
        else
          call add_error(fx%error_stack, "Unexpected token in ENTITY")
          goto 100
        endif

      case (ST_DTD_ENTITY_PUBLIC)
        !write(*,*) 'ST_DTD_ENTITY_PUBLIC'
        if (fx%token(1)/='"'.and.fx%token(1)/="'" &
          .and.fx%token(1)/=fx%token(size(fx%token))) then
          call add_error(fx%error_stack, "Invalid Public Id literal")
          goto 100
        endif
        if (checkPublicId(str_vs(fx%token(2:size(fx%token)-1)))) then
          fx%publicId => vs_str_alloc(str_vs(fx%token(2:size(fx%token)-1)))
          deallocate(fx%token)
          fx%state = ST_DTD_ENTITY_SYSTEM
        else
          call add_error(fx%error_stack, "Invalid PUBLIC id in ENTITY")
          goto 100
        endif

      case (ST_DTD_ENTITY_SYSTEM)
        !write(*,*) 'ST_DTD_ENTITY_SYSTEM'
        if (fx%token(1)/='"'.and.fx%token(1)/="'" &
          .and.fx%token(1)/=fx%token(size(fx%token))) then
          call add_error(fx%error_stack, "Invalid System Id literal")
          goto 100
        endif
        fx%systemId => vs_str_alloc(str_vs(fx%token(2:size(fx%token)-1)))
        deallocate(fx%token)
        fx%state = ST_DTD_ENTITY_NDATA

      case (ST_DTD_ENTITY_NDATA)
        !write(*,*) 'ST_DTD_ENTITY_NDATA'
        if (str_vs(fx%token)=='>') then
          if (processDTD) then
            call add_entity
          endif
          deallocate(fx%name)
          if (associated(fx%attname)) deallocate(fx%attname)
          if (associated(fx%systemId)) deallocate(fx%systemId)
          if (associated(fx%publicId)) deallocate(fx%publicId)
          if (associated(fx%Ndata)) deallocate(fx%Ndata)
          fx%state = ST_INT_SUBSET
          fx%whitespace = WS_DISCARD
        elseif (str_vs(fx%token)=='NDATA') then
          if (pe) then
            call add_error(fx%error_stack, "Parameter entity cannot have NDATA declaration")
            goto 100
          endif
          fx%state = ST_DTD_ENTITY_NDATA_VALUE
        else
          call add_error(fx%error_stack, "Unexpected token in ENTITY")
          goto 100
        endif

      case (ST_DTD_ENTITY_NDATA_VALUE)
        !write(*,*) 'ST_DTD_ENTITY_NDATA_VALUE'
        !check is a name and exists in notationlist
        if (namespaces_) then
          nameOk = checkNCName(str_vs(fx%token), fx%xds)
        else
          nameOk = checkName(str_vs(fx%token), fx%xds)
        endif
        if (.not.nameOk) then
          call add_error(fx%error_stack, "Invalid name for Notation")
          goto 100
        endif
        fx%Ndata => fx%token
        nullify(fx%token)

        fx%state = ST_DTD_ENTITY_END
        fx%whitespace = WS_DISCARD

      case (ST_DTD_ENTITY_END)
        !write(*,*) 'ST_DTD_ENTITY_END'
        if (str_vs(fx%token)=='>') then
          if (processDTD) then
            call add_entity
          endif
          deallocate(fx%name)
          if (associated(fx%attname)) deallocate(fx%attname)
          if (associated(fx%systemId)) deallocate(fx%systemId)
          if (associated(fx%publicId)) deallocate(fx%publicId)
          if (associated(fx%Ndata)) deallocate(fx%Ndata)
          fx%state = ST_INT_SUBSET
        else
          call add_error(fx%error_stack, "Unexpected token at end of ENTITY")
          goto 100
        endif

      case (ST_DTD_NOTATION)
        !write(*,*) 'ST_DTD_NOTATION'
        if (namespaces_) then
          nameOk = checkNCName(str_vs(fx%token), fx%xds)
        else
          nameOk = checkName(str_vs(fx%token), fx%xds)
        endif
        if (.not.nameOk) then
          call add_error(fx%error_stack, "Invalid name for Notation")
          goto 100
        endif
        fx%name => fx%token
        nullify(fx%token)
        fx%state = ST_DTD_NOTATION_ID

      case (ST_DTD_NOTATION_ID)
        !write(*,*)'ST_DTD_NOTATION_ID'
        if (str_vs(fx%token)=='SYSTEM') then
          fx%state = ST_DTD_NOTATION_SYSTEM
        elseif (str_vs(fx%token)=='PUBLIC') then
          fx%state = ST_DTD_NOTATION_PUBLIC
        else
          call add_error(fx%error_stack, "Unexpected token after NOTATION")
          exit
        endif

      case (ST_DTD_NOTATION_SYSTEM)
        !write(*,*)'ST_DTD_NOTATION_SYSTEM'
        if (fx%token(1)/='"'.and.fx%token(1)/="'" &
          .and.fx%token(1)/=fx%token(size(fx%token))) then
          call add_error(fx%error_stack, "Invalid System Id literal")
          goto 100
        endif
        fx%systemId => vs_str_alloc(str_vs(fx%token(2:size(fx%token)-1)))
        deallocate(fx%token)
        fx%state = ST_DTD_NOTATION_END

      case (ST_DTD_NOTATION_PUBLIC)
        !write(*,*)'ST_DTD_NOTATION_PUBLIC'
        if (fx%token(1)/='"'.and.fx%token(1)/="'" &
          .and.fx%token(1)/=fx%token(size(fx%token))) then
          call add_error(fx%error_stack, "Invalid Public Id literal")
          goto 100
        endif
        if (checkPublicId(str_vs(fx%token(2:size(fx%token)-1)))) then
          fx%publicId => vs_str_alloc(str_vs(fx%token(2:size(fx%token)-1)))
          deallocate(fx%token)
          fx%state = ST_DTD_NOTATION_PUBLIC_2
        else
          call add_error(fx%error_stack, "Invalid PUBLIC id in NOTATION")
          exit
        endif

      case (ST_DTD_NOTATION_PUBLIC_2)
        !write(*,*)'ST_DTD_NOTATION_PUBLIC_2'
        if (str_vs(fx%token)=='>') then
          if (validCheck) then
            if (notation_exists(fx%nlist, str_vs(fx%name))) then
              call add_error(fx%error_stack, "Duplicate notation declaration")
              exit
            endif
          endif
          if (processDTD) then
            call add_notation(fx%nlist, str_vs(fx%name), publicId=str_vs(fx%publicId))
            if (present(notationDecl_handler)) &
              call notationDecl_handler(str_vs(fx%name), publicId=str_vs(fx%publicId), systemId="") 
          endif
          deallocate(fx%name)
          deallocate(fx%publicId)
          fx%state = ST_INT_SUBSET
        else
          if (fx%token(1)/='"'.and.fx%token(1)/="'" &
            .and.fx%token(1)/=fx%token(size(fx%token))) then
            call add_error(fx%error_stack, "Invalid System Id literal")
            goto 100
          endif
          fx%systemId => vs_str_alloc(str_vs(fx%token(2:size(fx%token)-1)))
          deallocate(fx%token)
          fx%state = ST_DTD_NOTATION_END
        endif

      case (ST_DTD_NOTATION_END)
        !write(*,*)'ST_DTD_NOTATION_END'
        if (str_vs(fx%token)=='>') then
          if (validCheck) then
            if (notation_exists(fx%nlist, str_vs(fx%name))) then
              call add_error(fx%error_stack, "Duplicate notation declaration")
              exit
            endif
          endif
          if (processDTD) then
            if (associated(fx%publicId)) then
              call add_notation(fx%nlist, str_vs(fx%name), &
                publicId=str_vs(fx%publicId), systemId=str_vs(fx%systemId))
              if (present(notationDecl_handler)) &
                call notationDecl_handler(str_vs(fx%name), &
                publicId=str_vs(fx%publicId), systemId=str_vs(fx%systemId)) 
            else
              call add_notation(fx%nlist, str_vs(fx%name), &
                systemId=str_vs(fx%systemId))
              if (present(notationDecl_handler)) &
                call notationDecl_handler(str_vs(fx%name), &
                publicId="", systemId=str_vs(fx%systemId)) 
            endif
          endif
          if (associated(fx%publicId)) deallocate(fx%publicId)
          deallocate(fx%systemId)
          deallocate(fx%name)
          fx%state = ST_INT_SUBSET
          fx%whitespace = WS_DISCARD
        else
          call add_error(fx%error_stack, "Unexpected token in NOTATION")
          exit
        endif

      case (ST_CLOSE_DTD)
        !write(*,*) 'ST_CLOSE_DTD'
        ! token must be '>'
        if (present(endDTD_handler)) &
          call endDTD_handler
        ! Check that all notations used have been declared:
        if (validCheck) then
          do i = 1, size(fx%xds%entityList)
            if (getEntityNotationByIndex(fx%xds%entityList, i)/="" &
              .and..not.notation_exists(fx%nlist, getEntityNotationByIndex(fx%xds%entityList, i))) then
              call add_error(fx%error_stack, "Attempt to use undeclared notation")
              goto 100
            endif
          enddo
        endif
          
        fx%state = ST_MISC
        fx%context = CTXT_BEFORE_CONTENT

      end select

    end do

100 if (associated(tempString)) deallocate(tempString)

    if (iostat==io_eof) then ! error is end of file then
      ! EOF of main file
      if (startInChardata_) then
        if (fx%well_formed) then
          if (fx%state==ST_CHAR_IN_CONTENT.and.associated(fx%token)) then
            if (size(fx%token)>0.and.present(characters_handler)) call characters_handler(str_vs(fx%token))
          endif
        else
          if (present(error_handler)) call error_handler("Ill-formed XML fragment")
        endif
      elseif (fx%well_formed.and.fx%state==ST_MISC) then
        if (present(endDocument_handler)) &
          call endDocument_handler()
      else
        call add_error(fx%error_stack, "File is not well-formed")
        call sax_error(fx, error_handler)
      endif
    elseif (iostat==io_err) then ! we generated the error
      call sax_error(fx, error_handler)
    else ! Hard error - stop immediately
      if (fx%parse_stack>0) then !we are parsing an entity
        call add_error(fx%error_stack, "Error encountered processing entity.")
        call sax_error(fx, error_handler)
      else
        call sax_error(fx, error_handler)
      endif
    endif

  contains

    subroutine open_tag
      ! Is Name a valid QName?
      if (namespaces_) then
        nameOk = checkQName(str_vs(fx%name), fx%xds)
      else
        nameOk = checkName(str_vs(fx%name), fx%xds)
      endif
      if (.not.nameOk) then
        call add_error(fx%error_stack, "Invalid element name")
        return
      endif
      ! Are there any default values missing?
      if (validCheck) then
        elem => get_element(fx%xds%element_list, str_vs(fx%name))
        if (associated(elem)) &
          call checkImplicitAttributes(elem, fx%attributes)
        ! FIXME and also check that attribute declarations fit the ATTLIST
        ! FIXME and if we read external subset, is this element declared ok
        elem => get_element(fx%xds%element_list, get_top_elstack(fx%elstack))
        ! This will return null anyway if we are opening root element
        if (associated(elem)) then
          if (elem%empty) then
            call add_error(fx%error_stack, "Content inside empty element")
          endif
          ! FIXME and ideally do a proper check of is this element allowed here
        endif
      endif
      ! Check for namespace changes
      if (namespaces_) &
        call checkNamespaces(fx%attributes, fx%nsDict, &
        len(fx%elstack), fx%xds, namespace_prefixes_, xmlns_uris_, &
        fx%error_stack, startInCharData_, &
        startPrefixMapping_handler, endPrefixMapping_handler)
      if (in_error(fx%error_stack)) return
      call checkXmlAttributes
      if (in_error(fx%error_stack)) return
      if (namespaces_.and.getURIofQName(fx,str_vs(fx%name))==invalidNS) then
        ! no namespace was found for the current element
        if (.not.startInCharData_) then
          ! but we ignore this if we are parsing an entity through DOM
          call add_error(fx%error_stack, "No namespace found for current element")
          return
        elseif (present(startElement_handler)) then
          ! Record it as having an empty URI
          call startElement_handler("", &
            getlocalNameofQName(str_vs(fx%name)), &
            str_vs(fx%name), fx%attributes)
        endif
      elseif (namespaces_) then
        ! Normal state of affairs
        if (present(startElement_handler)) &
          call startElement_handler(getURIofQName(fx, str_vs(fx%name)), &
          getlocalNameofQName(str_vs(fx%name)), &
          str_vs(fx%name), fx%attributes)
      else
        ! Non-namespace aware processing
        if (present(startElement_handler)) &
          call startElement_handler("", "", &
          str_vs(fx%name), fx%attributes)
      endif
      call push_elstack(str_vs(fx%name), fx%elstack)
      call reset_dict(fx%attributes)
      fx%wf_stack(1) = fx%wf_stack(1) + 1
    end subroutine open_tag

    subroutine close_tag
      fx%wf_stack(1) = fx%wf_stack(1) - 1
      if (fx%wf_stack(1)<0) then
        call add_error(fx%error_stack, &
          'Ill-formed entity')
        return
      endif
      if (str_vs(fx%name)/=pop_elstack(fx%elstack)) then
        call add_error(fx%error_stack, "Mismatching close tag - expecting "//str_vs(fx%name))
        return
      endif
      if (present(endElement_handler)) then
        if (namespaces_.and.getURIofQName(fx,str_vs(fx%name))==invalidNS) then
          ! no namespace was found for the current element, we must be
          ! closing inside a DOM entity.
          ! Record it as having an empty URI
          call endElement_handler("", &
            getlocalNameofQName(str_vs(fx%name)), &
            str_vs(fx%name))
        elseif (namespaces_) then
          ! Normal state of affairs
          call endElement_handler(getURIofQName(fx, str_vs(fx%name)), &
            getlocalnameofQName(str_vs(fx%name)), &
            str_vs(fx%name))
        else
          ! Non-namespace-aware processing:
          call endElement_handler("", "", &
            str_vs(fx%name))
        endif
      endif
      if (namespaces_) &
        call checkEndNamespaces(fx%nsDict, len(fx%elstack), &
        endPrefixMapping_handler)
    end subroutine close_tag

    subroutine add_entity
      !Parameter or General Entity?
      if (pe) then
        !Does entity with this name exist?
        if (.not.existing_entity(fx%xds%PEList, str_vs(fx%name))) then
          ! Internal or external?
          if (associated(fx%attname)) then ! it's internal
            call register_internal_PE(fx%xds, str_vs(fx%name), str_vs(fx%attname(2:size(fx%attname)-1))) ! stripping off quotes
            ! FIXME need to expand value here before reporting ...
            if (present(internalEntityDecl_handler)) &
              call internalEntityDecl_handler('%'//str_vs(fx%name), str_vs(fx%attname(2:size(fx%attname)-1)))
          else ! PE can't have Ndata declaration
            if (associated(fx%publicId)) then
              call register_external_PE(fx%xds, str_vs(fx%name), str_vs(fx%systemId), public=str_vs(fx%publicId))
              !Need to fully resolve system ID to URL here
              if (present(externalEntityDecl_handler)) &
                call externalEntityDecl_handler('%'//str_vs(fx%name), &
                systemId=resolveSystemID(str_vs(fx%systemId)), publicId=str_vs(fx%publicId))
            else
              call register_external_PE(fx%xds, str_vs(fx%name), str_vs(fx%systemId))
              if (present(externalEntityDecl_handler)) &
                call externalEntityDecl_handler('%'//str_vs(fx%name), &
                systemId=resolveSystemId(str_vs(fx%systemId)))
            endif
          endif
          ! else we ignore it
        endif
      else !It's a general entity
        if (.not.existing_entity(fx%xds%entityList, str_vs(fx%name))) then
          ! Internal or external?
          if (associated(fx%attname)) then ! it's internal
            call register_internal_GE(fx%xds, str_vs(fx%name), str_vs(fx%attname(2:size(fx%attname)-1)))
            if (present(internalEntityDecl_handler)) &
              call internalEntityDecl_handler(str_vs(fx%name),&
              str_vs(fx%attname(2:size(fx%attname)-1))) ! stripping quotes
          else
            if (associated(fx%publicId).and.associated(fx%Ndata)) then
              call register_external_GE(fx%xds, str_vs(fx%name), str_vs(fx%systemId), &
                public=str_vs(fx%publicId), notation=str_vs(fx%Ndata))
              if (present(unparsedEntityDecl_handler)) &
                call unparsedEntityDecl_handler(str_vs(fx%name), &
                systemId=resolveSystemId(str_vs(fx%systemId)), publicId=str_vs(fx%publicId), &
                notation=str_vs(fx%Ndata))
            elseif (associated(fx%Ndata)) then
              call register_external_GE(fx%xds, str_vs(fx%name), str_vs(fx%systemId), notation=str_vs(fx%Ndata))
              if (present(unparsedEntityDecl_handler)) &
                call unparsedEntityDecl_handler(str_vs(fx%name), publicId="", &
                systemId=resolveSystemId(str_vs(fx%systemId)), notation=str_vs(fx%Ndata))
            elseif (associated(fx%publicId)) then
              call register_external_GE(fx%xds, str_vs(fx%name), str_vs(fx%systemId), public=str_vs(fx%publicId))
              if (present(externalEntityDecl_handler)) &
                call externalEntityDecl_handler(str_vs(fx%name), &
                systemId=resolveSystemId(str_vs(fx%systemId)), publicId=str_vs(fx%publicId))
            else
              call register_external_GE(fx%xds, str_vs(fx%name), str_vs(fx%systemId))
              if (present(externalEntityDecl_handler)) &
                call externalEntityDecl_handler(str_vs(fx%name), &
                systemId=resolveSystemId(str_vs(fx%systemId)))
            endif
          endif
        endif
      endif
    end subroutine add_entity

    function NotCDataNormalize(s1) result(s2)
      character(len=*), intent(in) :: s1
      character(len=len(s1)) :: s2

      integer :: i, i2
      logical :: w

      i2 = 1
      w = .true.
      do i = 1, len(s1)
        if (w.and.(verify(s1(i:i),XML_WHITESPACE)==0)) cycle
        w = .false.
        s2(i2:i2) = s1(i:i)
        i2 = i2 + 1
        if (verify(s1(i:i),XML_WHITESPACE)==0) w = .true.
      enddo
      s2(i2:) = ''
    end function NotCDataNormalize

    subroutine checkImplicitAttributes(elem, dict)
      type(element_t), pointer :: elem
      type(dictionary_t), intent(inout) :: dict

      integer :: i
      type(string_list) :: default_atts

      default_atts = get_default_atts(elem%attlist)
      do i = 1, size(default_atts%list), 2
        if (.not.has_key(dict, str_vs(default_atts%list(i)%s))) then
          call add_item_to_dict(dict, str_vs(default_atts%list(i)%s), &
            str_vs(default_atts%list(i+1)%s), specified=.false.)
        endif
      enddo
      call destroy_string_list(default_atts)

    end subroutine checkImplicitAttributes

    subroutine checkXMLAttributes
      ! This must be done with the name of the attribute,
      ! not the nsURI/localname pair, in case we are
      ! processing for a non-namespace aware application
      if (has_key(fx%attributes, 'xml:space')) then
        if (get_value(fx%attributes, 'xml:space')/='default' &
          .and. get_value(fx%attributes, 'xml:space')/='preserve') then
          call add_error(fx%error_stack, 'Illegal value of xml:space attribute')
        endif
      endif
      ! FIXME
      !if (has_key(fx%attributes, 'xml:id')) then
      ! must be an NCName
      ! must be unique ...
      !endif
      !if (has_key(fx%attributes, 'xml:base')
      !if (has_key(fx%attributes, 'xml:lang')
    end subroutine checkXMLAttributes
  end subroutine sax_parse


  subroutine sax_error(fx, error_handler)
    type(sax_parser_t), intent(inout) :: fx
    optional :: error_handler
    interface
      subroutine error_handler(msg)
        character(len=*), intent(in)     :: msg
      end subroutine error_handler
    end interface

    character, dimension(:), pointer :: errmsg

    integer :: i, m, n, n_err
    n = size(fx%error_stack%stack)
    n_err = n

    do i = 1, n
      n_err = n_err + size(fx%error_stack%stack(i)%msg) ! + spaces + size of entityref
    enddo
    allocate(errmsg(n_err))
    errmsg = ''
    n = 1
    do i = 1, size(fx%error_stack%stack)
      m = size(fx%error_stack%stack(i)%msg)
      errmsg(n:n+m-1) = fx%error_stack%stack(i)%msg
      errmsg(n+m:n+m) = " "
      n = n + m + 1
    enddo
    ! FIXME put location information in here
    if (present(error_handler)) then
      call error_handler(str_vs(errmsg))
      deallocate(errmsg)
    else
      call FoX_error(str_vs(errmsg))
    endif

  end subroutine sax_error

  pure function URIlength(fx, qname) result(l_u)
    type(sax_parser_t), intent(in) :: fx
    character(len=*), intent(in) :: qName
    integer :: l_u
    integer :: n
    n = index(QName, ':')
    if (n > 0) then
      l_u = len(getnamespaceURI(fx%nsDict, QName(1:n-1)))
    else
      l_u = len(getnamespaceURI(fx%nsDict))
    endif
  end function URIlength

  pure function getURIofQName(fx, qname) result(URI)
    type(sax_parser_t), intent(in) :: fx
    character(len=*), intent(in) :: qName
    character(len=URIlength(fx, qname)) :: URI

    integer :: n
    n = index(QName, ':')
    if (n > 0) then
      URI = getnamespaceURI(fx%nsDict, QName(1:n-1))
    else
      URI = getnamespaceURI(fx%nsDict)
    endif

  end function getURIofQName

  pure function getLocalNameofQName(qname) result(localName)
    character(len=*), intent(in) :: qName
    character(len=len(QName)-index(QName,':')) :: localName

    localName = QName(index(QName,':')+1:)
  end function getLocalNameofQName

end module m_sax_parser

module example_xml_module

  use FoX_wxml

  implicit none
  private

  type(xmlf_t) :: xmlfile

  save :: xmlfile

  public :: initialize_xml_output
  public :: add_paragraph
  public :: end_xml_output

contains

  subroutine initialize_xml_output(title)
     character(len=*), intent(in) :: title

     call xml_OpenFile('output.xml', xmlfile)

     call xml_DeclareNamespace(xmlfile, 'http://www.w3.org/1999/xhtml')

     call xml_NewElement(xmlfile, 'html')


     call xml_NewElement(xmlfile, 'head')
     call xml_NewElement(xmlfile, 'title')
     call xml_AddCharacters(xmlfile, title)
     call xml_EndElement(xmlfile, 'title')
     call xml_EndElement(xmlfile, 'head')

     call xml_NewElement(xmlfile, 'body')

  end subroutine initialize_xml_output


  subroutine add_paragraph(para, italic)
    character(len=*), intent(in) :: para
    logical :: italic

    call xml_NewElement(xmlfile, 'p')
    if (italic) call xml_AddAttribute(xmlfile, 'style', 'font-style:italic')
    call xml_AddCharacters(xmlfile, para)
    call xml_EndElement(xmlfile, 'p')
  end subroutine add_paragraph


  subroutine end_xml_output

     call xml_EndElement(xmlfile, 'body')

     call xml_Close(xmlfile)
  end subroutine end_xml_output

end module example_xml_module

program test

  use FoX_wxml, only : xmlf_t
  use FoX_wxml, only : xml_AddXMLStylesheet
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  call xml_AddXMLStylesheet(xf, "display.xsl", "text/stylesheet")

end program test

program test_xml_Openfile

  use FoX_wxml
  implicit none

  character(len=*), parameter :: filename = 'test.xml'

  type(xmlf_t) :: xf1

  call xml_OpenFile(filename, xf1)
  call xml_OpenFile(filename, xf1)

end program test_xml_Openfile

program test

  use FoX_wcml
  implicit none

  character(len=*), parameter :: filename = 'test.xml'
  type(xmlf_t) :: xf

  double precision, dimension(3) :: lens, angs

  lens = (/1.0d0, 1.0d0, 1.0d0/)
  angs = (/90.0d0, 90.0d0, 90.0d0/)

  call cmlBeginFile(xf, filename, unit=-1)
  call cmlStartCml(xf)
  
  call cmlAddCrystal(xf, lens(1), lens(2), lens(3), angs(1), angs(2), angs(3), &
       lenfmt="r3", angfmt="r3")

  call cmlFinishFile(xf)

end program test

module m_dom_error

  use pxf, only: pxfabort

  use m_common_error, only: error_stack, add_error, in_error, destroy_error_stack

  implicit none
  private

  type DOMException
    private
    type(error_stack) :: stack
  end type DOMException

  integer, parameter, public :: INDEX_SIZE_ERR              = 1
  integer, parameter, public :: DOMSTRING_SIZE_ERR          = 2
  integer, parameter, public :: HIERARCHY_REQUEST_ERR       = 3
  integer, parameter, public :: WRONG_DOCUMENT_ERR          = 4
  integer, parameter, public :: INVALID_CHARACTER_ERR       = 5
  integer, parameter, public :: NO_DATA_ALLOWED_ERR         = 6
  integer, parameter, public :: NO_MODIFICATION_ALLOWED_ERR = 7
  integer, parameter, public :: NOT_FOUND_ERR               = 8
  integer, parameter, public :: NOT_SUPPORTED_ERR           = 9
  integer, parameter, public :: INUSE_ATTRIBUTE_ERR         = 10
  integer, parameter, public :: INVALID_STATE_ERR           = 11
  integer, parameter, public :: SYNTAX_ERR                  = 12
  integer, parameter, public :: INVALID_MODIFICATION_ERR    = 13
  integer, parameter, public :: NAMESPACE_ERR               = 14
  integer, parameter, public :: INVALID_ACCESS_ERR          = 15
  integer, parameter, public :: VALIDATION_ERR              = 16
  integer, parameter, public :: TYPE_MISMATCH_ERR           = 17

  integer, parameter, public :: INVALID_EXPRESSION_ERR      = 51
  integer, parameter, public :: TYPE_ERR                    = 52

  integer, parameter, public :: PARSE_ERR                   = 81
  integer, parameter, public :: SERIALIZE_ERR               = 82

  integer, parameter, public :: FoX_INVALID_NODE            = 201
  integer, parameter, public :: FoX_INVALID_CHARACTER       = 202
  integer, parameter, public :: FoX_NO_SUCH_ENTITY          = 203
  integer, parameter, public :: FoX_INVALID_PI_DATA         = 204
  integer, parameter, public :: FoX_INVALID_CDATA_SECTION   = 205
  integer, parameter, public :: FoX_HIERARCHY_REQUEST_ERR   = 206
  integer, parameter, public :: FoX_INVALID_PUBLIC_ID       = 207
  integer, parameter, public :: FoX_INVALID_SYSTEM_ID       = 208
  integer, parameter, public :: FoX_INVALID_COMMENT         = 209
  integer, parameter, public :: FoX_NODE_IS_NULL            = 210
  integer, parameter, public :: FoX_INVALID_ENTITY          = 211
!  integer, parameter, public :: FoX_NO_DOCTYPE              = 212
  integer, parameter, public :: FoX_IMPL_IS_NULL            = 213
  integer, parameter, public :: FoX_MAP_IS_NULL             = 214
  integer, parameter, public :: FoX_LIST_IS_NULL            = 215

  integer, parameter, public :: FoX_INTERNAL_ERROR          = 999


  public :: DOMException
  public :: getExceptionCode
  public :: throw_exception
  public :: inException
  public :: dom_error
  public :: internal_error

contains

  pure function errorString(code) result(s)
    integer, intent(in) :: code
    character(len=27) :: s

    select case(code)
    case(1)
      s = "INDEX_SIZE_ERR"
    case(2)
      s = "DOMSTRING_SIZE_ERR"
    case(3)
      s = "HIERARCHY_REQUEST_ERR"
    case(4)
      s = "WRONG_DOCUMENT_ERR"
    case(5)
      s = "INVALID_CHARACTER_ERR"
    case(6)
      s = "NO_DATA_ALLOWED_ERR"
    case(7)
      s = "NO_MODIFICATION_ALLOWED_ERR"
    case(8)
      s = "NOT_FOUND_ERR"
    case(9)
      s = "NOT_SUPPORTED_ERR"
    case(10)
      s = "INUSE_ATTRIBUTE_ERR"
    case(11)
      s = "INVALID_STATE_ERR"
    case(12)
      s = "SYNTAX_ERR"
    case(13)
      s = "INVALID_MODIFICATION_ERR"
    case(14)
      s = "NAMESPACE_ERR"
    case(15)
      s = "INVALID_ACCESS_ERR"
    case(16)
      s = "VALIDATION_ERR"
    case(18)
      s = "TYPE_MISMATCH_ERR"
    case(51)
      s = "INVALID_EXPRESSION_ERR"
    case(52)
      s = "TYPE_ERR"
    case(81)
      s = "PARSE_ERR"
    case(82)
      s = "SERIALIZE_ERR"
    case(201)
      s = "FoX_INVALID_NODE"
    case(202)
      s = "FoX_INVALID_CHARACTER"
    case(203)
      s = "FoX_NO_SUCH_ENTITY"
    case(204)
      s = "FoX_INVALID_PI_DATA"
    case(205)
      s = "FoX_INVALID_CDATA_SECTION"
    case(206)
      s = "FoX_HIERARCHY_REQUEST_ERR"
    case(207)
      s = "FoX_INVALID_PUBLIC_ID"
    case(208)
      s = "FoX_INVALID_SYSTEM_ID"
    case(209)
      s = "FoX_INVALID_COMMENT"
    case(210)
      s = "FoX_NODE_IS_NULL"
    case(211)
      s = "FoX_INVALID_ENTITY"
    case(212)
      s = "FoX_NO_DOCTYPE"
    case(213)
      s = "FoX_IMPL_IS_NULL"
    case(214)
      s = "FoX_MAP_IS_NULL"
    case(215)
      s = "FoX_LIST_IS_NULL"
    case default
      s = "INTERNAL ERROR!!!!"
    end select

  end function errorString

  function getExceptionCode(ex) result(n)
    type(DOMException), intent(inout) :: ex
    integer :: n

    if (in_error(ex%stack)) then
      n = ex%stack%stack(size(ex%stack%stack))%error_code
      call destroy_error_stack(ex%stack)
    else
      n = 0
    endif
  end function getExceptionCode

  subroutine throw_exception(code, msg, ex)
    integer, intent(in) :: code
    character(len=*), intent(in) :: msg
    type(DOMException), intent(inout), optional :: ex

    if (present(ex)) then
      call add_error(ex%stack, msg, error_code=code) ! FIXME
    else
      write(0,'(a)') errorString(code)
      write(0,'(i0,a)') code, " "//msg
      call pxfabort()
    endif
      
  end subroutine throw_exception


  subroutine dom_error(name,code,msg)
    character(len=*), intent(in) :: name, msg
    integer, intent(in)          :: code

    write(0,'(4a)') "Routine ", name, ":", msg
    write(0,'(a)') errorString(code)
    call pxfabort()

  end subroutine dom_error

  
  subroutine destroyDOMException(ex)
    type(DOMException), intent(inout) :: ex

    call destroy_error_stack(ex%stack)
  end subroutine destroyDOMException


  subroutine internal_error(name,msg)
    character(len=*), intent(in) :: name, msg

    write(0,'(4a)') "Internal error in ", name, ":", msg
    call pxfabort()

  end subroutine internal_error

  function inException(ex) result(p)
    type(DOMException), intent(in) :: ex
    logical :: p

    p = in_error(ex%stack)
  end function inException

end module m_dom_error

#!/bin/sh

INCFLAGS=`../../FoX-config --fcflags`
export INCFLAGS
rm -f passed.score failed.score
rm -f tests.out failed.out
touch passed.score failed.score

for t in test_xml_*.sh
do
  ./$t
done

echo RESULT wxml/ Test Results:
echo RESULT wxml/ Passed: `grep -c PASSED tests.out`
echo RESULT wxml/ Failed: `grep -c FAILED tests.out`

echo RESULT wxml/ See wxml/test/failed.out for details of failed tests.

#! /bin/sh -e

# NB Note that we ensure all locally-produced files 
# have Unix line endings only by using 'tr', in
# order to compare properly to our canonical versions.

make $1.exe
./$1.exe 2>&1 | tr -d '\15' > test.out
passed=no
if [ -f $1.xml ]
then
  tr -d '/15' < test.xml > test.xml.tmp; mv test.xml.tmp test.xml
  if diff test.xml $1.xml > /dev/null; then
     echo $1 >> failed.out
     echo "------------" >> failed.out
     diff test.xml $1.xml >> failed.out
     echo "------------" >> failed.out
  else
    passed=yes
  fi
elif [ -f $1.out ]
then
# Note below that we don't do a direct grep; we just check 
# that the only DIFFerences are in one direction.
  if diff test.out $1.out | grep "^>" > /dev/null; then
     echo $1 >> failed.out
     echo "------------" >> failed.out
     diff test.out $1.out >> failed.out
     echo "------------" >> failed.out
  else
    passed=yes
  fi
else
  echo No test output found for $1
fi

if [ $passed = yes ]; then
  echo 'PASSED: ' $1 
  echo 'PASSED: ' $1 >> tests.out
else
  echo 'FAILED: ' $1 
  echo 'FAILED: ' $1 >> tests.out
fi

#!/bin/sh

if [ $1 = yes ]; then
  echo 'PASSED: ' $2
  echo 'PASSED: ' $2 >> tests.out
  echo -n '1' >> passed.score
else
  echo 'FAILED: ' $2
  echo 'FAILED: ' $2 >> tests.out
  echo -n '1' >> failed.score
fi

#!/bin/sh -e

m4 -DTESTINPUT="$1" test_str.f90.in > test_str.f90
make test_str.exe > /dev/null 2>&1
OUT=`./test_str.exe`
rm -f test_str.exe test_str.o test_str.f90

echo $OUT $2

if [ "$OUT" = \!"$2"\! ]; then
  echo Passed: $2
  echo 1 >> passed.score
  exit 0
else
  echo Failed: $2
  echo Failed: $2 >> failed.out
  echo 1 >> failed.score
  exit 1
fi

#!/bin/sh 

INCFLAGS=`../../FoX-config --fcflags --wxml`

rm -f test.xml
make test_xml_Openfile_1.exe
./test_xml_Openfile_1.exe > /dev/null 2>&1
if [ -f test.xml ]; then
   echo we passed
   PASSED=yes
else
   echo we failed
   PASSED=no
fi
./passed.sh $PASSED "file creation with default unit number"
rm -f test.xml

# check for creation with non-default file handle.
make test_xml_Openfile_2.exe
./test_xml_Openfile_2.exe> /dev/null 2>&1
if [ -f test.xml ]; then
   PASSED=yes
else
   PASSED=no
fi
./passed.sh $PASSED "file creation with non-default unit number"
rm -f test.xml

# check that we replace existing file by default
echo TESTINPUT > test.xml
make test_xml_Openfile_1.exe
./test_xml_Openfile_1.exe> /dev/null 2>&1
if grep -v TESTINPUT test.xml >/dev/null; then
   PASSED=yes
else
   PASSED=no
fi
./passed.sh $PASSED "file creation replacement by default"
rm -f test.xml

# check that we create a new file when we ask to.
# This should fail ...
echo TESTINPUT > test.xml
make test_xml_Openfile_3.exe
./test_xml_Openfile_3.exe >/dev/null 2>&1
if [ $? -ne 0 ]; then
   PASSED=yes
else
   PASSED=no
fi
./passed.sh $PASSED "file creation without replacement"
rm -f test.xml

echo TESTINPUT > test.xml
make test_xml_Openfile_1.exe
./test_xml_Openfile_1.exe> /dev/null 2>&1
if grep -v TESTINPUT test.xml >/dev/null; then
   PASSED=yes
else
   PASSED=no
fi
./passed.sh $PASSED "file creation specifying REPLACE"
rm -f test.xml

make test_xml_Openfile_4.exe
rm -f test.xml
./test_xml_Openfile_4.exe> test.out 2>&1
if diff test.out test_xml_Openfile_4.out | grep "^>" > /dev/null; then
   PASSED=no
else
   PASSED=yes
fi
./passed.sh $PASSED "Trying to create file twice"
rm -f test.xml

( cd usr/lib ; rm -rf libCHART-1.6.so.0 )
( cd usr/lib ; ln -sf libCHART-1.6.so.0.0.33 libCHART-1.6.so.0 )
( cd usr/lib ; rm -rf libFOX-1.6.so )
( cd usr/lib ; ln -sf libFOX-1.6.so.0.0.33 libFOX-1.6.so )
( cd usr/lib ; rm -rf libCHART-1.6.so )
( cd usr/lib ; ln -sf libCHART-1.6.so.0.0.33 libCHART-1.6.so )
( cd usr/lib ; rm -rf libFOX-1.6.so.0 )
( cd usr/lib ; ln -sf libFOX-1.6.so.0.0.33 libFOX-1.6.so.0 )

#!/bin/sh -e

VN=$(grep dummy common/FoX_common.F90 | awk '{print $6}' | sed -e s/-dummy//)

if test x$VN != x\'$1\'; then
  echo Wrong version number
  exit 1 
fi

git-archive --format=tar --prefix=FoX-$1/ HEAD | gzip -9 > ../FoX-$1-full.tar.gz

mkdir tmpFoX
cd tmpFoX
tar xzf ../../FoX-$1-full.tar.gz
(
  cd FoX-$1
  make cutdown
)
tar czf ../../FoX-$1.tar.gz FoX-$1
rm -rf FoX-$1

for i in wxml wcml sax dom
do
  tar xzf ../../FoX-$1-full.tar.gz
  (
    cd FoX-$1
    (
      cd config; \
       sed -e "s/CUTDOWN_TARGET=.*/CUTDOWN_TARGET=$i/" -i "" configure.ac; \
       make
    )
    make cutdown-$i
  )
  tar czf FoX-$1-$i.tar.gz FoX-$1
  rm -rf FoX-$1
done

cp FoX-$1-* ../..

cd ..
rm -rf tmpFoX

#!/bin/sh -e

INCFLAGS=`../../FoX-config --fcflags`
export INCFLAGS
rm -f passed.score failed.score
rm -f tests.out failed.out
touch passed.score failed.score

# I don't know why make won't do this ...

make m_handlers.o
for t in test_sax*.sh
do
  ./$t
done

echo RESULT sax/ Test Results:
echo RESULT sax/ Passed: `wc -l passed.score| cut -f 1 -d 'p'`
echo RESULT sax/ Failed: `wc -l failed.score| cut -f 1 -d 'f'`

echo RESULT sax/ See sax/test/failed.out for details of failed tests.

#!/bin/sh

INCFLAGS=`../../FoX-config --fcflags`
export INCFLAGS
rm -f passed.score failed.score
rm -f tests.out failed.out
touch passed.score failed.score

for t in test_cml?*.sh
do
  ./$t
done

echo RESULT wcml/ Test Results:
echo RESULT wcml/ Passed: `wc -l passed.score| cut -f 1 -d 'p'`
echo RESULT wcml/ Failed: `wc -l failed.score| cut -f 1 -d 'f'`

echo RESULT wcml/ See wcml/test/failed.out for details of failed tests.

#!/bin/sh

make $1.exe
./$1.exe > test.out 2>&1
passed=no
if [ -f $1.xml ]
then
  if diff test.xml $1.xml > /dev/null; then
    passed=yes
  else
     echo $1 >> failed.out
     echo "------------" >> failed.out
     diff test.xml $1.xml >> failed.out
     echo "------------" >> failed.out
  fi
elif [ -f $1.out ]
then
  if diff test.out $1.out > /dev/null; then
    passed=yes
  else
     echo $1 >> failed.out
     echo "------------" >> failed.out
     diff test.out $1.out >> failed.out
     echo "------------" >> failed.out
  fi
else
  echo No test output found for $1
fi

if [ $passed = yes ]; then
  echo 'PASSED: ' $1 
  echo 'PASSED: ' $1 >> tests.out
  echo '1' >> passed.score
else
  echo 'FAILED: ' $1 
  echo 'FAILED: ' $1 >> tests.out
  echo '1' >> failed.score
fi

#!/bin/sh

# Core files off, because they are huge on a Mac
ulimit -c 0

# NB Note that we ensure all locally-produced files 
# have Unix line endings only by using 'tr', in
# order to compare properly to our canonical versions.

passed=no
if ! make $1.exe; then
  echo $1 >> failed.out
  echo "------------" >> failed.out
  echo Cannot compile $1 >> failed.out
  echo "------------" >> failed.out
else
  ./$1.exe 2>&1 | tr -d '\15' > test.out
  if test -f $1.xml
  then
    tr -d '\15' < test.xml | grep -v UUID > test.xml.tmp; mv test.xml.tmp test.xml
    if test -f test.xml
    then
      if diff test.xml $1.xml > /dev/null; then
        passed=yes
      else
        echo $1 >> failed.out
        echo "------------" >> failed.out
        diff -u test.xml $1.xml >> failed.out
        echo "------------" >> failed.out
      fi
    else
      echo $1 >> failed.out
      echo " -----------"
      echo "test.xml not produced"
      echo " -----------"
    fi
  elif test -f $1.out
  then
    # Note below that we don't do a direct grep; we just check 
    # that the only DIFFerences are in one direction.
    if diff test.out $1.out | grep "^>" > /dev/null; then
      echo $1 >> failed.out
      echo "------------" >> failed.out
      diff -u test.out $1.out >> failed.out
      echo "------------" >> failed.out
    else
      passed=yes
    fi
  else
    echo $1 >> failed.out
    echo "------------" >> failed.out
    echo No test output found for $1
    echo "------------" >> failed.out
  fi
fi

if [ $passed = yes ]; then
  echo 'PASSED: ' $1 
  echo 'PASSED: ' $1 >> tests.out
  echo '1' >> passed.score
else
  echo 'FAILED: ' $1 
  echo 'FAILED: ' $1 >> tests.out
  echo '1' >> failed.score
fi

# Attributes dictionaries.

When parsing XML using the FoX SAX module, attributes are returned contained within a dictionary object.

All of the attribute dictionary objects and functions are exported through FoX_common and FoX_sax - you must USE the module to enable them. The dictionary API is described here.

An attribute dictionary consists of a list of entries, one for each attribute. The entries all have the following pieces of data:

* key - the attribute's full name  
* value - the attribute's value

and for namespaced attributes:

* nsURI - the namespace URI (if any) of the attribute
* localname - the local name of the attribute

------

## Derived types

There is one derived type of interest, `dictionary_t`.

It is opaque - that is, it should only be manipulated through the functions described here.

## Functions

* `len  
   type(dictionary_t), intent(in) :: dict`

Returns an integer with the length of the dictionary, ie the number of dictionary entries.

* `getLength  
   type(dictionary_t), intent(in) :: dict`

Returns an integer with the length of the dictionary, ie the number of dictionary entries. Identical to the `len` function.


* `hasKey  
    type(dictionary_t), intent(in) :: dict  
    character(len=*), intent(in) :: key`

Returns a logical value according to whether the dictionary contains an attribute named `key` or not.


* `hasKey  
    type(dictionary_t), intent(in) :: dict  
    character(len=*), intent(in) :: uri  
    character(len=*), intent(in) :: localname`

Returns a logical value according to whether the dictionary contains an attribute with the correct `URI` and `localname`.

The following functions may be used to retrieve data from a dictionary

* `getQName  
    type(dictionary_t), intent(in) :: dict   
    integer, intent(in) :: i`

Return the full name of the `i`th dictionary entry.

* `getValue  
    type(dictionary_t), intent(in)  
    integer, intent(in) :: i`

If an integer is passed in - the value of the `i`th attribute. 

* `getValue  
    type(dictionary_t), intent(in)  
    character(len=*), intent(in) :: key`

If a single string is passed in, the value of the attribute with that name.

* `getValue  
    type(dictionary_t), intent(in)  
    character(len=*), intent(in) :: uri, localname`

If two strings are passed in, the value of the attribute with that uri and localname.

* `getURI  
    type(dictionary_t), intent(in)  
    integer, intent(in), optional :: i`

Returns a string containing the nsURI of the `i`th attribute.

* `getlocalName  
    type(dictionary_t), intent(in)  
    integer, intent(in), optional :: i`

Returns a string containing the localName of the `i`th attribute.

#Debugging with FoX.

Following experience integrating FoX into several codes, here are a few tips for debugging any problems you may encounter.


## Compilation problems

You may encounter problems at the compiling or linking stage, with error messages along the lines of:
     'No Specific Function can be found for this Generic Function'
(exact phrasing depending on compiler, of course.)

If this is the case, it is possible that you have accidentally got the arguments to the offending out of order. If so, then use the keyword form of the argument to ensure correctness; that is, instead of doing:

    call cmlAddProperty(file, name, value)

do:

    call cmlAddProperty(xf=file, name=name, value=value)

This will prevent argument mismatches, and is recommended practise in any case.

## Runtime problems

You may encounter run-time issues. FoX performs many run-time checks to ensure the validity of the resultant XML code. In so far as it is possible, FoX will either issue warnings about potential problems, or try and safely handle any errors it encounters. In both cases, warning will be output on stderr, which will hopefully help diagnose the problem.

Sometimes, however, FoX will encounter a problem it can do nothing about, and must stop. In all cases, it will try and write out an error message highlighting the reason, and generate a backtrace pointing to the offending line. Occasionally though, the compiler will not generate this information, and the error message will be lost.

If this is the case, you can either investigate the coredump to find the problem, or (if you are on a Mac) look in ~/Library/Logs/CrashReporter to find a human-readable log.

If this is not enlightening, or you cannot find the problem, then some of the most common issues we have encountered are listed below. Many of them are general Fortran problems, but sometimes are not easily spotted in the context of FoX.

### Incorrect formatting.

Make sure, whenever you are writing out a real number through one of FoX's routines, and specifying a format, that the format is correct according to [StringFormatting](|StringFormatting|). Fortran-style formats are **not** permitted, and will cause crashes at runtime.

### Array overruns

If you are outputting arrays or matrices, and are doing so in the traditional Fortran style - by passing both the array and its length to the routine, like so:

     call xml_AddAttribute(xf=file, name=name, value=array, nvalue=n)

then if `n` is wrong, you may end up with an array overrun, and cause a crash.

We highly recommend wherever possible using the Fortran-90 style, like so:

     call xml_AddAttribute(xf=file, name=name, value=array)

where the array length will be passed automatically.

### Uninitialized variables

If you are passing variables to FoX which have not been initialized, you may well cause a crash. This is especially true, and easy to cause if you are passing in an array which (due to a bug elsewhere) has been partly but not entirely initialized. To diagnose this, try printing out suspect variables just before passing them to FoX, and look for suspiciously wrong values.

### Invalid floating point numbers.

If during the course of your calculation you accidentally generate Infinities, or NaNs, then passing them to any Fortran subroutine can result in a crash - therefore trying to pass them to FoX for output may result in a crash.

If you suspect this is happening, try printing out suspect variables before calling FoX. 

#Configuration and compilation

You will have received the FoX source code as a tar.gz file.

Unpack it as normal, and change directory into the top-level directory, FoX-$VERSION.

### Requirements for use

FoX requires a Fortran 95 compiler - not just Fortran 90. All currently available versions of Fortran compilers claim to support F95. If your favoured compiler is not listed as working below, I recommend the use of [g95](www.g95.org), which is free to download and use. And if your favourite compiler is listed as not working, then please send a bug report to your compiler vendor.

In the event that you need to write a code targetted at multiple compilers, including some which have bugs preventing FoX compilation, please note the possibility of producing a [dummy library](#dummy_library).

The list below shows results as tested at the time of release with the 3.0 release of the FoX code (see a special the note on the PGI compilers [below](#PGI).). An up-to-date list of tested compiler version is maintained [here](http://uszla.me.uk/space/software/FoX/compat/).

* g95 as of 25/5/7
* gfortran as of version 4.2
* Intel version 8.1, 9.1, 10.1
* NAG version 5.1
* XLF version 10.01

Known failures:

* Any version of Compaq Visual Fortran
* g95 prior to 25/5/7  
* Intel version 7.1  
* NAG version 5.0  
* F version of 16/5/6
* All PGI versions (see below)

Results from other compilers are welcome.

As of version 2.0.2, the following other compilers had been tested and are known to work:

* Lahey version 6.20
* Pathscale, version 2.4
* XLF version 9.1

#### PGI compilers

<a name="PGI"/>

The Portland group compilers are by far the worst performing and buggiest compilers I have had the misfortune to use. Nevertheless, I have tried hard to make FoX work with them. The results are that:

* PGI 5.1 is completely broken. Compilation is impossible, too few F95 features are supported.

* PGI 6.1-6 and 6.2-3, and 7.0-2 are usable. All of FoX will be compiled, and most of the functionality is available, with the exception of any array-output routines, which the compiler runtime cannot handle. In practice, this means that most of WXML, and all of SAX and DOM are safe for use. Segfaults will be generated in the use of WCML.

I cannot recommend the use of PGI compilers. Patches to work around PGI problems will be welcomed, but please direct bug reports to the Portland Group.

##Configuration

* In order to generate the Makefile, make sure that you have a Fortran compiler in your `PATH`, and do:

    `./configure`

This should suffice for most installations. However:

1. You may not be interested in all of the modules that FoX supplies. For example, you may only be interested in output, not input. If so, you can select which modules you want using `--enable-MODULENAME` where MODULENAME is one of `wxml`, `wcml`, `wkml`, `sax`, `dom`. If none are explicitly enabled, then all will be built. (Alternatively, you can exclude modules one at a time with `--disable-MODULENAME`) Thus, for example, if you only care about CML output, and not anything else: `./configure --enable-wcml`

2. If you have more than one Fortran compiler available, or it is not on your `PATH`, you can force the choice by doing:

   `./configure FC=/path/to/compiler/of/choice`

3. It is possible that the configuration fails. In this case
	* please tell me about it so I can fix it
  	* all relevant compiler details are placed in the file arch.make; you may be able to edit that file to allow compilation. Again, if so, please let me know what you need to do.

4. By default the resultant files are installed under the objs directory. If you wish them to be installed elsewhere, you may do

    `./configure --prefix=/path/to/installation`

Note that the configure process encodes the current directory location in several
places.  If you move the FoX directory later on, you will need to re-run configure.

* You may be interested in [dummy compilation](#dummy_library). This is activated with the `--enable-dummy` switch (but only works for wxml/wcml currently).

    `./configure --enable-wcml --enable-dummy`

##Compilation

In order to compile the full library, now simply do:

    make

This will build all the requested FoX modules, and the relevant examples

##Testing

In the full version of the FoX library, there are several testsuites included.

To run them all, simply run `make check` from the top-level directory. This will run the individual testsuites, and collate their results.

If any failures occur (unrelated to known compiler issues, see the [up-to-date list](http://uszla.me.uk/space/software/FoX/compat/)), please send a message to the mailing list (<FoX@lists.uszla.me.uk>) with details of compiler, hardware platform, and the nature of the failure.

##Linking to an existing program

* The files all having been compiled and installed, you need to link them into your program.

A script is provided which will provide the appropriate compiler and linker flags for you; this will be created after configuration, in the top-level directory, and is called `FoX-config`. It may be taken from there and placed anywhere.

FoX-config takes the following arguments:

* `--fcflags`: return flags for compilation
* `--libs`: return flags for linking
* `--wxml`: return flags for compiling/linking against wxml
* `--wcml`: return flags for compiling/linking against wcml
* `--sax`: return flags for compiling/linking against sax

If it is called with no arguments, it will expand to compile & link flags, thusly:

       f95 -o program program.f90 `FoX-config`

For compiling only against FoX, do the following:

 	f95 -c `FoX-config --fcflags` sourcefile.f90

For linking only to the FoX library, do:

  	f95 -o program `FoX-config --libs` *.o

or similar, according to your compilation scheme. 

Note that by default, `FoX-config` assumes you are using all modules of the library. If you are only using part, then this can be specified by also passing the name of each module required, like so:

	FoX-config --fcflags --wcml

## Compiling a dummy library

<a name="dummy_library"/>

Because of the shortcomings in some compilers, it is not possible to compile FoX everywhere. Equally, sometimes it is useful to be able to compile a code both with and without support for FoX (perhaps to reduce executable size). Especially where FoX is being used only for additional output, it is useful to be able to run the code and perform computations even without the possibility of XML output.

For this reason, it is possible to compile a dummy version of FoX. This includes all public interfaces, so that your code will compile and link correctly - however none of the subroutines do anything, so you can retain the same version of your code without having to comment out all FoX calls.

Because this dummy version of FoX contains nothing except empty subroutines, it compiles and links with all known Fortran 95 compilers, regardless of compiler bugs.

To compile the dummy code, use the `--enable-dummy` switch. Note that currently the dummy code is only available for the WXML and WCML modules.

#WCML

WCML is a library for outputting [CML](http://www.xml-cml.org) data. It wraps all the necessary XML calls, such that you should never need to touch any [WXML](|FoX_wxml|) calls when outputting CML.

The CML output is conformant to version 2.4 of the CML schema.

The available functions and their intended use are listed below. Quite deliberately, no reference is made to the actual CML output by each function. 

Wcml is *not* intended to be a generalized Fortran CML output layer. rather it is intended to be a library which allows the output of a limited set of well-defined syntactical fragments.

Further information on these fragments, and on the style of CML generated here, is available at <http://www.uszla.me.uk/specs/subset.html>.

This section of the manual will detail the available CML output subroutines.

## Use of WCML

wcml subroutines can be accessed from within a module or subroutine by inserting

     use FoX_wcml

at the start. This will import all of the subroutines described below, plus the derived type `xmlf_t` needed to manipulate a CML file.

*No* other entities will be imported; public/private Fortran namespaces are very carefully  controlled within the library.

## Dictionaries.

The use of dictionaries with WCML is strongly encouraged. (For those not conversant with dictionaries, a fairly detailed explanation is available at <http://www.xml-cml.org/information/dictionaries>)

In brief, dictionaries are used in two ways.

### Identification

Firstly, to identify and disambiguate output data. Every output function below takes an optional argument, `dictRef=""`. It is intended that every piece of data output is tagged with a dictionary reference, which will look something like `nameOfCode:nameOfThing`. 

So, for example, in SIESTA, all the energies are output with different dictRefs, looking like: `siesta:KohnShamEnergy`, or `siesta:kineticEnergy`, etc. By doing this, we can ensure that later on all these numbers can be usefully identified.

We hope that ultimately, dictionaries can be written for codes, which will explain what some of these names might mean. However, it is not in any way necessary that this be done - and using `dictRef` attributes will help merely by giving the ability to disambiguate otherwise indistinguishable quantities.

We strongly recommend this course of action - if you choose to do follow our recommendation, then you should add a suitable Namespace to your code. That is, immediately *after* `cmlBeginFile` and *before* `cmlStartCml`, you should add something like:

    call cmlAddNamespace(xf=xf, 'nameOfCode', 'WebPageOfCode')

Again, for SIESTA, we add:
 
    call cmlAddNamespace(xf, 'siesta, 'http://www.uam.es/siesta')

If you don't have a webpage for your code, don't worry; the address is only used as an identifier, so anything that looks like a URL, and which nobody else is using, will suffice.

###Quantification

Secondly, we use dictionaries for units. This is compulsory (unlike `dictRef`s above). Any numerical quantity that is output through cmlAddProperty or cmlAddParameter is *required* to carry units. These are added with the `units=""` argument to the function. In addition, every other function below which will take numerical arguments also will take optional units, although default will be used if no units are supplied.

Further details are supplied in section [Units](#Units) below.

### General naming conventions for functions.

Functions are named in the following way:

* All functions begin 
`cml`

* To begin and end a section of the CML file,
a pair of functions will exist:
	* `cmlStart`something
	* `cmlEnd`something

* To output a given quantity/property/concept etc. a function will exist
`cmlAdd`something


###Conventions used below.

* Function names are in `monospace`
* argument names are in **bold**
* optional argument names are in (**parenthesized bold**)
* argument types are in *italic* and may consist of:
* *string*: string of arbitrary (unless otherwise specified) length
* *integer*: default integer
* *real(sp)*: single precision real number
* *real(dp)*: double precision real number
* *logical*: default logical 
* *real*: either of *real(sp)* or *real(dp)*
* *anytype*: any of *logical*, *integer*, *real(sp)*, *real(dp)*, *string*

Note that where *strings* are passed in, they will be passed through entirely unchanged to the output file - no truncation of whitespace will occur.

Also note that wherever a *real* number can be passed in (including through *anytype*) then the formatting can be specified using the conventions described in [StringFormatting](|StringFormatting|)

* *scalar*: single item
* *array*: one-dimensional array of items
* *matrix*: two-dimensional array of items
* *anydim*: any of *scalar*, *array*, *matrix*

Where an *array* is passed in, it may be passed either as an assumed-shape array; that is, as an F90-style array with no necessity for specifying bounds; thusly:

	integer :: array(50)
	call cmlAddProperty(xf, 'coords', array)

or as an assumed-size array; that is, an F77-style array, in which case the length must be passed as an additional parameter:

	integer :: array(*)
	call cmlAddProperty(xf, 'coords', array, nitems=50)

Similarly, when a *matrix* is passed in, it may be passed in both fashions:

	integer :: matrix(50, 50)
	call cmlAddProperty(xf, 'coords', matrix)

or 

	integer :: array(3, *)
	call cmlAddProperty(xf, 'coords', matrix, nrows=3, ncols=50)

All functions take as their first argument an XML file object, whose keyword is always `xf`. This file object is initialized by a `cmlBeginFile` function.

It is *highly* recommended that subroutines be called with keywords specified rather than relying on the implicit ordering of arguments. This is robust against changes in the library calling convention; and also stepsides a significant cause of errors when using subroutines with large numbers of arguments.

<a name="Units"/>

### Units

Note below that the functions `cmlAddParameter` and `cmlAddProperty` both *require* that units be specified for any numerical quantities output.

If you are trying to output a quantity that is genuinely dimensionless, then you should specify `units="units:dimensionless"`; or if you are trying to output a countable quantity (eg number of CPUs) then you may specify `units="units:countable"`.

For other properties, all units should be specified as namespaced quantities. If you are using
a very few common units, it may be easiest to borrow definitions from the provided dictionaries;

(These links do not resolve yet.)

`cmlUnits: http://www.xml-cml.org/units/units`  
`siUnits: http://www.xml-cml.org/units/siUnits`  
`atomicUnits: http://www.xml-cml.org/units/atomic`  

A default units dictionary, containing only the very basic units that wcml needs to know about, which has a namespace of: `http://www.uszla.me.uk/FoX/units`, and wcml assigns it automatically to the prefix `units`.

This is added *automatically*, so attempts to add it manually will fail.

The contents of all of these dictionaries, plus the wcml dictionary, may be viewed at:
<http://www.uszla.me.uk/unitsviz/units.cgi>.

Otherwise, you should feel at liberty to construct your own namespace;
declare it using `cmlAddNamespace`, and markup all your units as:

     units="myNamespace:myunit"

## Functions for manipulating the CML file:

* `cmlBeginFile`   
**filename**: *string* *scalar*: Filename to be opened.  
**unit**: *integer* *scalar*: what unit number should the file be opened on? If you don't
care, you may specify `-1` as the unit number, in which case wcml will make a guess  
(**replace**): *logical* *scalar*: should the file be replaced if it already exists? *default: yes*

This takes care of all calls to open a CML output file.

* `cmlFinishFile`

This takes care of all calls to close an open CML output file, once you have finished with it. It is compulsory to call this - if your program finished without calling this, then your CML file will be invalid.

* `cmlAddNamespace`  
**prefix** *string* *scalar*: prefix to be used  
**nsURI** *string* *scalar*: namespace URI to be used  

This adds a namespace to a CML file.  
NB This may only ever be called immediately after a `cmlBeginFile` call, before any
output has been performed.
Attempts to do otherwise will result in a runtime error.

This will be needed if you are adding dictionary references to your output. Thus for siesta, we do:

    call cmlAddNamespace(xf, 'siesta', 'http://www.uam.es/siesta')

and then output all our properties and parameters with `dictRef="siesta:something"`.

* `cmlStartCml`  
(**fileId**) *string* *scalar*: name of originating file.  (default: current filename)  
(**version**) *string* *scalar*: version of CML in use.  (default: 2.4)

* `cmlEndCml`

This pair of functions begin and end the CML output to an existing CML file. It takes care of namespaces.

Note that unless specified otherwise, there will be a `convention` attribute added to the `cml` tag specifying `FoX_wcml-2.0` as the convention. (see <http://www.uszla.me.uk/FoX> for details)

## Start/End sections

* `cmlStartMetadataList`  
(**name**) *string* *scalar*: name for the metadata list    
(**role**) *string* *scalar* role which the element plays 

* `cmlEndMetadataList`

This pair of functions open & close a metadataList, which is a wrapper for metadata items.

* `cmlStartParameterList`  
(**ref**) *string* *scalar*: Reference an `id` attribute of another element (generally deprecated)  
(**role**) *string* *scalar* role which the element plays 

* `cmlEndParameterList`

This pair of functions open & close a parameterList, which is a wrapper for input parameters.

* `cmlStartPropertyList`  
(**ref**) *string* *scalar*: Reference an `id` attribute of another element (generally deprecated)  
(**role**) *string* *scalar* role which the element plays 

* `cmlEndPropertyList`

This pair of functions open & close a propertyList, which is a wrapper for output properties.

* `cmlStartKpointList`
* `cmlEndKpointList`

Start/end a list of k-points (added using `cmlAddKpoint` below)

* `cmlStartModule`  
(**serial**) *string* *scalar*: serial id for the module  
(**role**) *string* *scalar* role which the element plays 

Note that in most cases where you might want to use a serial number, you should probably be using the `cmlStartStep` subroutine below.

* `cmlEndModule`

This pair of functions open & close a module of a computation which is unordered, or loosely-ordered. For example, METADISE uses one module for each surface examined.

* `cmlStartStep`  
(**index**) *integer* *scalar*: index number for the step. In the absence of an index, steps will be assumed to be consecutively numbered. Specifying this is useful if you wish to output *eg* every hundredth step.   
(**type**) *string* *scalar*: what sort of step is this? This should be a namespaced string, for example: `siesta:CG` is a Conjugate Gradient step in siesta.

* `cmlEndStep`

This pair of functions open and close a module of a computation which is strongly ordered. For example, DLPOLY uses steps for each step of the simulation.

## Adding items.

* `cmlAddMetadata`  
**name**: *string* *scalar*: Identifying string for metadata  
**content**: *character* *scalar*: Content of metadata  

This adds a single item of metadata. Metadata vocabulary is completely uncontrolled within WCML. This means that metadata values may *only* be strings of characters. If you need your values to contain numbers, then you need to define the representation yourself, and construct your own strings.

* `cmlAddParameter`  
**name**: *string* *scalar*: Identifying title for parameter  
**value**:*anytype* *anydim*: value of parameter  
**units**: *string* *scalar*: units of parameter value  (optional for logical/character **value**s, compulsory otherwise; see note above)  
(**constraint**) *string* *scalar*: Constraint under which the parameter is set (this can be an arbitrary string)  
(**ref**) *string* *scalar*: Reference an `id` attribute of another element (generally deprecated)  
(**role**) *string* *scalar* role which the element plays 

This function adds a tag representing an input parameter

* `cmlAddProperty`  
**title**: *string* *scalar*  
**value**: *any* *anydim*  
**units**: *string* *scalar* units of property value  (optional for logical/character **value**s, compulsory otherwise; see note above)  
(**ref**) *string* *scalar*: Reference an `id` attribute of another element (generally deprecated)  
(**role**) *string* *scalar* role which the element plays 

This function adds a tag representing an output property

## Adding geometry information

* `cmlAddMolecule`  
**coords**: *real*: a 3xn matrix of real numbers representing atomic coordinates (either fractional or Cartesian) . These *must* be specified in Angstrom or fractional units (see **style** below.)  
**OR**  
**x**, **y**, **z**: *real*: 3 one-dimensional arrays containing the *x*, *y*, and *z* coordinates of the atoms in the molecule.  These *must* be specified in Angstrom or fractional units (see **style** below.)  
**elements**: *string* *array*: a length-n array of length-2 strings containing IUPAC chemical symbols for the atoms    
(**natoms**) *integer* *scalar*: number of atoms in molecule (default: picked up from length of **coords** array)  
(**occupancies**): *real* *array* : a length-n array of the occupancies of each atom.  
(**atomRefs**): *string* *array*: a length-n array of strings containing references which may point to IDs elsewhere of, for example, pseudopotentials or basis sets defining the element's behaviour.  
(**atomIds**): *string* *array*: a length-n array of strings containing IDs for the atoms.  
(**style**): *string* *scalar*: `cartesian` - the coordinates are Cartesian, or `fractional` - the coordinates are fractional. The default is Cartesian.  
(**ref**) *string* *scalar*: Reference an `id` attribute of another element (generally deprecated)  
(**formula**) *string* *scalar*: An IUPAC chemical formula  
(**chirality**) *string* *scalar*: The chirality of the molecule. No defined vocabulary.  
(**role**) *string* *scalar*: Role of molecule. No defined vocabulary.

Outputs an atomic configuration. 

* `cmlAddLattice`   
**cell**: *real* *matrix* a 3x3 matrix of the unit cell  
(**spaceType**): *string* *scalar*: `real` or `reciprocal` space.  
(**latticeType**): *string* *scalar* Space group of the lattice. No defined vocabulary  
(**units**): *string* *scalar* units of (reciprocal) distance that cell vectors is given in;
*default: Angstrom*


Outputs information about a unit cell, in lattice-vector form

* `cmlAddCrystal`  
**a**: *real* *scalar* the 'a' parameter (must be in Angstrom)  
**b**: *real* *scalar* the 'b' parameter  
**c**: *real* *scalar* the 'c' parameter  
**alpha**: *real* *scalar* the 'alpha' parameter  
**beta**: *real* *scalar* the 'beta' parameter  
**gamma**: *real* *scalar* the 'gamma' parameter  
(**z**): *integer* *scalar* the 'z' parameter: number of molecules per unit cell.  
(**lenunits**): *string* *scalar*: Units of length: default is `units:angstrom`    
(**angunits**): *string* *scalar*: Units of angle: default is `units:degrees`   
(**lenfmt**): *string* *scalar*: format for crystal lengths  
(**angfmt**): *string* *scalar*: format for crystal angles  
(**spaceGroup**): *string* *scalar* Space group of the crystal. No defined vocabulary.

Outputs information about a unit cell, in crystallographic form

## Adding eigen-information

* `cmlStartKPoint`  
**kpoint**: *real* *array-3* the reciprocal-space coordinates of the k-point  
(**weight**): *real* *scalar* the weight of the kpoint  
(**kptfmt**): *string* *scalar* numerical formatting for the k-point  
(**wtfmt**): *string* *scalar* numerical formatting for the weight

Start a kpoint section.

* `cmlEndKPoint`  

End a kpoint section.

* `cmlAddKPoint`  
**kpoint**: *real* *array-3* the reciprocal-space coordinates of the k-point  
(**weight**): *real* *scalar* the weight of the kpoint  
(**kptfmt**): *string* *scalar* numerical formatting for the k-point  
(**wtfmt**): *string* *scalar* numerical formatting for the weight

Add an empty kpoint section.

* `cmlStartBand`  
(**spin**): *string* *scalar* the spin of this band. Must be either "up" or "down"  
(**label**): the label of this band.

Start a section describing one band.

* `cmlEndBand`

End a section describing one band.

* `cmlAddEigenValue`  
**value**: *real* *scalar* the eigenvalue  
**units**: *QName* *scalar* the units of the eigenvalue

Add a single eigenvalue to a band.

* `cmlAddBandList`  
**values**: *real* *array* the eigenvalues  
**spin**: *string* *scalar* the spin orientation ("up" or "down")  
**units**: *QName* *scalar* the units of the eigenvalue

Add a list of eigenvalues for a kpoint

* `cmlAddEigenValueVector`
**value**: *real* *scalar* the eigenvalue for this band  
**units**: *QName* *scalar* the units of the eigenvalue  
**vector**: *real/complex* *3xN matrix* the eigenvectors for this band  
(**valfmt**): *string* *scalar* numerical formatting for the eigenvalue  
(**vecfmt**): *string* *scalar* numerical formatting for the eigenvector

Add a phononic eigenpoint to the band - which has a single energy, and a 3xN matrix representing the eigenvector.

##Common arguments

All `cmlAdd` and `cmlStart` routines take the following set of optional arguments:

* `id`: Unique identifying string for element. (Uniqueness is not enforced, though duplicated ids on output are usually an error and may cause later problems)  
* `title`: Human-readable title of element for display purposes  
* `dictRef`: reference to disambiguate element. Should be a QName; a namespaced string. An actual dictionary entry may or may not exist. It is not an error for it not to.  
* `convention`: convention by which the element is to be read.  
(The wording of the definitions for `convention` is deliberately loose.)

# FoX versioning

This documentation describes version 3.1.2 of the FoX library.

This version includes output modules for general XML, and for CML, and also a Fortran version of the SAX2 input parser, and a Fortran mapping of the W3C DOM interface.

This is a stable branch, which will be maintained with important bugfixes.

<a name="Changes"/>

## FoX Changes

As of FoX-3.0, there is one user-visible change that should be noted.

### Configuration/compilation

In previous versions of FoX, the configure script was accessible as `config/configure`. Version 3.0 now follows common practice by placing the script in the main directory, so it is now called as `./configure`.

Previous versions of FoX made it quite hard to compile only portions of the library (eg only the CML output portion; or just the SAX input). This is now possible by specifying arguments to the configuration script. For example,

`./configure --enable-wcml`

will cause the generated Makefile to only compile the CML writing module and its dependencies.

See [Compilation](|Compilation|) for further details.

# UTILS

`FoX_utils` is a collection of general utility functions that the rest of FoX depends on, but which may be of independent use. They are documented here.

All functions are accessible from the `FoX_utils` module. 

NB Unlike the APIs of WXML, WCML, and SAX, the UTILS APIs may not remain constant between FoX versions. While some effort will be expended to ensure they don't change unnecessarily, no guarantees are made.

For any end-users interested in the code who are worried about interface changes, it is recommended that the  relevant code (all found in the `utils/` directory be lifted directly and imported into other projects, rather than accessed through the FoX interfaces.

Currently only one utility function is provided, `generate_UUID`.

<a name="UUID"/>

## UUID

UUIDs (see [RFC 4122](http://www.ietf.org/rfc/rfc4122.txt)) are  Universally Unique IDentifiers. They are a 128-bit number, represented as a 36-character string. For example:

     f81d4fae-7dec-11d0-a765-00a0c91e6bf6

The intention of UUIDs is to enable distributed systems to uniquely identify information without significant central coordination. Thus, anyone can create a UUID and use it to identify something with reasonable confidence that the identifier will never be unintentionally used by anyone for anything else.

This property also makes them useful as Uniform Resource Names, to refer to a given document without requiring a position in a particular URI scheme. Thus the above UUID could be referred to as

    urn:uuid:f81d4fae-7dec-11d0-a765-00a0c91e6bf6

UUIDs are used by WCML to ensure that every document generated has a unique ID. This enables users to go back later on and have confidence that they are examining the same document, regardless of where it might have ended up in file-system hierarchies or databases.

In addition, UUIDs come in several flavours, one of which stores the time of creation to 100-nanosecond accuracy. This can later be extracted (see, for example [this service](http://www.famkruithof.net/uuid/uuidgen?typeReq=-1)) to verify creation time.

This may well be useful for other XML document types, or indeed in non-XML applications. Thus, UUIDs may be generated by the following function, with one optional argument.

* `generate_UUID`  
**version**: *integer*

This function returns a 36-character string containing the UUID.

**version** identifies the version of UUID to be used (see section 4.1.3 of the RFC). Only versions 0, 1, and 4 are supported. Version 0 generates a nil UUID; version 1 a time-based UUID, and version 4 a pseudo-randomly-generated UUID.

Version 1 is the default, and is recommended.

(Note: all pseudo-random-numbers are generated using the high-quality Mersenne Twister algorithm, using the Fortran implementation of [Scott Robert Ladd](http://www.coyotegulch.com).)

# FoX_common

FoX_common is a module exporting interfaces to a set of convenience functions common to all of the FoX modules, which are of more general use.

Currently, the only publically available function is `str`, which converts primitive datatypes into strings in a consistent fashion, conformant with the expectations of XML processors.

It is fully described in [StringFormatting](|StringFormatting|)

# String handling in FoX

Many of the routines in wxml, and indeed in wcml which is built on top of wxml, are overloaded so that data may be passed to the same routine as string, integer, logical or real data.

In such cases, a few notes on the conversion of non-textual data to text is on order. The
standard Fortran I/O formatting routines do not offer the control required for useful XML output, so FoX performs all its own formatting.

This formatting is done internally through a function which is also available publically to the user, `str`.

To use this in your program, import it via:

    use FoX_common, only; str

and use it like so:

     print*, str(data)

In addition, for ease of use, the `//` concatenation operator is overloaded, such that strings can easily be formed by concatenation of strings to other datatypes. To use this you must import it via:

     use FoX_common, only: operator(//)

and use it like so:

     integer :: data
     print*, "This is a number "//data

This will work for all native Fortran data types - but no floating point formatting is available as described below with concatenation, only with str()

You may pass data of the following primitive types to `str`:

## Scalar data

### Character (default kind)

Character data is returned unchanged.

### Logical (default kind)

Logical data is output such that True values are converted to the string 'true', and False to the string 'false'.

### Integer (default kind)

Integer data is converted to the standard decimal representation.

### Real numbers (single and double precision)

Real numbers, both single and double precision, are converted to strings in one of two ways, with some control offered to the user. The output will conform to the real number formats specified by XML Schema Datatypes.

This may be done in one of two ways:

 1. Exponential notation, with variable number of significant figures. Format strings of the form "`s`**n**"  are accepted, where **n** is the number of significant figures.

 Thus the number `111`, when output with various formats, will produce the following output:

<table class="format">
<tr>
  <td class="format"> s1 </td><td> 1e2 </td>
</tr><tr>
  <td> s2 </td><td> 1.1e2 </td>
</tr><tr>
  <td> s3 </td><td> 1.11e2 </td>
</tr><tr>
  <td> s4 </td><td> 1.110e2 </td>
</tr>
</table>

 The number of significant figures should lie between 1 and the number of digits precision provided by the real kind. If a larger or smaller number is specified, output will be truncated accordingly. If unspecified, then a sensible default will be chosen.

  This format is not permitted by XML Schema Datatypes 1.0, though it is in 2.0

 2. Non-exponential notation, with variable number of digits after the decimal point. Format strings of the form "`r`**n**", where **n** is the number of digits after the decimal point.

 Thus the number `3.14159`, when output with various formats, will produce the following output:

<table class="format">
<tr>
  <td> r0 </td><td> 3 </td>
</tr><tr>
  <td> r1 </td><td> 3.1</td>
</tr><tr>
  <td> r2 </td><td> 3.14</td>
</tr><tr>
  <td> r3 </td><td> 3.142 </td>
</tr>
</table>

 The number of decimal places must lie between 0 and whatever would output the maximum digits precision for that real kind.  If a larger or smaller number is specified, output will be truncated accorsingly. If unspecified, then a sensible default will be chosen.

 This format is the only one permitted by XML Schema Datatypes 1.0

 If no format is specified, then a default of exponential notation will be used.

 If a format is specified not conforming to either of the two forms above, a run-time error will be generated.

**NB** Since by using FoX or str, you are passing real numbers through various functions, this means that
       they must be valid real numbers. A corollary of this is that if you pass in +/-Infinity, or NaN, then
       the behaviour of FoX is unpredictable, and may well result in a crash. This is a consequence of the
       Fortran standard, which strictly disallows doing anything at all with such numbers, including even
       just passing them to a subroutine.

## Complex numbers (single and double precision)

Complex numbers will be output as pairs of real numbers, in the following way:

`(1.0e0)+i(1.0e0)`

where the two halves can be formatted in the way described for 'Real numbers' above; only one format may be specified, and it will apply to both.

All the caveats described above apply for complex number as well; that is, output of complex numbers either of whose components are infinite or NaN is illegal in Fortran, and more than likely will cause a crash in FoX.

## Arrays and matrices

All of the above types of data may be passed in as arrays and matrices as well. In this case, a string containing all the individual elements will be returned, ordered as they would be in memory, each element separated by a single space.

If the data is character data, then there is an additional option to str, `delimiter` which may be any single-character string, and will replace a space as the delimiter.

## wxml/wcml wrappers.

All functions in wxml which can accept arbitrary data (roughly, wherever you put anything that is not an XML name; attribute values, pseudo-attribute values, character data) will take scalars, arrays, and matrices of any of the above data types, with `fmt=` and `delimiter=` optional arguments where appropriate.

Similarly, wcml functions which can accept varied data will behave similarly.

#Further information

FoX evolved from the initial codebase of [xmlf90](http://lcdx00.wm.lc.ehu.es/ag/xml/),
which was written largely by Alberto Garcia <<albertog@icmab.es>> and Jon Wakelin <<jon.wakelin@bristol.ac.uk>>.

FoX is the work of Toby White <<tow21@cam.ac.uk>>, and all bug reports/complaints/bouquets of roses should be sent to him.

There is a FoX website at <http://www.uszla.me.uk/software/FoX/>.

There is also a mailing list for announcements/queries/bug reports. Information on how to subscribe may be found at <http://www.uszla.me.uk/cgi-bin/mailman/listinfo/FoX/>,

This manual is &copy; Toby White 2006.
